module ("BuilderData",package.seeall)
--建造队列数据
BuilderTemplet = {
	Idx = 0,		--建造队列id
	State = 0, 	--建造队列状态 0--空闲 1--CD中不可用
	CD = 0, 	--毫秒数
	IdLabel = nil,
	IdButton = nil,
	RedImg = nil, --小红点
}
local BuilderData = {}
local num = #BuilderData

function clearBuilderData()
	BuilderData = {}
end

function addBuilderData( _data )
	table_insert(BuilderData, _data)
end
function getBuilderNum()
	return #BuilderData
end
function getBuilderDataFromIndex(_locIdx)
	return BuilderData[_locIdx]

end
--通过id获取建造队列状态
function getBuilderStateFromId( _idx )
	local num = #BuilderData
	for i=1, num do
		if BuilderData[i]["Idx"] == _idx then
			return BuilderData[i]["State"]
		end
	end
	return nil
end
--通过id获取建造队列的CD时间
function getBuilderTimerFromId( _idx )
	local num = #BuilderData
	for i=1, num do
		if BuilderData[i]["Idx"] == _idx then
			return PT.gerStringFromMilSecond(BuilderData[i]["CD"])--os.date("%X", 57600+BuilderData[i]["CD"] )
		end
	end
	return nil
end
--更新建造队列的cd时间
function flushBuilderFromId( _idx, _state, _cd )
	local num = #BuilderData
	for i=1, num do
		if BuilderData[i]["Idx"] == _idx then
			BuilderData[i]["State"] = _state
			BuilderData[i]["CD"] = _cd
			return true
		end
	end
	return false
end
function clearBuilderFromId( _idx)
	local num = #BuilderData
	for i=1, num do
		if BuilderData[i]["Idx"] == _idx then
			BuilderData[i]["State"] = 0
			BuilderData[i]["CD"] = 0
			return true
		end
	end
	return false
end
--检测建筑队列是否可用，用以显示首页事件列表小红点
function checkBuilderIfBeUse()
	local num = #BuilderData
	for i=1, num do
		if BuilderData[i]["State"] == 0 then --可用
			return true 
		end
	end
	return false
end
---[[
function flushBuilderTimerFromId( )
	local num = #BuilderData
	for i=1, num do
		if BuilderData[i]["CD"] ~= 0 then
			BuilderData[i]["CD"] = BuilderData[i]["CD"] - 1

			if BuilderData[i]["CD"] == 0 then
				protoSend0x0524( BuilderData[i]["Idx"] )
			end

			if BuilderData[i]["IdLabel"] ~= nil then
				local str = PT.gerStringFromMilSecond(BuilderData[i]["CD"])
				if BuilderData[i]["State"] == 0 then --可用
					BuilderData[i]["RedImg"]:setVisible(true)
					BuilderData[i]["IdLabel"]:setColor( ccc3(255, 255, 255) )
				else --不可用
					BuilderData[i]["RedImg"]:setVisible(false)
					BuilderData[i]["IdLabel"]:setColor( ccc3(255, 0, 0) )
				end
				BuilderData[i]["IdLabel"]:setText( str )
				if BuilderData[i]["IdButton"] ~= nil then
					BuilderData[i]["IdButton"]:setVisible(true)
					BuilderData[i]["IdButton"]:setTouchEnabled(true)
				end
			end
		else
			if BuilderData[i]["IdLabel"] ~= nil then
				BuilderData[i]["IdLabel"]:setColor( ccc3(255, 255, 255) )
				BuilderData[i]["IdLabel"]:setText( "建造队列可用" )		
				BuilderData[i]["RedImg"]:setVisible(true)
				if BuilderData[i]["IdButton"] ~= nil then
					BuilderData[i]["IdButton"]:setVisible(false)
					BuilderData[i]["IdButton"]:setTouchEnabled(false)
				end
			end
		end
	end
end
--]]

--通过建造id设置相应的显示label
function setLableButtonFromId(_idx, _label, _button, _redImg)
	local num = #BuilderData
	for i=1, num do
		if BuilderData[i]["Idx"] == _idx then
			BuilderData[i]["IdLabel"] = _label
			BuilderData[i]["IdButton"] = _button
			BuilderData[i]["RedImg"] = _redImg
			return true
		end
	end
	return false
end
function clearAllLable()
	print("清除建筑队列.................................")
	local num = #BuilderData
	for i=1, num do
		BuilderData[i]["IdLabel"] = nil
		BuilderData[i]["IdButton"] = nil
		BuilderData[i]["RedImg"] = nil
	end

end

