module ("GuoZhanData",package.seeall)

GuoZhan_Ctiy = 1      -- 所在城市，1表示魏军大营 ......(详情见cmd)
GuoZhan_Position = 0  -- 0表示没有位置
GuoZhan_FightCD = 1   -- 战斗CD
GuoZhan_MoveCD = 1    -- 移动cd
local  GuoZhan_TP = 1          -- 快速到达城池
local  GuoZhan_GainZeny = 1  --获取银币
local  GuoZhan_Food = 1      -- 补给
local  GuoZhan_FoodMax = 1   -- 补给总量
local  GuoZhan_Hearten = 1   -- 鼓舞
local  GuoZhan_LiJiBuMan = 0 -- 立即不满所需要的金币数量
local  GuoZhan_LeftTime = 0  -- 国战剩余时间倒计时

local isStartGuoZhan = false


GuoZhan_CityName = {
	"魏军大营",
	"蜀军大营",
	"吴军大营",
	"东安门",
	"西安门",
	"横门",
	"东平门",
	"清明门",
	"西平门",
	"安门",
	"皇宫",
}

GuoZhan_YongJiName = {
	"无人",
	"稀少",	
	"普通",
	"拥挤",
	"爆满",
}

GuoZhan_Result ={
	"平局",
	"险胜",
	"小胜",
	"胜利",
	"大胜",
	"完胜",
	"惜败",
	"小败",
	"失败",
	"大败",
	"完败",
}

local  GuoZhan_MyKiller = 1  -- 我杀死的人数
GuoZhan_KillerPaiHangBang ={   --杀人排行榜
}

GuoZhan_ZhanBao = {  --国战战报
}

local GuoZhan_City_Number = 1 --城市总数
local  GuoZhan_CitySpyCD = {}

CityBlengs_cellData = {
	belong = 1,    --归属
	yongjidu = 1,   --城市拥挤程度
}

GuoZhan_PlayerData = {
	charid = 1,    --
	lv = 1,   	   --
	name = "", 
	pos = 0 ,
	belong = 1,
}

GuoZhan_ZhanBao = {
	ret = 1,
	camp = 1,
	name = "",
	lost = 1,
	time = "",
}

GuoZhan_KillerData = {  
	lv = 1,      --用户等级
	name = "",   --用户名称
	kill = 0 ,   --击杀数量
	belong = 1,  --归属阵营
}

GuoZhan_CityBelongs = {
}

GuoZhan_CityPosCount ={ --城市的位置数量
}

GuoZhan_CityPosPeople ={ --城市的人数
}

GuoZhan_CitySpysData ={  --所有的城市的侦查信息
	[1]={},
	[2]={},
	[3]={},
	[4]={},
	[5]={},
	[6]={},
	[7]={},
	[8]={},
	[9]={},
	[10]={},
	[11]={},
}

GuoZhan_CitySpyPlayerData = {  --某一个城市的侦查信息
}

local lable_gongjicd = nil   --显示刷新时间的lable
local lable_yidongcd = nil
local table_lable_spycd = {
	{["BG"] = nil, ["CD"]=nil},
	{["BG"] = nil, ["CD"]=nil},
	{["BG"] = nil, ["CD"]=nil},
	{["BG"] = nil, ["CD"]=nil},
	{["BG"] = nil, ["CD"]=nil},
	{["BG"] = nil, ["CD"]=nil},
	{["BG"] = nil, ["CD"]=nil},
	{["BG"] = nil, ["CD"]=nil},
	{["BG"] = nil, ["CD"]=nil},
	{["BG"] = nil, ["CD"]=nil},
	{["BG"] = nil, ["CD"]=nil},

} --11个城市的侦查cd
local progress_yinbi = nil
progress_number = 1    --哪一个进度


------------------玉玺状态
local rem_yuxiCD = 0
local lbl_yuxiCD = nil

function flushGuoZhanDataCDForManager()

	if GuoZhan_Ctiy ~= 1 and GuoZhan_Ctiy ~= 2 and GuoZhan_Ctiy ~=3 and progress_yinbi ~= nil then--设置进度条
		progress_number = progress_number+1
		if progress_number >30 then
			progress_number = 1
		end
		--progress_yinbi:setScaleX(0.01*progress_number*2/3)
		progress_yinbi:setPercent(progress_number*100/30)
	end

	if GuoZhan_FightCD >0 then
    	GuoZhan_FightCD = GuoZhan_FightCD -1
    	if lable_gongjicd ~= nil then
    		lable_gongjicd:setText(PT.gerStringFromMilSecond(GuoZhan_FightCD))
    	end
    elseif GuoZhan_FightCD <0 then
    	GuoZhan_FightCD = 0
   	end

	if GuoZhan_MoveCD >0 then
    	GuoZhan_MoveCD = GuoZhan_MoveCD -1
    	if lable_yidongcd ~= nil then
    		lable_yidongcd:setText(PT.gerStringFromMilSecond(GuoZhan_MoveCD))
    	end
    elseif GuoZhan_MoveCD <0 then
    	GuoZhan_MoveCD = 0
   	end

    for i=1,11 do
    	if GuoZhan_CitySpyCD[i] ~= nil and GuoZhan_CitySpyCD[i] >0 then
    		GuoZhan_CitySpyCD[i] = GuoZhan_CitySpyCD[i] -1
    		if table_lable_spycd[i]["CD"] ~= nil then
    			table_lable_spycd[i]["CD"]:setText( "侦查倒计时 " .. PT.gerStringFromMilSecond(GuoZhan_CitySpyCD[i]))
    			if GuoZhan_CitySpyCD[i] ==0 then
    				table_lable_spycd[i]["BG"]:setVisible(false)
    			else
    				table_lable_spycd[i]["BG"]:setVisible(true)
    			end
    		end
    	elseif  GuoZhan_CitySpyCD[i] ~= nil and GuoZhan_CitySpyCD[i]<0 then
    		GuoZhan_CitySpyCD[i] = 0
    	end    	
    end    
end

function setGuoZhanLableCD(_gongjiLable,yidongLable)
	lable_gongjicd = _gongjiLable
	lable_yidongcd = yidongLable
end

function setGuoZhanCitySpy(_index,_spylable,_spyImg)
	--table_insert(table_lable_spycd,_index,_spylable)
	table_lable_spycd[_index]["BG"] = _spyImg
	table_lable_spycd[_index]["CD"] = _spylable
end

function setGuoZhanJiangLiProgress(_progress) --设置国战银币进度条
	if _progress == nil then
		print("_progress is nil")
	else
		print(" _progress is not nil")
	end
	progress_yinbi = _progress
end

function setGuoZhanData(_Ctiy,_Position,_FightCD,_MoveCD,_GainZeny,_Food,_FoodMax,_Hearten,_tp,_leftTiem)
	GuoZhan_Ctiy 		= _Ctiy
	GuoZhan_Position 	= _Position
	GuoZhan_FightCD 	= _FightCD
	GuoZhan_MoveCD 		= _MoveCD
	GuoZhan_GainZeny 	= _GainZeny
	GuoZhan_Food 		= _Food
	GuoZhan_FoodMax 	= _FoodMax
	GuoZhan_Hearten 	= _Hearten
	GuoZhan_TP 			= _tp
	GuoZhan_LeftTime 	= _leftTiem

end
local lbl_CD = nil
function setTimeCDLbl(_lbl)

	lbl_CD = _lbl
end
function clearLeftTime()

	lbl_CD = nil
end
function flushGuoZhanLeftTime()

	if GuoZhan_LeftTime > 0 and lbl_CD ~= nil then
		
		GuoZhan_LeftTime = GuoZhan_LeftTime - 1
		local str = PT.gerStringFromMilSecond( GuoZhan_LeftTime )
		
		lbl_CD:setText("距离国战结束:" .. str)
	end
end
function setSpyCityCD(_index,_spycd)
	table_insert(GuoZhan_CitySpyCD,_index,_spycd)
	--GuoZhan_CitySpyCD[_index]= _spycd
end

function getSpyCityCD( _index)
	return GuoZhan_CitySpyCD[_index]
end

function setCityNumber(_cityNumber)
	GuoZhan_City_Number = _cityNumber
end

function addCityBelong(_belongData,_index)
	table_insert(GuoZhan_CityBelongs,_index,_belongData)
end

function getCityBelong(_index)
	if 	GuoZhan_CityBelongs[_index] ~= nil then
		return GuoZhan_CityBelongs[_index]["belong"]
	else
		return nil
	end
end

function getYongJiDu(_index)
	print(" getYongJiDu _index is  ".._index)
	if GuoZhan_CityBelongs[_index]["yongjidu"] ~= nil 
		and  GuoZhan_YongJiName[GuoZhan_CityBelongs[_index]["yongjidu"]] ~= nil then
		return "("..GuoZhan_YongJiName[GuoZhan_CityBelongs[_index]["yongjidu"]]..")"
	else
		return "(错误)"
	end	
end

function addCitySpyData(_city,_index,_spydata)
	--table_insert(GuoZhan_CitySpysData[_city],_index,_spydata)	
	print("the city is ".._city)
	GuoZhan_CitySpysData[_city][_index]=_spydata
end

function getCitySpyNumber(_index)
	local weinum = 0
	local shunum = 0
	local wunum = 0
	local CitySpynum = 0
	CitySpynum = #GuoZhan_CitySpysData[_index]
	--CitySpynum = GuoZhan_CityPosPeople[_index]
	for i=1,CitySpynum do
		local  people = GuoZhan_CitySpysData[_index][i]
		if people["belong"] == 1 then
			weinum = weinum +1
		elseif people["belong"] == 2 then
			shunum = shunum +1
		elseif  people["belong"] == 3 then
			wunum = wunum +1
		end
	end
	return weinum,shunum,wunum
end

function getCitySpyData(_city,_index)
	return GuoZhan_CitySpysData[_city][_index]
end

function clearKillPaiHangBang()
	GuoZhan_KillerPaiHangBang = {}
end

function addKillPaiHangBang(_killData,_index)
	table_insert(GuoZhan_KillerPaiHangBang,_killData)
end

function clearGuoZhanZhanBao()
	GuoZhan_ZhanBao = {}
end

function addGuoZhanZhanBao(_zhanbao)
	table_insert(GuoZhan_ZhanBao,_zhanbao)
end 

function getGuoZhanZhanBaoNum()
	return #GuoZhan_ZhanBao
end

function getGuoZhanZhanBaoByIndex(_index)
	return GuoZhan_ZhanBao[_index]
end

function getKillPaiHangBangNum()
	return #GuoZhan_KillerPaiHangBang
end

function getKillPaiHangBangByIndex(_index)
	return GuoZhan_KillerPaiHangBang[_index]
end

function clearKillPaiHangBang()
    GuoZhan_KillerPaiHangBang = {}
 end 

function setLiJiBuMan(_price )
	GuoZhan_LiJiBuMan = _price
end

function getBuJi()	
	return GuoZhan_Food,GuoZhan_FoodMax
end

function setCityPosCount( city,poscount,citypoeple)
	table_insert(GuoZhan_CityPosCount,city,poscount)
	table_insert(GuoZhan_CityPosPeople,city,citypoeple)
end

function getPeopleNumber(city)
	return GuoZhan_CityPosPeople[city]
end

function getCityPosAndPeo(city)
	 return  GuoZhan_CityPosPeople[city].."/"..GuoZhan_CityPosCount[city]
end

function getMyKiller()
	return #GuoZhan_KillerPaiHangBang
end

function getGuwuRatio()
	return GuoZhan_Hearten
end

function getCity()
	return GuoZhan_Ctiy
end

function getChi()
	return GuoZhan_TP
end

function setIsStartGuoZhan( _state )
	isStartGuoZhan=_state
end

function getIsStartGuoZhan()
	return isStartGuoZhan
end

-----------------------------------------

function setYuXiCd( _cd )
	rem_yuxiCD = _cd
end
function getYuXiCd()
	return rem_yuxiCD
end
function checkIfHaveYuXi()
	if rem_yuxiCD > 0 then
		return true
	else
		return false
	end
end
function setYuXiLbl( _lbl )
	lbl_yuxiCD = _lbl
end

function flushYuXiCd()
	if rem_yuxiCD > 0 then
		rem_yuxiCD = rem_yuxiCD -1
		if lbl_yuxiCD ~= nil then
			local str = PT.gerStringFromMilSecond( rem_yuxiCD )
			lbl_yuxiCD:setText("剩余时间：" .. str)
		end
	end

end


