module ("JTFightData",package.seeall)
--军团战战斗数据和团队数据

TeamTemplet = {
	Id 				= 0, --玩家在团队里的id
	Name 			= "", --玩家名字
}

------------------------------------------------
		FightGeneralTemplet = {
			GeneralPos = 0, --将领所在阵型位置
			GeneralId = 0, --将领id
			CurBlood = 0, --当前所剩血量
			MaxBlood = 0, --最大血量
		}
	FightTeamTemplet = {
		Pos 		= 0, --所在的位置（大的位置，123， 456）
		TeamId 		= 0, --军团数据索引
		Type 		= 0, --这一回合的战斗状态0为状态不变 1为上场 2为正在战斗 3为胜利等待 4为下场
		WinCount	= 0, --连胜次数
		TypeBlood   = 0, --0减血1加血
		LoseBlood 	= 0, --这一回合掉了多少血
		GeneralCount= 0, --掉血的将领数量
		GeneralData = {}
	}
FightRoundTemplet = {
	TeamNum = 0,
	TeamData = {}
}

local fightResult = -1 --0:失败 1:胜利
local gongjiCityIndex = 1

local LeftTeamDataList = {}
local RightTeamDataList = {}
local FightDataList = {}

function getName()
	return 
end

function clearAllData()
	fightResult = -1
	LeftTeamDataList = {}
	RightTeamDataList = {}
	FightDataList = {}
end

function setFightResult( _result )
	fightResult = _result
end

function getFightResult()
	return fightResult
end
function addTeamDataList(_swc, _data)
	if _swc == 1 then
		table_insert( LeftTeamDataList, _data )
	elseif _swc == 2 then
		table_insert( RightTeamDataList, _data )
	end
end
function getTeamdataList(_swc)
	if _swc == 1 then
		return LeftTeamDataList
	elseif _swc == 2 then
		return RightTeamDataList
	end
end

--获取团队里teamid对应的数据顺序
function getTeamIdIndex(_swc, _id)
	if _swc == 1 then
		local num = #LeftTeamDataList
		for i=1, num do
			if LeftTeamDataList[i]["Id"] == _id then
				return i, LeftTeamDataList[i]["Name"]
			end
		end
	elseif _swc == 2 then
		local num = #RightTeamDataList
		for i=1, num do
			if RightTeamDataList[i]["Id"] == _id then
				return i, RightTeamDataList[i]["Name"]
			end
		end
	end
	return 0
end

function addFightDataList( _data )
	table_insert( FightDataList, _data )
end

function getMaxFightRound()
	return #FightDataList
end
function getRoundFightData( RoundIdx )
	return FightDataList[RoundIdx]
end

function getLeftTeamNameFromLocIdx(_idx)
	if LeftTeamDataList[_idx] ~= nil then
		return LeftTeamDataList[_idx]["Name"]
	else
		return nil
	end
end