--征收数据
module ("LevyData",package.seeall)

local LevyData = {
	leftTime 	= 0,  --今日剩余可征收次数
	MaxTime 	= 0,   --今日最大可征收次数
	CDState 	= 0,   --征收cd状态 0：可征收 1：不可征收
	CDTime 		= 0, 	--征收的CD
	NeedGold 	= 0, 	--强征所需金币
	LevyEventId	= 0, --征收事件id
	LevyYuQiZeny= 0, --征收预期收获金币

	lable = nil,
	button = nil,

	pubLable = nil,
	pubButton = nil, 
	pubRedPoint = nil,
}


function flushCdAndState( _state, _cd )
	LevyData["CDState"] 	= _state
	LevyData["CDTime"] 		= _cd
end
function flushLevyData(_leftTime, _MaxTime, _CDState, _CDTime, _NeedGold, _LevyEventId, _LevyYuQiZeny)
	LevyData["leftTime"] 	= _leftTime
	LevyData["MaxTime"] 	= _MaxTime
	LevyData["CDState"] 	= _CDState
	LevyData["CDTime"] 		= _CDTime
	LevyData["NeedGold"] 	= _NeedGold
	LevyData["LevyEventId"] = _LevyEventId
	LevyData["LevyYuQiZeny"]= _LevyYuQiZeny
end

function getYuQiZeny()
	return  LevyData["LevyYuQiZeny"]
end

function refreshZeny(_LevyYuQiZeny)
	LevyData["LevyYuQiZeny"]= _LevyYuQiZeny
end

function flushLeftTime( _leftTime )
	LevyData["leftTime"] = _leftTime
end
function getLevyData()
	return LevyData
end
--清除征收事件
function clearLevyEvent()
	LevyData["LevyEventId"] = 0
end
--清除CD
function clearCD()
	LevyData["CDTime"] = 0
	LevyData["CDState"] = 0
end
function setlableButton( _lbl, _btn )
	LevyData["lable"] 	= _lbl
	LevyData["button"] 	= _btn
end
function clearLabelButton()
	LevyData["lable"] 	= nil
	LevyData["button"] 	= nil
end

function setPubLableButton( _lbl, _btn, _redImg )
	LevyData["pubLable"] 	= _lbl
	LevyData["pubButton"] 	= _btn
	LevyData["pubRedPoint"] = _redImg
end
function clearPubLableButton()
	LevyData["pubLable"] 	= nil
	LevyData["pubButton"] 	= nil
	LevyData["pubRedPoint"] = nil
end
--检测征收是否可用，为是否显示小红点
function checkLevyIfBeUse()
	if LevyData["CDState"] == 0 then --可用
		return true
	else
		return false
	end
end
--刷新征收的倒计时
function flushLevyCDTime()
	if LevyData["CDTime"] > 0 then
		LevyData["CDTime"] =  LevyData["CDTime"] - 1

		if LevyData["CDTime"] == 0 then
			protoSend0x0524( 9 )
		end

		if LevyData["lable"] ~= nil then
			local str = PT.gerStringFromMilSecond( LevyData["CDTime"] )
			LevyData["lable"]:setText( str )
			if LevyData["CDState"] == 0 then --可用
				LevyData["lable"]:setColor( ccc3(255, 255, 255) )
			else --不可用
				LevyData["lable"]:setColor( ccc3(255, 0, 0) )
			end
			if LevyData["button"] ~= nil then
				LevyData["button"]:setVisible(true)
				LevyData["button"]:setTouchEnabled(true)
			end
		end
		if LevyData["pubLable"] ~= nil then
			local str = PT.gerStringFromMilSecond( LevyData["CDTime"] )
			LevyData["pubLable"]:setText( str )
			if LevyData["CDState"] == 0 then --可用
				LevyData["pubRedPoint"]:setVisible(true)
				LevyData["pubLable"]:setColor( ccc3(255, 255, 255) )
			else --不可用
				LevyData["pubRedPoint"]:setVisible(false)
				LevyData["pubLable"]:setColor( ccc3(255, 0, 0) )
			end
			if LevyData["pubButton"] ~= nil then
				LevyData["pubButton"]:setVisible(true)
				LevyData["pubButton"]:setTouchEnabled(true)
			end
		end
	else
		if LevyData["lable"] ~= nil then
			LevyData["lable"]:setColor( ccc3(255, 255, 255) )
			LevyData["lable"]:setText("可以征收")
			if LevyData["button"] ~= nil then
				LevyData["button"]:setVisible(false)
				LevyData["button"]:setTouchEnabled(false)
			end
		end
		if LevyData["pubLable"] ~= nil then
			LevyData["pubLable"]:setColor( ccc3(255, 255, 255) )
			LevyData["pubLable"]:setText("可以征收")
			LevyData["pubRedPoint"]:setVisible(true)
			if LevyData["pubButton"] ~= nil then
				LevyData["pubButton"]:setVisible(false)
				LevyData["pubButton"]:setTouchEnabled(false)
			end
		end
	end

end