--战斗数据
module ("MapFightData",package.seeall)
--[[
	BufTemplet = {
		ifBufOpen = 0, --0关闭  否则开启
	}

		DeferTemplet = {
			DeferPos 		= 0,	--被攻击者的位置
			DeferDamage 	= 0, 	--被攻击者受到的伤害
			DeferIfdead 	= 0, 	--是否死亡
			DeferIfFail 	= 0, 	--是否失败 1失败
			DeferBufCount	= 0, 	--buf数量--0为眩晕 1为水 2为火 3为风 4为中毒 5为反间
			DeferBufData 	= {},
		}
	AckTemplet = {
		AckerPos 	= 0,	--本次出手的出手者位置
		BufHurt 	= 0, 	--所受buf产生的伤害
		Flag 		= 0, 	--1 女神 2 将领
		AttackType  = 0,	--1为普通，2为暴击，3为格挡，4为躲闪，5为反击，6为识破
		SkillId 	= 0, 	--本次出手释放的技能id
		DeferPos 	= 0,	--防守方位置
		BufCount 	= 0,	--buf数量
		DeferCount 	= 0, 	--防守者数量
		BufData = {},
		DeferData 	= {},
	}
RoundTemplet = {
	AckCount 	= 0, 	--当前回合的出手次数
	AckData 	= {},
}
--]]

			ChangeTemplet ={ 
				ChangeType = 0, --0:默认 1：被加血 2：被鼓舞（+气）3：被驱散加血 4:免疫（无用数据项）
				--免疫的dotaid
				ChangePos 	= 0, --防守者位置
				IfFail 		= 0, --是否失败 1为失败
				IfAddHp 	= 0, --+-血 1加血 2减血
				ChangeHp 	= 0, --改变的量
				LeftHp 		= 0, --剩余血量
				MaxHp 		= 0, --最大血量
				IfAddQi 	= 0, --+-气
				ChangQi 	= 0, --改变的气
				LeftQi 		= 0, --剩余的气
				MaxQi 		= 0, --最大气
				DotNum 		= 0, --所有dot数量
				DotData = {},
			}
		DamageTemplet = {
			Flag 				= 0, --攻击者 1女神 2将领 3 combo 4女神打多个
			ActType 			= 0, --攻击类型 0:女神攻击失败 1为普通，2为暴击，3为躲闪，4为格挡，5为反击，6为识破 8秒杀

		
			ComboType    		= 0,  --combo的类型0 无combo 1234 火水风小
			HighlightPos 		= 0,  --combo点亮的头像位置123
			ComboPos1      		= 0,  --combo攻击时另两个位置
			ComboPos2      		= 0, --combo攻击时另两个位置
			HighlightGeneralId 	= 0, --combo点亮的头像的将领id

			SkillId 			= 0,  --技能id
			DeferPos 			= 0, --防守方位置

			ChangeNum 			= 0, --状态改变者数量
			ChangeData 			= {},
		}
	AckTemplet = {
		AckerPos 		= 0, --本次出手的出手者位置
		
		--del
		--AckerPos1   	= 0, --combo位置只有ocmbo有意义
		--AckerPos2   	= 0, --combo位置只有ocmbo有意义
		--ComboId 	 	= 0, --combo技能标识

		IfVertigo 		= 0, --出手者是否眩晕
		WeatherDotlost 	= 0, --出手者因天气变化丢失的dot 0：没有 1：火 2：水
		DotHurt 		= 0, --出手者受到的dot产生的伤害
		LeftHp 			= 0, --攻击者剩余血量
		MaxHp 			= 0, --攻击者最大血量

		--新的DotHurtNum和DotHurtData的设计需求，每次出手，判断自己dota的变化
		DotHurtNum 		= 0, --出手前dota需要改变的dota数量
		DotHurtData 	= {},
		DamageNum 		= 0, --此位置出手人数 不大于2
		DamageData 		= {},

		--老的DotHurtNum和DotHurtData的设计需求
		--DotHurtNum     	= 0, --产生伤害的dot的数量
		--DotHurtData 	= {}, --哪些dot产生的伤害， (服务器端下标，是从0开始 客户端从1开始)1为火有伤害特效 2为水有伤害特效 3为风有伤害特效 6为逃兵有伤害特效
		

	}
	--------------------------------------
		DotTemplet = { ----1眩晕2火3水4风5中毒6反间7逃兵8破胆9不屈
			num = 0,  --这个数字大多数>0代表对应的dot开启 有时也表示一个对应dot的开关
		}

	BufChangeTemplet = { --无用
		Pos 	= 0, --需要改变dot的位置
		DotNum 	= 0, --这个位置上的dot数量
		DotData = {},
	}
RoundTemplet = {
	AckCount 	= 0, 	--当前回合的出手次数
	AckData 	= {},
	
	BufChangeNum= 0,    --当前回合需要改变dot的位置数量
	BufChangeData = {}, --w无用
}		

local _M = {
	Result 		= 0, --战斗结果 0为平局1为险胜2为小胜3为胜4为大胜5为完胜6为惜败7为小败8为失败9为大败10为完败
	KillUnit 	= 0, --杀敌数
	LostUnit 	= 0, --损失数
	Weather 	= 0, --当前天气

	LeftGodCount 	= 0,    --0为小于三个1为等于三个 2为大于三个
	LeftComboType 	= 0,
	LeftJnrId1 		= 0,
	LeftJnrId2 		= 0,
	LeftJnrId3 		= 0,
	RightGodCount 	= 0, --0为小于三个1为等于三个 2为大于三个
	RightComboType  = 0, --初始的combo类型
	RightJnrId1 	= 0,
	RightJnrId2 	= 0,
	RightJnrId3 	= 0,

	RoundCount 	= 0, --战斗回合数
	RoundData 	= {},
}

function setFightBaseData( _result, _kill, _lost, _weather, _leftgodcount,_leftcombotype, _leftId1, _leftId2, _leftId3, _rightgodcount,_rightcombotype, _rightId1, _rightId2, _rightId3, _round  )
	_M.Result 		= _result
	_M.KillUnit 	= _kill
	_M.LostUnit 	= _lost
	_M.RoundCount 	= _round
	_M.Weather 		= _weather

	_M.LeftGodCount 	= _leftgodcount    --0为小于三个1为等于三个 2为大于三个
	_M.LeftComboType 	= _leftcombotype
	_M.LeftJnrId1 		= _leftId1
	_M.LeftJnrId2 		= _leftId2
	_M.LeftJnrId3 		= _leftId3
	_M.RightGodCount 	= _rightgodcount --0为小于三个1为等于三个 2为大于三个
	_M.RightComboType  	= _rightcombotype --初始的combo类型
	_M.RightJnrId1 		= _rightId1
	_M.RightJnrId2 		= _rightId2
	_M.RightJnrId3 		= _rightId3

	_M.RoundData 		= {}
end
--获取战斗支出需要初始化的combo数据
function getFightRoundBeginComboData(_lfOrRi)
	if _lfOrRi then
		return _M.LeftGodCount, _M.LeftComboType, _M.LeftJnrId1, _M.LeftJnrId2, _M.LeftJnrId3
	else
		return _M.RightGodCount, _M.RightComboType, _M.RightJnrId1, _M.RightJnrId2, _M.RightJnrId3
	end
end

--回合数据
function setRoundData(_data)
	table_insert( _M.RoundData, _data )
end
function setAckData( _roundIndex, _data )
	table_insert( _M.RoundData[_roundIndex].AckData, _data )
end
--设置回合结束buf改变位置数据
function setBufChangeData(_roundIndex, _data)
	table_insert( _M.RoundData[_roundIndex].BufChangeData, _data )
end
--设置回合结束buf改变数据
function setBufChangeDotData(_roundIndex, _BufChangeIndex, _data)
	table_insert( _M.RoundData[_roundIndex].BufChangeData[_BufChangeIndex].DotData, _data )
end
--出手前受到dot伤害的特效数据
function setDotHurtData(_roundIndex, _ackIndex, _data)
	table_insert( _M.RoundData[_roundIndex].AckData[_ackIndex].DotHurtData, _data )
end
function setDamageData(_roundIndex, _ackIndex, _data)
	table_insert( _M.RoundData[_roundIndex].AckData[_ackIndex].DamageData, _data )
end

function setChangeData(_roundIndex, _ackIndex, _DamageIndex, _data)
	table_insert( _M.RoundData[_roundIndex].AckData[_ackIndex].DamageData[_DamageIndex].ChangeData, _data )
end
function setChangeDotData(_roundIndex, _ackIndex, _DamageIndex, _ChangeIndex, _data)
	table_insert( _M.RoundData[_roundIndex].AckData[_ackIndex].DamageData[_DamageIndex].ChangeData[_ChangeIndex].DotData, _data )
end
function getMaxRoundData()
	return _M.RoundCount
end
function getCurRoundData(_curRoundIndex)
	return _M.RoundData[_curRoundIndex]
end

function getWeather()
	return _M.Weather
end
--返回战斗结局 敌我双方的兵量损失
function getFightResult()
	return _M.Result, _M.LostUnit, _M.KillUnit
end
---[[
function setBufData(_roundIndex, _ackIndex, _data)
	table_insert( _M.RoundData[_roundIndex].AckData[_ackIndex].BufData, _data )
end
function setDeferData( _roundIndex, _ackIndex, _data )
	table_insert( _M.RoundData[_roundIndex].AckData[_ackIndex].DeferData, _data )
end

function setDeferBufData(_roundIndex, _ackIndex, _deferIndex, _data)
	table_insert( _M.RoundData[_roundIndex].AckData[_ackIndex].DeferData[_deferIndex].DeferBufData, _data )
end

function getRoundDataFromIndex( _roundIndex )
	return _M.RoundData[_roundIndex]
end
function getAckDataFromIndex( _roundIndex, _ackIndex )
	return _M.RoundData[_roundIndex].AckData[_ackIndex]
end
function getDeferDataFromIndex( _roundIndex, _ackIndex, _DeferIndex )
	return _M.RoundData[_roundIndex].AckData[_ackIndex].DeferData[_DeferIndex]
end
--获取战斗回合数
function getRoundCount()
	return _M.RoundCount
end

function getRoundDataFromIndex( _RoundIndex )
	return _M.RoundData[_RoundIndex]
end
--获取当前回合的出手次数
function getAckCount( _RoundIndex )
	return getRoundDataFromIndex(_RoundIndex)["AckCount"]
end
function getAckDataFromIndex(_RoundIndex, _AckIndex)
	--print("_RoundIndex === " .. _RoundIndex)
	return getRoundDataFromIndex(_RoundIndex)["AckData"][_AckIndex]
end
--获取防御者数量
function getDeferCount( _RoundIndex, _AckIndex )
	return getAckDataFromIndex(_RoundIndex, _AckIndex)["DeferCount"]
end
function getDeferDataFromIndex( _RoundIndex, _AckIndex, _deferIndex )
	return getAckDataFromIndex(_RoundIndex, _AckIndex)["DeferData"][_deferIndex]
end
--]]
