module ("SDNpcData",package.seeall)
--扫荡npc数据


SaoDangResTemplet = {
	Id 		= 1, --第几场的数据
	Ret 	= 2, --战斗结果 0为平局 1为险胜 2为小胜 3为胜利 4为大胜 5为完胜 6为惜败 7为小败 8为失败 9为大败 10为完败
	value1 	= 3, --军工
	value2 	= 4, --装备id
}
local Type = 0  		--2:普通npc 3隐藏npc
local curCharpterId = 0  	--扫荡的当前章节id
local curNpcId = 0 			--扫荡的当前章节的npc id
local tatalSize = 0 		--总得扫荡次数

local saoDangType = 0  ----1为暂停 2为结束 0正在扫荡 3手动结束扫荡
local saoDangReason = 0 --type为暂停时 1为征战cd 2为粮草为0 type为结束时 1为正常结束 2为军令为0

local SaoDangList = {}

function setBaseData(_type, _charPterId, _npcId, _tatal)
	Type = _type
	curCharpterId = _charPterId
	curNpcId = _npcId
	tatalSize = _tatal
end
function getBaseData()
	return Type, curCharpterId, curNpcId
end

function setSaoDangZhuangTai(_type, _reason)
	saoDangType		= _type
	saoDangReason 	= _reason
end
function getSaoDangZhuangTai()
	return saoDangType, saoDangReason
end
function addSaoDangData(_data)
	table_insert(SaoDangList, _data)
end
--获取剩余挑战次数
function getLeftSize()
	return tatalSize-#SaoDangList
end
function getTatalSize()
	return tatalSize
end
--检测是否需要显示倒计时显示
function checkIfViweTime()
	if saoDangType == 0 then
		return true
	else
		return false
	end
end
function getSaoDangDataCurNum()
	return #SaoDangList
end
function getSaoDangDataFromIdx(_idx)
	return SaoDangList[_idx]
end
function getLastSaoDangData()
	local size = #SaoDangList
	return SaoDangList[size]
end
--检测当前npc是否正在扫荡
function checkIfSaoDang(charpterId, npcid)
	if charpterId~= 0 and Type==2 then --普通npc
		if charpterId == curCharpterId and npcid == curNpcId then
			return true
		else
			return false
		end
	elseif charpterId== 0 and Type==3 and npcid == curNpcId then --隐藏npc
		return true
	end
	return false
end
function clearSaoDangData()
	SaoDangList = {}
	Type = 0  			--2:普通npc 3隐藏npc
	curCharpterId = 0  	--扫荡的当前章节id
	curNpcId = 0 		--扫荡的当前章节的npc id
	tatalSize = 0 		--总得扫荡次数

	saoDangType		= 0
	saoDangReason 	= 0
end