module ("TeamMemberListData",package.seeall)
--公会成员列表
TeamMemberTemplet = {
	Name = "", 		--人物名
	GuildOffi = 0, 	--官职	1会长 2副会长 3万夫长 4千夫长 5百夫长 6精兵 7杂兵
}

local MemberList = {
	TeamId = 0,
	CreatName 	= "",     --军团创始人名字
	JunHuiName = "",
	CreatYear 	= 0,     --军团创建年
	CreatSeason = 0,     --军团创建季节
	Belongs 	= 0,     --军团所属国家
	GuildLv 	= 0, 	--军团等级
	EmbLv 		= 0, 	--军徽等级
	CurNum 		= 0,	--当前成员数
	MaxNum 		= 0, 	--最大成员数
	GuildName 	= "",   	--军团名字
	Zeney 		= 0, 	--军团资金
	ZeneyMax 	= 0, 	--军团资金上限
	Count 		= 0, 	--军团官职数量	
	MemberData = {},
}

function setMemberListData(_id, _CreatName,_junHuiName, _CreatYear, _CreatSeason, _Belongs, _GuildLv, _EmbLv, _CurNum, _MaxNum, _GuildName, _zeney,_zeneyMax,_Count)
	MemberList["TeamId"] 	= _id
	MemberList["CreatName"] 	= _CreatName
	MemberList["JunHuiName"] 	= _junHuiName
	MemberList["CreatYear"] 	= _CreatYear
	MemberList["CreatSeason"] 	= _CreatSeason
	MemberList["Belongs"] 		= _Belongs
	MemberList["GuildLv"] 		= _GuildLv
	MemberList["EmbLv"] 		= _EmbLv
	MemberList["CurNum"] 		= _CurNum
	MemberList["MaxNum"] 		= _MaxNum
	MemberList["GuildName"] 	= _GuildName
	MemberList["Zeney"] 		= _zeney
	MemberList["ZeneyMax"] 		= _zeneyMax
	MemberList["Count"] 		= _Count
end
function clearMemberData()
	MemberList["MemberData"]  = {}
end
function addMemberData(_data)
	table_insert( MemberList["MemberData"], _data )
end
function getMemberSize()
	return MemberList["CurNum"], MemberList["MaxNum"]
end

--清除表中数据,不清除的话会往里面一直添加重复数据
function clearMemberData()
	MemberList["MemberData"]=nil
	MemberList["MemberData"]={}
end

function getGuildName()
	return MemberList["GuildName"] 
end
function setGuildName(_juntuanName)
	MemberList["GuildName"]=_juntuanName
end
function getGuildId()
	return MemberList["TeamId"] 
end
function getCreatName()
	return MemberList["CreatName"]
end

function getJunTuanZiJin()
	return MemberList["Zeney"]
end

function getJunTuanZiJinMax()
	return MemberList["ZeneyMax"]
end

function getCreatTimeString()

	local function getSeason(_idx)
		if _idx == 0 then
			return "春"
		elseif _idx == 1 then
			return "夏"
		elseif _idx == 2 then
			return "秋"
		elseif _idx == 3 then
			return "冬"
		end
	end
	return MemberList["CreatYear"] .. "年" .. getSeason(MemberList["CreatSeason"])
end
function getBelongsCountry()
	local belongs = MemberList["Belongs"]
	if belongs == 1 then
		return "魏"
	elseif belongs == 2 then
		return "蜀"
	elseif belongs == 3 then
		return "吴"
	end 
end
function getGuildLv()
	return MemberList["GuildLv"]
end
function getEmbLv()
	return MemberList["EmbLv"]
end
function setEmbLv( _emblv )
	MemberList["EmbLv"] = _emblv
end
function getJunHuiName()
	return MemberList["JunHuiName"]
end
function setJunHuiName( _junHuiName )
	MemberList["JunHuiName"] = _junHuiName
end
--获取相关官职的人员
function getOfficalMember( _idx )
	local remTable = {}
	local data = MemberList["MemberData"]
	local Num = #data
	for i=1, Num do
		if data[i]["GuildOffi"] == _idx then
			table_insert(remTable,  data[i]["Name"] )
		end
	end
	return remTable
end