require "socket"

-- 获取屏幕尺寸
WinSize = CCDirector:sharedDirector():getWinSize()
print("lua WinSize W == " .. WinSize.width)
print("lua WinSize H == " .. WinSize.height)

VisibleSize = CCEGLView:sharedOpenGLView():getVisibleSize()
print("lua VisibleSize W == " .. VisibleSize.width)
print("lua VisibleSize H == " .. VisibleSize.height)

FramSize = CCEGLView:sharedOpenGLView():getFrameSize()
print("lua FramSize W == " .. FramSize.width)
print("lua FramSize H == " .. FramSize.height)

-- 设计尺寸
DesignSizeW = 960
DesignSizeH = 640

-- 使用尺寸
UseW = VisibleSize.width
UseH = VisibleSize.height

ListFontSize = 24

require "LuaScript/SdkConfig"

require "LuaScript/SocketModule/SocketCMD"
socketMachine = require "LuaScript/SocketModule/SocketMachine"
require "LuaScript/SocketModule/SocketParse"
require "LuaScript/SocketModule/SocketParseFunc"
require "LuaScript/SocketModule/SocketSendFunc"

require "LuaScript/PubModule/pubTool"
require "LuaScript/PubModule/pubTouchEffect"
require "LuaScript/PubModule/pubLoading"
require "LuaScript/PubModule/PubLocalDes"
require "LuaScript/PubModule/pubArmatureManager"
require "LuaScript/PubModule/pubHeartManager"
require "LuaScript/PubModule/pubComboViewControl"
require "LuaScript/PubModule/pubReLogin"
require "LuaScript/PubModule/GuideModule/guideUi_a"
require "LuaScript/PubModule/GuideModule/guideUi_b"
require "LuaScript/PubModule/GuideModule/guideUi_c"
require "LuaScript/PubModule/GuideModule/guideUi_d"
require "LuaScript/PubModule/GuideModule/guideFactory"
require "LuaScript/PubModule/pubLayerManager"
require "LuaScript/PubModule/pubShieldingWord"

require "LuaScript/Data/FormationData"
require "LuaScript/Data/GeneralData"
require "LuaScript/Data/MapFightData"
require "LuaScript/Data/BuilderData"
require "LuaScript/Data/CityData"
require "LuaScript/Data/TechnologyData"
require "LuaScript/Data/TrainData"
require "LuaScript/Data/PlayerData"
require "LuaScript/Data/CDTimeManager"
require "LuaScript/Data/FoodData"
require "LuaScript/Data/LevyData"
require "LuaScript/Data/NpcListData"
require "LuaScript/Data/ChapterListData"
require "LuaScript/Data/FightRewardData"
require "LuaScript/Data/ReportData"
require "LuaScript/Data/BagData"
require "LuaScript/Data/WordCityData"
require "LuaScript/Data/WordCityAreaData"
require "LuaScript/Data/JunTuanNpcRoomData"
require "LuaScript/Data/JunTuanFightData"
require "LuaScript/Data/GuildListData"
require "LuaScript/Data/GuildMemberData"
require "LuaScript/Data/MailListData"
require "LuaScript/Data/TeamApplyListData"
require "LuaScript/Data/TeamTechnologyData"
require "LuaScript/Data/TeamMemberListData"
require "LuaScript/Data/TalkData"
require "LuaScript/Data/JisiData"
require "LuaScript/Data/DelegateData"
require "LuaScript/Data/OfficialData"
require "LuaScript/Data/XunBaoData"
require "LuaScript/Data/TaskDailyData"
require "LuaScript/Data/TaskMainData"
require "LuaScript/Data/GuoZhanData"
require "LuaScript/Data/RegisterLoginData"
require "LuaScript/Data/JunTuanZhanData"
require "LuaScript/Data/NongTianYinKuangMemberData"
require "LuaScript/Data/NongTianYinKuangZhanBaoData"
require "LuaScript/Data/MapFightComboData"
require "LuaScript/Data/RankData"
require "LuaScript/Data/SaoDangNpcData"
require "LuaScript/Data/JunTuanAutoFightResult"
require "LuaScript/Data/MySlaveData"
require "LuaScript/Data/ChengJiuData"
require "LuaScript/Data/FindHelpData"
require "LuaScript/Data/MeiRiDengLuJiangLiData"
require "LuaScript/Data/ChongZhiActivityData"
require "LuaScript/Data/HuoDongData"

require "LuaScript/Login/Login"
require "LuaScript/Char/Char"
require "LuaScript/Map/MapFight"
-- require "LuaScript/Map/JTZZhanbaoFight"
-- require "LuaScript/Map/JTZZhanbaoFight_Sex"
-- require "LuaScript/Map/JTZZhanbaoFightResult"
require "LuaScript/Map/MapFight_Sex"
require "LuaScript/Map/MapShouYe"
require "LuaScript/Map/MapZhengZhan"
require "LuaScript/Map/MapShiJie"
require "LuaScript/Map/MapShiJie_QuYu"
require "LuaScript/Map/MapShiJie_QuYu_Pop3"
require "LuaScript/Map/MapPubUI"
require "LuaScript/Map/MapFight_GongLue"
require "LuaScript/Map/MapFight_Result"
require "LuaScript/Map/MapFight_Talk"
require "LuaScript/Map/MapJunTuanFight"
require "LuaScript/Map/MapJunTuanFight_Result"
require "LuaScript/Map/MapYinKuang"
require "LuaScript/Map/MapNongTian"
require "LuaScript/Map/MapFight_PaopaoTalk"
require "LuaScript/Map/MapFight_PaopaoTalk2"


require "LuaScript/Map/GuoZhanUI/Pop3_GuoZhanGuiZe"
require "LuaScript/Map/GuoZhanUI/GuoZhan_Map"
require "LuaScript/Map/GuoZhanUI/Pop3_GuoZhan_LuoYangCheng"
require "LuaScript/Map/GuoZhanUI/GuoZhan_MainUI"
require "LuaScript/Map/GuoZhanUI/Pop3_GuoZhan_PaiHangBang"
require "LuaScript/Map/GuoZhanUI/Pop3_GuoZhan_CityPlayers"

require "LuaScript/Map/JunTuanZhan/Pop3_JunTuanZhan_JiaRu"
require "LuaScript/Map/JunTuanZhan/Pop3_JunTuanZhan_JieGuo"
require "LuaScript/Map/JunTuanZhan/Pop3_JunTuanZhan_TuiChu"
require "LuaScript/Map/JunTuanZhan/Pop3_JunTuanZhan_GuanKa"
require "LuaScript/Map/JunTuanZhan/JunTuanZhan_JunTuanFight"
require "LuaScript/Map/JunTuanZhan/Pop3_JunTuanZhan_GuWu"
require "LuaScript/Map/JunTuanZhan/Pop3_JunTuanZhan_ChangeMember"

require "LuaScript/Map/RegisterAndLogin/RL_ChangeAccount"
require "LuaScript/Map/RegisterAndLogin/RL_GameName"
require "LuaScript/Map/RegisterAndLogin/RL_Login"
require "LuaScript/Map/RegisterAndLogin/RL_Register"
require "LuaScript/Map/RegisterAndLogin/RL_ServerList"
require "LuaScript/Map/RegisterAndLogin/RL_UpdateData"
require "LuaScript/Map/RegisterAndLogin/RL_ChooseCamp"



require "LuaScript/Map/Pop3/Map_Pop3_ZhuCheng"
require "LuaScript/Map/Pop3/Map_Pop3_MinJu"
require "LuaScript/Map/Pop3/Map_Pop3_JunJiChu"
require "LuaScript/Map/Pop3/Map_Pop3_JiaoChang"
require "LuaScript/Map/Pop3/Map_Pop3_JunXieKu"
require "LuaScript/Map/Pop3/Map_Pop3_GuoKu"
require "LuaScript/Map/Pop3/Map_Pop3_YiZhan"
require "LuaScript/Map/Pop3/Map_Pop3_ZhengZhan"
require "LuaScript/Map/Pop3/Map_Pop3_SaoDang"
require "LuaScript/Map/Pop3/Map_Pop3_SaoDangResult"
require "LuaScript/Map/Pop3/Map_Pop3_ZhengZhan_ZhangJieXuanZe"
require "LuaScript/Map/Pop3/Map_Pop3_ZhengZhan_TipsNewJeneral"
require "LuaScript/Map/Pop3/Map_Pop3_JunTuanZhan"
require "LuaScript/Map/Pop3/Map_Pop3_JunTuanZhan_Help"
require "LuaScript/Map/Pop3/Map_Pop3_ZiDongCanZhan"
require "LuaScript/Map/Pop3/Map_Pop3_ShiJie_TouZi"
require "LuaScript/Map/Pop3/Map_Pop3_JiangLiPerDay"
require "LuaScript/Map/Pop3/Map_Pop3_NongTianYinKuang"
require "LuaScript/Map/Pop3/Map_Pop3_SJZhanhao"
require "LuaScript/Map/Pop3/Map_Pop3_MyTeamPeaple"
require "LuaScript/Map/Pop3/Map_Pop3_XiaoFeiTiShi"
require "LuaScript/Map/Pop3/Map_Pop3_TiShiResult"
require "LuaScript/Map/Pop3/Map_Pop3_ChangeMod"
require "LuaScript/Map/Pop3/Map_Pop3_SourceNotEnough"
require "LuaScript/Map/Pop3/Map_Pop3_SaoDangNpcResult"
require "LuaScript/Map/Pop3/Map_Pop3_BuyJunLing"
require "LuaScript/Map/Pop3/Map_Pop3_SystemTips"
require "LuaScript/Map/Pop3/Map_Pop3_ChangePlayerName"
require "LuaScript/Map/Pop3/Map_Pop3_BingLiBuZu"
require "LuaScript/Map/Pop3/Map_Pop3_TiShiPower"
require "LuaScript/Map/Pop3/Map_Pop3_LingQuLiBao"

require "LuaScript/Map/generalUI/generalBase"
require "LuaScript/Map/generalUI/JiangLing"
require "LuaScript/Map/generalUI/XunLian"
require "LuaScript/Map/generalUI/ZhaoMu"
require "LuaScript/Map/generalUI/ZhaoMu_Pop3"
require "LuaScript/Map/generalUI/PeiYang"
require "LuaScript/Map/generalUI/KeJi"
require "LuaScript/Map/generalUI/BuZhen"

require "LuaScript/Map/kaiFuHuoDong/kaiFuHuoDongBase"
require "LuaScript/Map/kaiFuHuoDong/HD_KaoShangSanJun"
require "LuaScript/Map/kaiFuHuoDong/HD_TuiTuZhengBa"
require "LuaScript/Map/kaiFuHuoDong/HD_VipLiBao"
require "LuaScript/Map/kaiFuHuoDong/HD_JunLingDaLiBao"
require "LuaScript/Map/kaiFuHuoDong/HD_ChaoZhiYueKa"
require "LuaScript/Map/kaiFuHuoDong/HD_ChongZhiJiangLi"
require "LuaScript/Map/kaiFuHuoDong/D_ChongZhiXiaoFei"
require "LuaScript/Map/kaiFuHuoDong/HD_ShouChongSanBei"
require "LuaScript/Map/kaiFuHuoDong/HD_DengLuJiangLi"
require "LuaScript/Map/kaiFuHuoDong/HD_XinFuDouble"
require "LuaScript/Map/kaiFuHuoDong/HD_XiTongGongGao"





require "LuaScript/Map/nvshenUI/NvShenUIBase"
require "LuaScript/Map/nvshenUI/ShengJi"
require "LuaScript/Map/nvshenUI/JinJie"
require "LuaScript/Map/nvshenUI/GuiZe"
require "LuaScript/Map/nvshenUI/TuJian"
require "LuaScript/Map/nvshenUI/NvShen_ChaKan"


require "LuaScript/Map/nvshenUI/NvShen_BaseA"
require "LuaScript/Map/nvshenUI/LieBiao"

require "LuaScript/Map/LiaoTianUI/LiaoTianUI"
require "LuaScript/Map/LiaoTianUI/LiaoTianFactory"
require "LuaScript/Map/LiaoTianUI/LiaoTian_InputName"

require "LuaScript/Map/BeiBaoUI/BeiBaoUIBase"
require "LuaScript/Map/BeiBaoUI/BeiBao"
require "LuaScript/Map/BeiBaoUI/QiangHua"
require "LuaScript/Map/BeiBaoUI/WeiPai"
require "LuaScript/Map/BeiBaoUI/ZhuangBei"
require "LuaScript/Map/BeiBaoUI/Pop3_JiaoHuan"
require "LuaScript/Map/BeiBaoUI/Pop3_JiaoHuanOne"
require "LuaScript/Map/BeiBaoUI/Pop3_GoodsXiangQing"

require "LuaScript/Map/ZhengShouUI/ZhengShouUIBase"
require "LuaScript/Map/ZhengShouUI/GouLiang"
require "LuaScript/Map/ZhengShouUI/ZhengShou"
require "LuaScript/Map/Mail/MailBase"
require "LuaScript/Map/JunTuanUI/JunTuanUIBase"
require "LuaScript/Map/JunTuanUI/JunTuanUI_JiaRu"
require "LuaScript/Map/JunTuanUI/JunTuanUI_ChengYuan"
require "LuaScript/Map/JunTuanUI/JunTuanUI_KeJi"
require "LuaScript/Map/JunTuanUI/JunTuanUI_QingKuang"
require "LuaScript/Map/JunTuanUI/JunTuanUI_ShenQing"
require "LuaScript/Map/JunTuanUI/JunTuanUI_Pop3_NewTeam"
require "LuaScript/Map/JunTuanUI/JunTuanUI_Pop3_JuanXianYinBi"
require "LuaScript/Map/JunTuanUI/JunTuanUI_Pop3_ShenQingJiaRu"
require "LuaScript/Map/JunTuanUI/JunTuanUI_Pop3_XiuGaiJunHui"
require "LuaScript/Map/JunTuanUI/JunTuanUI_Pop3_XiuGaiJunTuanName"

require "LuaScript/Map/GuanKaUI/guanKaBase"
require "LuaScript/Map/GuanKaUI/guanKaPuTong"
require "LuaScript/Map/GuanKaUI/guanKaJingYing"
require "LuaScript/Map/GuanKaUI/guanKaCharpterPass"

require "LuaScript/Map/JiSiUI/JiSiUIBase"
require "LuaScript/Map/JiSiUI/JiSi_JiSi"

require "LuaScript/Map/Help/Help"

require "LuaScript/Map/GuanZhiUI/GuanZhiBase"
require "LuaScript/Map/GuanZhiUI/GuanZhi_GuanZhi"

require "LuaScript/Map/RenWuUI/RenWuBase"
require "LuaScript/Map/RenWuUI/RenWu_ZhuXian"
require "LuaScript/Map/RenWuUI/RenWu_RiChang"
require "LuaScript/Map/RenWuUI/RenWu_guide"

require "LuaScript/Map/XunBao/XunBaoBase"
require "LuaScript/Map/XunBao/XunBao_XunBao"

require "LuaScript/Data/CDTimeManager"
require "LuaScript/Data/CdData"
require "LuaScript/Map/VIP/TeQuanUI"
require "LuaScript/Map/VIP/VipUI"
require "LuaScript/Map/VIP/VipBase"
require "LuaScript/Map/Map_RankPerDay"
require "LuaScript/Map/chengJiuUI/ChengJiuTan"

--require "LuaScript/Map/DengLuJiangLi/DengLuJiangLi"
require "LuaScript/Map/ChongZhi/ChongZhiActivity"
require "LuaScript/Map/ChongZhi/DingEChongZhi"
require "LuaScript/Map/ShouChongDaLi/ShouChongDaLi"


require "AudioEngine"

--中秋活动
require "LuaScript/Map/ZhongQiuHuoDong/ZhongQiuHuoDongBase"
require "LuaScript/Map/ZhongQiuHuoDong/HD_zhongQiuActivity"
require "LuaScript/Map/ZhongQiuHuoDong/HD_zhongQiuJiSi"
--国庆活动
require "LuaScript/Map/GuoQingHuoDong/guoQingHuoDong"
require "LuaScript/Map/GuoQingHuoDong/HD_GuoQing_ChongZhiJiaCheng"
require "LuaScript/Map/GuoQingHuoDong/HD_GuoQing_XiaoFeiFanLi"
require "LuaScript/Map/GuoQingHuoDong/HD_GuoQing_GuoQingHuoDong"


--------------------MSDK相关-------------------------------
require "LuaScript/Map/TecentMsdkLogin/Msdk_login"
require "LuaScript/Map/TecentMsdkLogin/Msdk_char"
require "LuaScript/Map/TecentMsdkLogin/Msdk_loading"

--------------------MSDK相关-------------------------------

-- require "LuaScript/testUi"

-- 联网是否开启的开关
ifserver = true

-- 默认链接地址

--SERVER_ADDR_DEFAULT = "192.168.0.33" --马
-- SERVER_ADDR_DEFAULT = "192.168.0.17" --马
-- SERVER_ADDR_DEFAULT = "192.168.0.75" --韩
--SERVER_ADDR_DEFAULT = "192.168.0.44" --韩
-- SERVER_ADDR_DEFAULT = "192.168.1.101"
-- SERVER_ADDR_DEFAULT = "192.168.154.1"
--SERVER_ADDR_DEFAULT= "127.0.0.1" --内网测试
--SERVER_ADDR_DEFAULT ="120.132.71.8"
--SERVER_ADDR_DEFAULT = "223.223.197.35" --外网测试
--SERVER_ADDR_DEFAULT ="120.132.77.236"  --金山
SERVER_ADDR_DEFAULT= "203.195.176.234" --腾讯

SERVER_PORT_DEFAULT = "6901"
--SERVER_PORT_DEFAULT = "8083"
-- 记录主页菜单是否展开
ifMainOpen = true -- 默认关闭 --保持匹配，优化祛除
-- 记录主页菜单是否展开
ifNpcOpen = true -- 默认关闭 --保持匹配，优化祛除
-- 记录主页事件菜单是否展开
-- ifEventOpen = true
-- char服务器池
gCharServerPool = { }
-- map Ip和port
gMapIp = nil
gMapPort = nil
-- 记录登录的char服务器序列
gLoginCharRem = 1
-- 账号id
AccountID = nil
-- 音乐开关
ifMusic = true
-- 新手引导开关
ifGuideOpen = true
--是不是老的服务器，需要加密编码
ifOldServer = false

if ifOldServer == false then
    --SERVER_ADDR_DEFAULT= "127.0.0.1" --内网测试
    --SERVER_ADDR_DEFAULT= "192.168.1.12" --内网测试
     --SERVER_ADDR_DEFAULT= "192.168.1.16" --内网测试
    SERVER_ADDR_DEFAULT= "203.195.176.234" --腾讯
    --SERVER_PORT_DEFAULT = "8083" --link
    SERVER_PORT_DEFAULT = "8082" --linkserver
end
-- 腾讯MSDK接入
--ifTencentMsdk = false

-- 是否开启国战
ifGuoZhan = true
-- 是否开启军团战
ifJunTuanZhan = false

-- 玩家选择进入游戏的服务器id
_G.loginServerId = 1

-- 人物头像、大图资源路径
RoleHeadPath = "RoleHead/"
RoleBodyPath = "RoleBody/"
-- 女神头像、大图资源路径
SexHeadPath = "SexHead/"
SexBodyPath = "SexBody/"
-- 人物动作资源路径
RoleAckGeneralPath = "jiangling/"
RoleAckSoldierPath = "xiaobing/" 
-- 军团战的战斗人物资源
JunTuanFightRolePath = "JunTuanFight/"
-- 战斗使用的dot特效路径
DotEffectPath = "DotEffect/"
-- 将领技能特效路径
GeneralSkillEffctPath = "GeneralSkillEffec/"
-- 女神技能特效
SexSkillEffectPath = "SexSkillEffect/"
-- ui动画路径
UiEffectPath = "UiEffect/"
-- 物品头像
GoodsHeadPath = "GoodsHead/"


-- 物品品质颜色 1白 2蓝 3绿 4黄 5红 6紫
GoodsColorTab = {
    { "255", "255", "255" },
    { "33", "143", "255" },
    { "0", "255", "90" },
    { "234", "255", "0" },
    { "255", "0", "0" },
    { "167", "19", "252" },
}
-- 军徽
HuiHuiPic = {
    "floor+7_juntuan.png",
    "floor+8_juntuan.png",
    "floor+9_juntuan.png",
    "floor+10_juntuan.png",
    "floor+11_juntuan.png",
    "floor+12_juntuan.png",
    "floor+13_juntuan.png",
    "floor+14_juntuan.png",
    "floor+15_juntuan.png",
    "floor+16_juntuan.png"
}
-- 战斗结果图标
--[[
   	0为平局
	1为险胜
	2为小胜
	3为胜利
	4为大胜
	5为完胜
	6为惜败
	7为小败
	8为失败
	9为大败
	10为完败
	]]
resultImgPath = {
    { "floor+19_zhandou.png", "floor+20_zhandou.png" },
    { "floor+21_zhandou.png", "floor+25_zhandou.png" },
    { "floor+22_zhandou.png", "floor+25_zhandou.png" },
    { "floor+25_zhandou.png", "floor+26_zhandou.png" },
    { "floor+23_zhandou.png", "floor+25_zhandou.png" },
    { "floor+24_zhandou.png", "floor+25_zhandou.png" },
    { "floor+30_zhandou.png", "floor+31_zhandou.png" },
    { "floor+29_zhandou.png", "floor+31_zhandou.png" },
    { "floor+32_zhandou.png", "floor+31_zhandou.png" },
    { "floor+28_zhandou.png", "floor+31_zhandou.png" },
    { "floor+27_zhandou.png", "floor+31_zhandou.png" },
    --[[
		"pic+17_PK.png",
		"pic+9_PK.png",
		"pic+16_PK.png",
		"pic+11_PK.png",
		"pic+8_PK.png",
		"pic+12_PK.png",
		"pic+26_PK.png",
		"pic+25_PK.png",
		"pic+10_PK.png",
		"pic+19_PK.png",
		"pic+18_PK.png",
	--]]
}
------------------------------------------所在ui状态
UI_login = 1 								--
UI_Char = UI_login + 1 						-- 

UI_ZhuCheng = 10000    							-- 主城
UI_City_ZhuCheng = 10100 								-- city主城pop ?
UI_City_JunJiChu = 10200 								-- city军机处pop ? 
UI_City_MinJu = 10300 								-- city民居pop ?
UI_City_GuoKu = 10400 								-- city国库pop ?
UI_City_JunXieSuo = 10500 								-- city军械所pop ?
UI_City_YiZhan = 10600 								-- city驿站pop ?
UI_City_JiaoChang = 10700 								-- city校场pop ?



UI_ZhengZhan 					= 20 								--征战
UI_ZhengZhan_PuTongNpc_Pop  	= 20101 								--征战 -->普通npc弹出 ?
UI_ZhengZhan_JunTuanNpc_Pop 	= 20201 								--征战 -->军团npc弹出 ----en here
UI_ZhengZhan_JunTuanNpc_Help    = 21
UI_JunTuan_Fight 				= 23 								--军团战斗场景
UI_ZhengZhan_JunTuanNpc_Pop_Auto= 24  								--征战 -->军团npc弹出-->自动参战UI
UI_JunTuan_Fight_Result 		= 20204 								--军团Npc战斗结果
UI_Map_Fight 					= 20105 								--普通战斗场景
UI_Fight_OverUi 				= 20106 								--战斗结果通用ui
UI_Fight_Report 				= 28 								--战报ui
UI_Fight_CharpterChoice 		= 29 								--章节选择列表


UI_ShiJie = 30000 								-- 世界
UI_ShiJie_QuYu = 30100 								-- 世界 -->区域
UI_ShiJie_TouZi = 30102 								-- 世界 -->投资 ?

UI_NongTian = 10800 								-- 农田
UI_YinKuang = 10900 								-- 银矿

UI_General_Jiangling = 40600  								-- 将领 -->将领信息
UI_General_XunLian = 40100 								-- 将领 -->训练
UI_General_PeiYang = 40300 								-- 将领 -->培养
UI_General_ZhaoMu = 40400 								-- 将领 -->招募
UI_General_ZhaoMu_XiangQing = 40401 								-- 将领 -->招募-->详情
UI_General_KeJi = 10201 								-- 将领 -->科技
UI_General_BuZhen = 40500 								-- 将领 -->布阵

UI_BeiBao_BeiBao = 60100 								-- 背包 -->仓库
UI_BeiBao_ZhuangBei = 40200 								-- 背包 -->装备
UI_BeiBao_QiangHua = 60200 								-- 背包 -->强化
UI_BeiBao_WeiPai = 60300 								-- 背包 -->委派
UI_BeiBao_Dress = 60101 								-- 装备-仓库-装备信息
UI_BeiBao_ChangeAll = 40202								-- 背包 -->装备 -->装备全换
UI_BeiBao_ChangeOne = 40201 								-- 背包 -->装备 -->装备交换

UI_NvShen_JinJie = 50100 								-- 女神 -->进阶
UI_NvShen_ShengJi = 50200 								-- 女神 -->培养
UI_NvShen_GuiZe = 82 								-- 女神 -->进阶规则
UI_NvShen_TuJian = 50300 								-- 女神 -->图鉴
UI_NvShen_LieBiao = 50000 								-- 女神 -->列表
UI_NvShen_TuJian_GuanShang = 50301 							-- 女神 -->图鉴-->观赏

UI_JunTuan_JiaRu = 70100 								-- 军团 -->加入
UI_JunTuan_ChengYuan = 70200 								-- 军团 -->成员
UI_JunTuan_KeJi = 70300 								-- 军团 -->科技
UI_JunTuan_QingKuang = 70400 								-- 军团 -->情况
UI_JunTuan_ShenQing = 70500 								-- 军团 -->申请

UI_RenWu_ZhuXian = 80100 								-- 任务 -->主线
UI_RenWu_RiChang = 80200 								-- 任务 -->日常

UI_ZhengShou_ZhengShou = 10101 								-- 征收 -->征收
UI_ZhengShou_GouLiang = 10102 								-- 征收 -->购粮


UI_GuanZhi = 10103 								-- 官职
UI_JiSi = 10104 								-- 祭祀
UI_XunBao = 10601 								-- 寻宝
UI_Mail = 160  								-- 邮件
UI_LiaoTian = 90300 								-- 聊天
UI_Vip_ChongZHi = 90200 								-- Vip -->充值
UI_Vip_TeQuan = 90201 								-- Vip -->特权


UI_GuoZhan_GuiZe = 181				-- 国战 -->规则
UI_GuoZhan_Map = 182 				-- 国战 -->地图
UI_GuoZhan_LuoYangCheng = 183 				-- 国战 -->洛阳城
UI_GuoZhan_MainUI = 184       		-- 国战 -->主界面
UI_GuoZhan_PaiHangBang = 185				-- 国战 -->排行榜
UI_GuoZhan_CityPlayers = 186 		        -- 国战 -->城市详情



UI_JunTuanZhan_JiaRu            = 191               --军团战-->团员加入界面
UI_JunTuanZhan_GuanKa			= 192				--军团战-->军团长查看关卡信息
UI_JunTuanZhan_ZhunBei			= 193				--军团战-->攻方战斗准备界面
UI_JunTuanZhan_ShouZhunBei		= 194				--军团战-->守方战斗准备界面
UI_JunTuanZhan_GuWu				= 195				--军团战-->鼓舞
UI_JunTuanZhan_TuiChu			= 196				--军团战-->退出
UI_JunTuanZhan_TiaoZheng		= 197				--军团战-->调整
UI_JunTuanZhan_JieGuo			= 198				--军团战-->结果
UI_JunTuanZhan_ZhanDou			= 199				--军团战-->战斗界面


UI_Fight_SaoDang = 200 				-- 征战  扫荡
UI_Fight_SaoDangResult = 201				-- 征战  扫荡结果
UI_Fight_SaoDangNpcResult = 202 				-- 征战  扫荡npc结果

UI_RL_TongZhi = 210             -- 注册登录  通知
UI_RL_Register = 211			  -- 注册登录  注册
UI_RL_Login = 212             -- 注册登录  登录
UI_RL_GameName = 213			  -- 注册登录  取游戏中的名字
UI_RL_ServerList = 214			  -- 注册登录  服务器列表
UI_RL_ChangeAccount = 215			  -- 注册登录  更换帐号
UI_RL_UpdateData = 216			  -- 注册登录  更新资料
UI_RL_ChooseCamp = 217			  -- 注册登录  选择阵营

UI_SJ_ZhanBao = 218			  -- 世界战报
UI_JunTuan_Report = 219			  -- 军团战战报

UI_Msdk_Login = 220			  -- msdk登录
UI_Msdk_Char = 221          -- 服务器选择

UI_GuanKa_PuTong = 20100
UI_GuanKa_JingYing = 20200

UI_GetNewGeneral = 90400  -- 普通关卡获得新武将

UI_MeiRiDengLuJiangLi = 400 --每日登录奖励
UI_ChengJiu_cheJiuTan = 1128 --成就坛
UI_ChongZhi_ChongZhiActivity = 1129 --充值活动


UI_HuoDong_KaoShangSanJun = 600  --活动犒赏三军
UI_HuoDong_BuyVipLiBao = 601 --活动购买vip礼包
UI_HuoDong_TuiTuZhengBa = 602 --推图争霸
UI_HuoDong_JunLingDaLiBao = 603 --军令大礼包
UI_HuoDong_ChaoZhiYueKa  =604 --超值月卡
UI_HuoDong_ChongZhiJiangLi = 605 --充值奖励
UI_HuoDong_XiaoFeiChongZhi = 606 --累计消费充值
UI_HuoDong_ShouChongSanBei=607 --首冲三倍
UI_HuoDong_XinFuDouble =608    --新服两倍

----------------------
table_insert = table.insert
table_remove = table.remove
table_getn = table.getn
table_sort = table.sort

string_len = string.len
string_sub = string.sub
string_gsub = string.gsub
string_find = string.find

math_modf = math.modf
math_abs = math.abs
math_ceil = math.ceil
math_floor = math.floor
math_random = math.random