module ("BeiBao_QiangHua",package.seeall)

local Layer = nil
local _widget = nil
local curScene = nil

local _scrollviewRole = nil
    local scrolRoleNum = 0  --_scrollviewRole的节点数量
local _scrollviewGoods = nil

local lbl_sucTitle = nil
local lbl_suc = nil
local img_suc = nil
local btn_Bao = nil
local img_GoodsHead = nil  --物品的头像
local img_GoodsSuo = nil --物品头像的锁
local img_PinZhiKuang = nil
local lbl_GoodsName = nil  --物品名称
--local lbl_RoleName = nil   --穿戴的将领名称

local lbl_peiDai = nil      --佩戴
local lbl_qiangHua = nil    --强化
local lbl_zhuShu = nil      --主属
local lbl_shengJi = nil     --升级
local lbl_curZeny = nil  --当前银币
local lbl_upZeny = nil      --升级银币
local lbl_downZeny = nil    --降级银币

local font_Power = nil --物品的战斗力值
local img_powerDi2 = nil --战斗力值底版

--[[
local img_peiDai = nil      --佩戴
local img_qiangHua = nil    --强化
local img_zhuShu = nil      --主属
local img_shengJi = nil     --升级
local img_curZeny = nil  --当前银币
local img_upZeny = nil      --升级银币
local img_downZeny = nil    --降级银币
--]]


local lbl_TimeCD = nil   --解绑倒计时

local btn_Shengji = nil
local btn_JiangJi = nil
local btn_BangDing = nil
local LabelBMFont_bangding = nil
local btn_clear = nil
local lbl_cd = nil
local img_chenggonglv = nil --是否是成功率为100
    local img_choice = nil
local _per = 0
local _orient = 0

local remJeneral = 0 --记录将领(将领在数据里的序列)
local remGoods = 0 --记录装备物品/背包物品序列
local curGoodsData = nil


function setBaoJiEffect()
    local _armature = ArmatureManager.createArmature(UiEffectPath, "UI_BeiBaoQiangBao", 1)
    _armature:getAnimation():playWithIndex(0,-1, -1, -1)
    _armature:setAnchorPoint(ccp(0.5, 0.5))
    _armature:setTag(101)
    
    local function _nextStepCB(bone,evt,originFrameIndex,currentFrameIndex)
        print("remeve action here ......")
        if evt == "end" then
            btn_Bao:removeNodeByTag( 101 )
        end
    end
    _armature:getAnimation():setFrameEventCallFunc( _nextStepCB )
    btn_Bao:addNode(_armature)
end
--[[
function flushZeny()
    lbl_curZeny:setText(  PlayerData.getZeny() .. "银币" )  --当前银币
end
--]]
--_ifBag true背包数据 false已装备数据
local function flushPubModMessage(_ifBag, _dataIdx)   
    if _ifBag then
        curGoodsData = BagData.getGoods( 2, _dataIdx )
        BagData.flushWitchAndIdx( 2,  _dataIdx)
    else
        curGoodsData = BagData.getGoods( 1, _dataIdx )
        BagData.flushWitchAndIdx( 1,  _dataIdx)
    end
    local _goodsDes = Des.getGoodsDesFromId( curGoodsData["GoodId"] )
    _per,_orient = BagData.getlvupequip_persent()
    PT.showWidget(img_suc)
    if _per == 100 then
        PT.hideWidget(img_suc)
        lbl_suc:setText(_per .. "%")
        --img_chenggonglv:loadTexture("button+5_public_2.png")
        img_choice:setVisible(false)
    elseif _per > 100 then
        --img_chenggonglv:loadTexture("button+5_public_1.png")
        img_choice:setVisible(true)
        lbl_suc:setText(100 .. "%")
    else
        --img_chenggonglv:loadTexture("button+5_public_2.png")
        img_choice:setVisible(false)
        lbl_suc:setText(_per .. "%")
    end
    if _orient == 1 then 
        img_suc:loadTexture("floor+21_tong.png")
        lbl_suc:setColor(ccc3(0,248,23))
    else
        img_suc:loadTexture("floor+20_tong.png")
        lbl_suc:setColor(ccc3(255,0,0))
    end
--[[
    -- 成功率为100
    if _per == 100 then
        img_chenggonglv:loadTexture("button+5_public_1.png")
    else
        img_chenggonglv:loadTexture("button+5_public_2.png")
    end
--]]
    --
---[[   
    img_GoodsHead:loadTexture( GoodsHeadPath .. _goodsDes["goodsPic"] .. ".png" )
            --添加锁
            if curGoodsData["IfBang"] == 1 then --绑定状态
                img_GoodsSuo:loadTexture("floor+1_cangku.png")
                img_GoodsSuo:setVisible(true)
            elseif curGoodsData["IfBang"] == 0 and curGoodsData["GoodTimeLim"]~= 0 then --解绑定倒计时
                img_GoodsSuo:loadTexture("floor+2_cangku.png")
                img_GoodsSuo:setVisible(true)
            else
                img_GoodsSuo:setVisible(false)
            end
    print("scrolRoleNum == " .. scrolRoleNum)
    print("remJeneral == " .. remJeneral)
    if remJeneral == scrolRoleNum then --背包里
        lbl_GoodsName:setText( _goodsDes["goodsName"] )  --物品名称
        
        local quility = _goodsDes["goodsQuality"]
        img_PinZhiKuang:loadTexture( "rim+" .. quility .. "_juntuan.png" )
        lbl_GoodsName:setColor(ccc3(GoodsColorTab[quility][1], GoodsColorTab[quility][2], GoodsColorTab[quility][3]))
        
        lbl_GoodsName:setAnchorPoint(ccp(0.5, 0.5) )
        --lbl_RoleName:setVisible(false)
    else
        lbl_GoodsName:setAnchorPoint(ccp(1, 0.5) )
        --lbl_GoodsName:setPosition(ccp(-7, 148) )
        lbl_GoodsName:setText( _goodsDes["goodsName"] )

        local quility = _goodsDes["goodsQuality"]
        img_PinZhiKuang:loadTexture( "rim+" .. quility .. "_juntuan.png" )
        lbl_GoodsName:setColor(ccc3(GoodsColorTab[quility][1], GoodsColorTab[quility][2], GoodsColorTab[quility][3]))

        local jeneralData = GeneralData.getYesGeneralDataFromIndex( remJeneral )
        local jeneralDes = Des.getGeneralDesFromId( jeneralData["GenneralId"] )
        --lbl_RoleName:setVisible(true)
        --lbl_RoleName:setText("(" .. jeneralDes["generalName"] .. ")")   --穿戴的将领名称
    end
    lbl_peiDai:setText( _goodsDes["goodsLevel"] .. "级可装备" )      --佩戴
    
    local JieNum, xingNum = math_modf( curGoodsData["GoodLv"]/10 )
    xingNum = xingNum*10
    local str = nil
    --if JieNum > 0 then
        str = JieNum .. "阶" .. xingNum .. "星"
    --else
      --  str = xingNum .. "星"
   -- end
    lbl_qiangHua:setText(str)    --强化

    local zhushu = curGoodsData["GoodsProType"]
    local zhushuvalue = curGoodsData["GoodsProCount"]
    local str2 = nil
    local str = nil
    if zhushu == 1 then --1攻击 
        str = "攻击+" .. zhushuvalue
        str2 = "攻击+" .. curGoodsData["GoodsProSkip"]
        img_powerDi2:setVisible(true)
        font_Power:setText(curGoodsData["GoodsPower"])
        
    elseif zhushu == 2 then --2防御 
        str = "防御+" .. zhushuvalue
        str2 = "防御+" .. curGoodsData["GoodsProSkip"]
        img_powerDi2:setVisible(true)
        font_Power:setText(curGoodsData["GoodsPower"])
    elseif zhushu == 3 then --3带兵数 
        str = "带兵数+" .. zhushuvalue
        str2 = "带兵数+" .. curGoodsData["GoodsProSkip"]
        img_powerDi2:setVisible(true)
        font_Power:setText(curGoodsData["GoodsPower"])
    elseif zhushu == 4 then --4女神防御
        str = "女神防御+" .. zhushuvalue
        str2 = "女神防御+" .. curGoodsData["GoodsProSkip"]
        img_powerDi2:setVisible(true)
        font_Power:setText(curGoodsData["GoodsPower"])
    else
        str = ""
        str2 = ""
        img_powerDi2:setVisible(false)
    end

    lbl_zhuShu:setText( str )   --主属
    lbl_shengJi:setText(str2)     --升级

    --lbl_curZeny:setText(  PlayerData.getZeny() .. "银币" )  --当前银币
    lbl_upZeny:setText( curGoodsData["GoodsUpZeney"] .. "银币" )      --升级银币
    lbl_downZeny:setText( curGoodsData["GoodsDownZeney"] .. "银币" )    --降级银币


    if curGoodsData["IfBang"] == 1 then --绑定
        --btn_BangDing:loadTextures("button+18_bag_1.png", "button+18_bag_2.png", "")
        LabelBMFont_bangding:setText("解 绑")
        btn_BangDing:setTouchEnabled(true)
        btn_BangDing:setBright(true)
        lbl_TimeCD:setVisible(false)
    else --未绑定
        --btn_BangDing:loadTextures("button+5_bag_1.png", "button+5_bag_2.png", "button+5_bag_3.png")
        LabelBMFont_bangding:setText("绑 定")
        print("绑定 ==  " .. curGoodsData["GoodTimeLim"])
        if curGoodsData["GoodTimeLim"] > 1 then
            print("aaaaaa.....")
            btn_BangDing:setBright(false)
            btn_BangDing:setTouchEnabled(false)
            lbl_TimeCD:setVisible(true)
        else
            print("bbbbbb.....")
            btn_BangDing:setBright(true)
            btn_BangDing:setTouchEnabled(true)
            lbl_TimeCD:setVisible(false)
        end
    end
--]]
end
local function setNoGoodsView( _bool )
    lbl_sucTitle:setVisible(_bool)
    lbl_suc:setVisible(_bool)
    img_GoodsHead:setVisible(_bool)
    img_GoodsSuo:setVisible(_bool)
    if _bool == false then
        img_suc:setVisible(_bool)
        lbl_GoodsName:setVisible(_bool)
        --lbl_RoleName:setVisible(_bool)
    end
--[[
    img_peiDai:setVisible(_bool)
    img_qiangHua:setVisible(_bool)
    img_zhuShu:setVisible(_bool)
    img_shengJi:setVisible(_bool)
    img_curZeny:setVisible(_bool)
    img_upZeny:setVisible(_bool)
    img_downZeny:setVisible(_bool)
--]]
    lbl_peiDai:setVisible(_bool)
    lbl_qiangHua:setVisible(_bool)
    lbl_zhuShu:setVisible(_bool)
    lbl_shengJi:setVisible(_bool)
    --lbl_curZeny:setVisible(_bool)
    lbl_upZeny:setVisible(_bool)
    lbl_downZeny:setVisible(_bool)

    lbl_TimeCD:setVisible(_bool)

    btn_Shengji:setTouchEnabled(_bool)
    btn_JiangJi:setTouchEnabled(_bool)
    btn_BangDing:setTouchEnabled(_bool)
end    

function flushGoodsScrollView( )
    local num = 0
    local dataTab = {}
    local _Jeneraldex = 0
    print("remJeneral == " .. remJeneral)
    print("scrolRoleNum == " .. scrolRoleNum)
    if remJeneral == scrolRoleNum then
        _Jeneraldex = 0
    else
        _Jeneraldex = remJeneral
    end
    if _Jeneraldex == 0 then --背包数据
        num, _ = BagData.getMaxBag()
    else --将领身上穿戴
        local JeneralData = GeneralData.getYesGeneralDataFromIndex( _Jeneraldex )
        local localIdx = BagData.getLocalIdxFromOnlyIdx(1, JeneralData["GoodsWuQiOnlyIdx"])
        if localIdx ~= 0 then
            table_insert( dataTab, localIdx )
        end
        
        localIdx = BagData.getLocalIdxFromOnlyIdx(1, JeneralData["GoodsFangJuOnlyIdx"])
        if localIdx ~= 0 then
            table_insert( dataTab, localIdx )
        end       
        
        localIdx = BagData.getLocalIdxFromOnlyIdx(1, JeneralData["GoodsShiPinOnlyIdx"])
        if localIdx ~= 0 then
            table_insert( dataTab, localIdx )
        end

        localIdx = BagData.getLocalIdxFromOnlyIdx(1, JeneralData["GoodsShuOnlyIdx"])
        if localIdx ~= 0 then
            table_insert( dataTab, localIdx )
        end
        num = #dataTab
    end

    _scrollviewGoods:removeAllChildren()
    _scrollviewGoods:setClippingEnabled(true) --裁切窗口
    if num < 7 then
        _scrollviewGoods:setBounceEnabled(false) --边缘回弹
    else
        _scrollviewGoods:setBounceEnabled(true) --边缘回弹
    end
    _scrollviewGoods:setBackGroundColorType(0)
    --_scrollviewGoods:setAnchorPoint( ccp(0, 0) )
    local cell_disY = 16
    local cell_W, cell_H = 160, 60
        --可视区域
    local view_W = _scrollviewGoods:getSize().width 
    local view_H = _scrollviewGoods:getSize().height

    _scrollviewGoods:setInnerContainerSize( CCSize(view_W, cell_H*num+(num-1)*cell_disY) )
     --滑动区域
    local scroll_W = _scrollviewGoods:getInnerContainerSize().width
    local scroll_H = _scrollviewGoods:getInnerContainerSize().height
    local cell_X, cell_Y = view_W/2, scroll_H-cell_H/2   

    local function CellTouchCB(sender, eventType)
       if eventType == PT.ccs.TouchEventType.ended then
            RW_guide.exitUI()--关闭任务引导
            local _img = tolua.cast(sender, "ImageView")
            local tag = _img:getTag()
            guideFactory.CheckGuideProcess(nil)
            print("remGoods === " .. remGoods)
            if remGoods == tag then
                return
            end
            local imgbefor =  tolua.cast(_scrollviewGoods:getChildByTag(remGoods), "ImageView")
            imgbefor:loadTexture("button5_tong_2.png")
            --local imgfouc = tolua.cast(imgbefor:getChildByTag(100),"ImageView")
            --imgfouc:setVisible(false)
            remGoods = tag
            print("remGoods === " .. remGoods)
            --local img = tolua.cast(_img:getChildByTag(100),"ImageView")
            --img:setVisible(true)
            _img:loadTexture("button5_tong_1.png")
            if _Jeneraldex == 0 then --背包

                flushPubModMessage( true, remGoods )
            else --穿戴的
                flushPubModMessage( false, remGoods )
            end
            
        end
    end
    if num == 0 then
        setNoGoodsView(false)
    else
        setNoGoodsView(true)
    end
    for i=1, num do
        local tag = 0
        local data = nil
        local name = nil
        local xingjiestr = nil
        local quility = 0
if _Jeneraldex == 0 then
        tag = i
        data = BagData.getGoods(2, tag)
else
        tag = dataTab[i]
        data = BagData.getGoods(1, tag)
end
        if remGoods == 0 then
            remGoods = tag
        end

        local des = Des.getGoodsDesFromId( data["GoodId"] )
        name = des["goodsName"]
        quility = des["goodsQuality"]
        local JieNum, xingNum = math_modf( data["GoodLv"]/10 )
        xingNum = xingNum*10

       -- if JieNum > 0 then
            xingjiestr = JieNum .. "阶" .. xingNum .. "星"
       -- else
       --     xingjiestr = xingNum .. "星"
       -- end

        local imageView = ImageView:create()
        if remGoods == tag then
            imageView:loadTexture("button5_tong_1.png")
        else
            imageView:loadTexture("button5_tong_2.png")
        end
        imageView:setTag(tag)
        imageView:setPosition( ccp( cell_X, cell_Y ) )
        imageView:addTouchEventListener( CellTouchCB )
        imageView:setTouchEnabled(true)
            local lbl_name = Label:create()
            lbl_name:setText( name )
            lbl_name:setFontSize(_G.ListFontSize)
            lbl_name:setColor(ccc3(GoodsColorTab[quility][1], GoodsColorTab[quility][2], GoodsColorTab[quility][3]))
            lbl_name:setAnchorPoint( ccp(0.5, 0.5) )
            lbl_name:setPosition( ccp(0, 0) )
        imageView:addChild( lbl_name )
        --添加锁
            if data["IfBang"] == 1 then --绑定状态
                local _img = ImageView:create()
                _img:loadTexture("floor+1_cangku.png")
                _img:setPosition( CCPoint(-70, 18) )
                imageView:addChild( _img )
            elseif data["IfBang"] == 0 and data["GoodTimeLim"]~= 0 then --解绑定倒计时
                local _img = ImageView:create()
                _img:loadTexture("floor+2_cangku.png")
                _img:setPosition( CCPoint(-70, 18) )
                imageView:addChild( _img )
            end
        --[[
            local lbl_XingJie = Label:create()
            lbl_XingJie:setText( xingjiestr )
            lbl_XingJie:setFontSize(18)
            lbl_XingJie:setColor( ccc3(255, 240, 181) )
            lbl_XingJie:setAnchorPoint( ccp(0.5, 0.5) )
            lbl_XingJie:setPosition( ccp(0, -12) )
        imageView:addChild( lbl_XingJie )
        ]]
        --[[
            local img_fouc = ImageView:create()
            img_fouc:loadTexture("rim+10_bag.png")
            img_fouc:setTag(100)
            if remGoods == 0 then  --设置默认
                remGoods = tag
                img_fouc:setVisible(true)
                if _Jeneraldex == 0 then --背包
                    flushPubModMessage( true, tag )
                else --穿戴的
                    flushPubModMessage( false, tag )
                end
            elseif remGoods == tag then
                img_fouc:setVisible(true)
                if _Jeneraldex == 0 then --背包
                    flushPubModMessage( true, tag )
                else --穿戴的
                    flushPubModMessage( false, tag )
                end
            else
                img_fouc:setVisible(false)
            end
        imageView:addChild(img_fouc)
        --]]  
       _scrollviewGoods:addChild( imageView )

       cell_Y = cell_Y - cell_disY - cell_H
    end
    --初始化信息面板
    if num > 0 then
        if _Jeneraldex == 0 then --背包
            flushPubModMessage( true, remGoods )
        else --穿戴的
            flushPubModMessage( false, remGoods )
        end
    end
end

local function getItemNum(_num)
    local count = 0
    for i=1, _num do
        if i == _num then
            count = count + 1
        else
            local id = GeneralData.getDressOnGeneralIdFromIndex( i )
            if id ~= 0 then
                count = count + 1
            end
        end
    end
    return count
end 

local function _initJiangLingScrollView()
    
    _scrollviewRole:setClippingEnabled(true) --裁切窗口 
    _scrollviewRole:setBackGroundColorType(0)

    local cell_disY = 10
    local cell_W, cell_H = 118, 140
        --可视区域
    local view_W = _scrollviewRole:getSize().width 
    local view_H = _scrollviewRole:getSize().height 

    local num = 10
if ifserver then 
    scrolRoleNum = GeneralData.getYesGeneralDataNum()+1
    num = scrolRoleNum
end    
    print("强化人物数量 == " .. num)

    local  Jcount = getItemNum(num)
    _scrollviewRole:setInnerContainerSize( CCSize(view_W, cell_H*Jcount+(Jcount-1)*cell_disY) )

    --滑动区域
    local scroll_W = _scrollviewRole:getInnerContainerSize().width
    local scroll_H = _scrollviewRole:getInnerContainerSize().height
    print(" _initJiangLingScrollView scroll_H is"..scroll_H)

    local cell_X, cell_Y = view_W/2, scroll_H-cell_H/2

    local function CellTouchCB(sender, eventType)
       if eventType == PT.ccs.TouchEventType.ended then
            RW_guide.exitUI()--退出任务引导
            local _img = tolua.cast(sender, "ImageView")
            local tag = _img:getTag()
            
            guideFactory.CheckGuideProcess( LM.STATE_3 )

            if remJeneral == tag then
                return
            end

            local imgbefor =  tolua.cast(_scrollviewRole:getChildByTag(remJeneral), "ImageView")
            imgbefor:removeNodeByTag(99)
            remJeneral = tag
            print("tag ==== " .. tag)
            local ArmatureFouce = ArmatureManager.createArmature( UiEffectPath, "UI_Fouce", 1 )
            ArmatureFouce:setTag(99)
            ArmatureFouce:getAnimation():playWithIndex(0,-1, -1, -1)
            ArmatureFouce:setPosition( ccp(0, 5) )
            _img:addNode(ArmatureFouce)
            if remJeneral == num then
                remGoods = 0
                flushGoodsScrollView()
            else
                remGoods = 0
                flushGoodsScrollView( )
            end
            
        end
    end
local dressCount = 0
    for i=1, num do
        local GoodsPic = nil
        local GoodsName = nil
        local ifDress = false
if ifserver then
        if i == num then
            ifDress = true
            dressCount = dressCount + 1
        else
            local id = GeneralData.getDressOnGeneralIdFromIndex( i )
            if id ~= 0 then
                ifDress = true
                dressCount = dressCount + 1
                local jeneralDes = Des.getGeneralDesFromId( id )

                GoodsPic = RoleHeadPath .. jeneralDes["generalHeadIcon"] .. ".png"
                GoodsName = jeneralDes["generalName"]
            end
        end
else
        GoodsPic = "1.png"
        GoodsName = "玩家名字"
end
        if ifDress then
            local img_bg = ImageView:create()
            img_bg:loadTexture( "floor+17_tong.png")
            img_bg:setSize( CCSizeMake(cell_W, cell_H) )
            img_bg:setPosition( CCPoint(cell_X, cell_Y ) )
            img_bg:setTag(i)
            
            img_bg:setTouchEnabled(true)
            img_bg:addTouchEventListener( CellTouchCB )
            
                local img_head = ImageView:create()
                if i == num then
                    img_head:loadTexture("floor+12_bag.png")
                else
                    img_head:loadTexture( GoodsPic )
                end
                img_head:setPosition(ccp(6, 17))
                img_head:setScaleX(-1)
                --img_head:setScaleX(-0.75)
                --img_head:setScaleY(0.75)
            img_bg:addChild(img_head)
                local _lbl = Label:create()
                if i == num then
                    _lbl:setText("未 穿 戴")
                else
                    _lbl:setText( GoodsName )
                end
                _lbl:setFontSize( 20 )
                _lbl:setPosition(ccp(6, -50))
                --_lbl:setColor( ccc3( GoodsColorTab[quality][1], GoodsColorTab[quality][2], GoodsColorTab[quality][3]) )
            img_bg:addChild(_lbl)
            --[[
            local imageView = ImageView:create()
            if i == num then
                imageView:loadTexture("floor+12_bag.png")
            else
                imageView:loadTexture( GoodsPic )
            end
            imageView:setTag(i)
            imageView:setPosition( ccp( cell_X, cell_Y ) )
            imageView:addTouchEventListener( CellTouchCB )
            imageView:setTouchEnabled(true)
                local img_kuang = ImageView:create()
                img_kuang:loadTexture("rim+2_public.png")
                img_kuang:setPosition( ccp(0, -10) )
            imageView:addChild( img_kuang )
                local _lbl = Label:create()
                if i == num then
                    _lbl:setText("未 穿 戴")
                else
                    _lbl:setText( GoodsName )
                end
                _lbl:setPosition( ccp(0, -47) )
            imageView:addChild(_lbl)
            --]]
                if remJeneral == 0 then --默认焦点
                    remJeneral = i
                    local ArmatureFouce = ArmatureManager.createArmature( UiEffectPath, "UI_Fouce", 1 )
                    ArmatureFouce:setTag(99)
                    ArmatureFouce:getAnimation():playWithIndex(0,-1, -1, -1)
                    ArmatureFouce:setPosition( ccp(0, 5) )
                    img_bg:addNode( ArmatureFouce )
                    if remJeneral == num then
                        remGoods = 0
                        flushGoodsScrollView()
                    else
                        remGoods = 0
                        flushGoodsScrollView( )
                    end
                end

           _scrollviewRole:addChild( img_bg )

           cell_Y = cell_Y - cell_disY - cell_H
        end
    end
    
    if dressCount < 4 then
        _scrollviewRole:setBounceEnabled(false) 
    else
        _scrollviewRole:setBounceEnabled(true) --边缘回弹
    end
    -- _scrollviewRole:setInnerContainerSize( CCSize(view_W, cell_H*dressCount+(dressCount-1)*cell_disY) )
end

function setGuideFource(_JeneralId, _goodsId)
    
    local tag = GeneralData.getGenralIdxFromId(_JeneralId)
    if remJeneral == tag then
        return
    end

    local imgbefor =  tolua.cast(_scrollviewRole:getChildByTag(remJeneral), "ImageView")
    imgbefor:removeNodeByTag(99)
    remJeneral = tag
    print("tag ==== " .. tag)
    local ArmatureFouce = ArmatureManager.createArmature( UiEffectPath, "UI_Fouce", 1 )
    ArmatureFouce:setTag(99)
    ArmatureFouce:getAnimation():playWithIndex(0,-1, -1, -1)
    ArmatureFouce:setPosition( ccp(0, 5) )
    local _img = tolua.cast(_scrollviewRole:getChildByTag(tag), "ImageView")
    _img:addNode(ArmatureFouce)

    remGoods = BagData.getgoodsIdxFromId(1,_goodsId)

    flushGoodsScrollView( )

end
--任务引导，通过物品id设置焦点用，优先引导第一个已穿戴该物品将领
function setTaskGuideFource(_goodsId)
    local tag = GeneralData.getGeneralIdxFromGoodsId(_goodsId)

    
    print("tag ==== " .. tag)
    if tag ~= 0 then --有人穿戴，直接改变焦点
        local imgbefor =  tolua.cast(_scrollviewRole:getChildByTag(remJeneral), "ImageView")
        imgbefor:removeNodeByTag(99)
        remJeneral = tag
        local ArmatureFouce = ArmatureManager.createArmature( UiEffectPath, "UI_Fouce", 1 )
        ArmatureFouce:setTag(99)
        ArmatureFouce:getAnimation():playWithIndex(0,-1, -1, -1)
        ArmatureFouce:setPosition( ccp(0, 5) )
        local _img = tolua.cast(_scrollviewRole:getChildByTag(remJeneral), "ImageView")
        _img:addNode(ArmatureFouce)

        remGoods = BagData.getgoodsIdxFromId(1,_goodsId) --在将领身上
    else --没有穿戴 焦点到背包
        local imgbefor =  tolua.cast(_scrollviewRole:getChildByTag(remJeneral), "ImageView")
        imgbefor:removeNodeByTag(99)
        remJeneral = GeneralData.getYesGeneralDataNum()+1
        local ArmatureFouce = ArmatureManager.createArmature( UiEffectPath, "UI_Fouce", 1 )
        ArmatureFouce:setTag(99)
        ArmatureFouce:getAnimation():playWithIndex(0,-1, -1, -1)
        ArmatureFouce:setPosition( ccp(0, 5) )
        local _img = tolua.cast(_scrollviewRole:getChildByTag(remJeneral), "ImageView")
        _img:addNode(ArmatureFouce)


        remGoods = BagData.getgoodsIdxFromId(2,_goodsId) --在背包里
    end
    

    flushGoodsScrollView( )
end

local function _initPubMod()
    remJeneral = 0 
    remGoods = 0 

    _scrollviewRole = tolua.cast( Layer:getWidgetByName("ScrollView_Role"), "ScrollView" )
    _scrollviewGoods = tolua.cast( Layer:getWidgetByName("ScrollView_Goods"), "ScrollView" )

    img_chenggonglv = tolua.cast( Layer:getWidgetByName("ImageView_chenggonglv"), "ImageView" )
    img_choice = tolua.cast( Layer:getWidgetByName("ImageView_choice"), "ImageView" )

    lbl_sucTitle = tolua.cast( Layer:getWidgetByName("Label_chenggonglvtitle"), "Label" )
    lbl_suc = tolua.cast( Layer:getWidgetByName("Label_suc"), "Label" )
    img_suc = tolua.cast( Layer:getWidgetByName("ImageView_suc"), "ImageView" )
   
    img_GoodsHead= tolua.cast( Layer:getWidgetByName("ImageView_GoodsPic"), "ImageView" )
    img_GoodsSuo = tolua.cast( Layer:getWidgetByName("ImageView_viewSuo"), "ImageView" )
    img_PinZhiKuang = tolua.cast( Layer:getWidgetByName("ImageView_PinZhiKuang"), "ImageView" )
    img_PinZhiKuang:setVisible(true)

    lbl_GoodsName = tolua.cast( Layer:getWidgetByName("Label_GoodsName"), "Label" )
    --lbl_RoleName = tolua.cast( Layer:getWidgetByName("Label_GoodsRole"), "Label" )
    lbl_peiDai = tolua.cast( Layer:getWidgetByName("Label_PeiDai"), "Label" )
    lbl_qiangHua = tolua.cast( Layer:getWidgetByName("Label_QiangHuaShuXing"), "Label" )
    lbl_zhuShu = tolua.cast( Layer:getWidgetByName("Label_ZhuShu"), "Label" )
    lbl_shengJi = tolua.cast( Layer:getWidgetByName("Label_ShengJi"), "Label" )

    --lbl_curZeny = tolua.cast( Layer:getWidgetByName("Label_DangQianYinBi"), "Label" )
    lbl_upZeny = tolua.cast( Layer:getWidgetByName("Label_ShengJiNeed"), "Label" )
    lbl_downZeny = tolua.cast( Layer:getWidgetByName("Label_JiangJi"), "Label" )

    font_Power = tolua.cast( Layer:getWidgetByName("LabelBMFont_zhanDouLi"), "LabelBMFont" )
    img_powerDi2 =  tolua.cast( Layer:getWidgetByName("ImageView_PowerDi2"), "ImageView" )
--[[
img_peiDai = tolua.cast( Layer:getWidgetByName("ImageView_PeiDai"), "ImageView" )
img_qiangHua = tolua.cast( Layer:getWidgetByName("ImageView_QiangHua"), "ImageView" )
img_zhuShu = tolua.cast( Layer:getWidgetByName("ImageView_ZhuShu"), "ImageView" )
img_shengJi = tolua.cast( Layer:getWidgetByName("ImageView_ShengJi"), "ImageView" )
img_curZeny = tolua.cast( Layer:getWidgetByName("ImageView_DangQianYinBi"), "ImageView" )
img_upZeny = tolua.cast( Layer:getWidgetByName("ImageView_ShengJiFeiYong"), "ImageView" )
img_downZeny = tolua.cast( Layer:getWidgetByName("ImageView_JiangJiHuoDe"), "ImageView" )

    lbl_peiDai = tolua.cast( Layer:getWidgetByName("Label_PeiDai"), "Label" )
    lbl_qiangHua = tolua.cast( Layer:getWidgetByName("Label_QiangHua"), "Label" )
    lbl_zhuShu = tolua.cast( Layer:getWidgetByName("Label_ZhuShu"), "Label" )
    lbl_shengJi = tolua.cast( Layer:getWidgetByName("Label_ShengJi"), "Label" )
    lbl_curZeny = tolua.cast( Layer:getWidgetByName("Label_DangQianYinBi"), "Label" )
    lbl_upZeny = tolua.cast( Layer:getWidgetByName("Label_ShengJiFeiYong"), "Label" )
    lbl_downZeny = tolua.cast( Layer:getWidgetByName("Label_JiangJiHuoDe"), "Label" )
--]]

    lbl_TimeCD = tolua.cast( Layer:getWidgetByName("Label_BangDingtimeCD"), "Label" )
    lbl_TimeCD:setVisible(false)
    BagData.setCDlbl( lbl_TimeCD, nil )
    
    btn_Shengji = tolua.cast( Layer:getWidgetByName("Button_ShengJi"), "Button" )
    btn_JiangJi = tolua.cast( Layer:getWidgetByName("Button_JiangJi"), "Button" )
    btn_BangDing = tolua.cast( Layer:getWidgetByName("Button_BangDing"), "Button" )
    LabelBMFont_bangding = tolua.cast( Layer:getWidgetByName("Label_3819"), "Label" )
    btn_clear = tolua.cast( Layer:getWidgetByName("Button_clear"), "Button" )
    lbl_cd = tolua.cast( Layer:getWidgetByName("Label_timeCD_str"), "Label" )
    BagData.setQiangHuaCDLable(lbl_cd,btn_clear)

    local function ImageClick(sender, eventType)
        local _image = tolua.cast(sender, "ImageView")
      if eventType == PT.ccs.TouchEventType.ended then
            --print("image chenggonglv is click")
            RW_guide.exitUI()--关闭任务引导
            if _per > 100 then
                --Pop3_XFTiShi.enterUI(246,"取消提升下次升级成功率",1)   
                protoSend0x0246(1)
            else
                Pop3_XFTiShi.enterUI(246,"花费10金币将本次升级成功率提升至100%（升级时扣除）",1)   
            end                                                     
            --protoSend0x0246(1)
        end
    end 

    img_chenggonglv:setTouchEnabled(true)
    img_chenggonglv:addTouchEventListener(ImageClick)

    local function BtnCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            RW_guide.exitUI()--关闭任务引导
            local _btn = tolua.cast(sender, "Button")
            if _btn == btn_Shengji then
                protoSend0x0316( curGoodsData["GoodIndex"], 1 )
                print("btn_Shengji ")
            elseif _btn == btn_JiangJi then
                if curGoodsData["GoodLv"] > 0 then
                    protoSend0x0316( curGoodsData["GoodIndex"], 2 )
                else
                    Pop3_TS_Result.enterUI(   "已经是0级了" )
                end
            elseif _btn == btn_BangDing then
                if curGoodsData["IfBang"] == 1 then --绑定
                    protoSend0x0314( curGoodsData["GoodIndex"], 2 )
                else --未绑定
                    protoSend0x0314( curGoodsData["GoodIndex"], 1 )
                end
            elseif _btn == btn_clear then
                local cd = CdData.CreatEnumTable()
                local if_save = CdData.getcheckstrongcd()
                if if_save == 0 then
                    protoSend0x0420(cd.Strong)
                else
                    protoSend0x0422(cd.Strong)
                end

            end
        end

    end
    btn_Shengji:addTouchEventListener(BtnCB)
    btn_JiangJi:addTouchEventListener(BtnCB)
    btn_BangDing:addTouchEventListener(BtnCB)
    btn_clear:addTouchEventListener(BtnCB)


    btn_Bao = tolua.cast( Layer:getWidgetByName("Button_BaoJi"), "Button" )
    btn_Bao:setTouchEnabled(true)
    if GeneralData.ifBaoJi() then
        btn_Bao:setBright(true)
    else
        btn_Bao:setBright(false)
    end

    local Panel_tipsViewBG = tolua.cast( Layer:getWidgetByName("Panel_TipsView"), "Layout" )
    Panel_tipsViewBG:setVisible(false)
    Panel_tipsViewBG:setTouchEnabled(false)
    Panel_tipsViewBG:setZOrder(10)
    local img_tipsBG = tolua.cast( Layer:getWidgetByName("ImageView_BaoTips"), "ImageView" )


        local _richText = RichText:create()
        _richText:ignoreContentAdaptWithSize(false)
        _richText:setSize(CCSizeMake(150, 70))
        --_richText:setFontSize(24)
        _richText:setAnchorPoint( ccp(0, 0.5) )
        _richText:setPosition(ccp(-169,-75))
        _richText:setTag(100)

        local _re1 = RichElementText:create(1, ccc3(GoodsColorTab[1][1], GoodsColorTab[1][2], GoodsColorTab[1][3]), 255, "强化成功后，有一定几率使装备当前强化等级额外", "Helvetica", 18);
        _richText:pushBackElement( _re1 )
        local _re2 = RichElementText:create(1, ccc3(GoodsColorTab[5][1], GoodsColorTab[5][2], GoodsColorTab[5][3]), 255, "+1", "Helvetica", 18);
        _richText:pushBackElement( _re2 )
    img_tipsBG:addChild(_richText)

        local _richText2 = RichText:create()
        _richText2:ignoreContentAdaptWithSize(false)
        _richText2:setSize(CCSizeMake(150, 25))
        --_richText:setFontSize(24)
        _richText2:setAnchorPoint( ccp(0, 0.5) )
        _richText2:setPosition(ccp(-169, -120))
        _richText2:setTag(100)

        local _re3 = RichElementText:create(1, ccc3(GoodsColorTab[1][1], GoodsColorTab[1][2], GoodsColorTab[1][3]), 255, "(VIP ", "Helvetica", 20);
        _richText2:pushBackElement( _re3 )
        local _re4 = RichElementText:create(1, ccc3(GoodsColorTab[5][1], GoodsColorTab[5][2], GoodsColorTab[5][3]), 255, GeneralData.getBaoJiLim(), "Helvetica", 20);
        _richText2:pushBackElement( _re4 )
        local _re5 = RichElementText:create(1, ccc3(GoodsColorTab[1][1], GoodsColorTab[1][2], GoodsColorTab[1][3]), 255, " 等级开启)", "Helvetica", 20);
        _richText2:pushBackElement( _re5 )
    img_tipsBG:addChild(_richText2)

    local state = true
    local function BoxCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
           if state then
                RW_guide.exitUI()--关闭任务引导
                state = false
                img_tipsBG:setScale(0.2)
                Panel_tipsViewBG:setVisible(true)
                local function CallFucnCallback2(sender)
                    Panel_tipsViewBG:setTouchEnabled(true)
                end
                local array = CCArray:create()
                array:addObject(CCScaleBy:create(0.2, 6, 6))
                array:addObject(CCScaleBy:create(0.05, 0.83, 0.83))
                array:addObject( CCCallFuncN:create(CallFucnCallback2) )
                img_tipsBG:runAction(CCSequence:create(array))
            end
        end
    end
    btn_Bao:addTouchEventListener( BoxCB )

    local function hideBg(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            RW_guide.exitUI()--关闭任务引导
            Panel_tipsViewBG:setVisible(false)
            Panel_tipsViewBG:setTouchEnabled(false)
            state = true
        end
    end
    Panel_tipsViewBG:addTouchEventListener(hideBg)

    _initJiangLingScrollView()
end

function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        --Layer:clear()
        _widget = nil
        Layer = nil
        
        LM.STATE_3 = 0
    end
    BagData.clearCDlbl()
    BagData.clearQiangHuaCDLable()
end

function enterUI()
    LM.STATE_3 = UI_BeiBao_QiangHua

    Layer = LM.getLayer3()
    _widget = GUIReader:shareReader():widgetFromJsonFile("BeiBao_QiangHua.json")

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(false)

    _initPubMod()

    guideFactory.CheckGuideProcess( LM.STATE_3 )
end

