module ("BeiBao_ZhuangBei",package.seeall)
local Layer = nil
local _widget = nil

local lbl_name  = nil
local img_head  = nil
local lbl_lv    = nil
local lbl_tong  = nil
local lbl_yong  = nil
local lbl_mou   = nil

--装备图标
local img_wuQi  = nil   --武器头像
local img_fangJu= nil   --防具头像
local img_shu   = nil   --书头像
local img_bingFu= nil   --兵符头像
--装备提示
local lbl_wuQi = nil
local lbl_fangJu = nil
local lbl_shu = nil
local lbl_bingFu = nil 

local img_wuQi_pinZhi   = nil
local img_fangJu_pinZhi = nil
local img_shu_pinZhi    = nil
local img_bingFu_pinZhi = nil

local lbl_gong  = nil       --装备攻击
local lbl_fang  = nil       --装备防御
local lbl_godFang = nil     --装备女神防御
local lbl_bingNum = nil     --装备兵数

local _scrollview = nil --任务列表
local remCurGeneral = nil --记录点击将领的焦点
local remJeneralId = nil --记录当前将领id

function setGuideFource(_jeneralId)

end

local function _flushGeneralMessage( _index )
    local data = GeneralData.getYesGeneralDataFromIndex(_index)
    local desGeneral = Des.getGeneralDesFromId( data["GenneralId"] )
    --remJeneralId = data["GenneralId"]
     remJeneralId = data["Index"] --改成唯一id

    img_head:loadTexture( RoleHeadPath .. desGeneral["generalHeadIcon"] .. ".png" )
    lbl_name:setText( desGeneral["generalName"] )
    lbl_lv:setText( data["Lv"] )
    lbl_yong:setText( data["Attr_y"]+data["Plus_y"] )
    lbl_tong:setText( data["Attr_t"]+data["Plus_t"] )
    lbl_mou:setText( data["Attr_m"]+data["Plus_m"] )
    -----------------------------------------------------
   
    local gong = 0
    local fang = 0
    local godFang = 0 
    local bing = 0

    local function _getJeneralZhuangBei( _goodsonlyIdx , _img, img_pinzhi, _lblTip)
     
        --if _goodsonlyIdx == 0 then --无装备
        if _goodsonlyIdx == "" then --无装备
            _img:loadTexture("")
            _img:setVisible(false)

            img_pinzhi:loadTexture("")
            img_pinzhi:setVisible(false)

            _lblTip:setVisible(true)
        else
            local goodsId = BagData.getGoodsIdFromIndex(1, _goodsonlyIdx)
            print("==========goodsid=" .. goodsId)
            local goodsDes= Des.getGoodsDesFromId( goodsId )
            local quality = goodsDes["goodsQuality"]
            local  imgPic = GoodsHeadPath .. goodsDes["goodsPic"] .. ".png" 

            print("装备武器的图片名称 imgPic === " .. imgPic) 
            _img:loadTexture(imgPic)
            _img:setVisible(true)

            img_pinzhi:loadTexture("rim+"..quality.."_juntuan.png")
            img_pinzhi:setVisible(true)

            _lblTip:setVisible(false)
        end
        

        --[[ 
        if pinzhiBG[_idx] ~= nil then
            local quality = goodsDes["goodsQuality"]
            local  imgPic = "rim+"..quality.."_juntuan.png"
            pinzhiBG[_idx]:loadTexture(imgPic)
        end
        --]]
        local Type, value = BagData.getTypeAndValue(1, _goodsonlyIdx)
        --1攻击 2防御 3带兵数 4女神防御
        if Type == 1 then
            gong = gong + value
        elseif Type == 2 then
            fang = fang + value
        elseif Type == 3 then
            bing = bing + value
        elseif Type == 4 then
            godFang = godFang + value
        end      
    end
    print("==============shushushu=" .. data["GoodsShuOnlyIdx"])

    _getJeneralZhuangBei( data["GoodsWuQiOnlyIdx"], img_wuQi, img_wuQi_pinZhi, lbl_wuQi )
    _getJeneralZhuangBei( data["GoodsFangJuOnlyIdx"], img_fangJu, img_fangJu_pinZhi, lbl_fangJu )
    _getJeneralZhuangBei( data["GoodsShuOnlyIdx"], img_shu, img_shu_pinZhi, lbl_shu )
    _getJeneralZhuangBei( data["GoodsShiPinOnlyIdx"], img_bingFu, img_bingFu_pinZhi, lbl_bingFu )

    lbl_gong:setText( gong )
    lbl_fang:setText( fang )
    lbl_godFang:setText( godFang )
    lbl_bingNum:setText( bing )

end
function flushMessage()
    _flushGeneralMessage( remCurGeneral )
end

local function _initJeneralScrollView()
    _scrollview:removeAllChildren()
    _scrollview:setClippingEnabled(true) --裁切窗口
    
    _scrollview:setBackGroundColorType(0)
    local cell_disY = 5
        --可视区域
    local view_W = _scrollview:getSize().width 
    local view_H = _scrollview:getSize().height 

    local num = 0
if ifserver then
    num = GeneralData.getYesGeneralDataNum()
else
    num = 10
end
    if num < 7 then
        _scrollview:setBounceEnabled(false)
    else
        _scrollview:setBounceEnabled(true) --边缘回弹
    end
    local cell_W, cell_H = 160, 60
    _scrollview:setInnerContainerSize( CCSize(view_W, cell_H*num+(num-1)*cell_disY) )

    --滑动区域
    local scroll_W = _scrollview:getInnerContainerSize().width
    local scroll_H = _scrollview:getInnerContainerSize().height

    
    local cell_X, cell_Y = view_W/2, scroll_H-cell_H/2

    local function CellTouchCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            --guideFactory.CheckGuideProcess(nil)

            local _Img = tolua.cast(sender, "ImageView")
            local tag = _Img:getTag()
            guideFactory.CheckGuideProcess( LM.STATE_3 )
            if remCurGeneral == tag then
                return
            end
            local imgbefor =  tolua.cast(_scrollview:getChildByTag(remCurGeneral), "ImageView")
            imgbefor:loadTexture( "button2_tong_2.png" )
            remCurGeneral = tag
            _Img:loadTexture( "button2_tong_1.png" )

            _flushGeneralMessage( remCurGeneral )

            
        end
    end

    for i=1, num do
        local data = nil
        local desData = nil
        local ifGod = false
        local ifTrain, trainPos = false, 0
if ifserver then
        data = GeneralData.getYesGeneralDataFromIndex(i)
        local id = data["GenneralId"]
        desData = Des.getGeneralDesFromId( id )
            
        ifTrain, trainPos = TrainData.IfGeneralTrain( data["Index"] )
        if data["GoddessId"] ~= 0 then
            ifGod = true
        else
            ifGod = false
        end
end   
        local imageView = ImageView:create()
        if i == remCurGeneral then
            imageView:loadTexture("button2_tong_1.png")--当前默认
        else
            imageView:loadTexture("button2_tong_2.png")
        end
        imageView:setTag(i)
        imageView:setPosition( CCPoint( cell_X, cell_Y ) )
        imageView:addTouchEventListener( CellTouchCB )
        imageView:setTouchEnabled(true)
            if ifGod then
                local _imgGod = ImageView:create()
                _imgGod:loadTexture( "floor+8_bag.png" )
                _imgGod:setPosition(ccp(50, 0))
                imageView:addChild( _imgGod )
            end  
            --[[
            if ifTrain then --正在训练
                local _imgOnTrain = ImageView:create()
                _imgOnTrain:loadTexture( "word+1_wujiang.png" )
                _imgOnTrain:setPosition(ccp(-50, 0))
                imageView:addChild( _imgOnTrain )
            end
            --]]
            
            local _lbl = Label:create()
if ifserver then
            _lbl:setText( desData["generalName"] )
else
            _lbl:setText(i)
end
            _lbl:setFontSize( _G.ListFontSize )
            _lbl:setColor( ccc3(239, 224, 199) )
            imageView:addChild(_lbl)
       _scrollview:addChild( imageView )

       cell_Y = cell_Y - cell_disY - cell_H
    end
    
    --初始化默认
    _flushGeneralMessage(remCurGeneral)
end

local function _initPubMod()
    local btn_goToBag   = tolua.cast( Layer:getWidgetByName("Button_CangKu"), "Button" )
    local btn_changeAll = tolua.cast( Layer:getWidgetByName("Button_JiaoHuan"), "Button" )
    local btn_downAll   = tolua.cast( Layer:getWidgetByName("Button_XieXia"), "Button" )
    
    local function btn_btnCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            local _btn = tolua.cast(sender, "Button")
            if _btn == btn_goToBag then --前往仓库
                GeneralBase.exitUI()
                BeiBaoBase.enterUI(1)
            elseif _btn == btn_changeAll then --装备全换
                Pop3_JiaoHuan.enterUI( remCurGeneral )
            elseif _btn == btn_downAll then --装备卸下
                protoSend0x0318( remJeneralId, 0, 3  )
            end
        end
    end

    btn_goToBag:addTouchEventListener( btn_btnCB )
    btn_changeAll:addTouchEventListener( btn_btnCB )
    btn_downAll:addTouchEventListener( btn_btnCB )
-----------------------------------------------------------------
    local img_btn_wuQi      = tolua.cast( Layer:getWidgetByName("ImageView_WuQiKuang"), "ImageView" )
    local img_btn_fangJu    = tolua.cast( Layer:getWidgetByName("ImageView_FangJuKuang"), "ImageView" )
    local img_btn_shu       = tolua.cast( Layer:getWidgetByName("ImageView_ShuKuang"), "ImageView" )
    local img_btn_bingFu    = tolua.cast( Layer:getWidgetByName("ImageView_BingFuKuang"), "ImageView" )

    local function btn_imgCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            local _img = tolua.cast(sender, "ImageView")
            if _img == img_btn_wuQi then --武器
                Pop3_JiaoHuanOne.enterUI(remCurGeneral, 1)
            elseif _img == img_btn_fangJu then --防具
                Pop3_JiaoHuanOne.enterUI(remCurGeneral, 2)
            elseif _img == img_btn_shu then --书
                Pop3_JiaoHuanOne.enterUI(remCurGeneral, 4)
            elseif _img == img_btn_bingFu then --兵符
                Pop3_JiaoHuanOne.enterUI(remCurGeneral, 3)
            end
        end
    end

    img_btn_wuQi:addTouchEventListener( btn_imgCB )
    img_btn_fangJu:addTouchEventListener( btn_imgCB )
    img_btn_shu:addTouchEventListener( btn_imgCB )
    img_btn_bingFu:addTouchEventListener( btn_imgCB )
    img_btn_wuQi:setTouchEnabled(true)
    img_btn_fangJu:setTouchEnabled(true)
    img_btn_shu:setTouchEnabled(true)
    img_btn_bingFu:setTouchEnabled(true)
-----------------------------------------------------

    lbl_name  = tolua.cast( Layer:getWidgetByName("Label_MingZi"), "Label" )
    img_head  = tolua.cast( Layer:getWidgetByName("ImageView_Pic"), "ImageView" )
    lbl_lv    = tolua.cast( Layer:getWidgetByName("Label_DengJiKey"), "Label" )
    lbl_tong  = tolua.cast( Layer:getWidgetByName("Label_TongKey"), "Label" )
    lbl_yong  = tolua.cast( Layer:getWidgetByName("Label_YongKey"), "Label" )
    lbl_mou   = tolua.cast( Layer:getWidgetByName("Label_MouKey"), "Label" )

    img_wuQi  = tolua.cast( Layer:getWidgetByName("ImageView_WuQiPic"), "ImageView" )   --武器头像
    img_fangJu= tolua.cast( Layer:getWidgetByName("ImageView_FangJuPic"), "ImageView" )   --防具头像
    img_shu   = tolua.cast( Layer:getWidgetByName("ImageView_ShuPic"), "ImageView" )   --书头像
    img_bingFu= tolua.cast( Layer:getWidgetByName("ImageView_BingFuPic"), "ImageView" )   --兵符头像

    img_wuQi_pinZhi   = tolua.cast( Layer:getWidgetByName("ImageView_WuQiPinZhiKuang"), "ImageView" )
    img_fangJu_pinZhi = tolua.cast( Layer:getWidgetByName("ImageView_FangJuPinZhiKuang"), "ImageView" )
    img_shu_pinZhi    = tolua.cast( Layer:getWidgetByName("ImageView_ShuPinZhiKuang"), "ImageView" )
    img_bingFu_pinZhi = tolua.cast( Layer:getWidgetByName("ImageView_BingFuPinZhiKuang"), "ImageView" )

    lbl_wuQi    = tolua.cast( Layer:getWidgetByName("Label_WuQiDes"), "Label" )
    lbl_fangJu  = tolua.cast( Layer:getWidgetByName("Label_FangJuDes"), "Label" )
    lbl_shu     = tolua.cast( Layer:getWidgetByName("Label_ShuDes"), "Label" )
    lbl_bingFu  = tolua.cast( Layer:getWidgetByName("Label_BingFuDes"), "Label" ) 

    lbl_gong  = tolua.cast( Layer:getWidgetByName("Label_GongJiKey"), "Label" )       --装备攻击
    lbl_fang  = tolua.cast( Layer:getWidgetByName("Label_FangYuKey"), "Label" )       --装备防御
    lbl_godFang = tolua.cast( Layer:getWidgetByName("Label_NvShenGongJiKey"), "Label" )     --装备女神防御
    lbl_bingNum = tolua.cast( Layer:getWidgetByName("Label_BingShuKey"), "Label" )     --装备兵数

    _scrollview = tolua.cast( Layer:getWidgetByName("ScrollView_24"), "ScrollView" )

    remCurGeneral = 1
    _initJeneralScrollView()
end
function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        --Layer:clear()
        _widget = nil
        Layer = nil
        
        LM.STATE_3 = 0
    end
end

function enterUI()
    LM.STATE_3 = UI_BeiBao_ZhuangBei

    Layer = LM.getLayer3()
    _widget = GUIReader:shareReader():widgetFromJsonFile("BeiBao_ZhuangBei.json") 

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(false)

   _initPubMod()
   
--   Viewtype = 5
--   _flushBagScrollView()
    guideFactory.CheckGuideProcess( LM.STATE_3 )
end


