module ("DengLuJiangLi",package.seeall)

local Layer = nil
local widget = nil 

local scrollView = nil

function flushScrollViewJiangLi()
	scrollView:removeAllChildren()

	local cell_disY = 10
    local cell_H = 110
    --可视区域
    local view_W = scrollView:getSize().width 
    local view_H = scrollView:getSize().height 

    local dataList = MeiRiDengLuJLData.getJLListData()
    local Datanum = #dataList
    if Datanum == 0 then
    	return
    end
    scrollView:setInnerContainerSize( CCSize(view_W, cell_H*Datanum+(Datanum-1)*cell_disY) )

    --滑动区域
    local scroll_W = scrollView:getInnerContainerSize().width
    local scroll_H = scrollView:getInnerContainerSize().height

    
    local cell_X, cell_Y = scroll_W/2, scroll_H-cell_H/2

    local goodsDisx = 20 --物品间距
   	local goodsW = 88 --物品宽度
   	local typeImg = {"floor+53_tong.jpg", "floor+54_tong.jpg", "floor+55_tong.jpg", "floor+56_tong.jpg", "floor+57_tong.jpg"}
   
   	local function AddTouchCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			
			local _btn = tolua.cast(sender, "Button")
			local tag = _btn:getTag()
			local inteam = dataList[tag]["InTeam"]
			protoSend0x0538(tag)
		end
	end
    for i=1, Datanum do

    	local data = dataList[i]
    	local _state = data["state"]

    	local img_BG = ImageView:create()
		img_BG:loadTexture("floor+3_denglujiangli.png")
		img_BG:setAnchorPoint( ccp(0.5, 0.5) )
		img_BG:setPosition( ccp( cell_X, cell_Y ) )
			

			local goodsPosX = -(goodsDisx+goodsW)*1.5 - 40
			if _state == 3 then --已过期
				--领取状态
				local img_IfDo = ImageView:create()
				img_IfDo:loadTexture("floor+1_denglujiangli.png")
				img_IfDo:setAnchorPoint( ccp(0.5, 0.5) )
				img_IfDo:setPosition( ccp( goodsPosX-100 , 0 ) )
				img_BG:addChild(img_IfDo)
			elseif _state == 2 then --已领取
				local img_IfDo = ImageView:create()
				img_IfDo:loadTexture("floor+2_denglujiangli.png")
				img_IfDo:setAnchorPoint( ccp(0.5, 0.5) )
				img_IfDo:setPosition( ccp( goodsPosX-100 , 0 ) )
				img_BG:addChild(img_IfDo)
			end

			for j=1, 4 do
				local _type = data["type"..j] --1金币 2银币 3军功 4军粮 5军令 6装备
				local _value = data["value"..j]

		    	local img_GoodBG = ImageView:create()
				img_GoodBG:loadTexture("floor+8_tong.jpg")
				img_GoodBG:setAnchorPoint( ccp(0.5, 0.5) )
				img_GoodBG:setPosition( ccp( goodsPosX, 0 ) )
				
				if _type == 6 then
					local GodsData = Des.getGoodsDesFromId(_value)
					local name 	= GodsData["goodsName"]
					local qulity= GodsData["goodsQuality"]
					local pic 	= GoodsHeadPath .. GodsData["goodsPic"] .. ".png"
					
    				--img_pinzhi:loadTexture("rim+" .. quility .. "_juntuan.png")

    

					local img_Goods = ImageView:create()
					img_Goods:loadTexture( pic )
					img_Goods:setAnchorPoint(ccp(0.5, 0.5))
					img_Goods:setPosition(ccp(0,0))
					local img_qulity = ImageView:create()
					img_qulity:loadTexture("rim+" .. qulity .. "_juntuan.png")

					local img_numBG = ImageView:create()
					img_numBG:loadTexture("floor+10_tong.png")
					img_numBG:setAnchorPoint(ccp(0.5, 0.5))
					img_numBG:setPosition(ccp(0,-20))
					img_numBG:setScale9Enabled(true)
					img_numBG:setSize(CCSizeMake(75, 20))
						local lbl_name = Label:create()
						lbl_name:setText( name )
						lbl_name:setFontSize(22)
						lbl_name:setColor( ccc3( GoodsColorTab[qulity][1], GoodsColorTab[qulity][2], GoodsColorTab[qulity][3]) )
						lbl_name:setAnchorPoint( ccp(0.5, 0.5) )
						lbl_name:setPosition(ccp(0,-5))
					img_numBG:addChild(lbl_name)
				img_GoodBG:addChild(img_Goods)
				img_GoodBG:addChild(img_qulity)
				img_GoodBG:addChild(img_numBG)
				elseif _type ~= 0 then
					local img_Goods = ImageView:create()
					img_Goods:loadTexture( typeImg[_type] )
					img_Goods:setAnchorPoint(ccp(0.5, 0.5))
					img_Goods:setPosition(ccp(0,0))

					local img_numBG = ImageView:create()
					img_numBG:loadTexture("floor+10_tong.png")
					img_numBG:setAnchorPoint(ccp(0.5, 0.5))
					img_numBG:setPosition(ccp(0,-20))
					img_numBG:setScale9Enabled(true)
					img_numBG:setSize(CCSizeMake(75, 20))
						local lbl_num = Label:create()
						lbl_num:setText( _value )
						lbl_num:setFontSize(22)
						lbl_num:setAnchorPoint( ccp(0.5, 0.5) )
						lbl_num:setPosition(ccp(0,-5))
					img_numBG:addChild(lbl_num)
				img_GoodBG:addChild(img_Goods)
				img_GoodBG:addChild(img_numBG)
				end
				img_BG:addChild(img_GoodBG)
				
				goodsPosX = goodsPosX+(goodsW+goodsDisx)
			end

			--位置减回去
			goodsPosX = goodsPosX-(goodsW+goodsDisx)
---[[
		if _state == 3 then --已过期
			local img_State = ImageView:create()
			img_State:loadTexture("button13_tong_2.jpg")
			img_State:setAnchorPoint( ccp(0.5, 0.5) )
			img_State:setPosition( ccp( goodsPosX+130 , -15 ) )
			img_State:setScale(0.8)
				local lbl_State = Label:create()
				lbl_State:setText( "已过期" )
				lbl_State:setFontSize(26)
				lbl_State:setAnchorPoint( ccp(0.5, 0.5) )
	    		lbl_State:setColor( ccc3(217, 179, 16) )
	    		lbl_State:setPosition(ccp(0, 0))
	    	img_State:addChild(lbl_State)
			img_BG:addChild(img_State)
		elseif _state == 2 then --已领取
			local img_State = ImageView:create()
			img_State:loadTexture("button4_tong_3.jpg")
			img_State:setAnchorPoint( ccp(0.5, 0.5) )
			img_State:setPosition( ccp( goodsPosX+130 , -15 ) )
			img_State:setScale(0.8)
				local lbl_State = Label:create()
				lbl_State:setText( "已领取" )
				lbl_State:setFontSize(26)
				lbl_State:setAnchorPoint( ccp(0.5, 0.5) )
	    		--lbl_State:setColor( ccc3(255, 0, 0) )
	    		lbl_State:setPosition(ccp(0, 0))
	    	img_State:addChild(lbl_State)
			
			img_BG:addChild(img_State)
		elseif _state == 1 then --领取
			local btn_State = Button:create()
		    btn_State:setTouchEnabled(true)
		    btn_State:setScale(0.8)
		    btn_State:setTag(i)
		    btn_State:loadTextures("button12_tong_1.jpg", "button12_tong_2.jpg", "")
		    btn_State:setAnchorPoint(ccp(0.5,0.5))
		    btn_State:setPosition( CCPoint( goodsPosX+130 , -15 ) )
		   	btn_State:addTouchEventListener( AddTouchCB )
				local lbl_State = Label:create()
				lbl_State:setText( "领 取" )
				lbl_State:setFontSize(26)
				lbl_State:setAnchorPoint( ccp(0.5, 0.5) )
	    		lbl_State:setColor( ccc3(217, 179, 16) )
	    		lbl_State:setPosition(ccp(0, 0))
	    	btn_State:addChild(lbl_State)
		   	img_BG:addChild(btn_State)
		else --待领取
			local img_State = ImageView:create()
			img_State:loadTexture("button4_tong_3.jpg")
			img_State:setAnchorPoint( ccp(0.5, 0.5) )
			img_State:setPosition( ccp( goodsPosX+130 , -15 ) )
			img_State:setScale(0.8)
				local lbl_State = Label:create()
				lbl_State:setText( "待领取" )
				lbl_State:setFontSize(26)
				lbl_State:setAnchorPoint( ccp(0.5, 0.5) )
	    		--lbl_State:setColor( ccc3(255, 0, 0) )
	    		lbl_State:setPosition(ccp(0, 0))
	    	img_State:addChild(lbl_State)
			
			img_BG:addChild(img_State)

		end
--]]

				local lbl_DayNum = Label:create()
				lbl_DayNum:setText( "第" .. i .. "天" )
				lbl_DayNum:setFontSize(26)
				lbl_DayNum:setAnchorPoint( ccp(0.5, 0.5) )
	    		lbl_DayNum:setColor( ccc3(217, 179, 16) )
	    		lbl_DayNum:setPosition(ccp(goodsPosX+130, 25))

	    img_BG:addChild(lbl_DayNum)
		scrollView:addChild( img_BG )

		cell_Y = cell_Y - cell_H - cell_disY
    end

end


local function initPub()
    local btn_close = tolua.cast( Layer:getWidgetByName("Button_exit"), "Button" )
    local function btn_CB(sender, eventType)
       if eventType == PT.ccs.TouchEventType.ended then        
            exitUI()
        end
    end
    btn_close:addTouchEventListener( btn_CB )

    scrollView = tolua.cast( Layer:getWidgetByName("ScrollView_JiangLi"), "ScrollView" )

    flushScrollViewJiangLi()
end

function exitUI()
	if Layer ~= nil and widget ~= nil then
		Layer:removeWidget(widget)
		widget = nil
		Layer = nil
	end
	LM.STATE_3 = 0
	MapPubUI.setPubVisible(true)
end
function enterUI(  )
    LM.STATE_3 = UI_MeiRiDengLuJiangLi

    Layer = LM.getLayer3()
    widget = GUIReader:shareReader():widgetFromJsonFile("DengLuJiangLi.json") 

    Layer:addWidget(widget)
    widget:setTouchEnabled(true)

    MapPubUI.setPubVisible(false)

   	initPub()
end