module ("GK_JingYing",package.seeall)

local Layer = nil
local _widget = nil

local lbl_junLing = nil

local img_fatherCd = nil
	local lbl_CD = nil 		--cd时间


local guankaScrollview = nil


function flushJunLing()
	local curNum = PlayerData.getOrders()
	local maxNum = PlayerData.getOrdersLim()
	if curNum > maxNum then --变红
		lbl_junLing:setColor( ccc3(243, 7, 11) )
	else
		lbl_junLing:setColor( ccc3(240, 195, 55) )
	end
	local str = curNum .. "/" .. maxNum
	lbl_junLing:setText(str)
end

function flushGuanKaJingYingScrollView()
  
    guankaScrollview:removeAllChildren()

    guankaScrollview:setClippingEnabled(true) --裁切窗口
    
    guankaScrollview:setBackGroundColorType(0)

    --可视区域
	local view_W = guankaScrollview:getSize().width 
	local view_H = guankaScrollview:getSize().height 

	local Datanum = 20
	local weiZhaoMuData = nil
	local yiZhaoMuData = nil

	local openTab = NpcListData.getOpenLocTab()
	Datanum = #openTab

    local lieNum = 5
    local hangNum = math.ceil(Datanum/lieNum)

	local cell_W, cell_H = 163,170
	
	local cell_disY = 10 --纵向间隔
    local cell_disX = 2 --横向间隔

	guankaScrollview:setInnerContainerSize( CCSize(view_W, cell_H*hangNum+cell_disY*(hangNum-1)) )
		--滑动区域
	local scroll_W = guankaScrollview:getInnerContainerSize().width
	local scroll_H = guankaScrollview:getInnerContainerSize().height

	local cell_X, cell_Y = cell_W/2, scroll_H-cell_H/2+17


    local function CellTouchCB(sender, eventType)
         
 		if eventType == PT.ccs.TouchEventType.ended then
 			local _Img = tolua.cast(sender, "ImageView") 
 			local tag = _Img:getTag()
 			local splNpcData =  NpcListData.getSplDataFromLocIdx( tag )
 			PT.setId(splNpcData["Id"], 0, 0)
 			protoSend0x0204( splNpcData["Id"], -1 )

 			--guideFactory.CheckGuideProcess( nil  )
    	end
    end


	if hangNum < 3 then
		guankaScrollview:setBounceEnabled(false)
	else
		guankaScrollview:setBounceEnabled(true) --边缘回弹
	end
    for i=1, hangNum do
        for j=1, lieNum do
        
	        local index = (i-1)*lieNum+j
	        
	        if index <= Datanum then
	        	local splNpcData =  NpcListData.getSplDataFromLocIdx( openTab[index] )
	        	local groupDes = Des.getGroupBattleDesFromId(splNpcData["Id"])
	        	local state = splNpcData["State"]
	        	local name = groupDes["battleName"]
	        	local headpic = RoleHeadPath .. groupDes["npcPic"] .. ".png"

			    local img_bg = ImageView:create()
			    img_bg:loadTexture("floor+2_guanka_2.png")
			    img_bg:setPosition(ccp(cell_X, cell_Y))

			        local img_head = ImageView:create()
			        img_head:loadTexture( headpic )
			        img_head:setPosition(ccp(0, 5))
			        	local img_state = ImageView:create()
			        	if state == 2 then
			        		img_state:loadTexture( "" )
			        	else
				        	img_state:loadTexture( "floor+1_guanka_4.png" )
				        end
				        img_state:setPosition(ccp(0, 0))
				    img_head:addChild(img_state)

			        	local img_kuang = ImageView:create()
			        	img_kuang:loadTexture( "floor+2_juntuanNPC_1.png" )
			        	img_kuang:setTag(openTab[index])
			        	img_kuang:setPosition(ccp(0, -24))
				        img_kuang:setTouchEnabled(true)
				        img_kuang:addTouchEventListener(CellTouchCB)
			        	if state == 2 then --正在打
			        		local img_ZaiDa = ImageView:create()
				        	img_ZaiDa:loadTexture( "floor+5_guanka.png" )
				        	img_ZaiDa:setPosition(ccp(0, 75))
					        	local lbl_ZaiDa = Label:create()
					        	lbl_ZaiDa:setText("首次攻打")
					        	lbl_ZaiDa:setFontSize( 22 )
					        	--lbl_ZaiDa:setPosition( ccp(0, -59) )
					        img_ZaiDa:addChild(lbl_ZaiDa)
				        img_kuang:addChild(img_ZaiDa)

				       	end

				        	local lbl_name = Label:create()
				        	lbl_name:setText(name)
				        	lbl_name:setFontSize( 26 )
				        	lbl_name:setPosition( ccp(0, -59) )
							--lbl_name:setColor( ccc3(239, 224, 199) ) 
						img_kuang:addChild( lbl_name ) 
					img_kuang:addChild(img_head)
			        --img_head:addChild(img_kuang)
			        
				img_bg:addChild(img_kuang)

				cell_X = cell_X + cell_W + cell_disX	
				guankaScrollview:addChild( img_bg )
			end
   		end
   		cell_X = cell_W/2
        cell_Y = cell_Y -cell_H-cell_disY
	end



end

local function _initPubMod()
	guankaScrollview = tolua.cast( Layer:getWidgetByName("ScrollView_JingYingList"), "ScrollView" )

	img_fatherCd = tolua.cast( Layer:getWidgetByName("ImageView_ZhanDouCDTitle"), "ImageView" )
	lbl_CD = tolua.cast( Layer:getWidgetByName("Label_ZhanDouCD"), "Label" )
	
	lbl_junLing = tolua.cast( Layer:getWidgetByName("Label_JunLing"), "Label" )

	local img_cdBg =  tolua.cast( Layer:getWidgetByName("ImageView_cdBg"), "Label" )
	img_cdBg:setScaleX(-1)


	local img_addJunLing = tolua.cast( Layer:getWidgetByName("ImageView_JunLingTitle"), "ImageView" )
	local function Img_CDCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			local _img = tolua.cast(sender, "ImageView")
			if _img == img_cdBg then
				if PlayerData.getBeatCD() > 0 then
		    		protoSend0x0420(13)
		    	end
		    elseif _img == img_addJunLing then
		    	NotEnough.enterUI(4)
		    end
		end
	end
	img_cdBg:addTouchEventListener( Img_CDCB )
	img_addJunLing:addTouchEventListener( Img_CDCB )
	img_addJunLing:setTouchEnabled(true)

	PlayerData.setJingYingCDLable( lbl_CD,  img_cdBg)
	--初始化军令
	flushJunLing()

	flushGuanKaJingYingScrollView()



end 


function exitUI()
	if Layer ~= nil and _widget ~= nil then
		Layer:removeWidget(_widget)
		--Layer:clear()
		_widget = nil
		Layer = nil
		
		LM.STATE_2 = 0
	end
	PlayerData.clearJingYingCDLable()
	
end
function enterUI()
	LM.STATE_2 = UI_GuanKa_JingYing

	Layer = LM.getLayer2()
	_widget = GUIReader:shareReader():widgetFromJsonFile("guanKa_JingYing.json")

	Layer:addWidget(_widget)
    _widget:setTouchEnabled(false)

    _initPubMod()
    --_initKeJiScrollView()

    guideFactory.CheckGuideProcess( LM.STATE_2  )
end