module ("GuanZhi_GuanZhi",package.seeall)
--祭祀
local Layer = nil
local _widget = nil
--local curScene = nil
    local data = nil
    local ImgCur = nil
    local ImgNext =nil
    local lbl_curhonour = nil
    local lbl_cursalary = nil
    local lbl_notice = nil
    local lbl_nexthonour = nil
    local lbl_nextsalary = nil
    --local lbl_notice = nil
    local btn_salary = nil
    local btn_up = nil
    local img_offi = {"floor+1_guanzhi.jpg","floor+2_guanzhi.jpg","floor+3_guanzhi.jpg","floor+4_guanzhi.jpg","floor+5_guanzhi.jpg","floor+6_guanzhi.jpg"}
    local img_star = {"floor+32_tong.png","floor+33_tong.png","floor+34_tong.png","floor+35_tong.png","floor+36_tong.png"}
    local leftStar = {}
    local rightStar = {}

    local img_rightPanel = nil
function flushUI(  )
    local data = OfficialData.getOfficialData()
    if data ~= nil then
        lbl_curhonour:setText(data["CurHonour"])
        lbl_cursalary:setText(data["CurSalary"])
        if data["If_salary"] == 0 then
            --lbl_notice:setVisible(true)
            btn_salary:setTouchEnabled(true)
            btn_salary:setBright(true)
        else
            --lbl_notice:setVisible(false)
            btn_salary:setTouchEnabled(false)
            btn_salary:setBright(false)
        end
        lbl_nexthonour:setText(data["NextNeed"])
        lbl_nextsalary:setText(data["NextSalary"])
        if data["CurHonour"] >= data["NextNeed"] then
            btn_up:setTouchEnabled(true)
            btn_up:setBright(true)
        else
            btn_up:setTouchEnabled(false)
            btn_up:setBright(false)
        end
        
        local function getMN( Num )
            if Num == 1 then --贫民
                return 1, 0
            elseif Num <= 11 then --校尉
                return 2, Num-1
            elseif Num <= 21 then --偏将
                return 3, Num-11
            elseif Num <= 31 then --中郎将
                return 4, Num-21
            elseif Num <= 41 then --大将军
                return 5, Num-31
            elseif Num <= 51 then --大都督
                return 6, Num-41
            end
        end
        --当前级
        local m, n = getMN( data["CurOffi"] )

        ImgCur:loadTexture(img_offi[m]) 
            for i=1, 10 do
                if i<=n then
                    leftStar[i]["di"]:setVisible(true)
                    leftStar[i]["star"]:loadTexture( img_star[m] )
                else
                    leftStar[i]["di"]:setVisible(false)
                end
            end
        if data["CurOffi"] == 51 then --十星大都督
            img_rightPanel:setVisible(false)
            btn_up:setTouchEnabled(false)
            return
        end
        ----下一级
        m, n = getMN( data["NextOffi"] )
           ImgNext:loadTexture(img_offi[m]) 
            for i=1, 10 do
                if i<=n then
                    rightStar[i]["di"]:setVisible(true)
                    rightStar[i]["star"]:loadTexture( img_star[m] )
                else
                    rightStar[i]["di"]:setVisible(false)
                end
            end
        local offi = ""

            if m == 2 then
                offi = "校尉"
            elseif m == 3 then
                offi = "偏将"
            elseif m == 4 then
                offi = "中郎将"
            elseif m == 5 then
                offi = "大将军"
            elseif m == 6 then
                offi = "大都督"
            end 

            if data["NextType"] > 0 then
                local tp = ""
                if data["NextType"] == 1 then
                    tp = "武将"
                elseif data["NextType"] == 2 then
                    tp = "农田"
                elseif data["NextType"] == 3 then
                    tp = "附属国"
                elseif data["NextType"] == 4 then
                    tp = "银矿"
                end
                local offDes = Des.getOfficeDesFromId(data["NextOffi"])
                lbl_nextnotice:setText("威望达到" .. data["NextNeed"] .. "就能升级为" .. n .. "星" .. offi .. "。" .. offDes["rewardItems"])
                --lbl_nextnotice:setText("威望达到" .. data["NextNeed"] .. "就能升级为" .. n .. "星" .. offi .. "," .. tp .. "最大数量可增加" .. data["NextValue"] .. "个")
            else
                lbl_nextnotice:setText("威望达到" .. data["NextNeed"] .. "就能升级为" .. n .. "星" .. offi )
            end
  

    else
        print("GuanZhi_GuanZhi data = nil")
    end


end
local function _initPubMod()
   
    local btn_close = tolua.cast( Layer:getWidgetByName("Button_GuanBi"), "Button" )
    local function CloseCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then 
            exitUI()
        end
    end
    btn_close:addTouchEventListener(CloseCB)    

    img_rightPanel = tolua.cast( Layer:getWidgetByName("ImageView_rightBG"), "ImageView" )
    
    ImgCur = tolua.cast( Layer:getWidgetByName("ImageView_curGuanZhiBG"), "ImageView" )
    ImgNext = tolua.cast( Layer:getWidgetByName("ImageView_nextGuanZhiBG"), "ImageView" )
    lbl_curhonour = tolua.cast( Layer:getWidgetByName("Label_CurWeiWang"), "Label" )
    lbl_cursalary = tolua.cast( Layer:getWidgetByName("Label_CurFengLu"), "Label" )
    --lbl_notice = tolua.cast( Layer:getWidgetByName("Label_tishi"), "Label" )
    lbl_nexthonour = tolua.cast( Layer:getWidgetByName("Label_needWeiWang"), "Label" )
    lbl_nextsalary = tolua.cast( Layer:getWidgetByName("Label_needFengLu"), "Label" )
    lbl_nextnotice = tolua.cast( Layer:getWidgetByName("Label_needJiangLi"), "Label" )
    btn_salary = tolua.cast( Layer:getWidgetByName("Button_LingQu"), "Button" )
    btn_up = tolua.cast( Layer:getWidgetByName("Button_ShengGuan"), "Button" )
    local function btn_CB(sender, eventType)
      if eventType == PT.ccs.TouchEventType.ended then
            local _btn = tolua.cast(sender, "Button")
            if _btn == btn_salary then --领取俸禄
               protoSend0x0418(1)
            elseif _btn == btn_up then --升官
                protoSend0x0418(2)
            end
        end
    end

    btn_salary:addTouchEventListener( btn_CB )
    btn_up:addTouchEventListener( btn_CB )

    for i=1, 10 do
        leftStar[i] = {}
        leftStar[i]["di"] = tolua.cast( Layer:getWidgetByName("ImageView_LeftDi" .. i), "ImageView" )
        leftStar[i]["di"]:setVisible(false)
        leftStar[i]["star"] = tolua.cast( Layer:getWidgetByName("ImageView_LeftXing" .. i), "ImageView" )
    end

    for i=1, 10 do
        rightStar[i] = {}
        rightStar[i]["di"] = tolua.cast( Layer:getWidgetByName("ImageView_Di" .. i), "ImageView" )
        rightStar[i]["di"]:setVisible(false)
        rightStar[i]["star"] = tolua.cast( Layer:getWidgetByName("ImageView_Xing" .. i), "ImageView" )
    end

    flushUI()

end

function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        --Layer:clear()
        _widget = nil
        Layer = nil
        
        LM.STATE_3 = 0
    end
    MapPubUI.setPubVisible(true)
end

function enterUI()
    LM.STATE_3 = UI_GuanZhi

    Layer = LM.getLayer3()
    _widget = GUIReader:shareReader():widgetFromJsonFile("GuanZhi_GuanZhi.json")   

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)

    MapPubUI.setPubVisible(false)

    _initPubMod()
end

--[[
function enterUI( _Scene )
    PT.UI_State = UI_GuanZhi
	curScene = _Scene
	Layer = TouchGroup:create()
    Layer:setZOrder(10)

    local _widget = GUIReader:shareReader():widgetFromJsonFile("GuanZhi_GuanZhi.json")    
    _widget:setTouchEnabled(false)
    Layer:addWidget(_widget)
    _Scene:addChild(Layer)
  
    _initPubMod()

    guideFactory.CheckGuideProcess(curScene)
end

function exitUI()
    --BagData.clearCDlbl()
	curScene:removeChild(Layer, true)
	--Layer:onExit()
end
--]]