module ("GuoZhan_GuiZe",package.seeall)

local Layer = nil 
local scene = nil
local pre_UI = 1
local ScrollView_GuiZe = 1

local btn_close
local btn_jiaru

local function refresh_state()
    if PlayerData.getLv() <= 9 then
        print("Player lv is low")
        btn_jiaru:setTouchEnabled(false)
        btn_jiaru:setBright(false)
    else
        btn_jiaru:setTouchEnabled(true)
        btn_jiaru:setBright(true)
    end
    if ifserver == false then
        btn_jiaru:setTouchEnabled(true)
        btn_jiaru:setBright(true)
    end
end 

function enterGuoZhanUI()

    exitUI()
    Pop3_GuoZhan_LuoYangCheng.exitUI() --释放上一级ui，当从主ui进入时，此函数无效果
    local fatherUI = LM.STATE_1
    if fatherUI == UI_ZhuCheng then
        MapShouYe.exitUI()
    end
    --LM.clearLayer2ToUI()
    ------------------------------------
    LM.clearMainCity()
    CDTimeManager.clearAllLble()
    LM.clearPubMid()
    LM.clearUI()
    -----------------------------
    GuoZhan_Map.enterUI( fatherUI )
    GuoZhan_MainUI.enterUI( fatherUI )
end

local function flush_ScrollView_GuiZe()
    ScrollView_GuiZe:setBackGroundColorType(0)
    --ScrollView_GuiZe:removeAllChildren()
    ScrollView_GuiZe:setBounceEnabled(true) --边缘回弹
end

local function initMap()
    local function btnCallback(sender, eventType)     
        if eventType == PT.ccs.TouchEventType.ended then
        	local _btn = tolua.cast(sender, "Button")
        	local tag = _btn:getTag()
        	print("tag === " .. tag)
            if _btn == btn_close then
                exitUI()
            elseif _btn == btn_jiaru then
                if ifGuoZhan then
                    if CityData.canOpenFuncByIndex(34) then --判断玩家开启国战功能没
                        if GuoZhanData.getIsStartGuoZhan() then --判断当前国战是否在开始时间
                            protoSend0x0442(0)
                        else
                            Pop3_TS_Result.enterUI("国战还未开启，请稍后再来。")
                        end
                    else
                        Pop3_TS_Result.enterUI("等级不够，无法参加国战！")
                    end     
                else
                    Pop3_TS_Result.enterUI("国战未开启！")
                end
            end
    	end
    end

    btn_close = tolua.cast(Layer:getWidgetByName("Button_close"), "Button" )
    btn_jiaru = tolua.cast(Layer:getWidgetByName("Button_JiaRu"), "Button" )
    ScrollView_GuiZe = tolua.cast(Layer:getWidgetByName("ScrollView_GuiZe"),"ScrollView")

    btn_close:addTouchEventListener(btnCallback)
    btn_jiaru:addTouchEventListener(btnCallback)

    flush_ScrollView_GuiZe()
    refresh_state()

    if ifserver == false then
        GuoZhanData.setGuoZhanData(1,2,300,200,2000,200,500,15,10)
        for i=4,11 do
            GuoZhanData.setSpyCityCD(i,i*10)
        end        
        ---CDTimeManager:start()
        math.randomseed(os.time())
        for j=4,11 do    
            for i=1,100 do
            local _data = PT.copyTable(GuoZhanData.GuoZhan_PlayerData)
            _data["charid"] = math.random(3000)
            _data["lv"] = math.random(10)
            _data["name"] = "玩家名字真长"
            _data["pos"] =   math.random(2)
            _data["belong"] =  math.random(3)
            GuoZhanData.addCitySpyData(j,i,_data)
            end
            GuoZhanData.setCityPosCount(j,11,100)
        end
    end
    for i=1,11 do  --设置拥挤度
        local _data = PT.copyTable(GuoZhanData.CityBlengs_cellData)
        _data["belong"] = 0
        _data["yongjidu"] = math.random(5)
        GuoZhanData.addCityBelong(_data,i) 
    end
end

function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        _widget = nil
        Layer = nil
        LM.STATE_4 = 0
    end
    MapPubUI.setPubVisible(true)
end
function enterUI()
    LM.STATE_4 = UI_GuoZhan_GuiZe
    Layer = LM.getLayer4()
    _widget = GUIReader:shareReader():widgetFromJsonFile("GuoZhan_Pop3_GuiZe.json")   

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)

    initMap()

    MapPubUI.setPubVisible(false)
end
--[[
function exitUI()
    PT.UI_State =  pre_UI 
	scene:removeChild(Layer, true)
end

function enterUI(curScene)
    scene = curScene
    pre_UI =  PT.UI_State 
    PT.UI_State = UI_GuoZhan_GuiZe
    Layer = TouchGroup:create()
    Layer:setZOrder(150)

    local _widget = GUIReader:shareReader():widgetFromJsonFile("GuoZhan_Pop3_GuiZe.json") 
    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)
 	scene:addChild(Layer)
    initMap()
end
--]]