module ("Pop3_GuoZhan_LuoYangCheng",package.seeall)

local Layer = nil
local _widget = nil
local scene = nil

local btn_close = nil
local btn_jiaru = nil
local btn_guize = nil
local remFatherUi = nil


local function refresh_state()
    if PlayerData.getLv() <= 9 then
        print("Player lv is low")
        btn_jiaru:setTouchEnabled(false)
        btn_jiaru:setBright(false)
    else
        btn_jiaru:setTouchEnabled(true)
        btn_jiaru:setBright(true)
    end
    if ifserver == false then
        btn_jiaru:setTouchEnabled(true)
        btn_jiaru:setBright(true)
        btn_guize:setTouchEnabled(true)
        btn_guize:setBright(true)
    end
end 

local function initMap()
    local function btnCallback(sender, eventType)  
        if eventType == PT.ccs.TouchEventType.ended then
        	local _btn = tolua.cast(sender, "Button")
        	local tag = _btn:getTag()
        	print("tag === " .. tag)
            if _btn == btn_close then
                exitUI()
                MapPubUI.setPubVisible(true)
            elseif _btn == btn_jiaru then

                --todo:直接进国战
                if ifGuoZhan then  
                    if CityData.canOpenFuncByIndex(34) then
                        if GuoZhanData.getIsStartGuoZhan() then
                            exitUI()
                            local fatherUI = LM.STATE_1
                            if fatherUI == UI_ZhuCheng then
                                MapShouYe.exitUI()
                            end
                            ------------------------------------
                            LM.clearMainCity()
                            CDTimeManager.clearAllLble()
                            LM.clearPubMid()
                            LM.clearUI()
                            -----------------------------
                            GuoZhan_Map.enterUI( fatherUI )
                            GuoZhan_MainUI.enterUI( fatherUI )
                        else
                            Pop3_TS_Result.enterUI("国战还未开启，请稍后再来。")
                        end
                    else
                        Pop3_TS_Result.enterUI("等级不够，无法参加国战！")
                    end     
                else
                    Pop3_TS_Result.enterUI("国战未开启！")
                end
            elseif _btn == btn_guize then
                exitUI()
                GuoZhan_GuiZe.enterUI()      
            end
    	end
    end

    btn_close = tolua.cast(Layer:getWidgetByName("Button_close"), "Button" )
    btn_jiaru = tolua.cast(Layer:getWidgetByName("Button_JiaRu"), "Button" )
    btn_guize = tolua.cast(Layer:getWidgetByName("Button_guize"), "Button" )

    btn_close:addTouchEventListener(btnCallback)
    btn_jiaru:addTouchEventListener(btnCallback)
    btn_guize:addTouchEventListener(btnCallback)

    refresh_state()
end

function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        _widget = nil
        Layer = nil
        LM.STATE_3 = 0
    end
     MapPubUI.setPubVisible(true)
end

function enterUI()
    LM.STATE_3 = UI_GuoZhan_LuoYangCheng
    Layer = LM.getLayer3()
    _widget = GUIReader:shareReader():widgetFromJsonFile("GuoZhan_Pop3_LuoYangCheng.json")   

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)

    MapPubUI.setPubVisible(false)
    initMap()

    MapPubUI.setPubVisible(false)
end

--[[
function exitUI()
    PT.UI_State = remFatherUi 
    scene:removeChild(Layer, true)
end
function enterUI(curScene)
    remFatherUi =PT.UI_State 
    scene = curScene
    PT.UI_State = UI_GuoZhan_LuoYangCheng
    Layer = TouchGroup:create()
    Layer:setZOrder(0)

    local _widget = GUIReader:shareReader():widgetFromJsonFile("GuoZhan_Pop3_LuoYangCheng.json") 
    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)
 	scene:addChild(Layer)
    initMap()
end
--]]