module ("HelpUI",package.seeall)
--将领更改训练模式的3级UI
--local curScene = nil
local curLayer = nil
local widget = nil



local function initPub()
	local btn_close = tolua.cast( curLayer:getWidgetByName("Button_guanBi"), "Button" )
	local function btnCloseCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then 
			exitUI()
		end
	end	
	btn_close:addTouchEventListener(btnCloseCB)

	local btnTab = {}

	btnTab[1] ={}
	btnTab[1]["img"] = tolua.cast( curLayer:getWidgetByName("ImageView_wuJiang"), "ImageView" )
	btnTab[1]["scl"] = tolua.cast( curLayer:getWidgetByName("ScrollView_wuJiang"), "ScrollView" )

	btnTab[2] ={}
	btnTab[2]["img"] = tolua.cast( curLayer:getWidgetByName("ImageView_nvShen"), "ImageView" )
	btnTab[2]["scl"] = tolua.cast( curLayer:getWidgetByName("ScrollView_nvShen"), "ScrollView" )

	btnTab[3] ={}
	btnTab[3]["img"] = tolua.cast( curLayer:getWidgetByName("ImageView_zhenXing"), "ImageView" )
	btnTab[3]["scl"] = tolua.cast( curLayer:getWidgetByName("ScrollView_zhenXing"), "ScrollView" )

	btnTab[4] ={}
	btnTab[4]["img"] = tolua.cast( curLayer:getWidgetByName("ImageView_zhuangBei"), "ImageView" )
	btnTab[4]["scl"] = tolua.cast( curLayer:getWidgetByName("ScrollView_zhuangBei"), "ScrollView" )

	btnTab[5] ={}
	btnTab[5]["img"] = tolua.cast( curLayer:getWidgetByName("ImageView_tianQi"), "ImageView" )
	btnTab[5]["scl"] = tolua.cast( curLayer:getWidgetByName("ScrollView_tianQi"), "ScrollView" )

	btnTab[6] ={}
	btnTab[6]["img"] = tolua.cast( curLayer:getWidgetByName("ImageView_zhuCheng"), "ImageView" )
	btnTab[6]["scl"] = tolua.cast( curLayer:getWidgetByName("ScrollView_zhuCheng"), "ScrollView" )
	
	local remIdx = 1
	local function pubImgCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then 
			local _Img = tolua.cast(sender, "ImageView")
			local tag = _Img:getTag()
			if remIdx == tag then
				return
			end
			btnTab[remIdx]["img"]:loadTexture("button14_tong_2.png")
			btnTab[remIdx]["scl"]:setVisible(false)
			btnTab[remIdx]["scl"]:setTouchEnabled(false)

			remIdx = tag

			btnTab[remIdx]["scl"]:setVisible(true)
			btnTab[remIdx]["scl"]:setTouchEnabled(true)
			_Img:loadTexture("button14_tong_1.png")


		end
	end

	for i=1, 6 do
		btnTab[i]["img"]:setTouchEnabled(true)
		btnTab[i]["img"]:setTag(i)
		btnTab[i]["img"]:addTouchEventListener(pubImgCB)
		btnTab[i]["scl"]:setVisible(false)
		btnTab[i]["scl"]:setTouchEnabled(false)
	end

	btnTab[remIdx]["img"]:loadTexture("button14_tong_1.png")
	btnTab[remIdx]["scl"]:setVisible(true)
	btnTab[remIdx]["scl"]:setTouchEnabled(true)
end

function exitUI()
	if curLayer ~= nil and widget ~= nil then
		curLayer:removeWidget(widget)
		widget = nil
		curLayer = nil
		
		LM.STATE_3 = 0
	end
	MapPubUI.setPubVisible(true)

end

function enterUI()
	LM.STATE_3 = UI_City_JunJiChu

	curLayer = LM.getLayer3()
	widget = GUIReader:shareReader():widgetFromJsonFile("HelpUI.json")

    curLayer:addWidget(widget)
    widget:setTouchEnabled(true)
	MapPubUI.setPubVisible(false)

   	initPub()
end