module ("JunTuanZhan_JieGuo",package.seeall)

local Layer = nil 
--local scene = nil
--local pre_UI = 1
local _widget = nil
Hide_CD = 1

local btn_close
local sv_Result = nil  --胜负列表
--local img_result1 = nil --胜负图标
local img_result2 = nil --胜负图标
--local lbl_result = nil  --标题结果

local guanka_name = {
    "官渡港",
    "赤壁港",
    "夷洲港",
    "霞萌关",
    "汜水关",
    "潼关",
    "虎牢关",
}


function Hide_Layer()
    exitUI()
end

function refresh_ScrollView()
    sv_Result:setBackGroundColorType(0)
    sv_Result:removeAllChildren()
    sv_Result:setBounceEnabled(true) --边缘回弹
    sv_Result:setClippingEnabled(true) --裁切窗口
    
    local cell_disY = 5
        --可视区域
    local view_W = sv_Result:getSize().width 
    local view_H = sv_Result:getSize().height 
    local num = 0
    local dataList = FightRewardData.getJTResult()
    if ifserver then
        num = #dataList
    end
    local cell_W, cell_H = view_W, 60
    local scroll_H = cell_H*num+cell_disY*(num-1)
    sv_Result:setInnerContainerSize( CCSize(view_W, scroll_H) )

    local cell_X, cell_Y = 0, scroll_H

    for i=1, num do
        local name = "测试名字"
        local winsize= "4连胜"
        local zeny = "3000银币"
        local contribute = "10000贡献"
        local data = dataList[i]
        if ifserver then
            name = data["Name"]
            winsize = data["WinMax"] .. "连胜"
            contribute = data["Contribute"] .. "贡献"
            zeny = data["Zeny"] .. "银币"
        end

        local lbl_name = Label:create()
        lbl_name:setText( name )
        lbl_name:setFontSize( 20 )
        lbl_name:setPosition(ccp(0, cell_Y-15))
        lbl_name:setAnchorPoint(ccp(0,0.5))
        lbl_name:setColor( ccc3(255, 239, 176) )
       
        local posY = cell_Y-27-cell_disY-15
        local lbl_win = Label:create()
        lbl_win:setText( winsize )
        lbl_win:setFontSize( 20 )
        lbl_win:setPosition(ccp(70, posY))
        lbl_win:setAnchorPoint(ccp(0.5,0.5))
        lbl_win:setColor( ccc3(255, 239, 176) )

        local lbl_zeny = Label:create()
        lbl_zeny:setText( zeny )
        lbl_zeny:setFontSize( 20 )
        lbl_zeny:setPosition(ccp(149, posY))
        lbl_zeny:setAnchorPoint(ccp(0.5,0.5))
        lbl_zeny:setColor( ccc3(255, 239, 176) )

        local lbl_GongXian = Label:create()
        lbl_GongXian:setText( contribute )
        lbl_GongXian:setFontSize( 20 )
        lbl_GongXian:setPosition(ccp(297, posY))
        lbl_GongXian:setAnchorPoint(ccp(1,0.5))
        lbl_GongXian:setColor( ccc3(255, 239, 176) )

        sv_Result:addChild(lbl_name)
        sv_Result:addChild(lbl_win)
        sv_Result:addChild(lbl_zeny)
        sv_Result:addChild(lbl_GongXian)

        cell_Y = cell_Y - cell_H - cell_disY
    end

end

local function refresh_data()
    if JunTuanZhanData.getFightResult() == 0 then --失败
        --img_result1:loadTexture("pic+18_jtz.png")
        img_result2:loadTexture("word+11_juntuanzha.png")
        --lbl_result:setText("进攻失败")
        AudioEngine.playEffect("4_20.wav",false)      
    else --胜利
        local  data = guanka_name[index_city]
            print("the index_city is "..index_city)
        if data ~= nil then
            print("the data is "..data)
            --lbl_result:setText(data.."易主")
        end
       -- img_result1:loadTexture("pic+17_jtz.png")
        img_result2:loadTexture("word+10_juntuanzha.png")
        AudioEngine.playEffect("4_19.wav", false)
    end
    refresh_ScrollView()
end 

local function initMap()

    local function btnCallback(sender, eventType)     
        if eventType == PT.ccs.TouchEventType.ended then
        	local _btn = tolua.cast(sender, "Button")
        	local tag = _btn:getTag()        	
            print("tag === " .. tag)
            if _btn == btn_close then
                exitUI()
            --elseif _btn == btn_jiaru then
            end
    	end
    end

    btn_close = tolua.cast(Layer:getWidgetByName("Button_close"), "Button" )
    sv_Result = tolua.cast(Layer:getWidgetByName("ScrollView_result"),"ScrollView")
    --img_result1 = tolua.cast(Layer:getWidgetByName("ImageView_result1"),"ImageView")
    img_result2 = tolua.cast(Layer:getWidgetByName("ImageView_result2"),"ImageView")
    --lbl_result = tolua.cast(Layer:getWidgetByName("Label_result"),"Label")
    
    btn_close:addTouchEventListener(btnCallback)
    refresh_data()
    JunTuanZhanData.setFightResultCD(3)
end

function exitUI()
--[[   
    if Layer ~= nil then
        PT.UI_State = pre_UI  
	    scene:removeChild(Layer, true)
        Layer = nil
    end
--]]
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        --Layer:clear()
        _widget = nil
        Layer = nil
        
        LM.STATE_11 = 0
    end
end

function enterUI()
--[[   
    scene = curScene
    pre_UI =  PT.UI_State 
    PT.UI_State = UI_JunTuanZhan_JieGuo
    Layer = TouchGroup:create()
    Layer:setZOrder(0)
    --Layer:setTouchPriority(-10)
    local _widget = GUIReader:shareReader():widgetFromJsonFile("JunTuanZhan_Pop3_JieGuo.json") 
    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)
 	scene:addChild(Layer)
--]]    
    LM.STATE_11 = UI_JunTuanZhan_JieGuo

    Layer = LM.getLayer11()
    _widget = GUIReader:shareReader():widgetFromJsonFile("JunTuanZhan_Pop3_JieGuo.json")

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)


    initMap()
end
