module ("LiaoTianInputName",package.seeall)
local Layer = nil
local curScene = nil
local name = nil
function exitUI()
	LiaoTian.setSiLiaoName( name, false, 0, 0 )
	curScene:removeChild(Layer, true)
end

function enterUI( _Scene )

	ifOnTheTalkUi = true

	curScene = _Scene
	Layer = TouchGroup:create()
	--Layer:setTouchEnabled(false)
	Layer:setZOrder(10)
    local _widget = GUIReader:shareReader():widgetFromJsonFile("LiaoTian_InputName.json")    
    _widget:setTouchEnabled(true)
    Layer:addWidget(_widget)
    _Scene:addChild(Layer)

    local TextField_inputName = tolua.cast( Layer:getWidgetByName("TextField_inputName"), "TextField" )
    
    local btn_QueDing = tolua.cast( Layer:getWidgetByName("Button_queding"), "Button" )
    local btn_QuXiao =  tolua.cast( Layer:getWidgetByName("Button_quxiao"), "Button" )

	local function btn_TouchCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			 
			local _btn = tolua.cast(sender, "Button")
			if _btn == btn_QueDing then
				name = TextField_inputName:getStringValue()
				protoSend0x0428(name)
				--exitUI()
			elseif _btn == btn_QuXiao then
				LiaoTian.setSiLiaoName( "", false, 0, 0 )
				exitUI()
			end
		end
	end

    btn_QueDing:addTouchEventListener( btn_TouchCB )
    btn_QuXiao:addTouchEventListener( btn_TouchCB )

end