module ("MailBase",package.seeall)
local Layer = nil
local widget = nil
--local scene = nil
local remIndex = nil

local img_read = nil
local img_write = nil

local scl_MailList = nil
local lbl_pageNum = nil --页数

local btn_dellAll = nil
local btn_dellOne = nil
local btn_backMail = nil

--读取面板
local lbl_readName = nil
local lbl_readTitle = nil
local lbl_readText = nil
local ScrollView_Read = nil

--写邮件面板
local TextField_WriteName = nil
local TextField_WriteTitle= nil
local TextField_WriteText = nil

local fouceImg = nil

local remMailTab = nil
local maxPage = 1 --最大页数
local curPage = 1 --当前页数

local remDataIdx = 0 --记录数据信息

local LabelBMFont_HuiFu = nil
local LabelBMFont_DelOne = nil
local LabelBMFont_FaSong = nil
local LabelBMFont_GuanBi = nil

local lbl_HuiFu = nil
local lbl_DelOne = nil
local lbl_FaSong = nil
local lbl_GuanBi = nil


ifclickable = false

local img_QuanbuForRed = nil --为显示小红点引出的指针

local remFatherUi = nil
function setName(_name)
    TextField_WriteName:setText(_name)
end

function flushRedPoint()
    local ifneed = MailListData.getIfViewRedPoint()
    if ifneed then --需要显示
        local _Img = tolua.cast( img_QuanbuForRed:getChildByTag(10), "ImageView" ) 
        if _Img == nil then
            local img_point = ImageView:create()
            img_point:loadTexture("floor+60_tong.png")
            img_point:setTag(10)
            img_point:setPosition(ccp(-47,17))
            img_QuanbuForRed:addChild(img_point)
        end
    else -- 移除
        local _Img = tolua.cast( img_QuanbuForRed:getChildByTag(10), "ImageView" ) 
        if _Img ~= nil then
            img_QuanbuForRed:removeChildByTag(10, true)
        end
    end
end

local function flushDataPart( )
    remMailTab = MailListData.getTableIdx(remIndex)
    curPage = 1
    maxPage = math_ceil( (#remMailTab)/5)
    if maxPage <= 0 then
        maxPage = 1
    end
end

local function getseasion( _seasion )
    if _seasion == 0 then
        return "春"
    elseif _seasion == 1 then
        return "夏"
    elseif _seasion == 2 then
        return "秋"
    elseif _seasion == 3 then
        return "冬"
    end
end

function setReadOrWrite( _bool )
    if _bool then --读取面板显示
        PT.showWidget( img_read )
        PT.hideWidget( img_write )
        --LabelBMFont_HuiFu:setTouchEnabled(false)
        --LabelBMFont_DelOne:setTouchEnabled(false)
        lbl_HuiFu:setTouchEnabled(false)
        lbl_DelOne:setTouchEnabled(false)
    else --写面板显示
        PT.showWidget( img_write )
        PT.hideWidget( img_read )
        --LabelBMFont_FaSong:setTouchEnabled(false)
        --LabelBMFont_GuanBi:setTouchEnabled(false)
        
        lbl_FaSong:setTouchEnabled(false)
        lbl_GuanBi:setTouchEnabled(false)
        clearWritePanel()
    end
end

function writeBackEmail() --回复邮件    
        PT.showWidget( img_write )
        PT.hideWidget( img_read )
        --LabelBMFont_FaSong:setTouchEnabled(false)
        --LabelBMFont_GuanBi:setTouchEnabled(false)
        TextField_WriteTitle:setText("")
        TextField_WriteText:setText("")
        if lbl_readName:getStringValue() == "系统" then
            TextField_WriteName:setText("")
            Pop3_TS_Result.enterUI( "无法给系统恢复邮件！"  )
        else
            TextField_WriteName:setText(lbl_readName:getStringValue())
        end
end

function clearWritePanel()
    TextField_WriteName:setText("")
    TextField_WriteTitle:setText("")
    TextField_WriteText:setText("")
end
local function clearReadPanel()
    lbl_readName:setText("")
    lbl_readTitle:setText("")
    lbl_readText:setText("")

    ScrollView_Read:setInnerContainerSize(CCSize(285,150))
    lbl_readText:setSize(CCSize(285,150))
end
function flushReadPanel( _dataIdx )
    local data = MailListData.getMailDataFromLocalIdx(_dataIdx)

    lbl_readName:setText( data["SenderName"] )
    lbl_readTitle:setText( data["MailTitle"] )
    lbl_readText:setText( data["MailBody"] )

    local lbl_test = Label:create()
    lbl_test:setText(data["MailBody"])
    print( "---> " .. data["MailBody"] )
    local len = string_len( data["MailBody"] )
    print("len --> " .. len )
    local size = lbl_test:getContentSize()
    print("size W = " .. size.width)
    print("size H = " .. size.height)

    local len = string_len( data["MailBody"] )

    lbl_readText:setAnchorPoint(ccp(0,1))


    local Height = len/11*18
    print("Height == " .. Height)
    if Height < 158 then
        Height = 158
    end
    lbl_readText:setSize(CCSize(285,Height))
    lbl_readText:setPosition(ccp(0,Height))
    ScrollView_Read:setInnerContainerSize(CCSize(285,Height))
    ScrollView_Read:setClippingEnabled(true)

end

function flushScrollViewMailList()
    scl_MailList:setClippingEnabled(true) --裁切窗口
    --scl_MailList:setBounceEnabled(true) --边缘回弹
    scl_MailList:setBackGroundColorType(0)

    scl_MailList:removeAllChildren()
    --设置页数
    lbl_pageNum:setText( curPage .. "/" .. maxPage )

    local cell_disY = -7
    local cell_disX = 0

    local cell_W, cell_H = 371, 80
        --可视区域
    local view_W = scl_MailList:getSize().width 
    local view_H = scl_MailList:getSize().height 

    local Datanum = 5
    local maxMailSize = #remMailTab
    
    if maxMailSize -(curPage-1)*5 > 5 then
        Datanum = 5
    else
        Datanum = maxMailSize - (curPage-1)*5
    end

    scl_MailList:setInnerContainerSize( CCSize(view_W, cell_H*Datanum + (Datanum-1)*cell_disY) )

    --滑动区域
    local scroll_W = scl_MailList:getInnerContainerSize().width
    local scroll_H = scl_MailList:getInnerContainerSize().height
    local cell_X, cell_Y = (scroll_W)/2, scroll_H-cell_H/2

    local function CellTouchCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            
            local _img = tolua.cast(sender, "ImageView")
            local _imgstate = tolua.cast(_img:getChildByTag(1), "ImageView")
            _imgstate:removeAllChildren()
            _imgstate:loadTexture( "floor+42_tong.png" )
            local img_state2 = ImageView:create()
            img_state2:loadTexture("floor+2_youjian.png")
            local img_state3 = ImageView:create()
            img_state3:loadTexture("floor+40_tong.png")
            img_state3:setPosition(ccp(-22,18))
            _imgstate:addChild(img_state2)
            _imgstate:addChild(img_state3)

            remDataIdx = _img:getTag()
            local posX, posY = _img:getPosition()
            fouceImg:setPosition( ccp(posX-10, posY) )
            setReadOrWrite(true)
            print(" remDataIdx is "..remDataIdx)
            MailListData.openMail(remDataIdx)
            flushRedPoint()
            flushReadPanel( remDataIdx )
        end
    end    
    if Datanum > 0 then
        fouceImg = ImageView:create()
        fouceImg:loadTexture("floor+3_youjian.png")
        fouceImg:setScale9Enabled(true)
        fouceImg:setSize( CCSize( 366, 74) )
        scl_MailList:addChild( fouceImg)

        btn_dellAll:setTouchEnabled(true)
        btn_dellOne:setTouchEnabled(true)
        btn_backMail:setTouchEnabled(true)
    else
        remDataIdx = 0
        clearReadPanel()
        btn_dellAll:setTouchEnabled(false)
        btn_dellOne:setTouchEnabled(false)
        btn_backMail:setTouchEnabled(false)
    end
    for i=1, Datanum do
        local dataIdx = remMailTab[(curPage-1)*5+i]

        local MailData = MailListData.getMailDataFromLocalIdx(dataIdx)
        if i == 1 then
            remDataIdx = dataIdx
            fouceImg:setPosition( ccp(cell_X, cell_Y) )
            MailListData.openMail(dataIdx)
            flushRedPoint()
            MailData["ReadState"] = 1
            setReadOrWrite(true)
            flushReadPanel( dataIdx )
        end
local ifOpen = false --默认未打开
local SenderName = nil
local MailTime = nil
local MailTitle = nil

        if MailData["ReadState"] == 1 then --打开
            ifOpen = true
        elseif MailData["ReadState"] == 0 then --未打开
            ifOpen = false
        end

        SenderName = MailData["SenderName"]
        MailTitle = MailData["MailTitle"]

        MailTime = MailData["MailYear"] .. "年" .. getseasion(MailData["MailSeason"] )

        local imageViewBG = ImageView:create()
        imageViewBG:loadTexture("button14_tong_1.png")
        imageViewBG:setScale9Enabled(true)
        imageViewBG:setSize( CCSize( 338, 65) )
        imageViewBG:setTag(dataIdx)
        imageViewBG:setPosition( ccp( cell_X+10, cell_Y ) )
        imageViewBG:addTouchEventListener( CellTouchCB )
        imageViewBG:setTouchEnabled(true)
            
        local img_state = ImageView:create()
            img_state:loadTexture("floor+42_tong.png")

        if ifOpen then             
            local img_state2 = ImageView:create()
            img_state2:loadTexture("floor+2_youjian.png")
            local img_state3 = ImageView:create()
            img_state3:loadTexture("floor+40_tong.png")
            img_state3:setPosition(ccp(-22,18))
            img_state:addChild(img_state2)
            img_state:addChild(img_state3)
        else
            local img_state2 = ImageView:create()
            img_state2:loadTexture("floor+1_youjian.png")

            local img_state3 = ImageView:create()
            img_state3:loadTexture("floor+41_tong.png")
            img_state3:setPosition(ccp(-22,18))

            img_state:addChild(img_state2)
            img_state:addChild(img_state3)
        end

            img_state:setTag(1)
            img_state:setPosition( ccp(-155, 0) )
        imageViewBG:addChild( img_state )
            local lbl_name = Label:create()
            lbl_name:setText( SenderName )
            lbl_name:setFontSize(24)
            lbl_name:setColor( ccc3(0, 255, 0) )
            lbl_name:setAnchorPoint( ccp(0, 0) )
            lbl_name:setPosition( ccp(-90, -1) )
        imageViewBG:addChild( lbl_name )
        local size = lbl_name:getContentSize()
            local lbl_time = Label:create()
            lbl_time:setText(MailTime)
            lbl_time:setFontSize(24)
            lbl_time:setColor( ccc3(204,167,108) )
            lbl_time:setAnchorPoint( ccp(0, 0) )
            lbl_time:setPosition( ccp(-90+size.width+10, -1) )
        imageViewBG:addChild( lbl_time ) 
            local lbl_title = Label:create()
            lbl_title:setText( MailTitle )
            lbl_title:setFontSize(24)
            lbl_title:setColor( ccc3(204,167,108) )
            lbl_title:setAnchorPoint( ccp(0, 1) )
            lbl_title:setPosition( ccp(-90, 0) )
        imageViewBG:addChild( lbl_title )
        scl_MailList:addChild( imageViewBG )
        cell_Y = cell_Y - cell_disY - cell_H
    end
    -- if Datanum > 0 then
    --     scl_MailList:addChild( fouceImg,123,1 )
    -- end
end
--shancu youjian 
function delFlush()
    flushDataPart()
    flushScrollViewMailList()
end



local function initPubUI( _index )
    --[[
    LabelBMFont_HuiFu = tolua.cast( Layer:getWidgetByName("LabelBMFont_HuiFu"), "LabelBMFont" )
    LabelBMFont_DelOne = tolua.cast( Layer:getWidgetByName("LabelBMFont_DelOne"), "LabelBMFont" )
    LabelBMFont_FaSong = tolua.cast( Layer:getWidgetByName("LabelBMFont_FaSong"), "LabelBMFont" )
    LabelBMFont_GuanBi = tolua.cast( Layer:getWidgetByName("LabelBMFont_GuanBi"), "LabelBMFont" )
    --]]
    lbl_HuiFu = tolua.cast( Layer:getWidgetByName("Label_HuiFu"), "Label" )
    lbl_DelOne = tolua.cast( Layer:getWidgetByName("Label_DelOne"), "Label" )
    lbl_FaSong = tolua.cast( Layer:getWidgetByName("Label_FaSong"), "Label" )
    lbl_GuanBi = tolua.cast( Layer:getWidgetByName("Label_GuanBi"), "Label" )

    local btn_close = tolua.cast( Layer:getWidgetByName("Button_close"), "Button" )
    local function btn_closeCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            
            protoSend0x0370()
            exitUI()
        end
    end
    btn_close:addTouchEventListener( btn_closeCB )
--[[
local path = {
    {["UI"] = nil, ["pic1"] = "button+7_mail_2.png", ["pic2"] = "button+7_mail_1.png", ["Imge"] = nil }, --全部
    {["UI"] = nil, ["pic1"] = "button+8_mail_2.png", ["pic2"] = "button+8_mail_1.png", ["Imge"] = nil }, --系统
    {["UI"] = nil, ["pic1"] = "button+9_mail_2.png", ["pic2"] = "button+9_mail_1.png", ["Imge"] = nil }, --玩家
}
--]]

local path = {
    {["UI"] = nil, ["pic1"] = "button1_tong_2.jpg", ["pic2"] = "button1_tong_1.jpg", ["Imge"] = nil }, --全部
    {["UI"] = nil, ["pic1"] = "button1_tong_2.jpg", ["pic2"] = "button1_tong_1.jpg", ["Imge"] = nil }, --系统
    {["UI"] = nil, ["pic1"] = "button1_tong_2.jpg", ["pic2"] = "button1_tong_1.jpg", ["Imge"] = nil }, --玩家
}

path[1]["Imge"] = tolua.cast( Layer:getWidgetByName("ImageView_QuanBu"), "ImageView" )
path[2]["Imge"] = tolua.cast( Layer:getWidgetByName("ImageView_XiTong"), "ImageView" )
path[3]["Imge"] = tolua.cast( Layer:getWidgetByName("ImageView_WanJia"), "ImageView" )
    img_QuanbuForRed = path[1]["Imge"]

    local function Img_TouchCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            
            local _img = tolua.cast(sender, "ImageView")
            if _img == path[1]["Imge"] then --全部
                if remIndex == 1 then
                    return
                end
                path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic1"] )
                remIndex = 1
            elseif _img == path[2]["Imge"] then --系统
                if remIndex == 2 then
                    return
                end
                path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic1"] )
                remIndex = 2
            elseif _img == path[3]["Imge"] then --玩家
                if remIndex == 3 then
                    return
                end
                path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic1"] )
                remIndex = 3
            end
            path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic2"] )
            flushDataPart()
            flushScrollViewMailList()
        end
    end 

    for i=1,3 do
        path[i]["Imge"]:addTouchEventListener( Img_TouchCB )
        path[i]["Imge"]:setTouchEnabled(true)
    end 
---[[
    remIndex = _index
    flushDataPart() 
    path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic2"] )
--]]    

----左右翻页
    local btn_left  = tolua.cast( Layer:getWidgetByName("Button_left"), "Button" )
    btn_left:setScaleX(-1)
    local btn_right = tolua.cast( Layer:getWidgetByName("Button_right"), "Button" )
    lbl_pageNum = tolua.cast( Layer:getWidgetByName("Label_pageNum"), "Label" )
    
    local function Btn_PageCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            
            local _btn = tolua.cast(sender, "Button")
            if _btn == btn_left then
                --todo:上一页
                if curPage == 1 then
                    return
                else
                    curPage = curPage - 1
                    flushScrollViewMailList()
                end
            elseif _btn == btn_right then
                --todo:下一页
                if curPage == maxPage then
                    return
                else
                    curPage = curPage + 1
                    flushScrollViewMailList()
                end
            end
        end
    end

    btn_left:addTouchEventListener( Btn_PageCB )
    btn_right:addTouchEventListener( Btn_PageCB )

--读写面板操作
    img_read  = tolua.cast( Layer:getWidgetByName("ImageView_Read"), "ImageView" )
    img_write = tolua.cast( Layer:getWidgetByName("ImageView_Write"), "ImageView" )
    setReadOrWrite(true)

--所有恩建的操作
    btn_dellAll   = tolua.cast( Layer:getWidgetByName("Button_delAll"), "Button" )
    btn_dellOne   = tolua.cast( Layer:getWidgetByName("Button_DelOne"), "Button" )
    local btn_newMail   = tolua.cast( Layer:getWidgetByName("Button_NewMail"), "Button" )
    btn_backMail  = tolua.cast( Layer:getWidgetByName("Button_HuiFu"), "Button" )
    local btn_SendMail  = tolua.cast( Layer:getWidgetByName("Button_FaSong"), "Button" )
    local btn_CloseMail = tolua.cast( Layer:getWidgetByName("Button_GuanBi"), "Button" )

    local function btn_CB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            
            local _btn = tolua.cast(sender, "Button")
            if _btn == btn_dellAll then
                --todo:删除全部
                --AudioEngine.playEffect(DeleteGood_Mus, false)
                Pop3_XFTiShi.enterUI(372, "确定删除所有邮件吗？", 0)
                --protoSend0x0372( 0 )
            elseif _btn == btn_dellOne then
                --todo:删除当前邮件
                if remDataIdx > 0 then
                    local data = MailListData.getMailDataFromLocalIdx(remDataIdx)
                    protoSend0x0372( data["MailId"] )
                end
            elseif _btn == btn_newMail then
                --todo:新建邮件
                setReadOrWrite(false)
            elseif _btn == btn_backMail then
                --todo:回复邮件
                writeBackEmail()
                -- setReadOrWrite(false)
            elseif _btn == btn_SendMail then
                --todo:发送邮件
                local name = TextField_WriteName:getStringValue()
                local title = TextField_WriteTitle:getStringValue()
                local body = TextField_WriteText:getStringValue()
                if string_len(name) <= 0 then
                    Pop3_TS_Result.enterUI("请输入收件人名字！")
                elseif string_len(title) <= 0 then
                    Pop3_TS_Result.enterUI("请输入邮件标题！")
                elseif string_len(body) <= 0 then
                    Pop3_TS_Result.enterUI("请输入邮件内容！")
                else
                    title, _ = ShieldWord.checkShieldWord(title) 
                    body, _ = ShieldWord.checkShieldWord(body) 
                    protoSend0x0374(name, title, body)
                end
            elseif _btn == btn_CloseMail then
                --todo:关闭写邮件
                setReadOrWrite(true)
                if #remMailTab <= 0 then
                    btn_dellOne:setTouchEnabled(false)
                    btn_backMail:setTouchEnabled(false)
                end
            end
        end
    end
    btn_dellAll:addTouchEventListener( btn_CB )
    btn_dellOne:addTouchEventListener( btn_CB )
    btn_newMail:addTouchEventListener( btn_CB )
    btn_backMail:addTouchEventListener( btn_CB )
    btn_SendMail:addTouchEventListener( btn_CB )
    btn_CloseMail:addTouchEventListener( btn_CB )


    lbl_readName = tolua.cast( Layer:getWidgetByName("Label_PlayerName"), "Label" )
    lbl_readTitle = tolua.cast( Layer:getWidgetByName("Label_MailTitle"), "Label" )
    lbl_readText = tolua.cast( Layer:getWidgetByName("Label_MailC"), "Label" )
    ScrollView_Read = tolua.cast( Layer:getWidgetByName("ScrollView_Read"), "ScrollView" )

    TextField_WriteName = tolua.cast( Layer:getWidgetByName("TextField_PlayerName"), "TextField" )
    TextField_WriteTitle= tolua.cast( Layer:getWidgetByName("TextField_mailTitle"), "TextField" )
    TextField_WriteText = tolua.cast( Layer:getWidgetByName("TextField_mailC"), "TextField" )

    TextField_WriteText:setPlaceHolder("只能输入100个字符")
    TextField_WriteText:setMaxLength(100)
    TextField_WriteText:setMaxLengthEnabled(true)
--滑动层
    scl_MailList = tolua.cast( Layer:getWidgetByName("ScrollView_MailList"), "ScrollView" )
    flushScrollViewMailList()
end

function exitUI()
    if Layer ~= nil and widget ~= nil then
        --Layer:removeWidget(widget)
        Layer:clear()
        widget = nil
        Layer = nil
        
        LM.STATE_3 = 0
    end
    if LM.STATE_9 == 1 then
        MapPubUI.setPubVisible(true)
    elseif LM.STATE_9 == 2 then
        GuoZhan_MainUI.setPubVisible(true)
    end

    ifclickable = true

    MapPubUI.checkIfRedPointOnMail()
    GuoZhan_MainUI.checkIfRedPointOnMail()
    --MapPubUI.closeEmailTips()
end

function enterUI(_index)
    LM.clearLayer3ToUI()

    LM.STATE_3 = UI_Mail

    Layer = LM.getLayer3()
    widget = GUIReader:shareReader():widgetFromJsonFile("Mail_Base.json")    

    Layer:addWidget(widget)
    widget:setTouchEnabled(true) --底层的widget设置为true，阻断点击事件的穿透

    if LM.STATE_9 == 1 then
        MapPubUI.setPubVisible(false)
    elseif LM.STATE_9 == 2 then
        GuoZhan_MainUI.setPubVisible(false)
    end


    initPubUI( _index)
end

