module ("MapFight_Result",package.seeall)
--将领更改训练模式的3级UI
local curScene = nil
local curLayer = nil
local widget = nil

local _from = 0

local lbl_JiangLiTitle = nil
local  lbl_ShiBaiTitle =  nil
--[[
    local GoodsColorTab = {
        {255, 255, 255},
        {33, 143, 255},
        {0, 255, 90},
        {234, 255, 0},
        {255, 0, 0 },
        {167, 19, 252},
    }
--]]
function exitUI()
	if curLayer ~= nil and widget ~= nil then
		curLayer:removeWidget(widget)
		widget 		= nil
		curLayer 	= nil
		LM.STATE_18 = 0
	end
end
--function enterUI(scene, fatherUI, Fight_Type) --战争类型 Fight_Type  =0 表示一般战斗  =2 表示军团战
function enterUI(Fight_Type)
    LM.STATE_18 = UI_Fight_OverUi	
    curLayer = LM.getLayer18()

    

    widget = GUIReader:shareReader():widgetFromJsonFile("FightResult.json")  

    curLayer:addWidget(widget)
    widget:setTouchEnabled(true)

	local rewardTag = {}
    local img_result_1 	= tolua.cast( curLayer:getWidgetByName("ImageView_result1"), "ImageView" )
    local img_result_2 	= tolua.cast( curLayer:getWidgetByName("ImageView_result2"), "ImageView" )


    lbl_JiangLiTitle = tolua.cast( curLayer:getWidgetByName("Label_JiangLiTitle"), "Label" )
    lbl_ShiBaiTitle = tolua.cast( curLayer:getWidgetByName("Label_ShiBaiTitle"), "Label" )

    rewardTag[1] = tolua.cast( curLayer:getWidgetByName("Label_jiangli_1"), "Label" )
    rewardTag[2] = tolua.cast( curLayer:getWidgetByName("Label_jiangli_2"), "Label" )
    rewardTag[3] = tolua.cast( curLayer:getWidgetByName("Label_jiangli_3"), "Label" )
    for i=1,3 do
    	rewardTag[i]:setVisible(false)
    end

    local   myLostTitle =   tolua.cast( curLayer:getWidgetByName("Label_MyLostTitle"), "Label" )
    local   heLostTitle =   tolua.cast( curLayer:getWidgetByName("Label_HeLostTitle"), "Label" )


    local lbl_myLost 	= tolua.cast( curLayer:getWidgetByName("Label_mylost"), "Label" )
    local lbl_herLost 	= tolua.cast( curLayer:getWidgetByName("Label_helost"), "Label" )

    local btn_chongbo 	= tolua.cast( curLayer:getWidgetByName("Button_chongbo"), "Button" )
    local btn_tuichu 	= tolua.cast( curLayer:getWidgetByName("Button_tuichu"), "Button" )
   	btn_tuichu:setPosition(ccp(UseW, 0))
    local btn_ZaiLaiYiCi= tolua.cast( curLayer:getWidgetByName("Button_zailaiyici"), "Button" )


	local btn_WuJiangXunLian 	= tolua.cast( curLayer:getWidgetByName("Button_WuJiangXunLian"), "Button" )
    local btn_NvShenShengJi 	= tolua.cast( curLayer:getWidgetByName("Button_NvShenShengJi"), "Button" )
    local btn_ZhuangBeiQiangHua 	= tolua.cast( curLayer:getWidgetByName("Button_ZhuangBeiQiangHua"), "Button" )
    local btn_KeJi 	= tolua.cast( curLayer:getWidgetByName("Button_KeJi"), "Button" )
    --默认是隐藏，只有攻打普通npc失败才显示
    btn_WuJiangXunLian:setTouchEnabled(false)
    btn_WuJiangXunLian:setVisible(false)

    btn_NvShenShengJi:setTouchEnabled(false)
    btn_NvShenShengJi:setVisible(false)

    btn_ZhuangBeiQiangHua:setTouchEnabled(false)
    btn_ZhuangBeiQiangHua:setVisible(false)

    btn_KeJi:setTouchEnabled(false)
    btn_KeJi:setVisible(false)
    --默认再来一次是隐藏，只有攻打普通npc才显示
    btn_ZaiLaiYiCi:setTouchEnabled(false)
    btn_ZaiLaiYiCi:setVisible(false)

    local function btnCallback( sender, eventType )
    	if eventType == PT.ccs.TouchEventType.ended then
			local _btn = tolua.cast(sender, "Button")
			_btn:setTouchEnabled(false)
			if _btn == btn_WuJiangXunLian then 	--武将训练
                 if CityData.canOpenFuncByIndex(5) then
                 	LM.exitNormFightGround()
					Pop3_ZhengZhan.exitUI()
					GeneralBase.enterUI(1)

                else
                    Pop3_TS_Result.enterUI("此功能暂未开启") 
                end
			elseif _btn == btn_NvShenShengJi then  --女神升级
                if CityData.canOpenFuncByIndex(18) then
                	LM.exitNormFightGround()
					Pop3_ZhengZhan.exitUI()
	
					NvShenBaseA.enterUI(1)
                else
                    Pop3_TS_Result.enterUI("此功能暂未开启") 
                end
			elseif _btn == btn_ZhuangBeiQiangHua then  --装备强化
                if CityData.canOpenFuncByIndex(14) then
                	LM.exitNormFightGround()
					Pop3_ZhengZhan.exitUI()
					BeiBaoBase.enterUI(2)

                else
                    Pop3_TS_Result.enterUI("此功能暂未开启") 
                end
			elseif _btn == btn_KeJi then --将领 --科技

                if CityData.canOpenFuncByIndex(10) then
                	LM.exitNormFightGround()
					Pop3_ZhengZhan.exitUI()
					GNR_KeJi.enterUI()

                else
                    Pop3_TS_Result.enterUI("此功能暂未开启") 
                end
			end
		end

	end
    btn_WuJiangXunLian:setPressedActionEnabled(true)
    btn_NvShenShengJi:setPressedActionEnabled(true)
    btn_ZhuangBeiQiangHua:setPressedActionEnabled(true)
    btn_KeJi:setPressedActionEnabled(true)

    btn_WuJiangXunLian:addTouchEventListener( btnCallback )
	btn_NvShenShengJi:addTouchEventListener( btnCallback )
	btn_ZhuangBeiQiangHua:addTouchEventListener( btnCallback )
	btn_KeJi:addTouchEventListener( btnCallback )

	local result, mylost, helost = 0,0,0
	if Fight_Type == 0 then
		result, mylost, helost = MapFightData.getFightResult()
		print("game over result == " .. result)
		--img_result:loadTexture( resultImgPath[result+1] )
		local  _t = result+1
		img_result_1:loadTexture(resultImgPath[_t][1])
		img_result_2:loadTexture(resultImgPath[_t][2])

		lbl_myLost:setText( mylost )
		lbl_herLost:setText( helost )
		local ifZhanBao = FormationData.getReportState()
		if ifZhanBao == false then 
			if LM.STATE_2 == UI_GuanKa_PuTong and LM.STATE_10 == UI_ZhengZhan_PuTongNpc_Pop then --征战 普通npc
				btn_ZaiLaiYiCi:setTouchEnabled(true)
	    		btn_ZaiLaiYiCi:setVisible(true)

				if result == 0 or result == 6 or result == 7 or 
									result == 8 or result == 9 or result == 10 then --失败

				    btn_WuJiangXunLian:setTouchEnabled(true)
				    btn_WuJiangXunLian:setVisible(true)

				    btn_NvShenShengJi:setTouchEnabled(true)
				    btn_NvShenShengJi:setVisible(true)

				    btn_ZhuangBeiQiangHua:setTouchEnabled(true)
				    btn_ZhuangBeiQiangHua:setVisible(true)

				    btn_KeJi:setTouchEnabled(true)
				    btn_KeJi:setVisible(true)

				    lbl_JiangLiTitle:setVisible(false)
					lbl_ShiBaiTitle:setVisible(true)
				    AudioEngine.playEffect("4_20.wav", false) --失败音效
				else
					lbl_JiangLiTitle:setVisible(true)
					lbl_ShiBaiTitle:setVisible(false)
					AudioEngine.playEffect("4_19.wav", false) --胜利音效
				end
			elseif LM.STATE_2 == UI_ShiJie_QuYu then --世界征服
				lbl_JiangLiTitle:setVisible(true)
				lbl_ShiBaiTitle:setVisible(false)
				AudioEngine.playEffect("4_19.wav", false)	
			else
				lbl_JiangLiTitle:setVisible(true)
				lbl_ShiBaiTitle:setVisible(false)
				AudioEngine.playEffect("4_19.wav", false)			
			end
		else
			lbl_JiangLiTitle:setVisible(true)
			lbl_ShiBaiTitle:setVisible(false)
		end

	end

	local rewardData = FightRewardData.getReWardDataList()
	local rewardNum = #rewardData
	print("rewardNum === " .. rewardNum)
	if rewardNum > 3 then
		print("获取奖励大于3个请修改UI 。。。 ")
		return
	end

    ---[[
	for i=1, rewardNum do
		local data = rewardData[i]
		local _type = data["Type"]
		local _getNumOrId = data["NumOrId"] 
		local str = nil
		local colorIdx = 1
		if _type == 0 then--0为银币
			str =  _getNumOrId .. "银币"

		elseif _type == 1 then--1为金币
			str =  _getNumOrId .. "金币"

		elseif _type == 2 then--2为粮草
			str =  _getNumOrId .. "粮草"
		elseif _type == 3 then--3为军功
			str =  _getNumOrId .. "军功"
		elseif _type == 4 or _type == 5 then--4为挑战npc过关奖励--5为首次过关卡奖励
			local goodsDes = Des.getGoodsDesFromId( _getNumOrId )
			str = goodsDes["goodsName"]
			colorIdx = goodsDes["goodsQuality"]
		elseif _type == 6 then--6为将领
			local generalDes = Des.getGeneralDesFromId( _getNumOrId )
			str = generalDes["generalName"]
		elseif _type == 7 then--7为军令
			str =  _getNumOrId .. "军令"
		elseif _type == 8 then--8为荣誉
			str =  _getNumOrId .. "威望"
		elseif _type == 9 then--9为民忠

		elseif _type == 10 then--10为农场

		elseif _type == 11 then--11为铁矿

		elseif _type == 100 then--pvp 玩家城防值减少
			str = data["Str"]
		end

		rewardTag[i]:setText(str)
		rewardTag[i]:setVisible(true)

		AudioEngine.playEffect("4_4.wav", false)
		--print( "colorIdx === " .. colorIdx )
		--print("i === " .. i)
		local r = GoodsColorTab[colorIdx][1]
		local g = GoodsColorTab[colorIdx][2]
		local b = GoodsColorTab[colorIdx][3]
		rewardTag[i]:setColor(ccc3( r, g, b ))
	end

	local function btn_touch(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			local _btn = tolua.cast(sender, "Button")
			print("result btn_touch")
			if _btn == btn_chongbo then --重播
				exitUI()
				if Fight_Type == 0 then
					MapFight.fightBegin(true)
				elseif Fight_Type == 1 then
					MapJunTuanFight.clearZhanghaoData()
					MapJunTuanFight.rePlayJunTuanNpcFight()
				end
				--[[
				if Fight_Type == 1 then --重播军团npc战斗
					MapJunTuanFight.clearZhanghaoData()
					MapJunTuanFight.rePlayJunTuanNpcFight()
				elseif Fight_Type == 0 then
				 --重播普通战斗
					MapFight.fightBegin(true)
				elseif Fight_Type == 2 then
					print("军团战")
					JTZ_JunTuanFight.replayJUnTuanZhan()
				end
				--]]
			elseif _btn == btn_tuichu then --退出
				btn_tuichu:setTouchEnabled(false)
				if Fight_Type == 0 then
					LM.exitNormFightGround()
					Pop3_ZhengZhan.exitUI()
					if GK_CharpterPass.setTongGuanVisible(true) then --直接进行新手引导
						guideFactory.CheckGuideProcess( LM.STATE_2 )
						Pop3_GetNewJeneral.enterUI()
					else --关卡通关动画关闭新手引导
						guideFactory.clearAllTypeUi()
					end

					
					if LM.STATE_2 == UI_GuanKa_PuTong then
						GK_PuTong.flushGuanKaPuTongScrollView()
					end
				elseif Fight_Type == 1 then
					exitUI()
					MapJunTuanFight.exitUI()
				end

				FightRewardData.ClearReWardDataList()
				print("退出战斗结果ui.....")
				--[[
				guideFactory.clearAllTypeUi()
				CCDirector:sharedDirector():getScheduler():setTimeScale(1)
				GeneralData.getOutDataFormPool()
				FightRewardData.ClearReWardDataList()
				print("fatherUI == " .. fatherUI)
				if fatherUI == UI_ZhengZhan then
					MapPubUI.enterUI( UI_ZhengZhan )
				elseif fatherUI == UI_ZhuCheng then
					MapPubUI.enterUI( UI_ZhuCheng )
				elseif fatherUI == UI_ShiJie_QuYu then
					--MapShiJie_QuYu.enterUI()
					MapPubUI.enterUI( UI_ShiJie )
				elseif fatherUI == UI_NongTian then --进入农田
					MapPubUI.enterUI(UI_NongTian)
				elseif fatherUI == UI_YinKuang then --进入银矿
					MapPubUI.enterUI(UI_YinKuang)
				elseif fatherUI == UI_GuoZhan_MainUI then --进入国战
					MapPubUI.enterUI(UI_GuoZhan_MainUI)
				elseif fatherUI == UI_JunTuanZhan_ZhanDou then
					JTZ_JunTuanFight.clearZhanChang()
					exitUI()
				elseif fatherUI == UI_ZhengZhan_PuTongNpc_Pop then
					MapPubUI.enterUI( UI_ZhengZhan )
				elseif fatherUI == UI_SJ_ZhanBao then
					local uiState = Map_Pop3_SJZhanhao.getRemFatherUi()
					MapPubUI.enterUI( uiState )
				-- elseif fatherUI == UI_JunTuan_Report then
				-- 	print("UI_JunTuan_Report"..UI_JunTuan_Report)
				-- 	removeLayer()
				-- 	JTZZhanbaoFight.exitUI()
				-- 	print("PT.UI_State状态"..PT.UI_State)
				-- 	if PT.UI_State == UI_JunTuanZhan_JieGuo or PT.UI_State == UI_JunTuanZhan_ZhanDou then
				-- 		AudioEngine.playMusic("1_6.wav",true)
				-- 	else
				-- 		AudioEngine.playMusic("1_5.wav",true)
				-- 	end
				end
				--]]
				
			elseif _btn == btn_ZaiLaiYiCi then
				LM.exitNormFightGround()
			end
		end
	end
	btn_chongbo:addTouchEventListener( btn_touch )
	btn_tuichu:addTouchEventListener( btn_touch )
	btn_ZaiLaiYiCi:addTouchEventListener( btn_touch )
--[[	
	if fatherUI == UI_NongTian or 
		fatherUI== UI_YinKuang or 
		fatherUI == UI_SJ_ZhanBao or 
		fatherUI == UI_GuoZhan_MainUI or 
		fatherUI == UI_JunTuanZhan_ZhanDou then

		btn_ZaiLaiYiCi:setVisible(false)
		btn_ZaiLaiYiCi:setTouchEnabled(false)
	end
--]]

	guideFactory.CheckGuideProcess( LM.STATE_18 )
end
