module ("Pop3_GuoKu",package.seeall)
--主城升级的3级弹出界面
--local curScene = nil
local curLayer = nil
local widget = nil
--local remFatherUi = nil

local armature = nil
--[[
1主城
2民居
3仓库
4军机处
5校场
6商店
7驿站
--]]

function initPopPanel( _cityId)

	local img_city = tolua.cast( curLayer:getWidgetByName("ImageView_CityPic"), "ImageView" )
img_city:setRotation(0)
--img_city:setScale(1)
	local btn_close = tolua.cast( curLayer:getWidgetByName("Button_close"), "Button" )
	local btn_shengJi = tolua.cast( curLayer:getWidgetByName("Button_shengji"), "Button" )

	local lbl_lv 		= tolua.cast( curLayer:getWidgetByName("Label_lv"), "Label" )
	local lbl_miaoshu  	= tolua.cast( curLayer:getWidgetByName("Label_miaoshu"), "Label" )
	local lbl_strLv  	= tolua.cast( curLayer:getWidgetByName("Label_strLv"), "Label" )

	--升级所需金币和时间
	local lbl_UpZeny = tolua.cast( curLayer:getWidgetByName("Label_UpZeny"), "Label" )
	local lbl_UpTime = tolua.cast( curLayer:getWidgetByName("Label_UpTime"), "Label" )

	local cityData = CityData.getCityDataFromId( _cityId )
	lbl_lv:setText( cityData["Lv"] )
	lbl_strLv:setText("国库 " .. cityData["Lv"] .. " 级")
	local cityDes = Des.getBuildDesFromId( _cityId )
	lbl_miaoshu:setText( cityDes["buildDes"] )

	local curZeny =	PlayerData.getZeny()
	if curZeny < cityData["UpZeny"] then
		lbl_UpZeny:setColor( ccc3(255, 0, 0) )
	else
		lbl_UpZeny:setColor( ccc3(255, 255, 255) )
	end

	lbl_UpZeny:setText( cityData["UpZeny"] .. "银币" )
	local _fen, _ = math_modf( cityData["UpTime"]/60 )
	lbl_UpTime:setText( _fen .. "分钟" )


	local function pubBtnCB(sender, eventType)
		local _btn = tolua.cast(sender, "Button")
		if eventType == PT.ccs.TouchEventType.ended then 
			RW_guide.exitUI()--关闭任务引导
			print("close here")
			if _btn == btn_close then
				--PT.UI_State = remFatherUi
				exitUI()
			elseif _btn == btn_shengJi then
if ifserver then
				protoSend0x0218( 3 )
end			
			end
		end
	end

	btn_close:addTouchEventListener(pubBtnCB)
	btn_shengJi:addTouchEventListener(pubBtnCB)


	if armature == nil then
		local effectIMg = tolua.cast( curLayer:getWidgetByName("ImageView_b"), "ImageView" )
		
		armature =  ArmatureManager.createArmature( UiEffectPath, "UI_ShengJi", 1  )
		--armature:getAnimation():playWithIndex(0,-1, -1, -1)
		armature:setPosition(ccp(10, 123))
		armature:setZOrder(3)
		armature:setTag(10)
		effectIMg:addNode(armature)
	else
		armature:getAnimation():playWithIndex(0,-1, -1, -1)
	end
end

function exitUI()
	if curLayer ~= nil and widget ~= nil then
		curLayer:removeWidget(widget)
		widget = nil
		curLayer = nil
		
		LM.STATE_3 = 0
	end
	MapPubUI.setPubVisible(true)
	armature = nil
end

function enterUI(_cityId)
	LM.STATE_3 = UI_City_GuoKu

	curLayer = LM.getLayer3()
	widget = GUIReader:shareReader():widgetFromJsonFile("ShouYe_Pop3_GuoKu.json")

    curLayer:addWidget(widget)
    widget:setTouchEnabled(true)
    MapPubUI.setPubVisible(false)
    armature = nil
    initPopPanel( _cityId)
end
