module ("Pop3_JunXieKu",package.seeall)
--主城升级的3级弹出界面
--local curScene = nil
local curLayer = nil
local widget = nil
--local remFatherUi = nil

local armature = nil
--[[
1主城
2民居
3国库
4军机处
5校场
6军械处
7驿站
--]]

function initPopPanel( _cityId)

	local img_city = tolua.cast( curLayer:getWidgetByName("ImageView_CityPic"), "ImageView" )
--img_city:setRotation(0)
img_city:setScaleX(-1)
	local btn_close = tolua.cast( curLayer:getWidgetByName("Button_close"), "Button" )
	local btn_shengJi = tolua.cast( curLayer:getWidgetByName("Button_shengji"), "Button" )

	local btn_beibao = tolua.cast( curLayer:getWidgetByName("Button_beibao"), "Button" )
	local btn_qianghua = tolua.cast( curLayer:getWidgetByName("Button_qianghua"), "Button" )
	local btn_weipai = tolua.cast( curLayer:getWidgetByName("Button_weipai"), "Button" )
	--[[
	btn_beibao:setIfPixelTouch(true)
	btn_qianghua:setIfPixelTouch(true)
	btn_weipai:setIfPixelTouch(true)
	--]]
	local lbl_lv 		= tolua.cast( curLayer:getWidgetByName("Label_lv"), "Label" )
	local lbl_miaoshu  	= tolua.cast( curLayer:getWidgetByName("Label_miaoshu"), "Label" )
	local lbl_strLv  	= tolua.cast( curLayer:getWidgetByName("Label_strLv"), "Label" )

	--升级所需金币和时间
	local lbl_UpZeny = tolua.cast( curLayer:getWidgetByName("Label_UpZeny"), "Label" )
	local lbl_UpTime = tolua.cast( curLayer:getWidgetByName("Label_UpTime"), "Label" )

	local cityData = CityData.getCityDataFromId( _cityId )
	lbl_lv:setText( cityData["Lv"] )
	lbl_strLv:setText("军械库 " .. cityData["Lv"] .. " 级")
	local cityDes = Des.getBuildDesFromId( _cityId )
	lbl_miaoshu:setText( cityDes["buildDes"] )

	local curZeny =	PlayerData.getZeny()
	if curZeny < cityData["UpZeny"] then
		lbl_UpZeny:setColor( ccc3(255, 0, 0) )
	else
		lbl_UpZeny:setColor( ccc3(255, 255, 255) )
	end

	lbl_UpZeny:setText( cityData["UpZeny"] .. "银币" )
	local _fen, _ = math_modf( cityData["UpTime"]/60 )
	lbl_UpTime:setText( _fen .. "分钟" )

	local function pubBtnCB(sender, eventType)
		local _btn = tolua.cast(sender, "Button")
		if eventType == PT.ccs.TouchEventType.ended then 
			RW_guide.exitUI()--关闭任务引导
			print("close here")
			if _btn == btn_close then  --关闭
				--PT.UI_State = remFatherUi
				exitUI()
				guideFactory.CheckGuideProcess(nil)
			elseif _btn == btn_shengJi then --升级
if ifserver then
				protoSend0x0218( 6 )
end			
			elseif _btn == btn_beibao then --背包
				--[[
				PT.UI_State = remFatherUi
				BeiBaoBase.enterUI(curScene, 1 )
				exitUI()
				--]]
				exitUI()
				BeiBaoBase.enterUI( 1 )
			elseif _btn == btn_qianghua then --强化
				--[[
				PT.UI_State = remFatherUi
				BeiBaoBase.enterUI( curScene,3 )
				exitUI()
				--]]
				exitUI()
				BeiBaoBase.enterUI( 2 )
			elseif _btn == btn_weipai then --委派
				--[[
				PT.UI_State = remFatherUi
				BeiBaoBase.enterUI( curScene,4 )
				exitUI()
				--]]
				exitUI()
				BeiBaoBase.enterUI( 3 )
			end
		end
	end

	btn_close:addTouchEventListener(pubBtnCB)
	btn_shengJi:addTouchEventListener(pubBtnCB)
	btn_beibao:addTouchEventListener(pubBtnCB)
	btn_qianghua:addTouchEventListener(pubBtnCB)
	btn_weipai:addTouchEventListener(pubBtnCB)
--判断是否开启
	if armature == nil then
		local effectIMg = tolua.cast( curLayer:getWidgetByName("ImageView_b"), "ImageView" )
	
		armature =  ArmatureManager.createArmature( UiEffectPath, "UI_ShengJi", 1  )
		--armature:getAnimation():playWithIndex(0,-1, -1, -1)
		armature:setPosition(ccp(10, 123))
		armature:setZOrder(3)
		effectIMg:addNode(armature)
	else
		armature:getAnimation():playWithIndex(0,-1, -1, -1)
	end
	local openBtn={}
	local btnTable=
	{
		{["id"]=12,["btn"]=btn_beibao},
		{["id"]=14,["btn"]=btn_qianghua},
		{["id"]=15,["btn"]=btn_weipai},	
	}
	for i=1, #btnTable do
		PT.hideManyBtn(openBtn,btnTable[i]["id"],btnTable[i]["btn"])
	end

	for i=1,#openBtn do
		openBtn[i]:setPosition(ccp(-281+127*(i-1),-141))
	end
end

function exitUI()
	if curLayer ~= nil and widget ~= nil then
		curLayer:removeWidget(widget)
		widget = nil
		curLayer = nil
		
		LM.STATE_3 = 0
	end
	MapPubUI.setPubVisible(true)
	armature = nil
end

function enterUI(_cityId)
	LM.STATE_3 = UI_City_JunXieSuo

	curLayer = LM.getLayer3()
	widget = GUIReader:shareReader():widgetFromJsonFile("ShouYe_Pop3_JunXieKu.json")

    curLayer:addWidget(widget)
    widget:setTouchEnabled(true)
 	MapPubUI.setPubVisible(false)
    armature = nil
 	initPopPanel( _cityId)

 	guideFactory.CheckGuideProcess( LM.STATE_3 )
end
