module ("Pop3_MTPeaple",package.seeall)
--我得将领选择三级页面
local curScene = nil
local curLayer = nil
local exiteUI = nil
local function initPopPanel( _withUI, _curzhenxing )

	local btn_close = tolua.cast( curLayer:getWidgetByName("Button_close"), "Button" )
	local function btn_closeCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then 
			 
			exiteUI()
		end
	end
	btn_close:addTouchEventListener( btn_closeCB )
--------------------------------------------------------
	local _scrollview = tolua.cast( curLayer:getWidgetByName("ScrollView_RoleList"), "ScrollView" )
	_scrollview:setClippingEnabled(true) --裁切窗口
	_scrollview:setBounceEnabled(true) --边缘回弹
	
	local cell_disY = 2
	local cell_disX = 2
		--可视区域
	local view_W = _scrollview:getSize().width 
	local view_H = _scrollview:getSize().height 

	local Datanum = 20
	local genIndxData = nil
    if ifserver then
	    --Datanum = GeneralData.getYesGeneralDataNum()
	    genIndxData, _ = GeneralData.getYesGenearalIndxDataAndNumOnThePos(_curzhenxing)
	    Datanum = #genIndxData
    end  
	local lieNum = 5
	local hangNum = math.ceil(Datanum/lieNum)
	local cell_W, cell_H = 119, 136
	_scrollview:setInnerContainerSize( CCSize(view_W, cell_H*hangNum) )
	--滑动区域
	local scroll_W = _scrollview:getInnerContainerSize().width
	local scroll_H = _scrollview:getInnerContainerSize().height
	local cell_X, cell_Y = cell_W/2, scroll_H-cell_H/2

	local function CellTouchCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			 guideFactory.CheckGuideProcess(nil)
			local _img = tolua.cast(sender, "ImageView")
			local tag = _img:getTag()
			if _withUI == 1  then --布阵UI
				GNR_BuZhen.resetLocalOnthePos(tag)
			elseif _withUI == 2 then --战场UI
				Pop3_ZhengZhan.resetLocalOnthePos(tag)
			end
			exiteUI()
		end
	end

	for i=1, hangNum do
		for j=1, lieNum do
			local idx =  (i-1)*lieNum+j
			if idx > Datanum then
				return
			end

			local data = nil
			local desData = nil
--			local ifOn = false --这个将领是否已经在这个阵型上了
if ifserver then
			data =  GeneralData.getYesGeneralDataFromIndex( genIndxData[idx] )
end

			local Img_Head = ImageView:create()
	if ifserver then
			desData = Des.getGeneralDesFromId( data["GenneralId"] )
			Img_Head:loadTexture( RoleHeadPath .. desData["generalHeadIcon"] .. ".png" )
			Img_Head:setTag( genIndxData[idx] )
	else
			Img_Head:loadTexture("1.png")
			Img_Head:setTag( idx )
	end
    		Img_Head:setPosition( ccp(cell_X, cell_Y) )
    		Img_Head:addTouchEventListener( CellTouchCB )
--[[    		
    		if ifOn then
    			Img_Head:setTouchEnabled(false)
    		else
--]]
				Img_Head:setTouchEnabled(true)
--			end
    			local Img_Kuang = ImageView:create()
				Img_Kuang:loadTexture("rim+2_public.png")
    			Img_Kuang:setPosition( ccp(0, -10) )
    		Img_Head:addChild( Img_Kuang )

		   		local _lbl = Label:create()
	if ifserver then
				_lbl:setText( desData["generalName"] )
	else
		   		_lbl:setText( "武将名字")
	end
		   		_lbl:setPosition( ccp(0, -48) )
		   	Img_Head:addChild(_lbl)
--[[	
			if ifOn then
			    local Img_ifon = ImageView:create()
				Img_ifon:loadTexture("floor+17_public_2.png")
    			Img_ifon:setPosition( ccp(30, -50) )	
    		Img_Head:addChild( Img_ifon )
			end
--]]
		   	_scrollview:addChild( Img_Head )

		   	cell_X = cell_X + cell_W + cell_disX

		end
		cell_X = cell_W/2
		cell_Y = cell_Y - cell_disY - cell_H
	end


end

function enterUI(scene, _witchUi, _curzhenxing)

	curScene = scene
   	local widget = GUIReader:shareReader():widgetFromJsonFile("MyTeamRole_Pop3.json")    
	
	widget:setTouchEnabled(true)
	
	curLayer = TouchGroup:create()
	curLayer:setZOrder(13)
    curLayer:addWidget(widget)
    scene:addChild(curLayer)

    initPopPanel( _witchUi, _curzhenxing )

    guideFactory.CheckGuideProcess(nil)

end
exiteUI = function ()
	curScene:removeChild(curLayer, true)
end