module ("Pop3_SaoDang",package.seeall)

local Layer = nil
local _widget = nil 
local scene = nil
local pre_UI = 1

local btn_guanbi  = nil --关闭
local btn_kaishi  = nil --开始
local btn_jia     = nil --加
local btn_jian    = nil --减
local slid_bar = nil --滑动条
local load_bar = nil --

local lbl_time = 1  --扫荡次数

local rem_size = 0 --记录当前的数量

local function refresh_state()

end 



local function initMap()
    local charpterId, npcId, _ = PT.getId()
    local maxTime = 0
    local data = nil
        
    if charpterId == -1 then
        data = NpcListData.getNpcDataFromId( npcId, true )
    else
        data = NpcListData.getNpcDataFromId( npcId, false )
    end
    --if data["BeatMax"] ~= -1 then
    if data["BeatMax"] ~= 0 then
        --lbl_leftNum:setText( data["BeatMax"]-data["BeatNum"] )
        print("==" ..  data["BeatMax"] .. "==" .. data["BeatNum"])
        maxTime = data["BeatMax"]-data["BeatNum"] 
    else
        --lbl_leftNum:setText("无限制")
        maxTime = 1000
    end

    local orders = PlayerData.getOrders()
    print("orders == " .. orders)
    if orders < maxTime then
        maxTime = orders
    end
    local function btnCallback(sender, eventType)            
        if eventType == PT.ccs.TouchEventType.ended then
        	local _btn = tolua.cast(sender, "Button")
        	local tag = _btn:getTag()        	
            print("tag === " .. tag)
            
            if _btn == btn_guanbi then
                exitUI()
            elseif _btn == btn_kaishi then
                ---[[
                local timenum = lbl_time:getStringValue()
                local num = tonumber(timenum)
                
                if num > 0 then
                    MapFight.setFartherUI(UI_ZhengZhan_PuTongNpc_Pop)
                    exitUI()
                    local npcOnlyId =NpcListData.getNpcOnlyIdFromId(npcId)
                    if charpterId == -1 then
                        --protoSend0x0338(3, charpterId, npcId,0,num)
                        protoSend0x0338(3, charpterId, npcOnlyId,0,num)
                    else
                       --protoSend0x0338(2, charpterId, npcId,0,num)
                        protoSend0x0338(2, charpterId, npcOnlyId,0,num)
                    end
                    Pop3_SaoDangNpcResult.enterUI(  )
                    Loading:LoadingHide()
                    MapZhengZhan.openSaoDang()
                else
                    --todo:提示扫荡次数不足

                end
                --]]
            elseif _btn == btn_jia then
                rem_size = rem_size + 1
                if rem_size >= maxTime then
                    rem_size = maxTime
                end
                local percent = rem_size*(93-7)/(maxTime-0) + 7
                if percent > 93 then
                    percent = 93  
                end
                slid_bar:setPercent(percent)
                load_bar:setPercent( percent )
                lbl_time:setText(rem_size)
                print("====" .. rem_size .. "=" .. maxTime .. "=" .. percent)
                --[[
                local percent = slid_bar:getPercent()
                percent = percent + 1
                if percent > 90 then
                    percent = 90  
                end
                slid_bar:setPercent(percent)
                load_bar:setPercent( percent )
                local size = 0
                size = 0 + (maxTime-0)*(percent-10)/(90-10)
                size = math_floor(size)
                lbl_time:setText(size)
                --]]
            elseif _btn == btn_jian then
                rem_size = rem_size - 1
                if rem_size <= 0 then
                    rem_size = 0
                end
                local percent = rem_size*(93-7)/(maxTime-0) + 7
                if percent < 7 then
                    percent = 7  
                end
                slid_bar:setPercent(percent)
                load_bar:setPercent( percent )
                lbl_time:setText(rem_size)
                --[[
                local percent = slid_bar:getPercent()
                percent = percent -1
                if percent < 10 then
                    percent = 10
                end
                slid_bar:setPercent(percent)
                load_bar:setPercent( percent )
                local size = 0
                size = 0 + (maxTime-0)*(percent-10)/(90-10)
                size = math_floor(size)
                lbl_time:setText(size)
                --]]
            end
    	end
    end

    btn_guanbi = tolua.cast(Layer:getWidgetByName("Button_GuanBi"), "Button" )
    btn_kaishi = tolua.cast(Layer:getWidgetByName("Button_KaiShiSaoDang"), "Button" )
    btn_jia = tolua.cast(Layer:getWidgetByName("Button_Jia"), "Button" )
    btn_jian = tolua.cast(Layer:getWidgetByName("Button_Jian"), "Button" )
   
    slid_bar = tolua.cast(Layer:getWidgetByName("Slider_bar"), "Slider" )
    load_bar = tolua.cast(Layer:getWidgetByName("LoadingBar_bar"), "LoadingBar" )

    lbl_time = tolua.cast(Layer:getWidgetByName("Label_CiShuNum"), "Label" )


    btn_guanbi:setTouchEnabled(true)
    btn_kaishi:setTouchEnabled(true)
    btn_jia:setTouchEnabled(true)
    btn_jian:setTouchEnabled(true)

    btn_guanbi:addTouchEventListener(btnCallback)
    btn_kaishi:addTouchEventListener(btnCallback)
    btn_jia:addTouchEventListener(btnCallback)
    btn_jian:addTouchEventListener(btnCallback)
    
    local function percentChangedEvent(sender,eventType)
        
        local slider = tolua.cast(sender,"Slider")
        local percent = slider:getPercent()
        
        if eventType == PT.ccs.SliderEventType.percent_changed then    
            if percent< 7 then
                percent = 7
            elseif percent > 93 then
                percent = 93
            end
            slider:setPercent(percent)
            load_bar:setPercent( percent )
            
            rem_size = 0 + (maxTime-0)*(percent-7)/(93-7)
            rem_size = math_floor(rem_size)
            lbl_time:setText(rem_size)
        end
    end
    slid_bar:addEventListenerSlider( percentChangedEvent )

    slid_bar:setPercent(7)
    load_bar:setPercent( 7 )
    rem_size = 0
    lbl_time:setText(rem_size)

    refresh_state()
end

function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        --Layer:clear()
        _widget = nil
        Layer = nil
        
        LM.STATE_11 = 0
    end
end

function enterUI()
    LM.STATE_11 = UI_Fight_SaoDang

    Layer = LM.getLayer11()
    _widget = GUIReader:shareReader():widgetFromJsonFile("Pop3_SaoDang.json")

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)

    initMap()
end


--[[
function exitUI()
    PT.UI_State = pre_UI 
    if Layer ~= nil then 
       scene:removeChild(Layer, true)
       Layer = nil
    end 
end
function enterUI(curScene)
    scene = curScene
    pre_UI =  PT.UI_State 
    PT.UI_State = UI_Fight_SaoDang
    Layer = TouchGroup:create()
    Layer:setZOrder(13)
    print("saodang")
    local _widget = GUIReader:shareReader():widgetFromJsonFile("Pop3_SaoDang.json") 
    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)
 	scene:addChild(Layer)

    initMap()
end
--]]
