module ("Pop3_SaoDangResult",package.seeall)

local Layer = nil 
local _widget = nil
local scene = nil
local pre_UI = 1

local sv_result = nil
local btn_close  = nil

local _type = 2  -- 1为玩家  2为npc

local function imgCallback(sender, eventType)     
        if eventType == PT.ccs.TouchEventType.ended then
            local _btn = tolua.cast(sender, "ImageView")
            local tag = _btn:getTag()           
            print("tag === " .. tag)
            local charpterId, npcId, _ = PT.getId()
            print("charpterId is "..charpterId)
            print("npcId is "..npcId)
            
            if tag>0 then

                protoSend0x0348( _type,charpterId,npcId,tag )
            end
        end
    end

local function refresh_Scroll()
    sv_result:removeAllChildren()
    sv_result:setBackGroundColorType(0)
    local num = JTNpcRoomData.getResultNum(_type)
    
        --可视区域
    local view_W = sv_result:getSize().width 
    local view_H = sv_result:getSize().height 

    local cell_W, cell_H = 187, 30
    local cell_disY = 20
    local cell_disX = 10
    local hangNum = 10

    sv_result:setInnerContainerSize(CCSize(view_W, cell_H*num+cell_disY*num))
    local scroll_W = sv_result:getInnerContainerSize().width 
    local scroll_H = sv_result:getInnerContainerSize().height
    local cell_X, cell_Y = 30, scroll_H-cell_H/2-10
    print("num ============ " .. num)
    for i=1,num do    
        local data = JTNpcRoomData.getSaoDangResultByIndex(i,_type)        
        if data ~= nil then

            local lbl_time  = Label:create()
            lbl_time:setText("第"..i.."次扫荡")
            lbl_time:setPosition(ccp(cell_X,cell_Y))
            sv_result:addChild(lbl_time)

            local lbl_ret  = Label:create()
            print("data"..data["ret"])
            
            if data["ret"]>0 and data["ret"]<=11 then
                lbl_ret:setText("扫荡结果为:"..GuoZhanData.GuoZhan_Result[data["ret"]])
            else
                lbl_ret:setText("扫荡结果错误")
            end            
            lbl_ret:setPosition(ccp(80,0))
            lbl_time:addChild(lbl_ret)

            local lbl_jiangli = Label:create()
            local jiangli = nil
            if _type == 1 then
                jiangli = "荣誉"
            else
                jiangli = "军工"
            end
            lbl_jiangli:setText("奖励"..jiangli..",数量为:"..data["num"])
            lbl_jiangli:setPosition(ccp(195,0))
            lbl_time:addChild(lbl_jiangli)

            local jiangliwuqi  = Des.getGoodsDesFromId(data["_id"])
            if _type == 2 and jiangliwuqi~= nil then
                local lbl_jiangli  = Label:create()
                lbl_jiangli:setText("奖励的装备为:"..jiangliwuqi["goodsName"])
                lbl_jiangli:setPosition(ccp(335,0))
                lbl_time:addChild(lbl_jiangli)                
            end

            local image = ImageView:create()
            image:loadTexture("pic+11_jtz.png")
            image:setPosition(ccp(450,0))
            image:addTouchEventListener(imgCallback)
            image:setTouchEnabled(true)
            image:setTag(i)
            lbl_time:addChild(image)            
        end
        cell_Y = cell_Y - cell_disY - cell_H
    end
end 

local function initMap()

    local function btnCallback(sender, eventType)     
        if eventType == PT.ccs.TouchEventType.ended then
        	local _btn = tolua.cast(sender, "Button")
        	local tag = _btn:getTag()        	
            print("tag === " .. tag)
            if _btn == btn_close then
                exitUI()
            end
    	end
    end

    btn_close = tolua.cast(Layer:getWidgetByName("Button_GuanBi"), "Button" )
    sv_result = tolua.cast(Layer:getWidgetByName("ScrollView_JieGuo"), "ScrollView" )
    btn_close:addTouchEventListener(btnCallback)
    refresh_Scroll()
end

function exitUI()
   if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        --Layer:clear()
        _widget = nil
        Layer = nil
        
        LM.STATE_4 = 0
    end
    JTNpcRoomData.clearSaoDangResult()
end

function enterUI(_rettype)
    LM.STATE_4 = UI_Fight_SaoDangResult

    Layer = LM.getLayer4()
    _widget = GUIReader:shareReader():widgetFromJsonFile("Pop3_SaoDang_Result.json")

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)

    _type = _rettype
    initMap()
end
--[[
function exitUI()
    JTNpcRoomData.clearSaoDangResult()
    PT.UI_State = pre_UI  
	scene:removeChild(Layer, true)
end

function enterUI(curScene,_rettype)
    scene = curScene
    _type = _rettype
    pre_UI =  PT.UI_State 
    PT.UI_State = UI_Fight_SaoDangResult
    Layer = TouchGroup:create()
    Layer:setZOrder(13)
    print("saodang")
    local _widget = GUIReader:shareReader():widgetFromJsonFile("Pop3_SaoDang_Result.json") 
    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)
 	scene:addChild(Layer)
    initMap()
    
end
--]]
