module("Map_Pop3_SystemTips", package.seeall)

local Layer = nil
local _widget = nil

local scrollView_Tips = nil



local function paseTT(_str)
    local str2 = _str
    local i, j = string_find(str2 , "~")
    if i ~= nil then
        print("替代 1 。。。")
        str2=string.gsub(str2, "~", "~ ")
    end
    i, j = string_find(str2 , "{")
    if i ~= nil then
        print("替代 2 。。。")
        str2=string.gsub(str2, "{", " { ")
    end
    
    i, j = string_find(str2 , "’")
    if i ~= nil then
        print("替代 3 。。。")
        str2=string.gsub(str2, "’", " ’ ")
    end

    i, j = string_find(str2 , "”")
    if i ~= nil then
        print("替代 4 。。。")
        str2=string.gsub(str2, "”", " ” ")
    end

    i, j = string_find(str2 , ",")
    if i ~= nil then 
        print("替代 5 。。。")
        str2=string.gsub(str2, ",", " , ")
    end

    i, j = string_find(str2 , ":")
    if i ~= nil then
        print("替代 6 。。。")
        str2=string.gsub(str2, ":", " : ")
    end

    i, j = string_find(str2 , "\"")
    if i ~= nil then
        print("替代 7 。。。")
        str2=string.gsub(str2, "\"", " \" ")
    end
--[[            
    --英文的"."有问题
    i, j = string_find(str2 , ".")
    if i ~= nil then
        str2=string.gsub(str2, ".", " . ")
    end
--]]
    return str2
end



local function  refresh_scrollview()
    scrollView_Tips:removeAllChildren()
    scrollView_Tips:setBounceEnabled(true)

    --可视区域
    local view_W = scrollView_Tips:getSize().width 
    local view_H = scrollView_Tips:getSize().height 

    local cell_H = 32
    local cell_disY = 0

   local systemTipsData=Des.getSystemTipsData() --获取本地系统公告数据
   local systemTipsTextData = systemTipsData["versionContent"]

    local hangNum = #systemTipsTextData

    --先判断是多行文本的数量
    local duoHangNum = 0
    for i=1,hangNum do
        local tipsContents =systemTipsTextData[i]["Content"]
        -- if string.len(tipsContents) >98 then
        --     duoHangNum=duoHangNum+1
        -- end

        local myHangNum = math.ceil(string.len(tipsContents)/98) -1
        duoHangNum=duoHangNum+myHangNum

        print("==============why" .. duoHangNum)

    end


    --local serverChengjiuData= ChengJiuData.getChengJiuData() --获取服务器成就数据

    scrollView_Tips:setInnerContainerSize(CCSize(view_W, cell_H*(hangNum+duoHangNum)+cell_disY*(hangNum-1) ) )

    local scroll_W = scrollView_Tips:getInnerContainerSize().width 
    local scroll_H = scrollView_Tips:getInnerContainerSize().height

    local cell_Y =  scroll_H-cell_H/2
    print("cell_Y == " .. cell_Y)
    print("scroll_W == " .. scroll_W)
    print("scroll_H == " .. scroll_H)

    for i=1,hangNum do
        --local itemY = cell_Y-(cell_H+cell_disY)*(i-1)
        local tipsContents =systemTipsTextData[i]["Content"]
        print("===========tipsContentssize=" .. string.len(tipsContents))
       local myHangNum = math.ceil(string.len(tipsContents)/98) -1
        print("=========myHangNum=" .. myHangNum)

        local targetPlatform = CCApplication:sharedApplication():getTargetPlatform()
        local hangHeight = 0
        if targetPlatform==kTargetWindows then
            if systemTipsTextData[i]["istitle"] then
                hangHeight=40
            else
                hangHeight=25
            end
            
        else
            if systemTipsTextData[i]["istitle"] then
                hangHeight=50
            else
                hangHeight=32
            end
        end

       if systemTipsTextData[i]["istitle"] then

            local lab_title = Label:create()
            lab_title:setAnchorPoint(ccp(0,1))
            lab_title:setPosition(ccp(0,cell_Y +16))

            lab_title:setText(systemTipsTextData[i]["Content"])
            lab_title:setFontSize(30)
            lab_title:setColor( ccc3(250, 198, 138) )
            lab_title:setSize(CCSizeMake(view_W,hangHeight*(myHangNum+1)))
            lab_title:ignoreContentAdaptWithSize(false)

            scrollView_Tips:addChild(lab_title)
       else 

             local _richText = RichText:create()
            _richText:ignoreContentAdaptWithSize(false)
            _richText:setAnchorPoint( ccp(0, 0.5) )
             _richText:setSize(CCSizeMake(view_W, cell_H)) 
             _richText:setTag(100)
           
            _richText:setPosition(ccp(0,cell_Y))
            


            local function addElement( _str, _typeColor )
                _str = paseTT(_str)
                local _re1 = RichElementText:create(1, ccc3(GoodsColorTab[_typeColor][1], GoodsColorTab[_typeColor][2], GoodsColorTab[_typeColor][3]), 255, _str, "Helvetica", 24);
                _richText:pushBackElement( _re1 )
            end

            local parsestr = nil
            parsestr = function (_str)
                local len = string.len(_str)
                local i, j = string.find(_str , "<")
                if i ~= nil then
                    local str1 = string.sub(_str, 1, i-1) --截取<之前的数据
                    print(str1)
                    addElement(str1, 1)

                    _str = string.sub(_str, j+1, len)--截取<之后的数据
                    len = string.len(_str)
                    i, j = string.find(_str , ":")
                    if i == 2 then --: 位置
                        local number = tonumber( string.sub(_str, 1, i-1) ) --截取色值索引

                        _str = string.sub(_str, j+1, len) --截取:后数据
                        len = string.len(_str)
                        i, j = string.find(_str , ">")
                        if i~= nil then
                            print(number)
                            local str2 = string.sub(_str, 1, i-1) --截取:后>前数据
                            print(str2)
                            --todo:正确的颜色节点
                            addElement( str2, number )
                            _str = string.sub(_str, j+1, len) --截取>后数据
                            --递归解析
                            parsestr(_str )
                        else --没有:
                            _str = "<" .. number .. ":" .. _str --恢复数据
                            print("1_error: " .. _str)
                            --todo:普通节点
                            addElement(_str, 1)
                        end
                    else -- < 尖括号里没有: 把
                        _str = "<" .. _str --恢复数据
                        print("2_error: " .. _str)
                        --todo:普通节点
                        addElement(_str, 1)
                    end
                else
                    print("3_error: " .. _str)
                    --todo:普通节点
                    addElement(_str, 1)
                    print("4_error: " .. _str)
                end
            end     
            parsestr(tipsContents)

            scrollView_Tips:addChild(_richText)
           
       end
        
        -- if string.len(tipsContents) >98 then
        --      cell_Y = cell_Y - cell_H - cell_disY -35
        -- else
        --      cell_Y = cell_Y - cell_H - cell_disY
        -- end

        
        
        cell_Y = cell_Y - cell_H - cell_disY -hangHeight*myHangNum

        print("=========cell_Y=" .. cell_Y)
           
    end   


    
end




local function initPub()

    local btn_close= tolua.cast(Layer:getWidgetByName("Button_close"), "Button")
    local function btnCloseCallback(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
           exitUI()
           --关闭公告，然后检测新手引导
           --判断有没有正在进行的引导
           if guideFactory.isHaveGuideDoing then
                print("======tttttt3")
                guideFactory.CheckGuideProcess( guideFactory.guideCurUi )
            else
                print("======tttttt4")
                guideFactory.CheckGuideProcess( LM.STATE_1 )
            end

            print("======tttttt5")
           
        end
    end
    btn_close:addTouchEventListener(btnCloseCallback)


    scrollView_Tips= tolua.cast(Layer:getWidgetByName("ScrollView_SystemTips"), "ScrollView" )

    refresh_scrollview()
   
end




function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        _widget = nil
        Layer = nil
    end
end


function enterUI()
    Layer =LM.getLayer26()

    _widget = GUIReader:shareReader():widgetFromJsonFile("xiTongGongGao.json")
    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)

    initPub()

end