module ("RL_UpdateData",package.seeall)
local Layer = nil 
local scene = nil
local pre_UI = 1
local Lb_1 = nil
local Lb_2 = nil 
local ifhasAccount = false
local EntryID = nil
local lbl_tips = nil
local lbl_progress = nil
local table_img_tips = {}
local table_img_name = {}
local progress = 0
--local start = 1
local nextLayer = nil
local emitter1 = nil
local emitter2 = nil
local particles_x = -365
local step = 1
local yuzhi = 80
local time = 0.05
local wait_max_time = 30
local wait_max_step = 0

function getScene()
    return scene
end

function enterChangeAccount()
    -- RL_ChangeAccount.enterUI(scene,false)
    -- exitUI()
end

function downloadOK()    
   
    if ifhasAccount  then
        RL_Login.enterUI(scene)
        exitUI()
    else
        RL_ChangeAccount.enterUI(scene,true)
        exitUI()
    end
end

local function refreshProgress(_progress)
    --setPosition(ccp(particles_x,-2))
    emitter2:setPosition(ccp(particles_x+7.3*_progress,-3))
    Lb_1:setPercent(_progress)
    lbl_progress:setText(_progress.."%")
    if _progress ~= 100 then
        if _progress <50 then
           -- Lb_2:setPercent(_progress+3)
        else
           -- Lb_2:setPercent(_progress+3-_progress/30)
        end
    else
        --Lb_2:setPercent(_progress)
    end
end 

local function refresh_state()
    refreshProgress(progress)
end

local function refreshImgName()
    for i=1,4 do
        table_img_name[i]="pic"..(math.random(2,6)+i).."_login_1.png"
    end
end 

function setGotoLayer(_layer)
    nextLayer = _layer
    print(" the nextLayer is "..nextLayer)
    progress = yuzhi + 1
    --progress = 90
end

local function updateTips()
    step = step+1
    wait_max_step = wait_max_step +1

    if wait_max_step == wait_max_time/time then
        wait_max_step = 0
        Pop3_TS_Result.enterUI("登录超时，请重新登录！")
    end

    if step == 20*4 then
        lbl_tips:setText("友情提示："..Des.getRandomTipsDes())
        --refreshImgName()
        step = 1
    end

    -- if start == 6 then
    --     start = 1
    -- end
    -- start = start +1
    
    -- for i=1,4 do
    --     table_img_tips[i]:loadTexture(table_img_name[i])
    -- end
    if  progress == yuzhi then
        progress = progress
    else
        progress = progress +1
    end
    if progress <=100 then
        refreshProgress(progress)
    else
        exitUI()
        print(" the nextLayer is "..nextLayer)
        if nextLayer == UI_RL_Login then
            print(" goto UI_RL_Login ")
            RL_Login.enterUI(scene)

        elseif nextLayer == UI_RL_GameName then
            RL_GameName.enterUI(scene)

        elseif nextLayer == UI_RL_ChooseCamp then
            RL_ChooseCamp.enterUI(scene)
            
        elseif nextLayer == UI_ZhuCheng then
            --CDTimeManager.start()

            HeartManager.openHeart()

            guideFactory.guideFactoryInit()
            LM.UIlayerInit()
            if guideFactory.checkIfGuideDoing() ~= true then
               print("no guide ............")
                MapShouYe.enterUI()
                MapPubUI.enterUI() 
                
               
                --[[
                if guideFactory.getIfFistPlay() then
                    MapPubUI.enterUI( UI_ZhengZhan )
                else
                    MapPubUI.enterUI( UI_ZhuCheng )
                end
                --]]
            end
        else
            print("关闭loading界面")
        end
    end
end 

local function initMap()  
    Lb_1 = tolua.cast(Layer:getWidgetByName("LoadingBar_1"),"LoadingBar")
    --Lb_2 = tolua.cast(Layer:getWidgetByName("LoadingBar_2"),"LoadingBar")
    Lb_2 = tolua.cast(Layer:getWidgetByName("ImageView_1204"),"ImageView")
    lbl_tips = tolua.cast(Layer:getWidgetByName("Label_tips"),"Label")
    lbl_progress =  tolua.cast(Layer:getWidgetByName("Label_progress"),"Label")
   -- Lb_2:setPercent(100)

    for i=1,4 do
        table_img_tips[i] = tolua.cast(Layer:getWidgetByName("ImageView_tips"..i),"ImageView")
        table_img_tips[i]:setEnabled(false)
    end

    local data = PT.getAccount("Account.lua")    
    if data~=nil then
        print("initMap true")
        ifhasAccount = true
    else
        print("initMap false")
        ifhasAccount = false
    end


    print(" the pre_UI is "..pre_UI)
    if pre_UI == -1 then
        downloadOK()
        ifhasAccount = false
    end
   
    if ifserver == false then
        MapPubUI.enterUI(UI_ZhuCheng)
    else
        if ifhasAccount then
            local scheduler = CCDirector:sharedDirector():getScheduler()
            math.randomseed(os.time())
            lbl_tips:setText("友情提示："..Des.getRandomTipsDes())
            EntryID = scheduler:scheduleScriptFunc( updateTips, time, false)
            emitter1 = CCParticleSystemQuad:create("src/Particles/Loading_texture.plist")
            emitter1:setAnchorPoint(ccp(1,0.5))
            emitter1:setPosition(ccp(0,-2))
            emitter2 = CCParticleSystemQuad:create("src/Particles/Loading_texturehead.plist")
            emitter2:setPosition(ccp(particles_x,-3))
            Lb_2:addNode(emitter2)
            Lb_2:addNode(emitter1)
            progress = 0
            refresh_state()
        end
    end

end

function exitUI()
    local scheduler = CCDirector:sharedDirector():getScheduler()
    if EntryID ~= nil then
        scheduler:unscheduleScriptEntry(EntryID)
    end
    scene:removeChild(Layer, true)
end

function enterUI(curScene)
    --scene = curScene
     print(" enterUI 1  ")
    pre_UI =  PT.UI_State 
    if curScene == nil then
        scene = CCScene:create()
    else
        scene = curScene
    end
    PT.UI_State = UI_RL_UpdateData
    Layer = TouchGroup:create()
    Layer:setZOrder(15)
    print(" enterUI 2  ")
   
    local _widget = GUIReader:shareReader():widgetFromJsonFile("RL_UpdateData.json") 
    Layer:addWidget(_widget)

    if curScene == nil then
        CCDirector:sharedDirector():replaceScene( scene )
    end
    print(" enterUI 3  ")
    _widget:setTouchEnabled(true)
 	scene:addChild(Layer)
    initMap()
    AudioEngine.playMusic("1_1.wav",true)
    print(" enterUI 4  ")
end
