module ("RenWuBase",package.seeall)
local Layer = nil
--local scene = nil
local remIndex = nil
local remFatherUi = nil
 local _widget = nil
local path = {
	{["UI"] = nil, ["pic1"] = "button1_tong_2.jpg", ["pic2"] = "button1_tong_1.jpg", ["Imge"] = nil }, --主线
	{["UI"] = nil, ["pic1"] = "button1_tong_2.jpg", ["pic2"] = "button1_tong_1.jpg", ["Imge"] = nil }, --日常
}

--监测主线任务小红点
function checkZhuRedPoint()
	--if LM.STATE_3 == UI_RenWu_ZhuXian then

		local ifneed = TaskMainData.checkIfNeedRedPoint()
		local img = path[1]["Imge"]
		if ifneed then
			local _Img = tolua.cast( img:getChildByTag(10), "ImageView" ) 
			if _Img == nil then
				local img_point = ImageView:create()
				img_point:loadTexture("floor+60_tong.png")
				img_point:setTag(10)
				img_point:setPosition(ccp(-47,17))
				
				img:addChild(img_point)
			end
		else
			local _Img = tolua.cast( img:getChildByTag(10), "ImageView" ) 
			if _Img ~= nil then
				img:removeChildByTag(10, true)
			end
		end

	--end
end
---[[
--监测日常任务小红点
function checkRiRedPoint()
	--if LM.STATE_3 == UI_RenWu_RiChang then
		--local ifneed = TaskMainData.checkIfNeedRedPoint()
		local ifneed = TaskDailyData.checkIfRedPoint()
		local img = path[2]["Imge"]
		if ifneed then
			local _Img = tolua.cast( img:getChildByTag(10), "ImageView" ) 
			if _Img == nil then
				local img_point = ImageView:create()
				img_point:loadTexture("floor+60_tong.png")
				img_point:setTag(10)
				img_point:setPosition(ccp(-47,17))
				
				img:addChild(img_point)
			end
		else
			local _Img = tolua.cast( img:getChildByTag(10), "ImageView" ) 
			if _Img ~= nil then
				img:removeChildByTag(10, true)
			end
		end

	--end
end
--]]
local function initPubUI( _index )
	local btn_close = tolua.cast( Layer:getWidgetByName("Button_TuiChu"), "Button" )
	local function btn_closeCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			
			BagData.clearCDlbl()
			DelegateData.clearLabelButton()
			exitUI()
			--path[remIndex]["UI"].exitUI()
			guideFactory.CheckGuideProcess( LM.STATE_1 )
		end
	end
	btn_close:addTouchEventListener( btn_closeCB )


path[1]["Imge"] = tolua.cast( Layer:getWidgetByName("ImageView_ZhuXian"), "ImageView" )
path[2]["Imge"] = tolua.cast( Layer:getWidgetByName("ImageView_RiChang"), "ImageView" )

---[[
path[1]["UI"] = RWZhuXian
path[2]["UI"] = RWRiChang
--]]
	local function Img_TouchCB(sender, eventType)
		local _img = tolua.cast(sender, "ImageView")
		if eventType == PT.ccs.TouchEventType.ended then
			
			if _img == path[1]["Imge"] then --主线
				if remIndex == 1 then
					return
				end
				path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic1"] )
				path[remIndex]["UI"].exitUI()
				remIndex = 1
				path[remIndex]["UI"].enterUI()
			elseif _img == path[2]["Imge"] then --日常
				if remIndex == 2 then
					return
				end
				path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic1"] )
				path[remIndex]["UI"].exitUI()
				remIndex = 2
				path[remIndex]["UI"].enterUI()
			end
			path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic2"] )
		end
	end 

	for i=1,2 do
		path[i]["Imge"]:addTouchEventListener( Img_TouchCB )
			path[i]["Imge"]:setVisible(true)
			path[i]["Imge"]:setTouchEnabled(true)
--[[
		if CityData.canOpenFuncByIndex(20+i) then
			path[i]["Imge"]:setVisible(true)
			path[i]["Imge"]:setTouchEnabled(true)
		else
			path[i]["Imge"]:setVisible(false)
			path[i]["Imge"]:setTouchEnabled(false)
		end
--]]
	end
---[[	
	local openBtn={}
	local btnTable={
			{["id"]=21,["btn"]=path[1]["Imge"]},
			{["id"]=22,["btn"]=path[2]["Imge"]}	
		}
	for i=1, #btnTable do
		PT.hideManyBtn(openBtn,btnTable[i]["id"],btnTable[i]["btn"])
	end
	for i=1,#openBtn do
		--openBtn[i]:setPosition(ccp(-414+105*(i-1),-28))
		openBtn[i]:setPosition( ccp(-359+110*(i-1),239) )
	end
--]]

	if CityData.canOpenFuncByIndex(21) then
		remIndex = 1
	elseif CityData.canOpenFuncByIndex(22) then
		remIndex = 2
	end
	--remIndex = _index
	path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic2"] )

	path[remIndex]["UI"].enterUI()


	checkZhuRedPoint()
	checkRiRedPoint()
end


function exitUI()
	if Layer ~= nil and _widget ~= nil then
		--Layer:removeWidget(_widget)
		Layer:clear()
		_widget = nil
		Layer = nil
		
		LM.STATE_3 = 0
	end
	MapPubUI.setPubVisible(true)
--	MapPubUI.setPanelBtnState(false)
end
function enterUI(_index)
	if LM.STATE_3 == UI_RenWu_RiChang or
		LM.STATE_3 == UI_RenWu_ZhuXian then
		return
	end
--	MapPubUI.setPanelBtnState(false)
	
	LM.clearLayer3ToUI()
	Layer = LM.getLayer3()
	_widget = GUIReader:shareReader():widgetFromJsonFile("RenWuUIBase.json")

	Layer:addWidget(_widget)
    _widget:setTouchEnabled(true) --底层的widget设置为true，阻断点击事件的穿透

    MapPubUI.setPubVisible(false)

    initPubUI( _index )
end
