module ("RWZhuXian",package.seeall)
--祭祀
local Layer = nil
local _widget = nil
--local curScene = nil

local _ScrollView = nil
local lbl_mingCheng= nil
local Img_nanDuTab = {} --难度列表
local lbl_miaoShu  = nil
local lbl_shuoMing = nil
local lbl_jiangLi1 = nil
local lbl_jiangLi2 = nil
local btn_LingQu = nil
local lbl_LingQu = nil
local remId = nil

local remIdex = nil --记录当前任务所在的焦点

local isClickLingQu = false
local jiangLiStr = ""

--设置任务描述
function _setMiaoShu(_lbl, Data)
    local locDes = Des.getMainTaskDesFromId( Data["MainTaskId"] )
   local taskType = locDes["taskType"]
--[[
    1建筑升级    建筑ID  提升至等级
    2通关NPC    关卡ID   NPCID
    3获得某件装备     装备ID
    4将装备强化至某个级别     装备ID    强化等级
    5招募到某个武将      武将ID
    6某个武将提升至某个级别    武将ID   等级
    7某个武将上阵         武将ID
    8玩家官职到达某个级别    官职Id
    9占领农田
    10占领银矿
    11玩家某个女神升级至某个等级    女神ID   等级
    12某个女神升级至某个星级          女神id   星级
    13迁移至某个地区       地区等级上限
    14女神进阶
    15提升女神到多少级
    16消灭军团npc
    17花费金币消除1次战斗CD
--]]
    local str = ""
    local atdata1 = Data["Ratio1"]
    local atdata2 = Data["Ratio2"]
    local atdata3 = Data["Ratio3"]

    local ttDes = nil
    local name = nil

    if taskType == 1 then
        ttDes = Des.getBuildDesFromId( atdata1 )
        name = ttDes["buildName"]
        str = "将 " .. name .. " 提升至 " .. atdata2 .. " 级"
    elseif taskType == 2 then
        print("atdata1 === " .. atdata1)
        print("atdata2 === " .. atdata2)
        ttDes = Des.getChapterDesFromId( atdata1 )
        local GKname = ttDes["chapterName"]
        ttDes = Des.getBattleDesFromId( atdata1, atdata2 )
        local NPCname = ttDes["battleName"]
        str = "消灭 " .. GKname .. " 的 " .. NPCname
    elseif taskType == 3 then
        ttDes = Des.getGoodsDesFromId( atdata1 )
        name = ttDes["goodsName"]
        str = "获得 " .. name
    elseif taskType == 4 then
        ttDes = Des.getGoodsDesFromId( atdata1 )
        name = ttDes["goodsName"]

        local JieNum, xingNum = math_modf( atdata2/10 )
        xingNum = xingNum*10

        str = "将 " .. name .. " 强化升至 " .. JieNum .. "阶" .. xingNum .. "星"
        --str = "将 " .. name .. " 强化升至 " .. atdata2 .. " 级"
    elseif taskType == 5 then
        ttDes = Des.getGeneralDesFromId( atdata1 )
        name = ttDes["generalName"]
        str = "招募 " .. name
    elseif taskType == 6 then
        ttDes = Des.getGeneralDesFromId( atdata1 )
        name = ttDes["generalName"]
        str = "将 " .. name .. " 提升至 " .. atdata2 .. " 级"
    elseif taskType == 7 then
        ttDes = Des.getGeneralDesFromId( atdata1 )
        name = ttDes["generalName"]
        str = "将 " .. name .. " 上阵,并进行一场战斗 "
    elseif taskType == 8 then
        ttDes = Des.getOfficeDesFromId(atdata1)
        name = ttDes["officeName"]
        str = "将官职提升至 " .. name
    elseif taskType == 9 then
        str = "占领一座农田"
    elseif taskType == 10 then
        str = "占领一座银矿"
    elseif taskType == 11 then
        ttDes = Des.getGoddessDesFromId( atdata1 )
        name = ttDes["goddessName"]
        str = "将 " .. name .. " 提升至 " .. atdata2 .. "级"
    elseif taskType == 12 then
        ttDes = Des.getGoddessDesFromId( atdata1 )
        name = ttDes["goddessName"]
        local t, k = PT.checkeGodQuality(atdata2) --math_modf( atdata2/11 )
        local color = {"蓝色", "绿色", "黄色", "红色", "紫色"}
        k = atdata2 - t*11
        str = "将 " .. name .. " 进阶至 " .. color[t+1] .. k .. "星"
    elseif taskType == 13 then
        str = "将主城迁移至等级上限为 " .. atdata1 .. "的城市"
    elseif taskType == 14 then
        local t, k = PT.checkeGodQuality(atdata1) --math_modf( atdata1/11 )
        local color = {"蓝色", "绿色", "黄色", "红色", "紫色"}
        k = atdata1 - t*11
        str = "将任意女神进阶至 " .. color[t+1] .. k .. "星"
    elseif taskType == 15 then
        str = "将任意女神提升至" .. atdata1 .. "级"
    elseif taskType == 16 then
        local groupDes = Des.getGroupBattleDesFromId( atdata1 )
        local name = groupDes["battleName"]
        str = "消灭 精英·【" .. name .. "】"
    elseif taskType == 17 then 
        str = "花费金币消除1次战斗CD"  
    elseif taskType == 18 then 
        str = "花费金币消除1次建筑CD" 
    elseif taskType == 19 then 
        str = "进入帮助界面，查看帮助信息"  
    end
    _lbl:setText(str)

end

local remType2 = 0 -- --记录要消灭的关卡npc id
local remJingYingGK = false
function getRemType2()
    return remType2
end

--清除所有任务引导的记录信息
function clearAllGuildRem()
    remType2 = 0
    remJingYingGK = false
end

function getRemJingYingGK()
   return remJingYingGK
end

--任务引导
local function Task_Guide(_taskType, _Ratio1, _Ratio2, _Ratio3)
    if _taskType == 1 then --建筑物升级
        RenWuBase.exitUI()
        if LM.STATE_1 == UI_ShiJie then --如果是在世界ui，跳转到主城
            LM.clearPubMid()
            MapShouYe.enterUI()
        end
        local _tag = _Ratio1
        if _tag == 1 then --1主城
            Pop3_ZhuCheng.enterUI( _tag )
        elseif _tag == 2 then --2民居
            Pop3_MinJu.enterUI( _tag  )
        elseif _tag == 3 then --3国库
            Pop3_GuoKu.enterUI( _tag  )
        elseif _tag == 4 then --4军机处
            Pop3_JunJiChu.enterUI( _tag  )
        elseif _tag == 5 then --5校场
            Pop3_JiaoChang.enterUI( _tag  )
        elseif _tag == 6 then --6军械库
            Pop3_JunXieKu.enterUI( _tag  )
        elseif _tag == 7 then --7驿站
            Pop3_YiZhan.enterUI( _tag  )
        --[[
        elseif _tag == 8 then --8农场
            protoSend0x0434(0)
        elseif _tag == 9 then --9矿藏
            protoSend0x0434(1)
        --]]
        end
        RW_guide.enterUI(0, 210, -50)
    elseif _taskType == 2 then --消灭关卡npc
        RenWuBase.exitUI()
        if CityData.canOpenFuncByIndex(3) then

            GuanKaBase.enterUI(1)
            protoSend0x0290( _Ratio1 ) --关卡id】     
            remType2 = _Ratio2           
        else    
            PT.popTips(3)
        end
        
        --_Ratio2 --npcid
    elseif _taskType == 3 then --获得装备
        RenWuBase.exitUI()
        GuanKaBase.enterUI(1) --跳转征战界面
    elseif _taskType == 4 then --强化装备
        --指引优先强化已穿戴装备
         
        if CityData.canOpenFuncByIndex(11) then
            if BagData.getgoodsIdxFromId(1,_Ratio1) ~= 0 or BagData.getgoodsIdxFromId(2,_Ratio1)~=0 then
                RenWuBase.exitUI()
                BeiBaoBase.enterUI(2)
                BeiBao_QiangHua.setTaskGuideFource(_Ratio1)
                RW_guide.enterUI(0, 310, -80)
            else
                Pop3_TS_Result.enterUI("该装备尚未获得！") 
            end
        else
            PT.popTips(11)
        end

    elseif _taskType == 5 then --招募武将
        if GeneralData.getGenralIdxFromId(_Ratio1) ~= 0 then
            RenWuBase.exitUI()
            GeneralBase.enterUI(4)

            local camp = PlayerData.getCamp()+1
            GNR_ZhaoMu_Pop3.enterUI(_Ratio1, camp)

            RW_guide.enterUI(0, 140, -90)
        else
            Pop3_TS_Result.enterUI("该将领尚未获得！") 
        end
    elseif _taskType == 6 then --训练武将
        if GeneralData.getGeneralDataFromId(_Ratio1) ~= nil then
            RenWuBase.exitUI()
            GeneralBase.enterUI(1)
            GNR_XunLian.setGuideFource(_Ratio1)
        else
            Pop3_TS_Result.enterUI("该将领尚未招募！")
        end

    elseif _taskType == 7 then --将领上阵
        if GeneralData.getGeneralDataFromId(_Ratio1) ~= nil then
            RenWuBase.exitUI()
            GeneralBase.enterUI(5)
            GNR_BuZhen.setFourceForTaskGuide(_Ratio1)
        else
            Pop3_TS_Result.enterUI("该将领尚未招募！")
        end
    elseif _taskType == 8 then --官职升级
        if CityData.canOpenFuncByIndex(25) then
            RenWuBase.exitUI()
            GuanZhi_GuanZhi.enterUI()
        else
            Pop3_TS_Result.enterUI("官职功能尚未开放！")
        end
    elseif _taskType == 9 then --占领一座农田
        if CityData.getStateOpenFromId(8) then
            RenWuBase.exitUI()
            if LM.STATE_1 == UI_ShiJie then --如果是在世界ui，跳转到主城
                LM.clearPubMid()
                MapShouYe.enterUI()
            end
            protoSend0x0434(0)
        else
            Pop3_TS_Result.enterUI("农田尚未开启！")
        end
    elseif _taskType == 10 then --占领一座银矿
        if CityData.getStateOpenFromId(9) then
            RenWuBase.exitUI()
            if LM.STATE_1 == UI_ShiJie then --如果是在世界ui，跳转到主城
                LM.clearPubMid()
                MapShouYe.enterUI()
            end
            protoSend0x0434(1)
        else
            Pop3_TS_Result.enterUI("银矿尚未开启")
        end
    elseif _taskType == 11 then --将对应女神提升至XX级
        if GeneralData.ifGetGodFromGodId(_Ratio1) then
            if GeneralData.ifGetGodAndYesFromGodId(_Ratio1) then
                if CityData.canOpenFuncByIndex(16) then
                    RenWuBase.exitUI()
                    NvShenBaseA.enterUI(1)
                    NvShenBase.enterUI(1, _Ratio1, 1) --已招募女神
                    RW_guide.enterUI(0, 300, -90)
                else
                    Pop3_TS_Result.enterUI("女神功能尚未开放！")
                end


            else
                Pop3_TS_Result.enterUI("该女神尚未招募！")
            end
        else
            Pop3_TS_Result.enterUI("该女神尚未获得！")
        end

    elseif _taskType == 12 then --将对应女神进阶只xx品质
        if GeneralData.ifGetGodFromGodId(_Ratio1) then
            if GeneralData.ifGetGodAndYesFromGodId(_Ratio1) then
                if CityData.canOpenFuncByIndex(16) then
                    RenWuBase.exitUI()
                    NvShenBaseA.enterUI(1)
                    NvShenBase.enterUI(1, _Ratio1, 1) --已招募女神
                    RW_guide.enterUI(0, 300, -90)
                else
                    Pop3_TS_Result.enterUI("女神功能尚未开放！")
                end
            else
                Pop3_TS_Result.enterUI("该女神尚未招募！")
            end
        else
            Pop3_TS_Result.enterUI("该女神尚未获得！")
        end
    elseif _taskType == 13 then --迁徙
        if LM.STATE_1 ~= UI_ShiJie then --如果是在世界ui，跳转到主城
            
            if CityData.getStateOpenFromId(2) then
                MapShouYe.exitUI()

                LM.clearMainCity()
                LM.clearPubMid()

                MapShiJie.enterUI()
            else
                Pop3_TS_Result.enterUI("世界功能尚未开放！")
            end
        else
            RenWuBase.exitUI()
        end

    elseif _taskType == 14 then

                if CityData.canOpenFuncByIndex(16) then
                    RenWuBase.exitUI()
                    NvShenBaseA.enterUI(1)
                    --NvShenBase.enterUI(1, _Ratio1, 1) --已招募女神
                    --RW_guide.enterUI(0, 300, -90)
                else
                    Pop3_TS_Result.enterUI("女神功能尚未开放！")
                end
  
    elseif _taskType == 15 then

                if CityData.canOpenFuncByIndex(16) then
                    RenWuBase.exitUI()
                    NvShenBaseA.enterUI(1)
                    --NvShenBase.enterUI(1, _Ratio1, 1) --已招募女神
                    --RW_guide.enterUI(0, 300, -90)
                else
                    Pop3_TS_Result.enterUI("女神功能尚未开放！")
                end
 
    elseif _taskType == 16 then --消灭精英军团
        
        if CityData.canOpenFuncByIndex(3) then
            RenWuBase.exitUI()
            GuanKaBase.enterUI(2) 

            PT.setId(_Ratio1, 0, 0)
            protoSend0x0204( _Ratio1, -1 )   
            remJingYingGK = true
            --RW_guide.enterUI(0, 300, -90)   
        else    
            PT.popTips(3)
        end   

    elseif _taskType == 17 then --花费金币消除1次战斗CD
        RenWuBase.exitUI()
        --MapPubUI.setCDEventPubVisible(true)
        RW_guide.enterUI(1, -(UseW*0.48 - 230), UseH*0.5-290)
    elseif _taskType == 18 then --费金币消除1次建筑CD
        RenWuBase.exitUI()
        MapPubUI.setCDEventPubVisible(true)
        RW_guide.enterUI(3, -(UseW*0.48 - 280), UseH*0.5-270)
    elseif _taskType == 19 then --进入帮助界面，查看帮助信息
        RenWuBase.exitUI()
        HelpUI.enterUI()
    end

end

--设置任务奖励
function _setJiangLi(_lbl, Data)
    local rewardType = Data["RewardType"]
    local rewardValue = Data["RewardValue"]
    --1银币 2金币 3军功 4军粮 5军令 6荣誉
    local reStr = ""
    if rewardType == 1 then
        reStr = "获取 "  .. rewardValue .. " 银币"
    elseif rewardType == 2 then
        reStr = "获取 "  .. rewardValue .. " 金币"
    elseif rewardType == 3 then
        reStr = "获取 "  .. rewardValue .. " 军功"
    elseif rewardType == 4 then
        reStr = "获取 "  .. rewardValue .. " 军粮"
    elseif rewardType == 5 then
        reStr = "获取 "  .. rewardValue .. " 军令"
    elseif rewardType == 6 then
        reStr = "获取 "  .. rewardValue .. " 威望"
    end
    _lbl:setText(reStr)

    if isClickLingQu then
        Pop3_TS_Result.enterUI(jiangLiStr)
        isClickLingQu=false
        jiangLiStr="恭喜您" .. reStr
    else
        jiangLiStr="恭喜您" .. reStr
    end

end

local function flushMessageMod( _index )
if ifserver then

    local datalist = TaskMainData.getMainTaskDatalist() 
    local data = datalist[_index]
    local locDes = Des.getMainTaskDesFromId(data["MainTaskId"])
    remId = data["MainTaskId"]

    lbl_mingCheng:setText( locDes["taskName"] )
    local nanDu = locDes["taskDifficulties"]
    for i=1, 5 do
        if i<= nanDu then
            Img_nanDuTab[i]:setVisible(true)
        else
            Img_nanDuTab[i]:setVisible(false)
        end
    end

    lbl_shuoMing:setText( locDes["taskText"] )

    _setJiangLi( lbl_jiangLi1,  data)
    lbl_jiangLi2:setVisible(false)

    _setMiaoShu(lbl_miaoShu,  data)

    if data["State"] == 1 then --完成
        btn_LingQu:setBright(true)
        btn_LingQu:setTouchEnabled(true)
        lbl_LingQu:setText("领取奖励")
    else --未完成
        btn_LingQu:setBright(true)
        btn_LingQu:setTouchEnabled(true)
        lbl_LingQu:setText("任务指引")
    end

end
end


function flushScrollview()
    remIdex = 1
    _ScrollView:removeAllChildren()
    _ScrollView:setClippingEnabled(true) --裁切窗口
    
    _ScrollView:setBackGroundColorType(0)


    local num = 5
    local datalist = nil

if ifserver then
    datalist = TaskMainData.getMainTaskDatalist()   
    num = #datalist
end
    if num < 8 then
        _ScrollView:setBounceEnabled(false) --边缘回弹
    else
        _ScrollView:setBounceEnabled(true) --边缘回弹
    end
    local cell_disY = 6
    local cell_W, cell_H = 200, 52

    local view_W = _ScrollView:getSize().width 
    local view_H = _ScrollView:getSize().height
    _ScrollView:setInnerContainerSize( CCSize(view_W, cell_H*num+(num-1)*cell_disY) )

    --滑动区域
    local scroll_W = _ScrollView:getInnerContainerSize().width
    local scroll_H = _ScrollView:getInnerContainerSize().height
    local cell_X, cell_Y = view_W/2+12, scroll_H-cell_H/2  
    
    local function CellTouchCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            --guideFactory.CheckGuideProcess(curScene)
            local _img = tolua.cast(sender, "ImageView")
            if remIdex == tag then
                return
            end
            local imgbefor =  tolua.cast(_ScrollView:getChildByTag(remIdex), "ImageView")
            imgbefor:loadTexture("button14_tong_2.png")
            local tag = _img:getTag()
            remIdex = tag
            _img:loadTexture("button14_tong_1.png")
            flushMessageMod( tag )

            guideFactory.CheckGuideProcess( LM.STATE_3 )
        end
    end
    for i=1, num do
        local name = nil
        local proc = 1 --1代表完成
        local id = 0
if ifserver then
        local data = datalist[i]
        id = data["MainTaskId"]
        local locDes = Des.getMainTaskDesFromId(id)
        name = locDes["taskName"]
        proc = data["State"]
else
        name = "任务名字一共八个字"
        proc = 1

end
        local imageView = ImageView:create()
        if i == remIdex then
            imageView:loadTexture("button14_tong_1.png")
            flushMessageMod( i )
        else
            imageView:loadTexture("button14_tong_2.png")       
        end
        imageView:setTag(i)
        imageView:setPosition( ccp( cell_X, cell_Y ) )
        imageView:setScale9Enabled(true)
        imageView:setSize( CCSize(cell_W, cell_H) )
        imageView:addTouchEventListener( CellTouchCB )
        imageView:setTouchEnabled(true)
            
            local img_StateBG = ImageView:create()
            img_StateBG:loadTexture("floor+47_tong.png")
            img_StateBG:setPosition(ccp(-100, 0))

                local Img_state = ImageView:create()
                if proc == 1 then --完成
                    Img_state:loadTexture("floor+10_renwu.png")
                else
                    Img_state:loadTexture("floor+9_renwu.png")
                end
                Img_state:setPosition(ccp(0, 0))
            img_StateBG:addChild(Img_state)
        imageView:addChild( img_StateBG )  

            local _lbl = Label:create()
            _lbl:setText( name )
            _lbl:setFontSize( 24 )
            _lbl:setAnchorPoint(ccp(0, 0.5))
            _lbl:setPosition(ccp(-70, 0))
            _lbl:setColor( ccc3(232, 223, 167) )
        imageView:addChild( _lbl )

        --添加已完成小红点
        if proc == 1 then
            local img_point = ImageView:create()
            img_point:loadTexture("floor+60_tong.png")
            img_point:setTag(10)
            img_point:setPosition(ccp(95,20))

            imageView:addChild( img_point )
        end

        _ScrollView:addChild( imageView )

        cell_Y = cell_Y - cell_disY - cell_H
    end
end

local function _initPubMod()
    _ScrollView   = tolua.cast( Layer:getWidgetByName("ScrollView_RenWuList"), "ScrollView" )
    
    lbl_mingCheng= tolua.cast( Layer:getWidgetByName("Label_MingCheng"), "Label" )
    lbl_miaoShu  = tolua.cast( Layer:getWidgetByName("Label_miaoshu"), "Label" )
    lbl_shuoMing = tolua.cast( Layer:getWidgetByName("Label_shuoming"), "Label" )
    lbl_jiangLi1 = tolua.cast( Layer:getWidgetByName("Label_jiangli1"), "Label" )
    lbl_jiangLi2 = tolua.cast( Layer:getWidgetByName("Label_jiangli2"), "Label" )
    btn_LingQu = tolua.cast( Layer:getWidgetByName("Button_LingJiang"), "Button" )
    lbl_LingQu = tolua.cast( Layer:getWidgetByName("Label_3088"), "Label" )
    local function CellTouchCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then       
            local Data = TaskMainData.getDataFromId(remId)

            if Data["State"] == 1 then --完成
                protoSend0x0430(remId)
                isClickLingQu=true
            else
                local locDes = Des.getMainTaskDesFromId( Data["MainTaskId"] )
                local taskType = locDes["taskType"]
                Task_Guide(taskType, Data["Ratio1"],Data["Ratio2"],Data["Ratio3"])
            end
        end
    end
    btn_LingQu:setTouchEnabled(true)
    btn_LingQu:addTouchEventListener( CellTouchCB )

    Img_nanDuTab = {} --难度列表
    for i=1, 5 do
        Img_nanDuTab[i] = tolua.cast( Layer:getWidgetByName("ImageView_xing" .. i), "ImageView" )
        Img_nanDuTab[i]:setVisible(false)
    end
    
    flushScrollview()
end

function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        --Layer:clear()
        _widget = nil
        Layer = nil
        
        LM.STATE_3 = 0
    end
end

function enterUI()
    LM.STATE_3 = UI_RenWu_ZhuXian

    Layer = LM.getLayer3()
    _widget = GUIReader:shareReader():widgetFromJsonFile("RenWu_ZhuXian.json") 

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(false)

    _initPubMod()

    guideFactory.CheckGuideProcess( LM.STATE_3 )
end

--[[
function enterUI( _Scene )
    PT.UI_State = UI_RenWu_ZhuXian
	curScene = _Scene
	Layer = TouchGroup:create()
	--Layer:setTouchEnabled(false)
	Layer:setZOrder(10)
    local _widget = GUIReader:shareReader():widgetFromJsonFile("RenWu_ZhuXian.json")    
    _widget:setTouchEnabled(false)
    Layer:addWidget(_widget)
    _Scene:addChild(Layer)

    _initPubMod()

    guideFactory.CheckGuideProcess(curScene)
end

function exitUI()
    --BagData.clearCDlbl()
	curScene:removeChild(Layer, true)
	--Layer:onExit()
end
--]]