module ("Msdk_loading",package.seeall)
local Layer = nil 
local scene = nil
local Lb_1 = nil
local Lb_2 = nil 
local EntryID = nil
local lbl_tips = nil
local lbl_progress = nil
local table_img_tips = {}
local progress = 0
local nextLayer = nil
local emitter1 = nil
local emitter2 = nil
local particles_x = -365
local step = 1
local yuzhi = 80
local time = 0.05
local wait_max_time = 60
local wait_max_step = 0

isFirstCheckGold=true

local mLab_tips=nil

local isShowTips = false

local function refreshProgress(_progress)
    
    emitter2:setPosition(ccp(particles_x+7.3*_progress,-3))
    Lb_1:setPercent(_progress)
    lbl_progress:setText(_progress.."%")
end 

local function refresh_state()
    refreshProgress(progress)
end

function setGotoLayer(_layer)
    nextLayer = _layer
    print(" the nextLayer is "..nextLayer)
    progress = yuzhi + 1
    
end

local function updateTips()
    step = step+1
    wait_max_step = wait_max_step +1

    if wait_max_step == wait_max_time/time then
        wait_max_step = 0
        --Pop3_TS_Result.enterUI("登录超时，请重新登录！")
        --Pop3_TS_Result.enterUI("努力加载中，请主公稍候！")
         isShowTips=true
    end

    if isShowTips then

        if step==25 then
          mLab_tips:setText( "努力加载中，请主公稍候。" )

        elseif  step==55  then
            mLab_tips:setText( "努力加载中，请主公稍候。。" )
        elseif  step==20*4  then
            mLab_tips:setText( "努力加载中，请主公稍候。。。" )
        end
    end

    if step == 20*4 then
        lbl_tips:setText("友情提示："..Des.getRandomTipsDes())
        --refreshImgName()
        step = 1
    end


    if  progress == yuzhi then
        progress = progress
    else
        progress = progress +1
    end
    if progress <=100 then
        refreshProgress(progress)
    else
        exitUI()
        print(" the nextLayer is "..nextLayer)
        if nextLayer == UI_RL_Login then
            print(" goto UI_RL_Login ")
            RL_Login.enterUI(scene)

        elseif nextLayer == UI_RL_GameName then
            RL_GameName.enterUI(scene)

        elseif nextLayer == UI_RL_ChooseCamp then
            RL_ChooseCamp.enterUI(scene)
            
        elseif nextLayer == UI_ZhuCheng then
            --CDTimeManager.start()
            HeartManager.openHeart()

            guideFactory.guideFactoryInit()
            LM.UIlayerInit()
            if guideFactory.checkIfGuideDoing() ~= true then
               print("no guide ............")
                MapShouYe.enterUI()
                MapPubUI.enterUI() 
                
            end
        else
            print("关闭loading界面")
        end
    end
end 

local function initMap()  
    Lb_1 = tolua.cast(Layer:getWidgetByName("LoadingBar_1"),"LoadingBar")
    --Lb_2 = tolua.cast(Layer:getWidgetByName("LoadingBar_2"),"LoadingBar")
    Lb_2 = tolua.cast(Layer:getWidgetByName("ImageView_1204"),"ImageView")
    lbl_tips = tolua.cast(Layer:getWidgetByName("Label_tips"),"Label")
    lbl_progress =  tolua.cast(Layer:getWidgetByName("Label_progress"),"Label")
   -- Lb_2:setPercent(100)

    for i=1,4 do
        table_img_tips[i] = tolua.cast(Layer:getWidgetByName("ImageView_tips"..i),"ImageView")
        table_img_tips[i]:setEnabled(false)
    end


    mLab_tips = Label:create()
    mLab_tips:setFontSize( 26 )
    mLab_tips:setPosition(ccp(UseW/2 -200,UseH*2/6 ))
    mLab_tips:setColor( ccc3(248, 227, 0) ) 
    mLab_tips:setAnchorPoint(ccp(0, 0.5) )     
    Layer:addChild(mLab_tips)

    local scheduler = CCDirector:sharedDirector():getScheduler()
    math.randomseed(os.time())
    lbl_tips:setText("友情提示："..Des.getRandomTipsDes())
    EntryID = scheduler:scheduleScriptFunc( updateTips, time, false)
    emitter1 = CCParticleSystemQuad:create("src/Particles/Loading_texture.plist")
    emitter1:setAnchorPoint(ccp(1,0.5))
    emitter1:setPosition(ccp(0,-2))
    emitter2 = CCParticleSystemQuad:create("src/Particles/Loading_texturehead.plist")
    emitter2:setPosition(ccp(particles_x,-3))
    Lb_2:addNode(emitter2)
    Lb_2:addNode(emitter1)
    progress = 0
    refresh_state()
       
   
end

function exitUI()
    local scheduler = CCDirector:sharedDirector():getScheduler()
    if EntryID ~= nil then
        scheduler:unscheduleScriptEntry(EntryID)
    end
    scene:removeChild(Layer, true)
end

function enterUI(curScene)
    scene = curScene
   
    Layer = TouchGroup:create()
    Layer:setZOrder(15)
    scene:addChild(Layer)
    print(" enterUI 2  ")
   
    local _widget = GUIReader:shareReader():widgetFromJsonFile("RL_UpdateData.json") 
    Layer:addWidget(_widget)

   _widget:setTouchEnabled(true)
 	
    initMap()
end
