module("Msdk_Login", package.seeall)

local Layer = nil
local _widget = nil
local scene = nil
local btn_Login =nil

msdkLoginMessageTab = { openId = "", accesstoken = "", pay_token = "", pf = "", pfkey = "", whichPlatform = "" ,hwUserid=""}



function setKeyEnabled(isCan)
    if Layer ~=nil then
        Layer:setKeypadEnabled(isCan)
    end
end

function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        _widget = nil
        Layer = nil
    end
end


function login_Success()
    exitUI()
    Msdk_Char.enterUI(scene)

end


local function loginCallBack(mResultTab)
    print("=====loginCallBack==", mResultTab.myOpenId)
    print("=====loginCallBack==", mResultTab.myToken)
    print("=====loginCallBack==", mResultTab.whichPlatform)
    -- 保存登录传过来的信息，后面支付用
    msdkLoginMessageTab.openId = mResultTab.myOpenId
    msdkLoginMessageTab.accesstoken = mResultTab.myToken
    msdkLoginMessageTab.pay_token = mResultTab.myPay_token
    msdkLoginMessageTab.pf = mResultTab.myPf
    msdkLoginMessageTab.pfkey = mResultTab.myPfkey
    msdkLoginMessageTab.whichPlatform = mResultTab.whichPlatform

    local function CallFucnCallback1()
        -- body
        print("======todo:CallFucnCallback1")
        Loading:LoadingShow()

        local function httpCallback(mhttpResultTab)
            Loading:LoadingHide()
            print("======todo:httpcallback")

            if mhttpResultTab.isResponseSuccess then
                if mhttpResultTab.errCode == 0 then
                    Pop3_TS_Result.enterUI("登录验证成功")

                    -- local function connectSuc()
                    --     protoSend0x0010(mResultTab.myOpenId, mResultTab.myToken)

                    --     print("=====login重连成功s1...")
                    -- end

                    -- local function connectFail()

                    --     print("=====login重连失败1...")
                    -- end
                    -- socketMachine:SocketConnect(nil, nil, connectSuc, connectFail)

                    PT.saveAccount("Account.lua", { ["name"] = mResultTab.myOpenId, ["password"] = ""})
                    -- exitUI()
                    -- RL_UpdateData.enterUI()

                    exitUI()
                    Msdk_Char.enterUI(scene)

                else
                    Pop3_TS_Result.enterUI("登录验证失败,请重试...")
                end
            else
                Pop3_TS_Result.enterUI("连接服务器失败,请重试...")
            end


        end

        local openid_url = "openid=" .. mResultTab.myOpenId
        local token_url = "&access_token=" .. mResultTab.myToken
        --local mUrl = "http://120.132.77.236:5021/sdk/qq/auth?" .. openid_url .. token_url
        --local mUrl = "http://" .. SERVER_ADDR_DEFAULT .. ":5021/sdk/qq/auth?" .. openid_url .. token_url
        local mUrl = "http://" .. SERVER_ADDR_DEFAULT .. ":5025/sdk/qq/auth?" .. openid_url .. token_url
        
        local openid_head = "openid:" .. mResultTab.myOpenId
        local token_head = "access_token:" .. mResultTab.myToken
        local whichPlat_head = "target:" .. mResultTab.whichPlatform
        --local str1 = openid_head .. "|" .. token_head .. "|" .. "Connection:Keep-Alive" .. "|" .. "Host:120.132.77.236:5021" .. "|" .. whichPlat_head
        --local str1 = openid_head .. "|" .. token_head .. "|" .. "Connection:Keep-Alive" .. "|" .. "Host:" .. SERVER_ADDR_DEFAULT .. ":5021" .. "|" .. whichPlat_head
        local str1 = openid_head .. "|" .. token_head .. "|" .. "Connection:Keep-Alive" .. "|" .. "Host:" .. SERVER_ADDR_DEFAULT .. ":5025" .. "|" .. whichPlat_head




        print("======todo:mUrl:" .. mUrl)
        print("======todo:mUrl:" .. str1)
        local myHttp = MyHttpRequest:create()
        myHttp:createMyHttpRequest(mUrl, httpCallback, 1, true, str1)

    end

    local action = CCSequence:createWithTwoActions(CCDelayTime:create(0.5), CCCallFunc:create(CallFucnCallback1))
    Layer:runAction(action)
end



local function mengLoginCallBack(mResultTab)
    print("=====loginCallBack==", mResultTab.myUserId)
    print("=====loginCallBack==", mResultTab.myPlatfromId)
    print("=====loginCallBack==", mResultTab.myLoginTime)

    btn_Login:setTouchEnabled(false)

    local function CallFucnCallback1()
        Loading:LoadingShow()
        local function httpCallback( mhttpResultTab )
             Loading:LoadingHide()
            print("======httpcallback" .. mhttpResultTab.errCode)

            if mhttpResultTab.isResponseSuccess then
                if mhttpResultTab.errCode == 0 then
                    btn_Login:setTouchEnabled(false)
                    Pop3_TS_Result.enterUI("登录验证成功")
                    local function connectSuc()
                        protoSend0x0010(mResultTab.myPlatfromId .. mResultTab.myUserId, "")
                        print("=====login重连成功s1...")
                    end

                    local function connectFail()
                        --todo:
                        print("=====login重连失败1...")
                         btn_Login:setTouchEnabled(true)
                    end
                    socketMachine:SocketConnect(nil, nil, connectSuc, connectFail)

                    PT.saveAccount("Account.lua", {["name"]=mResultTab.myUserId, ["password"] ="" })
                   

                else
                    btn_Login:setTouchEnabled(true)
                    Pop3_TS_Result.enterUI("登录验证失败,请重试...")
                end
            else
                 btn_Login:setTouchEnabled(true)
                Pop3_TS_Result.enterUI("连接服务器失败,请重试...")
            end


        end

        local openid_head = "userid:" .. mResultTab.myUserId
        local token_head = "platformid:" .. mResultTab.myPlatfromId
        local openid_head2 = "logintime:" .. mResultTab.myLoginTime
        local token_head2 = "sign:" .. mResultTab.mySign
        local str1 = openid_head .. "|" .. token_head .. "|" .. openid_head2 .. "|" .. token_head2 .. "|" .. "Connection:Keep-Alive" .. "|" .. "Host:" .. SERVER_ADDR_DEFAULT .. ":5021"

        local myHttp = MyHttpRequest:create()
        myHttp:createMyHttpRequest("http://" .. SERVER_ADDR_DEFAULT .. ":5021/sdk/xxwan/auth?userid=" .. mResultTab.myUserId .. "&platformid=" .. mResultTab.myPlatfromId .. "&logintime=" .. mResultTab.myLoginTime .. "&sign=" .. mResultTab.mySign,httpCallback,3,true,str1)

    end
    
    local action = CCSequence:createWithTwoActions(CCDelayTime:create(0.5), CCCallFunc:create(CallFucnCallback1))
    Layer:runAction(action)
end



local function huaWeiLoginCallBack(mResultTab )
    print("==========tokenhuawei" .. mResultTab.myToken)
    print("==========tokenhuawei" .. mResultTab.myUserid)
    msdkLoginMessageTab.hwUserid ="hw_" .. mResultTab.myUserid


     local function httpCallback( mhttpResultTab )
             Loading:LoadingHide()
            print("======httpcallback" .. mhttpResultTab.errCode)

            if mhttpResultTab.isResponseSuccess then
                if mhttpResultTab.errCode == 0 then
                    btn_Login:setTouchEnabled(false)
                    Pop3_TS_Result.enterUI("登录验证成功")
                    local function connectSuc()
                        protoSend0x0010("hw_" .. mResultTab.myUserid, "")
                        print("=====login重连成功s1...")
                    end

                    local function connectFail()
                        --todo:
                        print("=====login重连失败1...")
                         btn_Login:setTouchEnabled(true)
                    end
                    socketMachine:SocketConnect(nil, nil, connectSuc, connectFail)

                    PT.saveAccount("Account.lua", {["name"]="hw_" .. mResultTab.myUserid, ["password"] ="" })
                   

                else
                    btn_Login:setTouchEnabled(true)
                    Pop3_TS_Result.enterUI("登录验证失败,请重试...")
                end
            else
                 btn_Login:setTouchEnabled(true)
                Pop3_TS_Result.enterUI("连接服务器失败,请重试...")
            end


        end

       
        local token_head = "token:" .. mResultTab.myToken
        local str1 =token_head .. "|" .. "Connection:Keep-Alive" .. "|" .. "Host:" .. SERVER_ADDR_DEFAULT .. ":5021"

        local myHttp = MyHttpRequest:create()
        myHttp:createMyHttpRequest("http://" .. SERVER_ADDR_DEFAULT .. ":5021/sdk/huawei/auth",httpCallback,1,true,str1)


end



local function youleLoginCallBack(mResultTab)
    print("=====loginCallBack==", mResultTab.myUserId)
    print("=====loginCallBack==", mResultTab.myPlatfromId)

    btn_Login:setTouchEnabled(false)

    local function CallFucnCallback1()
        PT.saveAccount("Account.lua", { ["name"] ="yl" .. mResultTab.myPlatfromId .. mResultTab.myUserId, ["password"] ="" })
        
        exitUI()
        Msdk_Char.enterUI(scene)

    end
    
    local action = CCSequence:createWithTwoActions(CCDelayTime:create(0.5), CCCallFunc:create(CallFucnCallback1))
    Layer:runAction(action)
end


local function changeAccountCallBack()
    print("=======changeAccountCallBack")
   

    local function CallFucnCallback1()
         print("=======changeAccountCallBack=CallFucnCallback1")

         if PT.UI_State == UI_Msdk_Char then
                Msdk_Char.exitUI()
                Msdk_Login.enterUI(CCDirector:sharedDirector():getRunningScene())
                 print("=======changeAccountCallBack==11")
         elseif  PT.UI_State ~= UI_Msdk_Login then
            print("=======changeAccountCallBack==22")
            LM.relogin()
            MapShouYe.closeTimeG()
            MapYinKuang.closeTimeF()
            GK_PuTong.closeTimeE()
            MapNongTian.closeTimeD()
            LiaoTian.closeTimeC()
            NvShen_LieBiao.closeTimeB()
            NvShen_TuJian.closeTimeTuJian()
            Pop3_SaoDangNpcResult.closeTimeA()

            CDTimeManager.clearAllLble()

            PT.UI_State  = -1
            Msdk_Login.enterUI()
         end
       


    end

     local action = CCSequence:createWithTwoActions(CCDelayTime:create(1.0), CCCallFunc:create(CallFucnCallback1))
     CCDirector:sharedDirector():getRunningScene():runAction(action)
end




function enterUI(curScene)
    -- LM.UIlayerInit()
    if curScene == nil then
        scene = CCScene:create()
        CCDirector:sharedDirector():replaceScene(scene)
    else
        scene = curScene
    end

    PT.UI_State = UI_Msdk_Login

    -- Layer = LM.getLayer1Base_nom()
    Layer = TouchGroup:create()
    Layer:setZOrder(15)
    scene:addChild(Layer)

    PT.registerExitApp(Layer)

    _widget = GUIReader:shareReader():widgetFromJsonFile("Msdk_login.json")

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)

    --local img_bg = tolua.cast(Layer:getWidgetByName("ImageView_BG"), "ImageView")
    local emitter = CCParticleSystemQuad:create("LoginParticule.plist")
    emitter:setPosition(ccp(UseW*0.45, UseH * 0.75))
    -- emitter:setTag(10)
    _widget:addNode(emitter)

   
    

    local btn_QQ = tolua.cast(Layer:getWidgetByName("Button_QQ"), "Button")
    local btn_WeiXin = tolua.cast(Layer:getWidgetByName("Button_WeiXin"), "Button")
    btn_Login = tolua.cast(Layer:getWidgetByName("Button_login"), "Button")


     if ifTencentMsdk then
        -- 设置登录回调函数，因为有msdk的自动登录，所以放在这里
        TencentMsdk:setSDKLoginHandler(loginCallBack)
        -- msdk自动登录
        TencentMsdk:MyMSDKAutoLogin()
        btn_Login:setVisible(false)
        btn_Login:setTouchEnabled(false)
        
    elseif ifMengXiangSdk or ifHuaWeiSdk or ifYouLeSdk then
        btn_QQ:setTouchEnabled(false)
        btn_WeiXin:setTouchEnabled(false)

        btn_QQ:setVisible(false)
        btn_WeiXin:setVisible(false)
    end

    if ifHuaWeiSdk then

        TencentMsdk:setSDKChangeAccHandler(changeAccountCallBack)
    end


    local function btnCallback(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            local _btn = tolua.cast(sender, "Button")
            if _btn == btn_QQ then
                print("todo:QQ登录。。。。")
                
                TencentMsdk:QQ_Or_WeiXin_login(1)
                TencentMsdk:setSDKLoginHandler(loginCallBack)

                 --TencentMsdk:MyYoulePay("123","why",1,"10",1)

                -- local function httpCallback( mResultTab )
                --     -- body
                --     print("======httpcallback" .. mResultTab.errCode)

                --     if mResultTab.isResponseSuccess then
                --         if mResultTab.errCode == 0 then
                --             Pop3_TS_Result.enterUI("登录验证成功")
                --             local function connectSuc()
                --                 protoSend0x0010("A506122440B4A4F725C9C6777992CAE2", "38CF5C79E07B54B8048C15741C754938")
                --                 --protoSend0x0010( "123", "456")
                --                 print("=====login重连成功s1...")
                --             end

                --             local function connectFail()
                --                 --todo:
                --                 print("=====login重连失败1...")
                --             end
                --             socketMachine:SocketConnect(nil, nil, connectSuc, connectFail)

                --             PT.saveAccount("Account.lua", {["name"]="A506122440B4A4F725C9C6777992CAE2", ["password"] ="38CF5C79E07B54B8048C15741C754938" })
                --             -- exitUI()
                --             -- RL_UpdateData.enterUI()

                --         else
                --             Pop3_TS_Result.enterUI("登录验证失败,请重试...")
                --         end
                --     else
                --         Pop3_TS_Result.enterUI("连接服务器失败,请重试...")
                --     end


                -- end


                -- local openid_head = "openid:" .. "A506122440B4A4F725C9C6777992CAE2"
                -- local token_head = "access_token:" .. "38CF5C79E07B54B8048C15741C754938"
                -- --local openid_head = "openid:" .. "43B3ED4C04E4E70678F5A55DBA7006C9"
                -- --local token_head = "access_token:" .. "DCD632A4C7788C3A1E96A2DF43FD6284"
                -- local str1 = openid_head .. "|" .. token_head .. "|" .. "Connection:Keep-Alive" .. "|" .. "Host:" .. SERVER_ADDR_DEFAULT .. ":5021"

                -- local myHttp = MyHttpRequest:create()
                -- myHttp:createMyHttpRequest("http://" .. SERVER_ADDR_DEFAULT .. ":5021/sdk/qq/auth?openid=A506122440B4A4F725C9C6777992CAE2&access_token=38CF5C79E07B54B8048C15741C754938",httpCallback,1,true,str1)

                
            elseif _btn == btn_WeiXin then
                print("=======todo:微信登录。。。。")
                
                TencentMsdk:QQ_Or_WeiXin_login(2)
                TencentMsdk:setSDKLoginHandler(loginCallBack)

            elseif _btn == btn_Login then
                print("=======todo:梦想。。。。")
                    --exitUI()
                   -- Msdk_Char.enterUI(scene)
                if ifMengXiangSdk then
                    TencentMsdk:MyMengLogin()
                    TencentMsdk:setSDKLoginHandler(mengLoginCallBack)
                elseif ifHuaWeiSdk then
                    TencentMsdk:huaWeiLogin()
                    TencentMsdk:setSDKLoginHandler(huaWeiLoginCallBack)
                elseif ifYouLeSdk then
                    TencentMsdk:MyYouleLogin()
                    TencentMsdk:setSDKLoginHandler(youleLoginCallBack)
                end
            end
        end
    end
    btn_QQ:addTouchEventListener(btnCallback)
    btn_WeiXin:addTouchEventListener(btnCallback)
    btn_Login:addTouchEventListener(btnCallback)

end