module ("VipBase", package.seeall)

local curLayer = nil
--local curScene=nil

local remIndex = nil
--local remFatherUi = nil
local widget = nil
local path = {
	{["UI"] = nil, ["pic1"] = "button1_tong_2.jpg", ["pic2"] = "button1_tong_1.jpg", ["Imge"] = nil }, 
	{["UI"] = nil, ["pic1"] = "button1_tong_2.jpg", ["pic2"] = "button1_tong_1.jpg", ["Imge"] = nil },
}


function getRemIndex()
	return remIndex
end
function getPath()
	return path
end
function setRemIndex(index)
	remIndex=index
end




local function initPubUI( _index )
	local btn_close = tolua.cast( curLayer:getWidgetByName("Button_close"), "Button" )
	local function btn_closeCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			DelegateData.clearLabelButton()
			print("关闭")
			exitUI()
			path[remIndex]["UI"].exitUI()
		end
	end
	btn_close:addTouchEventListener( btn_closeCB )


	path[1]["Imge"] = tolua.cast( curLayer:getWidgetByName("ImageView_chongzhi"), "ImageView" )
	path[2]["Imge"] = tolua.cast( curLayer:getWidgetByName("ImageView_tequan"), "ImageView" )


---[[
	path[1]["UI"] = VipUI
	path[2]["UI"] = TeQuanUI

--]]
	local function Img_TouchCB(sender, eventType)
		local _img = tolua.cast(sender, "ImageView")
		if eventType == PT.ccs.TouchEventType.ended then
			
			if _img == path[1]["Imge"] then --充值

				print("充值")
				if remIndex == 1 then
					return
				end
				path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic1"] )
				path[remIndex]["UI"].exitUI()
				remIndex = 1
				path[remIndex]["UI"].enterUI()
			elseif _img == path[2]["Imge"] then --特权
				print("特权")
				
				if remIndex == 2 then
					return
				end
				path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic1"] )
				path[remIndex]["UI"].exitUI()
				remIndex = 2
				path[remIndex]["UI"].enterUI()
			end
			path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic2"] )
			
		end 
	end
	for i=1,2 do
		path[i]["Imge"]:addTouchEventListener( Img_TouchCB )
		path[i]["Imge"]:setTouchEnabled(true)
	end	

	local openBtn={}
	local btnTable=
	{
		{["id"]=30,["btn"]=path[1]["Imge"]},
		{["id"]=31,["btn"]=path[2]["Imge"]}	
	}
	for i=1, #btnTable do
		PT.hideManyBtn(openBtn,btnTable[i]["id"],btnTable[i]["btn"])
	end
	for i=1,#openBtn do
		openBtn[i]:setPosition(ccp(-359+110*(i-1),239))
	end

	remIndex = _index
	path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic2"] )
	path[remIndex]["UI"].enterUI(  )
	
end

function exitUI()
	if curLayer ~= nil and widget ~= nil then
		--curLayer:removeWidget(widget)
		curLayer:clear()
		widget = nil
		curLayer = nil
		
		LM.STATE_11 = 0
	end
	--[[
    if LM.STATE_9 == 1 then
        MapPubUI.setPubVisible(true)
    elseif LM.STATE_9 == 2 then
        GuoZhan_MainUI.setPubVisible(true)
    end
	--]]
end

function enterUI()
	if LM.STATE_11 == UI_Vip_TeQuan or
		LM.STATE_11 == UI_Vip_ChongZHi then
		return
	end

	--LM.clearLayer3ToUI()
	curLayer = LM.getLayer11()



	widget = GUIReader:shareReader():widgetFromJsonFile("VipBase.json")

	curLayer:addWidget(widget)
    widget:setTouchEnabled(true) --底层的widget设置为true，阻断点击事件的穿透
--[[
    if LM.STATE_9 == 1 then
        MapPubUI.setPubVisible(false)
    elseif LM.STATE_9 == 2 then
        GuoZhan_MainUI.setPubVisible(false)
    end
--]]
    initPubUI(1)
end

--[[
function enterUI(_curScene)

   	remFatherUi = PT.UI_State
    curScene = _curScene
    curLayer = TouchGroup:create()
	widget = GUIReader:shareReader():widgetFromJsonFile("VipBase.json")	
	curLayer:setZOrder(10)
    curLayer:addWidget(widget)
    curScene:addChild(curLayer)
    curScene:addChild( TouchEffect.setTouchEffect()  )
    
    initPubUI(1)
end
function exitUI()
	PT.UI_State=remFatherUi
    curScene:removeChild(curLayer, true)
end
--]]
