module ("GouLiang",package.seeall)
local Layer = nil
local _widget = nil
--local curScene = nil

local remIndex = nil

    --当前粮食
    --local lbl_curLiang = nil
    --当日粮草
    local lbl_todayLiang = nil
    --当日购粮上限
    local bai_max = nil
    --黑市购粮上限
    local hei_max = nil

    local LoadingBar_bai = nil
    local LoadingBar_hei = nil

    
local baiMax = 0
local baiJia = 0
local liangnum = 0
local heiliangnum = 0
local heiMax = 0
local heiJia = 0
--黑白两市买粮数量
local baiBuyNum = 0
local heiBuyNum = 0
local bai_liangcao = nil
local hei_liangcao = nil
local slid_bai = nil
local slid_hei = nil

local bai_yinbi = nil
local hei_yinbi = nil
function flushPanelMessage()
    local data = FoodData.getFoodData()
    --lbl_curLiang:setText( data["FoodLeft"] .. "/" .. data["FoodMax"] )
    lbl_todayLiang:setText( data["Today_buy"] .. "/" .. data["Today_Max"] .. "(凌晨5点或升级市场可刷新交易量)" )

    bai_max:setText( data["PuTongLim"] )
    baiMax = data["PuTongLim"]
    baiJia = data["PuTongJia"]
    hei_max:setText( data["HeiShiLim"] )
    heiMax = data["HeiShiLim"]
    heiJia = data["HeiShiJia"]
    slid_bai:setPercent(8)
    LoadingBar_bai:setPercent( 8 )
    slid_hei:setPercent(8)
    LoadingBar_hei:setPercent(8)
    bai_liangcao:setText(0)
    hei_liangcao:setText(0)
    bai_yinbi:setText( 0 )
    hei_yinbi:setText( 0 )
    liangnum = 0
    heiliangnum = 0
    --[[
    local percent = slid_bai:getPercent()
    local liangnum = 0 + (baiMax-0)*(percent-10)/(90-10)
    liangnum = math_floor(liangnum)
    local yinbi = liangnum*baiJia
    bai_yinbi:setText( yinbi )
    bai_liangcao:setText( liangnum )
    baiBuyNum = liangnum

    percent = slid_hei:getPercent()
    liangnum = 0 + (heiMax-0)*(percent-10)/(90-10)
    liangnum = math_floor(liangnum)
    yinbi = liangnum*heiJia
    hei_yinbi:setText( yinbi )
    hei_liangcao:setText( liangnum )
    heiBuyNum = liangnum
    --]]
end

local function _initPubMod()
    local bai_small     = tolua.cast( Layer:getWidgetByName("Label_bai_small"), "Label" )
    bai_small:setText("0")
    bai_max       = tolua.cast( Layer:getWidgetByName("Label_bai_big"), "Label" )

    bai_yinbi     = tolua.cast( Layer:getWidgetByName("Label_bai_yinbi"), "Label" )
    bai_liangcao  = tolua.cast( Layer:getWidgetByName("Label_bai_liangcao"), "Label" )
    bai_yinbi:setText(0)
    bai_liangcao:setText(0)

    local hei_small     = tolua.cast( Layer:getWidgetByName("Label_hei_small"), "Label" )
    hei_small:setText(0)
    hei_max       = tolua.cast( Layer:getWidgetByName("Label_hei_big"), "Label" )

    hei_yinbi     = tolua.cast( Layer:getWidgetByName("Label_hei_yinbi"), "Label" )
    hei_yinbi:setText(0)
    hei_liangcao  = tolua.cast( Layer:getWidgetByName("Label_hei_liangcao"), "Label" )
    hei_liangcao:setText(0)

	slid_bai = tolua.cast( Layer:getWidgetByName("Slider_baishi"), "Slider" )
	slid_hei = tolua.cast( Layer:getWidgetByName("Slider_heishi"), "Slider" )
    local function percentChangedEvent(sender,eventType)
        if eventType == PT.ccs.SliderEventType.percent_changed then
            local slider = tolua.cast(sender,"Slider")
            local percent = slider:getPercent()

            if slider == slid_bai then
                if percent< 7 then
                    percent = 7
                elseif percent > 93 then
                    percent = 93
                end
                slider:setPercent(percent)
                LoadingBar_bai:setPercent( percent )
                liangnum = (baiMax-0)*(percent-7)/(93-7)
                liangnum = math_floor(liangnum)
                local yinbi = liangnum*baiJia
                local curYinbi = PlayerData.getZeny()
                if yinbi > curYinbi then
                    bai_yinbi:setColor( ccc3(255, 0, 0) )
                else
                    bai_yinbi:setColor( ccc3(255, 255, 255) )
                end
                bai_yinbi:setText( yinbi )
                bai_liangcao:setText( liangnum )
                baiBuyNum = liangnum
            elseif slider == slid_hei then
                if percent< 7 then
                    percent = 7
                elseif percent > 93 then
                    percent = 93
                end
                slider:setPercent(percent)
                LoadingBar_hei:setPercent( percent )
                heiliangnum = 0 + (heiMax-0)*(percent-7)/(93-7)
                heiliangnum = math_floor(heiliangnum)
                local yinbi = heiliangnum*heiJia
                                local curYinbi = PlayerData.getZeny()
                if yinbi > curYinbi then
                    hei_yinbi:setColor( ccc3(255, 0, 0) )
                else
                    hei_yinbi:setColor( ccc3(255, 255, 255) )
                end
                hei_yinbi:setText( yinbi )
                hei_liangcao:setText( heiliangnum )
                heiBuyNum = heiliangnum
            end
        end
    end  
	slid_bai:addEventListenerSlider(percentChangedEvent)
	slid_hei:addEventListenerSlider(percentChangedEvent)


    --当前粮食
    --lbl_curLiang = tolua.cast( Layer:getWidgetByName("Label_liangshi"), "Label" )
    --今日交易量
    lbl_todayLiang = tolua.cast( Layer:getWidgetByName("Label_jiaoyiliang"), "Label" )
    --买进粮草
    local btn_BaiBuy = tolua.cast( Layer:getWidgetByName("Button_bai_buy"), "Button" )
    --黑市买粮
    local btn_HeiBuy = tolua.cast( Layer:getWidgetByName("Button_hei_buy"), "Button" )

    local btn_baiSmall  = tolua.cast( Layer:getWidgetByName("Button_bai_Jian"), "Button" )
    local btn_baiMax    = tolua.cast( Layer:getWidgetByName("Button_bai_jia"), "Button" )
    local btn_heiSmall  = tolua.cast( Layer:getWidgetByName("Button_hei_jian"), "Button" )
    local btn_heimax    = tolua.cast( Layer:getWidgetByName("Button_hei_jia"), "Button" )

    LoadingBar_bai = tolua.cast( Layer:getWidgetByName("LoadingBar_bai"), "LoadingBar" )
    LoadingBar_hei = tolua.cast( Layer:getWidgetByName("LoadingBar_hei"), "LoadingBar" )
    local function pubBtnCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then 
                    local _btn = tolua.cast(sender, "Button")
            if _btn == btn_BaiBuy then
                --todo:买进粮草
                protoSend0x0284(0, baiBuyNum)
            elseif _btn == btn_HeiBuy then
                --todo：黑市买粮
                protoSend0x0284(1, heiBuyNum)
            elseif _btn == btn_baiSmall then
                local percent = slid_bai:getPercent()
                --percent = percent - 1
                if percent< 7 then
                    slid_bai:setPercent(7)
                    LoadingBar_bai:setPercent( 7 )
                    return 
                elseif percent > 93 then
                    slid_bai:setPercent(93)
                    LoadingBar_bai:setPercent( 93 )
                    return
                end
                print("percent = " .. percent)
                liangnum = math_floor(liangnum)
                
                liangnum = liangnum - 1
                if liangnum < 0 then
                    liangnum = 0
                end
                print("liangnum == " .. liangnum .. " baiMax == " .. baiMax)
                percent = (liangnum*86)/baiMax + 7
                percent = math_floor(percent)
                print("des percent = " .. percent)
                slid_bai:setPercent( percent )
                LoadingBar_bai:setPercent( percent )
                --local liangnum = 0 + (baiMax-0)*(percent-10)/(90-10)
                --liangnum = math_floor(liangnum)
                local yinbi = liangnum*baiJia
                local curYinbi = PlayerData.getZeny()
                if yinbi > curYinbi then
                    bai_yinbi:setColor( ccc3(255, 0, 0) )
                else
                    bai_yinbi:setColor( ccc3(255, 255, 255) )
                end
                bai_yinbi:setText( yinbi )
                bai_liangcao:setText( liangnum )
                baiBuyNum = liangnum
            elseif _btn == btn_baiMax then
                local percent = slid_bai:getPercent()
                --percent = percent + 1
                if percent< 7 then
                    slid_bai:setPercent(7)
                    LoadingBar_bai:setPercent( 7 )
                    return 
                elseif percent > 93 then
                    slid_bai:setPercent(93)
                    LoadingBar_bai:setPercent( 93 )
                    return
                end
                
                liangnum = liangnum + 1
                if liangnum > baiMax then
                    liangnum = baiMax
                end
                liangnum = math_floor(liangnum)
                percent = (liangnum*86)/baiMax + 7
                percent = math_floor(percent)
                print(" add percent = " .. percent)
                slid_bai:setPercent( percent )
                LoadingBar_bai:setPercent( percent )
                local yinbi = liangnum*baiJia
                local curYinbi = PlayerData.getZeny()
                if yinbi > curYinbi then
                    bai_yinbi:setColor( ccc3(255, 0, 0) )
                else
                    bai_yinbi:setColor( ccc3(255, 255, 255) )
                end
                bai_yinbi:setText( yinbi )
                bai_liangcao:setText( liangnum )
                baiBuyNum = liangnum
            elseif _btn == btn_heiSmall then
                local percent = slid_hei:getPercent()
                --percent = percent - 1
                if percent< 7 then
                    slid_hei:setPercent(7)
                    LoadingBar_hei:setPercent( 7 )
                    return 
                elseif percent > 93 then
                    slid_hei:setPercent(93)
                    LoadingBar_hei:setPercent( 93 )
                    return
                end
                 print("percent = " .. percent)
                heiliangnum = math_floor(heiliangnum)
                
                heiliangnum = heiliangnum - 1
                if heiliangnum < 0 then
                    heiliangnum = 0
                end
                --print("liangnum == " .. liangnum .. " baiMax == " .. baiMax)
                percent = (heiliangnum*86)/heiMax + 7
                percent = math_floor(percent)
                print("des percent = " .. percent)
                slid_hei:setPercent( percent )
                LoadingBar_hei:setPercent( percent )
                --local liangnum = 0 + (heiMax-0)*(percent-10)/(90-10)
                --liangnum = math_floor(liangnum)
                local yinbi = heiliangnum*heiJia
                                local curYinbi = PlayerData.getZeny()
                if yinbi > curYinbi then
                    hei_yinbi:setColor( ccc3(255, 0, 0) )
                else
                    hei_yinbi:setColor( ccc3(255, 255, 255) )
                end
                hei_yinbi:setText( yinbi )
                hei_liangcao:setText( heiliangnum )
                heiBuyNum = heiliangnum
            elseif _btn == btn_heimax then
                local percent = slid_hei:getPercent()
                --percent = percent + 1
                if percent< 7 then
                    slid_hei:setPercent(7)
                    LoadingBar_hei:setPercent( 7 )
                    return 
                elseif percent > 93 then
                    slid_hei:setPercent(93)
                    LoadingBar_hei:setPercent( 93 )
                    return
                end
                heiliangnum = math_floor(heiliangnum)
                
                heiliangnum = heiliangnum + 1
                if heiliangnum > heiMax then
                    heiliangnum = heiMax
                end
                --print("liangnum == " .. liangnum .. " baiMax == " .. baiMax)
                percent = (heiliangnum*86)/heiMax + 7
                percent = math_floor(percent)
                print("des percent = " .. percent)
                slid_hei:setPercent( percent )
                LoadingBar_hei:setPercent( percent )
                --local liangnum = 0 + (heiMax-0)*(percent-10)/(90-10)
                --liangnum = math_floor(liangnum)
                local yinbi = heiliangnum*heiJia
                                local curYinbi = PlayerData.getZeny()
                if yinbi > curYinbi then
                    hei_yinbi:setColor( ccc3(255, 0, 0) )
                else
                    hei_yinbi:setColor( ccc3(255, 255, 255) )
                end
                hei_yinbi:setText( yinbi )
                hei_liangcao:setText( heiliangnum )
                heiBuyNum = heiliangnum
            end
        end
    end
    btn_BaiBuy:addTouchEventListener(pubBtnCB)
    btn_HeiBuy:addTouchEventListener(pubBtnCB)
    
    btn_baiSmall:addTouchEventListener(pubBtnCB)
    btn_baiMax:addTouchEventListener(pubBtnCB)
    btn_heiSmall:addTouchEventListener(pubBtnCB)
    btn_heimax:addTouchEventListener(pubBtnCB)

    flushPanelMessage()
end

function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        --Layer:clear()
        _widget = nil
        Layer = nil
        
        LM.STATE_3 = 0
    end
end

function enterUI()
    LM.STATE_3 = UI_ZhengShou_GouLiang

    Layer = LM.getLayer3()
    _widget = GUIReader:shareReader():widgetFromJsonFile("ZhengShou_GL.json")   

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(false)

    _initPubMod()
end

--[[
function enterUI( _Scene )
    PT.UI_State = UI_ZhengShou_GouLiang
	curScene = _Scene
	Layer = TouchGroup:create()
    Layer:setZOrder(10)
	--Layer:setTouchEnabled(false)
    local _widget = GUIReader:shareReader():widgetFromJsonFile("ZhengShou_GL.json")    
    _widget:setTouchEnabled(false)
    Layer:addWidget(_widget)
    _Scene:addChild(Layer)

 	_initPubMod()
end

function exitUI()
	curScene:removeChild(Layer, true)
	--Layer:onExit()
end
--]]