module ("zhongQiuActivity",package.seeall)
local Layer = nil
local _widget = nil


local function initPubUI( )
	local Img_BackBG =tolua.cast(Layer:getWidgetByName("ImageView_bg"), "ImageView")
	--Img_BackBG:loadTexture("floor+2_qiyuhuodong.jpg")
	local targetPlatform = CCApplication:sharedApplication():getTargetPlatform()

	local addHangHeight = 0
	if targetPlatform==kTargetWindows then
		addHangHeight=0
	else
		addHangHeight=1
	end

	local panel_content1 = tolua.cast(Layer:getWidgetByName("Panel_content1"), "Layout")

		local _richText = RichText:create()
	 	_richText:ignoreContentAdaptWithSize(false)
	 	_richText:setSize(CCSizeMake(555, 70))
	 	_richText:setAnchorPoint( ccp(0, 0.5) )
		_richText:setPosition(ccp(10,60))
		_richText:setTag(100)

		local _re11 = RichElementText:create(1, ccc3(GoodsColorTab[4][1], GoodsColorTab[4][2], GoodsColorTab[4][3]), 255, "欢天喜地迎中秋啦！绝色三国特送上丰厚的大礼！感谢各位主公长期以来的厚爱！", "Helvetica", 24);
		_richText:pushBackElement( _re11 )
	panel_content1:addChild( _richText )



	local panel_content2 = tolua.cast(Layer:getWidgetByName("Panel_content2"), "Layout")

	local lbl_title1 = Label:create()
    lbl_title1:setText( "活动一·中秋祝福：")
    lbl_title1:setFontSize( 24 )
    lbl_title1:setPosition(ccp(10,295))
    lbl_title1:setAnchorPoint(ccp(0,0.5))
    lbl_title1:setColor( ccc3( GoodsColorTab[4][1], GoodsColorTab[4][2], GoodsColorTab[4][3]) )
	panel_content2:addChild(lbl_title1)

	local _richText2 = RichText:create()
	 	_richText2:ignoreContentAdaptWithSize(false)
	 	_richText2:setSize(CCSizeMake(360, 70))
	 	_richText2:setAnchorPoint( ccp(0, 0.5) )
		_richText2:setPosition(ccp(195,275))
		_richText2:setTag(100)

		local _re21 = RichElementText:create(1, ccc3(GoodsColorTab[1][1], GoodsColorTab[1][2], GoodsColorTab[1][3]), 255, "活动期间玩家通过银币", "Helvetica", 24);
		_richText2:pushBackElement( _re21 )
		local _re22 = RichElementText:create(1, ccc3(GoodsColorTab[3][1], GoodsColorTab[3][2], GoodsColorTab[3][3]), 255, "祭祀", "Helvetica", 24);
		_richText2:pushBackElement( _re22 )
		local _re23 = RichElementText:create(1, ccc3(GoodsColorTab[1][1], GoodsColorTab[1][2], GoodsColorTab[1][3]), 255, "可额外获得祭祀所得", "Helvetica", 24);
		_richText2:pushBackElement( _re23 )
		local _re24 = RichElementText:create(1, ccc3(GoodsColorTab[5][1], GoodsColorTab[5][2], GoodsColorTab[5][3]), 255, "银币20%加成。", "Helvetica", 24);
		_richText2:pushBackElement( _re24 )
	panel_content2:addChild( _richText2 )


	local lbl_title2 = Label:create()
    lbl_title2:setText( "活动二·中秋祭祀：")
    lbl_title2:setFontSize( 24 )
    lbl_title2:setPosition(ccp(10,240-addHangHeight*4))
    lbl_title2:setAnchorPoint(ccp(0,0.5))
    lbl_title2:setColor( ccc3( GoodsColorTab[4][1], GoodsColorTab[4][2], GoodsColorTab[4][3]) )
	panel_content2:addChild(lbl_title2)

	local _richText3 = RichText:create()
	 	_richText3:ignoreContentAdaptWithSize(false)
	 	_richText3:setSize(CCSizeMake(360, 70))
	 	_richText3:setAnchorPoint( ccp(0, 0.5) )
		_richText3:setPosition(ccp(195,220-addHangHeight*4))
		_richText3:setTag(100)

		local _re31 = RichElementText:create(1, ccc3(GoodsColorTab[1][1], GoodsColorTab[1][2], GoodsColorTab[1][3]), 255, "活动期间每天", "Helvetica", 24);
		_richText3:pushBackElement( _re31 )
		local _re32 = RichElementText:create(1, ccc3(GoodsColorTab[3][1], GoodsColorTab[3][2], GoodsColorTab[3][3]), 255, "祭祀", "Helvetica", 24);
		_richText3:pushBackElement( _re32 )
		local _re33 = RichElementText:create(1, ccc3(GoodsColorTab[1][1], GoodsColorTab[1][2], GoodsColorTab[1][3]), 255, "祭祀一定次数，可以开启多次", "Helvetica", 24);
		_richText3:pushBackElement( _re33 )
		local _re34 = RichElementText:create(1, ccc3(GoodsColorTab[5][1], GoodsColorTab[5][2], GoodsColorTab[5][3]), 255, "中秋礼包", "Helvetica", 24);
		_richText3:pushBackElement( _re34 )
		local _re35 = RichElementText:create(1, ccc3(GoodsColorTab[1][1], GoodsColorTab[1][2], GoodsColorTab[1][3]), 255, "哦！每日礼包不同，各位主公要多关注哦！", "Helvetica", 24);
		_richText3:pushBackElement( _re35 )
	panel_content2:addChild( _richText3 )



	local lbl_title3 = Label:create()
    lbl_title3:setText( "活动三·战绩无双：")
    lbl_title3:setFontSize( 24 )
    lbl_title3:setPosition(ccp(10,160-addHangHeight*17))
    lbl_title3:setAnchorPoint(ccp(0,0.5))
    lbl_title3:setColor( ccc3( GoodsColorTab[4][1], GoodsColorTab[4][2], GoodsColorTab[4][3]) )
	panel_content2:addChild(lbl_title3)

	local _richText4 = RichText:create()
	 	_richText4:ignoreContentAdaptWithSize(false)
	 	_richText4:setSize(CCSizeMake(360, 70))
	 	_richText4:setAnchorPoint( ccp(0, 0.5) )
		_richText4:setPosition(ccp(195,140-addHangHeight*17))
		_richText4:setTag(100)

		local _re41 = RichElementText:create(1, ccc3(GoodsColorTab[1][1], GoodsColorTab[1][2], GoodsColorTab[1][3]), 255, "活动期间每天", "Helvetica", 24);
		_richText4:pushBackElement( _re41 )
		local _re42 = RichElementText:create(1, ccc3(GoodsColorTab[4][1], GoodsColorTab[4][2], GoodsColorTab[4][3]), 255, "战斗", "Helvetica", 24);
		_richText4:pushBackElement( _re42 )
		local _re43 = RichElementText:create(1, ccc3(GoodsColorTab[1][1], GoodsColorTab[1][2], GoodsColorTab[1][3]), 255, "一定次数，可以开启多次", "Helvetica", 24);
		_richText4:pushBackElement( _re43 )
		local _re44 = RichElementText:create(1, ccc3(GoodsColorTab[5][1], GoodsColorTab[5][2], GoodsColorTab[5][3]), 255, "中秋礼包", "Helvetica", 24);
		_richText4:pushBackElement( _re44 )
		local _re45 = RichElementText:create(1, ccc3(GoodsColorTab[1][1], GoodsColorTab[1][2], GoodsColorTab[1][3]), 255, "哦！每日礼包不同，各位主公要多关注哦！", "Helvetica", 24);
		_richText4:pushBackElement( _re45 )
	panel_content2:addChild( _richText4 )


	local lbl_title4 = Label:create()
    lbl_title4:setText( "活动四·登陆大礼：")
    lbl_title4:setFontSize( 24 )
    lbl_title4:setPosition(ccp(10,80-addHangHeight*28))
    lbl_title4:setAnchorPoint(ccp(0,0.5))
    lbl_title4:setColor( ccc3( GoodsColorTab[4][1], GoodsColorTab[4][2], GoodsColorTab[4][3]) )
	panel_content2:addChild(lbl_title4)

	local _richText5 = RichText:create()
	 	_richText5:ignoreContentAdaptWithSize(false)
	 	_richText5:setSize(CCSizeMake(360, 70))
	 	_richText5:setAnchorPoint( ccp(0, 0.5) )
		_richText5:setPosition(ccp(195,60-addHangHeight*28))
		_richText5:setTag(100)

		local _re51 = RichElementText:create(1, ccc3(GoodsColorTab[1][1], GoodsColorTab[1][2], GoodsColorTab[1][3]), 255, "活动期间", "Helvetica", 24);
		_richText5:pushBackElement( _re51 )
		local _re52 = RichElementText:create(1, ccc3(GoodsColorTab[2][1], GoodsColorTab[2][2], GoodsColorTab[2][3]), 255, "每日登录", "Helvetica", 24);
		_richText5:pushBackElement( _re52 )
		local _re53 = RichElementText:create(1, ccc3(GoodsColorTab[1][1], GoodsColorTab[1][2], GoodsColorTab[1][3]), 255, "可额外获得", "Helvetica", 24);
		_richText5:pushBackElement( _re53 )
		local _re54 = RichElementText:create(1, ccc3(GoodsColorTab[4][1], GoodsColorTab[4][2], GoodsColorTab[4][3]), 255, "10金币。", "Helvetica", 24);
		_richText5:pushBackElement( _re54 )
		-- local _re55 = RichElementText:create(1, ccc3(GoodsColorTab[1][1], GoodsColorTab[1][2], GoodsColorTab[1][3]), 255, "哦！每日礼包不同，各位主公要多关注哦！", "Helvetica", 24);
		-- _richText5:pushBackElement( _re55 )
	panel_content2:addChild( _richText5 )

end


function exitUI()
	if Layer ~= nil and _widget ~= nil then
		Layer:removeWidget(_widget)
		_widget = nil
		Layer = nil
		--LM.STATE_4 = 0
	end
end

function enterUI()
	--LM.STATE_4 = UI_HuoDong_XinFuDouble
	Layer = LM.getLayer4()
	_widget = GUIReader:shareReader():widgetFromJsonFile("ZhongQiuHuoDongType1_1.json")

	Layer:addWidget(_widget)
    _widget:setTouchEnabled(false) --底层的widget设置为true，阻断点击事件的穿透

    initPubUI()
end


