module ("zhongQiuJiSi",package.seeall)
local Layer = nil
local _widget = nil
local whichType = 1   --1祭祀  2征战

local Lab_Num1= nil
local Lab_Num2= nil
local btn_openBox =nil

local jiSiContents = {
"祭祀次数达到<4:10次>，<4:25次>，<4:50次>，分别可打开<6:中秋礼包[1]><4:5次、10次、20次>。当天不领不可补领哦！",
"<6:中秋礼包[1]>打开后可随机获得 -- <4:声望、军功、银币、粮草、军令>等资源其中一种，打开时还有几率<5:暴击>获得<5:多倍奖励>",
"祭祀次数达到<4:10次>，<4:25次>，<4:50次>，分别可打开<6:中秋礼包[2]><4:5次、10次、20次>。当天不领不可补领哦！",
"<6:中秋礼包[2]>打开后可随机获得 -- <3:五彩石[绿]>、<4:五彩石[黄]>、<5:五彩石[红]>、<6:紫霞仙丹>等资源其中一种，打开时还有几率<5:暴击>获得<5:多倍奖励>",
}

local zhengZhanContents = {
"通过征战、世界累计战斗次数达到<4:30次>，<4:60次>，<4:90次>，分别可打开<6:中秋礼包[1]><4:5次、10次、20次>。当天不领不可补领哦！",
"<6:中秋礼包[1]>打开后可随机获得 -- <4:声望、军功、银币、粮草、军令>等资源其中一种，打开时还有几率<5:暴击>获得<5:多倍奖励>",
"通过征战、世界累计战斗次数达到<4:30次>，<4:60次>，<4:90次>，分别可打开<6:中秋礼包[2]><4:5次、10次、20次>。当天不领不可补领哦！",
"<6:中秋礼包[2]>打开后可随机获得 -- <3:五彩石[绿]>、<4:五彩石[黄]>、<5:五彩石[红]>、<6:紫霞仙丹>等资源其中一种，打开时还有几率<5:暴击>获得<5:多倍奖励>",
}


local function paseTT(_str)
    local str2 = _str
    local i, j = string_find(str2 , "~")
    if i ~= nil then
        print("替代 1 。。。")
        str2=string.gsub(str2, "~", "~ ")
    end
    i, j = string_find(str2 , "{")
    if i ~= nil then
        print("替代 2 。。。")
        str2=string.gsub(str2, "{", " { ")
    end
    
    i, j = string_find(str2 , "’")
    if i ~= nil then
        print("替代 3 。。。")
        str2=string.gsub(str2, "’", " ’ ")
    end

    i, j = string_find(str2 , "”")
    if i ~= nil then
        print("替代 4 。。。")
        str2=string.gsub(str2, "”", " ” ")
    end

    i, j = string_find(str2 , ",")
    if i ~= nil then 
        print("替代 5 。。。")
        str2=string.gsub(str2, ",", " , ")
    end

    i, j = string_find(str2 , ":")
    if i ~= nil then
        print("替代 6 。。。")
        str2=string.gsub(str2, ":", " : ")
    end

    i, j = string_find(str2 , "\"")
    if i ~= nil then
        print("替代 7 。。。")
        str2=string.gsub(str2, "\"", " \" ")
    end
--[[            
    --英文的"."有问题
    i, j = string_find(str2 , ".")
    if i ~= nil then
        str2=string.gsub(str2, ".", " . ")
    end
--]]
    return str2
end



function flushMyZhongQiuUi( )
	local zhongqiuData = HuoDongData.getZhongQiuData()

	if whichType==1 then
    	Lab_Num1:setText(zhongqiuData["jisiAlready"])
    	Lab_Num2:setText(zhongqiuData["jisiCanOpen"])

    	if zhongqiuData["jisiCanOpen"] >0 then
			btn_openBox:setTouchEnabled(true)
			btn_openBox:setBright(true)
		else
			btn_openBox:setTouchEnabled(false)
			btn_openBox:setBright(false)
		end
    else
    	Lab_Num1:setText(zhongqiuData["zhengZhanAlready"])
    	Lab_Num2:setText(zhongqiuData["zhengZhanCanOpen"])

    	if zhongqiuData["zhengZhanCanOpen"] >0 then
			btn_openBox:setTouchEnabled(true)
			btn_openBox:setBright(true)
		else
			btn_openBox:setTouchEnabled(false)
			btn_openBox:setBright(false)
		end
    end

end


local function initPubUI( )
	--local Img_BackBG =tolua.cast(Layer:getWidgetByName("ImageView_bg"), "ImageView")
	--Img_BackBG:loadTexture("floor+2_qiyuhuodong.jpg")
	local zhongqiuData = HuoDongData.getZhongQiuData()
	--开宝箱
	btn_openBox = tolua.cast( Layer:getWidgetByName("Button_openBox"), "Button" )
	local function btn_touchCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			local _btn = tolua.cast(sender, "Button")
			if _btn == btn_openBox then
				if whichType==1 then
					protoSend0x0574(2)
				else
					protoSend0x0574(1)
				end
				
			end
		end
	end
	btn_openBox:addTouchEventListener( btn_touchCB )

	


	local Lab_huodongTime= tolua.cast( Layer:getWidgetByName("Label_time1"), "Label" )
	

	local Lab_JiSi1= tolua.cast( Layer:getWidgetByName("Label_jisi1"), "Label" )
	Lab_Num1= tolua.cast( Layer:getWidgetByName("Label_num1"), "Label" )
	Lab_Num2= tolua.cast( Layer:getWidgetByName("Label_num2"), "Label" )
	local Lab_GoodsName= tolua.cast( Layer:getWidgetByName("Label_goodsName"), "Label" )

	local Img_Libao =tolua.cast(Layer:getWidgetByName("ImageView_libao"), "ImageView")

	local panel_content1 = tolua.cast(Layer:getWidgetByName("Panel_content1"), "Layout")


	

	if zhongqiuData["mdays"]==1 then
		Lab_huodongTime:setText("9月26日")
		Img_Libao:loadTexture("floor+1_zhongqiu.png")
		Lab_GoodsName:setText("获得声望1000[暴击]")
    else
		Lab_huodongTime:setText("9月27日")
		Img_Libao:loadTexture("floor+2_zhongqiu.png")
		Lab_GoodsName:setText("获得紫霞仙丹x2")
    end


	local tipsContents =""

	local tipsContents2 = ""

    if whichType==1 then
    	if zhongqiuData["mdays"]==1 then
    		tipsContents =jiSiContents[1]
    		tipsContents2 = jiSiContents[2]
    	else
    		tipsContents =jiSiContents[3]
    		tipsContents2 = jiSiContents[4]
    	end
    	Lab_JiSi1:setText("已祭祀")
    	-- "祭祀次数达到10次，25次，50次，分别可打开中秋礼包[1]5次、10次、20次。当天不领不可补领哦！"
    else
    	if zhongqiuData["mdays"]==1 then
    		tipsContents = zhengZhanContents[1]
    		tipsContents2 = zhengZhanContents[2]
    	else
    		tipsContents = zhengZhanContents[3]
    		tipsContents2 = zhengZhanContents[4]
    	end
    	Lab_JiSi1:setText("已征战")
    	--"通过征战、世界累计战斗次数达到30次、60次、90次，分别可打开无双礼包[1]5次、10次、20次。当天不领不可补领哦！"
    end


	local _richText1 = RichText:create()
	 	_richText1:ignoreContentAdaptWithSize(false)
	 	_richText1:setSize(CCSizeMake(450, 70))
	 	_richText1:setAnchorPoint( ccp(0, 0.5) )
		_richText1:setPosition(ccp(110,80))
		_richText1:setTag(100)

		local function addElement( _str, _typeColor )
            _str = paseTT(_str)
            local _re1 = RichElementText:create(1, ccc3(GoodsColorTab[_typeColor][1], GoodsColorTab[_typeColor][2], GoodsColorTab[_typeColor][3]), 255, _str, "Helvetica", 24);
            _richText1:pushBackElement( _re1 )
        end

        local parsestr = nil
        parsestr = function (_str)
            local len = string.len(_str)
            local i, j = string.find(_str , "<")
            if i ~= nil then
                local str1 = string.sub(_str, 1, i-1) --截取<之前的数据
                print(str1)
                addElement(str1, 1)

                _str = string.sub(_str, j+1, len)--截取<之后的数据
                len = string.len(_str)
                i, j = string.find(_str , ":")
                if i == 2 then --: 位置
                    local number = tonumber( string.sub(_str, 1, i-1) ) --截取色值索引

                    _str = string.sub(_str, j+1, len) --截取:后数据
                    len = string.len(_str)
                    i, j = string.find(_str , ">")
                    if i~= nil then
                        print(number)
                        local str2 = string.sub(_str, 1, i-1) --截取:后>前数据
                        print(str2)
                        --todo:正确的颜色节点
                        addElement( str2, number )
                        _str = string.sub(_str, j+1, len) --截取>后数据
                        --递归解析
                        parsestr(_str )
                    else --没有:
                        _str = "<" .. number .. ":" .. _str --恢复数据
                        print("1_error: " .. _str)
                        --todo:普通节点
                        addElement(_str, 1)
                    end
                else -- < 尖括号里没有: 把
                    _str = "<" .. _str --恢复数据
                    print("2_error: " .. _str)
                    --todo:普通节点
                    addElement(_str, 1)
                end
            else
                print("3_error: " .. _str)
                --todo:普通节点
                addElement(_str, 1)
                print("4_error: " .. _str)
            end
        end     
        parsestr(tipsContents)
	
	panel_content1:addChild( _richText1 )

		


	local panel_content2 = tolua.cast(Layer:getWidgetByName("Panel_content2"), "Layout")
	
	local _richText2 = RichText:create()
	 	_richText2:ignoreContentAdaptWithSize(false)
	 	_richText2:setSize(CCSizeMake(550, 70))
	 	_richText2:setAnchorPoint( ccp(0, 0.5) )
		_richText2:setPosition(ccp(15,80))
		_richText2:setTag(100)

		local function addElement2( _str, _typeColor )
            _str = paseTT(_str)
            local _re1 = RichElementText:create(1, ccc3(GoodsColorTab[_typeColor][1], GoodsColorTab[_typeColor][2], GoodsColorTab[_typeColor][3]), 255, _str, "Helvetica", 24);
            _richText2:pushBackElement( _re1 )
        end

        local parsestr = nil
        parsestr = function (_str)
            local len = string.len(_str)
            local i, j = string.find(_str , "<")
            if i ~= nil then
                local str1 = string.sub(_str, 1, i-1) --截取<之前的数据
                print(str1)
                addElement2(str1, 1)

                _str = string.sub(_str, j+1, len)--截取<之后的数据
                len = string.len(_str)
                i, j = string.find(_str , ":")
                if i == 2 then --: 位置
                    local number = tonumber( string.sub(_str, 1, i-1) ) --截取色值索引

                    _str = string.sub(_str, j+1, len) --截取:后数据
                    len = string.len(_str)
                    i, j = string.find(_str , ">")
                    if i~= nil then
                        print(number)
                        local str2 = string.sub(_str, 1, i-1) --截取:后>前数据
                        print(str2)
                        --todo:正确的颜色节点
                        addElement2( str2, number )
                        _str = string.sub(_str, j+1, len) --截取>后数据
                        --递归解析
                        parsestr(_str )
                    else --没有:
                        _str = "<" .. number .. ":" .. _str --恢复数据
                        print("1_error: " .. _str)
                        --todo:普通节点
                        addElement2(_str, 1)
                    end
                else -- < 尖括号里没有: 把
                    _str = "<" .. _str --恢复数据
                    print("2_error: " .. _str)
                    --todo:普通节点
                    addElement2(_str, 1)
                end
            else
                print("3_error: " .. _str)
                --todo:普通节点
                addElement2(_str, 1)
                print("4_error: " .. _str)
            end
        end     
        parsestr(tipsContents2)
		
	panel_content2:addChild( _richText2 )

	flushMyZhongQiuUi()

end


function exitUI()
	if Layer ~= nil and _widget ~= nil then
		Layer:removeWidget(_widget)
		_widget = nil
		Layer = nil
		LM.STATE_4 = 0
		whichType=1
	end
end

function enterUI(_type)
	whichType=_type
	LM.STATE_4 =999
	Layer = LM.getLayer4()
	_widget = GUIReader:shareReader():widgetFromJsonFile("ZhongQiuHuoDongType2.json")

	Layer:addWidget(_widget)
    _widget:setTouchEnabled(false) --底层的widget设置为true，阻断点击事件的穿透

    initPubUI()
end


