module ("GNR_JiangLing",package.seeall)

--local curScene = nil
local Layer = nil
local _widget = nil

local remGeneralIdx = nil
--local starcolor = {{0,170,249},{0,248,23},{255,255,0},{255,0,0},{205,14,252}} --蓝，绿，黄，红，紫
local img_body 			= nil
local lbl_name 			= nil
local lbl_lv 			= nil
local lbl_yong 			= nil
local lbl_tong 			= nil
local lbl_zhi 			= nil
local lbl_bingzhong 	= nil
local lbl_xingjie 		= nil
local lbl_bingli 		= nil
local lbl_zhanfa 		= nil
local lbl_bingzhonJS 	= nil
local lbl_zhanfaJS 		= nil

local lbl_nvShen = nil

local function flushMessage(_dataIdx)
	if ifserver then
		local data = GeneralData.getYesGeneralDataFromIndex(_dataIdx)
		local id = data["GenneralId"]
		local desData = Des.getGeneralDesFromId( id )

		img_body:loadTexture( RoleBodyPath .. desData["generalBodyIcon"] .. ".png" )
		lbl_name:setText( desData["generalName"] )
		lbl_lv:setText("LV " .. data["Lv"] )
		lbl_yong:setText( data["Attr_y"]+data["Plus_y"] )
		lbl_tong:setText( data["Attr_t"]+data["Plus_t"] )
		lbl_zhi:setText( data["Attr_m"]+data["Plus_m"] )

		local _Z, _X = math_modf( data["UnitLv"]/10 )
		lbl_xingjie:setText( _Z .. "阶" .. _X*10 .. "星")
		
		lbl_bingli:setText( data["CurHp"] .. "/" .. data["TotalHp"] )
		---[[
		local unitId = data["Unit"]
		local desUnit = Des.getUnitDesFromId( unitId )
		lbl_bingzhong:setText( desUnit["unitName"] )
		lbl_bingzhonJS:setText( desUnit["unitDes"] )
		--lbl_zhanfaJS:setText( desUnit["unitDes"] )
		
		local skillId = data["Skill"]
		print("skillId == " .. skillId)
		if skillId == 0 then
			lbl_zhanfa:setText("无")
			lbl_zhanfaJS:setText("无")
			--lbl_bingzhonJS:setText("无")
		else
			local desSkill = Des.getSpAttackDesFromId( skillId )
			lbl_zhanfa:setText( desSkill["SpAttackName"] )
			local _js = desSkill["SpAttackDes"]
		--[[	if string_len(_js) > 30 then
				_js = string_sub(_js, 1, 27)
				_js = _js .. "..."
			end]]
			lbl_zhanfaJS:setText( _js )
			--lbl_bingzhonJS:setText( _js )
		end
		--]]
     if data["GoddessId"] == 0 then --没有女神
        --lbl_nsshuxing:setColor(ccc3(255,255,255))
	    lbl_nvShen:setText("无")
	    lbl_nvShen:setColor(ccc3(GoodsColorTab[1][1],GoodsColorTab[1][2],GoodsColorTab[1][3]))
        --lbl_nsshuxing:setText("无")
        --lbl_nslv:setText("无")
        --lbl_nspinjie:setText("无")
        --lbl_nvTip:setText("")
	else
  
        --lbl_nslv:setText(data["GoddessLv"])
        local goddesstype =nil
        if data["GoddessType"] == 1 then
 			goddesstype = "火"
 			--lbl_nsshuxing:setColor(ccc3(starcolor[4][1],starcolor[4][2],starcolor[4][3]))
            --lbl_nvTip:setText("(晴天攻击力增强)")
          
 		elseif data["GoddessType"] == 2 then
 			goddesstype = "水"
 			--lbl_nsshuxing:setColor(ccc3(starcolor[1][1],starcolor[1][2],starcolor[1][3]))
            --lbl_nvTip:setText("(雨天攻击力增强)")
 		else
            --lbl_nsshuxing:setColor(ccc3(starcolor[2][1],starcolor[2][2],starcolor[2][3]))
 			goddesstype = "风"
            --lbl_nvTip:setText("(阴天攻击力增强)")
 			
 		end
        --lbl_nsshuxing:setText(goddesstype)
		local desGods = Des.getGoddessDesFromId( data["GoddessId"] )
		--local desGodsSkill = Des.goddessSkillDes( data[""] )
		local quality,_= PT.checkeGodQuality(data["GoddessStar"]) --math_modf( data["GoddessStar"]/11 )
		local star = data["GoddessStar"]%11
  --[[     
        local quality,_ = math.modf(starAllNumber/ 11) 
	print("the quality  is "..quality)
	print("the starAllNumber is "..starAllNumber)]]
	    local color = nil
	    if quality== 4 then
           
		    color = "紫色"		
   	    elseif  quality==3 then
	        color = "红色"
           
        elseif 	quality ==2 then
		    color = "黄色"
				
	    elseif quality == 1 then
		    color = "绿色"
					
        elseif quality==0 then
		    color = "蓝色"					
	    end
	     --lbl_nspinjie:setText(color..star.."星")

      --  lbl_nspinjie:set
         local desGods = Des.getGoddessDesFromId( data["GoddessId"] )
		lbl_nvShen:setText( desGods["goddessName"] )

        lbl_nvShen:setColor(ccc3(GoodsColorTab[quality+2][1],GoodsColorTab[quality+2][2],GoodsColorTab[quality+2][3]))
 		--lbl_nspinjie:setColor(ccc3(starcolor[quality+1][1],starcolor[quality+1][2],starcolor[quality+1][3]))

	end
	end
end

local function _initPubMod()

	img_body 		= tolua.cast( Layer:getWidgetByName("ImageView_body"), "ImageView" )
	lbl_name 		= tolua.cast( Layer:getWidgetByName("Label_name"), "Label" )
	lbl_lv 			= tolua.cast( Layer:getWidgetByName("Label_lv"), "Label" )
	lbl_yong 		= tolua.cast( Layer:getWidgetByName("Label_Yong"), "Label" )
	lbl_tong 		= tolua.cast( Layer:getWidgetByName("Label_Tong"), "Label" )
	lbl_zhi 		= tolua.cast( Layer:getWidgetByName("Label_Zhi"), "Label" )
	lbl_bingzhong 	= tolua.cast( Layer:getWidgetByName("Label_BingZhong"), "Label" )
	lbl_xingjie 		= tolua.cast( Layer:getWidgetByName("Label_BingJie"), "Label" )
	lbl_bingli 		= tolua.cast( Layer:getWidgetByName("Label_BingLi"), "Label" )
	lbl_zhanfa 		= tolua.cast( Layer:getWidgetByName("Label_JiNeng"), "Label" )
	lbl_bingzhonJS 	= tolua.cast( Layer:getWidgetByName("Label_BingZhongTip"), "Label" )
	lbl_zhanfaJS 	= tolua.cast( Layer:getWidgetByName("Label_JiNengTip"), "Label" )

    lbl_nvShen		= tolua.cast( Layer:getWidgetByName("Label_NvShen"), "Label" )
	--lbl_nsshuxing	= tolua.cast( Layer:getWidgetByName("Label_nvshenshuxing"), "Label" )
	--lbl_nspinjie 	= tolua.cast( Layer:getWidgetByName("Label_nvshenpinzhi"), "Label" )
	--lbl_nslv= tolua.cast( Layer:getWidgetByName("Label_nvshendengji"), "Label" )
    --lbl_nvTip= tolua.cast( Layer:getWidgetByName("Label_shuxingshuoming"), "Label" )


	

	local function btn_zhanshiCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			 
			--todo:展示
		
		end
	end
	--btn_ZhanShi:addTouchEventListener( btn_zhanshiCB )

	remGeneralIdx = 1
	flushMessage(remGeneralIdx)
end

local function _initJiangLingScrollView()
	local _scrollview = tolua.cast( Layer:getWidgetByName("ScrollView_RoleList"), "ScrollView" )
	_scrollview:setClippingEnabled(true) --裁切窗口
	
	_scrollview:setBackGroundColorType(0)
	local cell_disY = 5
		--可视区域
	local view_W = _scrollview:getSize().width 
	local view_H = _scrollview:getSize().height 
print("view_W ===== " .. view_W)
print("view_H ===== " .. view_H)
	local num = 0
if ifserver then
	num = GeneralData.getYesGeneralDataNum()
else
	num = 10
end
	if num < 7 then
		_scrollview:setBounceEnabled(false) --边缘回弹
	else
		_scrollview:setBounceEnabled(true) --边缘回弹
	end
	local cell_W, cell_H = 160, 60
	_scrollview:setInnerContainerSize( CCSize(view_W, cell_H*num+cell_disY*(num-1)) )

	--滑动区域
	local scroll_W = _scrollview:getInnerContainerSize().width
	local scroll_H = _scrollview:getInnerContainerSize().height

	
	local cell_X, cell_Y = view_W/2, scroll_H-cell_H/2

	local function CellTouchCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			 
			local _img = tolua.cast(sender, "ImageView")
			local tag = _img:getTag()
			if remGeneralIdx == tag then
				return
			end

			local imgbefor =  tolua.cast(_scrollview:getChildByTag(remGeneralIdx), "ImageView")
			imgbefor:loadTexture( "button2_tong_2.png" )
			remGeneralIdx = tag
			_img:loadTexture( "button2_tong_1.png" )
			
			flushMessage( remGeneralIdx )
			guideFactory.CheckGuideProcess( LM.STATE_3 )
		end
	end

	for i=1, num do
		local data 		= nil
		local desData	= nil
		local ifGod = false
if ifserver then
		data = GeneralData.getYesGeneralDataFromIndex(i)
		local id = data["GenneralId"]
		desData = Des.getGeneralDesFromId( id )
		if data["GoddessId"] ~= 0 then
            ifGod = true
        else
            ifGod = false
        end
end

	    local imageView = ImageView:create()
		if i == remGeneralIdx then
			imageView:loadTexture("button2_tong_1.png")--当前默认
		else
			imageView:loadTexture("button2_tong_2.png")
		end
		imageView:setTag(i)
		imageView:setPosition( CCPoint( cell_X, cell_Y ) )
		imageView:addTouchEventListener( CellTouchCB )
		imageView:setTouchEnabled(true)

			if ifGod then
                local _imgGod = ImageView:create()
                _imgGod:loadTexture( "floor+8_bag.png" )
                _imgGod:setPosition(ccp(50, 0))
                imageView:addChild( _imgGod )
            end   

	   		local _lbl = Label:create()
	   		if ifserver then
				_lbl:setText( desData["generalName"] )
			else
	   			_lbl:setText(i)
			end
			_lbl:setFontSize( _G.ListFontSize )
			_lbl:setColor( ccc3(239, 224, 199) )
	   		imageView:addChild(_lbl)
	   _scrollview:addChild( imageView )

	   cell_Y = cell_Y - cell_disY - cell_H
	end
	
end

function exitUI()
	if Layer ~= nil and _widget ~= nil then
		Layer:removeWidget(_widget)
		--Layer:clear()
		_widget = nil
		Layer = nil
		
		LM.STATE_3 = 0
	end
end

function enterUI()
	LM.STATE_3 = UI_General_Jiangling

	Layer = LM.getLayer3()
	_widget = GUIReader:shareReader():widgetFromJsonFile("GNR_WuJiang.json")

	Layer:addWidget(_widget)
    _widget:setTouchEnabled(false)

    _initPubMod()
    _initJiangLingScrollView()

    guideFactory.CheckGuideProcess( LM.STATE_3 )
end



--[[
function enterUI( _Scene )
	PT.UI_State = UI_General_Jiangling
	curScene = _Scene
	Layer = TouchGroup:create()
	Layer:setZOrder(10)
    local _widget = GUIReader:shareReader():widgetFromJsonFile("GNR_WuJiang.json")    
    _widget:setTouchEnabled(false)
    Layer:addWidget(_widget)
    _Scene:addChild(Layer)

	_initPubMod()
    _initJiangLingScrollView()
    guideFactory.CheckGuideProcess(curScene)
end

function exitUI()
	curScene:removeChild(Layer, true)
end

--]]