module ("GNR_ZhaoMu_Pop3",package.seeall)

local Layer = nil
local _widget = nil


local function initPubMod(_jeneralId, _camp)
	local btn_close = tolua.cast( Layer:getWidgetByName("Button_GuanBi"), "Button" )


	local img_body 		= tolua.cast( Layer:getWidgetByName("ImageView_body"), "ImageView" )
	local lbl_name 		= tolua.cast( Layer:getWidgetByName("Label_name"), "Label" )
	local lbl_lv 		= tolua.cast( Layer:getWidgetByName("Label_lv"), "Label" )
	local lbl_tong 		= tolua.cast( Layer:getWidgetByName("Label_Tong"), "Label" )
	local lbl_yong 		= tolua.cast( Layer:getWidgetByName("Label_Yong"), "Label" )
	local lbl_mou 		= tolua.cast( Layer:getWidgetByName("Label_Zhi"), "Label" )
	local lbl_bingZhong = tolua.cast( Layer:getWidgetByName("Label_BingZhong"), "Label" )
	local lbl_bingJie 	= tolua.cast( Layer:getWidgetByName("Label_BingJie"), "Label" )
	local lbl_bingLi 	= tolua.cast( Layer:getWidgetByName("Label_BingLi"), "Label" )
	local lbl_bingZhongJieShao = tolua.cast( Layer:getWidgetByName("Label_BingZhongTip"), "Label" )
	local lbl_jiNeng 	= tolua.cast( Layer:getWidgetByName("Label_JiNeng"), "Label" )
	local lbl_jiNengJieShao = tolua.cast( Layer:getWidgetByName("Label_JiNengTip"), "Label" )
	local lbl_nvShen 	= tolua.cast( Layer:getWidgetByName("Label_NvShen"), "Label" )
	local lbl_nvShenShuXing = tolua.cast( Layer:getWidgetByName("Label_NvShenShuXing"), "Label" )

	--招募或者解聘恩建
	local btn_Zhao 		= tolua.cast( Layer:getWidgetByName("Button_ZhaoMu"), "Button" )
	local lbl_ZhaoZi 	= tolua.cast( Layer:getWidgetByName("Label_ZhaoMu"), "Label" )
	local lbl_ZhaoCost 	= tolua.cast( Layer:getWidgetByName("Label_ZhaoMuCost"), "Label" )
	local img_ZhaoCost 	= tolua.cast( Layer:getWidgetByName("ImageView_3117"), "ImageView" )
	--获取条件
	local lbl_huoDeTiaoJian = tolua.cast( Layer:getWidgetByName("Label_HuoDeTiaoJian"), "Label" )

	local ifZM = false
	local jeneralidx = 0
	local function btn_closeCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			RW_guide.exitUI()--关闭任务引导
			local _btn = tolua.cast(sender, "Button")
			if _btn == btn_close then
				exitUI()
			elseif _btn == btn_Zhao then
				if ifZM then --招募
					protoSend0x0254(jeneralidx, 0)
					exitUI()
				else --解聘
					protoSend0x0254(jeneralidx, 1)
					exitUI()
				end
				guideFactory.CheckGuideProcess(LM.STATE_3)
			end
		end
	end
	btn_close:addTouchEventListener( btn_closeCB )
	btn_Zhao:addTouchEventListener(btn_closeCB)

	local lv 		= 0
	local tong 		= 0
	local yong 		= 0
	local mou 		= 0
	local bingjie 	= 0
	local bingli 	= 0
	local quality   = -1 --女神品阶

	local yesState, yesData = GeneralData.ifOntheYesTeam(_jeneralId)
	local noState, noData = GeneralData.ifOntheNoTeam(_jeneralId)

	local _jeneralDes = Des.getGeneralDesFromId( _jeneralId )
	local _unityDes = Des.getUnitDesFromId( _jeneralDes["generalUnitID"] )
	local _skillDes = Des.getSpAttackDesFromId( _jeneralDes["SpAttackID"] )
	local _godDes = Des.getGoddessDesFromId( _jeneralDes["godID"] )

	print("jeneralid = " .. _jeneralId)
	print("godID = " .. _jeneralDes["godID"])

	if noState then --未招募英雄

		lv 		= noData["Lv"]
		tong 	= noData["Attr_t"] + noData["Plus_t"]
		yong 	= noData["Attr_y"] + noData["Plus_y"]
		mou 	= noData["Attr_m"] + noData["Plus_m"]		
		local _Z, _X = math_modf( noData["UnitLv"]/10 )
		bingjie = _Z .. "阶" .. _X*10 .. "星"
		bingli 	= noData["CurHp"] .. "/" .. noData["TotalHp"]

		quality,_ = PT.checkeGodQuality(noData["GoddessStar"]) --math_modf( noData["GoddessStar"]/11 )
		lbl_huoDeTiaoJian:setVisible( false )
		lbl_ZhaoZi:setText("招募")
		ifZM = true
		lbl_ZhaoCost:setText( noData["Price"] )
		jeneralidx = noData["Index"]
	elseif yesState then --已招募英雄

		lv 		= yesData["Lv"]
		tong 	= yesData["Attr_t"] + yesData["Plus_t"]
		yong 	= yesData["Attr_y"] + yesData["Plus_y"]
		mou 	= yesData["Attr_m"] + yesData["Plus_m"]		
		local _Z, _X = math_modf( yesData["UnitLv"]/10 )
		bingjie = _Z .. "阶" .. _X*10 .. "星"
		bingli 	= yesData["CurHp"] .. "/" .. yesData["TotalHp"]

		quality,_ = PT.checkeGodQuality(yesData["GoddessStar"]) --math_modf( yesData["GoddessStar"]/11 )

		lbl_huoDeTiaoJian:setVisible( false )
		lbl_ZhaoZi:setText("解募")
		ifZM = false
		img_ZhaoCost:setVisible(false)
		lbl_ZhaoCost:setText("解募的代价显示在这里")
		jeneralidx = yesData["Index"]

	else --未获得英雄
		local data = nil
		data = Des.getZhaoMuJeneralData(4, _jeneralId) --若不是公共将领
		if data == nil then
			data = Des.getZhaoMuJeneralData(_camp, _jeneralId) --就是本国特有将领
		end
		lv 		= data["Lv"]
		tong 	= data["Tong"] 
		yong 	= data["Yong"] 
		mou 	= data["Mou"] 	
		local _Z, _X = math_modf( data["Lv"]/10 )
		bingjie = _Z .. "阶" .. _X*10 .. "星"
		bingli 	= data["BingLi"] .. "/" .. data["BingLi"]

		btn_Zhao:setVisible(false)
		btn_Zhao:setTouchEnabled(false)
		lbl_huoDeTiaoJian:setVisible( true )
		lbl_huoDeTiaoJian:setText( data["ZhaoMuTiaoJian"] )

		if _godDes ~= nil then
			quality = _godDes["xingJi"]
			quality = quality+ 1
		end
	end
	print("_jeneralId  === " .. _jeneralId)

	lbl_name:setText( _jeneralDes["generalName"] )
	img_body:loadTexture( RoleBodyPath .. _jeneralDes["generalBodyIcon"] .. ".png" )

	lbl_bingZhong:setText( _unityDes["unitName"] )
	lbl_bingZhongJieShao:setText(_unityDes["unitDes"])

	if _skillDes == nil then
		lbl_jiNeng:setText("无")
		lbl_jiNengJieShao:setText("无")
	else
		lbl_jiNeng:setText( _skillDes["SpAttackName"] )
		lbl_jiNengJieShao:setText( _skillDes["SpAttackDes"] )
	end
	if _godDes == nil then
		lbl_nvShen:setText("无")
		lbl_nvShenShuXing:setText("无")
	else
		lbl_nvShen:setText( _godDes["goddessName"] )
		lbl_nvShen:setColor(ccc3(GoodsColorTab[quality+1][1],GoodsColorTab[quality+1][2],GoodsColorTab[quality+1][3]))
		local _type = _godDes["goddessType"]
		if _type == 1 then
			lbl_nvShenShuXing:setText( "火" )
		elseif _type == 2 then
			lbl_nvShenShuXing:setText( "水" )
		elseif _type == 3 then
			lbl_nvShenShuXing:setText( "风" )
		end
	end

	lbl_lv:setText( lv .. "级" )
	lbl_tong:setText( tong )
	lbl_yong:setText( yong )
	lbl_mou:setText( mou )
	lbl_bingJie:setText( bingjie )
	lbl_bingLi:setText( bingli )
end

function exitUI()
	if Layer ~= nil and _widget ~= nil then
		Layer:removeWidget(_widget)
		--Layer:clear()
		_widget = nil
		Layer = nil
		
		LM.STATE_4 = 0
	end
end
--将领id， 所属国家
function enterUI(_jeneralId, _camp)
	LM.STATE_4 = UI_General_ZhaoMu_XiangQing
	if Layer~= nil then
		return
	end
	Layer = LM.getLayer4()
	_widget = GUIReader:shareReader():widgetFromJsonFile("GNR_ZhaoMu_Pop3.json")

	Layer:addWidget(_widget)
    _widget:setTouchEnabled(false)

    initPubMod(_jeneralId, _camp)

    guideFactory.CheckGuideProcess( LM.STATE_4 )
end
