module ("NvShen_LieBiao",package.seeall)

local Layer = nil
local _widget = nil

local EntryID = 0
local scheduler = CCDirector:sharedDirector():getScheduler()

function _flushNvShenScrollView()
	local _scrollview = tolua.cast( Layer:getWidgetByName("ScrollView_WuJiangList"), "ScrollView" )
	_scrollview:removeAllChildren()
	_scrollview:setClippingEnabled(true) --裁切窗口
	_scrollview:setBackGroundColorType(0)
	_scrollview:setBounceEnabled(true)


	--获取初始的武将id
	local initData = {}
	

	local camp = PlayerData.getCamp()+1
	--获取本国可招募女神和公共可招募女神
--[[	
	local initNum, initData = Des.getZhaoMuJeneralDesFromCamp(5)
	local campNum,campData = Des.getNvShenFromCamp(camp)
	local pubNum, pubData = Des.getNvShenFromCamp(4)
--]]
---[[
	local _initNum, _initData = Des.getZhaoMuJeneralDesFromCamp(5)
	local _campNum,_campData = Des.getNvShenFromCamp(camp)
	local _pubNum, _pubData = Des.getNvShenFromCamp(4)


	local function checkGod(_dataList)
		local backdata = {}
		for i=1, #_dataList do
			if _dataList[i]["xianshi"] == 0 then --已弃用女神
				local _id = _dataList[i]["GodId"]
				if GeneralData.ifGetGodFromGodId(_id) then --已获得女神
					table_insert( backdata, _dataList[i] )
				end
			elseif _dataList[i]["xianshi"] == 1 then --
				table_insert( backdata, _dataList[i] )
			end
		end
		return #backdata, backdata
	end
	local campNum,campData = checkGod(_campData)
	local pubNum, pubData  = checkGod(_pubData)
	local _,initData = checkGod(_initData)
--]]
	local _,initGodsId = GeneralData.getInitJeneralId(initData[1]["generalId"], initData[2]["generalId"])
	
	initData = {}
	initData[1] = Des.getNvShenDataFromCampId(5, initGodsId)


	campData = PT.copyTable(campData)
	pubData  = PT.copyTable(pubData)
	initData = PT.copyTable(initData)

	--获取已招募的女神和未招募的女神id列表
	local yesTab, noTab = GeneralData.getGeneralHaveGodsYesOrNotTab()
	local yesTabNum = #yesTab

	local dataNum = campNum + pubNum + 1 + 1

---------行数计算滑动区域-------------------------------------------------------------------	
	
	local function getHangNum(_total, _per)
		if _total <= _per then
			return 1
		elseif _total <= _per*2 then
			return 2
		elseif _total <= _per*3 then
			return 3
		elseif _total <= _per*4 then
			return 4
		elseif _total <= _per*5 then
			return 5
		elseif _total <= _per*6 then
			return 6
		elseif _total <= _per*7 then
			return 7
		elseif _total <= _per*8 then
			return 8
		elseif _total <= _per*9 then
			return 9

		elseif _total <= _per*10 then
			return 10
		elseif _total <= _per*11 then
			return 11
		end
	end
--[[
	--已招募所占行数
	local topHangNum =  math.ceil((yesTabNum)/6)
	--分割线所占行数
	local midHangNum = 1
	--未招募所占行数
	local bomHangNum = math.ceil((campNum + pubNum - yesTabNum)/6)
--]]
	--已招募所占行数
	local topHangNum =  getHangNum(yesTabNum, 6)--math.ceil((yesTabNum)/6)
	--分割线所占行数
	local midHangNum = 1
	--未招募所占行数
	local bomHangNum = getHangNum(campNum + pubNum - yesTabNum+1, 6) --math.ceil((campNum + pubNum - yesTabNum)/6)
	--可视区域
    local view_W = _scrollview:getSize().width 
    local view_H = _scrollview:getSize().height 

    local cell_W, cell_H = 118, 140
	
	local cell_disY = 10 --纵向间隔
    local cell_disX = 10 --横向间隔

    print("yesTabNum == " .. yesTabNum)
    print("topHangNum == " .. topHangNum)
    print("bomHangNum == " .. bomHangNum)


	_scrollview:setInnerContainerSize( CCSize(view_W, (topHangNum+bomHangNum)*(cell_H+cell_disY) +cell_disY+4) )
    
    local scroll_H = _scrollview:getInnerContainerSize().height
    local cell_X = 90 --计算得出
    local cell_Y = scroll_H-cell_H/2

    local remPos = 1

    local fenGePos = yesTabNum+1 --分割线所在位置

    --从公共数据里移除已招募的数据
    local function removeYesDataFromDesData(id)
    	local size = #campData
    	for i=1, size do
    		if id == campData[i]["GodId"] then
    			table_remove( campData, i )
    			return
    		end
    	end

    	size = #pubData
    	for i=1, size do
    		if id == pubData[i]["GodId"] then
    	    	table_remove( pubData, i )
    			return		
    		end
    	end
    	print("id == " .. id)
    	if initData[1]["GodId"] == id then
    		table_remove( initData, 1 )
    	end

    end
    --返回是否在未招募列表和星级
    local function checkIfInNotab(id)
    	local size = #noTab
    	for i=1, size do
    		if noTab[i]["id"] == id then
    			return true, noTab[i]["GoddessStar"]
    		end
    	end
    	return false, 0
    end
    local function checkIfInYesTab(id)
    	local size = #yesTab
    	for i=1, size do
    		if yesTab[i]["id"] == id then
    			return true
    		end
    	end
    end
    --[[
    local function checkeGodQuality(_star)
		if _star < 11 then
			return 0, _star
		elseif _star < 22 then
			return 1, _star - 11
		elseif _star < 33 then
			return 2, _star - 22
		elseif _star < 44 then
			return 3, _star - 33
		elseif _star < 55 then
			return 4, _star - 44
		end
	end
	--]]
    local function addQulityImg(_head, quality)
    	local imgTab = {"rim+2_juntuan.png", "rim+3_juntuan.png", "rim+4_juntuan.png", "rim+5_juntuan.png", "rim+6_juntuan.png"}
    		
		local img_quality = ImageView:create()
		img_quality:loadTexture( imgTab[quality+1] )

		_head:addChild(img_quality)

    end

	local function Img_TouchCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			local _img = tolua.cast(sender, "ImageView")
			local tag = _img:getTag()
			local state, _ = checkIfInYesTab(tag)
			if state then
				NvShenBase.enterUI(1, tag, 1) --已招募女神
			else
				state, _ = checkIfInNotab(tag)
				if state then
					NvShenBase.enterUI(1, tag, 2) --未招募女神
				else
					NvShenBase.enterUI(1, tag, 3) --未获得女神
				end
			end

		end
	end

    local function addCell(i)
    	if i < yesTabNum+1 then --已招募的女神
 			local id, start = yesTab[i]["id"], yesTab[i]["GoddessStar"] --数据id， 星级
 			removeYesDataFromDesData(id)
 			
 			local des = Des.getNvShenDataFromCampId(camp, id)

 			
 			
 			local qulity, leftStar = PT.checkeGodQuality( start ) --品质、星级
 			local icon = SexHeadPath .. des["Icon"] .. "_" .. qulity+1 .. ".png"
 			local name = des["GodName"] .. "+" .. leftStar
 			local jenaralName = "[" .. des["GeneralName"] .. "]"
 			local img_headBG= ImageView:create()
	        img_headBG:loadTexture( "floor+17_tong.png" )
	        img_headBG:setPosition(ccp(cell_X, cell_Y))
					local img_head = ImageView:create()
		        	img_head:loadTexture( icon )
		        	img_head:setPosition(ccp(6, 17))
		        	img_head:setScaleX(1)
		        	--img_head:setScaleX(-0.75)
		        	--img_head:setScaleY(0.75)

		        	addQulityImg(img_head, qulity)
		        img_headBG:addChild(img_head)
		        	local _lbl = Label:create()
	                _lbl:setText(name)
	                _lbl:setFontSize( 16 )
	                _lbl:setPosition(ccp(0, -50))
	                --_lbl:ignoreContentAdaptWithSize(false)
                	--_lbl:setTextHorizontalAlignment(0) --水平靠右
                	_lbl:setAnchorPoint( ccp(0,0.5) )
                	--_lbl:setTextVerticalAlignment(1)
	                _lbl:setColor( ccc3( GoodsColorTab[qulity+2][1], GoodsColorTab[qulity+2][2], GoodsColorTab[qulity+2][3]) )
	            img_headBG:addChild(_lbl)

	            	local _lbl_jer = Label:create()

	                _lbl_jer:setText(jenaralName)
	                _lbl_jer:setFontSize( 16 )
	                _lbl_jer:setPosition(ccp(0, -50))
	               	--_lbl_jer:setTextHorizontalAlignment(2) --水平靠右
	            	_lbl_jer:setAnchorPoint( ccp(1,0.5) )
	                --_lbl:setColor( ccc3( GoodsColorTab[qulity+2][1], GoodsColorTab[qulity+2][2], GoodsColorTab[qulity+2][3]) )
	            img_headBG:addChild(_lbl_jer)
	           	--注册事件
		        img_headBG:setTag(id)
    			img_headBG:setTouchEnabled(true)
	        	img_headBG:addTouchEventListener( Img_TouchCB )	        	
	        _scrollview:addChild( img_headBG )
	    	if remPos < 6 then
	    		cell_X = cell_X+cell_W+cell_disX
	    		remPos = remPos + 1
	    	else
	    		if remPos ~= fenGePos-1 then
	    			remPos = 1
	    			cell_X = 90
	    			cell_Y = cell_Y - cell_H - cell_disY
	    		end
	    	end

    	elseif i == yesTabNum+1 then --分割线
    		if yesTabNum > 0 then
    			cell_Y = cell_Y-cell_H/2-cell_disY-2
	        end
	        local img_fenge = ImageView:create()
	        img_fenge:loadTexture( "floor+12_tong.png" )
	        img_fenge:setPosition(ccp(view_W/2, cell_Y))
		        local _lbl = Label:create()
	            _lbl:setText( "未 招 募")
	            _lbl:setFontSize( 24 )
	            _lbl:setPosition(ccp(0, 0))
	            img_fenge:addChild(_lbl)
	        _scrollview:addChild( img_fenge )

	        cell_Y = cell_Y-cell_H/2-cell_disY-2
	        cell_X = 90
	        remPos = 1

    	else --未招募和未获得
    		local idx = i - yesTabNum-1
    		local initdataSize = #initData
    		local campDataSize = #campData
    		local data = nil
    		local name = nil
    		local jenaralName = nil
    		local icon = nil
    		local id = nil
    		local ifInNoTeam, start = false, 0 --是否在未招募行列，数据星级
    		local qulity, leftStar = 0 --品质、星级

    		if idx <= initdataSize then
				data = initData[idx]
    	
    			--icon = SexHeadPath .. data["Icon"] .. "_1.png"
    			id = data["GodId"]
    			ifInNoTeam, start = checkIfInNotab(id)
    			if start == 0 then
    				start = data["XingJ"] --获取默认星级
    			end
    			qulity, leftStar = PT.checkeGodQuality( start )

    			name = data["GodName"] .. "+" .. leftStar
    			jenaralName = "[" .. data["GeneralName"] .. "]"

    			icon = SexHeadPath .. data["Icon"] .. "_" .. qulity+1 .. ".png"
    		elseif idx <= campDataSize+initdataSize then
    			idx = idx - initdataSize
    			data = campData[idx]
    			
    			--icon = SexHeadPath .. data["Icon"] .. "_1.png"
    			id = data["GodId"]
    			ifInNoTeam, start = checkIfInNotab(id)
    			if start == 0 then
    				start = data["XingJ"] --获取默认星级
    			end

    			qulity, leftStar = PT.checkeGodQuality( start )

    			name = data["GodName"] .. "+" .. leftStar
    			jenaralName = "[" .. data["GeneralName"] .. "]"
    			icon = SexHeadPath .. data["Icon"] .. "_" .. qulity+1 .. ".png"
    		else
    			idx = idx - campDataSize-initdataSize
    			data = pubData[idx]

    			id = data["GodId"]
    			ifInNoTeam, start = checkIfInNotab(id)
    			if start == 0 then
    				start = data["XingJ"] --获取默认星级
    			end
    			qulity, leftStar = PT.checkeGodQuality( start )

    			name = data["GodName"] .. "+" .. leftStar
    			jenaralName = "[" .. data["GeneralName"] .. "]"
    			icon = SexHeadPath .. data["Icon"] .. "_" .. qulity+1 .. ".png"
    		end

 			local img_headBG= ImageView:create()
	        img_headBG:loadTexture( "floor+17_tong.png" )
	        img_headBG:setPosition(ccp(cell_X, cell_Y))
					local img_head = ImageView:create()
		        	img_head:loadTexture( icon )
		        	img_head:setPosition(ccp(6, 17))
		        	img_head:setScaleX(1)
		        	if not ifInNoTeam then
		        		img_head:setOpacity(50)
		        	end
		        	--img_head:setScaleX(-0.75)
		        	--img_head:setScaleY(0.75)
		        	addQulityImg(img_head, qulity)
		        img_headBG:addChild(img_head)
		        	local _lbl = Label:create()
	                _lbl:setText( name)
	                _lbl:setFontSize( 16 )
	                _lbl:setPosition(ccp(0, -50))
	                _lbl:setAnchorPoint( ccp(0,0.5) )
	                _lbl:setColor( ccc3( GoodsColorTab[qulity+2][1], GoodsColorTab[qulity+2][2], GoodsColorTab[qulity+2][3]) )
	            img_headBG:addChild(_lbl)

	            	local _lbl_jer = Label:create()
	                _lbl_jer:setText(jenaralName)
	                _lbl_jer:setFontSize( 16 )
	                _lbl_jer:setPosition(ccp(0, -50))
	               	--_lbl_jer:setTextHorizontalAlignment(2) --水平靠右
	            	_lbl_jer:setAnchorPoint( ccp(1,0.5) )
	                --_lbl:setColor( ccc3( GoodsColorTab[qulity+2][1], GoodsColorTab[qulity+2][2], GoodsColorTab[qulity+2][3]) )
	            img_headBG:addChild(_lbl_jer)
	           	--注册事件
		        img_headBG:setTag( id )
    			img_headBG:setTouchEnabled(true)
	        	img_headBG:addTouchEventListener( Img_TouchCB )	        	
	        _scrollview:addChild( img_headBG )
	    	if remPos < 6 then
	    		cell_X = cell_X+cell_W+cell_disX
	    		remPos = remPos + 1
	    	else
	    		remPos = 1
	    		cell_X = 90
	    		cell_Y = cell_Y - cell_H - cell_disY
	    	end
    	end

    end

    for i=1, 20 do
    	addCell(i)
    end


    		
    local remNUM = 21
    EntryID = -1
    local function FlushPosition()
	    if remNUM < dataNum+1 then
	       	addCell(remNUM)
	        remNUM = remNUM + 1
	    else
	        scheduler:unscheduleScriptEntry( EntryID )
	        EntryID = -1
	    end
    end
    EntryID = scheduler:scheduleScriptFunc( FlushPosition, 0.01, false)
end
function closeTimeB()
	if -1 ~= EntryID then
		scheduler:unscheduleScriptEntry( EntryID )
        EntryID = -1
	end
end
function exitUI()
	if Layer ~= nil and _widget ~= nil then
		Layer:removeWidget(_widget)
		--Layer:clear()
		_widget = nil
		Layer = nil
		
		LM.STATE_3 = 0
	end
	if -1 ~= EntryID then
		scheduler:unscheduleScriptEntry( EntryID )
        EntryID = -1
	end
end

function enterUI()
	LM.STATE_3 = UI_NvShen_LieBiao  --尚无此ui状态

	Layer = LM.getLayer3()
	_widget = GUIReader:shareReader():widgetFromJsonFile("GNR_ZhaoMu.json") --这个json在此通用

	Layer:addWidget(_widget)
    _widget:setTouchEnabled(false)

    _flushNvShenScrollView()

    guideFactory.CheckGuideProcess( LM.STATE_3 )

end