module ("NvShen_ShengJi",package.seeall)
--女神培养界面

local Layer = nil
local _widget = nil

local remId = 0

--将领和女神名字
local lbl_godsName = nil
local lbl_jeneralName = nil

--大小属性图标
local img_Shu_A = nil
local img_Shu_B = nil
--女神攻击力
local lbl_gongJiValue = nil --攻击力
local img_starTab = {}  --攻击力进度

local img_body = nil --女神图像
local img_bodyBG = nil --女神图像背景
--物品图标和数量
local lbl_needNum = nil 
local img_zhanDouLiDi = nil --女神战斗力底板
local font_zhanDouLi = nil --女神战斗力

local ShuXingImgTab_A = {"floor+10_nvshen.png", "floor+9_nvshen.png", "floor+11_nvshen.png"}
local ShuXingImgTab_B = {"floor+23_nvshen.png", "floor+22_nvshen.png", "floor+24_nvshen.png"}
local bg_tab = {"floor+4_nvshen.jpg","floor+5_nvshen.jpg","floor+6_nvshen.jpg","floor+7_nvshen.jpg","floor+8_nvshen.jpg"}
function flusMessage(_id)
	if _id == nil then
		_id = remId
	end

	local name = nil
	local jeneralName = nil
	local gongjivalue = nil
	local neadNum = nil
	local shuxing = nil
	
	local godDes = Des.getGoddessDesFromId( _id )

	name = godDes["goddessName"]	
	shuxing = godDes["goddessType"] --123火水风

	local camp = PlayerData.getCamp()+1
	local des = Des.getNvShenDataFromCampId(camp, _id)

	jeneralName = des["GeneralName"]

	local jeneraldata = GeneralData.getGeneralDataFromGodessId(_id, 1)
	local godStar = jeneraldata["GoddessStar"]
	local curGong =jeneraldata["GoddessAck"] 			--女神当前攻击力
	local maxGong = jeneraldata["GoddessNextAck"] 		--女神最大攻击力
	local godsBaseGong = godDes["initialAttack"]

	
	font_zhanDouLi:setText("战斗力 " .. jeneraldata["GoddessPower"])
	--local quality, xing = math.modf(godStar / 11)	
	--xing = math.ceil(xing*11)
	--[[
		--当前品阶星级
	local function checkeGodQuality(_star)
		if _star < 11 then
			return 0, _star
		elseif _star < 22 then
			return 1, _star - 11
		elseif _star < 33 then
			return 2, _star - 22
		elseif _star < 44 then
			return 3, _star - 33
		elseif _star < 55 then
			return 4, _star - 44
		end
	end
	--]]
	local quality, xing = PT.checkeGodQuality(godStar)

	print("quality == " .. quality)
	print("xing === " .. xing)
	lbl_jeneralName:setText("[" .. jeneralName .. "]")
	lbl_godsName:setText( name .. "+" .. xing )
	img_body:loadTexture( SexBodyPath.. godDes["goddessIcon"] .."_" .. quality+1 .. ".png" )
	img_bodyBG:loadTexture( bg_tab[quality+1] )
	--0蓝 1绿 2黄 3红 4紫
	lbl_godsName:setColor(ccc3(GoodsColorTab[quality+2][1], GoodsColorTab[quality+2][2], GoodsColorTab[quality+2][3]))
	
	img_Shu_A:loadTexture( ShuXingImgTab_A[shuxing] )
	img_Shu_B:loadTexture( ShuXingImgTab_B[shuxing] )
	
	local function imgTouchCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			--local _img = tolua.cast(sender, "ImageView")
			NvGuiZe.enterUI(shuxing, curGong, godDes["goddessA"],godDes["goddessD"],godDes["goddessS"], quality+1)
		end
	end
	img_Shu_B:setTouchEnabled(true)
	img_Shu_B:addTouchEventListener(imgTouchCB)

	local per = 0
	if maxGong == godsBaseGong then
		per = 100
	else
		per = (curGong-godsBaseGong)/(maxGong-godsBaseGong)*100
	end
	print("the per is "..per)
	local vieNum = 0

	if per <20 then
		vieNum = 1
	elseif per<40 then
		vieNum = 2
	elseif per<60 then
		vieNum = 3
	elseif per<80 then
		vieNum = 4
	else
		vieNum = 5
	end
	print("vieNum ====== " .. vieNum)
	for i=1, 5 do
		if i < vieNum+1 then
			img_starTab[i]:loadTexture("floor+30_tong.png")
		else
			img_starTab[i]:loadTexture("floor+31_tong.png")
		end
	end
	lbl_gongJiValue:setText( "攻击力:" .. curGong .. "/" .. maxGong )

	local peiYangShiNum = BagData.getNvShengStone(6)
	lbl_needNum:setText(peiYangShiNum .. "/" .. 1)

end

local function _initPubMod(_id)
	--tolua.cast( Layer:getWidgetByName("ScrollView_WuJiangList"), "ScrollView" )
--将领和女神名字
	lbl_godsName = tolua.cast( Layer:getWidgetByName("Label_NvShenName"), "Label" )
	lbl_jeneralName = tolua.cast( Layer:getWidgetByName("Label_generalName"), "Label" )

--大小属性图标
	img_Shu_A = tolua.cast( Layer:getWidgetByName("ImageView_NvShenShuXing"), "ImageView" )
	img_Shu_B = tolua.cast( Layer:getWidgetByName("ImageView_GongJiTitle"), "ImageView" )
--女神攻击力
	lbl_gongJiValue = tolua.cast( Layer:getWidgetByName("Label_GongJiKey"), "Label" ) --攻击力
--女神战斗力
	font_zhanDouLi = tolua.cast( Layer:getWidgetByName("LabelBMFont_zhanDouLi"), "LabelBMFont" )
	img_zhanDouLiDi = tolua.cast( Layer:getWidgetByName("ImageView_powerDi1"), "ImageView" )
	
	img_starTab = {}  --攻击力进度
	for i=1, 5 do
		img_starTab[i] = tolua.cast( Layer:getWidgetByName("ImageView_Star" .. i), "ImageView" )
	end
--物品图标和数量
	local img_gods = tolua.cast( Layer:getWidgetByName("ImageView_GoodsPic"), "ImageView" ) 
	local img_godsKuang = tolua.cast( Layer:getWidgetByName("ImageView_PinZhiKuang"), "ImageView" ) 
	lbl_needNum = tolua.cast( Layer:getWidgetByName("Label_GoodsKey"), "Label" ) 
	local btn_PeiYang = tolua.cast( Layer:getWidgetByName("Button_PeiYang"), "Button" )
	btn_PeiYang:setVisible(true)
	btn_PeiYang:setTouchEnabled(true)
	local function btn_CB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
				local jeneraldata = GeneralData.getGeneralDataFromGodessId(_id, 1)

				local curGong =jeneraldata["GoddessAck"] 			--女神当前攻击力
				local maxGong = jeneraldata["GoddessNextAck"] 		--女神最大攻击力
				if curGong >= maxGong then
					Pop3_TS_Result.enterUI( "该女神攻击力已满！"  )
				else
					local data = GeneralData.getGeneralDataFromGodessId(remId, 1)
					protoSend0x0270(data["Index"])
				end
		end
	end

	btn_PeiYang:addTouchEventListener(btn_CB)

	local goodsData = Des.getGoodsDesFromId(125)
	local stronQulity = goodsData["goodsQuality"]
	local imgTab = {"rim+2_juntuan.png", "rim+3_juntuan.png", "rim+4_juntuan.png", "rim+5_juntuan.png", "rim+6_juntuan.png"}
	img_gods:loadTexture( GoodsHeadPath .. "76.png" )
	img_godsKuang:loadTexture( imgTab[stronQulity-1] )

	img_body = tolua.cast( Layer:getWidgetByName("ImageView_NvShenPic"), "ImageView" ) 
	img_bodyBG = tolua.cast( Layer:getWidgetByName("ImageView_NvShenDi"), "ImageView" ) 
	local img_tipsBG=tolua.cast( Layer:getWidgetByName("ImageView_goodsTips"), "ImageView" ) 
	
	local Panel_tipsViewBG = tolua.cast( Layer:getWidgetByName("Panel_TipsView"), "Layout" )
	Panel_tipsViewBG:setVisible(false)
	Panel_tipsViewBG:setTouchEnabled(false)
	Panel_tipsViewBG:setZOrder(10)
	
	local lbl_name = tolua.cast( Layer:getWidgetByName("Label_goodsName"), "Label" ) 
	lbl_name:setText("紫霞仙丹")


	lbl_name:setColor(ccc3(GoodsColorTab[stronQulity][1], GoodsColorTab[stronQulity][2], GoodsColorTab[stronQulity][3]))

	local state = true
    local function BoxCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
           if state then
           		state = false
			    img_tipsBG:setScale(0.2)
			    Panel_tipsViewBG:setVisible(true)
			    local function CallFucnCallback2(sender)
			        Panel_tipsViewBG:setTouchEnabled(true)
			    end
			    local array = CCArray:create()
			    array:addObject(CCScaleBy:create(0.2, 6, 6))
			    array:addObject(CCScaleBy:create(0.05, 0.83, 0.83))
			    array:addObject( CCCallFuncN:create(CallFucnCallback2) )
			    img_tipsBG:runAction(CCSequence:create(array))
			end
        end
    end
	img_gods:setTouchEnabled(true)
	img_gods:addTouchEventListener( BoxCB )

	local function hideBg(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			Panel_tipsViewBG:setVisible(false)
			Panel_tipsViewBG:setTouchEnabled(false)
			state = true
		end
	end
	Panel_tipsViewBG:addTouchEventListener(hideBg)

	flusMessage(_id)
end

function exitUI()
	if Layer ~= nil and _widget ~= nil then
		Layer:removeWidget(_widget)
		--Layer:clear()
		_widget = nil
		Layer = nil
		
		LM.STATE_4 = 0
	end
end

function enterUI(_id)
	LM.STATE_4 = UI_NvShen_ShengJi
	if _id ~= nil then
		remId = _id
	else
		local initData = {}
		local _, initData = Des.getZhaoMuJeneralDesFromCamp(5)
		local _,initGodsId = GeneralData.getInitJeneralId(initData[1]["generalId"], initData[2]["generalId"])
		remId = initGodsId
	end
	Layer = LM.getLayer4()
	_widget = GUIReader:shareReader():widgetFromJsonFile("NvShen_ShengJi.json")

	Layer:addWidget(_widget)
    _widget:setTouchEnabled(false)

    _initPubMod(_id, _state)
end
