module ("BagData",package.seeall)
--背包数据 包括三部分，分别是 已装备、背包、二次元

BagTemplet = {
	GoodIndex 		= "", --物品的唯一标识
	GoodId 			= 0, --物品id
	IfInBag 		= 0, --是否在背包 1：是
	IfBang 			= 0, --是否绑定 1:绑定
	GeneralId 		= 0, --装备的将领的id 没装备是0
	GoodLv 			= 0, --物品强化等级	
	GoodTimeLim		= 0, --物品到期时间 --背包里的物品没有到期时间，2次元是消失倒计时，背包里是解绑倒计时
	GoodType 		= 0, --物品所属类型 1武器 2防具 3兵符 4兵书 5碎片
	GoodQuility 	= 0, --物品的品质 1白 2蓝 3绿 4黄 5红 6紫 --这个可以本地获取了
	GoodsUpZeney 	= 0, --物品升级所需银币 
	GoodsDownZeney	= 0, --物品降级返还银币
	GoodsPrice 		= 0, --物品价格
	GoodsProType 	= 0, -- 物品添加的属性 1攻击 2防御 3带兵数 4女神防御
	GoodsProSkip 	= 0, --每升一级主属性增加值（背包--强化）
	GoodsProCount 	= 0, --属性增加值 （背包 -- 主属）
	GoodsAmount 	= 0, --堆叠数量  --堆叠数量，大于一需要显示堆叠数
    GoodsTotal   	= 0, --最大堆叠数量
    IfBeMake 		= 0, ----是否可合成 1可合成 0不可合成 可合成要显示最大堆叠数量
	--GoodsPicId  	= 0, -- 物品的图片id 
	GoodsPower      = 0, --物品战斗力值
}
local lbl_qianghua = nil
local btn_qianghua = nil

local lbl_pubQH = nil
local btn_pubQH = nil
local img_pubQH = nil --小红点

local cd_qianghua = 0
local state = 0
local MaxBag = 0 --背包最大容量
local MaxPageNum = 0 --最大背包页数（背包+二次元/每页数量）
local CurNumInBag = 0
local UpMaxBagGold = 0 --升级背包容量所需金币
local lvupequip_persent = 0
local lvupequip_tread = 0

local beUseBagList = {} --装备的物品背包列表
local BagList = {} --背包物品列表
local ErCiBagList = {} --二次元背包列表

--更新和获取背包最大页数
function FlushMaxPageNum( _pageNum, _numInBag )
	MaxPageNum = _pageNum
	CurNumInBag = _numInBag
end
function getMaxPageNum()
	return MaxPageNum
end
function getlvupequip_persent(  )
	-- body
	return lvupequip_persent,lvupequip_tread
end
function flush_lvup_persent( _percent ,tread)
	-- body
	lvupequip_persent = _percent
	lvupequip_tread = tread
end
--更新和获取背包最大容量
function FlushMaxBag( _newNum )
	MaxBag = _newNum
end

function getMaxBag()
	return CurNumInBag, MaxBag
end
--更新和获取升级背包容量所需的金币
function flushUpMaxBagGold( _newNum )
	UpMaxBagGold = _newNum
end
function flushBagStrongCD( _state,_cd )
	-- body
	state = _state
	cd_qianghua = _cd
	print("state == " .. state)
	print("cd_qianghua == " .. cd_qianghua)
end
function clearBagStrongCD( )
	-- body
	state = 0
	cd_qianghua = 0
end
function getUpMaxBagGold()
	return UpMaxBagGold
end
--获取二次元背包的实际物品数量
function getErCiBagListSize()
	return #ErCiBagList
end

--添加到背包列表
--_BagWitch 1装备的 2背包的 3二次元的
function addBag( _BagWitch, _data )
	if _BagWitch == 1 then  --装备的
		table_insert( beUseBagList, _data )
	elseif _BagWitch == 2 then --背包的
		table_insert( BagList, _data )
		print("=====bagsize:" .. #BagList)
	elseif _BagWitch == 3 then --二次元背包的
		table_insert( ErCiBagList, _data )
	end 
end
--通过唯一索引来获取此物品的数据本地序列
function getLocalIdxFromOnlyIdx(_BagWitch, onlyIdx)
	if _BagWitch == 1 then  --装备的
		local num = #beUseBagList
		for i=1, num do
			if beUseBagList[i]["GoodIndex"] == onlyIdx then
				return i
			end
		end
		return 0
	elseif _BagWitch == 2 then --背包的
		local num = #BagList
		for i=1, num do
			if BagList[i]["GoodIndex"] == onlyIdx then
				return i
			end
		end
		return 0
	elseif _BagWitch == 3 then --二次元背包的
		local num = #ErCiBagList
		for i=1, num do
			if ErCiBagList[i]["GoodIndex"] == onlyIdx then
				return i
			end
		end
		return 0
	end 
end
--获取背包中某一类型的索引数组
function getGoodTabFromType(_BagWitch, _type)
	local tab= {}
	if _BagWitch == 1 then

	elseif _BagWitch == 2 then
		local Num = #BagList
		for i=1, Num do
			if BagList[i]["GoodType"] == _type then
				table_insert(tab, i)
			end
		end
	elseif _BagWitch == 3 then

	end
	return tab
end

BagStone = { 120,121,122,123,124,125 }
function getNvShengStone(_type) --_type 1 进阶石蓝 2 进阶石绿 3 进阶石黄 4 进阶石红 5 进阶石紫  6 培养石
	local Num = #BagList
	for i=1, Num do
		if BagList[i]["GoodId"] == BagStone[_type] then
			return 	BagList[i]["GoodsAmount"] 
		end
	end
	return 0
end

--刷新一个背包数据
function flushBag( _BagWitch, _data )
	if _BagWitch == 1 then
		local Num = #beUseBagList
		for i=1, Num do
			if beUseBagList[i]["GoodIndex"] == _data["GoodIndex"] then
				beUseBagList[i]["GoodId"] 		= _data["GoodId"]
				beUseBagList[i]["IfInBag"] 		= _data["IfInBag"]
				beUseBagList[i]["IfBang"] 		= _data["IfBang"]
				beUseBagList[i]["GeneralId"] 	= _data["GeneralId"]
				beUseBagList[i]["GoodLv"] 		= _data["GoodLv"]
				beUseBagList[i]["GoodTimeLim"] 	= _data["GoodTimeLim"]
				beUseBagList[i]["GoodType"] 	= _data["GoodType"]
				beUseBagList[i]["GoodQuility"] 	= _data["GoodQuility"]
				beUseBagList[i]["GoodsUpZeney"] = _data["GoodsUpZeney"]
				beUseBagList[i]["GoodsDownZeney"]= _data["GoodsDownZeney"]
				beUseBagList[i]["GoodsPrice"] 	= _data["GoodsPrice"]
				beUseBagList[i]["GoodsProType"] = _data["GoodsProType"]
				beUseBagList[i]["GoodsProSkip"] = _data["GoodsProSkip"]
				beUseBagList[i]["GoodsProCount"]= _data["GoodsProCount"]
				beUseBagList[i]["GoodsAmount"] 	= _data["GoodsAmount"]
				beUseBagList[i]["GoodsTotal"]   = _data["GoodsTotal"]	
    			beUseBagList[i]["IfBeMake"] 	= _data["IfBeMake"]
				return
			end
		end	
	elseif _BagWitch == 2 then --背包的
		local Num = #BagList
		for i=1, Num do
			if BagList[i]["GoodIndex"] == _data["GoodIndex"] then
				BagList[i]["GoodId"] 		= _data["GoodId"]
				BagList[i]["IfInBag"] 		= _data["IfInBag"]
				BagList[i]["IfBang"] 		= _data["IfBang"]
				BagList[i]["GeneralId"] 	= _data["GeneralId"]
				BagList[i]["GoodLv"] 		= _data["GoodLv"]
				BagList[i]["GoodTimeLim"] 	= _data["GoodTimeLim"]
				BagList[i]["GoodType"] 		= _data["GoodType"]
				BagList[i]["GoodQuility"] 	= _data["GoodQuility"]
				BagList[i]["GoodsUpZeney"] 	= _data["GoodsUpZeney"]
				BagList[i]["GoodsDownZeney"]= _data["GoodsDownZeney"]
				BagList[i]["GoodsPrice"] 	= _data["GoodsPrice"]
				BagList[i]["GoodsProType"] 	= _data["GoodsProType"]
				BagList[i]["GoodsProSkip"] 	= _data["GoodsProSkip"]
				BagList[i]["GoodsProCount"] = _data["GoodsProCount"]
				BagList[i]["GoodsAmount"] 	= _data["GoodsAmount"]
				BagList[i]["GoodsTotal"]   = _data["GoodsTotal"]	
    			BagList[i]["IfBeMake"] 	= _data["IfBeMake"]
				return
			end
		end
	elseif _BagWitch == 3 then --二次元背包的
		local Num = #ErCiBagList
		for i=1, Num do
			if ErCiBagList[i]["GoodIndex"] == _data["GoodIndex"] then
				ErCiBagList[i]["GoodId"] 		= _data["GoodId"]
				ErCiBagList[i]["IfInBag"] 		= _data["IfInBag"]
				ErCiBagList[i]["IfBang"] 		= _data["IfBang"]
				ErCiBagList[i]["GeneralId"] 	= _data["GeneralId"]
				ErCiBagList[i]["GoodLv"] 		= _data["GoodLv"]
				ErCiBagList[i]["GoodTimeLim"] 	= _data["GoodTimeLim"]
				ErCiBagList[i]["GoodType"] 		= _data["GoodType"]
				ErCiBagList[i]["GoodQuility"] 	= _data["GoodQuility"]
				ErCiBagList[i]["GoodsUpZeney"] 	= _data["GoodsUpZeney"]
				ErCiBagList[i]["GoodsDownZeney"]= _data["GoodsDownZeney"]
				ErCiBagList[i]["GoodsPrice"] 	= _data["GoodsPrice"]
				ErCiBagList[i]["GoodsProType"] 	= _data["GoodsProType"]
				ErCiBagList[i]["GoodsProSkip"] 	= _data["GoodsProSkip"]
				ErCiBagList[i]["GoodsProCount"] = _data["GoodsProCount"]
				ErCiBagList[i]["GoodsAmount"] 	= _data["GoodsAmount"]
				ErCiBagList[i]["GoodsTotal"]   = _data["GoodsTotal"]	
    			ErCiBagList[i]["IfBeMake"] 	= _data["IfBeMake"]
				return
			end
		end
	end
end

function delGoods(_BagType, _goodsOnlyIdx)
	if _BagType == 1 then
		local num = #beUseBagList 
		for i=1, num do
			if _goodsOnlyIdx == beUseBagList[i]["GoodIndex"] then
				table_remove(beUseBagList, i)
				return
			end
		end		
	elseif _BagType == 2 then
		local num = #BagList 
		print("num1 === " .. num)
		for i=1, num do
			if _goodsOnlyIdx == BagList[i]["GoodIndex"] then
				table_remove(BagList, i)
				print("num2 === " .. #BagList)
				return
			end
		end
	elseif _BagType == 3 then
		local num = #ErCiBagList 
		for i=1, num do
			if _goodsOnlyIdx == ErCiBagList[i]["GoodIndex"] then
				table_remove(ErCiBagList, i)
				return
			end
		end
	end
end
--通过物品的id获取物品在数据数组中的索引
function getgoodsIdxFromId(_BagType, GoodsId)
	if _BagType == 2 then
		for i=1, #BagList do
			if GoodsId == BagList[i]["GoodId"] then
				return i
			end
		end
	elseif _BagType == 1 then
		for i=1, #beUseBagList do
			if GoodsId == beUseBagList[i]["GoodId"] then
				return i
			end
		end
	elseif _BagType == 3 then
		for i=1, #ErCiBagList do
			if GoodsId == ErCiBagList[i]["GoodId"] then
				return i
			end
		end
	end
	return 0
end

--通过本地索引获取物品数据
function getGoods(_BagType, _dataIndex)
	if _BagType == 2 then
		return BagList[_dataIndex]
	elseif _BagType == 1 then
		return beUseBagList[_dataIndex]
	elseif _BagType == 3 then
		return ErCiBagList[_dataIndex]
	end
end
--通过物品onlyidx获取物品数据
function getGoodsFromIdx(_BagType, onlyIdx)
	if _BagType == 1 then
		local num = #beUseBagList
		for i=1, num do
			if beUseBagList[i]["GoodIndex"] == onlyIdx then
				return beUseBagList[i]
			end
		end
	elseif _BagType == 2 then
		local num = #BagList
		for i=1, num do
			if BagList[i]["GoodIndex"] == onlyIdx then
				return BagList[i]
			end
		end
	elseif _BagType == 3 then
		local num = #ErCiBagList
		for i=1, num do
			if ErCiBagList[i]["GoodIndex"] == onlyIdx then
				return ErCiBagList[i]
			end
		end
	end
end

--获取物品增加的主属性类型和值
function getTypeAndValue( _BagType, _goodsOnlyIdx )
	if _BagType == 1 then
		local num = #beUseBagList 
		for i=1, num do
			if _goodsOnlyIdx == beUseBagList[i]["GoodIndex"] then
				
				return beUseBagList[i]["GoodsProType"], beUseBagList[i]["GoodsProCount"]
			end
		end		
	elseif _BagType == 2 then
		local num = #BagList 
		for i=1, num do
			if _goodsOnlyIdx == BagList[i]["GoodIndex"] then
				
				return BagList[i]["GoodsProType"], BagList[i]["GoodsProCount"]
			end
		end
	elseif _BagType == 3 then
		local num = #ErCiBagList 
		for i=1, num do
			if _goodsOnlyIdx == ErCiBagList[i]["GoodIndex"] then
				
				return ErCiBagList[i]["GoodsProType"], ErCiBagList[i]["GoodsProCount"]
			end
		end
	end
end

function getGoodsIdFromIndex(_BagType, _goodsOnlyIdx)
	if _BagType == 1 then --已穿戴
		local num = #beUseBagList 
		for i=1, num do
			if _goodsOnlyIdx == beUseBagList[i]["GoodIndex"] then
				
				return beUseBagList[i]["GoodId"]
			end
		end		
	elseif _BagType == 2 then --背包未穿戴
		local num = #BagList 
		for i=1, num do
			if _goodsOnlyIdx == BagList[i]["GoodIndex"] then
				
				return BagList[i]["GoodId"]
			end
		end
	elseif _BagType == 3 then --二次元
		local num = #ErCiBagList 
		for i=1, num do
			if _goodsOnlyIdx == ErCiBagList[i]["GoodIndex"] then
				
				return ErCiBagList[i]["GoodId"]
			end
		end
	end

end


function clearBagList()
	BagList={}
end

function clearErCiBagList()
	ErCiBagList={}
end

function clearbeUseBagList()
	beUseBagList={}
end


-------------------------------
--背包倒计时
local lbl_CDBangDing = nil
local lbl_CDDaoQi = nil
local curPage = 0
local curFoucse = 0
--升级倒计时
local witch = 0 --1装备 2背包
local goodsIdx = 0 --物品的本地数组序列
function flushWitchAndIdx( _witch, _idx )
	witch = _witch
	goodsIdx = _idx
end
function setCDlbl( _lblA, _lblB )
	lbl_CDBangDing = _lblA
	lbl_CDDaoQi = _lblB
end
function clearCDlbl()
	lbl_CDBangDing = nil
	lbl_CDDaoQi = nil
	curPage = 0
	curFoucse = 0

	witch = 0
	goodsIdx = 0
end
function flushPageAndFoucse( _curpage, _curfoucse )
	curPage = _curpage
	curFoucse = _curfoucse
end

function flushGoodsCD()
    local dataindex = (curPage-1)*10 + curFoucse
    local curInBagSize = #BagList
    local ercisize = #ErCiBagList
    local allSize = curInBagSize + ercisize
    local data = nil
    local time = 0
    for i=1, allSize do
    	
        if i <= curInBagSize then --背包
        	if BagList[i]["GoodTimeLim"] > 0 then
        		BagList[i]["GoodTimeLim"] = BagList[i]["GoodTimeLim"] -1
        		time = BagList[i]["GoodTimeLim"]
        	end
        elseif i <= curInBagSize + ercisize then
        	local _idx = i-curInBagSize
        	if ErCiBagList[_idx]["GoodTimeLim"] > 0 then
        		ErCiBagList[_idx]["GoodTimeLim"] = ErCiBagList[_idx]["GoodTimeLim"] - 1
        		time = ErCiBagList[_idx]["GoodTimeLim"]
        	end
        end
        if i == dataindex then
        	local str = PT.gerStringFromMilSecond( time )
        	if lbl_CDBangDing ~= nil then
        		lbl_CDBangDing:setText(str)
        	end

        	if lbl_CDDaoQi ~= nil then
        		lbl_CDDaoQi:setText(str)
        	end
        end
        if witch == 2 and i == goodsIdx then --升级背包
        	local str = PT.gerStringFromMilSecond( time )
        	if lbl_CDBangDing ~= nil then
        		if time > 0 then
        			lbl_CDBangDing:setText(str)
        			--lbl_CDBangDing:setVisible(true)
        		else
        			lbl_CDBangDing:setVisible(false)
        		end
        	end
        end
    end
    local size = #beUseBagList 
    for i=1, size do
        if beUseBagList[i]["GoodTimeLim"] > 0 then
        	beUseBagList[i]["GoodTimeLim"] = beUseBagList[i]["GoodTimeLim"] -1
        	time = beUseBagList[i]["GoodTimeLim"]
        end
        if witch == 1 and i == goodsIdx then --升级背包
        	local str = PT.gerStringFromMilSecond( time )
        	if lbl_CDBangDing ~= nil then
        		if time > 0 then
        			lbl_CDBangDing:setText(str)
        			--lbl_CDBangDing:setVisible(true)
        		else
        			lbl_CDBangDing:setVisible(false)
        		end
        	end
        end
    end
end
--检测背包强化cd是否可用，用以显示小红点
function checkBagQHIfBeUse()
	if state == 0 then --可用
		return true
	else
		return false
	end
end
function flushQiangHuaCDForManager()
	
	if cd_qianghua > 0 then
		cd_qianghua =  cd_qianghua - 1
		
		if cd_qianghua == 0 then
			protoSend0x0524( 10 )
		end

		if lbl_qianghua ~= nil then
			local str = PT.gerStringFromMilSecond( cd_qianghua )
			lbl_qianghua:setText( str )
			lbl_qianghua:setVisible(true)
			if state == 0 then --可用
				lbl_qianghua:setColor( ccc3(255, 255, 255) )
			else --不可用
				lbl_qianghua:setColor( ccc3(255, 0, 0) )
			end
			if btn_qianghua ~= nil then
				btn_qianghua:setVisible(true)
				btn_qianghua:setTouchEnabled(true)
			end
		end


		if lbl_pubQH ~= nil then
			local str = PT.gerStringFromMilSecond( cd_qianghua )
			lbl_pubQH:setText( str )
			lbl_pubQH:setVisible(true)
			if state == 0 then --可用
				img_pubQH:setVisible(true)
				lbl_pubQH:setColor( ccc3(255, 255, 255) )
			else --不可用
				img_pubQH:setVisible(false)
				lbl_pubQH:setColor( ccc3(255, 0, 0) )
			end
			if btn_pubQH ~= nil then
				btn_pubQH:setVisible(true)
				btn_pubQH:setTouchEnabled(true)
			end
		end
	else
		if lbl_qianghua ~= nil then
			lbl_qianghua:setColor( ccc3(255, 255, 255) )
			lbl_qianghua:setText("强化可用")
			lbl_qianghua:setVisible(false)
			if btn_qianghua ~= nil then
				btn_qianghua:setVisible(false)
				btn_qianghua:setTouchEnabled(false)
			end
		end
		if lbl_pubQH ~= nil then
			lbl_pubQH:setColor( ccc3(255, 255, 255) )
			lbl_pubQH:setText("强化可用")
			img_pubQH:setVisible(true)
			if btn_pubQH ~= nil then
				btn_pubQH:setVisible(false)
				btn_pubQH:setTouchEnabled(false)
			end
		end
	end

end

function setQiangHuaCDLable( _lable, _button )
	lbl_qianghua = _lable --保存征战CD的lable
	btn_qianghua = _button --保存征战清除恩建
end
function clearQiangHuaCDLable()
	lbl_qianghua = nil --保存征战CD的lable
	btn_qianghua = nil --保存征战清除恩建
end

function setPubQiangHuaCDLable( _lable, _button, _redImg)

	lbl_pubQH = _lable
	btn_pubQH = _button
	img_pubQH = _redImg
end
function clearPubQiangHuaCDLable()
	lbl_pubQH = nil --保存征战CD的lable
	btn_pubQH = nil --保存征战清除恩建
	img_pubQH = nil
end