module ("CityData",package.seeall)
--城市数据
CityTemplet = {
	Id = 0,		--城市id
	Lv = 0, 	--城市等级
	UpZeny = 0,  --升级所需银币
	UpTime = 0,  --升级将要增加的时间
}

--功能开启
--[[
1为主城
2为世界
3为征战
4为武将
5为武将信息
6为武将训练
7为武将培养
8为武将招募
9为布阵
10为科技
11为装备
12为装备列表
13为装备的装备界面
14为装备强化
15为委派
16为女神
17为女神进阶
18为女神升级
19为军团
20为任务
21为主线任务
22为日常任务
23为征收
24为购粮
25为官职
26为祭祀
27为寻宝
28为同国pvp
29为异国pvp
30为vip
31为充值
32为扫荡npc
33为每日奖励
34为国战
35为军团战
36为聊天
37为讨扫玩家

--   7超值月卡   10首冲三倍 11新服特享 
38每日排行
39开服活动

40登录领取  	5七日登录送大礼
41成就坛
42首充大礼
43犒赏奖励    	1 犒赏三军
44vip独享礼包 	6vip独享礼包
45军令大礼包 	8军令大礼包
46每日充值礼包 	9每日充值
47充值大礼包
48超级月卡
49中秋活动
50国庆活动
--]]
OpenFuncTemplet = {
	Id = 0,
	open = 1,
}

local openFuncTable = {}
function clearOpenFuncData()
	openFuncTable = {}
end
function addOpenFuncData(_data)
	table_insert(openFuncTable,_data)
end
function canOpenFuncByIndex(_id)
	local data = nil
	for i=1,#openFuncTable do
		if openFuncTable[i]["Id"] == _id then
			data = openFuncTable[i]
			break
		end
	end

	if data~= nil then
		--print("=====canOpenFuncByIndex=" .. _index)
		--print("xxxx = " .. openFuncTable[_index]["open"])
		if _id == 32 then
			return data["open"] --0:未开启 1：vip等级不足 2 
		elseif _id == 35 then
			return data["open"] --1：显示图标 2:会长可以点  3:既可以点又显示图标
		else
			return data["open"] == 1
		end
	else
		return false
	end
end

--1主城2民居3仓库4军机处5校场6商店7驿站8农田9银矿
local cityData = {}

local remFistLv = {} --记录某一城市第一次到达某一等级
function addCityData( _data )
	table_insert(cityData, _data)
end
function clearCityData()
	cityData = {}
end
--返回当前id的主城等级
function getCityLvFromId( _id )
	local num = #cityData
	for i=1, num do
		if cityData[i]["Id"] == _id then
			return cityData[i]["Lv"]
		end
	end
	return 0
end
--通过城市id判断相应城市是否开启
function getStateOpenFromId(_cityid)
	local num = #cityData
	for i=1, num do
		if cityData[i]["Id"] == _cityid then
			return true
		end
	end
	return false
end
---[[
function getIfFistLv(_id, _lv)
	if remFistLv[_id]~= nil and remFistLv[_id][_lv] ~= nil and remFistLv[_id][_lv] == 1 then
		remFistLv[_id][_lv] = 0
		return true

	else
		return false
	end
end
--]]
function getCityDataFromId( _id )
	local num = #cityData
	for i=1, num do
		if cityData[i]["Id"] == _id then
			return cityData[i]
		end
	end
	return 0
end
function flushCityLvFromId( _id, _lv )
	local num = #cityData
	for i=1, num do
		if cityData[i]["Id"] == _id then
			---[[
			--if _lv == cityData[i]["Lv"] +1 then
				if remFistLv[_id] == nil then
					remFistLv[_id] = {}
				end
				remFistLv[_id][_lv] = 1 --第一次升级到_lv级，记录
			--end
			--]]
			cityData[i]["Lv"] = _lv
			
			MapShouYe.flushCityLv(_id, _lv)
			
			return true
		end
	end
	return false
end
function getCityNum()
	return #cityData
end
function getCityDataFromIndex(_locIdx)
	return cityData[_locIdx]

end
function setEnterUIIndex()
	for	i=10, 5 do
		if openFuncTable[i]["open"]==1 then
			remGeneral= i
		end
	end
	for i=14 ,11 do
		if openFuncTable[i]["open"]==1 then
			remBag= i
		end
	end
end