module ("FoodData",package.seeall)
--粮草数据

local _foodData = {
	Today_buy = 0, --今日已买粮草
	Today_Max = 0, --今日可买粮草上限
	PuTongLim = 0, --普通市场可买粮草上限
	HeiShiLim = 0, --黑市可买粮草上限
	FoodLeft  = 0, --粮仓当前粮草
	FoodMax   = 0, --粮仓最大容量
	PuTongJia = 0, --普通粮草一个单位价格
	HeiShiJia = 0, --黑市粮草一个单位价格
}

function flushFoodData(_Today_buy, _Today_Max, _PuTongLim, _HeiShiLim, _FoodLeft, _FoodMax, _PuTongJia, _HeiShiJia)
	_foodData["Today_buy"] = _Today_buy
	_foodData["Today_Max"] = _Today_Max
	if _foodData["FoodLeft"]<_FoodLeft and _foodData["FoodLeft"] ~=0 then
		AudioEngine.playEffect("4_4.wav", false)
	end
	_foodData["PuTongLim"] = _PuTongLim
	_foodData["HeiShiLim"] = _HeiShiLim
	_foodData["FoodLeft"]  = _FoodLeft
	_foodData["FoodMax"]   = _FoodMax
	_foodData["PuTongJia"] = _PuTongJia
	_foodData["HeiShiJia"] = _HeiShiJia
end

function getFoodData()
	return _foodData
end

--粮草和粮草上限
function flushProvition( _new )
	_foodData["FoodLeft"] = _new
end
function getProvition()
	return _foodData["FoodLeft"]
end

function flushProvitionLim( _new )
	_foodData["FoodMax"] = _new
end
function getProvitionLim()
	return _foodData["FoodMax"]
end