module ("JunTuanZhanData",package.seeall)

local zhanling_cityid = 1   --本军团占领的关卡id
local shouhuonum 	  = 1	--收获的次数
local total 		  = 1   --总次数
local ifCanJunTuanZhan = false
local FightResult  	  = 1 --0失败 1胜利
local gongJiCityId    = 1

TeamTemplet = {
	Id 				= 0, --玩家在团队里的id
	Name 			= "", --玩家名字
}

JunTuanZhan_GuanKaTable = {   --军团战中关卡信息
}

JunTuanZhan_ZhangChang1Table = {  --军团战中战场信息 自己方
}

JunTuanZhan_ZhangChang2Table = {  --军团战中战场信息 敌方
}

FightGeneralTemplet = {
	GeneralPos = 0, --将领所在阵型位置
	GeneralId = 0, --将领id
	CurBlood = 0, --当前所剩血量
	MaxBlood = 0, --最大血量
}

FightTeamTemplet = {
	Pos 		= 0, --所在的位置（大的位置，123， 456）
	TeamId 		= 0, --军团数据索引
	Type 		= 0, --这一回合的战斗状态0为状态不变 1为上场 2为正在战斗 3为胜利等待 4为下场
	WinCount	= 0, --连胜次数
	LoseBlood 	= 0, --这一回合掉了多少血
	GeneralCount= 0, --掉血的将领数量
	GeneralData = {}
}

JTZ_ZhanBao_Table = {}

JTZ_ZhanBao = {
	id1 = 0 ,  --攻击方id
	id2 = 0 ,  --守方id
	win = 0 ,  --成败
	winCount = 0, -- 连胜次数
	round = 0, -- 那一个回合可以出现
}

FightRoundTemplet = {
	TeamNum = 0,
	TeamData = {}
}

LeftTeamDataList = {
}

RightTeamDataList = {
}

FightDataList = {
}

JunTuanZhan_GuanKa = {
	id = 1,
	state = 1,
	name ="",
	emb_lv = 0,	  --军团等级
	emb_name ="", --军徽名字
	time = 0,
	_type = 1,    --物品种类
	num = 1,      --物品个数
	shouhuoMax = 1,
}

JunTuanZhan_Output  = {
	[1]="粮食",
	[2]="银币",
}

JunTuanZhan_ZhangChang = {
	id = 1,
	lv = 1,
	name ="",
	gongjiguwu = 0,
	fangyuguwu = 0,
}

local JTZResult_CD = 0
local JTZ_Master = 1 --是否是军团长

local fightcdlabel = nil

function clearJTZZhanBao()
	JTZ_ZhanBao_Table = {}
end

function getZhanBaoCount()
	return #JTZ_ZhanBao_Table
end

function addJTZZhanBao(_data)
	table_insert(JTZ_ZhanBao_Table,_data)
end

function getJTZZhanBaoTable()
	return JTZ_ZhanBao_Table
end

function getJTZZhanBaoByIdx(_index)
	return JTZ_ZhanBao_Table[_index]
end

function setJunTuanZhang(_master)
	JTZ_Master = _master
end

function setFightLastCD(_lableCD)
	fightcdlabel = _lableCD
end

function getJunTuanZhang()
	return JTZ_Master
end

function setFightResultCD( _cd )
	JTZResult_CD = _cd
end

function flushJunTuanZhanCDForManager()
	if JTZResult_CD >0 then
		JTZResult_CD = JTZResult_CD - 1
	elseif JTZResult_CD == 0 then	
		JunTuanZhan_JieGuo.Hide_Layer()
		JTZResult_CD = -1
	end
	for i=1,7 do		
		local _data = getGuanKa(i)
		if _data ~= nil and _data["time"] >0 then
			_data["time"] = _data["time"] - 1
			if fightcdlabel~= nil then
				fightcdlabel:setVisible(true)
				fightcdlabel:setText("开战倒计时："..PT.gerStringFromMilSecond(_data["time"]))
				break
			end
		else
			if fightcdlabel~= nil then
				fightcdlabel:setVisible(false)
			end
		end
	end
end

function getMaxFightRound()
	return #FightDataList
end
function getRoundFightData( RoundIdx )
	return FightDataList[RoundIdx]
end

function getLeftTeamNameFromLocIdx(_idx)
	if LeftTeamDataList[_idx] ~= nil then
		return LeftTeamDataList[_idx]["Name"]
	else
		return nil
	end
end

function addFightDataList( _data )
	table_insert( FightDataList, _data )
end

function addTeamDataList(_swc, _data)
	if _swc == 1 then
		table_insert( LeftTeamDataList, _data )
	elseif _swc == 2 then
		table_insert( RightTeamDataList, _data )
	end
end
function getTeamdataList(_swc)
	if _swc == 1 then
		return LeftTeamDataList
	elseif _swc == 2 then
		return RightTeamDataList
	end
end
function clearAllData()
	FightResult = -1
	LeftTeamDataList = {}
	RightTeamDataList = {}
	FightDataList = {}
end

function setFightResult( _result )
	FightResult = _result
end

function getFightResult()
	return FightResult
end

function getGongjiCityId()
	return gongJiCityId
end

function setGongJiCityId(_cityId)
	gongJiCityId = _cityId
end 

function getZhanling()
	return zhanling_cityid 
end

function setJTZData(_id,_shouhuo,_total)
	zhanling_cityid = _id
	shouhuonum = _shouhuo
	total = _total
end

function getshouhuonum(_index)
	if zhanling_cityid == JunTuanZhan_GuanKaTable[_index]["id"] then
		return shouhuonum.."/"..JunTuanZhan_GuanKaTable[_index]["shouhuoMax"]
	else
		return "0/"..JunTuanZhan_GuanKaTable[_index]["shouhuoMax"]
	end
end

function getCityOutput(_index)
	return  JunTuanZhan_Output[JunTuanZhan_GuanKaTable[_index]["_type"]].."_"..JunTuanZhan_GuanKaTable[_index]["num"]
end

function clearGuanKa()
	JunTuanZhan_GuanKaTable = {}
end

function addGuanKa( _guanka )
	table_insert(JunTuanZhan_GuanKaTable,_guanka)
end

function getGuanKa(_index)
	return  JunTuanZhan_GuanKaTable[_index]
end

function clearZhangChang()
	JunTuanZhan_ZhangChang1Table = {}
	JunTuanZhan_ZhangChang2Table = {}
end

function addZhangChang( _zhangChang )
	if  _zhangChang["id"] <= 30 then
		table_insert(JunTuanZhan_ZhangChang1Table,_zhangChang)
	else
		print("addZhangChang 2")
		table_insert(JunTuanZhan_ZhangChang2Table,_zhangChang)
	end
end

function getZhangChangByIndex(_index ,_type)
	if _type == 1 then
		return JunTuanZhan_ZhangChang1Table[_index]
	else
		return JunTuanZhan_ZhangChang2Table[_index]
	end
end

function getZhangChangByPos(_index ,_type)
	if _type == 1 then

		local allnum = #JunTuanZhan_ZhangChang1Table
		for i=1,allnum do	
			local _data = JunTuanZhan_ZhangChang1Table[i]
			if _data["id"]== _index then
				return _data
			end
		end
		return nil
	else
		return JunTuanZhan_ZhangChang2Table[_index]
	end
end


