module ("MailListData",package.seeall)

MailTemplet = {
	MailId 		= "",
	ReadState 	= 0, --0未读，1已读
	SenderId 	= "", --寄件人id  ==“” 是系统邮件
	SenderName 	= "",--寄件人名字
	MailTitle 	= "",
	MailBody 	= "",
	MailYear 	= 0,
	MailSeason	= 0,
}

local MailListData = {}

function addMailToMailListData( _data )
	table_insert(MailListData, _data)
end
function clearMailListData()
	MailListData = {}
end
--用于关闭时更新服务器状态
function getReadMailTable()
	local num = #MailListData
	local remtable= {}
	for i= 1, num do
		if MailListData[i]["ReadState"] == 1 then
			print("关闭邮件 == " ..  MailListData[i]["MailId"])
			table_insert( remtable, MailListData[i]["MailId"] )
		end
	end
	return remtable
end
--判断是否显示小红点
function getIfViewRedPoint()

	for i= 1, #MailListData do
		if MailListData[i]["ReadState"] == 0 then --有未读邮件 显示小红点
			return true
		end
	end
	return false
end

function getUnreadMailNum()--获取未读的邮件的数量
	local num = #MailListData
	local unreadNum = 0
	for i= 1, num do
		if MailListData[i]["ReadState"] == 0 then
			unreadNum= unreadNum+1
		end
	end
	return unreadNum
end

function delMailFromId( _id )
	if _id == "" then --全部删除
		MailListData = {}
	else --只删除一封
		local num = #MailListData
		for i=1, num do
			if MailListData[i]["MailId"] == _id then
				table_remove(MailListData, i)
				return 
			end
		end
	end
end

function getTableIdx( _type )
	local MailNum = #MailListData
	local table = {}  --分类
	local BackTable = {}
	if _type == 1 then --全部邮件
		for i=1, MailNum do
			table_insert( table, i )
		end
	elseif _type == 2 then --系统邮件
		for i=1, MailNum do
			if MailListData[i]["SenderId"] == "" then
				table_insert( table, i )
			end
		end
	elseif _type == 3 then --玩家邮件
		for i=1, MailNum do
			if MailListData[i]["SenderId"] ~= "" then
				table_insert( table, i )
			end
		end
	end
	
	local num = #table
	for i=1, num do
		if MailListData[table[num-i+1]]["ReadState"] == 0 then --未读 新来的邮件在前边
			table_insert( BackTable, table[num-i+1] )
		end
	end
	for i=1, num do
		if MailListData[table[num-i+1]]["ReadState"] == 1 then --已读 新来的邮件在前边
			table_insert( BackTable, table[num-i+1] )
		end
	end
	return BackTable
end

function getMailDataFromLocalIdx( _idx )
	return MailListData[_idx]
end

function openMail( _idx )
	MailListData[_idx]["ReadState"] = 1
end