module ("XunBaoData", package.seeall)

local times = 0		--寻宝次数
local state = 0		--寻宝状态
local genCount = 0		--产生线索格子数
TaskListTemplet = {
	cell_1	=	0,	--任务线索id1
	cell_2	=	0,	--任务线索id2
	cell_3	=	0,	--任务线索id3
	zeny 	= 0,  	--奖励银币
}
local treasureRetData = {
	state 	= 0,	--寻宝状态
	times 	= 0,	--已寻宝次数
	win	  	= 0,	--1(达成) 0(未达成) 2(进map刷新push数据)
	task_id = 0,	--达成事件的id	
	zeny 	= 0,	--达成事件获得的银币
--[[	
	gen_1	= 0,	
	gen_2	= 0,
	gen_3	= 0,
	gen_4	= 0,
	found_1 = 0,
	found_2 = 0,
	found_3 = 0,
	found_4 = 0,
	found_5 = 0,
--]]
}

local genData = {}
local foundData = {}

local tasklistData = {}

function flushTreasureRetData( _state,_times,_win,_task_id, _zeny)
	--,_gen_1,_gen_2,_gen_3,_gen_4,_found_1,_found_2,_found_3,_found_4,_found_5 
	treasureRetData["state"]	 = _state
	treasureRetData["times"]	 = _times
	treasureRetData["win"]		 = _win
	treasureRetData["task_id"]	 = _task_id
	treasureRetData["zeny"]	 	 = _zeny
--[[
	treasureRetData["gen_1"]	 = _gen_1
	treasureRetData["gen_2"]	 = _gen_2
	treasureRetData["gen_3"]	 = _gen_3
	treasureRetData["gen_4"]	 = _gen_4
	treasureRetData["found_1"]	 = _found_1
	treasureRetData["found_2"]	 = _found_2
	treasureRetData["found_3"]	 = _found_3
	treasureRetData["found_4"]	 = _found_4
	treasureRetData["found_5"]	 = _found_5
--]]
end
function clearTreasureRetData()
	treasureRetData = {}
end

function addGenData( _data )
	table_insert( genData, _data )
end
function clearGenData()
	genData = {}
end
function addFoundData( _data )
	table_insert( foundData, _data )
end
function clearFoundData()
	foundData = {}
end

function addTaskListData( _data )
	table_insert( tasklistData, _data )
end

function clearTaskListData( )
	tasklistData = {}
end

function getTreasureRetData( _idx )
	return treasureRetData[_idx]
end
function getTaskTip( _taskID, _cellID )
	-- body
	if( _cellID == 1) then
		return tasklistData[_taskID]["cell_1"]
	elseif(_cellID == 2) then 
		return tasklistData[_taskID]["cell_2"]
	elseif(_cellID == 3) then
		return tasklistData[_taskID]["cell_3"]
	end
end
function getTaskZeny(_taskID)
	return tasklistData[_taskID]["zeny"]
end
function getGenData( _id )
	return genData[_id]
end
function getFoundData( _id )
	return foundData[_id]
end
function goBackRealData()
	-- body
	treasureRetData["win"] = 0
	local count = 0
	local id = 5
	for i=1,3 do
		if getTaskTip( treasureRetData["task_id"], i) > 0 then
			count = count + 1
		end
	end
	print(" goBackRealData -- count == " .. count)
	for i=1,5 do
		if getFoundData(i) == 0 then
			id = i - 1
			--print("i == " .. i)
			break
		end
	end
	print(" goBackRealData -- id == " .. id)
	for i=id - count + 1,id do
		foundData[i] = 0
	end
	for i=1,5 do
		print("goBackRealData -- foundData" .. i .. " == " .. foundData[i])
	end
end
function getFaceId( _curTaskId )
	-- body
	local id = 0
	local tmp = {}
	local countTask = 0
	local countFound = 0
	local countGen = 0

	for i=1,3 do
		if getTaskTip( _curTaskId, i ) > 0 then
			countTask = countTask + 1
		else 
			break
		end
	end
	for i=1,5 do
		if getFoundData( i ) > 0 then
			countFound = countFound + 1
		else
			break
		end
	end
	for i=1,4 do
		if getGenData( i ) > 0 then
			countGen = countGen + 1
		else
			break
		end
	end

	if countFound == 0 then
		for i=1,countGen do
			if getTaskTip( _curTaskId, 1 ) == getGenData( i ) then
				return i
			end
		end
	elseif countFound == 1 then
		if getTaskTip( _curTaskId, 1 ) == getFoundData( countFound ) then
			for i=1,countGen do
				if getTaskTip( _curTaskId, 2 ) == getGenData( i ) then
					return i
				end
			end
		else 
			for i=1,countGen do
				if getTaskTip( _curTaskId, 1 ) == getGenData( i ) then
					return i
				end
			end
		end
	elseif countFound > 1 then
		if countTask == 3 then
			if getTaskTip( _curTaskId, 1 ) == getFoundData( countFound-1 ) and getTaskTip( _curTaskId, 2 ) == getFoundData( countFound ) then
				for i=1,4 do
					if getTaskTip( _curTaskId, 3 ) == getGenData( i ) then
						return i
					end
				end
			elseif getTaskTip( _curTaskId, 1 ) == getFoundData( countFound ) then
				for i=1,4 do
					if getTaskTip( _curTaskId, 2 ) == getGenData( i ) then
						return i
					end
				end
			else
				for i=1,countGen do
					if getTaskTip( _curTaskId, 1 ) == getGenData( i ) then
						return i
					end
				end 
			end
		elseif countTask == 2 then
			if getTaskTip( _curTaskId, 1 ) == getFoundData( countFound ) then
				for i=1,4 do
					if getTaskTip( _curTaskId, 2 ) == getGenData( i ) then
						return i
					end
				end
			else
				for i=1,countGen do
					if getTaskTip( _curTaskId, 1 ) == getGenData( i ) then
						return i
					end
				end 
			end
		end

	end
	
--[[
	for i=1,countTask-1 do
		for j=1,i do
			if getTaskTip( _curTaskId, j) ~= getFoundData( countFound-j ) then
				return 0
			end
		end

		for k=1,4 do
			if getTaskTip( _curTaskId, i+1 ) == getGenData( k ) then
				return k
			end
		end
	end
--]]
	return id
end

