module ("Pop3_GoodsXiangQing",package.seeall)
--将领更改训练模式的3级UI
--local curScene = nil
local curLayer = nil
local widget = nil

local function initpubMod( _dataidx )
	local btn_close = tolua.cast( curLayer:getWidgetByName("Button_guanbi"), "Button" )
	local function btn_closeCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			exitUI()
		end
	end
	btn_close:addTouchEventListener( btn_closeCB )

	local lbl_name = tolua.cast( curLayer:getWidgetByName("Label_name"), "Label" )
	local img_head = tolua.cast( curLayer:getWidgetByName("ImageView_GoodsPic"), "ImageView" )
	local lbl_peiDaiNeed = tolua.cast( curLayer:getWidgetByName("Label_chuandaiLv"), "Label" )
	local lbl_pinJie = tolua.cast( curLayer:getWidgetByName("Label_qianghualv"), "Label" )
	local lbl_shuXing = tolua.cast( curLayer:getWidgetByName("Label_shuxing"), "Label" )
	local img_PinZhiKuang = tolua.cast( curLayer:getWidgetByName("ImageView_PinZhiKuang"), "ImageView" )

	local font_Power = tolua.cast( curLayer:getWidgetByName("LabelBMFont_zhanDouLi"), "LabelBMFont" )
    local img_powerDi2 =  tolua.cast( curLayer:getWidgetByName("ImageView_PowerDi2"), "ImageView" )

	local curInBagSize,_ = BagData.getMaxBag()
	local ercisize = BagData.getErCiBagListSize()
    
    local data = nil
	local ifInBag = false --true 背包里 false 二次元里
	local ifDown = false --true 可以降级 false 不可以
	local ifBang = 0 --1 未绑定 2 解绑定中 3 绑定

    if _dataidx <= curInBagSize then --背包
        data = BagData.getGoods(2, _dataidx)
        ifInBag = true
    elseif _dataidx <= curInBagSize + ercisize then --二次元
        data = BagData.getGoods(3, _dataidx-curInBagSize)
        ifInBag = false
    else
        print("背包详情报错了吧....")
        return
    end
    local quility = data["GoodQuility"]
    local goodsid = data["GoodId"]
    local goodsOnlyIdx = data["GoodIndex"]
    local goodsType = data["GoodType"] --1武器 2防具 3兵符 4兵书 5碎片
    local GoodsAmount = data["GoodsAmount"] --堆叠数量
    local goodsLv = data["GoodLv"] --强化等级

    local goodsdes = Des.getGoodsDesFromId( goodsid )
    local goodPeiDaiNeed = goodsdes["goodsLevel"] --佩戴等级
    local GoodsName = goodsdes["goodsName"]
    local GoodsType = data["GoodType"] 
    local JieNum, xingNum = math_modf( goodsLv/10 ) --物品星阶
    xingNum = xingNum*10

    local headPath = GoodsHeadPath .. goodsdes["goodsPic"] .. ".png" --物品头像

    if goodsLv > 0 then 
    	ifDown = true
    else
    	ifDown = false
    end
    if data["IfBang"] == 1 then --绑定
    	--if data["GoodTimeLim"] > 0 then
    	--	ifBang = 2
    	--else
    		ifBang = 3
    	--end
    else --未绑定
    	if data["GoodTimeLim"] > 0 then
    		ifBang = 2
    	else
    		ifBang = 1
    	end
    end
    --[[
    if GoodsType > 5 and GoodsType < 12 then
       	GoodsName = GoodsName .. " x" .. GoodsAmount
    end
    --]]
    if data["GoodsTotal"] > 1 then --说明是有堆叠的
        if data["IfBeMake"] == 1 then
            GoodsName = GoodsName .. " x" .. GoodsAmount .. "/" .. data["GoodsTotal"]
        else
            GoodsName = GoodsName .. " x" .. GoodsAmount
        end
    end

    local quility = goodsdes["goodsQuality"]
	img_PinZhiKuang:loadTexture( "rim+" .. quility .. "_juntuan.png" )

    lbl_name:setText( GoodsName )
    lbl_name:setColor( ccc3( GoodsColorTab[quility][1], GoodsColorTab[quility][2], GoodsColorTab[quility][3]) )
    img_head:loadTexture( headPath )
    lbl_peiDaiNeed:setText( goodPeiDaiNeed .. "级可穿戴" )
    lbl_pinJie:setText( JieNum .. "阶" .. xingNum .. "星" )

    local zhushu = data["GoodsProType"]
    local zhushuvalue = data["GoodsProCount"]

    local str = nil
    if zhushu == 1 then --1攻击 
        str = "攻击+" .. zhushuvalue
        --str2 = "攻击+" .. curGoodsData["GoodsProSkip"]
         img_powerDi2:setVisible(true)
        font_Power:setText(data["GoodsPower"])
    elseif zhushu == 2 then --2防御 
        str = "防御+" .. zhushuvalue
        --str2 = "防御+" .. curGoodsData["GoodsProSkip"]
         img_powerDi2:setVisible(true)
        font_Power:setText(data["GoodsPower"])
    elseif zhushu == 3 then --3带兵数 
        str = "带兵数+" .. zhushuvalue
        --str2 = "带兵数+" .. curGoodsData["GoodsProSkip"]
         img_powerDi2:setVisible(true)
        font_Power:setText(data["GoodsPower"])
    elseif zhushu == 4 then --4女神防御
        str = "女神防御+" .. zhushuvalue
        --str2 = "女神防御+" .. curGoodsData["GoodsProSkip"]
        img_powerDi2:setVisible(true)
        font_Power:setText(data["GoodsPower"])
    else
    	if GoodsType > 5 and GoodsType < 12 then
    		str = goodsdes["goodsDes"]
    	end
    	img_powerDi2:setVisible(false)
    end
    lbl_shuXing:setText( str )
--[[
    if goodsType == 1 then
    	lbl_shuXing:setText( "武器" )
    elseif goodsType == 2 then
    	lbl_shuXing:setText( "防具" )
    elseif goodsType == 3 then
    	lbl_shuXing:setText( "兵符" )
    elseif goodsType == 4 then
    	lbl_shuXing:setText( "兵书" )
    elseif goodsType == 5 then
    	lbl_shuXing:setText( "碎片" )
    elseif goodsType == 6 then
    elseif goodsType == 7 then
    elseif goodsType == 8 then
    elseif goodsType == 9 then
    elseif goodsType == 10 then
    	lbl_shuXing:setText( "五彩石" )
    elseif goodsType == 11 then	
    	lbl_shuXing:setText( "培养石" )
    end
--]]
    local btn_bangDing = tolua.cast( curLayer:getWidgetByName("Button_BangDing"), "Button" )
    local btn_jiangJi = tolua.cast( curLayer:getWidgetByName("Button_JiangJi"), "Button" )
    local btn_maiChu = tolua.cast( curLayer:getWidgetByName("Button_MaiChu"), "Button" )

    local lbl_btnbangDing = tolua.cast( curLayer:getWidgetByName("Label_1151"), "Label" )
    local lbl_btnjiangJi = tolua.cast( curLayer:getWidgetByName("Label_1153"), "Label" )
    local lbl_btnmaiChu = tolua.cast( curLayer:getWidgetByName("Label_1154"), "Label" )

    --降级返还价格
    local lbl_fanHuan = tolua.cast( curLayer:getWidgetByName("Label_FanHuanNum"), "Label" )
    --卖出价格
    local lbl_shouJia = tolua.cast( curLayer:getWidgetByName("Label_ShouJiaNum"), "Label" )
    --绑定、二次元倒计时cd
    local lbl_timeCD = tolua.cast( curLayer:getWidgetByName("Label_BangDingTime"), "Label" )

	local function btn_CB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			local _btn = tolua.cast(sender, "Button")
			if _btn == btn_bangDing then
				if ifInBag == false then
					--todo：提取物品
					protoSend0x0324( goodsOnlyIdx )
					exitUI()
				else
					if ifBang == 1 then
						--todo：绑定
						protoSend0x0314( goodsOnlyIdx, 1 )
						exitUI()
					elseif ifBang == 2 then --解绑中，可给提示

					elseif ifBang == 3 then
						--todo：解绑
						 protoSend0x0314( goodsOnlyIdx, 2 )
						 exitUI()
					end
				end
			elseif _btn == btn_jiangJi then
				if ifDown then
					--todo：降级
					--protoSend0x0316( goodsOnlyIdx, 2 )
					--exitUI()
					Pop3_XFTiShi.enterUI(316, "是否确认降级该物品？", goodsOnlyIdx)
				end
			elseif _btn == btn_maiChu then
				--todo：卖出
				protoSend0x0312( goodsOnlyIdx )
				exitUI()
			end
		end
	end
	btn_bangDing:addTouchEventListener( btn_CB )
	btn_jiangJi:addTouchEventListener( btn_CB )
	btn_maiChu:addTouchEventListener( btn_CB )

	--卖出价格
	lbl_shouJia:setText( data["GoodsPrice"] )

	if ifInBag == false then --二次元
		
		lbl_btnbangDing:setText("提 取")
		BagData.setCDlbl( lbl_timeCD, nil )
	else
		--1 未绑定 2 解绑定中 3绑定
		if ifBang == 1 then
			lbl_btnbangDing:setText("绑 定")
			lbl_timeCD:setVisible(false)
		elseif ifBang == 2 then --解绑中
			lbl_btnbangDing:setText("绑 定")
			btn_bangDing:setTouchEnabled(false)
			btn_bangDing:setBright(false)
			BagData.setCDlbl( nil, lbl_timeCD )
			ifDown = false
			btn_maiChu:setTouchEnabled(false)
			btn_maiChu:setBright(false)
		elseif ifBang == 3 then
			lbl_btnbangDing:setText("解 绑")
			lbl_timeCD:setVisible(false)
			ifDown = false
			btn_maiChu:setTouchEnabled(false)
			btn_maiChu:setBright(false)
		end
	end

	if ifDown == false then --不可以降级
		lbl_fanHuan:setVisible(false)
		btn_jiangJi:setTouchEnabled(false)
		btn_jiangJi:setBright(false)
	else
		lbl_fanHuan:setText( data["GoodsDownZeney"] )
	end

end


function exitUI()
    if curLayer ~= nil and widget ~= nil then
        curLayer:removeWidget(widget)
        --curLayer:clear()
        widget = nil
        curLayer = nil
        
        LM.STATE_4 = 0
    end
    BagData.setCDlbl( nil, nil)
end

function enterUI( dataIdx )
    LM.STATE_4 = UI_BeiBao_Dress

    curLayer = LM.getLayer4()
    widget = GUIReader:shareReader():widgetFromJsonFile("BeiBao_Pop_WuPinXiangQing.json")    

    curLayer:addWidget(widget)
    widget:setTouchEnabled(true)

    initpubMod( dataIdx )
end


--[=[
--local img_PinZhiKuang = nil
---local remFatherUi = nil

local function initpubMod(_idx, jeneralId, _type)
	local img_Head = tolua.cast( curLayer:getWidgetByName("ImageView_Head"), "ImageView" )
	
	local lbl_name = tolua.cast( curLayer:getWidgetByName("Label_name"), "Label" )
	local lbl_chuandailv = tolua.cast( curLayer:getWidgetByName("Label_chuandaiLv"), "Label" )
	local lbl_qianghualv = tolua.cast( curLayer:getWidgetByName("Label_qianghualv"), "Label" )
	local lbl_shuxing = tolua.cast( curLayer:getWidgetByName("Label_shuxing"), "Label" )
	local lbl_jieshao = tolua.cast( curLayer:getWidgetByName("Label_jieshao"), "Label" )
	local lbl_zhuangbei = tolua.cast(curLayer:getWidgetByName("LabelBMFont_zhuangbei"),"LabelBMFont")

	local btn_zhuangbei = tolua.cast( curLayer:getWidgetByName("Button_zhuangbei"), "Button" )
	if _type ~= 0 then
		--btn_zhuangbei:loadTextures( "button+55_bag_1.png", "button+55_bag_2.png", "" )
		lbl_zhuangbei:setText("卸  下")
	end
	local btn_guanbi = tolua.cast( curLayer:getWidgetByName("Button_guanbi"), "Button" )
	local img_PinZhiKuang = tolua.cast( curLayer:getWidgetByName("ImageView_PinZhiKuang"), "ImageView" )
	
	print("_idx == " .. _idx)
	local data = nil
	local goodsDes = nil
	local jeneralData = nil
	if _type == 0 then
		data = BagData.getGoods(2, _idx)
	elseif _type == 1 then --武器
		jeneralData = GeneralData.getGeneralDataFromId( jeneralId )
		data = BagData.getGoodsFromIdx( 1, jeneralData["GoodsWuQiOnlyIdx"]  )
	elseif _type == 2 then --防具
		jeneralData = GeneralData.getGeneralDataFromId( jeneralId )
		data = BagData.getGoodsFromIdx( 1, jeneralData["GoodsFangJuOnlyIdx"]  )
	elseif _type == 3 then --饰品
		jeneralData = GeneralData.getGeneralDataFromId( jeneralId )
		data = BagData.getGoodsFromIdx( 1, jeneralData["GoodsShiPinOnlyIdx"]  )
	elseif _type == 4 then --书
		jeneralData = GeneralData.getGeneralDataFromId( jeneralId )
		data = BagData.getGoodsFromIdx( 1, jeneralData["GoodsShuOnlyIdx"]  )
	end
	print("data id ==== " .. data["GoodId"] )
	print("data index ==== " .. data["GoodIndex"] )
	goodsDes = Des.getGoodsDesFromId( data["GoodId"] )

	local quility = goodsDes["goodsQuality"]
    img_PinZhiKuang:loadTexture( "rim+" .. quility .. "_juntuan.png" )

	img_Head:loadTexture( GoodsHeadPath .. goodsDes["goodsPic"] .. ".png" )
	lbl_name:setText( goodsDes["goodsName"] )
	local quility = goodsDes["goodsQuality"]
	lbl_name:setColor(ccc3(GoodsColorTab[quility][1], GoodsColorTab[quility][2], GoodsColorTab[quility][3]))
	
	lbl_chuandailv:setText( goodsDes["goodsLevel"] .. "级可穿戴" )

	local JieNum, xingNum = math_modf( data["GoodLv"]/10 )
    xingNum = xingNum*10
    local str = nil
    --if JieNum > 0 then
        str = JieNum .. "阶" .. xingNum .. "星"
    --else
     --   str = xingNum .. "星"
    --end
	lbl_qianghualv:setText( str )
	local _typeTT, value = data["GoodsProType"], data["GoodsProCount"]
	--1攻击 2防御 3带兵数 4女神防御
	if _typeTT == 1 then
		str = "攻击+" .. value
	elseif _typeTT == 2 then
		str = "防御+" .. value
	elseif _typeTT == 3 then
		str = "带兵数+" .. value
	elseif _typeTT == 4 then
		str = "女神防御+" .. value
	end
	lbl_shuxing:setText( str )

	lbl_jieshao:setText( goodsDes["goodsDes"] )

	local function btn_CB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			 
			local _btn = tolua.cast(sender, "Button")
			if _btn == btn_zhuangbei then
				--穿上一件装备
				print("_type == " .. _type)
				if _type == 0 then
					protoSend0x0318( jeneralId, data["GoodIndex"], 1  )
				else
					protoSend0x0318( jeneralId, data["GoodIndex"], 2  ) --卸下
				end
				exitUI()
				guideFactory.CheckGuideProcess(nil)
			elseif _btn == btn_guanbi then
				exitUI()
			end
		end
	end
	btn_zhuangbei:addTouchEventListener( btn_CB )
	btn_guanbi:addTouchEventListener( btn_CB )
end

function exitUI()
    if curLayer ~= nil and widget ~= nil then
        curLayer:removeWidget(widget)
        --curLayer:clear()
        widget = nil
        curLayer = nil
        
        LM.STATE_4 = 0
    end
end

function enterUI(Goodsindex, jeneralId, _type)
    LM.STATE_4 = UI_BeiBao_Dress

    curLayer = LM.getLayer4()
    widget = GUIReader:shareReader():widgetFromJsonFile("BeiBao_Pop_WuPinXiangQing.json")    

    curLayer:addWidget(widget)
    widget:setTouchEnabled(true)

    initpubMod( Goodsindex, jeneralId, _type )
end
--]=]
--[[
function exitUI()
	PT.UI_State = remFatherUi 
	curScene:removeChild(curLayer, true)
end
function enterUI(scene, Goodsindex, jeneralId, _type )

	remFatherUi = PT.UI_State 
	PT.UI_State  = UI_BeiBao_Dress
	curScene = scene
    local widget = GUIReader:shareReader():widgetFromJsonFile("BeiBao_Pop_WuPinXiangQing.json")    
	
	widget:setTouchEnabled(true)
	
	curLayer = TouchGroup:create()
	curLayer:setZOrder(13)
    curLayer:addWidget(widget)
    scene:addChild(curLayer)

    initpubMod( Goodsindex, jeneralId, _type )
    
    guideFactory.CheckGuideProcess(nil)
end
--]]