module ("Pop3_JiaoHuan",package.seeall)
--将领更改训练模式的3级UI
--local curScene = nil
local curLayer = nil
local widget = nil

local remGeneralIdx = 0

local generalId_old = 0
local generalId_new = 0

    local img_buttomHead = nil
    local lbl_buttomName = nil
    local lbl_buttomLv = nil
    local img_buttomGood1 = nil
    local img_buttomGood2 = nil
    local img_buttomGood3 = nil
    local img_buttomGood4 = nil
    
    local img_buttomPinZ1 = nil
    local img_buttomPinZ2 = nil
    local img_buttomPinZ3 = nil
    local img_buttomPinZ4 = nil
local remFatherUI = 0


--刷新将领装备
local function flushPart( _dataIndex )
    local data = GeneralData.getYesGeneralDataFromIndex(_dataIndex)
    generalId_new = data["GenneralId"]

    local generalDes = Des.getGeneralDesFromId( generalId_new )

    img_buttomHead:loadTexture( RoleHeadPath .. generalDes["generalHeadIcon"] .. ".png" )
    lbl_buttomName:setText( generalDes["generalName"] )
    lbl_buttomLv:setText("lv: " .. data["Lv"])

    local function setGoodsPic( _onlyindex, _img , img_pinzhi)
        if _onlyindex ~= 0 then
            local goodsId = BagData.getGoodsIdFromIndex(1, _onlyindex ) 
            local goodsDes = Des.getGoodsDesFromId( goodsId )
            local quality = goodsDes["goodsQuality"]
            _img:loadTexture( GoodsHeadPath .. goodsDes["goodsPic"] .. ".png" )
            _img:setVisible(true)

            img_pinzhi:loadTexture("rim+"..quality.."_juntuan.png")
            img_pinzhi:setVisible(true)
        else
            --local path = {"floor+24_public.png", "floor+21_public.png","floor+22_public.png","floor+23_public.png"}
            --_img:loadTexture( path[_index] )

            _img:loadTexture("")
            _img:setVisible(false)

            img_pinzhi:loadTexture("")
            img_pinzhi:setVisible(false)
        end
    end

    setGoodsPic( data["GoodsWuQiOnlyIdx"], img_buttomGood1,  img_buttomPinZ1)
    setGoodsPic( data["GoodsFangJuOnlyIdx"], img_buttomGood2,  img_buttomPinZ2)
    setGoodsPic( data["GoodsShiPinOnlyIdx"], img_buttomGood3, img_buttomPinZ3)
    setGoodsPic( data["GoodsShuOnlyIdx"], img_buttomGood4, img_buttomPinZ4)
end

local function _initJiangLingScrollView( _idex )
    local _scrollview = tolua.cast( curLayer:getWidgetByName("ScrollView_roleList"), "ScrollView" )
    _scrollview:removeAllChildren()
    _scrollview:setClippingEnabled(true) --裁切窗口
    _scrollview:setBounceEnabled(true) --边缘回弹
    _scrollview:setBackGroundColorType(0)
    local cell_disY = 5
        --可视区域
    local view_W = _scrollview:getSize().width 
    local view_H = _scrollview:getSize().height 

    local num = 0
if ifserver then
    num = GeneralData.getYesGeneralDataNum()
else
    num = 10
end
    _scrollview:setInnerContainerSize( CCSize(view_W, 75*num) )

    --滑动区域
    local scroll_W = _scrollview:getInnerContainerSize().width
    local scroll_H = _scrollview:getInnerContainerSize().height

    local cell_W, cell_H = 153, 70
    local cell_X, cell_Y = view_W/2, scroll_H-cell_H/2

    local function CellTouchCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            
            local _img = tolua.cast(sender, "ImageView")
            local tag = _img:getTag()
            if remGeneralIdx == tag then
                return
            end

            local imgbefor =  tolua.cast(_scrollview:getChildByTag(remGeneralIdx), "ImageView")
            imgbefor:loadTexture( "button2_tong_2.png" )
            remGeneralIdx = tag
            _img:loadTexture( "button2_tong_1.png" )
            
           flushPart( remGeneralIdx )
        end
    end

    for i=1, num do
        if i ~= _idex then
            local data      = nil
            local desData   = nil
            local ifGod = nil
    if ifserver then
            data = GeneralData.getYesGeneralDataFromIndex(i)
            local id = data["GenneralId"]
            desData = Des.getGeneralDesFromId( id )
            if data["GoddessId"] ~= 0 then
                ifGod = true
            else
                ifGod = false
            end
    end

            local imageView = ImageView:create()
            if i == remGeneralIdx then
                imageView:loadTexture("button2_tong_1.png")--当前默认
                flushPart(remGeneralIdx)
            else
                imageView:loadTexture("button2_tong_2.png")
            end
            imageView:setTag(i)
            imageView:setPosition( CCPoint( cell_X, cell_Y ) )
            imageView:addTouchEventListener( CellTouchCB )
            imageView:setTouchEnabled(true)
                if ifGod then
                    local _imgGod = ImageView:create()
                    _imgGod:loadTexture( "floor+8_bag.png" )
                    _imgGod:setPosition(ccp(50, 0))
                    imageView:addChild( _imgGod )
                end 
                local _lbl = Label:create()
                _lbl:setFontSize( 26 )
                _lbl:setColor( ccc3(239, 224, 199) )
                if ifserver then
                    _lbl:setText( desData["generalName"] )
                else
                    _lbl:setText(i)
                end
                imageView:addChild(_lbl)
           _scrollview:addChild( imageView )

           cell_Y = cell_Y - cell_disY - cell_H
        end
    end
    
end


local function initPubPanel(index)


    local btn_close = tolua.cast( curLayer:getWidgetByName("Button_close"), "Button" )
    local btn_jiaoHuan = tolua.cast( curLayer:getWidgetByName("Button_JiaoHuan"), "Button" )

    local function pubBtnCB(sender, eventType)
       if eventType == PT.ccs.TouchEventType.ended then 
             
            local _btn = tolua.cast(sender, "Button")
            if _btn == btn_close then
                exitUI()
                guideFactory.CheckGuideProcess(nil)
            elseif _btn == btn_jiaoHuan then
                --todo:交换装备
                protoSend0x0322( generalId_old, generalId_new )
                exitUI()
            end
        end

    end
    btn_close:addTouchEventListener(pubBtnCB)
    btn_jiaoHuan:addTouchEventListener(pubBtnCB)
--上部
    
    local img_topHead  = tolua.cast( curLayer:getWidgetByName("ImageView_TopPic"), "ImageView" )
    local lbl_topName  = tolua.cast( curLayer:getWidgetByName("Label_TopName"), "Label" )
    local lbl_topLv    = tolua.cast( curLayer:getWidgetByName("Label_TopLv"), "Label" )
    local img_TopGood1 = tolua.cast( curLayer:getWidgetByName("ImageView_TopGoods1_Pic"), "ImageView" )
    local img_TopGood2 = tolua.cast( curLayer:getWidgetByName("ImageView_TopGoods2_Pic"), "ImageView" )
    local img_TopGood3 = tolua.cast( curLayer:getWidgetByName("ImageView_TopGoods3_Pic"), "ImageView" )
    local img_TopGood4 = tolua.cast( curLayer:getWidgetByName("ImageView_TopGoods4_Pic"), "ImageView" )

    local img_TopPinZ1 = tolua.cast( curLayer:getWidgetByName("ImageView_TopGoods1_PinZhiKuang"), "ImageView" )
    local img_TopPinZ2 = tolua.cast( curLayer:getWidgetByName("ImageView_TopGoods2_PinZhiKuang"), "ImageView" )
    local img_TopPinZ3 = tolua.cast( curLayer:getWidgetByName("ImageView_TopGoods3_PinZhiKuang"), "ImageView" )
    local img_TopPinZ4 = tolua.cast( curLayer:getWidgetByName("ImageView_TopGoods4_PinZhiKuang"), "ImageView" )

    local data = GeneralData.getYesGeneralDataFromIndex( index )
    generalId_old = data["GenneralId"]
    local generalDes = Des.getGeneralDesFromId( generalId_old )

    img_topHead:loadTexture( RoleHeadPath .. generalDes["generalHeadIcon"] .. ".png" )
    lbl_topName:setText( generalDes["generalName"] )
    lbl_topLv:setText("lv: " .. data["Lv"])

    local function setGoodsPic( _onlyindex, _img, img_pinzhi )
        if _onlyindex ~= 0 then
            local goodsId = BagData.getGoodsIdFromIndex(1, _onlyindex ) 
            local goodsDes = Des.getGoodsDesFromId( goodsId )
            local quality = goodsDes["goodsQuality"]
            _img:loadTexture( GoodsHeadPath .. goodsDes["goodsPic"] .. ".png" )

            img_pinzhi:loadTexture("rim+"..quality.."_juntuan.png")
            img_pinzhi:setVisible(true)
        else
            _img:loadTexture("")
            _img:setVisible(false)

            img_pinzhi:loadTexture("")
            img_pinzhi:setVisible(false)
        
        end
    end

    setGoodsPic( data["GoodsWuQiOnlyIdx"], img_TopGood1, img_TopPinZ1)
    setGoodsPic( data["GoodsFangJuOnlyIdx"], img_TopGood2, img_TopPinZ2)
    setGoodsPic( data["GoodsShiPinOnlyIdx"], img_TopGood3, img_TopPinZ3)
    setGoodsPic( data["GoodsShuOnlyIdx"], img_TopGood4, img_TopPinZ4)

--下部
    img_buttomHead  = tolua.cast( curLayer:getWidgetByName("ImageView_ButPic"), "ImageView" )
    lbl_buttomName  = tolua.cast( curLayer:getWidgetByName("Label_ButName"), "Label" )
    lbl_buttomLv    = tolua.cast( curLayer:getWidgetByName("Label_ButLv"), "Label" )
    
    img_buttomGood1 = tolua.cast( curLayer:getWidgetByName("ImageView_ButGoods1_Pic"), "ImageView" )
    img_buttomGood2 = tolua.cast( curLayer:getWidgetByName("ImageView_ButGoods2_Pic"), "ImageView" )
    img_buttomGood3 = tolua.cast( curLayer:getWidgetByName("ImageView_ButGoods3_Pic"), "ImageView" )
    img_buttomGood4 = tolua.cast( curLayer:getWidgetByName("ImageView_ButGoods4_Pic"), "ImageView" )

    img_buttomPinZ1 = tolua.cast( curLayer:getWidgetByName("ImageView_ButGoods1_PinZhiKuang"), "ImageView" )
    img_buttomPinZ2 = tolua.cast( curLayer:getWidgetByName("ImageView_ButGoods2_PinZhiKuang"), "ImageView" )
    img_buttomPinZ3 = tolua.cast( curLayer:getWidgetByName("ImageView_ButGoods3_PinZhiKuang"), "ImageView" )
    img_buttomPinZ4 = tolua.cast( curLayer:getWidgetByName("ImageView_ButGoods4_PinZhiKuang"), "ImageView" )

if index == 1 then
    remGeneralIdx = 2
else
    remGeneralIdx = 1
end
    _initJiangLingScrollView( index )
end

function exitUI()
    if curLayer ~= nil and widget ~= nil then
        curLayer:removeWidget(widget)
        --curLayer:clear()
        widget = nil
        curLayer = nil
        
        LM.STATE_4 = 0
    end
end

function enterUI(curIdx)
    LM.STATE_4 = UI_BeiBao_ChangeAll

    curLayer = LM.getLayer4()
    widget = GUIReader:shareReader():widgetFromJsonFile("BeiBao_Pop_JiaoHuan.json")    

    curLayer:addWidget(widget)
    widget:setTouchEnabled(true)

    initPubPanel(curIdx)
end

--[=[
function exitUI()
    PT.UI_State = remFatherUI
    curScene:removeChild(curLayer, true)
end
function enterUI(scene, curIdx )
	curScene = scene

    remFatherUI = PT.UI_State
    PT.UI_State = UI_BeiBao_ChangeAll

    local widget = GUIReader:shareReader():widgetFromJsonFile("BeiBao_Pop_JiaoHuan.json")    
	
	widget:setTouchEnabled(true)
	
	curLayer = TouchGroup:create()
	curLayer:setZOrder(13)
    curLayer:addWidget(widget)
    scene:addChild(curLayer)

    
    initPubPanel(curIdx)
    
    guideFactory.CheckGuideProcess(curScene)
------------------------------------------------
--[[
    curLayer:setKeypadEnabled(true)
    local function KeypadHandler(strEvent)
        if "backClicked" == strEvent then
            exitUI()
            Pop3_XFTiShi.enterUI( 10000,  "是否确认退出游戏？" )
        elseif "menuClicked" == strEvent then
            
    	end
    end 
    curLayer:registerScriptKeypadHandler(KeypadHandler)
--]] 
end
--]=]