module ("Pop3_JiaoHuanOne",package.seeall)
--将领更改训练模式的3级UI
--local curScene = nil
local curLayer = nil
local widget = nil


local img_botHead       = nil
local img_botPinZhi     = nil
local lbl_botName       = nil
local lbl_botDressLim   = nil
local lbl_botShuXing    = nil
local lbl_botPinJie     = nil
local font_botPower     = nil
local img_botpowerDi2   = nil
    local img_topHead   = nil
    local img_topPinZhi = nil
    local lbl_topName   = nil
    local lbl_topDressLim  = nil
    local lbl_topShuXing   = nil
    local lbl_topPinJie    = nil
    local font_topPower     = nil
    local img_toppowerDi2   = nil


local remGoods = nil --记录物品焦点

local function flushBotGoodsPanel()

    img_botpowerDi2:setVisible(false)
    if remGoods == 0 then
        img_botHead:loadTexture("")
        img_botHead:setVisible(false)
        img_botPinZhi:loadTexture("")
        img_botPinZhi:setVisible(false)

        lbl_botName:setText("")
        lbl_botDressLim:setText("")
        lbl_botShuXing:setText("")
        lbl_botPinJie:setText("")
    else
        local data = BagData.getGoods(2, remGoods)
        local goodsDes = Des.getGoodsDesFromId( data["GoodId"] )
        local quality = goodsDes["goodsQuality"]
        local Type  = data["GoodsProType"]
        local value = data["GoodsProCount"]
        
        local imgPic = GoodsHeadPath .. goodsDes["goodsPic"] .. ".png"  
        img_botHead:loadTexture(imgPic)
        img_botHead:setVisible(true)

        img_botPinZhi:loadTexture("rim+"..quality.."_juntuan.png")
        img_botPinZhi:setVisible(true)

                --1攻击 2防御 3带兵数 4女神防御
        local str = nil
        if Type == 1 then
            str = "攻击+" .. value
            img_botpowerDi2:setVisible(true)
            font_botPower:setText(data["GoodsPower"])
        elseif Type == 2 then
            str = "防御+" .. value
            img_botpowerDi2:setVisible(true)
            font_botPower:setText(data["GoodsPower"])
        elseif Type == 3 then
            str = "带兵数+" .. value
            img_botpowerDi2:setVisible(true)
            font_botPower:setText(data["GoodsPower"])
        elseif Type == 4 then
            str = "女神防御+" .. value
            img_botpowerDi2:setVisible(true)
            font_botPower:setText(data["GoodsPower"])
        end
        lbl_botShuXing:setText(str)

        lbl_botName:setText(goodsDes["goodsName"])
        lbl_botName:setColor( ccc3( GoodsColorTab[quality][1], GoodsColorTab[quality][2], GoodsColorTab[quality][3]) )
    
        lbl_botDressLim:setText( goodsDes["goodsLevel"] .. "级可装备" )

        local JieNum, xingNum = math_modf( data["GoodLv"]/10 )
        xingNum = xingNum*10
        str = JieNum .. "阶" .. xingNum .. "星"-- .. "(每星加主属" .. _data["GoodsProSkip"] .. ")"
        lbl_botPinJie:setText(str)
    end


end
    
local function initGoodsScl(_type)
    local _scrollview = tolua.cast( curLayer:getWidgetByName("ScrollView_GoodsList"), "ScrollView" )
    _scrollview:setBackGroundColorType(0)
    _scrollview:removeAllChildren()
    _scrollview:setClippingEnabled(true)
    _scrollview:setBounceEnabled(false) --边缘回弹   不能回弹
    
    local cell_disY = 10 --纵向间隔
    local cell_disX = 6 --横向间隔
        --可视区域
    local view_W = _scrollview:getSize().width 
    local view_H = _scrollview:getSize().height 

    local Datanum = 0
    local remTab = nil

    remTab = BagData.getGoodTabFromType(2, _type)
    Datanum = #remTab
    print("Datanum === " .. Datanum)
    if Datanum == 0 then
        remGoods = 0
    else
        remGoods = remTab[1]
    end
    local lieNum = 2
    local hangNum = math.ceil(Datanum/lieNum)

    local cell_W, cell_H = 160, 60
    _scrollview:setInnerContainerSize( CCSize(view_W, cell_H*hangNum+cell_disY*(hangNum-1)) )
    --滑动区域
    local scroll_W = _scrollview:getInnerContainerSize().width 
    local scroll_H = _scrollview:getInnerContainerSize().height
    local cell_X, cell_Y = cell_W/2, scroll_H-cell_H/2
    local function CellTouchCB(sender, eventType)
        
        if eventType == PT.ccs.TouchEventType.ended then
            local _img = tolua.cast(sender, "ImageView")
            local tag = _img:getTag()

            guideFactory.CheckGuideProcess( LM.STATE_4 )

            if remGoods == tag then
                return
            end

            local imgbefor =  tolua.cast(_scrollview:getChildByTag(remGoods), "ImageView")
            imgbefor:loadTexture( "button5_tong_2.png" )
            remGoods = tag
            _img:loadTexture( "button5_tong_1.png" )
            flushBotGoodsPanel(_type)


        end
    end  
    for i=1, hangNum do
        for j=1, lieNum do
            local index = (i-1)*lieNum+j
            if index <= #remTab then
                local data = BagData.getGoods(2, remTab[index])
                local goodsDes = Des.getGoodsDesFromId( data["GoodId"] )
                local quality = goodsDes["goodsQuality"]

                local imageView = ImageView:create()
                if remTab[index] == remGoods then
                    imageView:loadTexture("button5_tong_1.png")--当前默认
                    --flushPart(remGeneralIdx)
                else
                    imageView:loadTexture("button5_tong_2.png")
                end
                imageView:setTag( remTab[index] )
                imageView:setPosition( CCPoint( cell_X, cell_Y ) )
                imageView:addTouchEventListener( CellTouchCB )
                imageView:setTouchEnabled(true)
                    local _lbl = Label:create()
                    _lbl:setText( goodsDes["goodsName"] )
                    _lbl:setFontSize( 22 )
                    _lbl:setColor( ccc3( GoodsColorTab[quality][1], GoodsColorTab[quality][2], GoodsColorTab[quality][3]) )
                imageView:addChild(_lbl)
                _scrollview:addChild( imageView )
                cell_X = cell_X + cell_W + cell_disX
            end
        end
        cell_X = cell_W/2
        cell_Y = cell_Y -cell_H-cell_disY
    end
    flushBotGoodsPanel(_type)
end

local Rem_curjeneral = 0
local Rem_jeneralId = 0
local Rem_type = 0
local onlyidx = 0 --身上的装备

function flushPartPubPanel()

    local data = GeneralData.getYesGeneralDataFromIndex(Rem_curjeneral)
    --Rem_jeneralId = data["GenneralId"] 
    Rem_jeneralId = data["Index"] --改成唯一id

    
    onlyidx = nil

    if Rem_type == 1 then 
        onlyidx = data["GoodsWuQiOnlyIdx"]
    elseif Rem_type == 2 then
        onlyidx = data["GoodsFangJuOnlyIdx"]
    elseif Rem_type == 3 then
        onlyidx = data["GoodsShiPinOnlyIdx"]
    elseif Rem_type == 4 then
        onlyidx = data["GoodsShuOnlyIdx"]
    end

    img_toppowerDi2:setVisible(false)
   -- if onlyidx == 0 then
    if onlyidx == "" then

        img_topHead:loadTexture("")
        img_topHead:setVisible(false)
        img_topPinZhi:loadTexture("")
        img_topPinZhi:setVisible(false)

        lbl_topName:setText("")
        lbl_topDressLim:setText("")
        lbl_topShuXing:setText("")
        lbl_topPinJie:setText("")

        
    else
        
        print("Rem_type ==== " .. Rem_type)
        print("onlyidx ======== " .. onlyidx)
        local goodsId = BagData.getGoodsIdFromIndex(1, onlyidx)
        print("goodsId ==== " .. goodsId)
        local goodsDes = Des.getGoodsDesFromId( goodsId )
        local Type, value = BagData.getTypeAndValue(1, onlyidx)

        local quality = goodsDes["goodsQuality"]
        local imgPic = GoodsHeadPath .. goodsDes["goodsPic"] .. ".png"  
        
        img_topHead:loadTexture(imgPic)
        img_topHead:setVisible(true)

        img_topPinZhi:loadTexture("rim+"..quality.."_juntuan.png")
        img_topPinZhi:setVisible(true)
        
        local data = BagData.getGoodsFromIdx(1, onlyidx)
        --1攻击 2防御 3带兵数 4女神防御
        local str = nil
        if Type == 1 then
            str = "攻击+" .. value
            img_toppowerDi2:setVisible(true)
            font_topPower:setText(data["GoodsPower"])
        elseif Type == 2 then
            str = "防御+" .. value
            img_toppowerDi2:setVisible(true)
            font_topPower:setText(data["GoodsPower"])
        elseif Type == 3 then
            str = "带兵数+" .. value
            img_toppowerDi2:setVisible(true)
            font_topPower:setText(data["GoodsPower"])
        elseif Type == 4 then
            str = "女神防御+" .. value
            img_toppowerDi2:setVisible(true)
            font_topPower:setText(data["GoodsPower"])
        end
        lbl_topShuXing:setText(str)

        lbl_topName:setText(goodsDes["goodsName"])
        lbl_topName:setColor( ccc3( GoodsColorTab[quality][1], GoodsColorTab[quality][2], GoodsColorTab[quality][3]) )
    
        lbl_topDressLim:setText( goodsDes["goodsLevel"] .. "级可装备" )

        
        local JieNum, xingNum = math_modf( data["GoodLv"]/10 )
        xingNum = xingNum*10
        str = JieNum .. "阶" .. xingNum .. "星"-- .. "(每星加主属" .. _data["GoodsProSkip"] .. ")"
        lbl_topPinJie:setText(str)

    end


    img_botHead       = tolua.cast( curLayer:getWidgetByName("ImageView_NewGoods_Pic"), "ImageView" )
    img_botPinZhi     = tolua.cast( curLayer:getWidgetByName("ImageView_NewGoods_PinZhiKuang"), "ImageView" )
    lbl_botName       = tolua.cast( curLayer:getWidgetByName("Label_NewGoodsName"), "Label" )
    lbl_botDressLim   = tolua.cast( curLayer:getWidgetByName("Label_NewGoodsLv"), "Label" )
    lbl_botShuXing    = tolua.cast( curLayer:getWidgetByName("Label_NewGoodsShuXing"), "Label" )
    lbl_botPinJie     = tolua.cast( curLayer:getWidgetByName("Label_NewGoodsQiangHua"), "Label" )

    font_botPower     = tolua.cast( curLayer:getWidgetByName("LabelBMFont_newPower"), "LabelBMFont" )
    img_botpowerDi2   = tolua.cast( curLayer:getWidgetByName("ImageView_newPowerDi2"), "ImageView" )

    initGoodsScl(Rem_type)

end

local function initPubPanel(curjeneral, _type)
    
    local btn_close = tolua.cast( curLayer:getWidgetByName("Button_close"), "Button" )
    local btn_zhuangBei = tolua.cast( curLayer:getWidgetByName("Button_ZhuangBei"), "Button" )
    local btn_xieXia = tolua.cast( curLayer:getWidgetByName("Button_XieXia"), "Button" )
    local function pubBtnCB(sender, eventType)
       if eventType == PT.ccs.TouchEventType.ended then 
             
            local _btn = tolua.cast(sender, "Button")
            if _btn == btn_close then
                exitUI()
                guideFactory.CheckGuideProcess( LM.STATE_3 )
            elseif _btn == btn_zhuangBei then
                --todo:装备
                if remGoods ~= 0 then
                    local goodsdata = BagData.getGoods(2, remGoods)
                    protoSend0x0318( Rem_jeneralId, goodsdata["GoodIndex"], 1 )
                end
                guideFactory.CheckGuideProcess( LM.STATE_4 )
                --exitUI()
            elseif _btn == btn_xieXia then
                if onlyidx ~= 0 then
                    protoSend0x0318( Rem_jeneralId, onlyidx, 2 )
                end
            end
        end
    end
    btn_close:addTouchEventListener(pubBtnCB)
    btn_zhuangBei:addTouchEventListener(pubBtnCB)
    btn_xieXia:addTouchEventListener(pubBtnCB)

    img_topHead   = tolua.cast( curLayer:getWidgetByName("ImageView_TopGoods_Pic"), "ImageView" )
    img_topPinZhi = tolua.cast( curLayer:getWidgetByName("ImageView_TopGoods_PinZhiKuang"), "ImageView" )
    lbl_topName   = tolua.cast( curLayer:getWidgetByName("Label_TopGoodsName"), "Label" )
    lbl_topDressLim  = tolua.cast( curLayer:getWidgetByName("Label_TopGoodsLv"), "Label" )
    lbl_topShuXing   = tolua.cast( curLayer:getWidgetByName("Label_TopGoodsShuXing"), "Label" )
    lbl_topPinJie    = tolua.cast( curLayer:getWidgetByName("Label_TopGoodsQiangHua"), "Label" )
    
    font_topPower     = tolua.cast( curLayer:getWidgetByName("LabelBMFont_topPower"), "LabelBMFont" )
    img_toppowerDi2   = tolua.cast( curLayer:getWidgetByName("ImageView_TopPowerDi2"), "ImageView" )

    Rem_curjeneral = curjeneral
    Rem_type = _type

    flushPartPubPanel()

end

function exitUI()
    if curLayer ~= nil and widget ~= nil then
        curLayer:removeWidget(widget)
        --curLayer:clear()
        widget = nil
        curLayer = nil
        
        LM.STATE_4 = 0
    end
   -- MapPubUI.setPanelBtnState(false)
end

--当前将领 ，当前物品类型goodstype
function enterUI(curjeneralIdx, goodstype)
    LM.STATE_4 = UI_BeiBao_ChangeOne

    curLayer = LM.getLayer4()
    widget = GUIReader:shareReader():widgetFromJsonFile("BeiBao_Pop_JiaoHuanOne.json")    

    curLayer:addWidget(widget)
    widget:setTouchEnabled(true)

    initPubPanel(curjeneralIdx, goodstype)

    --MapPubUI.setPanelBtnState(false)
    guideFactory.CheckGuideProcess( LM.STATE_4 )
end