module ("BeiBao_WeiPai",package.seeall)

local Layer = nil
local _widget = nil
--local curScene = nil
local panel_equip = nil
local btn_confirm = nil
local btn_sell = nil
local btn_delegate = nil
local img_npc = {img_npc1,img_npc2,img_npc3,img_npc4}
local img_hlnpc = {img_hlnpc1,img_hlnpc2,img_hlnpc3,img_hlnpc4}
local img_npcIsCanTouch = {}
local lbl_text = {
    {"水镜先生","谋事在人,成事在天,不可强也"},
    {"左慈","土鼠随金虎，奸雄一旦休"},
    {"于吉","死亡只是一个开始"},
    {"南华老仙","代天宣化，普救世人"}
}

local isInWeiPai = false
local _richText1=nil
local _richText2=nil

local tips_tab = {
    {"水镜先生",{"大概率获得","蓝色","品质兵书"},{"小概率获得","绿色","品质兵书"}},
    {"左慈",{"大概率获得","蓝色","或","绿色","品质兵书"},{"小概率获得","黄色","品质兵书"}},
    {"于吉",{"大概率获得","蓝色","/","绿色","或","黄色","品质兵书"},{"小概率获得","红色","品质兵书碎片"}},
    {"南华老仙(60级开启)",{"大概率获得","蓝色","/","绿色","或","黄色","品质兵书"},{"小概率获得","红色","或","紫色","品质兵书"}}
}


local lbl_delegate_zeny = nil
local index = 1
--local lbl_zeny = nil
local GoodsColorTab = {
        {"255", "255", "255"},
        {"33", "143", "255"},
        {"0", "255", "90"},
        {"234", "255", "0"},
        {"255", "0", "0"},
        {"167", "19", "252"},
    }
local function _initReward(  )
    -- body
    local equip_id,main_type,main_value,main_skip = DelegateData.readEquipInfo()
    print("equip_id == " .. equip_id)
    if equip_id == 0 then
        panel_equip:setVisible(false)
        btn_confirm:setTouchEnabled(false)
        btn_sell:setTouchEnabled(false)
        btn_confirm:setVisible(false)
        btn_sell:setVisible(false)

        isInWeiPai=true
    else
        panel_equip:setVisible(true)
        btn_confirm:setTouchEnabled(true)
        btn_sell:setTouchEnabled(true)
        btn_confirm:setVisible(true)
        btn_sell:setVisible(true)
        local lbl_name = tolua.cast( Layer:getWidgetByName("Label_getName"), "Label" )
        local lbl_need_lv = tolua.cast( Layer:getWidgetByName("Label_getPeiDai"), "Label" )
        local lbl_skip = tolua.cast( Layer:getWidgetByName("Label_getQiangHua"), "Label" )
        local lbl_zhanfa = tolua.cast( Layer:getWidgetByName("Label_getZhanFa"), "Label" )
        local lbl_sell = tolua.cast( Layer:getWidgetByName("Label_chuShouJiaGe"), "Label" )
        local img_pic = tolua.cast( Layer:getWidgetByName("ImageView_getHead"), "ImageView" )
        local img_quality = tolua.cast( Layer:getWidgetByName("ImageView_PinZhiKuang"), "ImageView" )

        local _data = Des.getGoodsDesFromId(equip_id)
        lbl_name:setText(_data["goodsName"])

        local quility = _data["goodsQuality"]
        print("quility == " .. quility)
        lbl_name:setColor( ccc3( GoodsColorTab[quility][1], GoodsColorTab[quility][2], GoodsColorTab[quility][3]) )
    
        lbl_need_lv:setText(_data["goodsLevel"] .. "级可装备")
        lbl_sell:setText( _data["goodsPrice"] )
        lbl_skip:setText("0星（每星加主属" .. main_skip .. "点)")
        img_pic:loadTexture(GoodsHeadPath .. _data["goodsPic"] .. ".png")
        img_quality:setColor( ccc3( GoodsColorTab[quility][1], GoodsColorTab[quility][2], GoodsColorTab[quility][3]) )

        local text = nil
        print("main_type === " .. main_type)
        if main_type == 1 then
            text = "攻击+" 
        elseif main_type == 2 then
            text = "防御+" 
        elseif main_type == 3 then
            text = "带兵数+" 
        elseif main_type == 4 then
            text = "女神防御+" 
        end
        lbl_zhanfa:setText(text .. main_value .. "点")
        if isInWeiPai then
            --委派成功提示
            Pop3_TS_Result.enterUI("委派成功,获得" .. _data["goodsName"])
        end
        isInWeiPai=true
    end
end

function _initPubMod( )
    index = 1
    for i=1,4 do
        local data = DelegateData.readDelegate(i)
        print("i == " .. i .. " state == " .. data["state"] )
        if data["state"] == 1 then
            index = i
        end 
    end

    panel_equip = tolua.cast( Layer:getWidgetByName("ImageView_getContBG"), "ImageView" )
    btn_confirm = tolua.cast( Layer:getWidgetByName("Button_queren"), "Button" )
    btn_sell = tolua.cast( Layer:getWidgetByName("Button_maichu"), "Button" )
    btn_delegate = tolua.cast( Layer:getWidgetByName("Button_weiPai"), "Button" )
    img_npc[1] = tolua.cast( Layer:getWidgetByName("ImageView_npc1"), "ImageView" )
    img_npc[2] = tolua.cast( Layer:getWidgetByName("ImageView_npc2"), "ImageView" )
    img_npc[3] = tolua.cast( Layer:getWidgetByName("ImageView_npc3"), "ImageView" )
    img_npc[4] = tolua.cast( Layer:getWidgetByName("ImageView_npc4"), "ImageView" )
    img_hlnpc[1] = tolua.cast( Layer:getWidgetByName("ImageView_npc1_faguang"), "ImageView" )
    img_hlnpc[2] = tolua.cast( Layer:getWidgetByName("ImageView_npc2_faguang"), "ImageView" )
    img_hlnpc[3] = tolua.cast( Layer:getWidgetByName("ImageView_npc3_faguang"), "ImageView" )
    img_hlnpc[4] = tolua.cast( Layer:getWidgetByName("ImageView_npc4_faguang"), "ImageView" )
    lbl_delegate_zeny = tolua.cast( Layer:getWidgetByName("Label_weiPaiPay"), "Label" )
    --lbl_zeny = tolua.cast( Layer:getWidgetByName("Label_curYinBi"), "Label" )
    --local lbl_name = tolua.cast( Layer:getWidgetByName("Label_name"), "Label" )
    --local lbl_des = tolua.cast( Layer:getWidgetByName("Label_des"), "Label" )
    local lbl_cd = tolua.cast( Layer:getWidgetByName("Label_next"), "Label" )
    local btn_clear = tolua.cast( Layer:getWidgetByName("Button_jiasu"), "Button" )
    DelegateData.setlableButton(lbl_cd,btn_clear)
    local zeny = PlayerData.getZeny()

    
    local Panel_TipsViewBg=tolua.cast( Layer:getWidgetByName("Panel_TipsView"), "Layout")
    Panel_TipsViewBg:setTouchEnabled(false)
    Panel_TipsViewBg:setZOrder(10)
    
    local ImageView_Tips = tolua.cast( Layer:getWidgetByName("ImageView_shopTips"), "ImageView" )

    local Label_shopName =tolua.cast( Layer:getWidgetByName("Label_shopName"), "Label" )
    local Label_des1 =tolua.cast( Layer:getWidgetByName("Label_des1"), "Label" )
    local Label_des2 =tolua.cast( Layer:getWidgetByName("Label_des2"), "Label" )
    Label_des1:setText("")
    Label_des2:setText("")


    local function creatRichText()
        local rich_W = 15*24 --37个字符 每个字符24的宽度
        local rich_H = 20
        _richText1 = RichText:create()
        _richText1:ignoreContentAdaptWithSize(false)
        _richText1:setSize(CCSizeMake(rich_W, rich_H))
        _richText1:setAnchorPoint( ccp(0, 0.5) )
        _richText1:setPosition(ccp(Label_des1:getPosition()))
        ImageView_Tips:addChild(_richText1)

        _richText2 = RichText:create()
        _richText2:ignoreContentAdaptWithSize(false)
        _richText2:setSize(CCSizeMake(rich_W, rich_H))
        _richText2:setAnchorPoint( ccp(0,0.5) )
        _richText2:setPosition(ccp(Label_des2:getPosition()))
        ImageView_Tips:addChild(_richText2)
    end

    local function addElement(_richText, _str,r,g,b )
        local _re1 = RichElementText:create(1, ccc3(r,g,b), 255, _str, "Helvetica", 19);
        _richText:pushBackElement( _re1 )
    end
    --设置点击商人的弹窗里面的富文本内容
    local function setTipsContent( _id )
       if _id==1 then
            ImageView_Tips:setPositionX(99)

            Label_shopName:setText(tips_tab[1][1])
            Label_shopName:setColor(ccc3(0, 255, 0))
            addElement(_richText1,tips_tab[1][2][1],255,255,255)
            addElement(_richText1,tips_tab[1][2][2],0,0,255)
            addElement(_richText1,tips_tab[1][2][3],255,255,255)

            addElement(_richText2,tips_tab[1][3][1],255,255,255)
            addElement(_richText2,tips_tab[1][3][2],0,255,0)
            addElement(_richText2,tips_tab[1][3][3],255,255,255)
       elseif _id==2 then
            ImageView_Tips:setPositionX(230)

            Label_shopName:setText(tips_tab[2][1])
            Label_shopName:setColor(ccc3(255, 192, 0))
            addElement(_richText1,tips_tab[2][2][1],255,255,255)
            addElement(_richText1,tips_tab[2][2][2],0,0,255)
            addElement(_richText1,tips_tab[2][2][3],255,255,255)
            addElement(_richText1,tips_tab[2][2][4],0,255,0)
            addElement(_richText1,tips_tab[2][2][5],255,255,255)

            addElement(_richText2,tips_tab[2][3][1],255,255,255)
            addElement(_richText2,tips_tab[2][3][2],255,192,0)
            addElement(_richText2,tips_tab[2][3][3],255,255,255)
       elseif _id==3 then
            ImageView_Tips:setPositionX(360)

            Label_shopName:setText(tips_tab[3][1])
            Label_shopName:setColor(ccc3(255, 0, 0))
            addElement(_richText1,tips_tab[3][2][1],255,255,255)
            addElement(_richText1,tips_tab[3][2][2],0,0,255)
            addElement(_richText1,tips_tab[3][2][3],255,255,255)
            addElement(_richText1,tips_tab[3][2][4],0,255,0)
            addElement(_richText1,tips_tab[3][2][5],255,255,255)
            addElement(_richText1,tips_tab[3][2][6],255,192,0)
            addElement(_richText1,tips_tab[3][2][7],255,255,255)

            addElement(_richText2,tips_tab[3][3][1],255,255,255)
            addElement(_richText2,tips_tab[3][3][2],255,0,0)
            addElement(_richText2,tips_tab[3][3][3],255,255,255)
       elseif _id==4 then
            ImageView_Tips:setPositionX(480)

            Label_shopName:setText(tips_tab[4][1])
            Label_shopName:setColor(ccc3(112, 48, 160))
            addElement(_richText1,tips_tab[4][2][1],255,255,255)
            addElement(_richText1,tips_tab[4][2][2],0,0,255)
            addElement(_richText1,tips_tab[4][2][3],255,255,255)
            addElement(_richText1,tips_tab[4][2][4],0,255,0)
            addElement(_richText1,tips_tab[4][2][5],255,255,255)
            addElement(_richText1,tips_tab[4][2][6],255,192,0)
            addElement(_richText1,tips_tab[4][2][7],255,255,255)

            addElement(_richText2,tips_tab[4][3][1],255,255,255)
            addElement(_richText2,tips_tab[4][3][2],255,0,0)
            addElement(_richText2,tips_tab[4][3][3],255,255,255)
            addElement(_richText2,tips_tab[4][3][4],112,48,160)
            addElement(_richText2,tips_tab[4][3][5],255,255,255)
       end
    end

    --lbl_zeny:setText( zeny .. "银币")
    local function BtnCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
             
            local _btn = tolua.cast(sender, "Button")
            if _btn == btn_confirm then
                --DelegateData.resetEquipInfo()
                protoSend0x0410(1)
            elseif _btn == btn_sell then
                protoSend0x0410(2)
            elseif _btn == btn_delegate then
                protoSend0x0408(index)
            elseif _btn == btn_clear then
                local cd = CdData.CreatEnumTable()
                local if_save = CdData.getcheckdelegatecd()
                if if_save == 0 then
                    protoSend0x0420(cd.Delegate)
                else
                    protoSend0x0422(cd.Delegate)
                end
            end
        end
    end
    btn_confirm:addTouchEventListener(BtnCB)
    btn_sell:addTouchEventListener(BtnCB)
    btn_delegate:addTouchEventListener(BtnCB)
    btn_clear:addTouchEventListener(BtnCB)

    local function ImgCB(sender, eventType)
       if eventType == PT.ccs.TouchEventType.ended then
            local _img = tolua.cast(sender, "ImageView")
            img_hlnpc[index]:setVisible(false)

            if _richText1~=nil then
               ImageView_Tips:removeChild(_richText1,true)
               ImageView_Tips:removeChild(_richText2,true)
               _richText1=nil
               _richText2=nil
            end
            creatRichText()

            if _img == img_npc[1] then
                if img_npcIsCanTouch[1] then
                    if index ~= 1 then
                        index = 1
                    end
                end
                setTipsContent(1)
            elseif _img == img_npc[2] then
                if img_npcIsCanTouch[2] then
                    if index ~= 2 then
                        index = 2
                    end
                end
                setTipsContent(2)
            elseif _img == img_npc[3] then
                if img_npcIsCanTouch[3] then
                    if index ~= 3 then
                        index = 3
                    end
                end
                setTipsContent(3)
            elseif _img == img_npc[4] then
                if img_npcIsCanTouch[4] then
                    if index ~= 4 then
                        index = 4       
                    end
                end
                setTipsContent(4)
            end
            --lbl_name:setText(lbl_text[index][1])
            --lbl_des:setText(lbl_text[index][2])
            local data = DelegateData.readDelegate(index)
            if data then
                lbl_delegate_zeny:setText(data["need_zeny"] .. "银币")
            end
            img_hlnpc[index]:setVisible(true)

            -- local pointX,pointY=_img:getPosition()
            -- if pointX==ImageView_Tips:getPositionX() then
            --      ImageView_Tips:setVisible(false)
            --      ImageView_Tips:setPositionX(pointX+1)
            -- else
            --     ImageView_Tips:setPosition(ccp(pointX,pointY))
            --     ImageView_Tips:setVisible(true)
            -- end
            Panel_TipsViewBg:setTouchEnabled(true)
            Panel_TipsViewBg:setVisible(true)


        end
    end

    for i=1,4 do
       img_npc[i]:setTouchEnabled(true)
       img_npc[i]:addTouchEventListener(ImgCB)
       img_hlnpc[i]:setVisible(false)
    end
    local data = DelegateData.readDelegate(index)
    if data then
        lbl_delegate_zeny:setText(data["need_zeny"] .. "银币")
    end
    img_hlnpc[index]:setVisible(true)
    --img_hlnpc[2]:setVisible(false)
    --img_hlnpc[3]:setVisible(false)
    --img_hlnpc[4]:setVisible(false)

  
    for i=1,4 do
        local data = DelegateData.readDelegate(i)
        local color = img_npc[i]:getColor()
        --print("color r== " .. color.r .. " color g == " .. color.g .. " color b == " .. color.b)
        if data == nil then
            --img_npc[i]:setTouchEnabled(false)
            img_npcIsCanTouch[i]=false
            img_npc[i]:setColor(ccc3(111,111,111))
        else 
            if data["state"] == 0 then
               -- img_npc[i]:setTouchEnabled(false)
               img_npcIsCanTouch[i]=false
               img_npc[i]:setColor(ccc3(111,111,111)) 
            else
                --img_npc[i]:setTouchEnabled(true)
                img_npcIsCanTouch[i]=true
                img_npc[i]:setColor(ccc3(255,255,255)) 
            end  
        end
    end


    local function hideBg(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            Panel_TipsViewBg:setVisible(false)
            Panel_TipsViewBg:setTouchEnabled(false)
            --state = true
        end
    end
    Panel_TipsViewBg:addTouchEventListener(hideBg)


    _initReward()
end

function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        --Layer:clear()
        _widget = nil
        Layer = nil
        
        LM.STATE_3 = 0
        isInWeiPai=false
    end
    DelegateData.clearLabelButton()
end

function enterUI()
    LM.STATE_3 = UI_BeiBao_WeiPai

    Layer = LM.getLayer3()
    _widget = GUIReader:shareReader():widgetFromJsonFile("BeiBao_WeiPai.json") 

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(false)

    isInWeiPai=false

    _initPubMod()

    guideFactory.CheckGuideProcess( LM.STATE_3 )
end

--[[
function enterUI( _Scene )
    PT.UI_State = UI_BeiBao_WeiPai
	curScene = _Scene
	Layer = TouchGroup:create()
    Layer:setZOrder(10)
	--Layer:setTouchEnabled(false)
    local _widget = GUIReader:shareReader():widgetFromJsonFile("BeiBao_WeiPai.json")    
    _widget:setTouchEnabled(false)
    Layer:addWidget(_widget)
    _Scene:addChild(Layer)
    

    _initPubMod()
    guideFactory.CheckGuideProcess(curScene)
end

function exitUI()
    DelegateData.clearLabelButton()
	curScene:removeChild(Layer, true)
	--Layer:onExit()
end
--]]