module ("GuanKaBase",package.seeall)
local Layer = nil
--local scene = nil
local remIndex = nil
local remFatherUi = nil
 local _widget = nil
local path = {
	{["UI"] = nil, ["pic1"] = "floor+6_guanka_2.png", ["pic2"] = "floor+6_guanka_1.png", ["Imge"] = nil }, --主线
	{["UI"] = nil, ["pic1"] = "floor+7_guanka_2.png", ["pic2"] = "floor+7_guanka_1.png", ["Imge"] = nil }, --日常
}

local img_map = nil

function setMapImg(path)

	img_map:loadTexture(path)
end

local function initPubUI( _index )
	img_map = tolua.cast( Layer:getWidgetByName("ImageView_38"), "ImageView" )
	local btn_close = tolua.cast( Layer:getWidgetByName("Button_TuiChu"), "Button" )
	local function btn_closeCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then

			guideFactory.CheckGuideProcess( LM.STATE_2 )
			RW_guide.exitUI()--退出任务引导
			if LM.STATE_2 == UI_GuanKa_PuTong then
				GK_PuTong.exitUI()
			end
			if LM.STATE_2 == UI_GuanKa_JingYing then
				GK_JingYing.exitUI()
			end
			exitUI()

		end
	end
	btn_close:addTouchEventListener( btn_closeCB )


	path[1]["Imge"] = tolua.cast( Layer:getWidgetByName("ImageView_PuTong"), "ImageView" )
	path[2]["Imge"] = tolua.cast( Layer:getWidgetByName("ImageView_JingYing"), "ImageView" )

	
	path[1]["UI"] = GK_PuTong
	path[2]["UI"] = GK_JingYing

	local function Img_TouchCB(sender, eventType)
		local _img = tolua.cast(sender, "ImageView")
		if eventType == PT.ccs.TouchEventType.ended then
			RW_guide.exitUI()--退出任务引导
			if _img == path[1]["Imge"] then --关卡
				if remIndex == 1 then
					return
				end
				path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic1"] )
				path[remIndex]["UI"].exitUI()
				remIndex = 1
				path[remIndex]["UI"].enterUI()
			elseif _img == path[2]["Imge"] then --精英
				if remIndex == 2 then
					return
				end
				path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic1"] )
				path[remIndex]["UI"].exitUI()
				remIndex = 2
				path[remIndex]["UI"].enterUI()
			end
			path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic2"] )
			
		end
	end 

	for i=1,2 do
		path[i]["Imge"]:addTouchEventListener( Img_TouchCB )
		path[i]["Imge"]:setTouchEnabled(true)
		--[[
		if CityData.canOpenFuncByIndex(20+i) then
			path[i]["Imge"]:setVisible(true)
			path[i]["Imge"]:setTouchEnabled(true)
		else
			path[i]["Imge"]:setVisible(false)
			path[i]["Imge"]:setTouchEnabled(false)
		end
		--]]
	end
	--[[
	local openBtn={}
	local btnTable={
			{["id"]=21,["btn"]=path[1]["Imge"]},
			{["id"]=22,["btn"]=path[2]["Imge"]}	
		}
	for i=1, #btnTable do
		PT.hideManyBtn(openBtn,btnTable[i]["id"],btnTable[i]["btn"])
	end
	for i=1,#openBtn do
		openBtn[i]:setPosition(ccp(-369+90*(i-1),239))
	end
	--]]

	remIndex = _index
	path[remIndex]["Imge"]:loadTexture( path[remIndex]["pic2"] )

	path[remIndex]["UI"].enterUI()
	
end


function exitUI()
	if Layer ~= nil and _widget ~= nil then
		--Layer:removeWidget(_widget)
		Layer:clear()
		_widget = nil
		Layer = nil
		
		LM.STATE_2 = 0
	end
	MapPubUI.setPubVisible(true)

	guideFactory.CheckGuideProcess( LM.STATE_1 )

end
function enterUI(_index)
	
	if LM.STATE_2 == UI_GuanKa_JingYing	or
		LM.STATE_2 == UI_GuanKa_PuTong then
		return
	end

LM.clearLayer3ToUI()

	
	Layer = LM.getLayer2()
	_widget = GUIReader:shareReader():widgetFromJsonFile("GuanKaBase.json")

	Layer:addWidget(_widget)
    _widget:setTouchEnabled(true) --底层的widget设置为true，阻断点击事件的穿透

    MapPubUI.setPubVisible(false)

    initPubUI( _index )
end