module ("GuoZhan_Map",package.seeall)

local Layer = nil 
local _widget = nil
local scene = nil

_Type = 0  --侦查
_Value = 0  --侦查是为城市id

_Value_Yidong = 1 --移动的城市id

local ScrollView_Map = nil
local table_City = {}  -- 11个城市，魏蜀吴横门西安门东安门西平门东平门清平门安门皇宫
local table_loadBar = {}
local table_zhenChaCD = {} 

local table_zhenchaCDBG = {}
local table_zhenchaCd = {}

local img_tanchu = nil
local btn_ZhenCha = nil
local btn_ZhanDou = nil
local btn_YiDong  = nil
local tag_touch   = 1   --点击的城市id
local iftanchuopen = false

local img_fource = nil

function btns_setVisible(ifvisible)
    img_tanchu:setVisible(ifvisible)

    --btn_ZhenCha:setVisible(ifvisible)
    --btn_ZhanDou:setVisible(ifvisible)
    --btn_YiDong:setVisible(ifvisible)
    
    btn_ZhenCha:setTouchEnabled(ifvisible)
    btn_ZhanDou:setTouchEnabled(ifvisible)
    btn_YiDong:setTouchEnabled(ifvisible)
end



function Pop3_CityPlayers( _city_index)    
    Pop3_GuoZhan_CityPlayers.enterUI(_city_index)
end

local function refresh_Button()
    if GuoZhanData.GuoZhan_MoveCD >0 then
       -- btn_YiDong:setText("驰")
    else
       -- btn_YiDong:setText("移动")
    end
end

local function city_touch(sender,eventType) --点击了某个城市
	 if eventType == PT.ccs.TouchEventType.ended then
        local _btn = tolua.cast(sender, "Button")
        local tag_pre = tag_touch
        tag_touch = _btn:getTag()
        --print("tag_touch === " .. tag_touch)
        local x,y = _btn:getPosition()
        if GuoZhanData.getSpyCityCD(tag_touch) ~= 0 then
            --img_tanchu:setVisible(false)
            btns_setVisible(false)
            if tag_touch ~= 1 and  tag_touch ~= 2 and tag_touch ~= 3 then
                protoSend0x0450(1,tag_touch)
            end
            if  ifserver == false then
                print("ifserver = false is "..tag_touch)
                Pop3_CityPlayers(tag_touch)
            end
        else
            img_tanchu:setPosition(ccp(x,y))
            --img_tanchu:setVisible(true)
            if tag_pre == tag_touch then

               if img_tanchu:isVisible() then
                    btns_setVisible(false)
                else
                    btns_setVisible(true)
                end
            else
                 btns_setVisible(true)
            end
            refresh_Button()
        end
    end
end 

local function button_touch(sender,eventType)
    if eventType == PT.ccs.TouchEventType.ended then
        local _btn = tolua.cast(sender, "Button")
        if  _btn == btn_ZhenCha then
                _Type =1
                GuoZhan_MainUI.GuoZhanMoneyType =2
                _Value = tag_touch
                protoSend0x0446(_Type,tag_touch)
        elseif _btn == btn_ZhanDou then
                protoSend0x0444(tag_touch,1,0)
                MapFight.setFartherUI(UI_GuoZhan_MainUI)
        elseif _btn == btn_YiDong then
                GuoZhan_MainUI.GuoZhanMoneyType =3
                print("yidong is "..tag_touch)
                _Value_Yidong = tag_touch
                protoSend0x0444(_Value_Yidong,2,0)
        end
        --img_tanchu:setVisible(false)
        btns_setVisible(false)
    end
end

function refresh_data()
    if Layer == nil then
        return
    end
    print("GuoZhan_Map refresh_data")
    for i=1,11 do
        --table_City[i]:removeChildByTag(2,true)        
        if GuoZhanData.getCity() == i then
            print("加光圈")
            local _x, _y = table_City[i]:getPosition()
            img_fource:setPosition(ccp(_x, _y))

            local ImgMap_W = 2000
            local ImgMap_H = 1500
            _x = _x + ImgMap_W/2
            _y = _y +ImgMap_H/2

            
            local _layout = ScrollView_Map:getInnerContainer()

            local posx = UseW/2 - _x
            local posy = UseH/2 - _y

            local disW = math_abs(ImgMap_W-UseW)
            local disH = math_abs(ImgMap_H-UseH)

            if posx >= 0 then
                posx = 0
            elseif posx < -disW then
                posx = -disW
            end

            if posy >= 0 then
                posy = 0
            elseif posy < -disH then
                posy = -disH
            end
            ScrollView_Map:setSize(CCSize(UseW, UseH))
            _layout:setPosition( ccp(posx, posy) )

--[[
            local EntryID = -1
            local scheduler = CCDirector:sharedDirector():getScheduler()
            local function FlushPositionGuoZhan()
                ScrollView_Map:setSize(CCSize(UseW, UseH))
                print("set Layout Posx = " .. posx)
                print("set Layout Posy = " .. posy)
                _layout:setPosition( ccp(posx, posy) )

                scheduler:unscheduleScriptEntry( EntryID )

                --guideFactory.CheckGuideProcess(scene)
            end
            EntryID = scheduler:scheduleScriptFunc( FlushPositionGuoZhan, 0.01, true)
--]]

        end
        print("i == " .. i)
        if table_zhenchaCd[i]~=nil and GuoZhanData.getSpyCityCD(i) ~= 0 and GuoZhanData.getSpyCityCD(i) ~= nil then
            table_zhenchaCDBG[i]:setVisible(true)
            table_zhenchaCd[i]:setText("侦查倒计时 " .. PT.gerStringFromMilSecond(GuoZhanData.getSpyCityCD(i)))
        else
            table_zhenchaCDBG[i]:setVisible(false)
        end

        --if i ~= 1 and i~=2 and i ~= 3 then            
            local img_citybel = table_City[i]:getChildByTag(200)
            local city_b = GuoZhanData.getCityBelong(i)
            if city_b ~= nil then

                if city_b == 1 then
                    print("魏")
                    img_citybel:setVisible(true)
                    img_citybel:loadTexture("pic5_guozhan_1.png")
                elseif  city_b == 2 then
                    print("蜀")
                    img_citybel:setVisible(true)
                    img_citybel:loadTexture("pic4_guozhan_1.png")
                elseif  city_b== 3 then
                    print("吴")
                    
                    img_citybel:setVisible(true)
                    img_citybel:loadTexture("pic6_guozhan_1.png")
                else
                    print("隐藏所属提示")
                    img_citybel:setVisible(false)
                end
            end
                
            --local pro = table_City[i]:getChildByTag(150)
            local pro = table_loadBar[i]

            if i == GuoZhanData.getCity() then

                GuoZhanData.progress_number = 1
                GuoZhanData.setGuoZhanJiangLiProgress(pro)
                if pro ~= nil then
                    --pro:setScaleX(0.01)
                    pro:setPercent(1)
                    pro:setVisible(true)
                end
            else
                pro:setVisible(false)
            end

    end
end

local function moveCenter()
    local x,y = table_City[11]:getPosition()
    local _layout = ScrollView_Map:getInnerContainer()
    _layout:setPosition( ccp(-1*x+UseW/2,-1*y+UseH/2))
end

local function initMap()    
    ScrollView_Map = tolua.cast(Layer:getWidgetByName("ScrollView_map"),"ScrollView")
    ScrollView_Map:setSize(CCSize(UseW, UseH))
    img_fource = tolua.cast(Layer:getWidgetByName("ImageView_fource"),"ImageView")
    for i=1,11 do
        table_City[i] = tolua.cast(Layer:getWidgetByName("Button_"..i),"Button")
        table_City[i]:setTag(i) 
        --侦查倒计时
        --[[
        local  label = Label:create()
        label:setText("0")
        label:setTag(100)
        label:setPosition(ccp(0,-30))
        table_City[i]:addChild(label) 
        --]]

        table_zhenchaCDBG[i] = tolua.cast(Layer:getWidgetByName("ImageView_ZhenChaCDBG_"..i),"ImageView")
        table_zhenchaCd[i] = tolua.cast(Layer:getWidgetByName("Label_ZhenChaCD_"..i),"Label")
        table_zhenchaCDBG[i]:setZOrder(2)
        GuoZhanData.setGuoZhanCitySpy(i,table_zhenchaCd[i], table_zhenchaCDBG[i])
        --------------------------------
        table_loadBar[i]=tolua.cast(Layer:getWidgetByName("LoadingBar_"..i),"LoadingBar")
        table_loadBar[i]:setVisible(false)

        local img_city =  ImageView:create()
        img_city:loadTexture("pic4_guozhan_1.png")
        img_city:setTag(200)
        img_city:setZOrder(1)
        if i ~= 1 and i ~= 2 and i ~=3 then
            img_city:setScale(0.8)
        end
        img_city:setVisible(false)
        img_city:setPosition(ccp(0,100))
        table_City[i]:addChild(img_city)
        
        table_City[i]:addTouchEventListener(city_touch)
    end

    btn_ZhenCha = tolua.cast(Layer:getWidgetByName("Button_ZhenCha"),"Button")
    btn_ZhanDou = tolua.cast(Layer:getWidgetByName("Button_ZhanDou"),"Button")
    btn_YiDong  = tolua.cast(Layer:getWidgetByName("Button_YiDong"),"Button")

    btn_ZhenCha:addTouchEventListener(button_touch)    
    btn_ZhanDou:addTouchEventListener(button_touch)    
    btn_YiDong:addTouchEventListener(button_touch)    

    img_tanchu = tolua.cast(Layer:getWidgetByName("ImageView_TanChu"),"ImageView")
    --img_tanchu:setVisible(false)
    btns_setVisible(false)
    refresh_data()
--[[
    local camp_png = nil
    if PlayerData.getCamp()+1 == 1 then
            camp_png = "pic5_guozhan_1.png"
    elseif PlayerData.getCamp()+1 == 2 then
            camp_png = "pic4_guozhan_1.png"
    elseif PlayerData.getCamp()+1 == 3 then 
            camp_png = "pic6_guozhan_1.png"
    end

    if camp_png ~= nil then
        print("tianjiaguobiao")
        local img_tag =  ImageView:create()
        img_tag:loadTexture(camp_png)
        table_City[PlayerData.getCamp()+1]:addChild(img_tag)
    end
    --moveCenter()
--]]

    local img_map = tolua.cast(Layer:getWidgetByName("ImageView_GuoZhanMap"),"ImageView")
    local function mapTouch(sender,eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            if img_tanchu:isVisible() then
                btns_setVisible(false)
            end
        end
    end
    img_map:setTouchEnabled(true)
    img_map:addTouchEventListener(mapTouch)
end

function guwuSetVisible(ifvisible)    
    if ifvisible then
    
    else
   
    end
end

function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        _widget = nil
        Layer = nil
        LM.STATE_1 = 0
    end   
    for i=1,11 do
        GuoZhanData.setGuoZhanCitySpy(i,nil)  
    end
    GuoZhanData.setGuoZhanJiangLiProgress(nil)
end

function enterUI(_fatherUI)
    LM.STATE_1 = UI_GuoZhan_Map
    Layer = LM.getLayer1Base_ccf()
    _widget = GUIReader:shareReader():widgetFromJsonFile("GuoZhanUI.json")   

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)

    initMap()
end

--[[
function exitUI()
    for i=1,11 do
        GuoZhanData.setGuoZhanCitySpy(i,nil)  
    end
    GuoZhanData.setGuoZhanJiangLiProgress(nil)
    if scene ~=nil then
	   scene:removeChild(Layer, true)
    end
    Layer = nil
end

function enterUI(curScene)
    scene = curScene
    PT.UI_State = UI_GuoZhan_Map
    Layer = TouchGroup:create()
    Layer:setZOrder(0)

    local _widget = GUIReader:shareReader():widgetFromJsonFile("GuoZhanUI.json") 
    Layer:addWidget(_widget)
    _widget:setTouchEnabled(false)
 	scene:addChild(Layer)

    initMap()
end
--]]
