module ("Pop3_GuoZhan_PaiHangBang",package.seeall)

local Layer = nil
local _widget = nil
local scene = nil

local btn_close = nil
local btn_left  = nil
local btn_right = nil

local lbl_mykill = nil
local ScrollView_mykill = nil

local current_page = 0  --显示第几页的数据
local Pre_UI_Name = nil 

local function refresh_ScrollView()
    ScrollView_mykill:setBackGroundColorType(0)
    ScrollView_mykill:removeAllChildren()       
    ScrollView_mykill:setClippingEnabled(true) 
    ScrollView_mykill:setTouchEnabled(true)

    local view_W = ScrollView_mykill:getSize().width 
    local view_H = ScrollView_mykill:getSize().height 

    local cell_H = 26
    local cell_disY = 1
    local num = GuoZhanData.getKillPaiHangBangNum()

    ScrollView_mykill:setInnerContainerSize( CCSize(view_W, cell_H*num+cell_disY*(num-1)) )

    --滑动区域
    local scroll_W = ScrollView_mykill:getInnerContainerSize().width
    local scroll_H = ScrollView_mykill:getInnerContainerSize().height
    print("scroll_H == " .. scroll_H)
     print("view_H == " .. view_H)
    local cell_Y = scroll_H-cell_H/2

    
    for i=1,num do
       
        local data = GuoZhanData.getKillPaiHangBangByIndex(i)
        local name = data["name"]
        local lv = data["lv"]
        local kill = data["kill"]
        --[[
        local name = "测试名字"
        local lv = 50
        local kill = "dsfd"
        --]]
        local lable_rank = Label:create()
        lable_rank:setText(i)
        lable_rank:setPosition(ccp(30,cell_Y))        

        
        local lable_name = Label:create()
        lable_name:setText(name)
        lable_name:setPosition(ccp(100,cell_Y))

        
        local lable_lv = Label:create()
        lable_lv:setText(lv)
        lable_lv:setPosition(ccp(200,cell_Y))

        local lable_kill = Label:create()
        lable_kill:setText(kill)
        lable_kill:setPosition(ccp(300,cell_Y))

        ScrollView_mykill:addChild(lable_name)
        ScrollView_mykill:addChild(lable_lv)
        ScrollView_mykill:addChild(lable_kill)
        ScrollView_mykill:addChild(lable_rank)

        cell_Y = cell_Y - cell_disY - cell_H
    end
end 

local function refresh_data()
    print("refresh_data1")
    if ifserver then
        lbl_mykill:setText(GuoZhanData.getMyKiller())
    else
        print("refresh_data2")
        lbl_mykill:setText("10095")
    end
    refresh_ScrollView(1)
end 

local function initMap()
    
    local function btnCallback(sender, eventType)      
        if eventType == PT.ccs.TouchEventType.ended then
        	local _btn = tolua.cast(sender, "Button")
        	local tag = _btn:getTag()
        	print("tag === " .. tag)
            if _btn == btn_close then
                exitUI()
            --[[
            elseif _btn == btn_left then
                refresh_ScrollView(current_page - 1)
            elseif _btn == btn_right then
                refresh_ScrollView(current_page + 1)
            --]]
            end
    	end
    end

    btn_close = tolua.cast(Layer:getWidgetByName("Button_close"), "Button" )
    --btn_left  = tolua.cast(Layer:getWidgetByName("Button_left"), "Button" )
    --btn_right  = tolua.cast(Layer:getWidgetByName("Button_right"), "Button" )
    lbl_mykill = tolua.cast(Layer:getWidgetByName("Label_mykiller"), "Label" )
    ScrollView_mykill =  tolua.cast(Layer:getWidgetByName("ScrollView_killlist"), "ScrollView" )
    
    btn_close:addTouchEventListener(btnCallback)
    --btn_left:addTouchEventListener(btnCallback)
    --btn_right:addTouchEventListener(btnCallback)
    --btn_right:setFlipX(true)

    refresh_data()
end

function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        --Layer:clear()
        _widget = nil
        Layer = nil
        
        LM.STATE_2 = 0
    end
    if ifserver == false then
        GuoZhanData.clearKillPaiHangBang()
    end
    GuoZhan_MainUI.setPubVisible(true)
end

function enterUI()
    LM.STATE_2 = UI_GuoZhan_PaiHangBang

    Layer = LM.getLayer2()
    _widget = GUIReader:shareReader():widgetFromJsonFile("GuoZhan_Pop3_PaiHangBang.json")

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)

    if ifserver == false then
        for i=1,45 do
            local _data = PT.copyTable(GuoZhanData.GuoZhan_KillerData)
            if _data == nil then
                print("_data")
            end
            _data["lv"] = 10
            _data["belong"] = 1
            _data["kill"] = 100
            _data["name"] = "大保健"
            GuoZhanData.addKillPaiHangBang(_data,i)
        end
    end
    GuoZhan_MainUI.setPubVisible(false)
    initMap()
end

--[[
function exitUI()   
	scene:removeChild(Layer, true)
    PT.UI_State = Pre_UI_Name
    if ifserver == false then
        GuoZhanData.clearKillPaiHangBang()
    end
end

function enterUI(curScene)    
    scene = curScene
    Pre_UI_Name = PT.UI_State
    PT.UI_State = UI_GuoZhan_PaiHangBang
    Layer = TouchGroup:create()
    Layer:setZOrder(0)

    local _widget = GUIReader:shareReader():widgetFromJsonFile("GuoZhan_Pop3_PaiHangBang.json") 
    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)
 	scene:addChild(Layer)

    if ifserver == false then
        for i=1,45 do
            local _data = PT.copyTable(GuoZhanData.GuoZhan_KillerData)
            if _data == nil then
                print("_data")
            end
            _data["lv"] = 10
            _data["belong"] = 1
            _data["kill"] = 100
            _data["name"] = "大保健"
            GuoZhanData.addKillPaiHangBang(_data,i)
        end
    end

    initMap()
end
--]]
