module ("JunTuan_JiaRu",package.seeall)

--local curScene = nil
local Layer = nil
local _widget = nil

local _scrollview = nil
local remFouceIdx = 0 --记录选中军团的序列
--[[
HuiHuiPic = {
	"floor+9_juntuan.png", 
	"floor+10_juntuan.png",
	"floor+7_juntuan.png",
	"floor+8_juntuan.png",
	"floor+11_juntuan.png",
	"floor+12_juntuan.png",
	"floor+15_juntuan.png",
	"floor+16_juntuan.png",
	"floor+13_juntuan.png",
	"floor+14_juntuan.png"
}
--]]
local countryName= {"魏国", "蜀国", "吴国"}
local img_junHuiIcon 	= nil  --军徽图标
local lbl_junHuiName 	= nil  --军徽名字
local lbl_teamName 		= nil  --公会名字
local lbl_teamLv 		= nil  --公会等级
local lbl_teamCountry 	= nil  --公会所属国家
local lbl_teamPeople 	= nil  --公会人员数量
local lbl_teamLeader 	= nil  --公会队长名字
local lbl_teamLiuYan 	= nil  --公会留言
local img_hideNode = nil
--local img_righttop = nil
--local img_rightmid = nil
local lbl_page = nil

function flushGuildMessagePanel()
	local dataList = GuildListData.getGuildListData()
	local dataNum = #dataList
	print("flushGuildMessagePanel dataNum == " .. dataNum)
	
if remFouceIdx <= dataNum then
	local data = dataList[remFouceIdx]
	img_junHuiIcon:loadTexture( HuiHuiPic[data["EmbLv"]] )

	lbl_junHuiName:setText( data["EmbName"] )  	--军徽名字
	lbl_teamName:setText( data["GuildName"] )  	--公会名字
	lbl_teamLv:setText( data["GuildLv"] .. "级" )  		--公会等级
	lbl_teamCountry:setText( countryName[data["Country"]] )  	--此处国家不用+1 公会所属国家
	lbl_teamPeople:setText( data["TeamerNum"] .. "/" .. data["MaxNum"] )  	--公会人员数量
	lbl_teamLeader:setText( data["LeaderName"] )  	--公会队长名字
	lbl_teamLiuYan:setText( data["GuildText"] )  	--公会留言



end
end


function _flushGuildListScrollView()
	_scrollview:removeAllChildren()
    _scrollview:setClippingEnabled(true) --裁切窗口
   -- _scrollview:setBounceEnabled(true) --边缘回弹
    _scrollview:setBackGroundColorType(0)

_scrollview:removeAllChildren()
    local cell_disY = 5
    local cell_disX = 5
    local cell_W, cell_H = 88, 88
        --可视区域
    local view_W = _scrollview:getSize().width 
    local view_H = _scrollview:getSize().height 

    local Datanum = 20

    local lieNum  = 5
    local hangNum = math.ceil(Datanum/lieNum)

    _scrollview:setInnerContainerSize( CCSize(view_W, cell_H*hangNum+(hangNum-1)*cell_disY ) )

    --滑动区域
    local scroll_W = _scrollview:getInnerContainerSize().width
    local scroll_H = _scrollview:getInnerContainerSize().height

   
	local cell_X, cell_Y = (scroll_W-(cell_W+cell_disX)*4)/2, scroll_H-cell_H/2-10

	local dataList = GuildListData.getGuildListData()
	local dataNum = #dataList
	print( "dataNum == " .. dataNum )
	if dataNum == 0 then
		--img_righttop:setVisible(false)
		--img_rightmid:setVisible(false)
		img_hideNode:setVisible(false)
	else
		--img_righttop:setVisible(true)
		--img_rightmid:setVisible(true)
		img_hideNode:setVisible(true)
	end

	local fouceImg = nil
	local function CellTouchCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
        	
            local _img = tolua.cast(sender, "ImageView")
            local tag = _img:getTag()
            if remFouceIdx == tag then
            	return
            end
            remFouceIdx = tag
            local posX, posY = _img:getPosition()
            fouceImg:setPosition( ccp(posX, posY) )
            flushGuildMessagePanel()
        end
	end

	if dataNum > 0 then
		fouceImg =  ImageView:create()
		fouceImg:loadTexture("floor+6_juntuan.png")
	end
    for i=1, hangNum do
        for j=1, lieNum do
            local _index = (i-1)*lieNum+j

            local imageView = ImageView:create()
            imageView:loadTexture("floor+8_tong.jpg")
            imageView:setTag(_index)
            imageView:setPosition( CCPoint( cell_X, cell_Y ) )
if _index <= dataNum then
			if _index == remFouceIdx then
				fouceImg:setPosition( ccp( cell_X, cell_Y ) )
				flushGuildMessagePanel()
			end
            imageView:addTouchEventListener( CellTouchCB )
            imageView:setTouchEnabled(true)
            local data = dataList[_index]
            
            local HuiHuiLv = data["EmbLv"]
            local HuiHuiName = data["EmbName"]

	            local Img_huihui = ImageView:create()
	            Img_huihui:loadTexture(HuiHuiPic[HuiHuiLv])
	            	local lbl_huihui = Label:create()
	           	 	lbl_huihui:setText( HuiHuiName )
	            	lbl_huihui:setFontSize(35)
	            Img_huihui:addChild( lbl_huihui )
	            --加的魏蜀吴的小图标
	            local Img_whichGuojia= ImageView:create()
	            Img_whichGuojia:setPosition(ccp(22,-22))
	            Img_huihui:addChild( Img_whichGuojia )
	            local int_whichGuojia = data["Country"]
	            if int_whichGuojia==1 then
	            	Img_whichGuojia:loadTexture("pic87_city_1.png")
	            elseif int_whichGuojia==2 then
	            	Img_whichGuojia:loadTexture("pic89_city_1.png")
	            elseif int_whichGuojia==3 then
	            	Img_whichGuojia:loadTexture("pic88_city_1.png")
	            end

            imageView:addChild(Img_huihui)
end
            _scrollview:addChild( imageView )
            cell_X = cell_X + cell_W + cell_disX
        end
        cell_X = (scroll_W-(cell_W+cell_disX)*4)/2
        cell_Y = cell_Y - cell_disY - cell_H
    end
    if dataNum > 0 then
    	_scrollview:addChild( fouceImg )
    end
    local cur, max = GuildListData.getPage()
    lbl_page:setText( cur .. "/" .. max )
end

local function _initPubMod()

	local btn_AddOrExit = tolua.cast( Layer:getWidgetByName("Button_Exit"), "Button" )
	local LabelBMFont_tuichu = tolua.cast( Layer:getWidgetByName("Label_1008"), "Label" )
	local btn_newTeam = tolua.cast( Layer:getWidgetByName("Button_newTeam"), "Button" )

	local btn_left  = tolua.cast( Layer:getWidgetByName("Button_leftPage"), "Button" )
	btn_left:setScaleX(-1)
	local btn_right = tolua.cast( Layer:getWidgetByName("Button_rightPage"), "Button" )

	local ifInTeam = PlayerData.CheckIfHaveInTeam() --检测是否已经加入了军团

	local function btn_CB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
		
			local _btn = tolua.cast(sender, "Button")
			if _btn == btn_AddOrExit then
				if ifInTeam then --退出军团
					local guild_id = PlayerData.getGuildId()
					protoSend0x0394(recv0x0103[INDEX_0x0103_CharId][VALUE],guild_id)
				else --申请加入
					--JunTuan_Pop3_ShenQingJiaRu.enterUI( curScene ,remFouceIdx)
					JunTuan_Pop3_ShenQingJiaRu.enterUI( remFouceIdx )
				end
			elseif _btn == btn_newTeam then
				--JunTuan_Pop3_newTeam.enterUI( curScene )
				JunTuan_Pop3_newTeam.enterUI()
			elseif _btn == btn_left then
				--todo：左翻页
				local cur, max = GuildListData.getPage()
				protoSend0x0380(cur,1)
			elseif _btn == btn_right then
				--todo：右翻页
				local cur, max = GuildListData.getPage()
				protoSend0x0380(cur,2)
			end
		end
	end
	
	btn_AddOrExit:addTouchEventListener( btn_CB )
	btn_newTeam:addTouchEventListener( btn_CB )
	btn_left:addTouchEventListener( btn_CB )
	btn_right:addTouchEventListener( btn_CB )
	btn_right:setColor(ccc3(128,128,128))
	if ifInTeam then --在军团里
		btn_newTeam:setTouchEnabled(false)
		btn_newTeam:setVisible(false)
	else
		btn_AddOrExit:loadTextures("button4_tong_1.jpg", "button4_tong_2.jpg", "button4_tong_3.jpg")
		LabelBMFont_tuichu:setText("申请加入")
	end

	_scrollview = tolua.cast( Layer:getWidgetByName("ScrollView_TeamList"), "ScrollView" )


	img_junHuiIcon 	= tolua.cast( Layer:getWidgetByName("ImageView_TeamIcon"), "ImageView" )
	lbl_junHuiName 	= tolua.cast( Layer:getWidgetByName("Label_TeamJunHuiName"), "Label" )
	lbl_teamName 	= tolua.cast( Layer:getWidgetByName("Label_TeamName"), "Label" )
	lbl_teamLv 		= tolua.cast( Layer:getWidgetByName("Label_TeamLv"), "Label" )
	lbl_teamCountry = tolua.cast( Layer:getWidgetByName("Label_GuoJia"), "Label" )
	lbl_teamPeople 	= tolua.cast( Layer:getWidgetByName("Label_RenShu"), "Label" )
	lbl_teamLeader 	= tolua.cast( Layer:getWidgetByName("Label_JunZhang"), "Label" )
	lbl_teamLiuYan 	= tolua.cast( Layer:getWidgetByName("Label_shuoming"), "Label" )
	lbl_page 		= tolua.cast( Layer:getWidgetByName("Label_page"), "Label" )
	--img_righttop 	= tolua.cast( Layer:getWidgetByName("ImageView_796"), "ImageView" )
	--img_rightmid 	= tolua.cast( Layer:getWidgetByName("ImageView_812"), "ImageView" )
	img_hideNode = tolua.cast( Layer:getWidgetByName("ImageView_hideNode"), "ImageView" )
	remFouceIdx = 1
	_flushGuildListScrollView()
end

function exitUI()
	if Layer ~= nil and _widget ~= nil then
		Layer:removeWidget(_widget)
		--Layer:clear()
		_widget = nil
		Layer = nil
		
		LM.STATE_3 = 0
	end
end

function enterUI()
	if LM.STATE_3 == UI_JunTuan_JiaRu then --退出刷新
		exitUI()
	end

	LM.STATE_3 = UI_JunTuan_JiaRu

	Layer = LM.getLayer3()
	_widget = GUIReader:shareReader():widgetFromJsonFile("JunTuanUI_JiaRu.json")

	Layer:addWidget(_widget)
    _widget:setTouchEnabled(false) --底层的widget设置为true，阻断点击事件的穿透

    _initPubMod()
end

--[[
function enterUI( _Scene )
    PT.UI_State = UI_JunTuan_JiaRu
	curScene = _Scene
	Layer = TouchGroup:create()
	Layer:setZOrder(10)
	--Layer:setTouchEnabled(false)
    local _widget = GUIReader:shareReader():widgetFromJsonFile("JunTuanUI_JiaRu.json")    
    _widget:setTouchEnabled(false)
    Layer:addWidget(_widget)
    _Scene:addChild(Layer)
    
    _initPubMod()
    guideFactory.CheckGuideProcess(curScene)
end

function exitUI()
    --BagData.clearCDlbl()
	curScene:removeChild(Layer, true)
	--Layer:onExit()
end
--]]