module ("JunTuan_KeJi",package.seeall)

--local curScene = nil
local Layer = nil
local _widget = nil

local _scrollview = nil
local remFouceIdx = 0 --记录选中军团的序列
local lbl_name = nil
local lbl_lv = nil
local lbl_needlv = nil
local lbl_persent = nil
local lbl_text = nil
local img_Icon = nil
local btn_setdefault = nil

function flushGuildMessagePanel()
    local dataList = TeamTechnologyData.getGuildListData()
    local dataNum = #dataList
    
    if remFouceIdx <= dataNum then
        local data = dataList[remFouceIdx]
        print("data id == " .. data["Id"])
        print("remFouceIdx == " .. remFouceIdx)
        print("CurExp == " .. data["CurExp"])
        local _Des = Des.getGuildTechDesFromId(data["Id"])
        img_Icon:loadTexture( _Des["guildPic"] )
        lbl_name:setText( _Des["guildName"] )   --科技名字
        lbl_lv:setText( data["Lv"] )   --等级
        lbl_needlv:setText( "军团等级" .. data["Lv"]+1 .. "级" )        --需求等级
        lbl_persent:setText( data["CurExp"] .. "/" .. data["MaxExp"]  )     --进度
        lbl_text:setText( _Des["guildDes"]  )    --描述
        print( "dataNum == " .. dataNum )
        if dataNum < 3 then --科技数量小于3
            btn_setdefault:setTouchEnabled(false)
            btn_setdefault:setBright(false)
        else
            if TeamTechnologyData.getDefaultTeamTechnologyId()==data["Id"] then 
            --是默认科技，把设为默认按钮变为灰色
                btn_setdefault:setTouchEnabled(false)
                btn_setdefault:setBright(false)
            else
                btn_setdefault:setTouchEnabled(true)
                btn_setdefault:setBright(true)
            end
        end
    end
end
function _flushGuildListScrollView()
    _scrollview:setClippingEnabled(true) --裁切窗口
   -- _scrollview:setBounceEnabled(true) --边缘回弹
    _scrollview:setBackGroundColorType(0)

_scrollview:removeAllChildren()
    local cell_disY = 5
    local cell_disX = 5
    local cell_W, cell_H = 88, 88
        --可视区域
    local view_W = _scrollview:getSize().width 
    local view_H = _scrollview:getSize().height 

    local Datanum = 20

    local lieNum  = 5
    local hangNum = math.ceil(Datanum/lieNum)

    _scrollview:setInnerContainerSize( CCSize(view_W, cell_H*hangNum+(hangNum-1)*cell_disY ) )

    --滑动区域
    local scroll_W = _scrollview:getInnerContainerSize().width
    local scroll_H = _scrollview:getInnerContainerSize().height

   
    local cell_X, cell_Y = (scroll_W-(cell_W+cell_disX)*4)/2, scroll_H-cell_H/2-10

    local dataList = TeamTechnologyData.getGuildListData()
    local dataNum = #dataList
    print( "dataNum == " .. dataNum )


    local fouceImg = nil
    local function CellTouchCB(sender, eventType)
       if eventType == PT.ccs.TouchEventType.ended then
            
            local _img = tolua.cast(sender, "ImageView")
            local tag = _img:getTag()
            if remFouceIdx == tag then
                return
            end
            remFouceIdx = tag
            local posX, posY = _img:getPosition()
            fouceImg:setPosition( ccp(posX, posY) )
            flushGuildMessagePanel()
        end
    end

    if dataNum > 0 then
        fouceImg =  ImageView:create()
        fouceImg:loadTexture("floor+6_juntuan.png")
    end
    local default_tech = TeamTechnologyData.getDefaultTeamTechnologyId()
    print("default_tech == " .. default_tech)
    for i=1, hangNum do
        for j=1, lieNum do
            local _index = (i-1)*lieNum+j
            
            local imageView = ImageView:create()
            imageView:loadTexture("floor+8_tong.jpg")
            imageView:setTag(_index)
            imageView:setPosition( CCPoint( cell_X, cell_Y ) )

if _index <= dataNum then
            if _index == remFouceIdx then
                fouceImg:setPosition( ccp( cell_X, cell_Y ) )
                flushGuildMessagePanel()
            end
            imageView:addTouchEventListener( CellTouchCB )
            imageView:setTouchEnabled(true)
            local data = dataList[_index]
            
            local HuiHuiLv = data["EmbLv"]
            local HuiHuiName = data["EmbName"]
            local data = Des.getGuildTechDesFromId(_index)
            local Img_huihui = ImageView:create()
                Img_huihui:loadTexture(data["guildPic"])
            if default_tech == _index then
                local imageView_def = ImageView:create()
                local size = nil
                Img_huihui:addChild(imageView_def)
                local x,y = Img_huihui:getPosition()
                local size = Img_huihui:getContentSize()

                print("x == " .. x .. "y == " .. y)
                print("w == " .. size.width .. "h == " .. size.height)
                imageView_def:loadTexture("common_star_3.png")
                local size1 = imageView_def:getContentSize()
                --imageView_def:setTag(_index)
                print("w1 == " .. size1.width .. "h1 == " .. size1.height)
                local w2,_ = math_modf((size.width-size1.width)/2)
                local h2,_ = math_modf((size.height-size1.height)/2)
                print("w2 == " .. w2 .. " h2 == " .. h2)
                imageView_def:setPosition( CCPoint( x-w2, y+h2 ) )

            end
            imageView:addChild(Img_huihui)
end
            _scrollview:addChild( imageView )
            cell_X = cell_X + cell_W + cell_disX
        end
        cell_X = (scroll_W-(cell_W+cell_disX)*4)/2
        cell_Y = cell_Y - cell_disY - cell_H
    end
    if dataNum > 0 then
        _scrollview:addChild( fouceImg )
    end
    flushGuildMessagePanel()
    --local cur, max = GuildListData.getPage()
    --lbl_page:setText( cur .. "/" .. max )
end

local function _initPubMod()
    lbl_name  = tolua.cast( Layer:getWidgetByName("Label_name"), "Label" )
    lbl_lv    = tolua.cast( Layer:getWidgetByName("Label_Lv"), "Label" )
    lbl_needlv      = tolua.cast( Layer:getWidgetByName("Label_XuQiu"), "Label" )
    lbl_persent = tolua.cast( Layer:getWidgetByName("Label_JinDu"), "Label" )
    lbl_text  = tolua.cast( Layer:getWidgetByName("Label_MiaoShu"), "Label" )
    img_Icon  = tolua.cast( Layer:getWidgetByName("ImageView_996"), "ImageView" )
    local btn_left  = tolua.cast( Layer:getWidgetByName("Button_left"), "Button" )
    btn_left:setScaleX(-1)
    local btn_right = tolua.cast( Layer:getWidgetByName("Button_right"), "Button" )
    local lbl_pageNum = tolua.cast( Layer:getWidgetByName("Label_988"), "Label" )
    lbl_pageNum:setText("1/1")
    local btn_contribute  = tolua.cast( Layer:getWidgetByName("Button_JuanXian"), "Button" )
    btn_setdefault = tolua.cast( Layer:getWidgetByName("Button_SetMoRen"), "Button" )
local function btn_CB(sender, eventType)
       if eventType == PT.ccs.TouchEventType.ended then
            
            local _btn = tolua.cast(sender, "Button")
            if _btn == btn_contribute then
                JunTuan_Pop3_JuanXianYinBi.enterUI( remFouceIdx )
            elseif _btn == btn_setdefault then
                protoSend0x0392(remFouceIdx)
            elseif _btn == btn_left then
                --todo：左翻页
                --protoSend0x0380(1)
            elseif _btn == btn_right then
                --todo：右翻页
                --protoSend0x0380(2)
            end
        end
    end
    
    btn_contribute:addTouchEventListener( btn_CB )
    btn_setdefault:addTouchEventListener( btn_CB )
    btn_left:addTouchEventListener( btn_CB )
    btn_right:addTouchEventListener( btn_CB )
 _scrollview = tolua.cast( Layer:getWidgetByName("ScrollView_986"), "ScrollView" )
    remFouceIdx = 1
    _flushGuildListScrollView()
end

function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        --Layer:clear()
        _widget = nil
        Layer = nil
        
        LM.STATE_3 = 0
    end
end

function enterUI()
    LM.STATE_3 = UI_JunTuan_KeJi

    Layer = LM.getLayer3()
    _widget = GUIReader:shareReader():widgetFromJsonFile("JunTuanUI_KeJi.json")

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(false) --底层的widget设置为true，阻断点击事件的穿透

    _initPubMod()
end

--[[
function enterUI( _Scene )
    PT.UI_State = UI_JunTuan_KeJi
	curScene = _Scene
	Layer = TouchGroup:create()
    Layer:setZOrder(10)
	--Layer:setTouchEnabled(false)
    local _widget = GUIReader:shareReader():widgetFromJsonFile("JunTuanUI_KeJi.json")    
    _widget:setTouchEnabled(false)
    Layer:addWidget(_widget)
    _Scene:addChild(Layer)
    
    _initPubMod()
end

function exitUI()
    --BagData.clearCDlbl()
	curScene:removeChild(Layer, true)
	--Layer:onExit()
end
--]]