module ("JunTuanZhan_GuanKa",package.seeall)

local Layer = nil 
local _widget = nil
--local scene = nil


local btn_close = nil
local btn_shouhuo = nil
local btn_gongzhan = nil
local btn_fangqi = nil

local lbl_belong = nil
local lbl_shouhuo = nil
local lbl_output = nil
--local img_photo = nil

local img_name1 = nil
local img_name2 = nil

local index_city = 1   -- 哪一个关卡
local  data = nil
local pre_UI = 1

local function refresh_state()
    local  data = JunTuanZhanData.getGuanKa(index_city)
    if data ~= nil then
        lbl_belong:setText(data["name"])
        lbl_shouhuo:setText(JunTuanZhanData.getshouhuonum(index_city))
        lbl_output:setText(JunTuanZhanData.getCityOutput(index_city))
--[[        
        if data["state"] == 1 then --被攻打
            btn_gongzhan:setTouchEnabled(false)  
            btn_gongzhan:setBright(false)
        else --未被攻打
            if JunTuanZhanData.getZhanling() ~= index_city then
                btn_gongzhan:setTouchEnabled(true)
                btn_gongzhan:setBright(true)   
            end
        end
--]]
    else
        print("the data is nil the index_city is "..index_city)
    end
--[[    
    if index_city==29 or index_city ==30 or index_city ==31 then
        img_photo:loadTexture("button+15_World_1.png")
    else
        img_photo:loadTexture("button+16_World_1.png")
    end
--]]
    ---[[
    --中原逐鹿 异族羌族  异族匈奴  异族胡人 异族山越 异族土族 异族南蛮
    local img_path = {
        {"word+9_juntuanzha.png", "word+4_juntuanzha.png"},
        {"word+1_juntuanzhan.png", "word+5_juntuanzha.png"},
        {"word+1_juntuanzhan.png", "word+6_juntuanzha.png"},
        {"word+1_juntuanzhan.png", "word+2_juntuanzha.png"},
        {"word+1_juntuanzhan.png", "word+8_juntuanzha.png"},
        {"word+1_juntuanzhan.png", "word+7_juntuanzha.png"},
        {"word+1_juntuanzhan.png", "word+3_juntuanzha.png"},
    }
    img_name1:loadTexture(img_path[index_city][1])
    img_name2:loadTexture(img_path[index_city][2])
    --]]
    if JunTuanZhanData.getZhanling() == index_city then--已经被我军攻占的城市
        
        btn_gongzhan:setTouchEnabled(false)
        btn_gongzhan:setBright(false)   

        btn_shouhuo:setTouchEnabled(true)
        btn_shouhuo:setVisible(true)

        if JunTuanZhanData.getJunTuanZhang() == 1 then --如果是军团长
            btn_fangqi:setTouchEnabled(true)
            btn_fangqi:setVisible(true)
        else
            btn_fangqi:setTouchEnabled(false)
            btn_fangqi:setVisible(false)
        end
    
    else --未被我军攻占的城市
        btn_shouhuo:setTouchEnabled(false)
        btn_shouhuo:setVisible(false)

        btn_fangqi:setTouchEnabled(false)
        btn_fangqi:setVisible(false)

        btn_gongzhan:setTouchEnabled(true)
        btn_gongzhan:setBright(true)   
    end
end 

local function initMap()

    local function btnCallback(sender, eventType)     
        if eventType == PT.ccs.TouchEventType.ended then
        	local _btn = tolua.cast(sender, "Button")
        	local tag = _btn:getTag()
        	print("tag === " .. tag)
            if _btn == btn_close then
                exitUI()
            elseif _btn == btn_shouhuo then
                protoSend0x0462(1,data["id"])
            elseif _btn == btn_gongzhan then
                if ifserver == false then
                    JTZ_JunTuanFight.enterUI()
                else
                    if ifJunTuanZhan then
                        protoSend0x0462(2,data["id"])
                        JTZ_JunTuanFight.setCityId(data["id"])
                    else
                        Pop3_TS_Result.enterUI("国战未开启！")
                    end
                end
            elseif _btn == btn_fangqi then
                protoSend0x0462(3,data["id"])
            end
    	end
    end

    btn_close = tolua.cast(Layer:getWidgetByName("Button_close"), "Button" )
    btn_shouhuo = tolua.cast(Layer:getWidgetByName("Button_ShouHuo"), "Button" )
    btn_gongzhan = tolua.cast(Layer:getWidgetByName("Button_JiaRu_GongZhan"), "Button" )
    btn_fangqi = tolua.cast(Layer:getWidgetByName("Button_JiaRu_FangQi"), "Button" )

    lbl_belong = tolua.cast(Layer:getWidgetByName("Label_belong"), "Label" )
    lbl_shouhuo = tolua.cast(Layer:getWidgetByName("Label_shouhuotime"), "Label" )
    lbl_output = tolua.cast(Layer:getWidgetByName("Label_output"), "Label" )
    --img_photo = tolua.cast(Layer:getWidgetByName("ImageView_guanka"), "ImageView" )

    img_name1 = tolua.cast(Layer:getWidgetByName("ImageView_name1"), "ImageView" )
    img_name2 = tolua.cast(Layer:getWidgetByName("ImageView_name2"), "ImageView" )

    lbl_belong:setText("")
    lbl_shouhuo:setText("")
    lbl_output:setText("")

    btn_close:addTouchEventListener(btnCallback)
    btn_shouhuo:addTouchEventListener(btnCallback)
    btn_gongzhan:addTouchEventListener(btnCallback)
    btn_fangqi:addTouchEventListener(btnCallback)

    refresh_state()
end

function exitUI()
    --[[
    PT.UI_State = pre_UI
	scene:removeChild(Layer, true)
    --]]
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        --Layer:clear()
        _widget = nil
        Layer = nil
        
        LM.STATE_3 = 0
    end
    MapPubUI.setPubVisible(true)
end

function enterUI(_index)
    index_city = _index
    data = JunTuanZhanData.getGuanKa(index_city)
    
    --[[  
    pre_UI = PT.UI_State  
    scene = curScene
    PT.UI_State = UI_JunTuanZhan_GuanKa
    Layer = TouchGroup:create()
    Layer:setZOrder(0)

    local _widget = GUIReader:shareReader():widgetFromJsonFile("JunTuanZhan_Pop3_GuanKa.json") 
    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)
 	scene:addChild(Layer)
    --]]
    print("_index ===== " .. _index)
    LM.STATE_3 = UI_JunTuanZhan_GuanKa
    Layer = LM.getLayer3()
    _widget = GUIReader:shareReader():widgetFromJsonFile("JunTuanZhan_Pop3_GuanKa.json")

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)
    MapPubUI.setPubVisible(false)
    
    if ifserver==false then        
        JunTuanZhanData.setJTZData(2,5)
        for i=1,7 do
            print("JunTuanZhanData addChild")
            local _data = PT.copyTable(JunTuanZhanData.JunTuanZhan_GuanKa)
            _data["id"] = i
            _data["sate"] = math.random(2)-1
            _data["name"] = "虎牢关"..i+28
            _data["time"] = 20
            _data["_type"] = math.random(3)
            _data["num"] = math.random(100,1000)
            _data["shouhuoMax"] = math.random(11,15)
            JunTuanZhanData.addGuanKa(_data)
        end
        for i=1,10 do
            local _data = PT.copyTable(JunTuanZhanData.JunTuanZhan_Member)
            _data["id"] = i
            _data["pos"] = math.random(10)
            _data["gongjiguwu"] = math.random(10)
            _data["fangyuguwu"] = math.random(10)
            _data["lv"] = math.random(3)
            _data["name"] ="大宝剑"
            JunTuanZhanData.addJunTuanMember(_data)
        end
    end
    initMap()
end
