module ("LtFactory",package.seeall)

local curScrollView = nil
local curPinDao = 0

local lineH = 25
local ScorllViewW = 940
local ScorllViewH = FramSize.height*506/640

local remPosY = {ScorllViewH-lineH/2,ScorllViewH-lineH/2, ScorllViewH-lineH/2, ScorllViewH-lineH/2, ScorllViewH-lineH/2}
local remPosX = 0


local function checkPosY()
   if remPosY[curPinDao] < 0 then
    	local width = curScrollView:getInnerContainerSize().width
    	local height = curScrollView:getInnerContainerSize().height
    	curScrollView:setInnerContainerSize( CCSize(width, height+lineH) )
    	
    	curScrollView:setBounceEnabled(true)
    	

    	curScrollView:getInnerContainer():setPosition(ccp(0,0))
 		remPosY[curPinDao] = remPosY[curPinDao] + lineH
 		local childNum = curScrollView:getChildrenCount()
 		print("childNum === " .. childNum)

 		local array = curScrollView:getChildren()
 		for i=0, childNum-1 do
 			local widgetson = tolua.cast( array:objectAtIndex(i), "Widget" )
 			local x, y = widgetson:getPosition()
 			widgetson:setPosition(ccp(x, y+lineH))
 		end
 	else
 		curScrollView:setBounceEnabled(false)
    end
end
local function checkColor(str)
	local len = string_len(str) 
	local i, j = string_find(str , ":")
	local r = string_sub(str, 1, i-1)
	str = string_sub(str, j+1, len)
	len = string_len(str) 
	i, j = string_find(str , ":")
	local g = string_sub(str, 1, i-1)
	local b = string_sub(str, j+1, len)

	--print("r == " .. r .. "  g == " .. g .. "  b == " .. b)
	return tonumber(r), tonumber(g), tonumber(b)
end

local function CreateIconNode(_data)
	local scale = 0.8
	--print("========CreateIconNode")
    local imageView = ImageView:create()
    --imageView:loadTexture( "floor+5_chat.png" )  
    imageView:loadTexture( "src/faceicon/faceIcon" .. _data["name"] .. ".png")
    imageView:setAnchorPoint( ccp(0,0.5) )

    imageView:setScale( scale )

	local size = imageView:getContentSize()
	if remPosX+size.width*scale > ScorllViewW then
		remPosX = 0
	    remPosY[curPinDao] = remPosY[curPinDao] - lineH
	    checkPosY()	
	end
	imageView:setPosition( ccp(remPosX, remPosY[curPinDao]) )
	curScrollView:addChild( imageView )

	remPosX = remPosX + size.width*scale
end

local function CreateEquipNode(_data, _DataIdx, _nodeIdx)
	local _lbl = Label:create()
	_lbl:setText( _data["text"] )
	_lbl:setFontSize( 22 )
	local size = _lbl:getContentSize()
	if remPosX+size.width >ScorllViewW then
		remPosX = 0
	    remPosY[curPinDao] = remPosY[curPinDao] - lineH
	    checkPosY()	
	end

    local textButton = Button:create()
    textButton:setTouchEnabled(true)
    textButton:setScale9Enabled(true)
   -- textButton:setAnchorPoint( ccp(0, 0.5) )
    textButton:setTitleFontSize(22)
    textButton:loadTextures("floor+100_public.png", "floor+100_public.png", "")
    textButton:setSize(CCSize(size.width, lineH))
    textButton:setTitleText( _data["text"] )
    local _r, _g, _b = checkColor( _data["clor"] )
	textButton:setTitleColor( ccc3( _r, _g, _b ) )
	
	local function btn_CB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			 
			local _btn = tolua.cast(sender, "Button")
			local tag = _btn:getTag()
			print("role tag = " .. tag)
		end
	end
	textButton:setTag(_DataIdx*100+ _nodeIdx)
    textButton:setPosition( ccp(remPosX+size.width/2, remPosY[curPinDao]) )
    textButton:addTouchEventListener(btn_CB) 
curScrollView:addChild( textButton )
remPosX = remPosX + size.width
--[[	
	local _lbl = Label:create()
	_lbl:setText( _data["text"] )
	_lbl:setFontSize( 22 )
	_lbl:setAnchorPoint( ccp(0, 0.5) )
	
	local _r, _g, _b = checkColor( _data["clor"] )
	_lbl:setColor( ccc3( _r, _g, _b ) )

	local size = _lbl:getContentSize()
	if remPosX+size.width >ScorllViewW then
		remPosX = 0
	    remPosY[curPinDao] = remPosY[curPinDao] - lineH
	    checkPosY()	
	end
	_lbl:setPosition( ccp(remPosX, remPosY[curPinDao]) )
	curScrollView:addChild(_lbl)

	local function lbl_CB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			local _lbl = tolua.cast(sender, "Label")
			local tag = _lbl:getTag()
			print("equip tag = " .. tag)
		end
	end
	_lbl:setTag( _DataIdx*100+ _nodeIdx )
	_lbl:setTouchEnabled(true)
	_lbl:addTouchEventListener( lbl_CB )
	remPosX = remPosX + size.width
--]]
end

local function CreateRoleNode(_data, _DataIdx, _nodeIdx)

	local _lbl = Label:create()
	_lbl:setText( _data["text"] )
	_lbl:setFontSize( 22 )
	local size = _lbl:getContentSize()
	if remPosX+size.width >ScorllViewW then
		remPosX = 0
	    remPosY[curPinDao] = remPosY[curPinDao] - lineH
	    checkPosY()	
	end

    local textButton = Button:create()
    textButton:setTouchEnabled(true)
    textButton:setScale9Enabled(true)
   -- textButton:setAnchorPoint( ccp(0, 0.5) )
    textButton:setTitleFontSize(22)
    textButton:loadTextures("floor+100_public.png", "floor+100_public.png", "")
    textButton:setSize(CCSize(size.width, lineH))
    textButton:setTitleText( _data["text"] )
    local _r, _g, _b = checkColor( _data["clor"] )
	textButton:setTitleColor( ccc3( _r, _g, _b ) )
	
	local function btn_CB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			 
			local _btn = tolua.cast(sender, "Button")
			local tag = _btn:getTag()
			---[[
			print("role tag = " .. tag)
			local dataIdx, nodeIdx =  0, 0
			dataIdx, nodeIdx = math_modf(tag/100)
			
			nodeIdx = nodeIdx*100
			local _a,_b = math_modf(nodeIdx)
			print("a = " .. _a)
			print("b = " .. _b)
			if _b >= 0.5 then
				nodeIdx = _a + 1
			else
				nodeIdx = _a
			end
			print("nodeIdx == " .. nodeIdx)

			
			--]]
			--[[
			local strnum = tostring(tag)
			local strA = string.sub(strnum, -2, -1)
			local strB = string.sub(strnum, 1, -3)
			local dataIdx = tonumber(strA)
			local nodeIdx = tonumber(strB)
			print(dataIdx)
			print(nodeIdx)
			--]]
			local data = TalkData.getDataFromLocalIndex(dataIdx)
			LiaoTian.setSiLiaoName(  data["Data"][nodeIdx]["text"],true, data["Type"], nodeIdx )
		end
	end
	textButton:setTag(_DataIdx*100+ _nodeIdx)
    textButton:setPosition( ccp(remPosX+size.width/2, remPosY[curPinDao]) )
    textButton:addTouchEventListener(btn_CB) 
curScrollView:addChild( textButton )
remPosX = remPosX + size.width
--[[	
	local _lbl = Label:create()
	_lbl:setText( _data["text"] )
	_lbl:setFontSize( 22 )
	_lbl:setAnchorPoint( ccp(0, 0.5) )
	
	local _r, _g, _b = checkColor( _data["clor"] )
	_lbl:setColor( ccc3( _r, _g, _b ) )

	local size = _lbl:getContentSize()
	if remPosX+size.width >ScorllViewW then
		remPosX = 0
	    remPosY[curPinDao] = remPosY[curPinDao] - lineH
	    checkPosY()	
	end
	_lbl:setPosition( ccp(remPosX, remPosY[curPinDao]) )

	local function lbl_CB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			local _lbl = tolua.cast(sender, "Label")
			local tag = _lbl:getTag()
			print("role tag = " .. tag)
		end
	end
	_lbl:setTag( _DataIdx*100+ _nodeIdx )
	_lbl:setTouchEnabled(true)
	_lbl:addTouchEventListener( lbl_CB )

	curScrollView:addChild(_lbl)
	remPosX = remPosX + size.width
]]	
end

local function CreatStringNode(_data)
			
	local _lbl = Label:create()
	_lbl:setText( _data["text"] )
	_lbl:setFontSize( 22 )
	_lbl:setAnchorPoint( ccp(0, 0.5) )
	
	local _r, _g, _b = checkColor( _data["clor"] )
	_lbl:setColor( ccc3( _r, _g, _b ) )

	local size = _lbl:getContentSize()
	if remPosX+size.width >ScorllViewW then
		remPosX = 0
	    remPosY[curPinDao] = remPosY[curPinDao] - lineH
	    checkPosY()	
	end
	_lbl:setPosition( ccp(remPosX, remPosY[curPinDao]) )
	curScrollView:addChild(_lbl)

	remPosX = remPosX + size.width

end


function addSentence( _ScrollView, _pindao, tabData, dataIdx )
	curScrollView = nil
	curScrollView = _ScrollView
	curPinDao = _pindao
	print("curPinDao === " .. curPinDao)
--[[	
local tabData = {
	[1] = {
		["type"] = 1,  
		["text"] = "【世界】",
		["clor"] = "0:255:132",
	},
	[2] = {
		["type"] = 4,
		["text"] = "河鱼",
		["clor"] = "255:166:0",	
	},
	[3] = {
		["type"] = 2,   
		["text"] = "一起吃风:",
		["clor"] = "248:255:203",	
	},
	[4] = {
		["type"] = 3,  
		["name"] = 001,
	},
	[5] = {
		["type"] = 4,  
		["text"] = "青锋剑",
		["clor"] = "33:143:255",	
		--["idex"] = "1231312",
	},
}
--]]
	remPosX = 0

	local size = #tabData
	print("size = " .. size)
	for i=1, size do
		local data = tabData[i]
		
		if data["type"] == 1 then
			CreatStringNode( data )
		elseif data["type"] == 2 then
			CreateRoleNode( data, dataIdx, i )
		elseif data["type"] == 3 then
			CreateIconNode( data, dataIdx, i )
			--print("wwwww:" .. data["name"])
		elseif data["type"] == 4 then
			CreateEquipNode( data , dataIdx, i )
		end
	end

	print("-------------> " .. remPosY[curPinDao])
	print("-------------> " .. curPinDao)

    remPosY[curPinDao] = remPosY[curPinDao] - lineH
    
    checkPosY()
 
end

function init()
	curScrollView = nil
	curPinDao = 0

	lineH = 25
	ScorllViewW = 940
	ScorllViewH = 506

	local posy = ScorllViewH-lineH/2
	remPosY[1] = posy
	remPosY[2] = posy
	remPosY[3] = posy
	remPosY[4] = posy
	remPosY[5] = posy
	remPosX = 0
end
-----------------主ui的聊天部分---------------

local _panelA = nil
local _panelB = nil
local UINoteState = false --ui是否在做动作
--_btn 参数暂且没用
function initUITalk( panel_a, panel_b, _btn)
	_panelA = nil
	_panelB = nil

	_panelA = panel_a
	_panelB = panel_b
	UINoteState = false
end
--当在去聊天ui时，关闭主UI的聊天提示效果
function closeUiTalk()

	_panelA = nil
	_panelB = nil
	UINoteState = false
end
function CheckUINoteState()
	if UINoteState then
		return
	else
		UINoteState = true
		flushUITalk()
	end

end
--当前是聊天ui，不会点亮提示效果
--当前是战斗场景，不刷新此操作
function flushUITalk()

	if LM.STATE_9 ~=1 and LM.STATE_9 ~= 2 then
		return
	end

	if _panelB == nil or _panelA == nil then
		return 
	end

	local _remX = 0
	local function addstring( _data )
		local _lbl = Label:create()
		_lbl:setText( _data["text"] )
		_lbl:setFontSize( 20 )
		_lbl:setAnchorPoint( ccp(0, 0) )
		
		local _r, _g, _b = checkColor( _data["clor"] )
		_lbl:setColor( ccc3( _r, _g, _b ) )

		local size = _lbl:getContentSize()
		--[[
		if remPosX+size.width >ScorllViewW then
			remPosX = 0
		    remPosY[curPinDao] = remPosY[curPinDao] - lineH
		    checkPosY()	
		end
		--]]
		_lbl:setPosition( ccp(_remX, 0) )
		
		_panelB:addChild( _lbl )

		_remX = _remX + size.width

	end

	local function addFace(_data)
		local scale = 0.8

	    local imageView = ImageView:create()
	    --imageView:loadTexture( "floor+5_chat.png" )
	    imageView:loadTexture( "src/faceicon/faceIcon" .. _data["name"] .. ".png")
	    imageView:setAnchorPoint( ccp(0,0) )

	    imageView:setScale( scale )

		local size = imageView:getContentSize()
		--[[
		if remPosX+size.width*scale > ScorllViewW then
			remPosX = 0
		    remPosY[curPinDao] = remPosY[curPinDao] - lineH
		    checkPosY()	
		end
		--]]
		imageView:setPosition( ccp(_remX, 0) )
		_panelB:addChild( imageView )

		_remX = _remX + size.width*scale
	end

	local function doAction(state)
		local move1 = CCMoveBy:create(0.1, ccp(0, 36) )
		local move2 = CCMoveBy:create(0.1, ccp(0, 36) )
		local function actionEnd(sender)
			_panelA:setPosition(ccp(0,-36))
			_panelA:removeAllChildren()

			local _t = _panelA
			_panelA = _panelB
			_panelB = _t

			if state then
				flushUITalk()
			end
		end
		
		if state then
			local array1 = CCArray:create()
			array1:addObject(move1)
			_panelA:runAction(CCSequence:create(array1))

			local array2 = CCArray:create()
			array2:addObject(move2)
			--array2:addObject(CCDelayTime:create(3)) --延迟三秒
			array2:addObject(CCCallFuncN:create(actionEnd))
			_panelB:runAction(CCSequence:create(array2))	

		end
		
	end
	--local size, _data = TalkData.getNoteOnUiMessage()
	--节点数据和节点数量
	local tabData = TalkData.getNoteOnUiMessage()
	if tabData == nil then --没有数据了
		doAction(false)
		UINoteState = false
		return
	end
	local size = #tabData

	for i=1, size do
		local data = tabData[i]
		
		if data["type"] == 1 then
			addstring( data )
		elseif data["type"] == 2 then
			addstring( data )
		elseif data["type"] == 3 then
			addFace( data )
		elseif data["type"] == 4 then
			addstring( data )
		end
	end

	--用完了就移除掉数据
	TalkData.DelNoteOnUiMessageOnce()

	doAction(true)

end