module ("MapFight_GongLue",package.seeall)
--将领更改训练模式的3级UI
--local curScene = nil
local curLayer = nil
local widget = nil

local remIdx = 0 --记录显示面板

local panel_tab = {}
local ifNeedFlash = {true, true, true}
local flushTab = {}


local function _flushWu()

if ifNeedFlash[3] then
	ifNeedFlash[3] = false
	local _scrollview = tolua.cast( curLayer:getWidgetByName("ScrollView_wu"), "ScrollView" )
	_scrollview:setClippingEnabled(true) --裁切窗口
	_scrollview:setBounceEnabled(true) --边缘回弹
	_scrollview:setBackGroundColorType(0)

	--可视区域
	local view_W = _scrollview:getSize().width 
	local view_H = _scrollview:getSize().height

	local cell_disY = 5 
	local cell_W, cell_H = view_W, 65
	local num = 5

	_scrollview:setInnerContainerSize( CCSize(view_W, (cell_H+cell_disY)*num) )

	--滑动区域
	local scroll_W = _scrollview:getInnerContainerSize().width
	local scroll_H = _scrollview:getInnerContainerSize().height

	local cell_X, cell_Y = view_W/2, scroll_H-cell_H/2
	local dataList = nil
	local dataSize = 0
	local function allCellCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
		 
			local _btn = tolua.cast(sender, "Button")
			local tag = _btn:getTag()
			local data = dataList[tag]

			local charpterId, npcId, _ = PT.getId()

			protoSend0x0308( data["charId"], charpterId, npcId )
			exitUI()
		end
	end
if ifserver then
	dataList = ReportData.getReport(3)
	dataSize = #dataList
end
if #dataList ~=0  then
	for i=dataSize, 1, -1 do
		local strlv = nil
		local strname = nil
		local _hava = false
		local charId = 0
		
if ifserver then
		local data = dataList[i]
		if data["charId"] ~= 0 then
			_hava = true
			strlv = "Lv: " .. data["lv"]
			strname = data["name"]
		end
else
		_hava = true
		strlv = "Lv: 18"
		strname = "玩家名字"
end

		if _hava then
			local img_cell = ImageView:create()
			img_cell:loadTexture("teamBG3.png")
			img_cell:setScale9Enabled(true)
			img_cell:setSize( CCSize( cell_W, cell_H) )
			img_cell:setPosition(ccp(cell_X,cell_Y))
			img_cell:setVisible(false)
				--国家
				local lbl_Country = Label:create()
				lbl_Country:setText( "【吴】" )
				lbl_Country:setFontSize( 20 )
				lbl_Country:setPosition( ccp(-220, 0) )
				lbl_Country:setAnchorPoint(ccp(0, 0.5))
				lbl_Country:setColor( ccc3(94, 209, 94 ) )
			img_cell:addChild( lbl_Country )

				local lbl_name = Label:create()
				lbl_name:setText( strname )
				lbl_name:setFontSize( 20 )
				lbl_name:setPosition( ccp(-160, 0) )
				lbl_name:setAnchorPoint(ccp(0, 0.5))
				--lbl_name:setColor( ccc3(255, 241, 15 ) )
			img_cell:addChild( lbl_name )

				local sizeName = lbl_name:getContentSize()
				local lbl_Lv = Label:create()
				lbl_Lv:setText( strlv )
				lbl_Lv:setFontSize( 20 )
				lbl_Lv:setPosition( ccp(-160 + sizeName.width + 10, 0) )
				lbl_Lv:setAnchorPoint(ccp(0, 0.5))
				--lbl_Lv:setColor( ccc3(255, 241, 15 ) )
			img_cell:addChild( lbl_Lv )
			local lbl_ChaKan = Label:create()
			lbl_ChaKan:setText("[查看战报]")
			lbl_ChaKan:setColor(ccc3(255, 200, 80))
			lbl_ChaKan:setTag(i)
			lbl_ChaKan:setFontSize(20)
			lbl_ChaKan:setPosition(ccp(170, 0))
			lbl_ChaKan:addTouchEventListener( allCellCB )
			img_cell:addChild( lbl_ChaKan )


			    -- local button = Button:create()
	      --       button:setTouchEnabled(true)
	      --       button:setTag( i )
	      --       button:loadTextures("button+104_PK_1.png", "button+104_PK_2.png", "")
	      --       button:setPosition( CCPoint( 170, 0 ) )
	      --       button:addTouchEventListener( allCellCB )
	      --   img_cell:addChild( button )
			_scrollview:addChild( img_cell )
			cell_Y = cell_Y - cell_disY - cell_H
		end
	end
	end

end
	PT.hideWidget( panel_tab[1] )
	PT.hideWidget( panel_tab[2] )
	PT.showWidget( panel_tab[3] )
end
local function _flushShu()

if ifNeedFlash[2] then
	ifNeedFlash[2] = false
	local _scrollview = tolua.cast( curLayer:getWidgetByName("ScrollView_shu"), "ScrollView" )
	_scrollview:setClippingEnabled(true) --裁切窗口
	_scrollview:setBounceEnabled(true) --边缘回弹
	_scrollview:setBackGroundColorType(0)

	--可视区域
	local view_W = _scrollview:getSize().width 
	local view_H = _scrollview:getSize().height

	local cell_disY = 5 
	local cell_W, cell_H = view_W, 65
	local num = 5

	_scrollview:setInnerContainerSize( CCSize(view_W, (cell_H+cell_disY)*num) )

	--滑动区域
	local scroll_W = _scrollview:getInnerContainerSize().width
	local scroll_H = _scrollview:getInnerContainerSize().height

	local cell_X, cell_Y = view_W/2, scroll_H-cell_H/2
	local dataList = nil
	local dataSize = 0
	local function allCellCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
		
			local _btn = tolua.cast(sender, "Button")
			local tag = _btn:getTag()
			local data = dataList[tag]

			local charpterId, npcId, _ = PT.getId()

			protoSend0x0308( data["charId"], charpterId, npcId )
			exitUI()
		end
	end

if ifserver then
	dataList = ReportData.getReport(2)
	dataSize = #dataList
end
	if #dataList ~=0 then
	for i=dataSize, 1, -1 do
		local strlv = nil
		local strname = nil
		local _hava = false
		local charId = 0
		
if ifserver then
	
		local data = dataList[i]
		if data["charId"] ~= 0 then
			_hava = true
			strlv = "Lv: " .. data["lv"]
			strname = data["name"]
		end
else
		_hava = true
		strlv = "Lv: 18"
		strname = "玩家名字"
end

		if _hava then
			local img_cell = ImageView:create()
			img_cell:loadTexture("teamBG3.png")
			img_cell:setScale9Enabled(true)
			img_cell:setSize( CCSize( cell_W, cell_H) )
			img_cell:setPosition(ccp(cell_X,cell_Y))
			img_cell:setVisible(false)
				--国家
				local lbl_Country = Label:create()
				lbl_Country:setText( "【蜀】" )
				lbl_Country:setFontSize( 20 )
				lbl_Country:setPosition( ccp(-220, 0) )
				lbl_Country:setAnchorPoint(ccp(0, 0.5))
				lbl_Country:setColor( ccc3(206, 92, 92 ) )
			img_cell:addChild( lbl_Country )

				local lbl_name = Label:create()
				lbl_name:setText( strname )
				lbl_name:setFontSize( 20 )
				lbl_name:setPosition( ccp(-160, 0) )
				lbl_name:setAnchorPoint(ccp(0, 0.5))
				--lbl_name:setColor( ccc3(255, 241, 15 ) )
			img_cell:addChild( lbl_name )

				local sizeName = lbl_name:getContentSize()
				local lbl_Lv = Label:create()
				lbl_Lv:setText( strlv )
				lbl_Lv:setFontSize( 20 )
				lbl_Lv:setPosition( ccp(-160 + sizeName.width + 10, 0) )
				lbl_Lv:setAnchorPoint(ccp(0, 0.5))
				--lbl_Lv:setColor( ccc3(255, 241, 15 ) )
			img_cell:addChild( lbl_Lv )

			local lbl_ChaKan = Label:create()
			lbl_ChaKan:setText("[查看战报]")
			lbl_ChaKan:setColor(ccc3(255, 200, 80))
			lbl_ChaKan:setTag(i)
			lbl_ChaKan:setFontSize(20)
			lbl_ChaKan:setPosition(ccp(170, 0))
			lbl_ChaKan:addTouchEventListener( allCellCB )
			img_cell:addChild( lbl_ChaKan )


			    -- local button = Button:create()
	      --       button:setTouchEnabled(true)
	      --       button:setTag( i )
	      --       button:loadTextures("button+104_PK_1.png", "button+104_PK_2.png", "")
	      --       button:setPosition( CCPoint( 170, 0 ) )
	      --       button:addTouchEventListener( allCellCB )
	      --   img_cell:addChild( button )
			_scrollview:addChild( img_cell )
			cell_Y = cell_Y - cell_disY - cell_H
		end
	end
	end

end
	PT.hideWidget( panel_tab[3] )
	PT.hideWidget( panel_tab[1] )
	PT.showWidget( panel_tab[2] )
end
local function _flushWei()

if ifNeedFlash[1] then
	ifNeedFlash[1] = false
	local _scrollview = tolua.cast( curLayer:getWidgetByName("ScrollView_wei"), "ScrollView" )
	_scrollview:setClippingEnabled(true) --裁切窗口
	_scrollview:setBounceEnabled(true) --边缘回弹
	_scrollview:setBackGroundColorType(0)

	--可视区域
	local view_W = _scrollview:getSize().width 
	local view_H = _scrollview:getSize().height

	local cell_disY = 5 
	local cell_W, cell_H = view_W, 65
	local num = 5

	_scrollview:setInnerContainerSize( CCSize(view_W, (cell_H+cell_disY)*num) )

	--滑动区域
	local scroll_W = _scrollview:getInnerContainerSize().width
	local scroll_H = _scrollview:getInnerContainerSize().height

	local cell_X, cell_Y = view_W/2, scroll_H-cell_H/2

	local dataList = nil
	local dataSize = 0
	local function allCellCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
		
			local _btn = tolua.cast(sender, "Button")
			local tag = _btn:getTag()
			local data = dataList[tag]
			local charpterId, npcId, _ = PT.getId()
			exitUI()
			protoSend0x0308( data["charId"], charpterId, npcId )
			
		end
	end

if ifserver then
	dataList = ReportData.getReport(1)
	dataSize = #dataList
end
if dataSize ~=0 then	
	for i=dataSize, 1, -1  do
		local strlv = nil
		local strname = nil
		local _hava = false
	
	if ifserver then
		
			local data = dataList[i]
			if data["charId"] ~= 0 then
				_hava = true
				strlv = "Lv: " .. data["lv"]
				strname = data["name"]
			end
	else
			_hava = true
			strlv = "Lv: 18"
			strname = "玩家名字"
	end

		if _hava then
			local img_cell = ImageView:create()
			img_cell:loadTexture("teamBG3.png")
			img_cell:setScale9Enabled(true)
			img_cell:setSize( CCSize( cell_W, cell_H) )
			img_cell:setPosition(ccp(cell_X,cell_Y))
			img_cell:setVisible(false)
				--国家
				local lbl_Country = Label:create()
				lbl_Country:setText( "【魏】" )
				lbl_Country:setFontSize( 20 )
				lbl_Country:setPosition( ccp(-220, 0) )
				lbl_Country:setAnchorPoint(ccp(0, 0.5))
				lbl_Country:setColor( ccc3(98, 140, 225 ) )
			img_cell:addChild( lbl_Country )

				local lbl_name = Label:create()
				lbl_name:setText( strname )
				lbl_name:setFontSize( 20 )
				lbl_name:setPosition( ccp(-160, 0) )
				lbl_name:setAnchorPoint(ccp(0, 0.5))
				--lbl_name:setColor( ccc3(255, 241, 15 ) )
			img_cell:addChild( lbl_name )

				local sizeName = lbl_name:getContentSize()
				local lbl_Lv = Label:create()
				lbl_Lv:setText( strlv )
				lbl_Lv:setFontSize( 20 )
				lbl_Lv:setPosition( ccp(-160 + sizeName.width + 10, 0) )
				lbl_Lv:setAnchorPoint(ccp(0, 0.5))
				--lbl_Lv:setColor( ccc3(255, 241, 15 ) )
			img_cell:addChild( lbl_Lv )
--[[
			    local button = Button:create()
	            button:setTouchEnabled(true)
	            button:setTag( i )
	            button:loadTextures("button+104_PK_1.png", "button+104_PK_2.png", "")
	            button:setPosition( CCPoint( 170, 0 ) )
	            button:addTouchEventListener( allCellCB )
	        img_cell:addChild( button )
--]]
			local lbl_ChaKan = Label:create()
			lbl_ChaKan:setText("[查看战报]")
			lbl_ChaKan:setColor(ccc3(255, 200, 80))
			lbl_ChaKan:setTag(i)
			lbl_ChaKan:setFontSize(20)
			lbl_ChaKan:setPosition(ccp(170, 0))
			lbl_ChaKan:addTouchEventListener( allCellCB )
			img_cell:addChild( lbl_ChaKan )

			_scrollview:addChild( img_cell )
			cell_Y = cell_Y - cell_disY - cell_H
		end	


	end
end

end
	PT.hideWidget( panel_tab[3] )
	PT.hideWidget( panel_tab[2] )
	PT.showWidget( panel_tab[1] )
end
local function initPub()
-----------------------------------------------
	--关闭
	local btn_close = tolua.cast( curLayer:getWidgetByName("Button_close"), "Button" )
	local function btn_closeCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then 
		 
			exitUI()
		end
	end
	btn_close:setTouchEnabled(true)
	btn_close:addTouchEventListener( btn_closeCB )

	--面板切换
	local img_tab = {}
	img_tab[1] = tolua.cast( curLayer:getWidgetByName("ImageView_wei"), "ImageView" )
	img_tab[2] = tolua.cast( curLayer:getWidgetByName("ImageView_shu"), "ImageView" )
	img_tab[3]  = tolua.cast( curLayer:getWidgetByName("ImageView_wu"), "ImageView" )
	
	panel_tab[1] = tolua.cast( curLayer:getWidgetByName("Panel_wei"), "Widget" )
	panel_tab[2] = tolua.cast( curLayer:getWidgetByName("Panel_shu"), "Widget" )
	panel_tab[3] = tolua.cast( curLayer:getWidgetByName("Panel_wu"), "Widget" )

	local function CellTouchCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
		 
			local _img = tolua.cast(sender, "ImageView")
			local tag = _img:getTag()
			img_tab[remIdx]:loadTexture( "button14_tong_2.png" )
			remIdx = tag
			img_tab[remIdx]:loadTexture( "button14_tong_1.png" )
			flushTab[remIdx]()
		end
	end
	for i=1,3 do
	 	img_tab[i]:addTouchEventListener( CellTouchCB )
    	img_tab[i]:setTouchEnabled(true)
    	img_tab[i]:setTag(i)
    end

flushTab[1] = _flushWei
flushTab[2] = _flushShu
flushTab[3] = _flushWu

    remIdx = 1
    img_tab[remIdx]:loadTexture( "button14_tong_1.png" )
    flushTab[remIdx]()

end


function exitUI()
    if curLayer ~= nil and widget ~= nil then
        curLayer:removeWidget(widget)
        --curLayer:clear()
        widget = nil
        curLayer = nil
        
        LM.STATE_4 = 0
    end
	ifNeedFlash[1] = true
	ifNeedFlash[2] = true
	ifNeedFlash[3] = true
end

function enterUI()
    --LM.STATE_4 = 0 --此ui暂无状态记录

    curLayer = LM.getLayer11()
    widget = GUIReader:shareReader():widgetFromJsonFile("FightGonglue.json")

    curLayer:addWidget(widget)
    widget:setTouchEnabled(true)

    initPub()
end

--[[
function exitUI()
	curScene:removeChild(curLayer, true)
	ifNeedFlash[1] = true
	ifNeedFlash[2] = true
	ifNeedFlash[3] = true
end
function enterUI(scene)
	curScene = scene
    local widget = GUIReader:shareReader():widgetFromJsonFile("FightGonglue.json")    
	
	widget:setTouchEnabled(true)
	
	curLayer = TouchGroup:create()
	curLayer:setZOrder(11)
    curLayer:addWidget(widget)
    scene:addChild(curLayer)

    initPub()
end
--]]