module ("MapFight_PaopaoTalk",package.seeall)

local curLayer = nil
local widget = nil
local imageView_paopao=nil
local imageView_head=nil
local EntryID = nil

local mGongjiPos =1
local mByGongjiPos =1
local mChangePos = 1
local mBloodNum = 1

local NowIsMiaoShaQian=false   --true 秒杀前， false秒杀后
local paoTalkData = nil
local mPaoTalkStep = 1

local paoTalkIsOver = true
local _richText=nil
local jiShiTime = 0

recordNpcBeforeZhandouState=1

local whichStylePaoTalk=1 --1秒杀 2 技能



local function paseTT(_str)
    local str2 = _str
    local i, j = string_find(str2 , "~")
    if i ~= nil then
        print("替代 1 。。。")
        str2=string.gsub(str2, "~", "~ ")
    end
    i, j = string_find(str2 , "{")
    if i ~= nil then
        print("替代 2 。。。")
        str2=string.gsub(str2, "{", " { ")
    end
    
    i, j = string_find(str2 , "’")
    if i ~= nil then
        print("替代 3 。。。")
        str2=string.gsub(str2, "’", " ’ ")
    end

    i, j = string_find(str2 , "”")
    if i ~= nil then
        print("替代 4 。。。")
        str2=string.gsub(str2, "”", " ” ")
    end

    i, j = string_find(str2 , ",")
    if i ~= nil then 
        print("替代 5 。。。")
        str2=string.gsub(str2, ",", " , ")
    end

    i, j = string_find(str2 , ":")
    if i ~= nil then
        print("替代 6 。。。")
        str2=string.gsub(str2, ":", " : ")
    end

    i, j = string_find(str2 , "\"")
    if i ~= nil then
        print("替代 7 。。。")
        str2=string.gsub(str2, "\"", " \" ")
    end
--[[            
    --英文的"."有问题
    i, j = string_find(str2 , ".")
    if i ~= nil then
        str2=string.gsub(str2, ".", " . ")
    end
--]]
    return str2
end


local function getIsMiaoShaQian()
     local isMiaoShaQian=false
    --1秒杀前 2秒杀后
        if paoTalkData["paoPaoData"][mPaoTalkStep]["miaoShaState"]==1 then
            isMiaoShaQian=true
            print("============miaosha千")
        else
            print("============miaosha厚")
            isMiaoShaQian=false
        end

        return isMiaoShaQian
end



local function setPaoTalkContent(  )
  
    print("============setPaoTalkContent1")
    if _richText ~= nil then
        --imageView_paopao:removeNodeByTag(112)
        imageView_paopao:removeChild(_richText,true)
        _richText=nil
    end

    _richText = RichText:create()
    _richText:ignoreContentAdaptWithSize(false)
    _richText:setAnchorPoint(ccp(0, 0.5))
    _richText:setSize(CCSizeMake(205, 25))
    _richText:setPosition(ccp(-50,115))

    local function addElement( _str, _typeColor )
        _str = paseTT(_str)
        local _re1 = RichElementText:create(1, ccc3(GoodsColorTab[_typeColor][1], GoodsColorTab[_typeColor][2], GoodsColorTab[_typeColor][3]), 255, _str, "Helvetica", 24);
        _richText:pushBackElement( _re1 )
    end

    local parsestr = nil
    parsestr = function (_str)
        local len = string.len(_str)
        local i, j = string.find(_str , "<")
        if i ~= nil then
            local str1 = string.sub(_str, 1, i-1) --截取<之前的数据
            print(str1)
            addElement(str1, 1)

            _str = string.sub(_str, j+1, len)--截取<之后的数据
            len = string.len(_str)
            i, j = string.find(_str , ":")
            if i == 2 then --: 位置
                local number = tonumber( string.sub(_str, 1, i-1) ) --截取色值索引

                _str = string.sub(_str, j+1, len) --截取:后数据
                len = string.len(_str)
                i, j = string.find(_str , ">")
                if i~= nil then
                    print(number)
                    local str2 = string.sub(_str, 1, i-1) --截取:后>前数据
                    print(str2)
                    --todo:正确的颜色节点
                    addElement( str2, number )
                    _str = string.sub(_str, j+1, len) --截取>后数据
                    --递归解析
                    parsestr(_str )
                else --没有:
                    _str = "<" .. number .. ":" .. _str --恢复数据
                    print("1_error: " .. _str)
                    --todo:普通节点
                    addElement(_str, 1)
                end
            else -- < 尖括号里没有: 把
                _str = "<" .. _str --恢复数据
                print("2_error: " .. _str)
                --todo:普通节点
                addElement(_str, 1)
            end
        else
            print("3_error: " .. _str)
            --todo:普通节点
            addElement(_str, 1)
            print("4_error: " .. _str)
        end
    end     
    local strContext = paoTalkData["paoPaoData"][mPaoTalkStep]["content"]
    print("=======strContext" .. strContext)
    parsestr(strContext)

    local whoPosition=mGongjiPos
    local who =MapFight.allTeamPosition

    if whichStylePaoTalk==1 then
        local mWhichOne = paoTalkData["paoPaoData"][mPaoTalkStep]["miaoShaType"]
        if  mWhichOne==1 then --秒杀者
            whoPosition=mGongjiPos
            who=MapFight.allTeamPosition
        elseif mWhichOne==2 then --被秒杀者
            whoPosition=mByGongjiPos
            who=MapFight.allBossPosition
        else
        end

    elseif whichStylePaoTalk==2 or whichStylePaoTalk==3 then
        local rightorleft= paoTalkData["paoPaoData"][mPaoTalkStep]["rightOrLeft"]
        local mWhichOne = paoTalkData["paoPaoData"][mPaoTalkStep]["miaoShaType"]
        if rightorleft==1 then
            who=MapFight.allTeamPosition
        elseif rightorleft==2 then
            who=MapFight.allBossPosition
        end
        if  mWhichOne==1 then --秒杀者
            whoPosition=mGongjiPos
        elseif mWhichOne==2 then --被秒杀者
            whoPosition=mByGongjiPos
        else
        end 

    end
    
    

    local state,name,lv, bingzhong, zhanfa,nvshen,jeneralId = FormationData.getTipsMessageFrom(whoPosition)
    local jeneralDes = Des.getGeneralDesFromId( jeneralId )
    imageView_head:loadTexture(RoleHeadPath .. jeneralDes["generalHeadIcon"] .. ".png")


    print("=======whoPosition" .. whoPosition)
    if whoPosition > 9 then
        whoPosition = whoPosition - 9
    end

    --imageView_paopao:setPosition(ccp( who[whoPosition]["X"]+10,who[whoPosition]["Y"]+50))
    imageView_paopao:setPosition(ccp( who[whoPosition]["X"]+10,who[whoPosition]["Y"]))

    imageView_paopao:addChild(_richText)




    local action1 =CCMoveBy:create(1,ccp(0,50))

    imageView_paopao:runAction(CCEaseElasticOut:create(action1))



    
end

local function nextStepWillDo()

     mPaoTalkStep=mPaoTalkStep+1
    if mPaoTalkStep > #paoTalkData["paoPaoData"] then
        paoTalkIsOver=true
        if NowIsMiaoShaQian then
            if whichStylePaoTalk==3 then
                MapFight.step2_1()
            else
                MapFight._onePosPlayActionEffect(mGongjiPos, "attack", nil)
                MapFight.step3()
            end
           
        else
            print("=======whpaopao22222222TouchCB")
            MapFight._onePosChangeArmature(mChangePos, false, mBloodNum)
            MapFight.pubStepNextDamageCount()
        end
       
        MapFight.isMiaoShaStop=false
        MapFight.isSkillStop=false
        MapFight.isHadSkillStop=true
        MapFight.isGongJiStop=false
        MapFight.isHadGongJiStop=true

        MapFight.isHadshowPaopao=false

        exitUI()
        return
    else
        paoTalkIsOver=false
        local nextIsMiaoShaQian =getIsMiaoShaQian()
        if NowIsMiaoShaQian==true  and  nextIsMiaoShaQian==false then
           if whichStylePaoTalk==3 then
                MapFight.step2_1()
            else
                MapFight._onePosPlayActionEffect(mGongjiPos, "attack", nil)
                MapFight.step3()
            end
            exitUI()
        else
            setPaoTalkContent()
        end

    end
end


 local function TouchCB(sender, eventType)
       if eventType == PT.ccs.TouchEventType.ended then
           -- local _img = tolua.cast(sender, "ImageView")
            print("=======whpaopao22222222")
            jiShiTime=0
            nextStepWillDo()
        end
end


--schedule更新函数
local function updateCallBack( dt )
	jiShiTime=jiShiTime+1
    if jiShiTime>2 then
        nextStepWillDo()
        jiShiTime=0
    end

end



--_mtype  1为秒杀，2位技能类型 3为特定将领说话
function CheckPaoTalkState(_mtype,_mskillid,_position)
    --print("============miaowhy_mtype" .. _mtype .. "=" .. _mskillid .. "=" .. _position)
    local ifOpenPaoTalk = false --是否出现泡泡对话
    local isStopThisSkill = false
    whichStylePaoTalk=_mtype
    --当前id
    local curCharpterId, curNpcId, _ = PT.getId() --获取当前章节和npcid

    local paoTalkList = Des.getFightPaopaoTalkData()

    
    for i=1, #paoTalkList do
        local data  = paoTalkList[i]
        local openType = data["OpenType"]

        local charpterId = openType["charpterId"]
        local npcId = openType["npcId"]
        local ifHide = openType["charpterType"]--1普通 2隐藏
        local mpaoType = openType["paopaoType"]--泡泡对话类型 1秒杀 2技能 3攻击

        if _mtype==1 then
            if ifHide == 2 and curCharpterId == -1 and curNpcId == npcId and mpaoType==1 then --隐藏npc
                paoTalkData = data
                ifOpenPaoTalk = true
                break
            elseif ifHide == 1 and curCharpterId == charpterId and curNpcId == npcId and mpaoType==1 then --普通npc
                paoTalkData = data
                ifOpenPaoTalk = true
                break
            end

        elseif _mtype==2 then
            if ifHide == 2 and curCharpterId == -1 and curNpcId == npcId and mpaoType==2 then --隐藏npc
                paoTalkData = data
                ifOpenPaoTalk = true
                break
            elseif ifHide == 1 and curCharpterId == charpterId and curNpcId == npcId and mpaoType==2 then --普通npc
                paoTalkData = data
                ifOpenPaoTalk = true
                break
            end
         elseif _mtype==3 then
            if ifHide == 2 and curCharpterId == -1 and curNpcId == npcId and mpaoType==3 then --隐藏npc
                paoTalkData = data
                ifOpenPaoTalk = true
                break
            elseif ifHide == 1 and curCharpterId == charpterId and curNpcId == npcId and mpaoType==3 then --普通npc
                paoTalkData = data
                ifOpenPaoTalk = true
                break
            end

        end

        
    end
   
    if ifOpenPaoTalk == false then --没有对话
        print("============miaosha没配数据")
        return ifOpenPaoTalk
    else
        print("============miaosha配数据" .. paoTalkData["paoPaoData"][1]["miaoShaState"])

        if paoTalkData["OpenType"]["mSkillId"]==_mskillid then
            print("============miaosha包括这个技能")
            if paoTalkData["paoPaoData"][mPaoTalkStep]["rightOrLeft"]==1 and _position<10 then
                isStopThisSkill=true
                print("============miaosha这个技能对上号")
            elseif paoTalkData["paoPaoData"][mPaoTalkStep]["rightOrLeft"]==2 and _position>=10  then
                isStopThisSkill=true
                 print("============miaosha这个技能对上号")
            else
                isStopThisSkill=false
                 print("============miaosha这个技能对不上号")
            end

        else
             print("============miaosha不包括这个技能")
             isStopThisSkill=false
        end


        local mIsQian = getIsMiaoShaQian()

        return ifOpenPaoTalk,mIsQian,isStopThisSkill
    end
    
end





local function initMap()
	
	imageView_paopao= tolua.cast( curLayer:getWidgetByName("ImageView_paopao"), "ImageView" )
    imageView_head = tolua.cast( curLayer:getWidgetByName("ImageView_head"), "ImageView" )
	imageView_paopao:setTouchEnabled(false)

	local scheduler = CCDirector:sharedDirector():getScheduler()      
    EntryID = scheduler:scheduleScriptFunc( updateCallBack, 1.0, false)


    setPaoTalkContent()
   
    
end


function exitUI()
	if curLayer ~= nil and widget ~= nil then
		curLayer:removeWidget(widget)
		widget 		= nil
		curLayer 	= nil

        imageView_paopao=nil
        imageView_head=nil

        isMiaoShaQian=false
        mGongjiPos =1
        mByGongjiPos =1
        mChangePos =1
        mBloodNum =1
        jiShiTime=0
        if paoTalkIsOver then
            mPaoTalkStep=1
        end
	end
	local scheduler = CCDirector:sharedDirector():getScheduler()
    if EntryID ~= nil then
        scheduler:unscheduleScriptEntry(EntryID)
    end
end

function enterUI(_gongJipos,_byGongJipos,_mChangePos,_mBloodNum)
    if paoTalkIsOver then
        mPaoTalkStep=1
    end
    jiShiTime=0
    NowIsMiaoShaQian=getIsMiaoShaQian()

    mGongjiPos =_gongJipos
    mByGongjiPos =_byGongJipos

    mChangePos =_mChangePos
    mBloodNum =_mBloodNum
   
   if _mChangePos then
    print("============miaowhy" .. mGongjiPos .. "=" .. _byGongJipos .. "=" .. _mChangePos .. "=" .. _mBloodNum )

   end
    curLayer =LM.getLayer17()

    widget = GUIReader:shareReader():widgetFromJsonFile("PaoPaoTalkUI_1.json")  

    curLayer:addWidget(widget)
    widget:setTouchEnabled(true)
    widget:addTouchEventListener(TouchCB)

	initMap()
end
