module ("MapFight_Talk",package.seeall)

local ifOpen = false

--需要从外部设置当前章节和npc，以便判断是否开启
local ifNeadCheck = false --是否需要检测有战斗对话
function setCheckstate(state)

	ifNeadCheck = state
end

function enterUI()

	if ifNeadCheck == false then --不需要检测
		print("----------------------A")
		return true
	end
	--当前id
	local curCharpterId, curNpcId, _ = PT.getId() --获取当前章节和npcid

	local talkList = Des.getFightTalkData()
	local talkData = nil
	ifOpen = false
	for i=1, #talkList do
		local data  = talkList[i]
		local openType = data["OpenType"]

		local charpterId = openType["charpterId"]
		local npcId = openType["npcId"]
		local ifHide = openType["charpterType"]--1普通 2隐藏
		if ifHide == 2 and curCharpterId == -1 and curNpcId == npcId then --隐藏npc
			talkData = data
			ifOpen = true
			break
		elseif ifHide == 1 and curCharpterId == charpterId and curNpcId == npcId then --普通npc
			talkData = data
			ifOpen = true
			break
		end
	end

--[[		
		local data_c = {
			["OpenType"] = {
				["charpterId"] = 1,
				["npcId"] = 2,
			},				
			["Name"]={
				[1]="莎莎",
			},
			["BodyIcon"]={
				[1]="106.png",
			},
			["Content"]={
				[1]="1:2:主公，它的本命女神是<5:火属性女神>，当前天气刚好是<5:晴天>，可以造成<6:加强伤害>哦",
			},
		}
--]]	
	if ifOpen == false then --没有对话
		print("----------------------B")
		return true
	end
	guideUI_c.enterUI(nil, talkData, 3)
	
	ifNeadCheck = false

	return false
end

function exitUI()


end