module ("MapPubUI",package.seeall)
local Layer = nil
local widget = nil


local country_img = {"pic87_city_1.png", "pic89_city_1.png", "pic88_city_1.png"}
local img_headBG = nil
local img_junLingBG = nil
local img_zhengZhanCDBG = nil
local img_eventBG = nil
local Button_Event_Btn = nil
local openState_CD = nil
local remCdStateSelf = nil --记录玩家cd时间列表的开启状态

local img_beAtack = nil --被攻击状态图标
--金币
local lbl_jinBi = nil
local LoadBar_jinBi = nil
--银币
local lbl_yinBi = nil
local loadBar_yinBi = nil
--粮草
local lbl_liangCao = nil
local loadBar_liangCao = nil
--军工
local lbl_junGong = nil
local loadBar_junGong = nil
--军令
local lbl_junLing = nil
--玩家名字、vip等级、等级
local lbl_playerName = nil
local lbl_playerLv = nil
local LabelBMFont_playerVip = nil
--所属国家
local img_contry = nil

--玩家战斗力
local img_powerBG = nil
local font_Power = nil


local btn_guoZhan  		= nil
local btn_mail 			= nil
local btn_gongHuiZhan 	= nil
local btn_dayPaiHang 	= nil --每日排行
local btn_kaiFuHuoDong = nil --开服活动
local btn_chongZhiXiaoFei = nil --充值消费
local btn_zhongQiuHuoDong = nil --中秋活动
local btn_guoQingHuoDong = nil --国庆活动
local btn_libao = nil --礼包

local btn_DengLuDaLi = nil --登录大礼
local ifOpenDengLuDaLi = true --是否开启登录大礼特效，开启则关闭特效
local ifChengJiuTan = true --是否开启成就坛
local ifShouChongDaLi = true --是否开启首充大礼

local btn_chengJiuTan 	= nil --成就坛
local btn_ChongZhiHuoDong = nil --充值活动
local btn_ShouChongDaLi = nil --首充大礼

local btn_vip = nil
--local btn_jiangLiPerDay = nil --每日奖励
local btn_LiaoTian = nil
local btn_main =nil
local btn_main_lbl = nil
local btnMainState = false

	local btn_zhengZhan = nil
	local btn_wuJiang 	= nil
	local btn_nvShen 	= nil
	local btn_junTuan 	= nil
	local btn_renWu 	= nil
	local btn_zhuangBei = nil

local openState = true --工程里默认是开启状态
local panel_btn = nil

local btn_panelContrl = nil

local isTanChuGuoJiangLiLayer = false --临时内存中记录一下

local btn_yuXi = nil
local img_yuXi = nil
local panel_yuXi =nil
local lbl_yuXiCd = nil	

isTanchuSysTips = false

function CheckYuXiState()
	if GuoZhanData.getYuXiCd() > 0 then
	--if true then
		btn_yuXi:setVisible(true)
		btn_yuXi:setTouchEnabled(true)

		GuoZhanData.setYuXiLbl(lbl_yuXiCd)
	else
		btn_yuXi:setVisible(false)
		btn_yuXi:setTouchEnabled(false)

		GuoZhanData.setYuXiLbl(nil)
	end

	panel_yuXi:setVisible(false)
	panel_yuXi:setTouchEnabled(false)
--	img_yuXi:setVisible(false)
--	img_yuXi:setTouchEnabled(false)
end

function flushPlayerPower()
	
	font_Power:setText("战斗力 "  .. PlayerData.getPower())
end

--增加上方图标的特效
function addShanGuangEffect(_whichIcon)
	local _armature = ArmatureManager.createArmature(UiEffectPath, "MeiRiDengLuEffect", 1)
	_armature:getAnimation():playWithIndex(0,-1, -1, -1)
	_armature:setAnchorPoint(ccp(0.5, 0.5))
	
	if _whichIcon==1 and ifOpenDengLuDaLi then
		if  btn_DengLuDaLi:getNodeByTag(10) == nil then
			_armature:setTag(10)
			
			local node = btn_DengLuDaLi:getNodeByTag(10) 
			if node == nil then --检查是否添加过
				btn_DengLuDaLi:addNode( _armature )
			end
		end
	elseif _whichIcon==2 and ifChengJiuTan then
		if  btn_chengJiuTan:getNodeByTag(11) == nil then
			_armature:setTag(11)
			local node = btn_chengJiuTan:getNodeByTag(11) 
			if node == nil then --检查是否添加过
				btn_chengJiuTan:addNode( _armature )
			end
		end
	elseif _whichIcon==3 and ( ifShouChongDaLi or PlayerData.getShouChongState()==1 ) then
		if  btn_ShouChongDaLi:getNodeByTag(12) == nil then
			_armature:setTag(12)
			local node = btn_ShouChongDaLi:getNodeByTag(12) 
			if node == nil then --检查是否添加过
				btn_ShouChongDaLi:addNode( _armature )
			end
		end
	end
end

--检测是否加入小红点在消费充值上
function checkIfRedPointOnXiaoFeiChongZhi()
	if LM.STATE_9 == 1 then
		local ifneed = HuoDongData.ChongZhiXiaoFei_ifRedPoint(3)
		if ifneed then --需要显示
			local _Img = tolua.cast( btn_chongZhiXiaoFei:getChildByTag(10), "ImageView" ) 
			if _Img == nil then
				local img_point = ImageView:create()
				img_point:loadTexture("floor+60_tong.png")
				img_point:setTag(10)
				img_point:setPosition(ccp(-35,35))
				btn_chongZhiXiaoFei:addChild(img_point)
			end
		else -- 移除
			local _Img = tolua.cast( btn_chongZhiXiaoFei:getChildByTag(10), "ImageView" ) 
			if _Img ~= nil then
				btn_chongZhiXiaoFei:removeChildByTag(10, true)
			end
		end
	end

end
--检测是否加入小红点在活动图标上
function checkIfRedPointOnHD()
	if LM.STATE_9 == 1 then
		local ifneed = HuoDongData.CheackAllHD_ifRedPoint()
		if ifneed then --需要显示
			local _Img = tolua.cast( btn_kaiFuHuoDong:getChildByTag(10), "ImageView" ) 
			if _Img == nil then
				local img_point = ImageView:create()
				img_point:loadTexture("floor+60_tong.png")
				img_point:setTag(10)
				img_point:setPosition(ccp(-35,35))
				btn_kaiFuHuoDong:addChild(img_point)
			end
		else -- 移除
			local _Img = tolua.cast( btn_kaiFuHuoDong:getChildByTag(10), "ImageView" ) 
			if _Img ~= nil then
				btn_kaiFuHuoDong:removeChildByTag(10, true)
			end
		end
	end

end

--监测是否加入小红点提示在邮件图标上
function checkIfRedPointOnMail()
	if LM.STATE_9 == 1 then
		local ifneed = MailListData.getIfViewRedPoint()
		if ifneed then --需要显示
			local _Img = tolua.cast( btn_mail:getChildByTag(10), "ImageView" ) 
			if _Img == nil then
				local img_point = ImageView:create()
				img_point:loadTexture("floor+60_tong.png")
				img_point:setTag(10)
				img_point:setPosition(ccp(-15,10))
				btn_mail:addChild(img_point)
			end
		else -- 移除
			local _Img = tolua.cast( btn_mail:getChildByTag(10), "ImageView" ) 
			if _Img ~= nil then
				btn_mail:removeChildByTag(10, true)
			end
		end
	end
end
--监测是否有小红点在聊天上
function checkIfRedPointOnTalk(ifneed)
	if LM.STATE_9 == 1 then
		if ifneed then --需要显示
			local _Img = tolua.cast( btn_LiaoTian:getChildByTag(10), "ImageView" ) 
			if _Img == nil then
				local img_point = ImageView:create()
				img_point:loadTexture("floor+60_tong.png")
				img_point:setTag(10)
				img_point:setPosition(ccp(10,10))
				btn_LiaoTian:addChild(img_point)
			end
		else -- 移除
			local _Img = tolua.cast( btn_LiaoTian:getChildByTag(10), "ImageView" ) 
			if _Img ~= nil then
				btn_LiaoTian:removeChildByTag(10, true)
			end
		end
	end
end
--检测小红点在任务上
function checkIfRedPointOnTask()
	if LM.STATE_9 == 1 then
		--检测主线任务
		local ifneed = TaskMainData.checkIfNeedRedPoint()
		if ifneed == false then
			ifneed = TaskDailyData.checkIfRedPoint()
		end
		--todo检测支线任务
		if ifneed then
			local _Img = tolua.cast( btn_renWu:getChildByTag(10), "ImageView" ) 
			if _Img == nil then
				local img_point = ImageView:create()
				img_point:loadTexture("floor+60_tong.png")
				img_point:setTag(10)
				img_point:setPosition(ccp(-35,35))

				btn_renWu:addChild(img_point)
			end
		else
			local _Img = tolua.cast( btn_renWu:getChildByTag(10), "ImageView" ) 
			if _Img ~= nil then
				btn_renWu:removeChildByTag(10, true)
			end
		end
	end
end
--检测小红点在事件按钮
function checkIfRedPointOnEvent()
	if LM.STATE_9 == 1 then
		
		local ifneed = false
		if ifneed == false then --建筑队列
			ifneed = BuilderData.checkBuilderIfBeUse()
		end
		if ifneed == false then --突飞
			ifneed = PlayerData.checkTuFeiIfBeUse()
		end
		if ifneed == false then --征收
			ifneed = LevyData.checkLevyIfBeUse()
		end
		if ifneed == false then --背包强化
			ifneed = BagData.checkBagQHIfBeUse()
		end
		if ifneed == false then
			ifneed = DelegateData.checkDelegateIfBeUse()
		end

		if ifneed then
			local _Img = tolua.cast( Button_Event_Btn:getChildByTag(10), "ImageView" ) 
			if _Img == nil then
				local img_point = ImageView:create()
				img_point:loadTexture("floor+60_tong.png")
				img_point:setTag(10)
				img_point:setPosition(ccp(25,50))

				Button_Event_Btn:addChild(img_point)
			end
		else
			local _Img = tolua.cast( Button_Event_Btn:getChildByTag(10), "ImageView" ) 
			if _Img ~= nil then
				Button_Event_Btn:removeChildByTag(10, true)
			end
		end

	end
end
--设置右侧边栏菜单开启状态 true 开启 false 关闭
function setPanelBtnState(state)
	local posx, _ = panel_btn:getPosition()
	if state then
		openState = true
		panel_btn:setPosition( ccp(posx, UseH-530+80)  )
		--panel_btn:setPosition( ccp(posx, UseH-530)  )
		btn_panelContrl:loadTextures("button91_city_1.png", "button91_city_1.png", "")
	else
		openState = false
		panel_btn:setPosition( ccp(posx, UseH-530+680+80)  )
		btn_panelContrl:loadTextures("button91_city_2.png", "button91_city_2.png", "")
	end
end

function flushJinBi(_new)
	lbl_jinBi:setText(PT.parseNum(_new))
end
function flushJunGong(_new)
	lbl_junGong:setText(PT.parseNum(_new))
end
function setMainBtn()
	if LM.STATE_1 == UI_ZhuCheng and LM.STATE_9 == 1 then
		btnMainState = true
		--btn_main:loadTextures("button99_city_1.png", "button99_city_2.png", "")
		btn_main_lbl:setText("前往世界")
	elseif LM.STATE_1 == UI_ShiJie and LM.STATE_9 == 1 then
		btnMainState = false   
		--btn_main:loadTextures("button100_city_1.png", "button100_city_2.png", "")
		btn_main_lbl:setText("前往主城")
	end
end
local ifHeadvisible = false --左上角图标的显示状态，true，显示，false 隐藏
function refreshBtn()
	print("刷新按钮")
	local openHengButton={}
	local btnTable1={
		{ ["id"]=3,	["btn"] = btn_zhengZhan },
		{ ["id"]=4,	["btn"] = btn_wuJiang 	},
		{ ["id"]=11,["btn"] = btn_zhuangBei },
		{ ["id"]=16,["btn"] = btn_nvShen  	},
		{ ["id"]=19,["btn"] = btn_junTuan 	},
		--{["id"]=20,["btn"]=btn_renWu},	
	}
	for i=1, #btnTable1 do
		PT.hideManyBtn(openHengButton,btnTable1[i]["id"],btnTable1[i]["btn"])
	end
	local btnWidth=btn_junTuan:getSize().width
	local btnHeight=btn_junTuan:getSize().height
	--local _heng=panel_heng:getSize().width
	print("num  = " .. #openHengButton)
	for i=1,#openHengButton do
		openHengButton[i]:setPosition(ccp(35,340-90*(i-1)) )
		openHengButton[i]:setTouchEnabled(true)
		openHengButton[i]:setVisible(true)
	end


	if ifJunTuanZhan then
		checkHuoDongIfOpen()
	end


end

--银币粮草军令有上限
function flushYinBi()
	---[[
	local curNum = PlayerData.getZeny()
	local maxNum = PlayerData.getZenyLim()
	if curNum > maxNum then --变红
		loadBar_yinBi:loadTexture("pic90_city_2.png")
		lbl_yinBi:setColor( ccc3(243, 7, 11) )
		loadBar_yinBi:setPercent(100)
		
	else
		local per = curNum/maxNum*100
		loadBar_yinBi:loadTexture("pic90_city_1.png")
		lbl_yinBi:setColor( ccc3(240, 195, 55) )
		loadBar_yinBi:setPercent( per )
		
	end
--[[
	local str = ""
	local cur,_ = math_modf(curNum/10000)
	if cur >= 1 then
		str = cur .. "万/"
	else
		str = curNum .. "/"
	end 
	cur,_ =  math_modf(maxNum/10000)
	if cur >= 1 then
		str = str .. cur .. "万"
	else
		str = str .. maxNum
	end
--]]
	lbl_yinBi:setText( PT.parseNum(curNum) )
	--]]
end
function flushLiang()
	---[[
	local curNum = FoodData.getProvition()
	local maxNum = FoodData.getProvitionLim()
	if curNum > maxNum then --变红
		loadBar_liangCao:loadTexture("pic90_city_2.png")
		lbl_liangCao:setColor( ccc3(243, 7, 11) )
		loadBar_liangCao:setPercent(100)
	else
		loadBar_liangCao:loadTexture("pic90_city_1.png")
		lbl_liangCao:setColor( ccc3(240, 195, 55) )
		loadBar_liangCao:setPercent(curNum/maxNum*100)
	end
--[[
	local str = ""
	local cur,_ = math_modf(curNum/10000)
	if cur >= 1 then
		str = cur .. "万/"
	else
		str = curNum .. "/"
	end 
	cur,_ =  math_modf(maxNum/10000)
	if cur >= 1 then
		str = str .. cur .. "万"
	else
		str = str .. maxNum
	end
--]]
	lbl_liangCao:setText( PT.parseNum(curNum) )
	--]]
end
function flushJunling()
	---[[
	local curNum = PlayerData.getOrders()
	local maxNum = PlayerData.getOrdersLim()
	if curNum > maxNum then --变红
		lbl_junLing:setColor( ccc3(243, 7, 11) )
	else
		lbl_junLing:setColor( ccc3(240, 195, 55) )
	end
	local str = curNum .. "/" .. maxNum
	lbl_junLing:setText(str)
	--]]
end
function flushBeAtack()
	local state = PlayerData.getIfBeAtack()
	if state then
		if img_headBG:getNodeByTag(100) ~= nil then
			img_headBG:removeNodeByTag(100)
		end
		local _armature = ArmatureManager.createArmature(UiEffectPath, "UI_beAtack", 1)
		_armature:getAnimation():playWithIndex(0,-1, -1, -1)
		_armature:setTag(100)
		_armature:setPosition( ccp(-90,40) )
		img_headBG:addNode(_armature)
		--img_beAtack:setVisible(true)
	else
		if img_headBG:getNodeByTag(100) ~= nil then
			img_headBG:removeNodeByTag(100)
		end
		--img_beAtack:setVisible(false)
	end
end
function flushname()
	lbl_playerName:setText(PlayerData.getName())
end
function flushCountry()
	local camp = PlayerData.getCamp()
	print("国家 ==== " .. camp)
	if camp ~= 4 then --没有国家是4
		img_contry:loadTexture( country_img[camp+1] )
	else
		img_contry:loadTexture("")
	end
end
function flushLv(_new)
	local str = "LV " .. _new
	lbl_playerLv:setText(str)
end
function flushVipLv(_new)
	---[[
	local str = "VIP" .. _new
	LabelBMFont_playerVip:setText(str)
	--]]
end
function clearAllMainLable(  )
	-- body
	BuilderData.clearAllLable()
	PlayerData.clearPubUITuFeiCDLable()
	PlayerData.clearZhengZhanCDLable()
	LevyData.clearPubLableButton()
	BagData.clearPubQiangHuaCDLable()
	DelegateData.clearPubLabelButton()
end
--监测左上角活动是否开启
function checkHuoDongIfOpen()

	if ifHeadvisible then

		local openBtn={}
		local btnTable={}
		--[[
		{

			{["id"]=34,["btn"]=btn_guoZhan},
			{["id"]=35,["btn"]=btn_gongHuiZhan},
			{["id"]=38,["btn"]=btn_dayPaiHang},
			--{["id"]=39,["btn"]=btn_kaiFuHuoDong},
		}
		]]
		--任务
		--table_insert( btnTable, {["id"]=20,["btn"]=btn_renWu} )
		--国战
		if ifGuoZhan then
			
			--if GuoZhanData.getIsStartGuoZhan() and CityData.canOpenFuncByIndex(34) then
				--玩家开启此功能，并且现在国战是开始状态
				table_insert( btnTable, {["id"]=34,["btn"]=btn_guoZhan} )
				
			--else
			--	btn_guoZhan:setVisible(false)
			--	btn_guoZhan:setTouchEnabled(false)	
			--end
		end
		--军团战
		if ifJunTuanZhan  then
			if CityData.canOpenFuncByIndex(35)==3 or CityData.canOpenFuncByIndex(35)==1 then
				table_insert( btnTable, {["id"]=35,["btn"]=btn_gongHuiZhan} )
				print("wwwwwww===3")
			end
		end

		--每日排行
		--table_insert( btnTable, {["id"]=38,["btn"]=btn_dayPaiHang} )

		--开服活动
		table_insert( btnTable, {["id"]=39,["btn"]=btn_kaiFuHuoDong} )

		for i=1, #btnTable do
			print("---i = " .. i)
			PT.hideManyBtn(openBtn,btnTable[i]["id"],btnTable[i]["btn"])
		end

---[[		
		--[[
		--每日登录
		if MeiRiDengLuJLData.ifOpenMeiRiDengLuJiangLi() and CityData.canOpenFuncByIndex(40) then --开启每日登陆奖励
			btn_DengLuDaLi:setVisible(true)
			btn_DengLuDaLi:setTouchEnabled(true)
			table_insert(openBtn, btn_DengLuDaLi)
			print("wwwwwww===4")

			addShanGuangEffect(1)
		else
			btn_DengLuDaLi:setVisible(false)
			btn_DengLuDaLi:setTouchEnabled(false)
		end
		--]]
		--成就坛
		--[[
		if ChengJiuData.ifOpenChengJiuTan() and CityData.canOpenFuncByIndex(41) then --开启成就坛
			btn_chengJiuTan:setVisible(true)
			btn_chengJiuTan:setTouchEnabled(true)
			table_insert(openBtn, btn_chengJiuTan)
			print("wwwwwww===5")

			addShanGuangEffect(2)
		else
			btn_chengJiuTan:setVisible(false)
			btn_chengJiuTan:setTouchEnabled(false)
		end
		--]]
		--首冲大礼
		if PlayerData.getShouChongState() ~= 2 and CityData.canOpenFuncByIndex(42) then --没有领取
			btn_ShouChongDaLi:setVisible(true)
			btn_ShouChongDaLi:setTouchEnabled(true)
			table_insert(openBtn, btn_ShouChongDaLi)

			addShanGuangEffect(3)
		else
			btn_ShouChongDaLi:setVisible(false)
			btn_ShouChongDaLi:setTouchEnabled(false)
		end

		--充值活动礼包
		if CityData.canOpenFuncByIndex(47) then
			btn_ChongZhiHuoDong:setVisible(true)
			btn_ChongZhiHuoDong:setTouchEnabled(true)
			table_insert(openBtn, btn_ChongZhiHuoDong)
		else
			btn_ChongZhiHuoDong:setVisible(false)
			btn_ChongZhiHuoDong:setTouchEnabled(false)
		end
				
		
		--开服活动
		--table_insert(openBtn, btn_kaiFuHuoDong)
		--中秋活动
		if CityData.canOpenFuncByIndex(49) then
			btn_zhongQiuHuoDong:setVisible(true)
			btn_zhongQiuHuoDong:setTouchEnabled(true)
			table_insert(openBtn, btn_zhongQiuHuoDong)
		else
			btn_zhongQiuHuoDong:setVisible(false)
			btn_zhongQiuHuoDong:setTouchEnabled(false)
		end
		
		--国庆活动
		if CityData.canOpenFuncByIndex(50) then
			btn_guoQingHuoDong:setVisible(true)
			btn_guoQingHuoDong:setTouchEnabled(true)
			table_insert(openBtn, btn_guoQingHuoDong)
		else
			btn_guoQingHuoDong:setVisible(false)
			btn_guoQingHuoDong:setTouchEnabled(false)
		end
		--充值消费活动
		if HuoDongData.checkIfPubUiOpen() then
			table_insert(openBtn, btn_chongZhiXiaoFei)
		end
--]]

		for i=1,#openBtn do
			openBtn[i]:setPosition( ccp(340+34+90*(i-1), UseH-110) )
			openBtn[i]:setVisible(true)
			openBtn[i]:setTouchEnabled(true)
		end
	end
end
--设置cd时间列表的开启状态
function setCDEventPubVisible(_state)
	if _state then
		--cd列表隐藏设为关闭状态
	    img_eventBG:setPosition( ccp(135, 261) )
	    Button_Event_Btn:loadTextures("pic92_city_2.png","pic92_city_2.png","")
	    openState_CD = _state 
	else
		--cd列表隐藏设为关闭状态
	    img_eventBG:setPosition( ccp(-135, 261) )
	    Button_Event_Btn:loadTextures("pic92_city_1.png","pic92_city_1.png","")
	    openState_CD = _state 
	end
end

function setPubVisible(_state)
	if LM.STATE_9 == 1 then
		if _state then
			if LM.STATE_2 == 0 then
				ifHeadvisible = true
				img_headBG:setVisible(true)
				img_eventBG:setVisible(true)
				img_junLingBG:setVisible(true)
				img_powerBG:setVisible(true)

				btn_mail:setVisible(true) 	
				btn_mail:setTouchEnabled(true) 
				btn_libao:setVisible(true)
				btn_libao:setTouchEnabled(true)
				checkHuoDongIfOpen()

				if ifJunTuanZhan then
					if CityData.canOpenFuncByIndex(35)==3 or CityData.canOpenFuncByIndex(35)==1 then
						btn_gongHuiZhan:setVisible(true) 
						btn_gongHuiZhan:setTouchEnabled(true)
					end
				else
					btn_gongHuiZhan:setVisible(false) 
					btn_gongHuiZhan:setTouchEnabled(false)
				end
---[[
				if CityData.canOpenFuncByIndex(38) then
					btn_dayPaiHang:setVisible(true)
					btn_dayPaiHang:setTouchEnabled(true) 
				end
				if CityData.canOpenFuncByIndex(20) then
					btn_renWu:setVisible(true)
					btn_renWu:setTouchEnabled(true)
				end

				if ChengJiuData.ifOpenChengJiuTan() and CityData.canOpenFuncByIndex(41) then
					btn_chengJiuTan:setVisible(true)
					btn_chengJiuTan:setTouchEnabled(true)
				end
--]]				


				if HuoDongData.checkIfPubUiOpen() then
					btn_chongZhiXiaoFei:setVisible(true)
					btn_chongZhiXiaoFei:setTouchEnabled(true)
				end


				-- if MeiRiDengLuJLData.ifOpenMeiRiDengLuJiangLi() then --开启每日登陆奖励
				-- 	btn_DengLuDaLi:setVisible(true)
				-- 	btn_DengLuDaLi:setTouchEnabled(true)

				-- else
				-- 	btn_DengLuDaLi:setVisible(false)
				-- 	btn_DengLuDaLi:setTouchEnabled(false)
				-- end

				CheckYuXiState()

				img_headBG:setTouchEnabled(true)
				img_eventBG:setTouchEnabled(true)
				img_junLingBG:setTouchEnabled(true)

				--if PlayerData.getBeatCD() > 0 then
					img_zhengZhanCDBG:setVisible(true)
					img_zhengZhanCDBG:setTouchEnabled(true)
				--[[
				else
					img_zhengZhanCDBG:setVisible(false)
					img_zhengZhanCDBG:setTouchEnabled(false)
				end
				--]]
				
				--btn_jiangLiPerDay:setTouchEnabled(true)

				btn_vip:setTouchEnabled(true)

				setCDEventPubVisible(remCdStateSelf)
			end
		else
			ifHeadvisible = false
			img_headBG:setVisible(false)
			img_eventBG:setVisible(false)
			img_junLingBG:setVisible(false)
			img_zhengZhanCDBG:setVisible(false)
			img_powerBG:setVisible(false)

			btn_yuXi:setVisible(false)
			btn_yuXi:setTouchEnabled(false)
			
			btn_mail:setVisible(false) 
			btn_gongHuiZhan:setVisible(false) 
			btn_dayPaiHang:setVisible(false)
			btn_kaiFuHuoDong:setVisible(false)
			
			btn_zhongQiuHuoDong:setVisible(false)
			btn_guoQingHuoDong:setVisible(false)
			btn_libao:setVisible(false)
			btn_chongZhiXiaoFei:setVisible(false)
			btn_DengLuDaLi:setVisible(false)

			btn_chengJiuTan:setVisible(false)
			btn_ChongZhiHuoDong:setVisible(false)
			btn_ShouChongDaLi:setVisible(false)
			btn_renWu:setVisible(false)

			img_headBG:setTouchEnabled(false)
			img_eventBG:setTouchEnabled(false)
			img_junLingBG:setTouchEnabled(false)
			
			img_zhengZhanCDBG:setTouchEnabled(false)
			btn_guoZhan:setVisible(false) 
			btn_guoZhan:setTouchEnabled(false) 
			btn_mail:setTouchEnabled(false) 
			btn_gongHuiZhan:setTouchEnabled(false)
			btn_dayPaiHang:setTouchEnabled(false) 
			btn_kaiFuHuoDong:setTouchEnabled(false)
			btn_chongZhiXiaoFei:setTouchEnabled(false)
			btn_zhongQiuHuoDong:setTouchEnabled(false)
			btn_guoQingHuoDong:setTouchEnabled(false)
			btn_libao:setTouchEnabled(false)

			btn_DengLuDaLi:setTouchEnabled(false)

			btn_chengJiuTan:setTouchEnabled(false)
			btn_ChongZhiHuoDong:setTouchEnabled(false)
			btn_ShouChongDaLi:setTouchEnabled(false)
			btn_renWu:setTouchEnabled(false)
			btn_vip:setTouchEnabled(false)



	    	setCDEventPubVisible(false)
		end
	end
end

--初始化事件列表
function initEventScrollView()
	local _scrollview = tolua.cast( Layer:getWidgetByName("ScrollView_3922"), "ScrollView" )
	_scrollview:setClippingEnabled(true) --裁切窗口
	_scrollview:setBounceEnabled(true) --边缘回弹
	_scrollview:removeAllChildren()
	_scrollview:setBackGroundColorType(0)
	--[[
	local lbl_ZhengZhantittle =tolua.cast( Layer:getWidgetByName("Label_ZhengZhantittle"), "Label" )
	local lbl_ZhengZhancontent =tolua.cast( Layer:getWidgetByName("Label_ZhengZhancontent"), "Label" )
	local btn_clearZZCD=tolua.cast( Layer:getWidgetByName("Button_clearZZCD"), "Button" )	
	btn_clearZZCD:setScale(0.8)
	btn_clearZZCD:setPosition(ccp(75,0))
	PlayerData.setZhengZhanCDLable(lbl_ZhengZhancontent,btn_clearZZCD)
	btn_clearZZCD:setTag(41)
	lbl_ZhengZhancontent:setTag(41)
	--]]
	local cell_disY = 1
	--可视区域
	_scrollview:setSize(CCSize(263, 268))
	local view_W = _scrollview:getSize().width 
	local view_H = _scrollview:getSize().height 

	local cell_H = 28
	local cell_X, cell_Y = 5, view_H-cell_H/2
	

local TYPE = 1
local ID = 0

	------建造队列----------------
if ifserver then
	--建造队列
	local BuilderNum = BuilderData.getBuilderNum()
	--训练位队列
	local TuFeiNum = 1
	--征收CD
	local ZhengShouNum = 1
	--征战cd
	local ZhengZhanNum = 1
	--强化cd
	local QiangHuaNum = 1
	--委派cd
	local WeiPaiNum = 1
	--购买建筑队伍
	local BuyBuilderNum = 1

	local totalNum = BuilderNum +  TuFeiNum + ZhengShouNum + QiangHuaNum + WeiPaiNum + BuyBuilderNum 

	if totalNum > 8 then
		local _h = totalNum*cell_H+20
		_scrollview:setInnerContainerSize( CCSize(view_W, _h) )
		cell_Y = _h-cell_H/2-10
	end

	local function touchEvent(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then 
			RW_guide.exitUI()--退出任务引导
			local _btn = sender--tolua.cast(sender, "Button")
			local _tag = _btn:getTag()
			local _type = string.sub(_tag, 1,1)
			local _id = string.sub(_tag, 2)
			local data = CdData.CreatEnumTable()
			
			--print("_type == " .. _type)
			--print("touchEvent cd == " .. cd)
			if _type == "1" then --建造队列清楚
				print("_type == " .. _type)
				local cd = CdData.getcheckbuildingcd()
				if cd == 0 then
					protoSend0x0420(_id)	
				else
					protoSend0x0422(_id)
				end
			elseif _type == "2" then
				print("_type == " .. _type)
				local cd = CdData.getchecktufeicd()
				if cd == 0 then
					protoSend0x0420(data.Tufei)
				else
					protoSend0x0422(data.Tufei)
				end
			elseif _type == "3" then
				local cd = CdData.getchecklevycd()
				if cd == 0 then
					protoSend0x0420(data.Levy)
				else
					protoSend0x0422(data.Levy)
				end
			elseif _type == "4" then
				local cd = CdData.getcheckbeatcd()
				if cd == 0 then
					protoSend0x0420(data.Beat)
				else
					protoSend0x0422(data.Beat)
				end
			elseif _type == "5" then
				local cd = CdData.getcheckstrongcd()
				if cd == 0 then
					protoSend0x0420(data.Strong)
				else
					protoSend0x0422(data.Strong)
				end
			elseif _type == "6"then
				print("_type == 6")
                local cd = CdData.CreatEnumTable()
                local if_save = CdData.getcheckdelegatecd()
                if if_save == 0 then
                    protoSend0x0420(cd.Delegate)
                else
                    protoSend0x0422(cd.Delegate)
                end
			elseif _type == "7" then
				print("_type == 7")
				if CdData.getbuybuilder() == 0 then
						protoSend0x0230(2)
					else
						protoSend0x0232(2)
					end
			end
		end
	end
	--lbl_ZhengZhancontent:setTouchEnabled(true)
	--lbl_ZhengZhancontent:addTouchEventListener(touchEvent)
	--btn_clearZZCD:addTouchEventListener(touchEvent)


	for i=1, totalNum do
		local data = nil
		local str = nil
		local ifAddRedPoint = false --是否添加小红点
		if i <= BuilderNum then --建造队列
				TYPE = 1
				data = BuilderData.getBuilderDataFromIndex(i)
				ID = data["Idx"]
				str = "建设" .. i .. ": "
				ifAddRedPoint = true
		elseif i <= BuilderNum + TuFeiNum then --突飞
				TYPE = 2
				ID = 0
				str = "突  飞: "
				ifAddRedPoint = true
		elseif i <= BuilderNum + TuFeiNum + ZhengShouNum then
				TYPE = 3
				ID = 0
				str = "征  收: "
				ifAddRedPoint = true
		--[[elseif i <= BuilderNum + TuFeiNum + ZhengShouNum + ZhengZhanNum then
				TYPE = 4
				ID = 0
				str = "征  战: "
				--]]
		elseif i <= BuilderNum + TuFeiNum + ZhengShouNum + QiangHuaNum then
				TYPE = 5
				ID = 0
				str = "强  化: "
				ifAddRedPoint = true
		elseif i <=  BuilderNum + TuFeiNum + ZhengShouNum + QiangHuaNum + WeiPaiNum then
				TYPE = 6
				ID = 0
				str = "委  派: "
				ifAddRedPoint = true
		elseif i<= totalNum and BuilderNum < 8 then
				TYPE = 7
				ID = 0
				str = "点击购买建筑队列"
				
		end

		local img_point = nil --小红点

	    local imageView = ImageView:create()
	    imageView:setScale(0.9)
	    imageView:loadTexture("button+5_public_1.png")
	    imageView:setAnchorPoint( CCPoint(0,0.5) )
	    imageView:setPosition(CCPoint(cell_X, cell_Y))
	    _scrollview:addChild(imageView)

	    local size = imageView:getSize()
	    cell_X = cell_X+size.width

	   	local _lblName = Label:create()

	   	_lblName:setText(str)
	   	_lblName:setAnchorPoint( CCPoint(0, 0.5) )
	   	_lblName:setFontSize(23)
	   	_lblName:setPosition(CCPoint(cell_X, cell_Y))
	   		if ifAddRedPoint then
	   			img_point = ImageView:create()
				img_point:loadTexture("floor+60_tong.png")
				img_point:setTag(10)
				img_point:setPosition(ccp(0,9))
				
				_lblName:addChild(img_point)
			end
	   	_scrollview:addChild( _lblName )

	   	size = _lblName:getSize()
	   	cell_X = cell_X+size.width
	   	print("Type == " .. TYPE)
	   	if TYPE <= 6 then
		   	local _lblContent = Label:create()
		   	_lblContent:setText("00:00:00")
		   	_lblContent:setFontSize(23)
		   	_lblContent:setAnchorPoint( CCPoint(0, 0.5) )
		   	_lblContent:setPosition(CCPoint(cell_X, cell_Y))
		   	_lblContent:setTouchEnabled(true)
		   	_lblContent:setTag( TYPE .. ID  )
		    _lblContent:addTouchEventListener(touchEvent)
		   	_scrollview:addChild( _lblContent )
		   	
		   	size = _lblContent:getSize()
		   	cell_X = cell_X+size.width
			local btn_clear = Button:create()
		    btn_clear:setTouchEnabled(true)
		    btn_clear:setScale(0.7)
		    btn_clear:setAnchorPoint( CCPoint(0, 0.5) )
		    btn_clear:loadTextures("floor+9_bag.png", "floor+11_bag.png", "")
		    btn_clear:setPosition( CCPoint( cell_X, cell_Y ) )
		    btn_clear:setTag( TYPE .. ID  )
		    btn_clear:addTouchEventListener(touchEvent)
		   	_scrollview:addChild(btn_clear)  
		   	if i <= BuilderNum then --建造队列
	   			BuilderData.setLableButtonFromId( ID,  _lblContent, btn_clear, img_point )
			elseif i <= BuilderNum + TuFeiNum then --训练位突飞
				PlayerData.setPubUITuFeiCDLable( _lblContent, btn_clear, img_point )
			elseif i <= BuilderNum + TuFeiNum + ZhengShouNum then  --征收
				LevyData.setPubLableButton( _lblContent, btn_clear, img_point )
			--[[
			elseif i <= BuilderNum + TuFeiNum + ZhengShouNum + ZhengZhanNum then
				PlayerData.setZhengZhanCDLable( _lblContent, btn_clear )
			--]]
			elseif i <= BuilderNum + TuFeiNum + ZhengShouNum + QiangHuaNum then --强化
				BagData.setPubQiangHuaCDLable( _lblContent, btn_clear, img_point )
			elseif i <= BuilderNum + TuFeiNum + ZhengShouNum + QiangHuaNum + WeiPaiNum then --委派
				DelegateData.setPublableButton(_lblContent, btn_clear, img_point)
			end
	   	else
	   		_lblName:setTouchEnabled(true)
	   		_lblName:setTag( TYPE .. ID  )
	   		_lblName:addTouchEventListener(touchEvent)
	   	end	
		cell_Y = cell_Y - cell_H
		cell_X = 5
	end
end
end


local function initpub()
	btn_main = tolua.cast( Layer:getWidgetByName("Button_main"), "Button" )
	btn_main_lbl = tolua.cast( Layer:getWidgetByName("Label_des"), "Label" )
	btnMainState = true

	btn_zhengZhan = tolua.cast( Layer:getWidgetByName("Button_zhengZhan"), "Button" )
	btn_wuJiang 	= tolua.cast( Layer:getWidgetByName("Button_wuJiang"), "Button" )
	btn_nvShen 	= tolua.cast( Layer:getWidgetByName("Button_nvShen"), "Button" )
	btn_junTuan 	= tolua.cast( Layer:getWidgetByName("Button_junTuan"), "Button" )
	btn_renWu 	= tolua.cast( Layer:getWidgetByName("Button_renWu"), "Button" )
	btn_zhuangBei = tolua.cast( Layer:getWidgetByName("Button_zhuangBei"), "Button" )

	btn_LiaoTian = tolua.cast( Layer:getWidgetByName("Button_talk"), "Button" )
	
	btn_guoZhan 		= tolua.cast( Layer:getWidgetByName("Button_guoZhan"), "Button" )
	btn_mail 			= tolua.cast( Layer:getWidgetByName("Button_youJian"), "Button" )
	btn_gongHuiZhan 	= tolua.cast( Layer:getWidgetByName("Button_gongHuiZhan"), "Button" )
	btn_dayPaiHang 		= tolua.cast( Layer:getWidgetByName("Button_dayPaiHang"), "Button" )
	btn_kaiFuHuoDong    = tolua.cast( Layer:getWidgetByName("Button_kaiFuHuoDong"), "Button" )
	btn_kaiFuHuoDong:setVisible(true)
	btn_kaiFuHuoDong:setTouchEnabled(true)

	btn_chongZhiXiaoFei = tolua.cast( Layer:getWidgetByName("Button_ChongZhiXiaoFei"), "Button" )
	btn_chongZhiXiaoFei:setVisible(false)
	btn_chongZhiXiaoFei:setTouchEnabled(false)

	btn_guoQingHuoDong = tolua.cast( Layer:getWidgetByName("Button_GuoQing"), "Button" )
	btn_guoQingHuoDong:setVisible(false)
	btn_guoQingHuoDong:setTouchEnabled(false)

	btn_DengLuDaLi  	= tolua.cast( Layer:getWidgetByName("Button_DengLuJiangLi"), "Button" )
	btn_DengLuDaLi:setVisible(false)
	btn_DengLuDaLi:setTouchEnabled(false)


	
	btn_zhongQiuHuoDong    = tolua.cast( Layer:getWidgetByName("Button_ZhongQiu"), "Button" )
	btn_zhongQiuHuoDong:setVisible(false)
	btn_zhongQiuHuoDong:setTouchEnabled(false)

	btn_libao = tolua.cast( Layer:getWidgetByName("Button_LiBao"), "Button" )

	img_powerBG = tolua.cast( Layer:getWidgetByName("ImageView_PowerBG1"), "ImageView" )
	font_Power = tolua.cast( Layer:getWidgetByName("LabelBMFont_ZhanDouLi"), "LabelBMFont" )

	--[[
	if MeiRiDengLuJLData.ifOpenMeiRiDengLuJiangLi() and CityData.canOpenFuncByIndex(40) then --开启每日登陆奖励
		btn_DengLuDaLi:setVisible(true)
		btn_DengLuDaLi:setTouchEnabled(true)
		
		addShanGuangEffect(1)
	else
		btn_DengLuDaLi:setVisible(false)
		btn_DengLuDaLi:setTouchEnabled(false)
	end
	--]]

	btn_yuXi = tolua.cast( Layer:getWidgetByName("Button_YuXi"), "Button" )
	img_yuXi = tolua.cast( Layer:getWidgetByName("ImageView_YuXi"), "ImageView" )
	panel_yuXi = tolua.cast( Layer:getWidgetByName("Panel_YuXi"), "Widget" )
	panel_yuXi:setVisible(false)
	panel_yuXi:setTouchEnabled(false)

	lbl_yuXiCd = tolua.cast( Layer:getWidgetByName("Label_lefttime"), "Label" )

	local function yuXiCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			RW_guide.exitUI()--退出任务引导
			btn_yuXi:setTouchEnabled(false)
			--img_yuXi:setVisible(true)
			panel_yuXi:setVisible(true)
		    img_yuXi:setScale(0.2)
		    local function CallFucnCallback2(sender)
		    	btn_yuXi:setTouchEnabled(true)
		        --img_yuXi:setTouchEnabled(true)
		        panel_yuXi:setTouchEnabled(true)
		    end
		    local array = CCArray:create()
		    array:addObject(CCScaleBy:create(0.2, 6, 6))
		    array:addObject(CCScaleBy:create(0.05, 0.83, 0.83))
		    array:addObject( CCCallFuncN:create(CallFucnCallback2) )
		    img_yuXi:runAction(CCSequence:create(array))
		end
	end
	btn_yuXi:addTouchEventListener( yuXiCB )
	local function TipsCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
        	RW_guide.exitUI()--退出任务引导
            --img_yuXi:setVisible(false)
            --img_yuXi:setTouchEnabled(false)
            panel_yuXi:setVisible(false)
            panel_yuXi:setTouchEnabled(false)
        end
    end
    panel_yuXi:addTouchEventListener(TipsCB)
	--img_yuXi:addTouchEventListener(TipsCB)
	--检测玉玺状态
	CheckYuXiState()
	

	btn_vip 			= tolua.cast( Layer:getWidgetByName("Button_3959"), "Button" )
	--btn_jiangLiPerDay = tolua.cast( Layer:getWidgetByName("Button_JiangLiPerDay"), "Button" )
	btn_ChongZhiHuoDong=tolua.cast( Layer:getWidgetByName("Button_ChongZhi"), "Button" )
	btn_ShouChongDaLi = tolua.cast( Layer:getWidgetByName("Button_ShouChongDaLi"), "Button" )
	btn_chengJiuTan = tolua.cast( Layer:getWidgetByName("Button_chengJiu"), "Button" )


	if ChengJiuData.ifOpenChengJiuTan() and CityData.canOpenFuncByIndex(41) then --开启成就坛
		btn_chengJiuTan:setVisible(true)
		btn_chengJiuTan:setTouchEnabled(true)
		addShanGuangEffect(2)
	else
		btn_chengJiuTan:setVisible(false)
		btn_chengJiuTan:setTouchEnabled(false)
	end

	if PlayerData.getShouChongState() ~= 2 and CityData.canOpenFuncByIndex(42) then --没有领取
		btn_ShouChongDaLi:setVisible(true)
		btn_ShouChongDaLi:setTouchEnabled(true)

		addShanGuangEffect(3)
	else
		btn_ShouChongDaLi:setVisible(false)
		btn_ShouChongDaLi:setTouchEnabled(false)
	end



	local function btnEvent(sender, eventType)
	    if eventType == PT.ccs.TouchEventType.ended then 
	    	local _btn = tolua.cast(sender, "Button")
	    	RW_guide.exitUI()--退出任务引导
	    	if _btn == btn_main then 
	    		if btnMainState then --去世界
	    			if CityData.canOpenFuncByIndex(2) then
		    			btnMainState = false    			
		    			MapShouYe.exitUI()

		    			LM.clearMainCity()
		    			LM.clearPubMid()

		    			MapShiJie.enterUI()
	    			else
	    				Pop3_TS_Result.enterUI("世界功能尚未开启！")
	    			end
	    			
	    		else 				--去主城
	    			btnMainState = true
	    			--MapShiJie.exitUI()
	    			--LM.clearLayer2ToUI()
	    			LM.clearPubMid()
	    			MapShouYe.enterUI()
	    			
	    		end
	    	elseif _btn == btn_zhengZhan then --征战
				if CityData.canOpenFuncByIndex(3) then
					
					GuanKaBase.enterUI(1)					
				else	
					PT.popTips(3)
				end	    		

	    	elseif _btn == btn_wuJiang then --武将
				if CityData.canOpenFuncByIndex(4) then					
					GeneralBase.enterUI(1)
				else
					PT.popTips(4)
				end
	    	elseif _btn == btn_nvShen then --女神
	
				if CityData.canOpenFuncByIndex(16) then
					NvShenBaseA.enterUI(1)
				else
					PT.popTips(16)
				end
	    	elseif _btn == btn_junTuan then --军团

				if CityData.canOpenFuncByIndex(19) then
					if PlayerData.CheckIfHaveInTeam() then --检测是否有军团
						protoSend0x0382(0, 2)
					else
						protoSend0x0380(0, 2)
					end
				else
					PT.popTips(19)
				end
	    	elseif _btn == btn_renWu then --任务
				if CityData.canOpenFuncByIndex(20) then
					RenWuBase.enterUI(1)
				else
					PT.popTips(20)
				end
	    	elseif _btn == btn_zhuangBei then --装备

				if CityData.canOpenFuncByIndex(11) then
					BeiBaoBase.enterUI(1)
				else
					PT.popTips(11)
				end
			elseif _btn == btn_LiaoTian then
				LiaoTian.enterUI()
				
			-----------------------------------
			elseif _btn == btn_guoZhan then --国战
	    		if CityData.canOpenFuncByIndex(34) then
	    			GuoZhan_GuiZe.enterUI()
	    		else
	    			PT.popTips(34)
	    		end
			elseif _btn == btn_mail then --邮件
	    		--邮件接口测试
	    		if CityData.canOpenFuncByIndex(36) then
					MailBase.enterUI( 1 )
				else
					PT.popTips(36)
				end
			elseif _btn == btn_gongHuiZhan then --工会战
				--JiSiBase.enterUI()
				JunTuanZhan_JiaRu.enterUI()
			--elseif _bnt == btn_jiangLiPerDay then --每日奖励
			elseif _btn == btn_vip then
				if CityData.canOpenFuncByIndex(30) then
					VipBase.enterUI()
				else
					--Pop3_TS_Result.enterUI( "功能未开启，请升级主城！"  )
					PT.popTips(30)
				end
			elseif _btn == btn_dayPaiHang then --每日排行
				--todo：
				protoSend0x0486()
				--Map_RankPerDay.enterUI()
				
			elseif _btn == btn_kaiFuHuoDong then --开服活动
				KaiFuHuoDongBase.enterUI()
			elseif _btn == btn_zhongQiuHuoDong then --中秋活动
				ZhongQiuHuoDongBase.enterUI()
			elseif _btn == btn_chongZhiXiaoFei then --活动--充值消费
				ChongZhiXiaoFei.enterUI()
			elseif _btn == btn_guoQingHuoDong then --国庆活动
				guoQingDongBase.enterUI()
			elseif _btn == btn_DengLuDaLi then --登录大礼
				DengLuJiangLi.enterUI()
				if MeiRiDengLuJLData.ifOpenMeiRiDengLuJiangLi() then 
					if ifOpenDengLuDaLi then
						ifOpenDengLuDaLi = false
						local node = btn_DengLuDaLi:getNodeByTag(10)
						if node ~= nil then
							btn_DengLuDaLi:removeNodeByTag(10)
						end
					end
				end
			elseif _btn == btn_chengJiuTan then --成就坛
				ChengJiuTan.enterUI()
				if ifChengJiuTan then
					--ifChengJiuTan = false
					local node = btn_chengJiuTan:getNodeByTag(11)
					if node ~= nil then
						btn_chengJiuTan:removeNodeByTag(11)
					end
				end
			elseif _btn == btn_ChongZhiHuoDong then --充值活动

				ChongZhiActivity.enterUI()
				--Pop3_TS_Result.enterUI("暂停充值")
			elseif _btn == btn_ShouChongDaLi then --首充大礼
				--todo: 进入首冲大礼ui
				ShouChongDaLi.enterUI()
				
				if ifShouChongDaLi and PlayerData.getShouChongState() == 0 then
					ifShouChongDaLi = false
					
					local node = btn_ShouChongDaLi:getNodeByTag(12)
					if node ~= nil then
						btn_ShouChongDaLi:removeNodeByTag(12)
					end

				end
			elseif _btn == btn_libao then --礼包兑换
				Pop3_LingQuLiBao.enterUI()
	    	end
	    end
	end

	btn_main:addTouchEventListener(btnEvent)
	btn_zhengZhan:addTouchEventListener(btnEvent)
	btn_wuJiang:addTouchEventListener(btnEvent)
	btn_nvShen:addTouchEventListener(btnEvent)
	btn_junTuan:addTouchEventListener(btnEvent)
	btn_renWu:addTouchEventListener(btnEvent)
	btn_zhuangBei:addTouchEventListener(btnEvent)
	btn_LiaoTian:addTouchEventListener(btnEvent)
	btn_DengLuDaLi:addTouchEventListener(btnEvent)
	btn_libao:addTouchEventListener(btnEvent)

if ifGuoZhan then	
	btn_guoZhan:addTouchEventListener(btnEvent)
else
	btn_guoZhan:setVisible(false)
	btn_guoZhan:setTouchEnabled(false)
end
	btn_mail:addTouchEventListener(btnEvent)
if ifJunTuanZhan then
	btn_gongHuiZhan:addTouchEventListener(btnEvent)
	if CityData.canOpenFuncByIndex(35)==3 or CityData.canOpenFuncByIndex(35)==1 then
		btn_gongHuiZhan:setVisible(true)
		btn_gongHuiZhan:setTouchEnabled(true)
	else
		btn_gongHuiZhan:setVisible(false)
		btn_gongHuiZhan:setTouchEnabled(false)
	end
else
	btn_gongHuiZhan:setVisible(false)
	btn_gongHuiZhan:setTouchEnabled(false)
end
	btn_dayPaiHang:addTouchEventListener(btnEvent)
	btn_kaiFuHuoDong:addTouchEventListener(btnEvent)
	btn_chongZhiXiaoFei:addTouchEventListener(btnEvent)
	btn_guoQingHuoDong:addTouchEventListener(btnEvent)
	btn_chengJiuTan:addTouchEventListener(btnEvent)
	btn_ShouChongDaLi:addTouchEventListener(btnEvent)
	btn_ChongZhiHuoDong:addTouchEventListener(btnEvent)
	btn_vip:addTouchEventListener(btnEvent)
	btn_zhongQiuHuoDong:addTouchEventListener(btnEvent)
	--btn_jiangLiPerDay:addTouchEventListener(btnEvent)

	refreshBtn()

--------------------------------------------------------
	ifHeadvisible = true
	img_headBG 			= tolua.cast( Layer:getWidgetByName("ImageView_headBG"), "ImageView" )
	img_junLingBG 		= tolua.cast( Layer:getWidgetByName("ImageView_junLingBG"), "ImageView" )
	img_zhengZhanCDBG 	= tolua.cast( Layer:getWidgetByName("ImageView_zhengZhanCDBG"), "ImageView" )
	img_eventBG 		= tolua.cast( Layer:getWidgetByName("ImageView_event_BG"), "ImageView" )

	

	local img_jinBiBG 	= tolua.cast( Layer:getWidgetByName("ImageView_jinBiBG"), "ImageView" )
	local img_yinBiBG 	= tolua.cast( Layer:getWidgetByName("ImageView_yinBiBG"), "ImageView" )
	local img_liangCaoBG= tolua.cast( Layer:getWidgetByName("ImageView_liangCaoBG"), "ImageView" )
	local img_junGongBG = tolua.cast( Layer:getWidgetByName("ImageView_junGong"), "ImageView" )
	
	img_jinBiBG:setTouchEnabled(true)
	img_yinBiBG:setTouchEnabled(true)
	img_junGongBG:setTouchEnabled(true)
	img_liangCaoBG:setTouchEnabled(true)

	local function imgEvent(sender, eventType)
	    if eventType == PT.ccs.TouchEventType.ended then 
	    	local _img = tolua.cast(sender, "ImageView")
	    	RW_guide.exitUI()--退出任务引导
	    	if img_headBG == _img then --todo:打开vip
	    		
	    		protoSend0x0478()
	    	elseif img_junLingBG == _img then --todo：购买军令
	    		NotEnough.enterUI(4)
	    	elseif img_zhengZhanCDBG == _img then --todo：消除征战cd
	    		if PlayerData.getBeatCD() > 0 then
	    			protoSend0x0420(13)
	    		end
	    	elseif img_eventBG == _img then --todo：事件列表点击事件

	    	elseif img_jinBiBG == _img then --todo:购买金币
	    		NotEnough.enterUI(2)
	    	elseif img_yinBiBG == _img then --todo:购买银币
	    		NotEnough.enterUI(1)
	    	elseif img_liangCaoBG == _img then --todo：购买粮草
	    		NotEnough.enterUI(5)
	    	elseif img_junGongBG == _img then --todo：购买军功

	    	end
	    end
	end
	img_headBG:addTouchEventListener(imgEvent)
	img_junLingBG:addTouchEventListener(imgEvent)
	img_zhengZhanCDBG:addTouchEventListener(imgEvent)
	img_eventBG:addTouchEventListener(imgEvent)
	img_jinBiBG:addTouchEventListener(imgEvent)
	img_yinBiBG:addTouchEventListener(imgEvent)
	img_liangCaoBG:addTouchEventListener(imgEvent)
	img_junGongBG:addTouchEventListener(imgEvent)


	local lbl_zhengZhanCD = tolua.cast( Layer:getWidgetByName("Label_zhengZhanCD"), "Label" )
	PlayerData.setZhengZhanCDLable(lbl_zhengZhanCD,img_zhengZhanCDBG)

--金币
	lbl_jinBi 		= tolua.cast( Layer:getWidgetByName("Label_jinBi"), "Label" )
	LoadBar_jinBi 	= tolua.cast( Layer:getWidgetByName("LoadingBar_jinBi"), "LoadingBar" )
	LoadBar_jinBi:setVisible(false)
--银币
	lbl_yinBi 		= tolua.cast( Layer:getWidgetByName("Label_yinBi"), "Label" )
	loadBar_yinBi 	= tolua.cast( Layer:getWidgetByName("LoadingBar_yinBi"), "LoadingBar" )
	--loadBar_yinBi:setPercent(7.9)
--粮草
	lbl_liangCao 	= tolua.cast( Layer:getWidgetByName("Label_liangCao"), "Label" )
	loadBar_liangCao= tolua.cast( Layer:getWidgetByName("LoadingBar_liangCao"), "LoadingBar" )
--军工
	lbl_junGong 	= tolua.cast( Layer:getWidgetByName("Label_JunGong"), "Label" )
	loadBar_junGong = tolua.cast( Layer:getWidgetByName("LoadingBar_junGong"), "LoadingBar" )
	loadBar_junGong:setVisible(false)
--军令
	lbl_junLing 	= tolua.cast( Layer:getWidgetByName("Label_junLing"), "Label" )
--玩家名字、vip等级、等级
	lbl_playerName 	= tolua.cast( Layer:getWidgetByName("Label_name"), "Label" )
	lbl_playerLv 	= tolua.cast( Layer:getWidgetByName("Label_Lv"), "Label" )
	LabelBMFont_playerVip = tolua.cast( Layer:getWidgetByName("LabelBMFont_vip"), "LabelBMFont" )
--所属国家
	img_contry = tolua.cast( Layer:getWidgetByName("ImageView_country"), "ImageView" )
	img_beAtack = tolua.cast( Layer:getWidgetByName("ImageView_beiGongJi"), "ImageView" )
	flushBeAtack()
--游戏时间
	local gameTimeYear ,gameTimeMonth = PlayerData.getGameTime()
	local season = nil
	--lbl_Time:setText(gameTimeYear)
	if gameTimeMonth ==0 then
		season ="春"
	elseif gameTimeMonth ==1 then
		season ="夏"
	elseif gameTimeMonth ==2 then
		season ="秋"
	elseif gameTimeMonth ==3 then
		season ="冬"
	end
	--lbl_Season:setText(season)

	local lbl_gameTime = tolua.cast( Layer:getWidgetByName("Label_season"), "Label" )
	lbl_gameTime:setText(gameTimeYear .. "年" .. season)
if ifserver then
	lbl_playerName:setText(PlayerData.getName() )
	flushCountry()
	flushJinBi( PlayerData.getGold() )
	flushYinBi( )
	flushLiang( )
	flushJunGong( PlayerData.getExploit() )
	flushJunling(  )
	flushLv( PlayerData.getLv() )
	flushVipLv(PlayerData.getVipLv())
end

	btn_panelContrl = tolua.cast( Layer:getWidgetByName("Button_panelControl"), "Button" )
	panel_btn = tolua.cast( Layer:getWidgetByName("Panel_btn"), "Widget" )
	local ImageView_talkBG = tolua.cast( Layer:getWidgetByName("ImageView_talkBG"), "ImageView" )

	local panel_AB = tolua.cast( Layer:getWidgetByName("Panel_AB"), "Layout" )
	local panel_A = tolua.cast( Layer:getWidgetByName("Panel_A"), "Layout" )
	local panel_B = tolua.cast( Layer:getWidgetByName("Panel_B"), "Layout" )

---------适配位置
	--if UseW > 960 then
		img_jinBiBG:setPosition( ccp(190/960*UseW,UseH-25) )
		img_yinBiBG:setPosition( ccp(360/960*UseW,UseH-25) )
		img_junGongBG:setPosition( ccp(530/960*UseW,UseH-25) )
		img_liangCaoBG:setPosition( ccp(700/960*UseW,UseH-25) )

		ifHeadvisible = true
		checkHuoDongIfOpen()
		--[[
		btn_guoZhan:setPosition( ccp(340, UseH-110) )
		btn_gongHuiZhan:setPosition( ccp(430, UseH-110) )
		btn_dayPaiHang:setPosition(ccp(520, UseH-110 ))
		btn_kaiFuHuoDong:setPosition(ccp(610, UseH-110) )
		--]]
		--btn_mail:setPosition( ccp(UseW-190, UseH-99) )
		
		--btn_jiangLiPerDay:setPosition( ccp(UseW-335, UseH-99) )
		

		btn_main:setPosition( ccp(UseW-52, 46) )
		btn_renWu:setPosition( ccp(UseW-150, 51) )
		btn_dayPaiHang:setPosition( ccp(UseW-240, 51) )
		btn_chengJiuTan:setPosition( ccp(UseW-330, 51)  )

		btn_panelContrl:setPosition( ccp(UseW-43,UseH-22 ) )
		panel_btn:setPosition( ccp(UseW-78, UseH-530) )

		ImageView_talkBG:setSize(CCSize(UseW-360-30, 42))
		ImageView_talkBG:setPosition( ccp(0, 23) )

		panel_AB:setSize(CCSize(UseW-370-70-30,31))
		panel_A:setSize(CCSize(UseW-370-70-30, 31))
		panel_B:setSize(CCSize(UseW-370-70-30, 31))
		panel_AB:setPosition(ccp(70, -16))


		img_headBG:setPosition( ccp(139, UseH-81) ) 

		img_junLingBG:setPosition( ccp( 75, UseH-210) )  		
		--img_zhengZhanCDBG:setPosition( ccp(243, UseH-182) )  	
		img_eventBG:setPosition(ccp(-135, 261))
	--end

--------------------------------------------------------------
	setPanelBtnState(true)
	local function panelEvent(sender, eventType)
	    if eventType == PT.ccs.TouchEventType.ended then 
	    	--local _img = tolua.cast(sender, "ImageView")
	    	RW_guide.exitUI()--退出任务引导
	    	if openState then
	    		--关闭动作
	    		openState = false
       			local actClose = CCArray:create()
       			actClose:addObject( CCMoveBy:create(0.1, ccp(0, -30)) )
        		actClose:addObject( CCMoveBy:create(0.4, ccp(0, 30+530+150)) )
	    		panel_btn:runAction( CCSequence:create(actClose) )

	    		btn_panelContrl:loadTextures("button91_city_2.png", "button91_city_2.png", "")
	    	else
	    		--开启动作
	    		openState = true
       			local actOpen = CCArray:create()
       			actOpen:addObject( CCMoveBy:create(0.4, ccp(0, -30-530-150)) )
       			actOpen:addObject( CCMoveBy:create(0.1, ccp(0, 30)) )
        		
	    		panel_btn:runAction( CCSequence:create(actOpen) )

	    		btn_panelContrl:loadTextures("button91_city_1.png", "button91_city_1.png", "")
	    	end
	    	if LM.STATE_4 ~= 0 then
	    		guideFactory.CheckGuideProcess( LM.STATE_4 )
	    	elseif LM.STATE_3 ~= 0 then
	    		guideFactory.CheckGuideProcess( LM.STATE_3 )
	    	elseif LM.STATE_2 ~= 0 then
	    		guideFactory.CheckGuideProcess( LM.STATE_2 )
	    	else
	    		guideFactory.CheckGuideProcess( LM.STATE_1 )
	    	end
	    end
	end
	btn_panelContrl:addTouchEventListener( panelEvent )
----------------------------------------------------------------
	openState_CD = false --默认是关闭状态
	Button_Event_Btn = tolua.cast( Layer:getWidgetByName("Button_Event_Btn"), "Button" )
	local function CD_Event(sender, eventType)
	    if eventType == PT.ccs.TouchEventType.ended then 
	    	RW_guide.exitUI()--退出任务引导
	    	if openState_CD then
	    		openState_CD = false
	    		remCdStateSelf = false
	    		img_eventBG:runAction( CCMoveBy:create(0.1, ccp(-270, 0)) )
	    		Button_Event_Btn:loadTextures("pic92_city_1.png","pic92_city_1.png","")
	    	else
	    		openState_CD = true
	    		remCdStateSelf = true
       			--local actOpen = CCArray:create()
       			--actOpen:addObject( CCMoveBy:create(0.4, ccp(0, 0)) )
       			--actOpen:addObject( CCMoveBy:create(0.1, ccp(0, 30)) )
        		--CCSequence:create(actOpen)
	    		img_eventBG:runAction( CCMoveBy:create(0.1, ccp(270, 0)) )
	    		Button_Event_Btn:loadTextures("pic92_city_2.png","pic92_city_2.png","")
	    	end
	   	end
	end

	Button_Event_Btn:addTouchEventListener(CD_Event)
	--设置默认状态
	setCDEventPubVisible(true)
	remCdStateSelf = true

	setPubVisible(true)
--------------------------------------------------------------
	initEventScrollView()


	--监测邮件是否存在小红点
	checkIfRedPointOnMail()
	checkIfRedPointOnTask()
	checkIfRedPointOnEvent()
	checkIfRedPointOnHD()
	checkIfRedPointOnXiaoFeiChongZhi()

	LtFactory.initUITalk( panel_A, panel_B )

	--更新玩家战斗力，此战斗力每次变化都需要刷新
	flushPlayerPower()
--[[
	local emitter = CCParticleSystemQuad:create("fource.plist")
	emitter:setPosition(ccp(-20,-16))
	emitter:setGravity(ccp(0,80))
	--emitter:setPosition(ccp(0,0))
	btn_mail:addNode(emitter)

	local disx = 20
	local disy = 16
	local state = 1
	local function FlushPosition()
		local x,y = emitter:getPosition()
		if state == 1 then
			y = y + 4
			if y == disy then
				state = 2
				emitter:setGravity(ccp(-80,0))
			end	
		elseif state == 2 then
			x = x + 4
			if x == disx then
				state = 3
				emitter:setGravity(ccp(0,-80))
			end
		elseif state == 3 then
			y = y -4
			if y == -disy then
				state = 4
				emitter:setGravity(ccp(80,0))
			end
		elseif state == 4 then
			x = x - 4 
			if x == -disx then
				state = 1
				emitter:setGravity(ccp(0,80))
			end
		end
		emitter:setPosition(ccp(x, y))
	end

	local scheduler = CCDirector:sharedDirector():getScheduler()
	scheduler:scheduleScriptFunc( FlushPosition, 0.1, false)
--]]
end

--检测每日奖励是否弹出
function checkJiangliPerDay( )
	if isTanChuGuoJiangLiLayer==false then
		if  PlayerData.getDailyLogin()==0 then
			if CityData.canOpenFuncByIndex(33) then
				Pop3_JiangLiPerDay.enterUI()
				PlayerData.flushDailyLogin(1) --这一句基本没用处
				--弹出过每日奖励层
				isTanChuGuoJiangLiLayer=true
	 		end
		end
	end
end


function isTanChuSystenmTips()

	--sdk设置游戏信息
	if ifYouLeSdk then
		TencentMsdk:MyYoulePay(recv0x0103[INDEX_0x0103_CharId][VALUE],PlayerData:getName(),0,PlayerData:getLv(),_G.loginServerId)
	end

	--检测是否弹出系统更新公告
	local systemTipsData=Des.getSystemTipsData() --获取本地系统公告数据
	local str_sysTipsKey="SysTips" .. recv0x0103[INDEX_0x0103_CharId][VALUE]
	if CCUserDefault:sharedUserDefault():getIntegerForKey(str_sysTipsKey)~=systemTipsData["version"] then
		Map_Pop3_SystemTips.enterUI()
		CCUserDefault:sharedUserDefault():setIntegerForKey(str_sysTipsKey, systemTipsData["version"])
		isTanchuSysTips = true
	else
		isTanchuSysTips = false

	 	--没公告，直接检测新手引导
	 	print("======tttttt1")
		guideFactory.CheckGuideProcess( LM.STATE_1 )
		
	end
end


function exitUI()
	if Layer ~= nil and widget ~= nil then
		Layer:removeWidget(widget)
		widget = nil
		Layer = nil
	end
	LM.STATE_9 = 0

	clearAllMainLable()
	LtFactory.closeUiTalk()
end
function enterUI(  )
	LM.STATE_9 = 1

	Layer = LM.getLayer9UI()
	widget = GUIReader:shareReader():widgetFromJsonFile("ShouYe_UI.json") 

    Layer:addWidget(widget)
    widget:setTouchEnabled(false) --false 具有穿透效果，true 没有

    initpub()
    
    isTanchuSysTips = false

    if  RL_GameName.checkname(curScene) == false and ReLogin.getReloginState() == false then 
		--RL_UpdateData.setGotoLayer(-1)
		--公告
		isTanChuSystenmTips()

	end
	
	--检测每日奖励是否弹出
	checkJiangliPerDay( )
	

	

	
end
