module ("MapShiJie",package.seeall)
local Layer = nil 
local scene = nil

local cityTable = {}
local GKTable = {}
--城市匹配索引
local uiCityIndex = {10,11,3,21,9,8,5,20,6,24,26,23,25,27,19,28,29,34,31,14,30,33,18,16,12,15,2}
--关卡匹配索引
local GKName = {"中原·逐鹿","异族·羌族","异族·匈奴","异族·胡人","异族·山越","异族·土族","异族·南蛮"}
local uiGKIndex = {13,1,7,17,22,35,32}
local ScrollView_Map = nil
function refreshGKState()
	for i=1,#uiGKIndex do
		local  data  = JunTuanZhanData.getGuanKa(i)
		if data ~= nil then
			local _TT = GKTable[i]
				if data["emb_lv"] == 0 then
					_TT["title"]:setVisible(false)
				else
					_TT["title"]:setVisible(true)
					_TT["imageView"]:loadTexture(JunTuan_JiaRu.HuiHuiPic[data["emb_lv"]])
					_TT["Label1"]:setText(data["emb_name"])
					_TT["Label2"]:setText(data["name"])
					
				end
		end
	end
end 
function flushMap()
	--初始化城市
	local mycityId = PlayerData.getCityId()
	local data = WordCityData.getWordCityDataFromId(mycityId)
	local myCityMaxLv = data["LvMax"]
	local myCamp = PlayerData.getCamp()

	local myzhuChengLv = PlayerData.getLv()

	for i=1, #uiCityIndex do
		print("i == " .. i)
		local data = WordCityData.getWordCityDataFromLocalIdx(i)
		local id = data["CityId"]
		local camp = data["Camp"]
		local CityMaxLv = data["LvMax"]
		local _TT = cityTable[i]

		if id == mycityId then

			local imageView = ImageView:create()
			imageView:loadTexture("floor+5_shijie.png")
			imageView:setPosition(ccp(0,70))
			imageView:setTag(100)
			_TT["nameBG"]:removeChildByTag(100, true)
			_TT["nameBG"]:addChild(imageView)

			local _x, _y = cityTable[id]["city"]:getPosition()

			local ImgMap_W = 1500
			local ImgMap_H = 1001
			_x = _x + ImgMap_W/2
			_y = _y +ImgMap_H/2

			
			local _layout = ScrollView_Map:getInnerContainer()

			local posx = UseW/2 - _x
			local posy = UseH/2 - _y

			local disW = math_abs(ImgMap_W-UseW)
			local disH = math_abs(ImgMap_H-UseH)

			if posx >= 0 then
				posx = 0
			elseif posx < -disW then
				posx = -disW
			end

			if posy >= 0 then
				posy = 0
			elseif posy < -disH then
				posy = -disH
			end

---[[
			local EntryID = -1
            local scheduler = CCDirector:sharedDirector():getScheduler()
            local function FlushPosition()
            	ScrollView_Map:setSize(CCSize(UseW, UseH))
                print("set Layout Posx = " .. posx)
                print("set Layout Posy = " .. posy)
                _layout:setPosition( ccp(posx, posy) )

                scheduler:unscheduleScriptEntry( EntryID )

                guideFactory.CheckGuideProcess(scene)
            end
            EntryID = scheduler:scheduleScriptFunc( FlushPosition, 0.01, true)
--]]
            	ScrollView_Map:setSize(CCSize(UseW, UseH))
                print("set Layout Posx = " .. posx)
                print("set Layout Posy = " .. posy)
                _layout:setPosition( ccp(posx, posy) )
                guideFactory.CheckGuideProcess(scene)
		else
			if myCamp == camp then --相同国家
				print("myzhuChengLv ====  " .. myzhuChengLv)
				print("CityMaxLv ====  " .. CityMaxLv)

				if myzhuChengLv <= CityMaxLv then --可迁徙

					local imageView = ImageView:create()
					imageView:loadTexture("floor+7_shijie.png")
					imageView:setPosition(ccp(0,70))
					imageView:setTag(100)
					_TT["nameBG"]:removeChildByTag(100, true)
					_TT["nameBG"]:addChild(imageView)
				end
			else
				--1,10,19是主城
				if CityMaxLv == myCityMaxLv and id ~= 1 and id ~= 10 and id ~= 19 then --可攻打

					local imageView = ImageView:create()
					imageView:loadTexture("floor+6_shijie.png")
					imageView:setPosition(ccp(0,70))
					imageView:setTag(100)
					_TT["nameBG"]:removeChildByTag(100, true)
					_TT["nameBG"]:addChild(imageView)
				end
			end
		end

		if data["Visible"] == 1 then
			_TT["city"]:setTouchEnabled(true)
			_TT["nameBG"]:setVisible(true)
		else
			_TT["city"]:setTouchEnabled(false)
			_TT["nameBG"]:setVisible(false)
		end
		local imageView = ImageView:create()
		--0魏1蜀2吴
		if camp == 0 then
    		_TT["city"]:setColor(ccc3(0,18,120))
    	elseif camp == 1 then
    		_TT["city"]:setColor(ccc3(142,0,3))
    	elseif camp == 2 then
    		_TT["city"]:setColor(ccc3(29,114,40))
    	end

	end
end
function initMap()
	if LM.STATE_9 == 1 then
		MapPubUI.setPubVisible(true)
	end
	
	--local ScrollView_Map = tolua.cast( Layer:getWidgetByName("ScrollView_Map"), "ScrollView" )
	--ScrollView_Map:setSize(FramSize)
	--ScrollView_Map:setSize(CCSize(1440, 640))
--城市
	local function pubCityBtnCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then 
			RW_guide.exitUI()--退出任务引导
			local _btn = tolua.cast(sender, "Button")
			local _tag = _btn:getTag()
			print("城市 map cell == " .. _tag)
			if _tag == 29 then --洛阳
				Pop3_GuoZhan_LuoYangCheng.enterUI()
			else
				protoSend0x0326( _tag )
				print("set city id = " .. _tag )
				MapShiJie_QuYu.setCityId(_tag)
			end
		end
	end

---[=[	
	for i=1, #uiCityIndex do
		cityTable[i] = {}
		local _TT = cityTable[i]
		_TT["city"] = tolua.cast( Layer:getWidgetByName("Button_cell_" .. uiCityIndex[i]), "Button" )
		_TT["nameBG"] = tolua.cast( Layer:getWidgetByName("ImageView_city" .. uiCityIndex[i]), "ImageView" )
		_TT["city"]:setIfPixelTouch(true)
		_TT["city"]:setTag( i )
		_TT["city"]:addTouchEventListener(pubCityBtnCB)

		--cityTable[i]["biaoZhi"] = tolua.cast( Layer:getWidgetByName("ImageView_BiaoZhi"..uiCityIndex[i]), "ImageView" )
		--cityTable[i]["biaoZhi"]:setVisible(false)
---[[
		local imageView = ImageView:create()
		imageView:loadTexture("floor+8_shijie.png")
		imageView:setPosition(ccp(0,-25))
		_TT["nameBG"]:addChild(imageView)

	   	local _lbl = Label:create()
	   	local name = Des.getAreaDesFromId(i)["areaName"]
		_lbl:setText( name )
		_lbl:setFontSize( 20 )
		_lbl:setPosition(ccp(0,-24))
		--_lbl:setColor( ccc3(239, 224, 199) )
		_TT["nameBG"]:addChild(_lbl)
--]]
	end
	flushMap()
--]=]

--城市洛阳
	local btn_luoyang = tolua.cast(Layer:getWidgetByName("Button_cell_" .. 4), "Button" )
	btn_luoyang:setTag(29)
	btn_luoyang:setIfPixelTouch(true)
	btn_luoyang:setColor(ccc3(219,206,90))
	btn_luoyang:addTouchEventListener(pubCityBtnCB)
---[[
	local btn_luoyangBG = tolua.cast(Layer:getWidgetByName("ImageView_city4"), "ImageView" )
		local imageView = ImageView:create()
		imageView:loadTexture("floor+8_shijie.png")
		imageView:setPosition(ccp(0,-25))


	   	local _lbl = Label:create()
		_lbl:setText( "洛阳" )
		_lbl:setFontSize( 20 )
		_lbl:setColor(ccc3(255, 244, 0))
		_lbl:setPosition(ccp(0,-24))
		--_lbl:setColor( ccc3(239, 224, 199) )

	btn_luoyangBG:addChild(imageView)
	btn_luoyangBG:addChild(_lbl)
--]]
--关卡
	local function pubGKBtnCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then 
			RW_guide.exitUI()--退出任务引导
			local _btn = tolua.cast(sender, "Button")
			local _tag = _btn:getTag()
			print("关卡 map cell == " .. _tag)
			if CityData.canOpenFuncByIndex(35) ==2 or CityData.canOpenFuncByIndex(35) ==3  then
				JunTuanZhan_GuanKa.enterUI(_tag)
			end
		end
	end
	
	for i=1, #uiGKIndex do
		print("i == " .. i)
		GKTable[i] = {}
		local _TT = GKTable[i]
		_TT["button"] = tolua.cast( Layer:getWidgetByName("Button_cell_" .. uiGKIndex[i]), "Button" )
		_TT["button"]:setIfPixelTouch(true)
		_TT["button"]:setTag( i )
		_TT["button"]:addTouchEventListener( pubGKBtnCB )

		--[[
		GKTable[i]["title"] = tolua.cast( Layer:getWidgetByName("ImageView_city"..uiGKIndex[i].."_JunTuanDi"), "ImageView" )
		GKTable[i]["title"]:setVisible(false)

		GKTable[i]["imageView"] = tolua.cast( Layer:getWidgetByName("ImageView_city"..uiGKIndex[i].."_junhui"), "ImageView" )
		GKTable[i]["Label1"] = tolua.cast( Layer:getWidgetByName("Label_city"..uiGKIndex[i].."_junhuiword"), "Label" )
		GKTable[i]["Label2"] = tolua.cast( Layer:getWidgetByName("Label_city"..uiGKIndex[i].."_juntuanname"), "Label" )
		--GKTable[i]["Label3"] = tolua.cast( Layer:getWidgetByName("Label_city"..uiGKIndex[i].."_name"), "Label" )
		GKTable[i]["biaoZhi"] = tolua.cast( Layer:getWidgetByName("ImageView_BiaoZhi"..uiGKIndex[i]), "ImageView" )
		--todo军团战开启
		GKTable[i]["biaoZhi"]:setVisible(false)
		--]]

			
		local img_bG = tolua.cast( Layer:getWidgetByName("ImageView_city" .. uiGKIndex[i]), "ImageView" )
		--设置关卡名字
		---[[
			local img_nameDi = ImageView:create()
			img_nameDi:loadTexture("floor+8_shijie.png")
			img_nameDi:setPosition(ccp(0,-28))
				local lbl_name = Label:create()
				lbl_name:setText( GKName[i] )
				lbl_name:setFontSize( 20 )
				lbl_name:setColor( ccc3(255, 0, 4) )
			img_nameDi:addChild(lbl_name)
		--]]
		--设置军团相关
			local img_junTuanDi = ImageView:create()
			img_junTuanDi:loadTexture("floor+8_shijie.png")
			img_junTuanDi:setPosition(ccp(0,28))
				local img_junHui = ImageView:create()
				img_junHui:loadTexture("floor+8_juntuan.png")
				img_junHui:setPosition(ccp(-50, 0))
				local lbl_junHuiName = Label:create()
				lbl_junHuiName:setText("")
				lbl_junHuiName:setFontSize( 14 )
				lbl_junHuiName:setPosition(ccp(-50, 2))
				local lbl_junTuanName = Label:create()
				lbl_junTuanName:setText("公会名字")
				lbl_junTuanName:setFontSize(20)
				lbl_junTuanName:setColor(ccc3(241, 255, 0))
				lbl_junTuanName:setPosition(ccp(-35, 0))
			img_junTuanDi:addChild(img_junHui)
			img_junTuanDi:addChild(lbl_junHuiName)
			img_junTuanDi:addChild(lbl_junTuanName)
		--标志部分
			local  img_biaoZhi = ImageView:create()
			img_biaoZhi:loadTexture("floor+5_shijie.png")
			img_biaoZhi:setPosition(ccp(0, 70))
		img_bG:addChild(img_nameDi)
		img_bG:addChild(img_junTuanDi)
		img_bG:addChild(img_biaoZhi)

		_TT["title"] = img_junTuanDi
		img_junTuanDi:setVisible(false)
		_TT["imageView"] = img_junHui
		_TT["Label1"] = lbl_junHuiName
		_TT["Label2"] = lbl_junTuanName
		_TT["biaoZhi"] = img_biaoZhi
		img_biaoZhi:setVisible(false)

	--]]
	end
	refreshGKState()
end
local _widget = nil
local state = false
--重连需要重置状态
function setstate(_state)
	state = _state
end
function getstate()
	return state
end
function exitUI()

			if Layer ~= nil and _widget ~= nil then
				Layer:removeWidget(_widget)
				_widget = nil
				Layer = nil
				LM.STATE_1 = 0
			end
			--LM.clearExcept9UIBtm()
		
			state = false
end

function enterUI()
	LM.STATE_1 = UI_ShiJie
	MapPubUI.setMainBtn()
	if state == false then
		state = true
		
		Layer = LM.getLayer1Base_nom()

		_widget = GUIReader:shareReader():widgetFromJsonFile("ShouYe_ShiJie.json")   

	    Layer:addWidget(_widget)
	    _widget:setTouchEnabled(false)


	    ScrollView_Map = tolua.cast( Layer:getWidgetByName("ScrollView_Map"), "ScrollView" )
	    ScrollView_Map:setSize(CCSize(UseW, UseH))
	    initMap()
	end
 
end
