module ("MapShouYe",package.seeall)

local Layer = nil 
local scene = nil

local cityArray = {
	{["city"] = nil, ["lv"] = nil, ["Shadow"]= nil, ["lvBG"] = nil}, --1主城
	{["city"] = nil, ["lv"] = nil, ["Shadow"]= nil, ["lvBG"] = nil}, --2民居
	{["city"] = nil, ["lv"] = nil, ["Shadow"]= nil, ["lvBG"] = nil}, --3国库
	{["city"] = nil, ["lv"] = nil, ["Shadow"]= nil, ["lvBG"] = nil}, --4军机处
	{["city"] = nil, ["lv"] = nil, ["Shadow"]= nil, ["lvBG"] = nil}, --5校场
	{["city"] = nil, ["lv"] = nil, ["Shadow"]= nil, ["lvBG"] = nil}, --6军械处
	{["city"] = nil, ["lv"] = nil, ["Shadow"]= nil, ["lvBG"] = nil}, --7驿站
	{["city"] = nil, ["lv"] = nil, ["Shadow"]= nil, ["lvBG"] = nil}, --8农场
	{["city"] = nil, ["lv"] = nil, ["Shadow"]= nil, ["lvBG"] = nil}, --9矿藏
}
local MainCityTimeID = 0

local scheduler = CCDirector:sharedDirector():getScheduler()
local ScrollView_Map = nil
local img_mapBG = nil

local curCharpterW = 0
local curCharpterH = 0
local cityId = 1
function flushCity( )
	-- body
	---[[
	if ifserver then
		local num = CityData.getCityNum()
		for i=1, num do
			local data = CityData.getCityDataFromIndex(i)
			local id = data["Id"]
			local lv = data["Lv"] 
			if cityArray[id]["city"] ~= nil then
				cityArray[id]["city"]:setVisible(true)
				cityArray[id]["city"]:setTouchEnabled(true)
				cityArray[id]["lv"]:setText(lv)
				cityArray[id]["lvBG"]:setVisible(true)
				if id == 8 or id == 9 then
					--8:农田 9:银矿
					cityArray[id]["lv"]:setVisible(false)
				end
			end
			if cityArray[id]["Shadow"] ~= nil then
				cityArray[id]["Shadow"]:setVisible(true)
			end
		end
	end
	--]]
	--[[
	for i=1, 9 do
				cityArray[i]["city"]:setVisible(true)
				cityArray[i]["city"]:setTouchEnabled(true)
				cityArray[i]["lv"]:setText(10)
				cityArray[i]["lvBG"]:setVisible(true)
	end
	--]]
end
local function getPosWithIdx( _idx )
	local size = ScrollView_Map:getInnerContainerSize()
	--local scale = img_mapBG:getScale()

	--print("scale = " .. scale)
	print("size W = " .. size.width )
	print("size H = " .. size.height )
	curCharpterW = size.width
	curCharpterH = size.height

    local _x, _y = cityArray[_idx]["city"]:getPosition()

    local posx = UseW/2 - _x
    local posy = UseH/2 - _y

    local disW = math_abs(curCharpterW-UseW)
    local disH = math_abs(curCharpterH-UseH)

    if posx >= 0 then
        posx = 0
    elseif posx < -disW then
        posx = -disW
    end
            
    if posy >= 0 then
        posy = 0
    elseif posy < -disH then
        posy = -disH
    end
    return posx, posy
end
function printlayoutpos()
	if ScrollView_Map ~= nil then
	local _layout = ScrollView_Map:getInnerContainer() 
	local posx, posy = _layout:getPosition()
	print("posx == " .. posx)
	print("posy == " .. posy)
	end
end
function setScrollViewMove()

    for i=1, #cityArray do
    	print("i == " .. i)
        cityArray[i]["city"]:setCanBeMoveForScrollView(true)
    end
end
function getWordPositon( _idx )
	
    if _idx == nil or _idx == 0 then
        return 
    end
    cityId = _idx
    local _x, _y = cityArray[_idx]["city"]:getPosition()
    local _arcPoint = cityArray[_idx]["city"]:getAnchorPoint()
    local _size = cityArray[_idx]["city"]:getSize()


    cityArray[_idx]["city"]:setCanBeMoveForScrollView(false)

   -- local ScrollView_map = tolua.cast( Layer:getWidgetByName( "ScrollView_map" ), "ScrollView" )
    local _layout = ScrollView_Map:getInnerContainer() 
    local posx, posy = getPosWithIdx(_idx)
    _layout:setPosition( ccp(posx, posy) )
    --print("_x == " .. _x)
    --print("_y == " .. _y )
    _x = _x - _size.width*_arcPoint.x
    _y = _y - _size.height*_arcPoint.y
    --print("posx == " .. posx)
    --print("posy == " .. posy )
    _x = _x - math_abs(posx)
    _y = _y - math_abs(posy)
    --print("_x == " .. _x)
    --print("_y == " .. _y )
    local pos = CCDirector:sharedDirector():convertToUI(ccp(_x, _y));
    
    return pos.x, UseH-pos.y

end
function removeScheduler()
	--if CDTimeManager ~= 0 then
		scheduler:unscheduleScriptEntry( MainCityTimeID )
		CDTimeManager = 0 
	--end
end
function initShouYeUI()
	if LM.STATE_9 == 1 then
		MapPubUI.setPubVisible(true)
	end
	cityArray[1]["city"] = tolua.cast( Layer:getWidgetByName("Button_ZhuCheng"), "Button" )
	cityArray[2]["city"] = tolua.cast( Layer:getWidgetByName("Button_JuMin"), "Button" )
	cityArray[3]["city"] = tolua.cast( Layer:getWidgetByName("Button_GuoKu"), "Button" )
	cityArray[4]["city"] = tolua.cast( Layer:getWidgetByName("Button_JunJiChu"), "Button" )
	cityArray[5]["city"] = tolua.cast( Layer:getWidgetByName("Button_JiaoChang"), "Button" )
	cityArray[6]["city"] = tolua.cast( Layer:getWidgetByName("Button_JunXieChu"), "Button" )
	cityArray[6]["city"]:setScaleX(-1)
	cityArray[7]["city"] = tolua.cast( Layer:getWidgetByName("Button_YiZhan"), "Button" )
	cityArray[8]["city"] = tolua.cast( Layer:getWidgetByName("Button_NongChang"), "Button" )
	cityArray[9]["city"] = tolua.cast( Layer:getWidgetByName("Button_KuangChang"), "Button" )
	
	cityArray[1]["lv"] 	= tolua.cast( Layer:getWidgetByName("Label_ZhuChengLv"), "Label" )
	cityArray[2]["lv"] 	= tolua.cast( Layer:getWidgetByName("Label_JuMinLv"), "Label" )
	cityArray[3]["lv"]  = tolua.cast( Layer:getWidgetByName("Label_GuoKuLv"), "Label" )
	cityArray[4]["lv"] 	= tolua.cast( Layer:getWidgetByName("Label_JunJiChuLv"), "Label" )
	cityArray[5]["lv"]  = tolua.cast( Layer:getWidgetByName("Label_JiaoChangLv"), "Label" )
	cityArray[6]["lv"]  = tolua.cast( Layer:getWidgetByName("Label_JunXieChuLv"), "Label" )
	cityArray[7]["lv"] 	= tolua.cast( Layer:getWidgetByName("Label_YiZhanLv"), "Label" )
	cityArray[8]["lv"]  = tolua.cast( Layer:getWidgetByName("Label_NongChangLv"), "Label" )
	cityArray[9]["lv"]  = tolua.cast( Layer:getWidgetByName("Label_KuangChangLv"), "Label" )

	cityArray[1]["Shadow"] = nil --tolua.cast( Layer:getWidgetByName("ImageView_ZhuChengYZ"), "ImageView" )
	cityArray[2]["Shadow"] = nil --tolua.cast( Layer:getWidgetByName("ImageView_ZhuChengYZ"), "ImageView" )
	cityArray[3]["Shadow"] = nil --tolua.cast( Layer:getWidgetByName("ImageView_ZhuChengYZ"), "ImageView" )
	cityArray[4]["Shadow"] = nil --tolua.cast( Layer:getWidgetByName("ImageView_JunJiChuYZ"), "ImageView" )
	cityArray[5]["Shadow"] = nil --tolua.cast( Layer:getWidgetByName("ImageView_JiaoChangYZ"), "ImageView" )
	cityArray[6]["Shadow"] = nil --tolua.cast( Layer:getWidgetByName("ImageView_JunXieChuYZ"), "ImageView" )
	cityArray[7]["Shadow"] = nil --tolua.cast( Layer:getWidgetByName("ImageView_YiZhanYZ"), "ImageView" )
	cityArray[8]["Shadow"] = nil --tolua.cast( Layer:getWidgetByName("ImageView_ZhuChengYZ"), "ImageView" )
	cityArray[9]["Shadow"] = nil --tolua.cast( Layer:getWidgetByName("ImageView_ZhuChengYZ"), "ImageView" )
	
	cityArray[1]["lvBG"] = tolua.cast( Layer:getWidgetByName("ImageView_ZhuCheng_NameBG"), "Label" )
	cityArray[2]["lvBG"] = tolua.cast( Layer:getWidgetByName("ImageView_JuMin_NameBG"), "Label" )
	cityArray[3]["lvBG"] = tolua.cast( Layer:getWidgetByName("ImageView_GuoKu_NameBG"), "Label" )
	cityArray[4]["lvBG"] = tolua.cast( Layer:getWidgetByName("ImageView_JunJiChu_NameBG"), "Label" )
	cityArray[5]["lvBG"] = tolua.cast( Layer:getWidgetByName("ImageView_JiaoChang_NameBG"), "Label" )
	cityArray[6]["lvBG"] = tolua.cast( Layer:getWidgetByName("ImageView_JunXieChu_NameBG"), "Label" )
	cityArray[6]["lvBG"]:setScaleX(-1)
	cityArray[7]["lvBG"] = tolua.cast( Layer:getWidgetByName("ImageView_YiZhan_NameBG"), "Label" )
	cityArray[8]["lvBG"] = tolua.cast( Layer:getWidgetByName("ImageView_NongChang_NameBG"), "Label" )
	cityArray[9]["lvBG"] = tolua.cast( Layer:getWidgetByName("ImageView_KuangCang_NameBG"), "Label" )


	local function pubBtnCB(sender, eventType)
		local _btn = tolua.cast(sender, "Button")
		local _tag = _btn:getTag()
		if eventType == PT.ccs.TouchEventType.ended then 
			RW_guide.exitUI()--退出任务引导
			if _btn == cityArray[_tag]["city"] then
				if _tag == 1 then --1主城
					Pop3_ZhuCheng.enterUI( _tag )
				elseif _tag == 2 then --2民居
					Pop3_MinJu.enterUI( _tag  )
				elseif _tag == 3 then --3国库
					Pop3_GuoKu.enterUI( _tag  )
				elseif _tag == 4 then --4军机处
					Pop3_JunJiChu.enterUI( _tag  )
				elseif _tag == 5 then --5校场
					Pop3_JiaoChang.enterUI( _tag  )
				elseif _tag == 6 then --6军械库
					Pop3_JunXieKu.enterUI( _tag  )
				elseif _tag == 7 then --7驿站
					Pop3_YiZhan.enterUI( _tag  )
				elseif _tag == 8 then --8农场
					protoSend0x0434(0)
				elseif _tag == 9 then --9矿藏
					protoSend0x0434(1)
				end
			end
		end
	end
	for i=1, 9 do
		cityArray[i]["city"]:setTag(i)
		cityArray[i]["city"]:addTouchEventListener(pubBtnCB)
		cityArray[i]["city"]:setIfPixelTouch(true)
		if ifserver then
			cityArray[i]["city"]:setVisible(false)
			cityArray[i]["city"]:setTouchEnabled(false)
			
			cityArray[i]["lvBG"]:setVisible(false)
			if cityArray[i]["Shadow"] ~= nil then
				cityArray[i]["Shadow"]:setVisible(false)
			end
		end
	end


	flushCity()
            
	ScrollView_Map = tolua.cast( Layer:getWidgetByName("ScrollView_22"), "ScrollView" )

	local img_FengChe = nil
	local img_PuBu = {}
	local img_ShuiHua = {}
	local img_ShuiWen = {}


	local PathFengChe 	= {"10_5_1.png", "10_5_2.png"}
	local PathPuBu 		= {"5_5_1.png", "5_5_2.png"}
	local PathShuiHua 	= {"8_5_1.png", "8_5_2.png"}
	local PathShuiWen 	= {"9_5_1.png", "9_5_2.png"}

	local PuBuState = {true, false, true, false,true, false, true, false,true, false, true, false,true, false, true, false, true,false, true,false}
	local ShuiHuaState = {true, false, true, false, true, false, true,false}
	local ShuiWenState = {true, false, true, false,true, false, true, false, true, false,true, false, true,false}

	img_FengChe = tolua.cast( Layer:getWidgetByName("ImageView_efc_Feng"), "ImageView" )

	for i=1, 19 do
		img_PuBu[i] = tolua.cast( Layer:getWidgetByName("ImageView_efc_pubu_" .. i), "ImageView" )
	end
	for i=1, 8 do
		img_ShuiHua[i] = tolua.cast( Layer:getWidgetByName("ImageView_efc_shuihua_" .. i), "ImageView" )
	end
	for i=1, 14 do
		img_ShuiWen[i] = tolua.cast( Layer:getWidgetByName("ImageView_efc_shuiwen_" .. i), "ImageView" )
	end
	
---[[
	local resetSize = true
	local resetPosId = 0
    local function resetPos()
        if resetSize then
            resetSize = false
            --[=[		
            local posx, posy = getPosWithIdx(cityId)
            local _layout = ScrollView_Map:getInnerContainer()
	        ScrollView_Map:setSize(CCSize(UseW, UseH))
	        print("set Layout Posx = " .. posx)
	        print("set Layout Posy = " .. posy)
	        _layout:setPosition( ccp(posx, posy) )
	        cityId = 1
			--]=]
			ScrollView_Map:setSize(CCSize(UseW, UseH))
			ScrollView_Map:jumpToPercentVertical(0)
			ScrollView_Map:jumpToPercentHorizontal(100)
			
	        scheduler:unscheduleScriptEntry( resetPosId )
	        resetPosId = 0
        end
    end
	resetPosId = scheduler:scheduleScriptFunc( resetPos, 0.0002, false)
--]]

	local ifWith = false
            local function FlushPositionttt()
            	--[[
            	if resetSize then
            		resetSize = false
            		
            		local posx, posy = getPosWithIdx(cityId)
            		local _layout = ScrollView_Map:getInnerContainer()
	            	ScrollView_Map:setSize(CCSize(UseW, UseH))
	                print("set Layout Posx = " .. posx)
	                print("set Layout Posy = " .. posy)
	                _layout:setPosition( ccp(posx, posy) )
	                cityId = 1
            	end
                --]]
                --scheduler:unscheduleScriptEntry( MainCityTimeID )

                local t = 1
                
                if ifWith then
                	ifWith = false
                	img_FengChe:loadTexture("10_5_1.png")
                else
                	ifWith = true
                	img_FengChe:loadTexture("10_5_2.png")
                end
                for i=1, 8 do
                	if ShuiHuaState[i] then
                		ShuiHuaState[i] = false
                		img_ShuiHua[i]:loadTexture(PathShuiHua[2])
                	else
                		ShuiHuaState[i] = true
                		img_ShuiHua[i]:loadTexture(PathShuiHua[1])
                	end
                end    
                for i=1, 19 do
                	if PuBuState[i] then
                		PuBuState[i] = false
                		img_PuBu[i]:loadTexture(PathPuBu[1])
                	else
                		PuBuState[i] = true
                		img_PuBu[i]:loadTexture(PathPuBu[2])
                	end
                end    
                for i=1, 14 do
                	if ShuiWenState[i] then
                		ShuiWenState[i] = false
						img_ShuiWen[i]:loadTexture(PathShuiWen[1])
					else
                		ShuiWenState[i] = true
						img_ShuiWen[i]:loadTexture(PathShuiWen[2])
					end
                end

            end

            MainCityTimeID = scheduler:scheduleScriptFunc( FlushPositionttt, 0.2, false)

--添加粒子
	img_mapBG = tolua.cast( Layer:getWidgetByName("ImageView_23"), "ImageView" )
--[[	
	local emitter1 = CCParticleSystemQuad:create("src/Particles/flower.plist")
	local emitter2 = CCParticleSystemQuad:create("src/Particles/flower.plist")
	local emitter3 = CCParticleSystemQuad:create("src/Particles/flower.plist")
	local emitter4 = CCParticleSystemQuad:create("src/Particles/flower.plist")
	local emitter5 = CCParticleSystemQuad:create("src/Particles/flower.plist")
	local emitter6 = CCParticleSystemQuad:create("src/Particles/flower.plist")
	local emitter7 = CCParticleSystemQuad:create("src/Particles/flower.plist")
	

	emitter1:setPosition(ccp(770, 780))
	emitter2:setPosition(ccp(850, 730))
	emitter3:setPosition(ccp(930, 680))
	emitter4:setPosition(ccp(900, 870))
	emitter5:setPosition(ccp(1000, 820))

	emitter6:setPosition(ccp(700,1280))
	emitter7:setPosition(ccp(780, 1200))

	img_mapBG:addNode(emitter1)
	img_mapBG:addNode(emitter2)
	img_mapBG:addNode(emitter3)
	img_mapBG:addNode(emitter4)
	img_mapBG:addNode(emitter5)
	img_mapBG:addNode(emitter6)
	img_mapBG:addNode(emitter7)
--]]	
	local emitterbig = CCParticleSystemQuad:create("src/Particles/flower2.plist")
	emitterbig:setPosition(ccp(990, 790))
	img_mapBG:addNode(emitterbig)
end

function flushCityLv(_id, _lv)
	if cityArray[_id]["lv"] ~= nil then
		cityArray[_id]["lv"]:setText(_lv)
	end
end

local _widget = nil

function closeTimeG()
	if 0 ~= MainCityTimeID then
		scheduler:unscheduleScriptEntry( MainCityTimeID )
		MainCityTimeID = 0
	end
end
function exitUI()

			if Layer ~= nil and _widget ~= nil then
				Layer:removeWidget(_widget)
				_widget = nil
				Layer = nil

				LM.STATE_1 = 0
			end
		print("首页 MainCityTimeID == " .. MainCityTimeID)
			if 0 ~= MainCityTimeID then
				scheduler:unscheduleScriptEntry( MainCityTimeID )
				MainCityTimeID = 0
			end
			--LM.clearLayer2To9()
			LM.clearMainCity()
end
function enterUI()
		LM.STATE_1 = UI_ZhuCheng

		Layer = LM.getLayer1Base_ccf()	

		_widget = GUIReader:shareReader():widgetFromJsonFile("ShouYe_Base.json")   

	    Layer:addWidget(_widget)
	    _widget:setTouchEnabled(false)

	    MapPubUI.setMainBtn()

	    initShouYeUI()


    
end
