module ("MapZhengZhan",package.seeall)

local Layer = nil 
local _widget = nil
local scene = nil

local MapNpcMax   = 0 --npc最大数量
local HideNpcMax  = 0 --隐藏npc最大数量
local MapNpcList  = {}
local HideNpcList = {}
local img_Player  = nil
local remPlayerId = 0

local remCharpterId = 0  --记录当前章节 id
local remNpcId = 0

local ScrollView_map = nil

local cache = CCSpriteFrameCache:sharedSpriteFrameCache()

local curCharpterW = 0
local curCharpterH = 0

local lbl_playerName = nil
local lbl_SaoDang = nil
--记录当前正在打的npc，用来从战斗返回时，
--确立当前焦点在正在打的这个npc上，切换章节或者值=0时，焦点停留在正在打的npc上
local remCurNpc = 0 
function clearremCurNpc()
    --此函数用于章节切换时调用，已清空记录
    remCurNpc = 0 
end
function CloseSaoDang()
    if lbl_SaoDang ~= nil then
        lbl_SaoDang:setVisible(false)
        lbl_SaoDang:removeFromParent()
    end
end
function openSaoDang()
   --[[
    local _type, _charpterid, _npcid = SDNpcData.getBaseData()
    if _type == 2 then --普通npc
        if _charpterid == remCharpterId then
            lbl_SaoDang =Label:create()
            lbl_SaoDang:setText("扫荡中...")
            lbl_SaoDang:setColor(ccc3(255,0,0))
            lbl_SaoDang:setPosition(ccp(20,25))
            lbl_SaoDang:setFontSize(22)

            MapNpcList[_npcid]:addChild(lbl_SaoDang)
        end
    elseif _type == 3 then --隐藏npc

    end
    --]]

    if remCharpterId ~= -1 then
        if remNpcId ~= 0 then
            print("开启扫荡。。。。")
            lbl_SaoDang = Label:create()
            lbl_SaoDang:setText("扫荡中...")
            lbl_SaoDang:setColor(ccc3(255,0,0))
            lbl_SaoDang:setPosition(ccp(20,25))
            lbl_SaoDang:setFontSize(22)

            MapNpcList[remNpcId]:addChild(lbl_SaoDang)
        end
    else --隐藏npc

    end
end
function justFro473()
    -- body
    --lbl_playerName:setText( PlayerData.getName() )
end
local function getPosWithIdx( _idx )
---[[
    local _x, _y = MapNpcList[_idx]:getPosition()

    local posx = _G.UseW/2 - _x
    local posy = _G.UseH/2 - _y

    local disW = math_abs(curCharpterW-_G.UseW)
    local disH = math_abs(curCharpterH-_G.UseH)

    if posx >= 0 then
        posx = 0
    elseif posx < -disW then
        posx = -disW
    end
            
    if posy >= 0 then
        posy = 0
    elseif posy < -disH then
        posy = -disH
    end
--]]

    return posx, posy
end

function getWordPositon( _idx )
    if _idx == nil or _idx == 0 then
        return 
    end
    local _x, _y = MapNpcList[_idx]:getPosition()
    local _arcPoint = MapNpcList[_idx]:getAnchorPoint()
    local _size = MapNpcList[_idx]:getSize()

--引导设置不滑动

    MapNpcList[_idx]:setCanBeMoveForScrollView(false)
    local _layout = ScrollView_map:getInnerContainer() 
    local posx, posy = getPosWithIdx(_idx)
    _layout:setPosition( ccp(posx, posy) )
    --print("_x == " .. _x)
    --print("_y == " .. _y )
    _x = _x - _size.width*_arcPoint.x
    _y = _y - _size.height*_arcPoint.y
    --print("posx == " .. posx)
    --print("posy == " .. posy )
    _x = _x - math_abs(posx)
    _y = _y - math_abs(posy)
    --print("_x == " .. _x)
    --print("_y == " .. _y )
    local pos = CCDirector:sharedDirector():convertToUI(ccp(_x, _y));
    
    return pos.x, UseH-pos.y
end

function setScrollViewMove()

    for i=1, MapNpcMax do
        MapNpcList[i]:setCanBeMoveForScrollView(true)
    end

end

local function createMovingFlag(imgNpc,_wich)
    local sprite= CCSprite:create("pic1-".._wich.."_level_1.png")
    sprite:setPosition(ccp(-25,60))
    imgNpc:addNode(sprite)
    local animation = CCAnimation:create()  
    for i = 1, 4 do  
        local szImageFileName ="pic1-".._wich.."_level_"..i..".png"
        animation:addSpriteFrameWithFileName(szImageFileName);    
    end 
    animation:setDelayPerUnit(0.15) 
    local action = CCAnimate:create(animation);  
    local  repeatForever = CCRepeatForever:create(action)
    sprite:runAction(repeatForever)
    return sprite
end

local function addMessage(_imageNpc,_npcMessage)
    local posX =10
    local posY =50
    local num =#_npcMessage
    for i=1, num do
            if  _npcMessage[i] ~= 0 then
                local imgMessage = ImageView:create()
                imgMessage:loadTexture("pic"..(_npcMessage[i]+3).."_level_1.png")
                if i==2 then
                    imgMessage:setPosition(ccp(posX+24*(i-1),posY+12))
                else
                    imgMessage:setPosition(ccp(posX+24*(i-1),posY))
                end
                _imageNpc:addChild(imgMessage) 
            end      
       
    end

end
function flushMap(  )
    local _data = nil
    local _num = 0 --npc数据数量
    
    if ifserver then
        _data = NpcListData.getNpcDataList()
        _num = #_data
        print("npc num == " .. _num)
    else
        _num = 15
    end

    for i=1, _num do
        local _iii = nil
        local npcId = 0
        local state = 1
        local lv = 0
        local ifSaoDang = false
        if ifserver  then
                _iii = _data[i]
                npcId = _iii["Id"]
                state = _iii["State"]
                --lv = _iii["NpcLv"]
        else
                npcId = i
                if i == 1 then
                    state = 0
                end
        end
        print("remCharpterId, npcId == " .. remCharpterId .. "  " .. npcId)
        
        ifSaoDang = SDNpcData.checkIfSaoDang(remCharpterId, npcId)

        local NpcDes = Des.getBattleDesFromId( remCharpterId, npcId )
        jeneralName = NpcDes["name"]
       -- lbl_name:setText(jeneralName)
        print("jeneralName == " .. jeneralName)
        --lbl_lv:setText("Lv:" .. lv)
        if state == 1 then --打通
            --MapNpcList[npcId]:loadTexture( "button+1_level.png" )
             
            local img_flag = ImageView:create()
            --img_flag:loadTexture("redFlag.png")
            img_flag:setTag(10)
            img_flag:setPosition( CCPoint( -25, 50 ) )
            MapNpcList[npcId]:addChild( img_flag )
            img_flag:loadTexture("pic1-3_level_1.png")
            local lbl_name =Label:create()
            lbl_name:setText(jeneralName)
            lbl_name:setColor(ccc3(0,0,0))
            lbl_name:setPosition(ccp(-10,0))
            img_flag:addChild(lbl_name)

        elseif state == 2 then --正在打
            local sprite=createMovingFlag(MapNpcList[npcId],1)
            local lbl_name =Label:create()
            lbl_name:setText(jeneralName)
            lbl_name:setColor(ccc3(0,0,0))
            lbl_name:setPosition(ccp(20,25))
            sprite:addChild(lbl_name)

            if remCurNpc == 0 then
                remCurNpc = npcId
            end
            local posx, posy = getPosWithIdx(remCurNpc)
            local scheduler = CCDirector:sharedDirector():getScheduler()
            local EntryID = 0
            local function FlushPosition()
                
                local _layout = ScrollView_map:getInnerContainer() 
                ScrollView_map:setSize(CCSize(_G.UseW, _G.UseH))


                _layout:setPosition( ccp(posx, posy) )
                scheduler:unscheduleScriptEntry( EntryID )
                EntryID = 0
                --检测引导
                print("posx == " .. posx)
                print("posx == " .. posy)
                print("检测引导 。。。")

                if PlayerData.getCamp() ~= 4 then --如果有阵营，没有阵营的话不从这里检测引导
                    --guideFactory.CheckGuideProcess(scene)
                end
            end
            EntryID = scheduler:scheduleScriptFunc( FlushPosition, 0.01, true)

        elseif state == 0 then --未打通
            local sprite=createMovingFlag(MapNpcList[npcId],2)
            local lbl_name =Label:create()
            lbl_name:setText(jeneralName)
            lbl_name:setColor(ccc3(0,0,0))
            lbl_name:setPosition(ccp(20,25))
            sprite:addChild(lbl_name)
        end
        MapNpcList[npcId]:setVisible(true)
        MapNpcList[npcId]:setTouchEnabled(true)

        if ifSaoDang then

            lbl_SaoDang =Label:create()
            lbl_SaoDang:setText("扫荡中...")
            lbl_SaoDang:setColor(ccc3(255,0,0))
            lbl_SaoDang:setPosition(ccp(20,25))
            lbl_SaoDang:setFontSize(22)

            MapNpcList[npcId]:addChild(lbl_SaoDang)
        end
    end

    --------隐藏npc处理
    _data = NpcListData.getHideNpcData()
    _num = #_data

    if #HideNpcList == 0 then
        _num = 0
        print("工程里没有隐藏npc, 但是却有隐藏npc的数据结构，请检查错误....")
    end

    for i=1, _num do
        local _iii = nil
        local HideNpcId = 0
        local state = 1
        local lv = 0

        _iii = _data[i]
        HideNpcId = _iii["Id"]
        state = _iii["State"]

        local NpcDes = Des.getHideBattleDesFromId( HideNpcId )
        jeneralName = NpcDes["name"]
        
        if state ~= 0 then --开启
            HideNpcList[i]:setTouchEnabled(true)
            HideNpcList[i]:setVisible(true)

            local sprite=createMovingFlag(HideNpcList[i],1)
            local lbl_name =Label:create()
            lbl_name:setText(jeneralName)
            lbl_name:setColor(ccc3(0,0,0))
            lbl_name:setPosition(ccp(20,25))
            sprite:addChild(lbl_name)


            local _lblBG = ImageView:create()
            _lblBG:loadTexture("floor+50_public.png")
            _lblBG:setScaleX(0.3)
            _lblBG:setScaleY(0.5)
            _lblBG:setAnchorPoint(ccp(0.5, 0.5))
            _lblBG:setPosition(ccp(0, -40))

            local _lbl = Label:create()
            _lbl:setText( "00:00:00" )
            _lbl:setFontSize( 16 )
            _lbl:setColor(ccc3(222,175,69))
            _lbl:setAnchorPoint(ccp(0.5, 0.5))
            _lbl:setPosition(ccp(0, -40))

            
            HideNpcList[i]:addChild( _lblBG )
            HideNpcList[i]:addChild( _lbl )
            NpcListData.setHideNpcLableFromId( HideNpcId, _lbl, _lblBG, HideNpcList[i] )
        end
    end
end

    function reloadSource()
        local sourceTab = {
            "GuanKa_1.jpg",
            "GuanKa_2.jpg",
            "GuanKa_3.jpg",
            "GuanKa_4.jpg",
            "GuanKa_5.jpg",
            "GuanKa_6.jpg",
            "GuanKa_7.jpg",
            "GuanKa_8.jpg",
            "GuanKa_9.jpg",
            "GuanKa_10.jpg",
            "GuanKa_11.jpg",
            "GuanKa_12.jpg",
            "GuanKa_13.jpg",
            "GuanKa_14.jpg",
            "GuanKa_15.jpg",
            "GuanKa_16.jpg",
            "GuanKa_17.jpg",
            "GuanKa_18.jpg",
            "GuanKa_19.jpg",
            "GuanKa_20.jpg",
            "GuanKa_21.jpg",
            "GuanKa_22.jpg",
            "GuanKa_23.jpg",
 
        }
        Loading:LoadingShow()
        local sourceNum = #sourceTab
        function yujiazai()
            print("预加载章节图片成功....")
            Loading:LoadingHide()
        end
        local pngs = CCArray:create() 
        for i=1, #sourceTab do
            pngs:addObject(CCString:create( sourceTab[i] ))
        end
        local tload = AsynResLoader:create()
        tload:asynLoadTexture(pngs, yujiazai, 1)  
    end


local function initMap()

reloadSource()
    lbl_SaoDang = nil
    ScrollView_map = tolua.cast( Layer:getWidgetByName( "ScrollView_map" ), "ScrollView" )
---[=[    
    local remStateTouch = true
    local function pubBtnCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then 
            if remStateTouch ~= true then
                return
            end

            local _img = tolua.cast(sender, "ImageView")
            local _tag = _img:getTag()
            remNpcId = _tag
            print("tag == " .. _tag)
            remStateTouch = false
            --记录当前正在打的npc
            remCurNpc = _tag
            if ifserver then
                remStateTouch = true
                PT.setId(remCharpterId, remNpcId, 0)
                local npcdata = NpcListData.getNpcDataFromId(remNpcId,false)
                if npcdata["State"] == 0 then
                    Pop3_TS_Result.enterUI( "此npc未开启！"  )
                else 
                    protoSend0x0204( remCharpterId, remNpcId )
                end
            else
                Pop3_ZhengZhan.enterUI()
            end
        end
    end
    local function pubHideBtnCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then 
            if remStateTouch ~= true then
                return
            end
            local _img = tolua.cast(sender, "ImageView")
            local remHideNpcId = _img:getTag()
            local data = NpcListData.getHideNpcDataFromId( remHideNpcId )
            print("tag == " .. remHideNpcId)
            remStateTouch = false
            if ifserver then
                remStateTouch = true
                
                PT.setId(-1, remHideNpcId, 0)
                local npcdata = NpcListData.getNpcDataFromId(remHideNpcId,true)
                
                if npcdata["State"] == 0 then
                    Pop3_TS_Result.enterUI( "此npc未开启！"  )
                else
                    protoSend0x0204( -1, remHideNpcId )
                end
            else
                Pop3_ZhengZhan.enterUI()
            end   
        end
    end 
if ifserver then
    --设置默认章节id
    print("remCharpterId == " .. remCharpterId)
    remCharpterId = ChapterListData.getCurCharpterId() --不一定是默认章节，也可以翻页
    remNpcId = 0
    local CharpterDes = Des.getChapterDesFromId(remCharpterId)
    
    curCharpterW = CharpterDes["mapW"]
    curCharpterH = CharpterDes["mapH"]
    MapNpcMax = CharpterDes["chapterNumber"] --获取当前章节的npc数量最大值
    HideNpcMax = CharpterDes["hideNPCNumber"] --隐藏npc数量

else
    HideNpcMax =2
    MapNpcMax = 16
    curCharpterW = 1440
    curCharpterH = 640
    remCharpterId = 1
end 
    MapNpcList = {}
    for i=1, MapNpcMax do
        print("i == " .. i)
        local name = "ImageView_NPC" .. i
        MapNpcList[i] = tolua.cast( Layer:getWidgetByName( name ), "ImageView" )
        MapNpcList[i]:setTouchEnabled(true)
        MapNpcList[i]:setTag(i)
        MapNpcList[i]:addTouchEventListener(pubBtnCB)
        local npcDes = Des.getBattleDesFromId( remCharpterId,i)
        local npcMessage= npcDes["battleGeneral"]
        addMessage(MapNpcList[i],npcMessage)
    end
    HideNpcList = {}
    for i=1, HideNpcMax do
        local name = "ImageView_YinCangNPC" .. i
        HideNpcList[i] = tolua.cast( Layer:getWidgetByName( name ), "ImageView" )
        HideNpcList[i]:setTouchEnabled(false)
        HideNpcList[i]:setVisible(false)
        
        HideNpcList[i]:addTouchEventListener(pubHideBtnCB)

        local hideNpcData = NpcListData.getHideNpcDataFromIdx(i)
        local hideNpcDes = Des.getHideBattleDesFromId( hideNpcData["Id"] )
        local npcMessage= hideNpcDes["battleGeneral"]
        addMessage(HideNpcList[i],npcMessage)
        HideNpcList[i]:setTag( hideNpcData["Id"] )
    end

if ifserver then
    flushMap()
end
    
--]=]
end


function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        _widget = nil
        Layer = nil
        LM.STATE_2 = 0
    end
end

function enterUI( _curcharpterid )

    LM.STATE_2 = UI_ZhengZhan
    Layer = LM.getLayer2()

    _widget = GUIReader:shareReader():widgetFromJsonFile("ShouYe_ZhengZhan_" .. _curcharpterid .. ".json")
    
    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)

    initMap()
end

--[[
function exitUI()
	scene:removeChild(Layer, true)
end

function enterUI(curScene, _curcharpterid)
    scene = curScene
    PT.UI_State = UI_ZhengZhan
    Layer = TouchGroup:create()
    Layer:setZOrder(0)
    print("初始化 哪一个章节的json 需要配表。。。")

    if ifserver == false then
        _curcharpterid = 1        
    end

    local _widget = GUIReader:shareReader():widgetFromJsonFile("ShouYe_ZhengZhan_" .. _curcharpterid .. ".json")    
    Layer:addWidget(_widget)
    _widget:setTouchEnabled(false)
 	scene:addChild(Layer)

    initMap()
    --guideFactory.CheckGuideProcess(scene)
end
--]]