module ("Map_RankPerDay",package.seeall)
local Layer = nil
--local scene = nil
--local remFatherUi = nil
local _widget = nil

function initPub()
    local my_type,my_rank,my_value,my_reward = RankData.get_myvalue()
   -- local lbl_type	= tolua.cast( Layer:getWidgetByName("Label_PaiMingName"), "Label" )
    local img_type = tolua.cast( Layer:getWidgetByName("ImageView_PaiMingName"), "ImageView" )
    local lbl_descript	= tolua.cast( Layer:getWidgetByName("Label_PaiMingType"), "Label" )
    local lbl_my_rank	= tolua.cast( Layer:getWidgetByName("Label_MyPaiMing"), "Label" )
    local lbl_my_value	= tolua.cast( Layer:getWidgetByName("Label_MyShuJu"), "Label" )
    local lbl_my_reward	= tolua.cast( Layer:getWidgetByName("Label_MyAwads"), "Label" )
    local img_paiming = {}
    img_paiming[1] = tolua.cast( Layer:getWidgetByName("ImageView_ShuJu1"), "ImageView" )
    img_paiming[2] = tolua.cast( Layer:getWidgetByName("ImageView_ShuJu2"), "ImageView" )
    img_paiming[3] = tolua.cast( Layer:getWidgetByName("ImageView_ShuJu3"), "ImageView" )
    img_paiming[4] = tolua.cast( Layer:getWidgetByName("ImageView_ShuJu4"), "ImageView" )
    img_paiming[5] = tolua.cast( Layer:getWidgetByName("ImageView_ShuJu5"), "ImageView" )
    local value_title = tolua.cast( Layer:getWidgetByName("Label_BianLiangTitle"), "Label" )
    local btn_close = tolua.cast( Layer:getWidgetByName("Button_Close"), "Button" )
    local function btn_CB(sender, eventType)
       if eventType == PT.ccs.TouchEventType.ended then        
            local _btn = tolua.cast(sender, "Button")
            if _btn == btn_close then --左翻页
                exitUI()
            end
        end
    end

    btn_close:addTouchEventListener( btn_CB )
    if my_rank == 0 then
    lbl_my_rank:setText("未上榜")
    lbl_my_reward:setText("无")
    else
    lbl_my_rank:setText(my_rank)
    lbl_my_reward:setText(my_reward)
    end
    lbl_my_value:setText(my_value)

    if my_type == 1 then 
        --lbl_type:setText("神兵利器")
        img_type:loadTexture("floor+1_paiming_3.png")
        lbl_descript:setText("(获得装备数)")
        value_title:setText("获得装备数量")
    elseif my_type == 2 then
        --lbl_type:setText("战神在世")
        img_type:loadTexture("floor+1_paiming_4.png")
        lbl_descript:setText("(获得威望数)")
        value_title:setText("获得威望数量")
    elseif my_type == 3 then
        --lbl_type:setText("富甲天下")
        img_type:loadTexture("floor+1_paiming_5.png")
        lbl_descript:setText("(获得银币数)")
        value_title:setText("获得银币数量")
    elseif my_type == 4 then
        --lbl_type:setText("征战四方")
        img_type:loadTexture("floor+1_paiming_6.png")
        lbl_descript:setText("(消耗的军功数)")
        value_title:setText("消耗军功数量")
    elseif my_type == 5 then
        --lbl_type:setText("一往无前")
        img_type:loadTexture("floor+1_paiming_2.png")
        lbl_descript:setText("(攻击NPC次数)")
        value_title:setText("攻击NPC次数")
    elseif my_type == 6 then
        --lbl_type:setText("三国无双")
        img_type:loadTexture("floor+1_paiming_7.png")
        lbl_descript:setText("(攻打玩家次数)")
        value_title:setText("攻打玩家次数")
    end
    for i=1,5 do
        if i > RankData.getRankCount() then
            PT.hideWidget(img_paiming[i])
        else
            PT.showWidget(img_paiming[i])
            local data = RankData.getRankData(i)
            local lbl_temp = "Label_PaiMing" .. i
            local lbl_paiming	= tolua.cast( Layer:getWidgetByName(lbl_temp), "Label" )
            lbl_paiming:setText(data["Id"])
            lbl_temp = "Label_Lv" .. i
            lbl_paiming	= tolua.cast( Layer:getWidgetByName(lbl_temp), "Label" )
            lbl_paiming:setText(data["Lv"])
            lbl_temp = "Label_BianLiang" .. i
            lbl_paiming	= tolua.cast( Layer:getWidgetByName(lbl_temp), "Label" )
            lbl_paiming:setText(data["Value"])
            lbl_temp = "Label_GuoJia" .. i
            lbl_paiming	= tolua.cast( Layer:getWidgetByName(lbl_temp), "Label" )
            lbl_paiming:setText(data["Camp"])
            lbl_temp = "Label_Name" .. i
            lbl_paiming	= tolua.cast( Layer:getWidgetByName(lbl_temp), "Label" )
            lbl_paiming:setText(data["Name"])

        end
    end

end
function exitUI()
    --PT.UI_State = remFatherUi 
    --scene:removeChild(Layer, true)
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        _widget = nil
        Layer = nil
        
        LM.STATE_3 = 0
    end
    RankData.clearRankData()
    MapPubUI.setPubVisible(true)
end
function enterUI( _curScene )
--[[
	remFatherUi = PT.UI_State 
	scene = _curScene
    Layer = TouchGroup:create()
    Layer:setZOrder(10)
    local _widget = GUIReader:shareReader():widgetFromJsonFile("RankPerDay.json")    

    Layer:addWidget(_widget)
    scene:addChild(Layer)
	
    scene:addChild( TouchEffect.setTouchEffect()  )
--]]
    LM.STATE_3 = 0

    Layer = LM.getLayer3()
    _widget = GUIReader:shareReader():widgetFromJsonFile("RankPerDay.json") 

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)

    MapPubUI.setPubVisible(false)
	
	initPub()
    ----------------------------------------------

    --PT.registerExitApp( Layer )

end
