module ("BuyJunLing",package.seeall)
local Layer = nil
local widget = nil

--购买军令

local function initPubMod( _baseNum, _maxNum )
	local lbl_buyNum = tolua.cast( Layer:getWidgetByName("Label_CiShuNum"), "Label" )
	local lbl_buyValue = tolua.cast( Layer:getWidgetByName("Label_jinBiNum"), "Label" )

	local btn_Jia = tolua.cast( Layer:getWidgetByName("Button_JiaLing"), "Button" )
	local btn_Jian = tolua.cast( Layer:getWidgetByName("Button_JianLing"), "Button" )
	local btn_gouMai = tolua.cast( Layer:getWidgetByName("Button_gouLing"), "Button" )
	local btn_close = tolua.cast( Layer:getWidgetByName("Button_GuanBi"), "Button" )

	local loading_Bar = tolua.cast( Layer:getWidgetByName("LoadingBar_bar"), "LoadingBar" )
	local slider_Bar = tolua.cast( Layer:getWidgetByName("Slider_bar"), "Slider" )

	--初始化
	local buyNum = 0 			--最小可购买数量
	local MaxNum = _maxNum 		--最大可购买数量

	lbl_buyNum:setText("0")
	lbl_buyValue:setText("0")

	loading_Bar:setPercent(7)
	slider_Bar:setPercent(7)

	local _min = 7  
	local _max = 93

	--计算消费
	local function getResult( _baseNum, _noNum )
		local _num = 0
		for i=1, _noNum do
			local _t = math.ceil( (_baseNum+i)/2 )*2
			if _t > 50 then
				_num = _num + 50
				--print("i == 50")
			else
				_num = _num + _t
				--print("i == " .. _t)
			end
		end
		return _num
	end
	local function percentChangedEvent(sender,eventType)
        if eventType == PT.ccs.SliderEventType.percent_changed then
            local slider = tolua.cast(sender,"Slider")
            local percent = slider:getPercent()
            loading_Bar:setPercent(percent)
   
            if percent < _min then
            	slider:setPercent(_min)
            	loading_Bar:setPercent(_min)

            	buyNum = 0
            	lbl_buyNum:setText( buyNum )
            	--todo:计算价格
            	lbl_buyValue:setText( getResult(_baseNum, buyNum) .. "金币" )
            	return
            elseif percent > _max then
            	slider:setPercent(_max)
            	loading_Bar:setPercent(_max)

            	buyNum = MaxNum
            	lbl_buyNum:setText( buyNum )
            	--todo:计算价格
            	lbl_buyValue:setText( getResult(_baseNum, buyNum) .. "金币" )
            	return
            end
  				
            buyNum = math.floor(percent*MaxNum/(_max-_min))
            lbl_buyNum:setText( buyNum )
            lbl_buyValue:setText( getResult(_baseNum, buyNum) .. "金币" )

        end

    end
    slider_Bar:addEventListenerSlider(percentChangedEvent)

	local function touchEvent(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then 
			local _btn = tolua.cast(sender, "Button")
			if _btn == btn_Jia then
				buyNum = buyNum + 1
				if buyNum > MaxNum then
					buyNum = MaxNum
					slider_Bar:setPercent(_max)
            		loading_Bar:setPercent(_max)
            	else
            		local persent = 7+ buyNum*((_max-_min)/MaxNum)
					slider_Bar:setPercent(persent)
            		loading_Bar:setPercent(persent)
				end

				lbl_buyNum:setText( buyNum )
				--todo:计算价格
				lbl_buyValue:setText( getResult(_baseNum, buyNum) .. "金币" )
			elseif _btn == btn_Jian then 
				buyNum = buyNum - 1
				if buyNum < 0 then
					buyNum = 0
					slider_Bar:setPercent(_min)
            		loading_Bar:setPercent(_min)
            	else
            		local persent = 7+ buyNum*((_max-_min)/MaxNum)
					slider_Bar:setPercent(persent)
            		loading_Bar:setPercent(persent)
				end
				lbl_buyNum:setText( buyNum )
				--todo:计算价格
				lbl_buyValue:setText( getResult(_baseNum, buyNum) .. "金币" )
			elseif _btn == btn_gouMai then --购买军令
				--protoSend0x0522(1, buyNum)

				Pop3_XFTiShi.enterUI(522, "购买" .. buyNum .. "军令，需要消费" .. getResult(_baseNum, buyNum) .. "金币，是否确认？", buyNum, nil )
				exitUI()
			elseif _btn == btn_close then --关闭游戏
				exitUI()
			end
		end
	end

    btn_Jia:addTouchEventListener( touchEvent )
    btn_Jian:addTouchEventListener( touchEvent )

    btn_close:addTouchEventListener( touchEvent )
    btn_gouMai:addTouchEventListener( touchEvent )

end


function exitUI()
	if Layer ~= nil and widget ~= nil then
		Layer:removeWidget(widget)
		widget = nil
		Layer = nil
	end
	LM.STATE_10 = 0

end
function enterUI( baseNum, maxNum  )
	LM.STATE_10 = 1

	Layer = LM.getLayer10()
	widget = GUIReader:shareReader():widgetFromJsonFile("Pop3_GouLing.json") 

    Layer:addWidget(widget)
    widget:setTouchEnabled(true) --false 具有穿透效果，true 没有

    initPubMod(baseNum, maxNum)

end