module ("Pop3_ChangePlayerName",package.seeall)

local curLayer = nil
local widget = nil

local function initPanel()
	local tf_name = tolua.cast(curLayer:getWidgetByName("TextField_InName"), "TextField" )
	--关闭
	local btn_close = tolua.cast( curLayer:getWidgetByName("Button_Close"), "Button" )
	local btn_ChangeName = tolua.cast( curLayer:getWidgetByName("Button_Change"), "Button" )

	local function btn_closeCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then 
			local _btn= tolua.cast(sender, "Button")
			if _btn == btn_close then
				exitUI()
			elseif _btn == btn_ChangeName then
 				name = tf_name:getStringValue()
                local state = false
                if string.len(name) > 0 then
                    --屏蔽字校验
                    name, state = ShieldWord.checkShieldWord(name) 
                end
                if state then --存在屏蔽字
                    Pop3_TS_Result.enterUI("您的名字包含敏感字符！")
                else
                    local _ps = TextManager:u82gbk(name)

                    if _ps == nil then
                        Pop3_TS_Result.enterUI("名字不能为空")
                    else
                        protoSend0x0472(_ps, 2)
                        exitUI()
                    end
        
                end
			end
		end
	end

	btn_ChangeName:addTouchEventListener( btn_closeCB )
	btn_close:addTouchEventListener( btn_closeCB )

end

function exitUI()
	if curLayer ~= nil and widget ~= nil then
		curLayer:removeWidget(widget)
		--curLayer:clear()
		widget = nil
		curLayer = nil
		

	end

end
function enterUI()

	curLayer = LM.getLayer20()
	widget = GUIReader:shareReader():widgetFromJsonFile("ChangePlayerName.json")

	curLayer:addWidget(widget)
    widget:setTouchEnabled(true)

    
    initPanel()
	
end