module ("Pop3_JunTuanZhan",package.seeall)
--征战军团战三级UI
--local curScene = nil
local curLayer = nil
local widget = nil
local _scrollviewRoomList = nil
local remRoomIdx = 0
local ifCreat = 0 --无效状态  1：创建房间 2：加入房间
local btn_JieSan = nil
local btn_GongJi = nil
local btn_help = nil 
local img_inRoom = nil
local img_outRoom = nil
local lbl_curRoleNum = nil --房间人数
local lbl_curRoomNum = nil --房间数
local _scrollviewRoleList = nil

local lbl_JieSan = nil 
local lbl_GongJi = nil
local lbl_AuTo = nil
local lbl_Creat = nil
local lbl_help = nil

local function setBtnHelpState(_state)
	local charpterId, NpcId, _ = PT.getId()
	if charpterId >3 then
		btn_help:setTouchEnabled(_state)
		btn_help:setVisible(_state)
	else
		btn_help:setTouchEnabled(false)
		btn_help:setVisible(false)
	end
end
local function setlabelBmFont()
	lbl_JieSan:setTouchEnabled(false)
	lbl_GongJi:setTouchEnabled(false)
	lbl_AuTo:setTouchEnabled(false)
	lbl_Creat:setTouchEnabled(false)	
	lbl_help:setTouchEnabled(false)
end
local function setRoomListTouchEnable( _state )
	local num = _scrollviewRoomList:getChildrenCount()
	print("num === " .. num)
	--减去一个焦点图
		for i = 1, (num-1) do
			local data = JTNpcRoomData.getRoomlistdataFromIdx(i)

			local _img = tolua.cast(_scrollviewRoomList:getChildByTag(i), "ImageView")
			local _btn = tolua.cast(_img:getChildByTag(i), "Button")
			_img:setTouchEnabled(_state)
			_btn:setTouchEnabled(_state)

			if data["CurNum"] ==data["MaxNum"] then --房间人满了就一定是false了
				_img:setTouchEnabled(false)
				_btn:setTouchEnabled(false)
			end
		end

end
function flushRoleListScrollview(  )
	local teamId = JTNpcRoomData.getTeamId()
	print("flush get teamId ==== " .. teamId)
	if teamId == "" then --不在房间
		ifCreat = 0

		setRoomListTouchEnable(true)
		PT.hideWidget(img_inRoom)
		PT.showWidget(img_outRoom)
		setlabelBmFont()
	else
		PT.hideWidget(img_outRoom)
		PT.showWidget(img_inRoom)
		setlabelBmFont()
		if JTNpcRoomData.getIfLead() == 0 then --在房间，不是队长
			ifCreat = 2
				--在房间，显示退出
			lbl_GongJi:setText("退 出")

			btn_JieSan:setVisible(false)
			btn_JieSan:setTouchEnabled(false)

			setBtnHelpState(false)
		else--在房间，是队长
			ifCreat = 1
			lbl_GongJi:setText("开 战")
			btn_JieSan:setVisible(true)
			btn_JieSan:setTouchEnabled(true)

			setBtnHelpState(true)
		end
	end



	print("teamId === " .. teamId)
	if teamId ~= "" then
		local curNum, maxNum = JTNpcRoomData.getPerSentSize()
		lbl_curRoleNum:setText( curNum .. "/" .. maxNum )
	else
		lbl_curRoleNum:setText("0/8")
	end
	_scrollviewRoleList:removeAllChildren()
	if teamId == "" then
		return 
	end

	local cell_disY = 3
    local cell_W, cell_H = 374, 46
        --可视区域
    local view_W = _scrollviewRoleList:getSize().width 
    local view_H = _scrollviewRoleList:getSize().height 

    local Datanum = 8
    Datanum = JTNpcRoomData.getRoleListSize()
    print("Datanum ===----- " .. Datanum)

if Datanum == 0 then
	PT.hideWidget(img_inRoom)
	PT.showWidget(img_outRoom)
	setlabelBmFont()
	setRoomListTouchEnable(true)
	return
end

    _scrollviewRoleList:setInnerContainerSize( CCSize(view_W, cell_H*Datanum+(Datanum-1)*cell_disY) )

    --滑动区域
    local scroll_W = _scrollviewRoleList:getInnerContainerSize().width
    local scroll_H = _scrollviewRoleList:getInnerContainerSize().height

    
    local cell_X, cell_Y = scroll_W/2, scroll_H-cell_H/2

    local celltab = {}

	local function AddTouchCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			RW_guide.exitUI()--关闭任务引导
			local _btn = tolua.cast(sender, "Button")
			local tag = _btn:getTag()
			--table_remove( celltab, tag )
			
			local function CallFucnCallback2(sender)
				---[[
				for i=tag+1, #celltab do
					local posx, posy = celltab[i]:getPosition()
					celltab[i]:setPosition( ccp(posx, posy+cell_H+cell_disY) )
				end
				--]]
				--[[
				for i=1, tag do
					local posx, posy = celltab[i]:getPosition()
					celltab[i]:setPosition( ccp(posx, posy-cell_H-cell_disY) )
				end
				--]]
				--[[
				local size = _scrollviewRoleList:getInnerContainerSize()

				if size.height-cell_H-cell_disY > view_H then
					local InnerContainer = _scrollviewRoleList:getInnerContainer()
					InnerContainer:setSize( CCSize( size.width, size.height-cell_H-cell_disY ) )
					local posx, posy = InnerContainer:getPosition()
					InnerContainer:setPosition( ccp(posx, 0) )
				end
				_scrollviewRoleList:removeChild( celltab[tag], true )
				--]]

			end

			local moveAct = CCMoveBy:create(0.1, ccp(400, 0))
			local nextfun = CCCallFuncN:create(CallFucnCallback2)

			local array = CCArray:create()
			array:addObject(moveAct)
			array:addObject(nextfun)
			celltab[tag]:runAction(CCSequence:create(array))

			local data = JTNpcRoomData.getRoleDataFromIdx( tag )
			local charpterId, NpcId, _ = PT.getId()
			--_scrollviewRoleList:removeAllChildren()
			local teamId = JTNpcRoomData.getTeamId()
			JTNpcRoomData.clearRoleList()
			protoSend0x0360( data["CharId"], teamId ,charpterId ,0, true )

		end
	end

    for i=1, Datanum do
    	local data = nil
    	local name = nil
    	local lv = nil
    	local bingli = false
if ifserver then
		data = JTNpcRoomData.getRoleDataFromIdx( i )
		name = data["Name"]
		lv = "lv: " .. data["Lv"]
		if data["HpType"] == 0 then
			bingli = false
		elseif data["HpType"] == 1 then
			bingli = true
		end
else

end

    	local imageView = ImageView:create()
		imageView:loadTexture("pic+1_team.png")
		imageView:setTag(i)
		imageView:setPosition( ccp( cell_X, cell_Y ) )
		--imageView:addTouchEventListener( CellTouchCB )
		imageView:setTouchEnabled(true)
			local lbl_name = Label:create()
			lbl_name:setText( name )
			lbl_name:setFontSize(18)
			lbl_name:setAnchorPoint( ccp(0, 0.5) )
    		--lbl_name:setColor( ccc3(255, 0, 0) )
    		lbl_name:setPosition(ccp(-170, 0))
    		--lbl_name:setVisible(false)
    	imageView:addChild(lbl_name)		
    	local Size = lbl_name:getContentSize()
		local lbl_Lv = Label:create()
			lbl_Lv:setText( lv )
			lbl_Lv:setFontSize(18)
			lbl_Lv:setAnchorPoint( ccp(0, 0.5) )
    		lbl_Lv:setPosition(ccp(-170+Size.width+10, 0))
    	imageView:addChild(lbl_Lv)

    	local lbl_chongzu = Label:create()
    	if bingli then
	    	lbl_chongzu:setText("兵力充足")
	    	lbl_chongzu:setColor( ccc3(131, 217, 18) )
    	else
	    	lbl_chongzu:setText("兵力不足")
	    	lbl_chongzu:setColor( ccc3(183, 15, 15) )
    	end
    	lbl_chongzu:setFontSize(18)
    	lbl_chongzu:setPosition(ccp(64, 0))

    	imageView:addChild(lbl_chongzu)

		if ifCreat == 1 and data["CharId"] ~= recv0x0103[INDEX_0x0103_CharId][VALUE] then --创建房间，可以踢掉队员
			local btn_del = Button:create()
		    btn_del:setTouchEnabled(true)
		    btn_del:setTag(i)
		    btn_del:loadTextures("button+12_team_1.png", "button+12_team_2.png", "")
		    btn_del:setPosition( CCPoint( 160, 0 ) )
		   	btn_del:addTouchEventListener( AddTouchCB )
		   	imageView:addChild(btn_del)
		end
	   	_scrollviewRoleList:addChild( imageView )
	   	table_insert( celltab, imageView )
	   	cell_Y = cell_Y - cell_disY - cell_H
    end
end



function flushRoomscrollview()

	if JTNpcRoomData.getTeamId() == "" then --不在房间
		ifCreat = 0
	else
		if JTNpcRoomData.getIfLead() == 0 then --在房间，不是队长
			ifCreat = 2
		else--在房间，是队长
			ifCreat = 1
		end
	end

	_scrollviewRoomList:removeAllChildren()

	local cell_disY = 3
    local cell_W, cell_H = 371, 80
        --可视区域
    local view_W = _scrollviewRoomList:getSize().width 
    local view_H = _scrollviewRoomList:getSize().height 

    local Datanum = 4

    Datanum = JTNpcRoomData.getRoomListSize()

    _scrollviewRoomList:setInnerContainerSize( CCSize(view_W, cell_H*Datanum+(Datanum-1)*cell_disY) )

    --滑动区域
    local scroll_W = _scrollviewRoomList:getInnerContainerSize().width
    local scroll_H = _scrollviewRoomList:getInnerContainerSize().height

    
    local cell_X, cell_Y = scroll_W/2, scroll_H-cell_H/2
	local imgFouce = ImageView:create()
	imgFouce:loadTexture("button+10_team_2.png")
	local function CellTouchCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			
			local _img = tolua.cast(sender, "ImageView")
			local tag = _img:getTag()
			if remRoomIdx == tag then
				return
			end
			remRoomIdx = tag
			local posX, posY = _img:getPosition()
			imgFouce:setPosition( ccp(posX, posY) )
		end
	end
	local function AddTouchCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			RW_guide.exitUI()--关闭任务引导
			local _btn = tolua.cast(sender, "Button")
			local tag = _btn:getTag()
			remRoomIdx = tag
			local _img = tolua.cast(_scrollviewRoomList:getChildByTag(tag), "ImageView")
			local posX, posY = _img:getPosition()
			imgFouce:setPosition( ccp(posX, posY) )

			PT.hideWidget(img_outRoom)
			PT.showWidget(img_inRoom)
			setlabelBmFont()
			ifCreat = 2

			setBtnHelpState(false)

			btn_JieSan:setVisible(false)
			btn_JieSan:setTouchEnabled(false)
			--btn_GongJi:loadTextures("button+2_team_1.png", "button+2_team_2.png", "")
			setRoomListTouchEnable(false)

			local data = JTNpcRoomData.getRoomlistdataFromIdx(tag)
			local charpterId, NpcId, _ = PT.getId()
			protoSend0x0358( data["TeamId"], charpterId )
		end
	end
    for i=1, Datanum do
    	local data = nil 
    	local name = nil
    	local iffist = false
    	local rolepage = nil
if ifserver then
		data = JTNpcRoomData.getRoomlistdataFromIdx(i)
		name = data["Name"]
		if data["IfFirst"] == 0 then
			iffist = true
		elseif data["IfFirst"] == 1 then
			iffist = false
		end
		rolepage = data["CurNum"] .. "/" ..data["MaxNum"]
else

end

    	local imageView = ImageView:create()
		imageView:loadTexture("button+10_team_1.png")
		imageView:setTag(i)
		imageView:setPosition( ccp( cell_X, cell_Y ) )
		imageView:addTouchEventListener( CellTouchCB )
		imageView:setTouchEnabled(true)
			local lbl_name = Label:create()
			lbl_name:setText( name )
			lbl_name:setFontSize(18)
			lbl_name:setAnchorPoint( ccp(0, 0.5) )
    		--lbl_name:setColor( ccc3(255, 0, 0) )
    		lbl_name:setPosition(ccp(-170, 15))
    		--lbl_name:setVisible(false)
    	imageView:addChild(lbl_name)
	    	if iffist then
	    		local size = lbl_name:getContentSize()
	    		local lbl_state = Label:create()
				lbl_state:setText("(首次击杀)")
				lbl_state:setFontSize(18)
				lbl_state:setColor( ccc3(255, 162, 16) )
				lbl_state:setAnchorPoint( ccp(0, 0.5) )   
				lbl_state:setPosition( ccp(-170+size.width+10, 15) ) 		
			imageView:addChild(lbl_state)
			end
			local img_curRole = ImageView:create()
			img_curRole:loadTexture("word+7_team.png")
			img_curRole:setAnchorPoint(ccp(0, 0.5))
			img_curRole:setPosition( ccp(-170, -15) )
			imageView:addChild(img_curRole)
			size = img_curRole:getContentSize()
    		local lbl_curRole = Label:create()
			lbl_curRole:setText( rolepage )
			lbl_curRole:setFontSize(18)
			lbl_curRole:setColor( ccc3(0, 255, 6) )
			lbl_curRole:setAnchorPoint( ccp(0, 0.5) )   
			lbl_curRole:setPosition( ccp(-170+size.width+10, -15) ) 		
			imageView:addChild(lbl_curRole)

		local btn_add = Button:create()
	    btn_add:setTouchEnabled(true)
	    btn_add:setTag(i)
	    btn_add:loadTextures("button+9_team_1.png", "button+9_team_2.png", "")
	    btn_add:setPosition( CCPoint( 130, 0 ) )
	   	btn_add:addTouchEventListener( AddTouchCB )
	   	--如果队伍人数已满，就不显示加入按钮，不满才显示
	   	if data["CurNum"] ==data["MaxNum"] then
	   		print("set addbtn false============")
	   		btn_add:setVisible(false)
	   		btn_add:setTouchEnabled(false)
	   	else
	   		print("set addbtn true============")
	   		btn_add:setVisible(true)
	   		btn_add:setTouchEnabled(true)
	   	end

	   	imageView:addChild(btn_add)
	   	_scrollviewRoomList:addChild( imageView )

		if remRoomIdx == i then
			imgFouce:setPosition( ccp( cell_X, cell_Y ) )
		end
	   cell_Y = cell_Y - cell_disY - cell_H
    end
    --最后添加焦点图片
    if Datanum> 0 then
    	_scrollviewRoomList:addChild(imgFouce)
	end

	if ifCreat == 1 or ifCreat == 2 then
		print("ifcreat == " .. ifCreat)
		setRoomListTouchEnable(false)
	end

	local curpage, Maxpage = JTNpcRoomData.getPageNum()
	lbl_curRoomNum:setText( curpage .. "/" .. Maxpage )
end


function initPubMod(_NpcCount, _WinCount, _Exploit, _EquipId, _Persent)

	lbl_JieSan 	= tolua.cast( curLayer:getWidgetByName("Label_876"), "Label" )
	lbl_GongJi 	= tolua.cast( curLayer:getWidgetByName("Label_877"), "Label" )
	lbl_AuTo 	= tolua.cast( curLayer:getWidgetByName("Label_878"), "Label" )
	lbl_Creat 	= tolua.cast( curLayer:getWidgetByName("Label_879"), "Label" )
	lbl_help 	= tolua.cast( curLayer:getWidgetByName("Label_934"), "Label" )

	local btn_close = tolua.cast( curLayer:getWidgetByName("Button_close"), "Button" )
	
	--军团名字登记
	local lbl_nameLv 		= tolua.cast( curLayer:getWidgetByName( "Label_NameLv"), "Label" )
	--军团部队
	local lbl_BuDuiNum 		= tolua.cast( curLayer:getWidgetByName( "Label_BuDuiShuLiang"), "Label" )
	
	--最大连胜纪录
	local lbl_LianShengMax 	= tolua.cast( curLayer:getWidgetByName( "Label_ZuiDaLianSheng"), "Label" )
	
	--获取军工
	local lbl_GoodsJunGong 	= tolua.cast( curLayer:getWidgetByName( "Label_JunGong"), "Label" )
	
	--获取物品名字、概率、头像
	local lbl_GoodsName = tolua.cast( curLayer:getWidgetByName( "Label_GoodsName"), "Label" )
	local lbl_GoodsGailv= tolua.cast( curLayer:getWidgetByName( "Label_GaiLv"), "Label" )
	local img_GoodsHead=tolua.cast( curLayer:getWidgetByName("ImageView_GoodsHead"), "ImageView")
	local img_yanSeKuang=tolua.cast(curLayer:getWidgetByName("ImageView_yanSeKuang"), "ImageView")
	
	local charpterId, NpcId, _ = PT.getId()
	--local Npcdes = Des.getBattleDesFromId( charpterId, NpcId )
	local Npcdes = Des.getGroupBattleDesFromId( charpterId )
	local npcdata =  nil--NpcListData.getNpcDataFromId( NpcId )
	npcdata = NpcListData.getSplDataFromId( charpterId )
	--[[
	if charpterId == -1 then
		npcdata = NpcListData.getNpcDataFromId( NpcId, true )
	else
		npcdata = NpcListData.getNpcDataFromId( NpcId, false )
	end
	--]]

	lbl_nameLv:setText( Npcdes["name"] ..  " Lv:" ..  npcdata["NpcLv"])
	
	lbl_BuDuiNum:setText( _NpcCount )
	lbl_LianShengMax:setText( _WinCount .. "连胜" )
	lbl_GoodsJunGong:setText( _Exploit .. "军功" )
	local des = nil
	if _EquipId ~= 0 then
		des = Des.getGoodsDesFromId( _EquipId )
		lbl_GoodsName:setText(des["goodsName"] )
		img_GoodsHead:loadTexture( GoodsHeadPath .. des["goodsPic"] .. ".png" )
		if _Persent == 1 then
			lbl_GoodsGailv:setText("(大概率)")
		elseif _Persent == 2 then
			lbl_GoodsGailv:setText("(小概率)")
		end
		local quality = des["goodsQuality"]
		lbl_GoodsName:setColor( ccc3(GoodsColorTab[quality][1], GoodsColorTab[quality][2], GoodsColorTab[quality][3]) )
		--设置物品周围的品质框
		if quality==1 then
			img_yanSeKuang:loadTexture("rim+1_juntuan.png")
		elseif quality==2 then
			img_yanSeKuang:loadTexture("rim+2_juntuan.png")
		elseif quality==3 then
			img_yanSeKuang:loadTexture("rim+3_juntuan.png")
		elseif quality==4 then
			img_yanSeKuang:loadTexture("rim+4_juntuan.png")
		elseif quality==5 then
			img_yanSeKuang:loadTexture("rim+5_juntuan.png")
		elseif quality==6 then
			img_yanSeKuang:loadTexture("rim+6_juntuan.png")
		end
	else
		--print("攻打该军团没有奖励物品吗？.......")
		img_GoodsHead:setVisible(false)
		lbl_GoodsName:setVisible(false)
		lbl_GoodsGailv:setVisible(false)
	end	
	_scrollviewRoomList 	= tolua.cast( curLayer:getWidgetByName( "ScrollView_RoomList"), "ScrollView" )
    _scrollviewRoomList:setClippingEnabled(true) --裁切窗口
    _scrollviewRoomList:setBounceEnabled(false) --边缘回弹
    _scrollviewRoomList:setBackGroundColorType(0)	

	local btn_pageLeft 			= tolua.cast( curLayer:getWidgetByName( "Button_Left"), "Button" )
	local btn_pageRight 		= tolua.cast( curLayer:getWidgetByName( "Button_Right"), "Button" )
	lbl_curRoomNum 			= tolua.cast( curLayer:getWidgetByName( "Label_pageNum"), "Label" )
	btn_pageLeft:setScaleX(-1)

	img_inRoom  = tolua.cast( curLayer:getWidgetByName( "ImageView_InRom"), "ImageView" )
	img_outRoom = tolua.cast( curLayer:getWidgetByName( "ImageView_outRom"), "ImageView" )	
	PT.hideWidget(img_inRoom)
	PT.showWidget(img_outRoom)
 	setlabelBmFont()
 	------outRoom 面板
 	--自动参战
 	local btn_autoCanZhan = tolua.cast( curLayer:getWidgetByName( "Button_AuTo"), "Button" )
 	--创建房间
 	local btn_ChuangJian 	= tolua.cast( curLayer:getWidgetByName( "Button_ChuangJian"), "Button" )
 	local lbl_shuoming1 	= tolua.cast( curLayer:getWidgetByName( "Label_shuoming1"), "Button" )
	local lbl_shuoming2 	= tolua.cast( curLayer:getWidgetByName( "Label_shuoming2"), "Button" )
	local lbl_shuoming3 	= tolua.cast( curLayer:getWidgetByName( "Label_shuoming3"), "Button" )
	--------inRoom面板
	lbl_curRoleNum= tolua.cast( curLayer:getWidgetByName( "Label_CurRole"), "Label" )
	lbl_curRoleNum:setText("")
	--自己创建的都显示，进入别人房间不显示解散，攻击变成退出
	btn_JieSan 	= tolua.cast( curLayer:getWidgetByName( "Button_JieSan"), "Button" )
	btn_GongJi 	= tolua.cast( curLayer:getWidgetByName( "Button_GongJi"), "Button" )
	btn_help    = tolua.cast( curLayer:getWidgetByName( "Button_help"), "Button" )

	_scrollviewRoleList = tolua.cast( curLayer:getWidgetByName( "ScrollView_RoleList"), "ScrollView" )
	_scrollviewRoleList:setClippingEnabled(true) --裁切窗口
    _scrollviewRoleList:setBounceEnabled(true) --边缘回弹
    _scrollviewRoleList:setBackGroundColorType(0)

	local function pubBtnCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then 
			RW_guide.exitUI()--关闭任务引导
			local _btn = tolua.cast(sender, "Button")
			if _btn == btn_close then
				local charpterId, NpcId, _ = PT.getId()
				local teamId = JTNpcRoomData.getTeamId()
				guideFactory.CheckGuideProcess( LM.STATE_3  )
				exitUI()
			elseif _btn == btn_pageLeft then --左翻页房间翻页
				local charpterId, NpcId, _ = PT.getId()
				local curpage, maxpage = JTNpcRoomData.getPageNum()
				--protoSend0x0354( 1, curpage,  charpterId)
			elseif _btn == btn_pageRight then --右翻页房间翻页
				local charpterId, NpcId, _ = PT.getId()
				local curpage, maxpage = JTNpcRoomData.getPageNum()
				--protoSend0x0354( 2, curpage,  charpterId )
			elseif _btn == btn_autoCanZhan then --自动参战
				Pop3_ZiDongCanZhan.enterUI()
			elseif _btn == btn_ChuangJian then --创建房间
				if PlayerData.getBeatCdState() ~= 0 then --不可用
					Pop3_TS_Result.enterUI("征战cd中！")
				elseif PlayerData.getOrders() == 0 then
					Pop3_TS_Result.enterUI("军令不足！")
				else
					ifCreat = 1
					btn_JieSan:setVisible(true)
					btn_JieSan:setTouchEnabled(true)
					btn_GongJi:loadTextures("button+3_team_1.png", "button+3_team_2.png", "")
					PT.hideWidget(img_outRoom)
					PT.showWidget(img_inRoom)
					setBtnHelpState(false)
					setlabelBmFont()
					setRoomListTouchEnable(false)

					local _CharpterId, _NpcId, _ = PT.getId()
					protoSend0x0356( _CharpterId, _NpcId)

					guideFactory.CheckGuideProcess( nil  )
				end
		
			elseif _btn == btn_JieSan then --解散房间
				PT.hideWidget(img_inRoom)
				PT.showWidget(img_outRoom)
				setlabelBmFont()
				setRoomListTouchEnable(true)
				local teamId = JTNpcRoomData.getTeamId()
				print("teamId is "..teamId)
				if teamId~= "" then
					local charpterId, NpcId, _ = PT.getId()
					JTNpcRoomData.clearRoleList()
					_scrollviewRoleList:removeAllChildren()
					ifCreat = 0
					protoSend0x0360( recv0x0103[INDEX_0x0103_CharId][VALUE], teamId ,charpterId ,0, true )

				end
			elseif _btn == btn_GongJi then --攻击/退出房间

				print("ifCreat == " .. ifCreat)
				if ifCreat == 2 then --退出房间
					setRoomListTouchEnable(true)
					PT.hideWidget(img_inRoom)
					PT.showWidget(img_outRoom)
					setlabelBmFont()
					local teamId = JTNpcRoomData.getTeamId()
					if teamId~= 0 then
						local charpterId, NpcId, _ = PT.getId()
						JTNpcRoomData.clearRoleList()
						ifCreat = 0
						protoSend0x0360( recv0x0103[INDEX_0x0103_CharId][VALUE], teamId ,charpterId,0, true  )
					end
				elseif ifCreat == 1 then ----攻击
					local teamId = JTNpcRoomData.getTeamId()
					if teamId~= "" then
						local charpterId, NpcId, _ = PT.getId()
						--JTNpcRoomData.clearRoleList()
						ifCreat = 0
						protoSend0x0364(teamId,charpterId, NpcId )
					end
				end
			elseif _btn == btn_help then
				local teamId = JTNpcRoomData.getTeamId()
				protoSend0x0526(teamId)
				--Pop3_JunTuanZhan_Help.enterUI()
			end
		end
	end

	btn_close:addTouchEventListener(pubBtnCB)
	btn_pageLeft:addTouchEventListener(pubBtnCB)
	btn_pageRight:addTouchEventListener(pubBtnCB)
	btn_autoCanZhan:addTouchEventListener(pubBtnCB)
	btn_ChuangJian:addTouchEventListener(pubBtnCB)
	btn_JieSan:addTouchEventListener(pubBtnCB)
	btn_GongJi:addTouchEventListener(pubBtnCB)
	btn_help:addTouchEventListener(pubBtnCB)

	remRoomIdx = 1
	flushRoomscrollview()
	flushRoleListScrollview()--y有可能一进来就在房间里啊，自动参战了
end

function exitUI()
    if curLayer ~= nil and widget ~= nil then
        curLayer:removeWidget(widget)
        --curLayer:clear()
        widget = nil
        curLayer = nil
        
        LM.STATE_3 = 0
    end

	local teamId = JTNpcRoomData.getTeamId()
	local charpterId, NpcId, _ = PT.getId()
	if teamId~= 0 then
		JTNpcRoomData.clearRoleList()
		protoSend0x0360( recv0x0103[INDEX_0x0103_CharId][VALUE], teamId ,charpterId,1, false  )
	else
		protoSend0x0360( recv0x0103[INDEX_0x0103_CharId][VALUE], "" ,charpterId,1, false  )
	end

end

function enterUI(NpcCount,WinCount,Exploit,EquipId,Persent)
    LM.STATE_3 = UI_ZhengZhan_JunTuanNpc_Pop

    curLayer = LM.getLayer3()
    widget = GUIReader:shareReader():widgetFromJsonFile("ShouYe_ZhengZhan_Pop3_JunTuanZhan.json")  

    curLayer:addWidget(widget)
    widget:setTouchEnabled(true)

	ifCreat = 0
    initPubMod(NpcCount,WinCount,Exploit,EquipId,Persent)

    guideFactory.CheckGuideProcess( LM.STATE_3  )

    if RWZhuXian.getRemJingYingGK() then --检查是否显示任务主线引导
    	RW_guide.enterUI(0, 280, -110)
	end
end

