module ("Pop3_GetNewJeneral",package.seeall)
--主城升级的3级弹出界面

local curScene = nil
local curLayer = nil
local _widget = nil

local newJeneralId = 0


function initPanel()
	local jeneralDes = Des.getGeneralDesFromId(newJeneralId)
	local name = jeneralDes["generalName"]
	local headicon = jeneralDes["generalHeadIcon"]

	local img_head = tolua.cast( curLayer:getWidgetByName("ImageView_WuJiangPic"), "ImageView" )
	local lbl_name = tolua.cast( curLayer:getWidgetByName("Label_WuJiangName"), "Label" )
	img_head:loadTexture(RoleHeadPath .. headicon.. ".png")
	lbl_name:setText( name )


	local function btn_closeCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			FightRewardData.clearNewGeneralId()
			exitUI()
			 guideFactory.CheckGuideProcess( LM.STATE_2 )
		end
	end
	
	local btn_close = tolua.cast( curLayer:getWidgetByName("Button_Close"), "Button" )
	btn_close:addTouchEventListener( btn_closeCB )

	local Img_BG = tolua.cast( curLayer:getWidgetByName("ImageView_JuanZhouBG"), "ImageView" )

	Img_BG:setScale(0.2)
    local array = CCArray:create()
    array:addObject(CCScaleBy:create(0.2, 6, 6))
    array:addObject(CCScaleBy:create(0.05, 0.83, 0.83))
    Img_BG:runAction(CCSequence:create(array))
end
function exitUI()
	--curScene:removeChild(curLayer, true)
	--MapZhengZhan.setScrollViewMove()
	if curLayer ~= nil and _widget ~= nil then
		curLayer:removeWidget(_widget)
		--curLayer:clear()
		_widget = nil
		curLayer = nil
		
		LM.STATE_10 = 0
	end
end
function enterUI(_id)
	if _id == nil then
		newJeneralId = FightRewardData.getNewGeneralId()
	else
		newJeneralId = _id --升官获得
	end
	if newJeneralId == 0 then --没有新将领
		return
	else
		FightRewardData.clearNewGeneralId()
	end
	--newJeneralId = 1


--[[
	curScene = scene
    local widget = GUIReader:shareReader():widgetFromJsonFile("ShouYe_ZhengZhan_Pop3_NewJeneral.json")    
	widget:setTouchEnabled(true)
	curLayer = TouchGroup:create()
	curLayer:setZOrder(5)
    curLayer:addWidget(widget)
    curScene:addChild(curLayer)
--]]
	LM.STATE_10 = UI_GetNewGeneral

	curLayer = LM.getLayer10()
	_widget = GUIReader:shareReader():widgetFromJsonFile("ShouYe_ZhengZhan_Pop3_NewJeneral.json")

	curLayer:addWidget(_widget)
    _widget:setTouchEnabled(true)


    initPanel()

    guideFactory.CheckGuideProcess( LM.STATE_10 )

end