module ("Pop3_ZhangJieXuanZe",package.seeall)
--征战的的3级弹出界面
local curScene = nil
local curLayer = nil
local remFatherUi = nil
function exitUI()
	PT.UI_State = remFatherUi
	curScene:removeChild(curLayer, true)
	MapZhengZhan.setScrollViewMove()
end

local function initScrollView()
	local _scrollview = tolua.cast( curLayer:getWidgetByName("ScrollView_panel"), "ScrollView" )

	_scrollview:setClippingEnabled(true) --裁切窗口
	_scrollview:setBounceEnabled(true) --边缘回弹
	_scrollview:setBackGroundColorType(0)
	local cell_disX = 4
	local cell_W = 180
		--可视区域
	local view_W = _scrollview:getSize().width 
	local view_H = _scrollview:getSize().height 

	local dataList = nil
	local num = 0
if ifserver then
	dataList = ChapterListData.getCharpterDataList()
	num = #dataList
else
	num = 10
end
	_scrollview:setInnerContainerSize( CCSize(180*num + 4*(num-1)+30, view_H) )

	--滑动区域
	local scroll_W = _scrollview:getInnerContainerSize().width
	local scroll_H = _scrollview:getInnerContainerSize().height

	local remImg = nil

	local cell_X, cell_Y = 105, 260
	local curId = ChapterListData.getCurCharpterId()
	local fouceId = curId
	local function CellTouchCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then

			guideFactory.CheckGuideProcess(nil)
			local _img = tolua.cast(sender, "ImageView")
			local tagid = _img:getTag()

			local x, y = _img:getPosition()
			remImg:setPosition( ccp( x+4, y ) )
			--remImg:setVisible(true)
			if tagid == curId then
				exitUI()
				return
			elseif fouceId == tagid then --二次确认

				local data = ChapterListData.getCharpterDataFromCptId( fouceId )
				if data["State"] == 0 then
					Pop3_TS_Result.enterUI( "尚未开启"  )
				else
					protoSend0x0290( fouceId )
					exitUI()
				end
				
				return
			else
				fouceId = tagid
			end

		end
	end
	
	local remX = 0
	local remY = 0
	for i=1, num do
		local data = nil
		local id = 0
		local imgName = nil
		local zhangName = "第"
		local strlv = nil --等级区间
		local strPro = nil --本章进度
if ifserver then
		data = dataList[i]
		id = data["Id"]
		if data["State"] == 0 then --没打
			imgName = "floor+5_battle.png"
		elseif data["State"] == 1 then --打通
			imgName = "floor+4_battle.png"
		elseif data["State"] == 2 then --正在打
			imgName = "floor+3_battle.png"
		end
		local str= PT.getNumHanZiFromNum( data["Id"] )
		zhangName = zhangName .. str .. "章"

		strlv = data["LvLow"] .. " ~ " .. data["LvHig"] 
		strPro = data["Pass"] .. " ~ " .. data["All"] 
		if curId == data["Id"] then
			remX = cell_X
			remY = cell_Y
		end
else
		imgName = "floor+3_battle.png"
		local str = PT.getNumHanZiFromNum( 13 )
		zhangName = zhangName .. str .. "章"
		strlv = "10 ~ 11"
		strPro = "2/11"
end

		local imageView = ImageView:create()
		imageView:loadTexture("GuanKa_" .. i .. ".jpg")
		imageView:setTag(id)
		imageView:setPosition( CCPoint( cell_X, cell_Y ) )
		imageView:addTouchEventListener( CellTouchCB )
		imageView:setTouchEnabled(true)
			--选中效果
			--[[
			local Img9 = ImageView:create()
			Img9:loadTexture( "floor+6_battle.png" )
			Img9:setScale9Enabled(true)
			Img9:setSize( CCSize( 270, 538) )
			Img9:setPosition(ccp(3,0))
			Img9:setVisible(false)
			Img9:setTag(1)
			--]]
			--通关状态
			local img_state = ImageView:create()
			img_state:loadTexture(imgName)
			img_state:setPosition( ccp(-50, 205) )
			imageView:addChild( img_state )
			--第几章
			local lbl_Zhang = Label:create()
			lbl_Zhang:setText( zhangName )
			lbl_Zhang:setFontSize(22)
			lbl_Zhang:setPosition( ccp( 16, 205 ) )
			--lbl_Zhang:setColor( ccc3() )
			imageView:addChild( lbl_Zhang )
			--等级
			local lbl_Lv = Label:create()
			lbl_Lv:setText( "Lv : " )
			lbl_Lv:setFontSize( 16 )
			lbl_Lv:setPosition( ccp(0, -195) )
			lbl_Lv:setColor( ccc3(208, 171, 133 ) )
			lbl_Lv:setAnchorPoint(ccp(1, 0))
			imageView:addChild( lbl_Lv )

			local lbl_LvZi = Label:create()
			lbl_LvZi:setText( strlv )
			lbl_LvZi:setFontSize( 16 )
			lbl_LvZi:setPosition( ccp(0, -195) )
			lbl_LvZi:setColor( ccc3(208, 171, 133 ) )
			lbl_LvZi:setAnchorPoint(ccp(0, 0))
			imageView:addChild( lbl_LvZi )
			--关卡进度
			local lbl_Pro = Label:create()
			lbl_Pro:setText( "关卡进度 : " )
			lbl_Pro:setFontSize( 16 )
			lbl_Pro:setPosition( ccp(0, -215) )
			lbl_Pro:setAnchorPoint(ccp(1, 0))
			lbl_Pro:setColor( ccc3(208, 171, 133 ) )
			--lbl_Pro:setTextHorizontalAlignment( 0 )
			imageView:addChild( lbl_Pro )

			local lbl_ProZi = Label:create()
			lbl_ProZi:setText( strPro )
			lbl_ProZi:setFontSize( 16 )
			lbl_ProZi:setPosition( ccp(0, -215) )
			lbl_ProZi:setAnchorPoint(ccp(0, 0))
			lbl_ProZi:setColor( ccc3(208, 171, 133 ) )
			imageView:addChild( lbl_ProZi )
		--imageView:addChild( Img9 )
		_scrollview:addChild( imageView )
		cell_X = cell_X + cell_W + cell_disX
	end


			remImg = ImageView:create()
			remImg:loadTexture( "floor+6_battle.png" )
			remImg:setScale9Enabled(true)
			remImg:setSize( CCSize( 270, 538) )
			remImg:setPosition(ccp(remX,remY))
			remImg:setVisible(true)
			remImg:setTag(1)
			_scrollview:addChild( remImg )
end

local function initPopPanel()
	local img_left = tolua.cast( curLayer:getWidgetByName("ImageView_Left"), "ImageView" )
	local img_right = tolua.cast( curLayer:getWidgetByName("ImageView_right"), "ImageView" )
	img_right:setScaleX( -1 )

	local btn_close = tolua.cast( curLayer:getWidgetByName("Button_close"), "Button" )
	local function pubBtnCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			 
			--local _btn = tolua.cast(sender, "Button")
			exitUI()
		end
	end
	btn_close:addTouchEventListener( pubBtnCB )

	initScrollView()
end



function enterUI(scene)
---[[
	remFatherUi = PT.UI_State
	PT.UI_State = UI_Fight_CharpterChoice
	curScene = scene
    local widget = GUIReader:shareReader():widgetFromJsonFile("ZhengZhan_Pop3_ZhangjieXuanZe.json")    
	
	widget:setTouchEnabled(true)
	
	curLayer = TouchGroup:create()
	curLayer:setZOrder(3)
    curLayer:addWidget(widget)
    scene:addChild(curLayer)

    initPopPanel()

    guideFactory.CheckGuideProcess(curScene)
--]]

end