module ("Pop3_ZhuCheng",package.seeall)
--主城升级的3级弹出界面
local curScene = nil
local curLayer = nil
local remFatherUi = nil
local widget = nil
local btn_zhengshou = nil
local btn_shengguan = nil
local btn_gouliang  = nil
local btn_jisi 		= nil
local armature = nil
--[[
1主城
2民居
3仓库
4军机处
5校场
6商店
7驿站
--]]

function refreshBtn()
		local openBtn={}
		local btnTable=
		{
			{["id"]=23,["btn"]=btn_zhengshou},
			{["id"]=25,["btn"]=btn_shengguan},
			{["id"]=24,["btn"]=btn_gouliang},	
			{["id"]=26,["btn"]=btn_jisi},	
		}
		for i=1, #btnTable do
			PT.hideManyBtn(openBtn,btnTable[i]["id"],btnTable[i]["btn"])
		end
		for i=1,#openBtn do
			--openBtn[i]:setPosition(ccp(-307+100*(i-1),-135))
			openBtn[i]:setTouchEnabled(true)
			openBtn[i]:setVisible(true)
		end
	end
function initPopPanel(_cityId)

	local img_city = tolua.cast( curLayer:getWidgetByName("ImageView_CityPic"), "ImageView" )
--img_city:setRotation(0)
--img_city:setScale(1)
	local btn_close = tolua.cast( curLayer:getWidgetByName("Button_close"), "Button" )
	local btn_shengJi = tolua.cast( curLayer:getWidgetByName("Button_shengji"), "Button" )

	 btn_zhengshou = tolua.cast( curLayer:getWidgetByName("Button_zhengshou"), "Button" )
	btn_shengguan = tolua.cast( curLayer:getWidgetByName("Button_shengguan"), "Button" )
	 btn_gouliang  = tolua.cast( curLayer:getWidgetByName("Button_gouliang"), "Button" )
	 btn_jisi 		= tolua.cast( curLayer:getWidgetByName("Button_jisi"), "Button" )
--[[
	btn_zhengshou:setIfPixelTouch(true)
	btn_shengguan:setIfPixelTouch(true)
	btn_gouliang:setIfPixelTouch(true)
	btn_jisi:setIfPixelTouch(true)
--]]

	local lbl_lv 		= tolua.cast( curLayer:getWidgetByName("Label_lv"), "Label" )
	local lbl_miaoshu  	= tolua.cast( curLayer:getWidgetByName("Label_miaoshu"), "Label" )
	local lbl_strLv  	= tolua.cast( curLayer:getWidgetByName("Label_strLv"), "Label" )

	--升级所需金币和时间
	local lbl_UpZeny = tolua.cast( curLayer:getWidgetByName("Label_UpZeny"), "Label" )
	local lbl_UpTime = tolua.cast( curLayer:getWidgetByName("Label_UpTime"), "Label" )

	local cityData = CityData.getCityDataFromId( _cityId )
	--img_city:setRotation(1)
	lbl_lv:setText( cityData["Lv"] )
	lbl_strLv:setText("主城 " .. cityData["Lv"] .. " 级")
	local cityDes = Des.getBuildDesFromId( _cityId )
	lbl_miaoshu:setText( cityDes["buildDes"] )

	local curZeny =	PlayerData.getZeny()
	if curZeny < cityData["UpZeny"] then
		lbl_UpZeny:setColor( ccc3(255, 0, 0) )
	else
		lbl_UpZeny:setColor( ccc3(255, 255, 255) )
	end

	lbl_UpZeny:setText( cityData["UpZeny"] .. "银币" )
	local _fen, _ = math_modf( cityData["UpTime"]/60 )
	lbl_UpTime:setText( _fen .. "分钟" )
	btn_jisi = tolua.cast( curLayer:getWidgetByName("Button_jisi"), "Button" )

	local function pubBtnCB(sender, eventType)
		local _btn = tolua.cast(sender, "Button")
		if eventType == PT.ccs.TouchEventType.ended then 
			RW_guide.exitUI()--关闭任务引导
			print("close here")
			if _btn == btn_close then
				--PT.UI_State = UI_ZhuCheng
				exitUI()
				guideFactory.CheckGuideProcess()
			elseif _btn == btn_shengJi then
if ifserver then
				protoSend0x0218( 1 )
end			
			elseif _btn == btn_zhengshou then --征收
				--todo：
				if CityData.canOpenFuncByIndex(23) then
					--[[
					PT.UI_State = remFatherUi
					curScene:removeChild(curLayer,true)
					ZhengShouBase.enterUI( curScene, 1 )
					--]]
					guideFactory.CheckGuideProcess(LM.STATE_3)
					exitUI()
					ZhengShouBase.enterUI(1)
				else
					PT.popTips(23)
				end
			elseif _btn == btn_shengguan then --升官
				--todo：
				if CityData.canOpenFuncByIndex(25) then
					--[[
					PT.UI_State = remFatherUi
					GuanZhiBase.enterUI(curScene)
					curScene:removeChild(curLayer,true)
					--]]
					exitUI()
					GuanZhi_GuanZhi.enterUI()
				else
					PT.popTips(25)
				end
			elseif _btn == btn_gouliang then --购粮
				--todo：
				if CityData.canOpenFuncByIndex(24) then
					--[[
					PT.UI_State = remFatherUi
					curScene:removeChild(curLayer,true)
					ZhengShouBase.enterUI( curScene,2 )
					--]]
					exitUI()
					ZhengShouBase.enterUI(2)
				else
					PT.popTips(24)
				end
			elseif _btn == btn_jisi then --祭祀
	    		if CityData.canOpenFuncByIndex(26) then
	    			--[[
	    			PT.UI_State = remFatherUi
	    			curScene:removeChild(curLayer,true)
	    			JiSiBase.enterUI(curScene)
	    			--]]
	    			
	    			exitUI()
	    			JiSiBase.enterUI()
	    		else
					PT.popTips(26)
	    		end
			end
		end
	end

	btn_close:addTouchEventListener(pubBtnCB)
	btn_shengJi:addTouchEventListener(pubBtnCB)
	btn_zhengshou:addTouchEventListener(pubBtnCB)
	btn_shengguan:addTouchEventListener(pubBtnCB)
	btn_gouliang:addTouchEventListener(pubBtnCB)
	btn_jisi:addTouchEventListener(pubBtnCB)

	
	btn_zhengshou:setVisible(true)
	btn_zhengshou:setTouchEnabled(true)
	btn_shengguan:setVisible(true)
	btn_shengguan:setTouchEnabled(true)
	btn_gouliang:setVisible(true)
	btn_gouliang:setTouchEnabled(true)
	btn_jisi:setVisible(true)
	btn_jisi:setTouchEnabled(true)

	-- PT.hideButton(btn_jisi,26)
	-- PT.hideButton(btn_zhengshou,23)
	-- PT.hideButton(btn_gouliang,24)
	-- PT.hideButton(btn_shengguan,25)
	
	refreshBtn()
	if armature == nil then
		local effectIMg = tolua.cast( curLayer:getWidgetByName("ImageView_b"), "ImageView" )
		armature =  ArmatureManager.createArmature( UiEffectPath, "UI_ShengJi", 1  )
		--armature:getAnimation():playWithIndex(0,-1, -1, -1)
		armature:setPosition(ccp(10, 123))
		armature:setZOrder(3)
		effectIMg:addNode(armature)
	else
		armature:getAnimation():playWithIndex(0,-1, -1, -1)
	end
end
function exitUI()
	if curLayer ~= nil and widget ~= nil then
		curLayer:removeWidget(widget)
		widget = nil
		curLayer = nil
		
		LM.STATE_3 = 0
	end
	MapShouYe.setScrollViewMove()
	MapPubUI.setPubVisible(true)
	armature = nil
end
function enterUI(_cityId)
	
	LM.STATE_3 = UI_City_ZhuCheng

	curLayer = LM.getLayer3()
	widget = GUIReader:shareReader():widgetFromJsonFile("ShouYe_Pop3_ZhuCheng.json")


    curLayer:addWidget(widget)
    widget:setTouchEnabled(true)

    MapPubUI.setPubVisible(false)
    armature = nil
    initPopPanel(_cityId)

    guideFactory.CheckGuideProcess(LM.STATE_3)
end
--[=[
function exitUI()
	if curScene ~=nil then
		PT.UI_State = remFatherUi  
		curScene:removeChild(curLayer, true)
		curScene = nil

	end
	MapShouYe.setScrollViewMove()
	armature = nil
end
function enterUI(scene, _cityId)
---[[
	remFatherUi = PT.UI_State
	PT.UI_State = UI_City_ZhuCheng	
	curScene = scene
    widget = GUIReader:shareReader():widgetFromJsonFile("ShouYe_Pop3_ZhuCheng.json")    
	
	widget:setTouchEnabled(true)
	
	curLayer = TouchGroup:create()
	curLayer:setZOrder(3)
    curLayer:addWidget(widget)
    scene:addChild(curLayer)
    armature = nil
    initPopPanel(_cityId)
--]]
	guideFactory.CheckGuideProcess(curScene)

end
--]=]
