module ("RL_GameName",package.seeall)

local Layer = nil 
local scene = nil
local pre_UI = 1

local btn_entergame
local btn_getname

local tf_name = nil
name = nil


local function refresh_state()
end

function checkname(_scene)
    local gamename = PlayerData.getName()
    if gamename == nil then
        RL_GameName.enterUI(_scene)
        return true
    else
        if PlayerData.getCamp() == 4 then
            
            RL_ChooseCamp.enterUI(_scene)
            return true
        end  
        return false
    end
end

function setname()
    PlayerData.setName(name)
    --PlayerData.setName(tf_name:getStringValue())
    print("setName is "..name)
end

local function initMap()

    local function btnCallback(sender, eventType)     
        if eventType == PT.ccs.TouchEventType.ended then
        	local _btn = tolua.cast(sender, "Button")
        	local tag = _btn:getTag()        	
            print("tag === " .. tag)
            if _btn == btn_entergame then

                name = tf_name:getStringValue()
                local state = false
                if string.len(name) > 0 then
                    --屏蔽字校验
                    name, state = ShieldWord.checkShieldWord(name) 
                end
                if state then --存在屏蔽字
                    Pop3_TS_Result.enterUI("您的名字包含敏感字符！")
                else
                    local _ps = TextManager:u82gbk(name)
                    -- if string_len(_ps)< 6 then
                    --     Pop3_TS_Result.enterUI("名字过短"..string_len(_ps))
                    -- elseif string_len(_ps)>12 then
                    --     Pop3_TS_Result.enterUI("名字过长"..string_len(_ps))
                    -- else
                    --     print("472 is ".._ps)
                    --RL_UpdateData.enterUI(scene)
                    if _ps == nil then
                        Pop3_TS_Result.enterUI("名字不能为空")
                    else
                        protoSend0x0472(_ps, 1)
                    end
                    --exitUI()
                    --end
                end
            elseif _btn == btn_getname then
                name = Des.getRandomName()
                tf_name:setText(name)
                --print()
            end
    	end
    end

    btn_entergame = tolua.cast(Layer:getWidgetByName("Button_entergame"), "Button" )
    btn_getname = tolua.cast(Layer:getWidgetByName("Button_getname"), "Button" )
    tf_name = tolua.cast(Layer:getWidgetByName("TextField_name"), "TextField" )

    btn_entergame:addTouchEventListener(btnCallback)
    btn_getname:addTouchEventListener(btnCallback)
    math.randomseed(os.time())
    refresh_state()   
    name = Des.getRandomName()
    tf_name:setText(name)
end

local _widget = nil
function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        --Layer:clear()
        _widget = nil
        Layer = nil
        LM.STATE_20 = 0
    end
end
function enterUI()
    LM.STATE_20 = UI_RL_GameName
    
    Layer = LM.getLayer20()
    _widget = GUIReader:shareReader():widgetFromJsonFile("RL_GameName.json") 
    _widget:setTouchEnabled(true)

    Layer:addWidget(_widget)

    initMap()
end

--[[
function exitUI()
    PT.UI_State = pre_UI  
	scene:removeChild(Layer, true)
end

function enterUI(curScene)
    scene = curScene
    pre_UI =  PT.UI_State 
    PT.UI_State = UI_RL_GameName
    Layer = TouchGroup:create()
    Layer:setZOrder(15)

    local _widget = GUIReader:shareReader():widgetFromJsonFile("RL_GameName.json") 
    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)
 	scene:addChild(Layer)

    initMap()
end
--]]