module ("TeQuanUI", package.seeall)

local curLayer = nil
--local curScene=nil
local ifBtnclick=false
local currentPage=0
local pageView=nil
local rightNote=true
local allTeQuan={}

function clearAllTeQuan()
    allTeQuan={}
end
function setAllTeQuan(num,index)
    allTeQuan[index]=num
end
function getAllTeQuan()
    if #allTeQuan == 0 then
        for i=1, 8 do
            allTeQuan[i] = Des.getTeQuanFromLv(i)
        end
    end

    return allTeQuan
end

local function initTeQuanPanel()
    getAllTeQuan()


    -- local btn_Chongzhi =tolua.cast( curLayer:getWidgetByName("Button_3279"), "Button" )
    local btn_left = tolua.cast( curLayer:getWidgetByName("Button_left"), "Button" )
    local btn_right = tolua.cast( curLayer:getWidgetByName("Button_right"), "Button" )
    local img_TeQuan = tolua.cast( curLayer:getWidgetByName("ImageView_VIP"), "ImageView" )
    pageView = tolua.cast(curLayer:getWidgetByName("PageView_3274"),"PageView")

    btn_left:setFlipX(true)
    local function pageViewEvent(sender, eventType)
        if eventType == PT.ccs.PageViewEventType.turning then
           --[[
            if ifBtnclick then
                ifBtnclick = false
                return
            end
            --]]
     
                if currentPage ~= pageView:getCurPageIndex() then   
                    currentPage = pageView:getCurPageIndex()
                    print("currentPage == " .. currentPage)
                    if currentPage<#allTeQuan then
                        img_TeQuan:loadTexture("word"..(currentPage+2).."_chongzhi_1_01.png")
                    end         
                end
           
        end
    end 

    pageView:addEventListenerPageView(pageViewEvent)

        local function pubBtnCB(sender, eventType)

            local _btn = tolua.cast(sender, "Button")
            if eventType == PT.ccs.TouchEventType.ended then 
               
                -- if _btn == btn_Chongzhi then
                  
                -- --充值接口
                --  print("close here1")

                --  if CityData.canOpenFuncByIndex(31) then --条件不满足，不能充值

                --  end
                 
                -- else
                if _btn == btn_left then
                   -- rightNote=true
                    if currentPage>0 then
                        pageView:scrollToPage(currentPage-1)
                        currentPage = pageView:getCurPageIndex()
                        print("left curpage == " .. currentPage)
                      --  if currentPage<#allTeQuan then
                            img_TeQuan:loadTexture("word"..(currentPage+2).."_chongzhi_1_01.png")
                       -- end
                    end
                elseif _btn == btn_right then
                        
                      
                        if currentPage<#allTeQuan then
                          
                            pageView:scrollToPage(currentPage+1)                           
                            currentPage = pageView:getCurPageIndex()
                            print("right curpage == " .. currentPage)
                            if currentPage<#allTeQuan then
                                img_TeQuan:loadTexture("word"..(currentPage+2).."_chongzhi_1_01.png")
                            end
                         
                        end
                end
            end
        end

    btn_left:setTouchEnabled(true)
    -- btn_Chongzhi:setTouchEnabled(true)
    btn_right:setTouchEnabled(true)

    btn_left:addTouchEventListener(pubBtnCB)
    btn_right:addTouchEventListener(pubBtnCB)
    -- btn_Chongzhi:addTouchEventListener(pubBtnCB)
    initPageIndex()

    local viplv = PlayerData.getVipLv()
    print("viplv === " .. viplv)
   

    currentPage = viplv
    if currentPage == 0 then
        img_TeQuan:loadTexture("word"..(currentPage+2).."_chongzhi_1_01.png")
        pageView:scrollToPage(viplv)
        print("page index A= " .. vipLv+1)
    else
        img_TeQuan:loadTexture("word"..(currentPage+1).."_chongzhi_1_01.png")
        pageView:scrollToPage(viplv-1)
        print("page index B= " .. viplv)
    end
    

    

end
function initPageIndex()
    for i=1,#allTeQuan do
        local scrollView = ScrollView:create();
        local view_W = scrollView:getSize().width 
        local layout = Layout:create();
        layout:setSize(pageView:getSize())
        scrollView:setAnchorPoint(ccp(0,1))
        scrollView:setSize(pageView:getSize())
      --  scrollView:setInnerContainerSize(pageView:getSize())
        scrollView:setPosition(CCPoint(0,200))
        layout:addChild(scrollView);    
        pageView:setClippingEnabled(true) --裁切窗口
        --scrollView:setBounceEnabled(true) --边缘回弹
        scrollView:setClippingEnabled(true) --裁切窗口
        pageView:insertPage(layout, i-1);
        local Height=0

        for j= 1, #allTeQuan[i] do
            local mylable =Label:create()
            mylable:ignoreContentAdaptWithSize(false)
            mylable:setText(allTeQuan[i][j])
            mylable:setFontSize(20)
            mylable:setColor(ccc3(250,250,210))
           
            mylable:setSize(CCSizeMake(pageView:getSize().width,0))
            mylable:setSize(CCSizeMake(pageView:getSize().width,mylable:getContentSize().height))
            mylable:setAnchorPoint(ccp(0,0))
            Height=Height+mylable:getContentSize().height
            mylable:setPosition(CCPoint(0,pageView:getSize().height-Height))
            scrollView:addChild(mylable)

        end 
        if pageView:getSize().height<Height then
            scrollView:removeAllChildren()
            local newHeight=0
            for j= #allTeQuan[i],1,-1 do
                local mylable =Label:create()         
                mylable:ignoreContentAdaptWithSize(false)
                mylable:setText(allTeQuan[i][j])
                mylable:setFontSize(20);    
                mylable:setColor(ccc3(250,250,210))
                mylable:setSize(CCSizeMake(pageView:getSize().width,0))
                mylable:setSize(CCSizeMake(pageView:getSize().width,mylable:getContentSize().height))
                mylable:setAnchorPoint(ccp(0,0))
                newHeight=newHeight+mylable:getContentSize().height
                mylable:setPosition(CCPoint(0,newHeight-mylable:getContentSize().height))
                scrollView:addChild(mylable)
            end
       end
        if scrollView:getSize().height<Height then
            scrollView:setInnerContainerSize( CCSize(view_W,Height) )
        end
         -- rightNote=true
    end
end  

function exitUI()
    if curLayer ~= nil and _widget ~= nil then
        curLayer:removeWidget(_widget)
        --curLayer:clear()
        _widget = nil
        curLayer = nil
        
        LM.STATE_11 = 0
    end
end

function enterUI()
    LM.STATE_11 = UI_Vip_TeQuan

    curLayer = LM.getLayer11()
    _widget = GUIReader:shareReader():widgetFromJsonFile("VIP_TeQuan.json")  

    curLayer:addWidget(_widget)
    _widget:setTouchEnabled(false)
    initTeQuanPanel()
end

--[[
function enterUI(_Scene)

    PT.UI_State = UI_Vip_TeQuan
    currentPage=0
    curScene = _Scene
    curLayer = TouchGroup:create()

    local widget = GUIReader:shareReader():widgetFromJsonFile("TeQuanUI.json")  
    widget:setTouchEnabled(false)
    curLayer:setZOrder(10)
    curLayer:addWidget(widget)

    curScene:addChild(curLayer)
    initTeQuanPanel()
end
function exitUI()   
    curScene:removeChild(curLayer, true)
end
--]]