module ("XunBao_XunBao",package.seeall)
--祭祀
local Layer = nil
local _widget = nil
--local curScene = nil

local scl_tasklist = nil
local focusImg = nil
--local labelState = nil
--local imgState = nil
local labelTimes = nil
local imgGen = {}
local imgGenFace = {}
local imgFound = {}
--local labelPrice = nil

local btn = nil
local labelBMFont = nil

local focusFaceID = nil
local focusTaskID = nil

local img_Tips = nil
local lbl_tip_name = nil
local lbl_tip_jiangLi = nil

local paths = {
    "pic+33_xunbao.png",
    "pic+34_xunbao.png",
    "pic+35_xunbao.png",
    "pic+39_xunbao.png",
    "pic+40_xunbao.png",
    "pic+41_xunbao.png",
    "pic+45_xunbao.png",
    "pic+46_xunbao.png",
    "pic+47_xunbao.png",
    "pic+48_xunbao.png",
    "pic+49_xunbao.png",
    "pic+50_xunbao.png",
}
local tipsPos = {
    {3, 5, 6},
    {12, 1, 2},
    {2, 8, 0},
    {9, 9, 7},
}


local function iniTips(_tag)

    img_Tips:setVisible(true)
    img_Tips:setTouchEnabled(false)

    img_Tips:setPosition(ccp(-131, (4-_tag+1)*112 -112/2- 245))

    lbl_tip_name:setText("宝藏" .. _tag)
    local zeny = XunBaoData.getTaskZeny(_tag)
    lbl_tip_jiangLi:setText( zeny .. "银币")

    img_Tips:setScale(0.2)
    local function CallFucnCallback2(sender)
        img_Tips:setTouchEnabled(true)
    end
    local array = CCArray:create()
    array:addObject(CCScaleBy:create(0.2, 6, 6))
    array:addObject(CCScaleBy:create(0.05, 0.83, 0.83))
    array:addObject( CCCallFuncN:create(CallFucnCallback2) )
    img_Tips:runAction(CCSequence:create(array))

end

local function flushScrollViewTaskList()
    scl_tasklist:setClippingEnabled(true)--裁切窗口
    --scl_tasklist:setBounceEnabled(true) --边缘回弹
    scl_tasklist:setBackGroundColorType(0)

    scl_tasklist:removeAllChildren()

    local cell_disY = 2
    local cell_disX = 0

    local cell_W, cell_H = 287, 110

    local label_H = 10
    --可视区域
    local view_W = scl_tasklist:getSize().width 
    local view_H = scl_tasklist:getSize().height 

    local Datanum = 4

    scl_tasklist:setInnerContainerSize( CCSize(view_W, cell_H*Datanum + (Datanum+1)*cell_disY) )

    --滑动区域
    local scroll_W = scl_tasklist:getInnerContainerSize().width
    local scroll_H = scl_tasklist:getInnerContainerSize().height

    local cell_X, cell_Y = (scroll_W)/2, scroll_H-cell_H/2-label_H
    local focus_X, focus_Y = cell_X, cell_Y

    if Datanum < 5 then
        scl_tasklist:setBounceEnabled(false) --边缘回弹
    else
        scl_tasklist:setBounceEnabled(true) --边缘回弹
    end

    local function CellTouchCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            
            local _img = tolua.cast(sender, "ImageView")
            local _tag = _img:getTag()
            iniTips(_tag)
            if focusTaskID == _tag then
                return 
            end
            local imgbefor =  tolua.cast(scl_tasklist:getChildByTag(focusTaskID), "ImageView")
            imgbefor:loadTexture( "button14_tong_2.png" )
            
            focusTaskID = _tag
            _img:loadTexture( "button14_tong_1.png" )

            --local posX, posY = _img:getPosition()
            --focusImg:setPosition( ccp( posX, posY) )
            flushDataPart()


            
        end
    end

    
    
    for i=1,Datanum do
        
        local imgBG = ImageView:create()
        if i == focusTaskID then
            imgBG:loadTexture("button14_tong_1.png")
        else
            imgBG:loadTexture("button14_tong_2.png")
        end
        imgBG:setScale9Enabled(true)
        imgBG:setTag(i)
        imgBG:setSize(CCSize(276, 66))
        imgBG:setPosition( ccp( cell_X, cell_Y ) )
        imgBG:addTouchEventListener( CellTouchCB )
        imgBG:setTouchEnabled(true)

        local CellBG_W, CellBG_H = 72, 70
        local CellBG_dis = 6
        local CellBG_X, CellBG_Y = -95, 0

        local lbl_name = Label:create()
        lbl_name:setText( "宝藏" .. i)
        lbl_name:setFontSize(24)
        lbl_name:setColor( ccc3(201, 192, 119) )
        lbl_name:setAnchorPoint( ccp(0, 0) )
        lbl_name:setPosition( ccp(-105, 42) )
        imgBG:addChild( lbl_name )
---[=[
        for k=1,3 do
            local tipsState = XunBaoData.getTaskTip( i, k )

            if tipsState ~= 0 then
                local imgTaskCellBG = ImageView:create()
                imgTaskCellBG:loadTexture("floor+47_tong.png")
                imgTaskCellBG:setPosition( ccp( CellBG_X, CellBG_Y ) )
                imgBG:addChild( imgTaskCellBG )
    ---[==[
                local imgTips = ImageView:create()
                if ifserver == true then
                    imgTips:loadTexture(paths[tipsState])
                    print( "i == " .. i)
                    print("k == " .. k)
                    print( "XunBaoData.getTaskTip( i, k ) == "..XunBaoData.getTaskTip( i, k ))
                else 
                    imgTips:loadTexture(paths[tipsPos[i][k]])
                end
                
                imgTips:setPosition( ccp( CellBG_X, CellBG_Y ) )
                imgTips:setScale( 0.4 )
                imgBG:addChild( imgTips )
    --]==]
                CellBG_X = CellBG_X + 70
            end
        end
--]=]
        local img_box = ImageView:create()
        img_box:loadTexture("button2_renwu_1.png")
        img_box:setPosition( ccp( 110, 0) )
        imgBG:addChild( img_box )

        local scale = 0.5
        local imgArrows1 = ImageView:create()
        imgArrows1:loadTexture("floor+22_tong.png")
        imgArrows1:setScaleX(-scale)
        imgArrows1:setScaleY(scale)
        imgArrows1:setPosition( ccp( -59, 0) )
        imgBG:addChild( imgArrows1 )

        if XunBaoData.getTaskTip( i, 3 )~= 0 then --是否加入第二个箭头
            local imgArrows2 = ImageView:create()
            imgArrows2:loadTexture("floor+22_tong.png")
            imgArrows2:setScaleX(-scale)
            imgArrows2:setScaleY(scale)
            imgArrows2:setPosition( ccp( 10, 0) )
            imgBG:addChild( imgArrows2 )
        end

        local imgArrows3 = ImageView:create()
        imgArrows3:loadTexture("floor+22_tong.png")
        imgArrows3:setScaleX(-scale)
        imgArrows3:setScaleY(scale)
        imgArrows3:setPosition( ccp( 79, 0) )
        imgBG:addChild( imgArrows3 )

        scl_tasklist:addChild( imgBG )
        cell_Y = cell_Y - cell_H - cell_disY
    end
--[[
    focusImg = ImageView:create()
    focusImg:loadTexture("pic+17_xunbao.png")
    focusImg:setPosition( ccp( focus_X, focus_Y ))
    scl_tasklist:addChild( focusImg )
--]]

end

function flushDataPart()
    focusFaceID = XunBaoData.getFaceId( focusTaskID )
    labelTimes:setText( XunBaoData.getTreasureRetData("times") ) 
    for i=1,4 do
       imgGen[i]:loadTexture( paths[ XunBaoData.getGenData( i ) ] )
    end
    for i=1,5 do
        local data = XunBaoData.getFoundData( i )
        print( "data == " .. data)
        if data == 0 then
            imgFound[i]:setVisible( false )
        else
            imgFound[i]:setVisible( true )
            imgFound[i]:loadTexture( paths[ data ] )
        end
    end
    --flush face
    for i=1,4 do
        if i == focusFaceID then
            imgGenFace[i]:setVisible( true )
        else
            imgGenFace[i]:setVisible( false )
        end
    end
    --open price
    --if XunBaoData.getGenData( 4 ) > 0 then
    --    labelPrice:setVisible(false)
    --end

    local function _nextStepCB(bone,evt,originFrameIndex,currentFrameIndex)
        if evt == "end" then
            imgFoundPanel:removeNodeByTag(123)
            XunBaoData.goBackRealData()
            flushDataPart()
            print(" armature callback")
                --[[
                local labelBMFont = LabelBMFont:create()  
                labelBMFont:setFntFile("word+10_public.fnt")  
                labelBMFont:setVisible(true)
                
                labelBMFont:setText("+" .. XunBaoData.getTreasureRetData("zeny"))
                labelBMFont:setPosition(ccp(0, 0))  
                --]]
                local zeny = Label:create()
                zeny:setText("+" .. XunBaoData.getTreasureRetData("zeny") .. "银币")
                zeny:setVisible(true)
                zeny:setPosition(ccp(0,0))
                zeny:setFontSize(20)
                local function CallFucnCallback2(sender)
                  zeny:setVisible(false)
                  imgFoundPanel:removeChildByTag(321, false)
                end
                local array = CCArray:create()
                --array:addObject(CCScaleBy:create(0.5, 1.2, 1.2))

                local action = CCSpawn:createWithTwoActions(
                
                CCMoveBy:create(1, ccp(0, 160)),
                CCSpawn:createWithTwoActions(CCFadeOut:create(0.5),
                                             CCScaleBy:create(1.0, 1.8, 1.8))
                                                )
                array:addObject(action)
                array:addObject(CCCallFuncN:create(CallFucnCallback2))

                imgFoundPanel:addChild(zeny)
                zeny:runAction(CCSequence:create(array))  
                zeny:setTag(321)
        end
    end
    --animat
    if XunBaoData.getTreasureRetData( "win" ) == 1 then
        local _armature = ArmatureManager.createArmature(UiEffectPath, "xunbao", 5)
        _armature:getAnimation():playWithIndex(0,-1, -1, -1)
        _armature:setAnchorPoint(ccp(0.5, 0.5))
        _armature:setPosition(ccp(0, 150))
        _armature:setTag(123)
        _armature:getAnimation():setFrameEventCallFunc(_nextStepCB)
        imgFoundPanel:addNode(_armature)
        print(" _armature  over ")
    end
end
local function _initPubMod()
    if ifserver == true then
        focusTaskID = 1
        focusFaceID = XunBaoData.getFaceId( 1 )
    end
    --bmpFont
      
    local btn_close = tolua.cast( Layer:getWidgetByName("Button_GuanBi"), "Button" )
    local btn_buy = tolua.cast( Layer:getWidgetByName("Button_Buy"), "Button" )
        local function CloseCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then 
            local _btn = tolua.cast(sender, "Button")
            if _btn==  btn_close then
                exitUI()
            elseif _btn == btn_buy then  --todo :购买寻宝次数
                protoSend0x0412()
            end
        end
    end
    btn_close:addTouchEventListener(CloseCB)
    btn_buy:addTouchEventListener( CloseCB )

    

    img_Tips = tolua.cast( Layer:getWidgetByName("ImageView_tips"), "ImageView")
    lbl_tip_name = tolua.cast( Layer:getWidgetByName("Label_Title"), "Label")
    lbl_tip_jiangLi = tolua.cast( Layer:getWidgetByName("Label_jiangLi"), "Label")
    
    img_Tips:setVisible(false)
    img_Tips:setTouchEnabled(false)

    local function TipsCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
            img_Tips:setVisible(false)
            img_Tips:setTouchEnabled(false)
        end
    end

    img_Tips:addTouchEventListener(TipsCB)
    --state
    --imgState = tolua.cast( Layer:getWidgetByName("ImageView_ZhuangTai"), "ImageView")
    --     labelState = tolua.cast( imgState:getChildByName("Label_ZhuangTai"), "label")
    --times
    labelTimes = tolua.cast( Layer:getWidgetByName("Label_XunBaoCount"), "Label")

    local function btnCB(sender, eventType)
        if eventType == PT.ccs.TouchEventType.ended then
           
            local _img = tolua.cast(sender, "ImageView")
            local tag = _img:getTag()
            print("tag == " .. tag)
            if ifserver == true then
                if tag == 4 and XunBaoData.getGenData( 4 ) == 0 then
                    local str = "开启此格需要消耗1000金币，是否确认？"
                    Loading:LoadingHide()
                    Pop3_XFTiShi.enterUI( 416,  str,0 )
                elseif tag==0 then
                    local str = "刷新需要消耗10金币，是否确认？"
                    Pop3_XFTiShi.enterUI( 414,  str,tag)
                    print("=====whyprotoSend0x0414")
                else
                    protoSend0x0414( tag )
                end  
            else
                ---[[
                local labelBMFont = LabelBMFont:create()  
                labelBMFont:setFntFile("word+10_public.fnt")  
                labelBMFont:setVisible(true)
                
                labelBMFont:setText("110")
                labelBMFont:setPosition(ccp(0, 0))  
                --]]
                --[[
                local zeny = Label:create()
                zeny:setText("110")
                zeny:setFontSize(20)
                --]]
                ---[[
                local function CallFucnCallback2(sender)
                  labelBMFont:setVisible(false)
                  --zeny:removeFromParentAndCleanup()
                  --imgFoundPanel:removeChildByTag(222)
                end
                local array = CCArray:create()
                --array:addObject(CCScaleBy:create(0.5, 1.2, 1.2))

                local action = CCSpawn:createWithTwoActions(
                
                CCMoveBy:create(1, ccp(0, 160)),
                CCSpawn:createWithTwoActions(CCFadeOut:create(0.5),
                                             CCScaleBy:create(1.0, 1.8, 1.8))
                                                )
                --]]

                array:addObject(action)
                array:addObject(CCCallFuncN:create(CallFucnCallback2))

                imgFoundPanel:addChild(labelBMFont)
                labelBMFont:runAction(CCSequence:create(array))  
                labelBMFont:setTag(222)
                         
            end
        end
    end

    --generate
    for i=1,4 do
        btn = tolua.cast( Layer:getWidgetByName("Button_Choice" .. i), "Button")
        btn:setTag( i )
        btn:addTouchEventListener( btnCB )
        imgGen[i] = tolua.cast( btn:getChildByName("ImageView_Choice" .. i), "ImageView")
        imgGen[i]:addTouchEventListener( btnCB )
        imgGenFace[i] = tolua.cast( btn:getChildByName("ImageView_face" .. i), "ImageView")
        imgGenFace[i]:setVisible( false )
    end
    --imgFoundPanel
    imgFoundPanel = tolua.cast( Layer:getWidgetByName("ImageView_519"), "ImageView")
    --found
    for i=1,5 do
        imgFound[i] = tolua.cast( Layer:getWidgetByName("ImageView_Pic" .. i), "ImageView")
    end
    --flush
    btn = tolua.cast( Layer:getWidgetByName("Button_shuaXin"), "Button")
    btn:setTag( 0 )
    btn:addTouchEventListener( btnCB )
    --openPrice
    --labelPrice = tolua.cast( Layer:getWidgetByName("Label_OpenLim4"), "Label")

    --滑动层
    scl_tasklist = tolua.cast( Layer:getWidgetByName("ScrollView_517"), "ScrollView")
    flushScrollViewTaskList()

    flushDataPart()

end

function exitUI()
    if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        --Layer:clear()
        _widget = nil
        Layer = nil
        
        LM.STATE_3 = 0
    end

    if LM.STATE_9 == 1 then
        MapPubUI.setPubVisible(true)
    elseif LM.STATE_9 == 2 then
        GuoZhan_MainUI.setPubVisible(true)
    end
end
function enterUI()
   
    LM.clearLayer3ToUI() --不用xunbaobase了？

    LM.STATE_3 = UI_XunBao

    Layer = LM.getLayer3()
    _widget = GUIReader:shareReader():widgetFromJsonFile("XunBao_XunBao.json")   

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)

    if LM.STATE_9 == 1 then
        MapPubUI.setPubVisible(false)
    elseif LM.STATE_9 == 2 then
        GuoZhan_MainUI.setPubVisible(false)
    end

    _initPubMod()
end

