module("ChengJiuTan", package.seeall)

local Layer = nil
local _widget = nil
local scene = nil
local ScrollView_chengjiu = nil
local isHadJumpTo = false


function exitUI()
     if Layer ~= nil and _widget ~= nil then
        Layer:removeWidget(_widget)
        _widget = nil
        Layer = nil
        LM.STATE_3 = 0
    end
    MapPubUI.setPubVisible(true)
end



local function btn_LingQuClick(sender, eventType)
      if eventType == PT.ccs.TouchEventType.ended then
        local _btn = tolua.cast(sender, "Button")
        local tag = _btn:getTag()           
        print("tag === " .. tag)

        
        -- _btn:setTouchEnabled(false)
        -- _btn:setBright(false)
        protoSend0x0530(tag)

    end   
end     



local function mRichTextClick(sender, eventType)
      if eventType == PT.ccs.TouchEventType.ended then
        print("tag ===mRichTextClick")
        exitUI()
        HelpUI.enterUI()
    end   
end    


local function paseTT(_str)
    local str2 = _str
    local i, j = string_find(str2 , "~")
    if i ~= nil then
        print("替代 1 。。。")
        str2=string.gsub(str2, "~", "~ ")
    end
    i, j = string_find(str2 , "{")
    if i ~= nil then
        print("替代 2 。。。")
        str2=string.gsub(str2, "{", " { ")
    end
    
    i, j = string_find(str2 , "’")
    if i ~= nil then
        print("替代 3 。。。")
        str2=string.gsub(str2, "’", " ’ ")
    end

    i, j = string_find(str2 , "”")
    if i ~= nil then
        print("替代 4 。。。")
        str2=string.gsub(str2, "”", " ” ")
    end

    i, j = string_find(str2 , ",")
    if i ~= nil then 
        print("替代 5 。。。")
        str2=string.gsub(str2, ",", " , ")
    end

    i, j = string_find(str2 , ":")
    if i ~= nil then
        print("替代 6 。。。")
        str2=string.gsub(str2, ":", " : ")
    end

    i, j = string_find(str2 , "\"")
    if i ~= nil then
        print("替代 7 。。。")
        str2=string.gsub(str2, "\"", " \" ")
    end
--[[            
    --英文的"."有问题
    i, j = string_find(str2 , ".")
    if i ~= nil then
        str2=string.gsub(str2, ".", " . ")
    end
--]]
    return str2
end





function refresh_Map()
    --ScrollView_chengjiu:setBackGroundColorType(0)
    ScrollView_chengjiu:removeAllChildren()
    ScrollView_chengjiu:setBounceEnabled(true)

    --可视区域
    local view_W = ScrollView_chengjiu:getSize().width 
    local view_H = ScrollView_chengjiu:getSize().height 

    local cell_H = 220
    local cell_disY = 10

    local cheJiuData=Des.getAchievementData() --获取本地成就表数据
    local hangNum = #cheJiuData

    local serverChengjiuData= ChengJiuData.getChengJiuData() --获取服务器成就数据

    ScrollView_chengjiu:setInnerContainerSize(CCSize(view_W, cell_H*hangNum+cell_disY*(hangNum-1)) )

    local scroll_W = ScrollView_chengjiu:getInnerContainerSize().width 
    local scroll_H = ScrollView_chengjiu:getInnerContainerSize().height

    local cell_Y =  scroll_H-cell_H/2
    print("cell_Y == " .. cell_Y)
    print("scroll_W == " .. scroll_W)
    print("scroll_H == " .. scroll_H)

    for i=1,hangNum do

        --背景1
        local img_bg1 = ImageView:create()
        img_bg1:setAnchorPoint(ccp(0,0.5))
        img_bg1:setPosition(ccp(0,cell_Y -(cell_H+cell_disY)*(i-1)))
        img_bg1:loadTexture("floor+1_chengjiu.jpg") 
        img_bg1:setScale9Enabled(true)
        img_bg1:setSize(CCSizeMake(scroll_W,cell_H));
        local bg1Size = img_bg1:getSize()
        --背景2
        local img_bg2= ImageView:create()
        img_bg2:setPosition(ccp(bg1Size.width/2 ,0))
        img_bg2:loadTexture("floor+" .. (i+2) .. "_chengjiu.jpg") 
        img_bg2:setScale9Enabled(true)
        img_bg2:setSize(CCSizeMake(bg1Size.width-10,bg1Size.height -10));
        img_bg1:addChild(img_bg2)

        --lv
        local bmLab_lv = LabelBMFont:create()
        bmLab_lv:setFntFile("myBMFont.fnt")
        bmLab_lv:setText("LV" .. cheJiuData[i]["level"])
        if i==1 then
            bmLab_lv:setPosition(ccp(bg1Size.width -bmLab_lv:getSize().width +5,bg1Size.height/2 -bmLab_lv:getSize().height+10)) 
        elseif i==2 or i==3 then
            bmLab_lv:setPosition(ccp(bg1Size.width -bmLab_lv:getSize().width +20 ,bg1Size.height/2 -bmLab_lv:getSize().height+10))        
        else
            bmLab_lv:setPosition(ccp(bg1Size.width -bmLab_lv:getSize().width +23 ,bg1Size.height/2 -bmLab_lv:getSize().height+10))        
        end
        img_bg1:addChild(bmLab_lv)


        local img_daShiJi= ImageView:create()
        img_daShiJi:loadTexture("floor+17_chengjiu.png")
        img_daShiJi:setPosition(ccp(img_daShiJi:getSize().width/2 +10,bg1Size.height/2 -img_daShiJi:getSize().height/2 -10))
        img_bg1:addChild(img_daShiJi)


        local miaoShuDes =cheJiuData[i]["str"]
        local miaoShuDesNum =#miaoShuDes
        for idx=1,#miaoShuDes do
            local _richText = RichText:create()
            _richText:ignoreContentAdaptWithSize(false)
            
            --_richText:setFontSize(24)
            _richText:setAnchorPoint( ccp(0, 0.5) )

            if i==1 and idx==3 then
                _richText:setSize(CCSizeMake(460, 25))
                _richText:setTouchEnabled(true)
                _richText:addTouchEventListener(mRichTextClick)
            else
                _richText:setSize(CCSizeMake(600, 25))
            end

             _richText:setTag(100)
            if miaoShuDesNum==1 then
                _richText:setPosition(ccp(10,-10-25 *idx))
            elseif miaoShuDesNum==2 then
                _richText:setPosition(ccp(10,5-25 *idx))
            elseif miaoShuDesNum==3 then
                _richText:setPosition(ccp(10,20-25 *idx))
            elseif miaoShuDesNum==4 then
                _richText:setPosition(ccp(10,35-25 *idx))
            else
                _richText:setPosition(ccp(10,40-25 *idx))
            end


            local function addElement( _str, _typeColor )
                _str = paseTT(_str)
                local _re1 = RichElementText:create(1, ccc3(GoodsColorTab[_typeColor][1], GoodsColorTab[_typeColor][2], GoodsColorTab[_typeColor][3]), 255, _str, "Helvetica", 24);
                _richText:pushBackElement( _re1 )
            end

            local parsestr = nil
            parsestr = function (_str)
                local len = string.len(_str)
                local i, j = string.find(_str , "<")
                if i ~= nil then
                    local str1 = string.sub(_str, 1, i-1) --截取<之前的数据
                    print(str1)
                    addElement(str1, 1)

                    _str = string.sub(_str, j+1, len)--截取<之后的数据
                    len = string.len(_str)
                    i, j = string.find(_str , ":")
                    if i == 2 then --: 位置
                        local number = tonumber( string.sub(_str, 1, i-1) ) --截取色值索引

                        _str = string.sub(_str, j+1, len) --截取:后数据
                        len = string.len(_str)
                        i, j = string.find(_str , ">")
                        if i~= nil then
                            print(number)
                            local str2 = string.sub(_str, 1, i-1) --截取:后>前数据
                            print(str2)
                            --todo:正确的颜色节点
                            addElement( str2, number )
                            _str = string.sub(_str, j+1, len) --截取>后数据
                            --递归解析
                            parsestr(_str )
                        else --没有:
                            _str = "<" .. number .. ":" .. _str --恢复数据
                            print("1_error: " .. _str)
                            --todo:普通节点
                            addElement(_str, 1)
                        end
                    else -- < 尖括号里没有: 把
                        _str = "<" .. _str --恢复数据
                        print("2_error: " .. _str)
                        --todo:普通节点
                        addElement(_str, 1)
                    end
                else
                    print("3_error: " .. _str)
                    --todo:普通节点
                    addElement(_str, 1)
                    print("4_error: " .. _str)
                end
            end     
            parsestr(miaoShuDes[idx])
            img_bg1:addChild(_richText)
        end



        -- local _richText2= RichText:create()
        -- _richText2:ignoreContentAdaptWithSize(false)
        -- _richText2:setSize(CCSizeMake(600, 25))
        -- _richText2:setAnchorPoint( ccp(0, 0.5) )
        -- _richText2:setPosition(ccp(400,0))
        --  img_bg1:addChild(_richText2)

        --  local reimg = RichElementImage:create(6, ccc3(255,255,255), 255, "button4_tong_1.jpg")

        -- -- local img_gold2= ImageView:create()
        -- -- img_gold2:loadTexture("floor+13_tong.png")
        -- --img_gold:setPosition(ccp(bg1Size.width- 50 ,0))
        -- --img_bg1:addChild(img_gold)
        --  local btn_Li = Button:create()
        -- btn_Li:setAnchorPoint(ccp(0,0.5))
        -- btn_Li:setTitleText( "领取奖励" )
        -- btn_Li:setTitleFontSize(24)
        -- btn_Li:loadTextures("button4_tong_1.jpg","button4_tong_2.jpg","button4_tong_3.jpg")
        -- btn_Li:addTouchEventListener(btn_LingQuClick)
        -- btn_Li:setTag(100)
        --  btn_Li:setTouchEnabled(false)
           
        --  --btn_Li:loadTextures("button4_tong_1.jpg","button4_tong_2.jpg","button4_tong_3.jpg")

        -- local cusNode= RichElementCustomNode:create(1, ccc3(255,255,255), 255, btn_Li)

        --  _richText2:pushBackElement(reimg)
        --  _richText2:pushBackElement(cusNode)



        local lab_jiangLi = Label:create()
        lab_jiangLi:setAnchorPoint(ccp(1,0.5))
        lab_jiangLi:setText("奖励:" .. cheJiuData[i]["value"])
        lab_jiangLi:setFontSize(24)
        lab_jiangLi:setColor( ccc3(250, 198, 138) )
        lab_jiangLi:setPosition(ccp(bg1Size.width- 70 ,0))
        img_bg1:addChild(lab_jiangLi)

        local img_gold= ImageView:create()
        img_gold:loadTexture("floor+13_tong.png")
        img_gold:setPosition(ccp(bg1Size.width- 50 ,0))
        img_bg1:addChild(img_gold)


        --领取按钮
        local btn_LingQu = Button:create()
        btn_LingQu:setAnchorPoint(ccp(0,0.5))
         btn_LingQu:loadTextures("button4_tong_1.jpg","button4_tong_2.jpg","button4_tong_3.jpg")
        btn_LingQu:setPosition(ccp(bg1Size.width- 165 ,-45))
        btn_LingQu:setTitleFontSize(24)
        --textButton:setTitleColor( ccc3( _r, _g, _b ) )
        img_bg1:addChild(btn_LingQu)
        btn_LingQu:setTag(i)

        if serverChengjiuData[i]["State"]==0 then
            btn_LingQu:setTitleText( "领取奖励" )
            btn_LingQu:setTouchEnabled(false)
            btn_LingQu:setBright(false)
        elseif serverChengjiuData[i]["State"]==1 then
            btn_LingQu:setTitleText( "领取奖励" )
            btn_LingQu:addTouchEventListener(btn_LingQuClick)

            --跳到第一个可领取的成就位置
            if isHadJumpTo == false then
                isHadJumpTo = true
                local mPercent = (cell_H+cell_disY+45)*(i-1) /scroll_H
                if mPercent>1 then
                    mPercent=1
                end
                ScrollView_chengjiu:jumpToPercentVertical(mPercent*100)

            end
        elseif serverChengjiuData[i]["State"]==2 then
            btn_LingQu:setTitleText("已领取")
            btn_LingQu:setTouchEnabled(false)
            btn_LingQu:setBright(false)

            --已领取
            local img_yiLingQu= ImageView:create()
            img_yiLingQu:loadTexture("floor+2_chengjiu.png")
            img_yiLingQu:setPosition(ccp(bg1Size.width- img_yiLingQu:getSize().width/2 ,bg1Size.height/2 -img_yiLingQu:getSize().height/2))
            img_bg1:addChild(img_yiLingQu)

        end

        ScrollView_chengjiu:addChild(img_bg1)
           
    end    
end



local function initPub()
    local btn_close = tolua.cast( Layer:getWidgetByName("Button_close"), "Button" )
    local function btn_CB(sender, eventType)
       if eventType == PT.ccs.TouchEventType.ended then        
            local _btn = tolua.cast(sender, "Button")
            if _btn == btn_close then
                exitUI()
            end
        end
    end
    btn_close:addTouchEventListener( btn_CB )

    ScrollView_chengjiu=tolua.cast( Layer:getWidgetByName("ScrollView_chengjiu"), "ScrollView" )

    refresh_Map()

    
    
end


function enterUI(curScene)
    
    LM.STATE_3 = UI_ChengJiu_cheJiuTan

    Layer = LM.getLayer3()
    _widget = GUIReader:shareReader():widgetFromJsonFile("ChengJiuTan.json") 

    Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)

    MapPubUI.setPubVisible(false)

    isHadJumpTo = false
    
    initPub()

   

  

    
end