module ("GNR_ZhaoMu",package.seeall)

local Layer = nil
local _widget = nil

function _flushJiangLingScrollView()
	local _scrollview = tolua.cast( Layer:getWidgetByName("ScrollView_WuJiangList"), "ScrollView" )
	_scrollview:removeAllChildren()
	_scrollview:setClippingEnabled(true) --裁切窗口
	_scrollview:setBackGroundColorType(0)
	_scrollview:setBounceEnabled(true)

	local camp = PlayerData.getCamp()+1
	
	local _campNum,_campData = Des.getZhaoMuJeneralDesFromCamp(camp) --所在阵营的可招募将领数量和数据
	local _pubNum, _pubData = Des.getZhaoMuJeneralDesFromCamp(4) --公共的可招募将领数量和数据
	local _initNum, _initData = Des.getZhaoMuJeneralDesFromCamp(5) --初始将数量和数据

	--筛选将领，剔除未获得并弃用武将
	local function getGeneral(_dataList)
		local newData = {}

		local _size = #_dataList
		for i=1, _size do
			local _data = _dataList[i]
			if _data["xianshi"] == 0 then --弃用的武将
				local _id = _data["generalId"]
				if GeneralData.getGenralIdxFromId(_id) ~= 0 then --是已获得的武将
					table_insert(newData, _data)
				end
			elseif _data["xianshi"] == 1 then --使用的武将
				table_insert(newData, _data)
			end
		end
		return #newData, newData
	end

	local campNum,campData = getGeneral(_campData)
	local pubNum, pubData = getGeneral(_pubData)
	local initNum, initData = getGeneral(_initData)

	local getKeZhaoMuMaxNum = GeneralData.getMaxYesNum() --可招募的最大上限
	--local yiZhaoMuNum = GeneralData.getYesGeneralDataNum() --已招募的数量

	local function getGeneralBefor(dataA, dataB)
		local tab_pub = {}
		local tab_camp = {}
		local sizeA = #dataA
		local sizeB = #dataB
		for i=1, sizeA do 
			local data = dataA[i]
			local state,_ = GeneralData.ifOntheNoTeam(data["generalId"])
			if state == false then --未获得
			    table_insert(tab_pub, data)
			else--已获得但未招募
				table_insert(tab_pub,1, data)
			end

		end

		for i=1, sizeB do
			local data = dataB[i]
			local state,_ = GeneralData.ifOntheNoTeam(data["generalId"])
			if state == false then --未获得
			    table_insert(tab_camp, data)
			else--已获得但未招募
				table_insert(tab_camp, 1,data)
			end

		end
		--[[
		for i=1, sizeA do 
			local data = dataA[i]
			local state,_ = GeneralData.ifOntheNoTeam(data["generalId"])
			if state == false then --已获得但未招募
			    table_insert(tab_camp, data)
			else
				table_insert(tab_pub, data)
			end

		end

		for i=1, sizeB do
			local data = dataB[i]
			local state,_ = GeneralData.ifOntheNoTeam(data["generalId"])
			if state == false then --已获得但未招募
			    table_insert(tab_camp, data)
			else
				table_insert(tab_pub, data)
			end

		end
		--]]
		return #tab_pub, tab_pub, #tab_camp, tab_camp
	end
	pubNum, pubData, campNum, campData = getGeneralBefor(pubData, campData)

	--节点数量
	--本阵营数+公共数+初始将数（1）+ （最大可招募数量-已招募数量+1个添加节点+2个分割线）
	--local dataNum = campNum+pubNum+getKeZhaoMuMaxNum-yiZhaoMuNum+2
	local dataNum = campNum+pubNum+1+getKeZhaoMuMaxNum + 3
---------行数计算滑动区域-------------------------------------------------------------------	
	--已招募所占行数
	local topHangNum =  math.ceil((getKeZhaoMuMaxNum+1)/6)
	--分割线所占行数
	local midHangNum = 2
	--未招募所占行数
	local bomHangNum = math.ceil((dataNum-getKeZhaoMuMaxNum-1)/6)

-----------------------------------------------------
	--可视区域
    local view_W = _scrollview:getSize().width 
    local view_H = _scrollview:getSize().height 

    local cell_W, cell_H = 118, 140
	
	local cell_disY = 10 --纵向间隔
    local cell_disX = 10 --横向间隔

	_scrollview:setInnerContainerSize( CCSize(view_W, (topHangNum+bomHangNum)*(cell_H+cell_disY) +midHangNum*(cell_disY+4) ))
    
    local scroll_H = _scrollview:getInnerContainerSize().height
    local cell_X = 90 --计算得出
    local cell_Y = scroll_H-cell_H/2

    local remPos = 1

    local fenGePos = getKeZhaoMuMaxNum+2 --分割线所在位置

	local function Img_TouchCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			local _img = tolua.cast(sender, "ImageView")
			local tag = _img:getTag()
			if tag == 0 then --添加可招募上限
				protoSend0x0488()
			else
				GNR_ZhaoMu_Pop3.enterUI(tag, camp)
			end
		end
	end
	print("fenGePos ===== " .. fenGePos)
    local function addHeadAndName(_img, _idx)

    	if _idx < fenGePos then --已招募
    		print("_idx ==== " .. _idx)
    		if _idx == fenGePos-1 then --加锁
    			print("_idx ==== " .. _idx)
    			local img_suo = ImageView:create()
		        img_suo:loadTexture( "floor+11_tong.png" )
		        img_suo:setPosition(ccp(6, 17))
		        _img:addChild(img_suo)

	           	--注册事件
		        _img:setTag(0)
    			_img:setTouchEnabled(true)
	        	_img:addTouchEventListener( Img_TouchCB )		        
    		else
    			---[[
    			local data = GeneralData.getYesGeneralDataFromIndex(_idx)
    			if data == nil then
    				return
    			end
    			local _generalDes = Des.getGeneralDesFromId( data["GenneralId"] )
				local headPath = RoleHeadPath .. _generalDes["generalHeadIcon"] .. ".png"

					local img_head = ImageView:create()
		        	img_head:loadTexture( headPath )
		        	img_head:setPosition(ccp(6, 17))
		        	img_head:setScaleX(-1)
		        	--img_head:setScaleX(-0.75)
		        	--img_head:setScaleY(0.75)
		        _img:addChild(img_head)
		        	local _lbl = Label:create()
	                _lbl:setText( _generalDes["generalName"] )
	                _lbl:setFontSize( 20 )
	                _lbl:setPosition(ccp(6, -50))
	                --_lbl:setColor( ccc3( GoodsColorTab[quality][1], GoodsColorTab[quality][2], GoodsColorTab[quality][3]) )
	            _img:addChild(_lbl)

	           	--注册事件
		        _img:setTag(data["GenneralId"])
    			_img:setTouchEnabled(true)
	        	_img:addTouchEventListener( Img_TouchCB )
	        	--]]
    		end
    	elseif _idx == fenGePos+1 then --初始将
    		local jeneralId,_ = GeneralData.getInitJeneralId(initData[1]["generalId"], initData[2]["generalId"])
	    	--[[
	    	local state,_ = GeneralData.ifOntheYesTeam(initData[1]["generalId"])
	    	if state == false then
	    		state,_ = GeneralData.ifOntheYesTeam(initData[2]["generalId"])
	    		jeneralId = initData[2]["generalId"]
	    	else
	    		jeneralId = initData[1]["generalId"]
	    	end
	    	--]]
  			print("jeneralId == " .. jeneralId)
	    		local _generalDes = Des.getGeneralDesFromId( jeneralId )
				local headPath = RoleHeadPath .. _generalDes["generalHeadIcon"] .. ".png"
				local img_head = ImageView:create()
			    img_head:loadTexture( headPath )
			    img_head:setPosition(ccp(6, 17))
			    img_head:setScaleX(-1)
			    --img_head:setScaleX(-0.75)
			    --img_head:setScaleY(0.75)
			    local state,_ = GeneralData.ifOntheNoTeam(jeneralId)
			    if state == false then --已获得但未招募
			        img_head:setOpacity(50)
			    end
			    _img:addChild(img_head)
			    local _lbl = Label:create()
		        _lbl:setText( _generalDes["generalName"] )
		        _lbl:setFontSize( 20 )
		        _lbl:setPosition(ccp(6, -50))
		        --_lbl:setColor( ccc3( GoodsColorTab[quality][1], GoodsColorTab[quality][2], GoodsColorTab[quality][3]) )
		        _img:addChild(_lbl)
		        --注册事件
		        _img:setTag(jeneralId)
    			_img:setTouchEnabled(true)
	        	_img:addTouchEventListener( Img_TouchCB )
	        		    	
    	elseif _idx > fenGePos+1 then --未招募
    		_idx = _idx - fenGePos-1
    		if _idx <= pubNum then
    			local jeneralId = pubData[_idx]["generalId"]

    			print("jeneralId == " .. jeneralId)
	    		local _generalDes = Des.getGeneralDesFromId( jeneralId )
				local headPath = RoleHeadPath .. _generalDes["generalHeadIcon"] .. ".png"
				local img_head = ImageView:create()
			    img_head:loadTexture( headPath )
			    img_head:setPosition(ccp(6, 17))
			    img_head:setScaleX(-1)
			    --img_head:setScaleX(-0.75)
			    --img_head:setScaleY(0.75)
			    local state,_ = GeneralData.ifOntheNoTeam(jeneralId)
			    if state == false then --已获得但未招募
			        img_head:setOpacity(50)
			    end
			    _img:addChild(img_head)
			    local _lbl = Label:create()
		        _lbl:setText( _generalDes["generalName"] )
		        _lbl:setFontSize( 20 )
		        _lbl:setPosition(ccp(6, -50))
		        --_lbl:setColor( ccc3( GoodsColorTab[quality][1], GoodsColorTab[quality][2], GoodsColorTab[quality][3]) )
		        _img:addChild(_lbl)
		        --注册事件
		        _img:setTag(jeneralId)
    			_img:setTouchEnabled(true)
	        	_img:addTouchEventListener( Img_TouchCB )
    		else
    			local jeneralId = campData[_idx-pubNum-1]["generalId"]

	    		local _generalDes = Des.getGeneralDesFromId( jeneralId )
				local headPath = RoleHeadPath .. _generalDes["generalHeadIcon"] .. ".png"
					local img_head = ImageView:create()
			        img_head:loadTexture( headPath )
			        img_head:setPosition(ccp(6, 17))
			        img_head:setScaleX(-1)
			        --img_head:setScaleX(-0.75)
			        --img_head:setScaleY(0.75)
			        local state,_ = GeneralData.ifOntheNoTeam(jeneralId)
			        if state == false then --已获得但未招募
			        	img_head:setOpacity(50)
			        end
			    _img:addChild(img_head)
			        local _lbl = Label:create()
		            _lbl:setText( _generalDes["generalName"] )
		            _lbl:setFontSize( 20 )
		            _lbl:setPosition(ccp(6, -50))
		            --_lbl:setColor( ccc3( GoodsColorTab[quality][1], GoodsColorTab[quality][2], GoodsColorTab[quality][3]) )
		        _img:addChild(_lbl)
		        --注册事件
		        _img:setTag(jeneralId)
    			_img:setTouchEnabled(true)
	        	_img:addTouchEventListener( Img_TouchCB )
    		end
    	end
   	end

    for i=1, dataNum do
    	print("fenGePos == " .. fenGePos)
    	print("i === " .. i)
    	if i == fenGePos then --分割线位置
    		print("分割线----------------------")
    		cell_Y = cell_Y-cell_H/2-cell_disY-2
	        
	        local img_fenge = ImageView:create()
	        img_fenge:loadTexture( "floor+12_tong.png" )
	        img_fenge:setPosition(ccp(view_W/2, cell_Y))
		        local _lbl = Label:create()
	            _lbl:setText( "未 招 募 通 用 将")
	            _lbl:setFontSize( 24 )
	            _lbl:setPosition(ccp(0, 0))
	            img_fenge:addChild(_lbl)
	        _scrollview:addChild( img_fenge )

	        cell_Y = cell_Y-cell_H/2-cell_disY-2
	        cell_X = 90
	        remPos = 1
	    elseif i==fenGePos+1 then --初始将
	    	print("初始将----------------------")
	    	local jeneralid,_ = GeneralData.getInitJeneralId(initData[1]["generalId"], initData[2]["generalId"])
	    	local state,_ = GeneralData.ifOntheYesTeam( jeneralid )
	    	
	    	-- if state == false then
	    	-- 	state,_ = GeneralData.ifOntheYesTeam( jeneralid )
	    	-- end
    		
    		print("jeneralid == " .. jeneralid)
    		if state == false then --剔除已经招募的
	    		print("jeneralid == " .. jeneralid)

	    		local img_headBG= ImageView:create()
		        img_headBG:loadTexture( "floor+17_tong.png" )
		        img_headBG:setPosition(ccp(cell_X, cell_Y))
		        	addHeadAndName(img_headBG, i)
		        _scrollview:addChild( img_headBG )

		        if remPos < 6 then
		    		cell_X = cell_X+cell_W+cell_disX
		    		remPos = remPos + 1
		    	else
		    		remPos = 1
		    		cell_X = 90
		    		cell_Y = cell_Y - cell_H - cell_disY
		    	end
	    	end

    	elseif i<fenGePos then --已招募位置
    		print("已招募----------------------")
	        local img_headBG= ImageView:create()
	        img_headBG:loadTexture( "floor+17_tong.png" )
	        img_headBG:setPosition(ccp(cell_X, cell_Y))
	        	addHeadAndName(img_headBG, i)
	        _scrollview:addChild( img_headBG )
	        print("remPos == " .. remPos)
	    	if remPos < 6 then
	    		cell_X = cell_X+cell_W+cell_disX
	    		remPos = remPos + 1
	    	else
	    		if remPos ~= fenGePos-1 then
	    			remPos = 1
	    			cell_X = 90
	    			cell_Y = cell_Y - cell_H - cell_disY
	    		end
	    	end
	    	

    	elseif i>fenGePos+1 then --未招募位置
    		print("未招募----------------------")
    		local _idx = i - fenGePos-1
    		local jeneralId = 0

    		if _idx == pubNum+1 then
	    		print("分割线----------------------")
		        cell_Y = cell_Y + cell_H/2
		        local img_fenge = ImageView:create()
		        img_fenge:loadTexture( "floor+12_tong.png" )
		        img_fenge:setPosition(ccp(view_W/2, cell_Y))
			        local _lbl = Label:create()
		            _lbl:setText( "未 招 募 威 望 将")
		            _lbl:setFontSize( 24 )
		            _lbl:setPosition(ccp(0, 0))
		            img_fenge:addChild(_lbl)
		        _scrollview:addChild( img_fenge )

		        cell_Y = cell_Y-cell_H/2-cell_disY-2
		        cell_X = 90
		        remPos = 1


    		else

	    		if _idx <= pubNum then
	    			jeneralId = pubData[_idx]["generalId"]
	    		else
	    			jeneralId = campData[_idx-pubNum-1]["generalId"]
	    		end
	    		local state,_ = GeneralData.ifOntheYesTeam(jeneralId)
	    		if state == false then --剔除已经招募的
		    		
		    		local img_headBG= ImageView:create()
			        img_headBG:loadTexture( "floor+17_tong.png" )
			        img_headBG:setPosition(ccp(cell_X, cell_Y))
			        	addHeadAndName(img_headBG, i)
			        _scrollview:addChild( img_headBG )

			        if _idx == pubNum then
				    	remPos = 1
				    	cell_X = 90
				    	cell_Y = cell_Y - cell_H - cell_disY
			        else
				        if remPos < 6 then
				    		cell_X = cell_X+cell_W+cell_disX
				    		remPos = remPos + 1
				    	else
				    		remPos = 1
				    		cell_X = 90
				    		cell_Y = cell_Y - cell_H - cell_disY
				    	end
			    	end
		    	end
	    	end
    	end



    end
end


function exitUI()
	if Layer ~= nil and _widget ~= nil then
		Layer:removeWidget(_widget)
		--Layer:clear()
		_widget = nil
		Layer = nil
		
		LM.STATE_3 = 0
	end
	GeneralData.reSortYesAndNoTeam()
end

function enterUI()
	LM.STATE_3 = UI_General_ZhaoMu

	Layer = LM.getLayer3()
	_widget = GUIReader:shareReader():widgetFromJsonFile("GNR_ZhaoMu.json")

	Layer:addWidget(_widget)
    _widget:setTouchEnabled(false)

    _flushJiangLingScrollView()

    guideFactory.CheckGuideProcess( LM.STATE_3 )
end

--[==[
	local yesNum = 0 --已招募将领数
	local noNum  = 0 --为招募将领数
local starcolor = {{0,170,249},{0,248,23},{255,255,0},{255,0,0},{205,14,252}} --蓝，绿，黄，红，紫
local remRoleIndex = 0 --记录将领序列，默认是1

local _scrollview = nil
local btn_ZhaoMu = nil --招募/解聘
local LabelBMFont_zhaomu = nil
local ifZM = true --记录btn_ZhaoMu的恩建状态，true：招募 false：解聘

local img_Head 			= nil
local lbl_Name 		= nil
local lbl_Lv        =nil
local lbl_bingzhong 	= nil
local lbl_zhanfa 		= nil
local lbl_Tong 			= nil
local lbl_Yong 			= nil
local lbl_Mou 			= nil
local lbl_bingli		= nil
local lbl_budui 		= nil
local lbl_bingzhongJS 	= nil
local lbl_zhanfaJS 		= nil

--这两个是否需要隐藏，通过数据判断
local img_nvshenHead 	= nil
local	lbl_nvShen= nil
local	 lbl_nsshuxing =nil
local	lbl_nslv= nil
local	lbl_nspinjie= nil
local lbl_nvShenJS = nil
local lbl_jiagetitle = nil
	local lbl_jiage = nil
local lbl_jiegushuoming = nil
--招募武将上限
local Label_zhaoMuNum =  nil
local btn_addLim = nil
function flushLim()
	local curNum = GeneralData.getYesGeneralDataNum()
	local MaxNum = GeneralData.getMaxYesNum()
	print("刷新招募 curNum == " .. curNum)
	print("刷新招募 MaxNum == " .. MaxNum)
	Label_zhaoMuNum:setText(curNum .. "/" .. MaxNum)
end
function flushGenerolMessage()
	local data = nil
	if yesNum> 0 and remRoleIndex <= yesNum then
		data = GeneralData.getYesGeneralDataFromIndex(remRoleIndex)
	elseif noNum > 0 and (remRoleIndex-yesNum) <= noNum then
		data = GeneralData.getNoGeneralDataFromIndex(remRoleIndex-yesNum)
	else
		return --没将领数据？
	end

	lbl_Tong:setText( data["Attr_t"] )
	lbl_Yong:setText( data["Attr_y"] )
	lbl_Mou:setText( data["Attr_m"] )
	lbl_bingli:setText( data["CurHp"] .. "/" .. data["TotalHp"] )
	
	local _Z, _X = math_modf( data["UnitLv"]/10 )
	lbl_budui:setText( _Z .. "阶" .. _X*10 .. "星")

	local desGeneral = Des.getGeneralDesFromId( data["GenneralId"] )
	img_Head:loadTexture( RoleHeadPath .. desGeneral["generalHeadIcon"] .. ".png" )
	lbl_Name:setText( desGeneral["generalName"])
    lbl_Lv:setText(data["Lv"])
	local unitId = data["Unit"]
	local desUnit = Des.getUnitDesFromId( unitId )
	lbl_bingzhong:setText( desUnit["unitName"] )
	lbl_zhanfaJS:setText( desUnit["unitDes"] )

	local skillId = data["Skill"]
	print("skillId == " .. skillId)
	if skillId == 0 then
		lbl_zhanfa:setText("")
		lbl_bingzhongJS:setText("")
	else
		local desSkill = Des.getSpAttackDesFromId( skillId )
		lbl_zhanfa:setText( desSkill["SpAttackName"] )
		local _js = desSkill["SpAttackDes"]
	--[[	
		if string_len(_js) > 30 then
			_js = string_sub(_js, 1, 27)
			_js = _js .. "..."
		end
	--]]
		lbl_bingzhongJS:setText( _js )
	end

	if data["GoddessId"] == 0 then --没有女神
		img_nvshenHead:setVisible(false)
        lbl_nsshuxing:setColor(ccc3(255,255,255))
		lbl_nvShen:setText("无")
        lbl_nsshuxing:setText("无")
          lbl_nslv:setText("无")
        lbl_nspinjie:setText("无")
        lbl_nvShenJS:setText("")
	else
       -- img_nvshenHead:
		 lbl_nslv:setText(data["GoddessLv"])
        local goddesstype =nil
        if data["GoddessType"] == 1 then
 			goddesstype = "火"
 			lbl_nsshuxing:setColor(ccc3(starcolor[4][1],starcolor[4][2],starcolor[4][3]))
            lbl_nvShenJS:setText("(晴天攻击力增强)")
          
 		elseif data["GoddessType"] == 2 then
 			goddesstype = "水"
 			lbl_nsshuxing:setColor(ccc3(starcolor[1][1],starcolor[1][2],starcolor[1][3]))
            lbl_nvShenJS:setText("(雨天攻击力增强)")
 		else
            lbl_nsshuxing:setColor(ccc3(starcolor[2][1],starcolor[2][2],starcolor[2][3]))
 			goddesstype = "风"
 			lbl_nvShenJS:setText("(阴天攻击力增强)")
 		end
        lbl_nsshuxing:setText(goddesstype)
		local desGods = Des.getGoddessDesFromId( data["GoddessId"] )
		--local desGodsSkill = Des.goddessSkillDes( data[""] )
		local quality,_= math_modf( data["GoddessStar"]/11 )
		local star = data["GoddessStar"]%11

		-- local desGods = Des.getGoddessDesFromId( data["GoddessId"] )
		-- --local desGodsSkill = Des.goddessSkillDes( data[""] )
		-- local _pinZhi,_ = math_modf( data["GoddessStar"]/11 )


		img_nvshenHead:setVisible(true)
		img_nvshenHead:loadTexture( SexHeadPath .. desGods["goddessIcon"] .. "_1" .. ".png"  )

  --[[     
        local quality,_ = math.modf(starAllNumber/ 11) 
	print("the quality  is "..quality)
	print("the starAllNumber is "..starAllNumber)]]
	    local color = nil
	    if quality== 4 then
		    color = "紫色"		
   	    elseif  quality==3 then
	        color = "红色"
	
        elseif 	quality ==2 then
		    color = "黄色"
				
	    elseif quality == 1 then
		    color = "绿色"
					
        elseif quality==0 then
		    color = "蓝色"					
	    end
	     lbl_nspinjie:setText(color..star.."星")

      --  lbl_nspinjie:set
         local desGods = Des.getGoddessDesFromId( data["GoddessId"] )
		lbl_nvShen:setText( desGods["goddessName"] )
        lbl_nvShen:setColor(ccc3(starcolor[quality+1][1],starcolor[quality+1][2],starcolor[quality+1][3]))
 		lbl_nspinjie:setColor(ccc3(starcolor[quality+1][1],starcolor[quality+1][2],starcolor[quality+1][3]))
       -- img_nvshenHead:loadTexture(desGods["goddessIcon"]..".png")
        end
	

	if data["State"] == 1 then --已招募
		--img_jiage:setVisible(false)
		lbl_jiagetitle:setVisible(false)
		lbl_jiegushuoming:setVisible(true)
		ifZM = false
		--btn_ZhaoMu:loadTextures("button+24_general_1.png", "button+24_general_2.png", "")
		LabelBMFont_zhaomu:setText("解 雇")
	else
		--img_jiage:setVisible(true)
		lbl_jiagetitle:setVisible(true)
		lbl_jiage:setText( data["Price"] .. "银币")
		ifZM = true
		lbl_jiegushuoming:setVisible(false)
		--btn_ZhaoMu:loadTextures("button+20_general_1.png", "button+20_general_2.png", "")
		LabelBMFont_zhaomu:setText("招 募")
	end

end

local function _initPubMod()
	btn_ZhaoMu = tolua.cast( Layer:getWidgetByName("Button_zhaomu"), "Button" )
	LabelBMFont_zhaomu = tolua.cast( Layer:getWidgetByName("LabelBMFont_zhaomu"), "LabelBMFont" )
	local function btn_CB(sender, eventType)
		local _btn = tolua.cast(sender, "Button")
		if eventType == PT.ccs.TouchEventType.ended then
			 
			local data = nil
			if yesNum> 0 and remRoleIndex <= yesNum then
				data = GeneralData.getYesGeneralDataFromIndex(remRoleIndex)
			elseif noNum > 0 and (remRoleIndex-yesNum) <= noNum then
				data = GeneralData.getNoGeneralDataFromIndex(remRoleIndex-yesNum)
			else
				return --没将领数据？
			end
			if ifZM then --招募
				protoSend0x0254(data["Index"], 0)
			else --解聘
				protoSend0x0254(data["Index"], 1)
			end
			
			--protoSend0x0254(1,1)
		end
	end
	btn_ZhaoMu:addTouchEventListener(btn_CB)

	img_Head 		= tolua.cast( Layer:getWidgetByName("ImageView_Head"), "ImageView" )
	lbl_Name 		= tolua.cast( Layer:getWidgetByName("Label_Name"), "Label" )
    lbl_Lv          =   tolua.cast( Layer:getWidgetByName("Label_lv"), "Label" )
	lbl_bingzhong 	= tolua.cast( Layer:getWidgetByName("Label_bingzhong"), "Label" )
	lbl_zhanfa 		= tolua.cast( Layer:getWidgetByName("Label_zhanfa"), "Label" )
	lbl_Tong 		= tolua.cast( Layer:getWidgetByName("Label_Tong"), "Label" )
	lbl_Yong 		= tolua.cast( Layer:getWidgetByName("Label_Yong"), "Label" )
	lbl_Mou 		= tolua.cast( Layer:getWidgetByName("Label_Zhi"), "Label" )
	lbl_bingli		= tolua.cast( Layer:getWidgetByName("Label_BingLi"), "Label" )
	lbl_budui 		= tolua.cast( Layer:getWidgetByName("Label_BuDui"), "Label" )
	lbl_bingzhongJS = tolua.cast( Layer:getWidgetByName("Label_bingzhongJS"), "Label" )
	lbl_zhanfaJS 	= tolua.cast( Layer:getWidgetByName("Label_bingfa"), "Label" )

--这两个是否需要隐藏，通过数据判断
	img_nvshenHead 	= tolua.cast( Layer:getWidgetByName("ImageView_nvshen"), "ImageView" )
		lbl_nvShen = tolua.cast( Layer:getWidgetByName("Label_nvShenName"), "Label" )
		lbl_nslv   = tolua.cast( Layer:getWidgetByName("Label_nvshenLv"), "Label" )
		lbl_nsshuxing   = tolua.cast( Layer:getWidgetByName("Label_nvshenshuxing"), "Label" )
        lbl_nspinjie   = tolua.cast( Layer:getWidgetByName("Label_nvshenpinjie"), "Label" )
        lbl_nvShenJS = Label:create()
        lbl_nvShenJS:setPosition(ccp(100,0))
        lbl_nvShenJS:setFontSize(18)
        lbl_nsshuxing:addChild(lbl_nvShenJS)
	--img_jiage = tolua.cast( Layer:getWidgetByName("ImageView_JiaGe"), "ImageView" )
	lbl_jiagetitle = tolua.cast( Layer:getWidgetByName("Label_JiaGetitle"), "Label" )
		lbl_jiage = tolua.cast( Layer:getWidgetByName("Label_JiaGe"), "Label" )
	lbl_jiegushuoming = tolua.cast( Layer:getWidgetByName("Label_jiegushuoming"), "Label" )
	
	remRoleIndex = 1

	Label_zhaoMuNum =  tolua.cast( Layer:getWidgetByName("Label_zhaoMuNum"), "Label" )
	flushLim()
	btn_addLim = tolua.cast( Layer:getWidgetByName("Button_addLim"), "Button" )
		local bmf_zi = tolua.cast( Layer:getWidgetByName("LabelBMFont_1731"), "LabelBMFont" )
		bmf_zi:setTouchEnabled(false)
	local function addlimt(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			protoSend0x0488()
		end
	end
	btn_addLim:setTouchEnabled(true)
	btn_addLim:addTouchEventListener(addlimt)
end
--设置引导的焦点，通过将领id
function setGuideFource( _jeneralId )
	print("remRoleIndex == " .. remRoleIndex)
	local imgbefor =  tolua.cast(_scrollview:getChildByTag(remRoleIndex), "ImageView")
	imgbefor:loadTexture( "button+4_public_1.png" )

	remRoleIndex = GeneralData.getGenralIdxFromId(_jeneralId)
	print("remRoleIndex == " .. remRoleIndex)
	local imgcur = tolua.cast(_scrollview:getChildByTag(remRoleIndex), "ImageView")
	imgcur:loadTexture( "button+4_public_2.png" )
	flushGenerolMessage()
end

local function _initJiangLingScrollView()
	_scrollview = tolua.cast( Layer:getWidgetByName("ScrollView_roleList"), "ScrollView" )
	_scrollview:setClippingEnabled(true) --裁切窗口
	
	_scrollview:setBackGroundColorType(0)
	_scrollview:removeAllChildren()
	local cell_disY = 5
	local cell_disX = 0
	--可视区域
	local view_W = _scrollview:getSize().width 
	local view_H = _scrollview:getSize().height 


	local Datanum = 19 --总数
	if ifserver then
		yesNum = GeneralData.getYesGeneralDataNum()
		noNum = GeneralData.getNoGeneralDataNum()
		Datanum = yesNum + noNum
	end
	local lieNum = 2
	local hangNum = math.ceil(Datanum/lieNum)

	if hangNum < 6 then
		_scrollview:setBounceEnabled(false) 
	else
		_scrollview:setBounceEnabled(true) --边缘回弹
	end

	_scrollview:setInnerContainerSize( CCSize(view_W, 75*hangNum) )

	--滑动区域
	local scroll_W = _scrollview:getInnerContainerSize().width
	local scroll_H = _scrollview:getInnerContainerSize().height

	local cell_W, cell_H = 210, 70
	local cell_X, cell_Y = cell_W/2-5, scroll_H-cell_H/2

	local function Img_TouchCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			 
			local _img = tolua.cast(sender, "ImageView")
			local tag = _img:getTag()
			guideFactory.CheckGuideProcess(nil)
			if tag == remRoleIndex then
				return
			end
			local imgbefor =  tolua.cast(_scrollview:getChildByTag(remRoleIndex), "ImageView")
			imgbefor:loadTexture( "button+4_public_1.png" )
			remRoleIndex = tag
			_img:loadTexture( "button+4_public_2.png" )
			
			flushGenerolMessage()
			--local _duigou = tolua.cast(_img:getChildByTag(10), "ImageView")
			--_duigou:setVisible(true)
		end
	end

	for i=1, hangNum do
		for j=1, lieNum do
			local idx =  (i-1)*lieNum+j
			if idx > Datanum then
				return
			end 
			local data = nil
			local desData = nil
			local ifGod = false
---[[			
			if idx <= yesNum then --已招募
				data = GeneralData.getYesGeneralDataFromIndex(idx)
				local id = data["GenneralId"]
				desData = Des.getGeneralDesFromId( id )
			else
				data = GeneralData.getNoGeneralDataFromIndex(idx-yesNum)
				local id = data["GenneralId"]
				desData = Des.getGeneralDesFromId( id )
			end
			if data["GoddessId"] ~= 0 then
            	ifGod = true
        	else
            	ifGod = false
        	end
--]]
		    local imageBG = ImageView:create()
		    imageBG:setTouchEnabled(true)
		    if remRoleIndex == idx then
		    	imageBG:loadTexture("button+4_public_2.png")
		    else
		    	imageBG:loadTexture("button+4_public_1.png")
			end
		    imageBG:setPosition( CCPoint( cell_X, cell_Y ) )
		   	imageBG:addTouchEventListener(Img_TouchCB)
		   	imageBG:setTag(idx)
		   		if ifGod then
	                local _imgGod = ImageView:create()
	                _imgGod:loadTexture( "floor+8_bag.png" )
	                _imgGod:setPosition(ccp(75, 0))
	                imageBG:addChild( _imgGod )
	            end 

		   		local _lbl = Label:create()
		   		if ifserver then
		   			_lbl:setText( desData["generalName"] )
		   		else
		   			_lbl:setText( idx )
		   		end
		   		_lbl:setFontSize( 26 )
				_lbl:setColor( ccc3(239, 224, 199) )
		   		imageBG:addChild(_lbl)
		   		
		   			local ImageIfZhao = ImageView:create()
		   			ImageIfZhao:loadTexture("floor+17_public_2.png")
		   			ImageIfZhao:setPosition( CCPoint(70, 0) )
		   			ImageIfZhao:setTag(10)
		   		if ifserver and data["State"] == 1 then
		   			ImageIfZhao:setVisible(true)
		   		else
		   			ImageIfZhao:setVisible(false)
		   		end
		   		imageBG:addChild( ImageIfZhao )
		   	_scrollview:addChild( imageBG )
		   	cell_X = cell_X + cell_W + cell_disX
		end
		cell_X = cell_W/2-5
		cell_Y = cell_Y - cell_disY - cell_H
	end
end
function CMD255Cb(_ifzhao)
	local imgbefor =  tolua.cast(_scrollview:getChildByTag(remRoleIndex), "ImageView")
	local _duigou = tolua.cast(imgbefor:getChildByTag(10), "ImageView")
	if _ifzhao then
		_duigou:setVisible(true)
	else
		_duigou:setVisible(false)
	end

	_initJiangLingScrollView()
	flushGenerolMessage()
end

function exitUI()
	if Layer ~= nil and _widget ~= nil then
		Layer:removeWidget(_widget)
		--Layer:clear()
		_widget = nil
		Layer = nil
		
		LM.STATE_3 = 0
	end
	GeneralData.reSortYesAndNoTeam()
end

function enterUI()
	LM.STATE_3 = UI_General_ZhaoMu

	Layer = LM.getLayer3()
	_widget = GUIReader:shareReader():widgetFromJsonFile("GNR_ZhaoMu.json")

	Layer:addWidget(_widget)
    _widget:setTouchEnabled(false)

	--_initPubMod()
    --_initJiangLingScrollView()
    --flushGenerolMessage()
end
--]==]
--[[
function enterUI( _Scene )
	PT.UI_State = UI_General_ZhaoMu
	

	curScene = _Scene
	Layer = TouchGroup:create()
	Layer:setZOrder(10)
	--Layer:setTouchEnabled(false)
    local _widget = GUIReader:shareReader():widgetFromJsonFile("GNR_ZhaoMu.json")    
    _widget:setTouchEnabled(false)
    Layer:addWidget(_widget)
    _Scene:addChild(Layer)
	
	_initPubMod()
    
    _initJiangLingScrollView()

    
    flushGenerolMessage()
    print("招募检测引导....")
	guideFactory.CheckGuideProcess(curScene)
    
end

function exitUI()
	curScene:removeChild(Layer, true)
	--Layer:onExit()
	GeneralData.reSortYesAndNoTeam()
end
--]]