module ("NvGuiZe",package.seeall)


local Layer = nil
local _widget = nil


local function initPubUI(_shuXing, _GongJi, _A, _D, _S, _curQulity)	

	print("_shuXing == " .. _shuXing)
	print("_GongJi == " .. _GongJi)
	print("_A == " .. _A)
	print("_D == " .. _D)
	print("_S == " .. _S)
	print("_curQulity == " .. _curQulity)

	local btn_close = tolua.cast( Layer:getWidgetByName("Button_exit"), "Button" )
	local function btn_closeCB(sender, eventType)
		if eventType == PT.ccs.TouchEventType.ended then
			exitUI()
		end
	end
	btn_close:addTouchEventListener( btn_closeCB )


	local img_tips = tolua.cast( Layer:getWidgetByName("ImageView_tips"), "ImageView" )

	local lbl_gongJi = tolua.cast( Layer:getWidgetByName("Label_gongJi"), "Label" )
	local img_icon = tolua.cast( Layer:getWidgetByName("ImageView_icon"), "ImageView" )

	local lbl_lv = tolua.cast( Layer:getWidgetByName("Label_lv"), "Label" )
	--火水风
	if _shuXing == 1 then
		lbl_lv:setText("女神攻击时有几率对目标造成\"烈焰\"伤害")
		lbl_gongJi:setText("火属性攻击:" .. _GongJi)
		img_icon:loadTexture("floor+1_sex.png")
	elseif _shuXing == 2 then
		lbl_lv:setText("女神攻击时有几率对目标造成\"洪水\"伤害")
		lbl_gongJi:setText("水属性攻击:" .. _GongJi)
		img_icon:loadTexture("floor+3_sex.png")
	elseif _shuXing == 3 then
		lbl_lv:setText("女神攻击时有几率对目标造成\"飓风\"伤害")
		lbl_gongJi:setText("风属性攻击:" .. _GongJi)
		img_icon:loadTexture("floor+2_sex.png")
	end

	local lbl_huang = tolua.cast( Layer:getWidgetByName("Label_huang"), "Label" )
	local lbl_hong = tolua.cast( Layer:getWidgetByName("Label_hong"), "Label" )
	local lbl_zi = tolua.cast( Layer:getWidgetByName("Label_zi"), "Label" )

	--根据数据记录便宜位置
	local remPos = 0

	if _S == 1 then --次女神只打一个
		remPos = remPos + 70
		lbl_huang:setVisible(false)
	elseif _S == 3 then
		--todo:
			--
		if _curQulity >= 3 then
			local img_pos1 = tolua.cast( Layer:getWidgetByName("ImageView_mubiao1"), "ImageView" )
			local img_pos2 = tolua.cast( Layer:getWidgetByName("ImageView_mubiao2"), "ImageView" )
			if _shuXing == 1 then --横排
				img_pos1:setPosition( ccp(0, 33) )
				img_pos2:setPosition( ccp(0, -33) )
			elseif _shuXing == 2 then --纵排
				img_pos1:setPosition( ccp(33, 0) )
				img_pos2:setPosition( ccp(-33, 0) )
			elseif _shuXing == 3 then --三角
				img_pos1:setPosition( ccp(33, 33) )
				img_pos2:setPosition( ccp(33, -33) )
			end
		end
	end

	--移动红色位置
	if _A == 0 then
		remPos = remPos + 70
		lbl_hong:setVisible(false)
	else
		local posx, posy = lbl_hong:getPosition()
		lbl_hong:setPosition(ccp(posx, posy+remPos))
		-- 1中毒2反间3混乱
		if _A == 1 then
			lbl_hong:setText("女神攻击时有几率对目标释放\"中毒\"效果")
		elseif _A == 2 then
			lbl_hong:setText("女神攻击时有几率对目标释放\"反间\"效果")
		elseif _A == 3 then
			lbl_hong:setText("女神攻击时有几率对目标释放\"混乱\"效果")
		end
	end
	--移动紫色位置
	if _D == 0 then
		remPos = remPos + 70 
		lbl_zi:setVisible(false)
	else
		local posx, posy = lbl_zi:getPosition()
		lbl_zi:setPosition(ccp(posx, posy+remPos))

		--4识破5反击
		if _D == 4 then
			lbl_zi:setText("将领受到攻击时，女神有几率触发\"识破\"效果")
		elseif _D == 5 then
			lbl_zi:setText("将领受到攻击时，女神有几率触发\"反击\"效果")
		end
	end

	--移动攻击范围和画布范围
	local img_3332 = tolua.cast( Layer:getWidgetByName("ImageView_3332"), "ImageView" )
	local posx, posy = img_3332:getPosition()
	img_3332:setPosition( ccp(posx, posy+remPos) )
---[[

	local size = img_tips:getSize()
	img_tips:setSize(CCSize(size.width, size.height-remPos))
--]]



end

function exitUI()
	if Layer ~= nil and _widget ~= nil then
		Layer:removeWidget(_widget)
		--Layer:clear()
		_widget = nil
		Layer = nil
		
		LM.STATE_10 = 0
	end
end
--女神属性，攻击力， 红，紫，黄品质的加成， 当前品质
function enterUI(_shuXing, _GongJi, _A, _D, _S, _curQulity)
	LM.STATE_10 = UI_NvShen_GuiZe  --todo:暂无此ui的状态

	Layer = LM.getLayer10()
	_widget = GUIReader:shareReader():widgetFromJsonFile("NvShen_Pop_GuiZe.json")

	Layer:addWidget(_widget)
    _widget:setTouchEnabled(true)
    initPubUI(_shuXing, _GongJi, _A, _D, _S,_curQulity)
end
