module ("guideFactory",package.seeall)

local GuideData = require "src/LocDes/guideData"

local remCurGuideId = 0 --0没有引导
local remStep = 0
local processData = {0} --进度数据
local ifCloseAllUi = false

local guidName = nil --引导保存文件的名字，和账号相关
local remCurStep = 0

isHaveGuideDoing = false  --是否有正在进行的引导
guideCurUi = 0

--初始化进度数据和引导数据
function guideFactoryInit()
	remCurGuideId = 0
	remStep = 0
	isHaveGuideDoing=false
	--todo：进度数据初始化
	local guidSize = #GuideData
	processData["size"] = guidSize   --引导数量

	for i=1, guidSize do
		local Size = #GuideData[i]
		processData[i] = {}
		processData[i]["size"] = Size
		processData[i]["state"]= 0 --每一个引导的状态，0：未完成，1：正在做，2：已完成
		
		for j=1, Size do
			processData[i][j] = 0 --每一步引导的状态 0：未完成 1：已完成
		end
	end
	local data_name = PT.getAccount("Account.lua")
	local countName = data_name["name"]
 	guidName = countName .. _G.loginServerId .. "Pro.lua"
	--读取本地记录
	local data = PT.getGuidePro(guidName)
	local data_Size = 0
	if data == nil then
		PT.saveGuidePro(guidName, processData)
		return
	else
		print("---------------新手引导初始化，获取了数据了，打印如下....")
		data_Size = #data
		print("data[Size] = " .. data["size"]) --引导个数
		for i=1, data_Size do
			local Size = data[i]["size"]
			print("	   data[" .. i .. "][size]" .. Size )  --每个引导的引导数量
			print("	   data[" .. i .. "][state]" .. data[i]["state"] ) --每个引导的状态
			for j=1, Size do
				print("	   	   data[" .. i .. "][".. j .. "] = " .. data[i][j] ) --每步引导的状态
			end
		end
	end
	
	--保存的引导的数量多于实际引导数量
	if data_Size > guidSize then
		print("删减了引导,请检查.....")
		return
	end

	--processData["size"] = data["size"] --这里不做赋值，以本地引导数据为准
	for i=1, data_Size do
		local Size = data[i]["size"]
		if processData[i]["size"] ~= Size then
			print("第" .. i .. "个引导的引导步骤数量不同了，请检查... ")
		end
		processData[i]["size"]  = Size
		processData[i]["state"] = data[i]["state"]
		
		for j=1, Size do
			processData[i][j] = data[i][j]
		end
	end

	if data_Size <= guidSize then
		PT.saveGuidePro(guidName, processData)
	end

end

function guideFactorySave()
	print("主动保存引导....")
	PT.saveGuidePro(guidName, processData)
end
--是否第一次登陆此游戏
function getIfFistPlay()
	--[[
	if processData[2] == 0 then --第一次登陆游戏，给引导
		return true
	elseif processData[2] == 1 then --已经给过引导了
		return false
	end
	--]]

	local curCharpterId = ChapterListData.getCurCharpterId()
	local curNpcId = NpcListData.getCurNpcId()
	print("curCharpterId == " .. curCharpterId)
	print("curNpcId == " .. curNpcId)
	local cityLv = CityData.getCityDataFromIndex(1)["Lv"] 
	--if curCharpterId == 1 and curNpcId == 1 and cityLv == 1 then
	if curCharpterId == 1 and curNpcId == 10101 and cityLv == 1 then
		return true
	else
		return false
	end
end

function setCanBeMove()
		--将不滑动设置为滑动
	if PT.UI_State  == UI_ZhuCheng then
    	MapShouYe.setScrollViewMove()
    elseif PT.UI_State  == UI_ZhengZhan then
    	MapZhengZhan.setScrollViewMove()
    end	
end
--guistate: 引导的状态0：未完成，1：正在做，2：已完成
function saveProcess( guistate )
	processData[remCurGuideId]["state"] = guistate
	
	if remStep >= 2 then --下一步开启才保存上一步
		processData[remCurGuideId][remStep-1] = 1
	end
	PT.saveGuidePro(guidName, processData)
end


local isNeedSetMove = false
local data = nil
local dataSize = 0

--跳过这个引导
function setBreakThisGuilde()

	for i=1, dataSize do
		processData[remCurGuideId][i] = 1
	end
	processData[remCurGuideId]["state"] = 2
	PT.saveGuidePro(guidName, processData)

	remCurGuideId = 0
	remStep = 0

	dataSize = 0
	data = nil

	setCanBeMove()
end

function clearAllTypeUi()
	print("退出引导 。。。 ")
	guideUI_a.exitUI()
	guideUI_b.exitUI()
	guideUI_c.exitUI()
	guideUI_d.exitUI()
end
--回退一步新手引导，用于新手引导时，退出提示弹出
local ifDoingGuide = false --记录当前是否在引导状态
function rebackOneStep()
	remStep = remCurStep
	print("当前 remStep ============ " .. remStep)
end
function getifDoingGuide()
	return ifDoingGuide
end

function NextStep(_uistate)

	remCurStep = remStep
	ifDoingGuide =  true
	local stepData = data[remStep]
	local uitype = stepData["UIStype"]

	local openUiData = stepData["OpenUI"]
	local openUISize = #openUiData
	local openUi = openUiData[openUISize]

	if LM.STATE_9 == 1 and remStep == 1 then --只在新手引导的第一步
		if stepData["OpenType"] == 1 then --展开
			MapPubUI.setPanelBtnState(true)
		elseif stepData["OpenType"] == 2 then --关闭
			MapPubUI.setPanelBtnState(false)
		end
	end

	print("openUI == " .. openUi)
	print("当前ui == " .. _uistate)
	if  openUi == UI_General_BuZhen and LM.STATE_3 == openUi and stepData["Move"]~=nil and stepData["Move"][1] == 1 then --布阵的引导特殊处理
		clearAllTypeUi()
		GNR_BuZhen.setGuideState(true)
		saveProcess(1) --保存当前引导
		remStep = remStep + 1
	elseif openUi == UI_ZhengZhan_PuTongNpc_Pop and LM.STATE_10 == UI_ZhengZhan_PuTongNpc_Pop and stepData["Move"]~=nil and stepData["Move"][3] ~= nil then --布阵的引导特殊处理
		clearAllTypeUi()
		Pop3_ZhengZhan.setGuideState(true)
		saveProcess(1) --保存当前引导
		remStep = remStep + 1
	elseif LM.STATE_15 == UI_Map_Fight and openUi == UI_Map_Fight then
		clearAllTypeUi()
		MapFight.setGuideState(true)
		saveProcess(1) --保存当前引导
		remStep = remStep + 1
	elseif openUi == _uistate then --检测是否引导ui
		if  stepData["Move"]~=nil and stepData["Move"][1]~= 0 then --说明坐标是scl动态
			if openUi == UI_ZhengZhan then --开启ui是征战, 从征战计算坐标
				local x, y = MapZhengZhan.getWordPositon( stepData["Move"][1] )
				stepData["PosX"] = "0:1:" .. x
				stepData["PosY"] = "0:4:" .. y

				isNeedSetMove = true
			elseif openUi == UI_ZhuCheng then
				local x, y = MapShouYe.getWordPositon( stepData["Move"][1] )
				print("move ==== " .. stepData["Move"][1])
				stepData["PosX"] = "0:1:" .. x
				stepData["PosY"] = "0:4:" .. y

				isNeedSetMove = true	

			--武将训练
			elseif openUi == UI_General_XunLian and stepData["Move"]~= nil and stepData["Move"][1]~= 0 then
				local jeneralId = stepData["Move"][1]
				GNR_XunLian.setGuideFource( jeneralId )	
			--背包装备
			elseif openUi == UI_BeiBao_ZhuangBei and stepData["Move"]~= nil and stepData["Move"][1]~= 0 then
				local jeneralId = stepData["Move"][1]
				BeiBao_ZhuangBei.setGuideFource( jeneralId )
			--背包装备的详情		
			elseif openUi == UI_BeiBao_Dress and stepData["Move"]~= nil and stepData["Move"][1]~= 0 then	
				local jeneralId = stepData["Move"][1]
				BeiBao_ZhuangBei.setGuideFource( jeneralId )
				if stepData["Move"][2]~= 0 then
					--详情的初始化在检测ui进行跳转的时候就做了
				end
			elseif openUi == UI_BeiBao_QiangHua and stepData["Move"]~= nil and stepData["Move"][1]~= 0 and stepData["Move"][2]~= 0  then
				local JeneralId = stepData["Move"][1]
				local goodsId = stepData["Move"][2]
				BeiBao_QiangHua.setGuideFource(JeneralId, goodsId)
			elseif openUi == UI_NvShen_JinJie and stepData["Move"]~= nil and stepData["Move"][1]~= 0 then
				local JeneralId = stepData["Move"][1]
				NvShen_JinJie.setGuideFource(JeneralId)
			end
		end
		print("第 " .. remCurGuideId .. " 个引导的第 " .. remStep .. " 步")
		print("uitype == " .. uitype)
		if uitype == 1 then --新功能提示	
			guideUI_d.enterUI(nil, stepData)
		elseif uitype == 2 then --对话事件
			guideUI_c.enterUI(nil, stepData)
		elseif uitype == 3 then --穿透事件
			guideUI_a.enterUI(nil, stepData)
		elseif uitype == 4 then --非穿透事件
			guideUI_b.enterUI(nil, stepData)
		end
		saveProcess(1) --保存当前引导
		remStep = remStep + 1

	else
		ifDoingGuide = false
	end
end
local remUI =0
function CheckGuideOpen(_uistate) --检测是否开启引导
	local GuideNum = #GuideData --引导数量
	
	for i=1, GuideNum do
		local guideData = GuideData[i] --一个引导数据
		local OpenData = guideData["Open"] --当前引导的开启条件
		local opentype = OpenData["type"]
		
			if opentype == 1 then --第一次登陆游戏
				if getIfFistPlay() then
					remCurGuideId = i
					remStep = 1
					
					data = GuideData[remCurGuideId]
					dataSize = #data

					NextStep(_uistate)
					return
				end
			elseif opentype == 2 then --主城等级

				local needLv = OpenData["A"]
				if CityData.getIfFistLv(1, needLv) then
					---[[
					if LM.STATE_3 == UI_City_ZhuCheng then
						Pop3_ZhuCheng.exitUI()
						_uistate = LM.STATE_1
						remUI = _uistate
					end

					remCurGuideId = i
					remStep = 1

					data = GuideData[remCurGuideId]
					dataSize = #data

					NextStep(_uistate)
					--]]
					return
				end
			elseif opentype == 3 then -----------3：第一次通关NPC ["a"]=关卡ID ["b"]=npcID
				local charpterId = OpenData["A"]
				local npcId = OpenData["B"]

				local curCharpterId = ChapterListData.getCurCharpterId()
				local curNpcId = NpcListData.getCurNpcId()
				if charpterId == curCharpterId and NpcListData.getNpcStatefromId(npcId) == 1 then
					---[[
					remCurGuideId = i
					remStep = 1

					data = GuideData[remCurGuideId]
					dataSize = #data

					NextStep(_uistate)
					--]]
					return
				end

			elseif opentype == 4 then --第一次攻击npc

			elseif opentype == 5 then --5:完成任务，["A"] = mainTaskId
				local mainTaskId = OpenData["A"]
				if TaskMainData.getStateFromId( mainTaskId ) then
					remCurGuideId = i
					remStep = 1

					data = GuideData[remCurGuideId]
					dataSize = #data

					NextStep(_uistate)
					return
				end
			elseif opentype == 6 then --6:军机处升级
				local needLv = OpenData["A"]
				if CityData.getIfFistLv(4, needLv) then
					---[[
					---[[
					if LM.STATE_3 == UI_City_JunJiChu then
						Pop3_JunJiChu.exitUI()
						_uistate = LM.STATE_1
						remUI = _uistate
					end
					--]]
					remCurGuideId = i
					remStep = 1

					data = GuideData[remCurGuideId]
					dataSize = #data
					
					NextStep(_uistate)
					--]]
					return
				end
			elseif opentype == 7 then 
				local splNpcId = OpenData["A"]

				if NpcListData.getSplNpcStatefromId(splNpcId) == 1 then
					---[[
					remCurGuideId = i
					remStep = 1

					data = GuideData[remCurGuideId]
					dataSize = #data

					NextStep(_uistate)
					--]]
					return
				end
			end
		--end
	end
end

--检测引导进程

function CheckGuideProcess(_uistate)
print("..........4")
	if _uistate == nil then
		_uistate = remUI
	else
		remUI = _uistate
	end
	if _G.ifGuideOpen then
		if remCurGuideId == 0 then --当前没有引导进行，需要检查是否开启引导
print("..........1")	
			CheckGuideOpen(_uistate)
		else
			if remStep == dataSize+1 then
print("..........2")	
				saveProcess(2) --引导完成

				remCurGuideId = 0
				remStep = 0

				data = nil
				dataSize = 0

				--ifCloseAllUi = true
				clearAllTypeUi()
				setCanBeMove()
				print("_uistate === " .. _uistate)
				CheckGuideProcess(_uistate) --检测是否有新的引导
			else
print("..........3")	
				NextStep(_uistate)
			end
		end
	end
end
local ifinguide = false --是否一进游戏就有引导
--检查是否有引导正在进行
function checkIfGuideDoing()

	if ifGuideOpen == false then
		return false
	end
--[[
	local guidSize = processData["size"]    --引导数量
	print("检测是否有引导...............")
	for i=1, guidSize do

		if processData[i]["state"] == 1 then--每一个引导的状态，0：未完成，1：正在做，2：已完成
			remCurGuideId = i
			print("有未完成的引导 i = " .. i)
			isHaveGuideDoing=true
			_G.ifGuideOpen =  false

			data = GuideData[remCurGuideId]
			dataSize = #data

			local Size = #processData[i]
			for j=1, Size do
				ifinguide =  true
				if processData[i][j] == 0 then--每一步引导的状态 0：未完成 1：已完成
					remStep = j
                    print("未完成引导的第 " .. j .. "步")
					local guideData = GuideData[i] --一个引导数据
					local data = guideData[j]
					local uiStateData = data["OpenUI"]
					local uiStateSize = #uiStateData
					local curScene = nil

					--第几章第几个npc
					local MoveData = data["Move"]
					local curCharpterId = 0
					local curNpcId = 0
					if MoveData ~= nil then
						curCharpterId = MoveData[1]
						curNpcId =  MoveData[2]
					end

					local ifneedCheck = true
					--local curUi = 0
					guideCurUi=0

					local ifSendMessage= false
					for k=1, uiStateSize do
						guideCurUi = uiStateData[k]
						--主城、世界
						if guideCurUi == UI_ZhuCheng then 
							MapShouYe.enterUI()
               				MapPubUI.enterUI() 
						elseif guideCurUi == UI_ShiJie  then
							MapShiJie.enterUI()
							MapPubUI.enterUI()
						end
						--征战、农田、银矿 一级UI
						if guideCurUi == UI_NongTian then
							--MapNongTian.enterUI()
							protoSend0x0434(0) --农田需要获得数据
							ifSendMessage = true
						elseif guideCurUi == UI_YinKuang then
							--MapYinKuang.enterUI()
							protoSend0x0434(1)  -- 银矿需要获得数据
							ifSendMessage = true
						elseif guideCurUi == UI_GuanKa_PuTong then
							GuanKaBase.enterUI(1)
						elseif guideCurUi == UI_GuanKa_JingYing then
							GuanKaBase.enterUI(2)
						end	


						if guideCurUi == UI_City_ZhuCheng then       --city主城pop ?
							Pop3_ZhuCheng.enterUI( 1 )
						elseif guideCurUi == UI_City_JunJiChu then   --city军机处pop ? 
							Pop3_JunJiChu.enterUI(  4  )
						elseif guideCurUi == UI_City_MinJu then      --city民居pop ?
							Pop3_MinJu.enterUI( 2  )
						elseif guideCurUi == UI_City_GuoKu then      --city国库pop ?
							Pop3_GuoKu.enterUI( 3  )
						elseif guideCurUi == UI_City_JunXieSuo then  --city军械所pop ?
							Pop3_JunXieKu.enterUI( 6  )
						elseif guideCurUi == UI_City_YiZhan then     --city驿站pop ?
							Pop3_YiZhan.enterUI( 7  )
						elseif guideCurUi == UI_City_JiaoChang then  --city校场pop ?
							Pop3_JiaoChang.enterUI( 5  )

						elseif guideCurUi == UI_ZhengZhan_PuTongNpc_Pop then --征战npc弹出

							ifneedCheck = false
	 						PT.setId(curCharpterId, curNpcId, 0)
	                        local npcdata = NpcListData.getNpcDataFromId(curNpcId, false)
	                        if npcdata["State"] == 0 then
	                            Pop3_TS_Result.enterUI( "此npc未开启！"  )
	                        else 
	                            protoSend0x0204( curCharpterId, curNpcId )
	                        end
	                   	elseif guideCurUi == UI_Fight_OverUi then --征战结果UI，直接下一步引导
	                   		remStep = remStep + 1
                            saveProcess(1)
	                   		checkIfGuideDoing()
	                   	elseif guideCurUi == UI_GetNewGeneral then --普通关卡获得新武将UI 直接跳过
	                   		remStep = remStep + 1
                            saveProcess(1)
	                   		checkIfGuideDoing()
	                   	--任务部分
	                    elseif guideCurUi==UI_RenWu_ZhuXian then --主线或者日常任务
	                    	RenWuBase.enterUI( 1)
	                    elseif guideCurUi == UI_RenWu_RiChang then
	                    	RenWuBase.enterUI( 2)
						--背包部分
						elseif guideCurUi == UI_BeiBao_BeiBao then 
							BeiBaoBase.enterUI( 1 )
						elseif guideCurUi == UI_BeiBao_ZhuangBei then 
							GeneralBase.enterUI(2)
						elseif guideCurUi == UI_BeiBao_QiangHua then 
							BeiBaoBase.enterUI( 2 )
						elseif guideCurUi == UI_BeiBao_WeiPai then 
							BeiBaoBase.enterUI( 3 )
						--武将部分
						elseif guideCurUi == UI_General_Jiangling then
							GeneralBase.enterUI( 6 )
						elseif guideCurUi == UI_General_XunLian then
							GeneralBase.enterUI( 1 )
						elseif guideCurUi == UI_General_PeiYang then
							GeneralBase.enterUI( 3 )
						elseif guideCurUi == UI_General_ZhaoMu then
							GeneralBase.enterUI( 4 )
						elseif guideCurUi == UI_General_KeJi then
							GNR_KeJi.enterUI()
						elseif guideCurUi == UI_General_BuZhen then
							GeneralBase.enterUI( 5 )
						--女神部分

						elseif guideCurUi == UI_NvShen_TuJian then
							NvShenBaseA.enterUI(2)
						elseif guideCurUi == UI_NvShen_LieBiao then
							NvShenBaseA.enterUI(1)
						--祭祀部分
						elseif guideCurUi == UI_JiSi then
							JiSiBase.enterUI()
						--征收购粮部分
						elseif guideCurUi == UI_ZhengShou_ZhengShou then
							ZhengShouBase.enterUI(1)
						elseif guideCurUi == UI_ZhengShou_GouLiang then	
							ZhengShouBase.enterUI(2)

						end

						if guideCurUi == UI_NvShen_JinJie then
							NvShenBase.enterUI(1, nil,1)
						elseif guideCurUi == UI_NvShen_ShengJi then
							NvShenBase.enterUI(2, nil,3)
						end

						if guideCurUi == UI_Map_Fight then --征战结果UI，直接下一步引导
	                   		remStep = remStep + 1
                            saveProcess(1)
	                   		checkIfGuideDoing()
	                   	end

						if guideCurUi == UI_BeiBao_Dress then  --背包的换装
							local jeneralId = MoveData[1] 
							local goodsIdx  = BagData.getgoodsIdxFromId(2, MoveData[2])
							local _type = 0
							print("Id == " .. MoveData[2])
							print( "goodsIdx  === " .. goodsIdx)
							Pop3_GoodsXiangQing.enterUI(curScene, goodsIdx,jeneralId, 0 )
						elseif guideCurUi == UI_BeiBao_ChangeOne then
							local jeneralId = MoveData[1] 
							local goodstype = MoveData[2] 
							local idx = 1
							if jeneralId ~= 0 then
								idx = GeneralData.getYesGeneralLocIdxFromJeneralId( jeneralId )
							end
							BeiBao_ZhuangBei.setGuideFource( jeneralId )
							Pop3_JiaoHuanOne.enterUI(idx, goodstype)
						elseif guideCurUi == UI_General_ZhaoMu_XiangQing then
							local camp = PlayerData.getCamp()+1
							GNR_ZhaoMu_Pop3.enterUI(MoveData[1], camp)
						end
					end
					if LM.STATE_9 == 1 then
						if data["OpenType"] == 1 then --展开
							MapPubUI.setPanelBtnState(true)
						elseif data["OpenType"] == 2 then --关闭
							MapPubUI.setPanelBtnState(false)
						end
					end
					_G.ifGuideOpen =  true
					print("当前引导 = " .. remCurGuideId)
					print("当前引导的步骤 = " .. remStep)
					ifinguide = false


					if ifSendMessage == false then --发送消息不需要
						--延迟加载，否则界面出不来
						local EntryID = 0
			            local scheduler = CCDirector:sharedDirector():getScheduler()
			            local function FlushPosition()
			            	--判断，有公告先不出现引导，如果没公告，直接出现引导
			            	if not MapPubUI.isTanchuSysTips then
			            		CheckGuideProcess(guideCurUi)
			            	end
			            		print("======tttttt2")
			                scheduler:unscheduleScriptEntry( EntryID )

			            end
			            EntryID = scheduler:scheduleScriptFunc( FlushPosition, 0.05, false)
		        	end
					return true
				end
			end
		end
	end
--]]
	return false

end
--用于判断引导开启下 菜单开关状态
function getGuideProState()
	if ifinguide then --在引导状态
		return true
	else
		return false
	end
end

--坐标解析
function GetPosFromStr(strx, stry)
	--"A:B:C"   A=坐标类型 0绝对坐标 1相对坐标    B=坐标加减 0加1减    C=坐标值

	local function paseFunc(str,_wich)
		local TTT = 0
		if _wich == 0 then
			TTT = UseW
		else
			TTT = UseH
		end
		local len = string_len(str) 
		local i, j = string_find(str , ":")
		local strA = string_sub(str, 1, i-1)
		
		str = string_sub(str, j+1, len)
		len = string_len(str) 
		i, j = string_find(str , ":")
		local strB = string_sub(str, 1, i-1)
		local strC = string_sub(str, j+1, len)

		local numA = tonumber(strA)
		local numB = tonumber(strB)
		local numC = tonumber(strC)
		if numA == 0 then
			if numB == 1 then --左
				return numC
			elseif numB == 2 then --右
				return UseW - numC
			elseif numB == 3 then --上
				return UseH - numC
			elseif numB == 4 then --下
				return numC
			end
		else
			if numB == 0 then
				return TTT/2+numC
			else
				return TTT/2-numC
			end
		end
	end
	return paseFunc(strx,0), paseFunc(stry,1)
end