module ("Des",package.seeall)

--将领描述
local generalDes = require "src/LocDes/GeneralDes"
--技能描述
local SpAttackDes = require "src/LocDes/SpAttackDes"
--女神描述
local goddessDes = require "src/LocDes/GoddessDes"
--女神技能描述
local goddessSkillDes = require "src/LocDes/GoddessSkillDes"
--科技描述
local TechnologyDes = require "src/LocDes/TechnologyDes"
--小兵描述
local UnitDes = require "src/LocDes/UnitDes"
--dot描述
local DotDes = require "src/LocDes/DotDes"
--事件描述
local EventDes = require "src/LocDes/EventDes"
--物品描述
local GoodsDes = require "src/LocDes/GoodsDes"
--世界城市的名字
local AreaDes = require "src/LocDes/AreaDes"
--征战章节的描述
local ChapterDes = require "src/LocDes/ChapterDes"
--征战npc的描述数据
local BattleDes = require "src/LocDes/BattleDes"
--征战隐藏npc的描述数据
local HideBattleDes = require "src/LocDes/HideBattleDes"
--关卡精英npc描述
local GroupBattleDes = require "src/LocDes/GroupBattleDes"

--主城城市的描述
local BuildDes = require "src/LocDes/BuildDes"
--官职描述
local OfficeDes = require "src/LocDes/officeDes"

local GuildTechDes = require "src/LocDes/GuildDes"

--日常任务
local DailyTaskDes = require "src/LocDes/DaytaskDes"
--主线任务
local MainTaskDes = require "src/LocDes/MaintaskDes"
--特权
local TeQuanBaseDes= require "src/LocDes/TeQuanBaseDes"
--可招募武將
local KeZhaoMuWuJiang = require "src/LocDes/JeneralZhaoMuDes"

local name1des = require "src/LocDes/name1Des"
local name2des = require "src/LocDes/name2Des"

local FunctionDes = require "src/LocDes/FunctionDes"
local LoadingtipsDes = require "src/LocDes/LoadingTipsDes"

--女神图鉴 --按照水火风属性的分类
local GoddessAtlasDes = require "src/LocDes/GoddessAtlas"
--女神列表 --按照国家分类
local GodListDes = require "src/LocDes/GodListDes"

--进阶石获取途径描述
local StoneWayDes = require "src/LocDes/DesGetStoneWay"

--本地成就描述
local AchievementDes = require "src/LocDes/AchievementDes"

--本地充值活动描述
local ChongZhiActivityDes = require "src/LocDes/ShopDes"

--系统公告
local SystemTipsDes = require "src/LocDes/SystemTips"

--战前对话
local fightTalk = require "src/LocDes/FightTalkData"

--泡泡对话
local fightPaopaoTalk = require "src/LocDes/FightPaoPaoTalkData"

--战斗演示的对话数据
local fightPaopaoTalk2 = require "src/LocDes/FightPaoPaoTalkData2"


LTipsNum = #LoadingtipsDes

function getRandomTipsDes()
    return LoadingtipsDes[math.random(LTipsNum)]
end

name1Num = #name1des
name2Num = #name2des

function getRandomName()
    return name1des[math.random(name1Num)]..name2des[math.random(name2Num)]
end

--dot描述
DotDesNum = #DotDes
    function getDatDesFromId( _id )
        for i=1, DotDesNum do
            if _id == DotDes[i]["damageOverTimeId"] then
                return DotDes[i]
            end
        end
    end
--将领描述
generalDesNum = #generalDes
	function getGeneralDesFromId( _id )
		for i=1, generalDesNum do
            if _id == generalDes[i]["generalId"] then        
                return generalDes[i]
            end
        end
        return nil
	end
--将领技能描述
SpAttackDesNum = #SpAttackDes
    function getSpAttackDesFromId( _id )
        for i=1, SpAttackDesNum do
            if _id == SpAttackDes[i]["SpAttackId"] then        
                return SpAttackDes[i]
            end
        end
        return nil
    end

--女神描述
goddessDesNum = #goddessDes
    function getGoddessDesFromId( _id )
    	for i=1, goddessDesNum do
            if _id == goddessDes[i]["goddessId"] then        
                return goddessDes[i]
            end
        end
        return nil
    end

--女神技能描述
goddessSkillDesNum = #goddessSkillDes
    function getGoddessSkillDesFromId( _id )
    	for i=1, goddessSkillDesNum do
            if _id == goddessSkillDes[i]["goddessSkillId"] then        
                return goddessSkillDes[i]
            end
        end
        return nil
    end

--科技描述
TechnologyDesNum = #TechnologyDes
    function getTechnologyDesFromId( _id )
        for i=1, TechnologyDesNum do
            if _id == TechnologyDes[i]["techID"] then        
                return TechnologyDes[i]
            end
        end
        return nil
    end
--小兵本地描述
UnitDesNum = #UnitDes
    function getUnitDesFromId( _id )
        for i=1, UnitDesNum do
            if _id == UnitDes[i]["unitId"] then        
                return UnitDes[i]
            end
        end
        return nil
    end
--征收事件的本地描述
EventDesNum = #EventDes
    function getEventDesFromId( _id )
        for i=1, EventDesNum do
            if _id == EventDes[i]["eventID"] then        
                return EventDes[i]
            end
        end
        return nil

    end

--物品描述
GoodsDesNum = #GoodsDes
    function getGoodsDesFromId( _id )
        for i=1, GoodsDesNum do
            if _id == GoodsDes[i]["goodsId"] then
                return GoodsDes[i]
            end
        end
        return nil
    end

--主城城市的描述
BuildDesNum = #BuildDes
    function getBuildDesFromId( _id )
        for i=1, BuildDesNum do
            if _id == BuildDes[i]["buildId"] then
                return BuildDes[i]
            end
        end
    end
--章节的描述
ChapterDesNum = #ChapterDes
    function getChapterDesFromId( _charpterId )
        for i=1, ChapterDesNum do
            if _charpterId == ChapterDes[i]["chapterID"] then
                return ChapterDes[i]
            end
        end
    end
    --获取最大章节id，也就是最后一个章节id
    function getMaxCharpterId()
        return ChapterDes[ChapterDesNum]["chapterID"]
    end

--征战npc的描述数据
BattleDesNum = #BattleDes
    function getBattleDesFromId( _charpterId, _npcId )
        for i=1, BattleDesNum do
            if _npcId == BattleDes[i]["battleID"] then
                return BattleDes[i]
            end
        end

--[[        
        local data = BattleDes[_charpterId]
        local dataNum = #data
        for i=1, dataNum do
            if _npcId == data[i]["battleID"] then
                return data[i]
            end
        end
--]]
    end
--隐藏npc
HideBattleDesNum = #HideBattleDes
    function getHideBattleDesFromId( _Id )
        for i=1, HideBattleDesNum do
            if _Id == HideBattleDes[i]["battleID"] then
                return HideBattleDes[i]
            end
        end
    end
--精英npc
GroupBattleDesNum = #GroupBattleDes
    function getGroupBattleDesFromId( _Id )
        for i=1, GroupBattleDesNum do
            if _Id == GroupBattleDes[i]["battleID"] then
                return GroupBattleDes[i]
            end
        end
    end
--征战城市名字及信息
AreaDesNum = #AreaDes
    function getAreaDesFromId( _id )
        for i=1, AreaDesNum do 
            if _id == AreaDes[i]["areaId"] then
                return AreaDes[i]
            end
        end
    end
--获取官职描述信息
OfficeDesNum = #OfficeDes
    function getOfficeDesFromId( _id )
        for i=1, OfficeDesNum do
            if _id == OfficeDes[i]["officeId"] then
                return OfficeDes[i]
            end
        end 
    end
--军团科技描述
GuildTechNum = #GuildTechDes
function getGuildTechDesFromId( _id )
    print("getGuildTechDesFromId GuildTechNum = " .. GuildTechNum)
    for i=1, GuildTechNum do
        if _id == GuildTechDes[i]["guildID"] then
            return GuildTechDes[i]
        end
    end 
end
--日常任务描述
DailyTaskNum = #DailyTaskDes
function getDailyTaskDesFromId(_id)
    for i=1, DailyTaskNum do
        if _id == DailyTaskDes[i]["taskId"] then
            return DailyTaskDes[i]
        end
    end 
end
--主线任务描述
MainTaskNum= #MainTaskDes
function getMainTaskDesFromId( _id )
    for i=1, MainTaskNum do
        if _id == MainTaskDes[i]["taskId"] then
            return MainTaskDes[i]
        end
    end
end
--进阶石获取途径描述
StoneWayNum = #StoneWayDes
function getStoneWayFromQulity(_qulity)
    return StoneWayDes[_qulity]
end

function getTeQuanFromIndex(_indexA,_indexB)
    return TeQuanBaseDes[_indexA][_indexB]
end
function getTeQuanFromLv(_lv)
    return TeQuanBaseDes[_lv]
end

FunctionDesNum = #FunctionDes
function getFunctionDesFromId(_id)
    
    for i=1, FunctionDesNum do
        if _id == FunctionDes[i]["FunctionID"] then
            return FunctionDes[i]["FunctionDes"]
        end
    end 
end
--女神图鉴
--类型
function getGoddessAtlasDesFromId(_type)
    return GoddessAtlasDes[_type]
end

--KeZhaoMuWuJiangNum = #KeZhaoMuWuJiang

function getZhaoMuJeneralDesFromCamp(_camp)
    return #KeZhaoMuWuJiang[_camp], KeZhaoMuWuJiang[_camp]
end

function getZhaoMuJeneralData(_camp, _jeneralid)
    local num, data = getZhaoMuJeneralDesFromCamp(_camp)
    for i=1,num do
        if data[i]["generalId"] == _jeneralid then
            return data[i]
        end
    end
    return nil
end


function getNvShenFromCamp(_camp) --通过阵营获取女神数量和数据
    return #GodListDes[_camp], GodListDes[_camp]
end
function getNvShenDataFromCampId(_camp, _id)
    local num , dataList = getNvShenFromCamp(_camp) --本国查找
    for i=1, num do
        if _id == dataList[i]["GodId"] then
            return dataList[i]
        end
    end

    num , dataList = getNvShenFromCamp( 4 )  --公共部分查找
    for i=1, num do
        if _id == dataList[i]["GodId"] then
            return dataList[i]
        end
    end

    num , dataList = getNvShenFromCamp( 5 ) --初始查找
    for i=1, num do
        if _id == dataList[i]["GodId"] then
            return dataList[i]
        end
    end
end
function getNvShenDataFromId( _id)
    local num , dataList = getNvShenFromCamp(1) --本国查找
    for i=1, num do
        if _id == dataList[i]["GodId"] then
            return dataList[i]
        end
    end
    num , dataList = getNvShenFromCamp( 2 )  --公共部分查找
    for i=1, num do
        if _id == dataList[i]["GodId"] then
            return dataList[i]
        end
    end
    num , dataList = getNvShenFromCamp( 3 )  --公共部分查找
    for i=1, num do
        if _id == dataList[i]["GodId"] then
            return dataList[i]
        end
    end
    num , dataList = getNvShenFromCamp( 4 )  --公共部分查找
    for i=1, num do
        if _id == dataList[i]["GodId"] then
            return dataList[i]
        end
    end

    num , dataList = getNvShenFromCamp( 5 ) --初始查找
    for i=1, num do
        if _id == dataList[i]["GodId"] then
            return dataList[i]
        end
    end
end


--本地成就描述
function getAchievementData( )
    return AchievementDes
end

--本地充值活动描述
function getChongZhiActivityData( )
    return ChongZhiActivityDes
end

--系统公告描述
function getSystemTipsData( )
    return SystemTipsDes
end

--战前对话
function getFightTalkData()
    return fightTalk
end

-- --example
-- local PaopaoTalkData = {
--     { ["OpenType"]  ={  ["charpterId"]=1,["npcId"]=1,["charpterType"]=1,["paopaoType"]=1,["mSkillId"]=0,},
--       ["paoPaoData"]={  {["rightOrLeft"]=1,["miaoShaType"]=1,["miaoShaState"]=1,["content"]="说都发送到",},
--                         {["rightOrLeft"]=2,["miaoShaType"]=3,["miaoShaState"]=1,["Content"]="说都发送到",},
--                       }
--     },
-- }
local PaopaoTalkData={}
local function paseFightPaopaoDataFunc(  )
    --print("=======paseFightPaopaoDataFunc=")
    for i=1,#fightPaopaoTalk do
        local tab1 = {}
        tab1["OpenType"]=fightPaopaoTalk[i]["OpenType"]
        --table_insert(allTeamPosition, tabPosition)
       
        --fightPaopaoTalk[i]["OpenType"]
        tab1["paoPaoData"]={}

        local contentTab = fightPaopaoTalk[i]["paoPaoData"]
        for j=1,#contentTab do
            local tab2 = {}
            --print("=======paseFightPaopaoDataFunc=" .. contentTab[j])
            local strCon = contentTab[j]

            tab2["rightOrLeft"]=tonumber(string.sub(strCon,1, 1)) 
            tab2["miaoShaType"]=tonumber(string.sub(strCon,3, 3))  
            tab2["miaoShaState"]=tonumber(string.sub(strCon,5,5))  
            tab2["content"]=string.sub(strCon,7)

             --print("=======" .. string.sub(strCon,1, 1) .. "=" .. string.sub(strCon,3, 3) .. "=" .. string.sub(strCon,5,5) .. "=" .. string.sub(strCon,7))

             table.insert(tab1["paoPaoData"],tab2)
           
        end

        table.insert(PaopaoTalkData,tab1)

    end
end
paseFightPaopaoDataFunc()

--泡泡对话
function getFightPaopaoTalkData()
    return PaopaoTalkData
end



-- --example
-- local FightPaoPaoTalkData2 = 
-- {
--     {["charpterId"]=2,["npcId"]=5,["charpterType"]=1,["huiheNum"]=1,
--      ["huiheData"]={ {["mPosition"]=1,["paoPaoData"]={ {["paoPosition"]=1,["qianhou"]=1,["content"]="朱老将军"},   
--                                                       },
--                      },
--                    },
--     },
-- }

local PaopaoTalkData2={}
local function paseFightPaopaoData2Func(  )
    for i=1,#fightPaopaoTalk2 do
        local tab1 = {}
        tab1["charpterId"]=fightPaopaoTalk2[i]["charpterId"]
        tab1["npcId"]=fightPaopaoTalk2[i]["npcId"]
        tab1["charpterType"]=fightPaopaoTalk2[i]["charpterType"]
        tab1["huiheNum"]=fightPaopaoTalk2[i]["huiheNum"]
       
        tab1["huiheData"]={}
        local huihedataTab = fightPaopaoTalk2[i]["huiheData"]
        for j=1,#huihedataTab do
            local tab2 = {}
             tab2["mPosition"]=huihedataTab[j]["mPosition"]
             --tab2["qianhou"]=huihedataTab[j]["qianhou"]

             tab2["paoPaoData"]={}
             local huihedataContentTab = huihedataTab[j]["paoPaoData"]
             for z=1,#huihedataContentTab do
                 local strCon = huihedataContentTab[z]
                 --print("===========" .. strCon)
                 local tab3 = {}
                tab3["qianhou"]=tonumber(string.sub(strCon,1, 1))
                
                local mpos =string.find(strCon,":",3) 
                tab3["paoPosition"]=tonumber(string.sub(strCon,3, mpos-1)) 
                tab3["content"]=string.sub(strCon,mpos+1)

                --print("=======" .. mpos .. "=" .. string.sub(strCon,1, 1) .. "=" .. string.sub(strCon,3, mpos-1) .. "=" .. string.sub(strCon,mpos+1) )

                table.insert(tab2["paoPaoData"],tab3)
             end
             table.insert(tab1["huiheData"],tab2)
        end
        table.insert(PaopaoTalkData2,tab1)
    end
end
paseFightPaopaoData2Func()

--泡泡对话
function getFightPaopaoTalk2Data()
    return PaopaoTalkData2
end