module ("LM", package.seeall)
--用于ui部分的layer管理
local layer1_base_nom = nil
local layer1_base_ccf = nil --TouchGroupCCF:create()
local layer2 = nil
local layer3 = nil
local layer4 = nil

local layer9_UI = nil --公共UI layer

--军团战战斗场景 / 国战UI
local layer10 = nil
local layer11 = nil
local layer12 = nil
--普通战战斗场景
local layer15 = nil  --地图战斗层
local layer16 = nil  --女神动画层
local layer17 = nil  --战斗ui层
local layer18 = nil  --战斗结果层

--聊天、通知层 资源不足提示 女神查看
local layer20 = nil

--引导层
local layer22_nom = nil

--消费二次确认提示层
local layer24 = nil
--动态提示
local layer25 = nil
--loading屏蔽层
local layer26 = nil

--touch effect点击效果层
local layer29 = nil

--记录各个对应layer的当前状态
STATE_1 = 0
STATE_2 = 0
STATE_3 = 0
STATE_4 = 0

STATE_9 = 0

STATE_10 = 0
STATE_11 = 0
STATE_12 = 0

STATE_15 = 0  --记录普通战斗场景状态
STATE_16 = 0  --暂无用
STATE_17 = 0  --暂无用
STATE_18 = 0  --记录战斗结果状态

STATE_20 = 0  --聊天、动态通知层 创建名字 选择阵营
STATE_22 = 0
STATE_24 = 0  --二次确认提示
STATE_25 = 0  --动态提示
STATE_26 = 0  --loading 层
STATE_29 = 0



function getLayer1Base_nom()
	return layer1_base_nom
end
function getLayer1Base_ccf()
	return layer1_base_ccf
end
function getLayer2()
	return layer2
end
function getLayer3()
	return layer3
end
function getLayer4()
	return layer4
end
function getLayer9UI()
	return layer9_UI
end

function getLayer10()
	return layer10
end
function getLayer11()
	return layer11
end
function getLayer12()
	return layer12
end

function getLayer15()
	return layer15
end
function getLayer16()
	return layer16
end
function getLayer17()
	return layer17
end
function getLayer18()
	return layer18
end

function getLayer20()
	return layer20
end
function getLayer22_nom()
	return layer22_nom
end

function getLayer25()
	return layer25
end
function getLayer26()
	return layer26
end
function getLayer29()
	return layer29
end


------------------------------------------------------------------
--释放第三层到UI层
function clearLayer3ToUI()
	if LM.STATE_3 == UI_ZhengZhan_JunTuanNpc_Pop then
		Pop3_JunTuanZhan.exitUI()
	end
	if LM.STATE_3 == UI_NvShen_TuJian then
		NvShen_TuJian.exitUI()
	end
	if LM.STATE_3 == UI_NvShen_LieBiao then
		NvShen_LieBiao.exitUI()
	end
	if LM.STATE_3 == UI_BeiBao_QiangHua then
		BagData.clearCDlbl()
		BagData.clearQiangHuaCDLable()
	end
	if LM.STATE_3 == UI_BeiBao_WeiPai then
		DelegateData.clearLabelButton()
	end
	if LM.STATE_3 == UI_General_XunLian then
		GNR_XunLian.exitUI()
	end

	if JunTuanBase.getJunTuanState() then
		JunTuanBase.exitUI()
	end

	layer3:clear()
	layer4:clear()

	STATE_3 = 0
	STATE_4 = 0
end
function clearLayer2To9()
	if LM.STATE_2 == UI_GuanKa_PuTong then
		GK_PuTong.exitUI()
	end
	if LM.STATE_2 == UI_GuanKa_JingYing then
		GK_JingYing.exitUI()
	end
	layer1_base_ccf:clear()
	layer2:clear()
	clearLayer3ToUI()
end
--清空9ui下的所有layer，用于主城和世界的任何时候的切换 layer1之间的切换
function clearExcept9UIBtm()
	if LM.STATE_2 == UI_GuanKa_PuTong then
		GK_PuTong.exitUI()
	end

	layer1_base_nom:clear()
	--layer1_base_ccf:clear()
	layer2:clear()
	--layer3:clear()
	--layer4:clear()

	STATE_1 = 0
	STATE_2 = 0
	--STATE_3 = 0
	--STATE_4 = 0
	clearLayer3ToUI()
end

--释放第三层到UI层
function clearLayer2ToUI()
	CDTimeManager.clearAllLble()
	
	if LM.STATE_2 == UI_GuanKa_PuTong then
		GK_PuTong.exitUI()
	end
	--layer1_base_nom:clear()
	layer1_base_ccf:clear()
	layer2:clear()
	layer3:clear()
	layer4:clear()
	layer9_UI:clear()

	STATE_1 = 0
	STATE_2 = 0
	STATE_3 = 0
	STATE_4 = 0
	STATE_9 = 0
end

---------------------------------------------------------------------
--释放世界
function clearLayerWord()
	layer1_base_nom:clear()
	STATE_1 = 0
end
--释放主城
function clearMainCity()
	layer1_base_ccf:clear()
	STATE_1 = 0
end
--释放中间公共区域
function clearPubMid()

	if LM.STATE_2 == UI_ShiJie_QuYu then
		MapShiJie_QuYu.exitUI()
	end


	if LM.STATE_2 == UI_GuanKa_PuTong then
		GK_PuTong.exitUI()
	end
	if LM.STATE_2 == UI_GuanKa_JingYing then
		GK_JingYing.exitUI()
	end
	if LM.STATE_3 == UI_NvShen_TuJian then
		NvShen_TuJian.exitUI()
	end
	if LM.STATE_3 == UI_BeiBao_QiangHua then
		BagData.clearCDlbl()
		BagData.clearQiangHuaCDLable()
	end
	if LM.STATE_3 == UI_BeiBao_WeiPai then
		DelegateData.clearLabelButton()
	end

	layer2:clear()
	layer3:clear()
	layer4:clear()
	
	STATE_2 = 0
	STATE_3 = 0
	STATE_4 = 0
end
function clearUI()
	layer9_UI:clear()
	STATE_9 = 0
end

---------------------------------------------------------
--退出普通战斗
function exitNormFightGround()

	
	layer15:clear() --地图战斗层
	layer16:clear()  --女神动画层
	layer17:clear()  --战斗ui层
	layer18:clear()  --战斗结果层

	STATE_15 = 0  --记录普通战斗场景状态
	STATE_16 = 0  --暂无用
	STATE_17 = 0  --暂无用
	STATE_18 = 0  --记录战斗结果状态
end
--重连情况，清除所有
function relogin()
STATE_1 = 0
STATE_2 = 0
STATE_3 = 0
STATE_4 = 0

STATE_9 = 0

STATE_10 = 0
STATE_11 = 0
STATE_12 = 0

STATE_15 = 0  --记录普通战斗场景状态
STATE_16 = 0  --暂无用
STATE_17 = 0  --暂无用
STATE_18 = 0  --记录战斗结果状态

STATE_20 = 0  --聊天、动态通知层 创建名字 选择阵营
STATE_22 = 0
STATE_24 = 0  --二次确认提示
STATE_25 = 0  --动态提示

	layer1_base_nom:clear()
	layer1_base_ccf:clear() --TouchGroupCCF:create()
	layer2:clear()
	layer3:clear()
	layer4:clear()

	layer9_UI:clear() --公共UI layer

--军团战战斗场景 / 国战UI
	layer10:clear()
	layer11:clear()
	layer12:clear()
--普通战战斗场景
	layer15:clear()  --地图战斗层
	layer16:clear()  --女神动画层
	layer17:clear()  --战斗ui层
	layer18:clear()  --战斗结果层

--聊天、通知层 资源不足提示
	layer20:clear()

--引导层
	layer22_nom:clear()

--消费二次确认提示层
	--layer24:clear()
--动态提示
	layer25:clear()

	layer26:clear()
	--layer29:clear()
end

function UIlayerInit()
    local curScene = CCScene:create()
 	CCDirector:sharedDirector():replaceScene( curScene )
---------------------------------------------------------------
	layer1_base_nom = TouchGroup:create()  --世界
	layer1_base_ccf = TouchGroup:create() --TouchGroupCCF:create()--主城

	layer2 		= TouchGroup:create()  --农田 银矿 征战 世界区域/投资
	layer3 		= TouchGroup:create()  --（主城建筑的弹出）女神 将领 装备 军团 任务 背包 邮件 vip 官职 国战 祭祀 军团战 寻宝 征收 征战npc弹出(普通npc布阵，军团npc房间) 世界洛阳城弹出
	layer4 		= TouchGroup:create()  --征战普通npc布阵的战报查看MapFight_GongLue 国战规则弹出ui
	layer9_UI 	= TouchGroup:create()  --公用UI区域 /国战ui

	--军团战/军团npc战场战斗场景 国战ui
	layer10 = TouchGroup:create()   --普通征战的弹出
	layer11 = TouchGroup:create() 	--普通征战的弹出--战报
	layer12 = TouchGroup:create()

	--普通战战斗场景
	layer15 = TouchGroup:create()  --地图战斗层
	layer16 = TouchGroup:create()  --女神动画层
	layer17 = TouchGroup:create()  --战斗ui层
	layer18 = TouchGroup:create()  --战斗结果层
	
	layer20 = TouchGroup:create()  --聊天动态通知层
	layer22_nom = TouchGroup:create()

	layer25 = TouchGroup:create()  --动态提示
	layer26 = TouchGroup:create()

	--触摸效果层
	layer29 = CCLayer:create()
------------------------------------------------------
	layer1_base_nom:setZOrder(1)
	layer1_base_ccf:setZOrder(2)

	layer2:setZOrder(4)
	layer3:setZOrder(5)
	layer4:setZOrder(6)

	layer9_UI:setZOrder(9)

	layer10:setZOrder(10)
	layer11:setZOrder(11)
	layer12:setZOrder(12)


	layer15:setZOrder(15)
	layer16:setZOrder(16)
	layer17:setZOrder(17)
	layer18:setZOrder(18)

	layer20:setZOrder(20)
	layer22_nom:setZOrder(22)
	layer25:setZOrder(25)
	layer26:setZOrder(26)

	layer29:setZOrder(29)
------------------------------------------------------
	curScene:addChild(layer1_base_nom)
	curScene:addChild(layer1_base_ccf)

	curScene:addChild(layer2)
	curScene:addChild(layer3)
	curScene:addChild(layer4)
	curScene:addChild(layer9_UI)

	curScene:addChild(layer10)
	curScene:addChild(layer11)
	curScene:addChild(layer12)

	curScene:addChild(layer15)
	curScene:addChild(layer16)
	curScene:addChild(layer17)
	curScene:addChild(layer18)

	curScene:addChild(layer20)
	curScene:addChild(layer22_nom)
	curScene:addChild(layer25)
	curScene:addChild(layer26)

	curScene:addChild(layer29)
-----------------------------------------------------
	STATE_1 = 0
	STATE_2 = 0
	STATE_3 = 0
	STATE_4 = 0

	STATE_9 = 0

	STATE_10 = 0
	STATE_11 = 0
	STATE_12 = 0

	STATE_15 = 0
	STATE_16 = 0
	STATE_17 = 0
	STATE_18 = 0

	STATE_20 = 0
	STATE_25 = 0
	STATE_26 = 0
	STATE_29 = 0


	TouchEffect.setTouchEffect()
end