--module ("SokcetParse", package.seeall)


function hex(s)
	 if(s == nil) then
		return nil
	 end
	 s=string.gsub(s,"(.)",function (x) return string.format("%02X",string.byte(x)) end)
	 return s
end
function stringPack(type,str,len)
    local temp
    if(str:len()>len)--你妹 超长了
    then
		temp = pack(type,str:sub(0,len))
    else
		temp = pack(type,str)
		--for i,v in ipairs{...} do
		for num = len-str:len(), 1, -1 do
			temp = temp..string.pack("b",0)
		end
    end
    return temp
end

function SCpack(mytable)
	local tempstring
	for i,v in ipairs (mytable) do
		--print(v)
		--print("i = " .. i .. "\n" .. "table.getn(v) = " .. table.getn(v))
		if(table.getn(v) == 2) then
			--print("v[1] = " .. v[1] ..  "v[2] = " .. v[2])
			if(tempstring~=nil) then
				tempstring = tempstring..pack(v[1],v[2])
			else
				tempstring = pack(v[1],v[2])
			end
		else
			if(tempstring~=nil) then
				--enter SCpack
				--print("v[1] = " .. v[1])
				--print("v[2] = " .. v[2])
				--print("v[3] = " .. v[3])
				tempstring = tempstring..stringPack(v[1],v[2],v[3])
			else
				--enter SCpack
				tempstring = stringPack(v[1],v[2],v[3])
			end
		end
	end
	--print("tempstring = %s" .. tempstring)
	return tempstring
end

function SCunpack(data,mytable,next)
	local paralen = 0
	local bresult
	local newNext
	for i,v in ipairs (mytable) do
		paralen = table.getn(v)
		if(paralen == 2) then
			bresult,newNext,v[2] = pcall(unpack,data,v[1],next)
			if (bresult==false) then
				return -1
			end
			--print(v[2])
			--print(type(v[2]))
			--print(hex(v[2]))
		elseif (paralen == 4) then
			bresult,newNext,v[2] = pcall(UnpackArray,data, v[3], v[4], next)
			if (bresult==false) then
				return -1
			end
		else  --paralen == 3
			bresult,newNext,v[2] = pcall(unpack,data,v[1]..v[3],next)
			if (bresult==false) then
				return -1
			end
		end
		next = newNext
	end
	return newNext

end


function UnpackArray(buff, lenFormat, eleFormat, pos )
	local len = 0
	local tempTable = {}
	pos, len = unpack(buff,lenFormat,pos)
	for i=1, len do
		pos, tempTable[i] = unpack(buff,eleFormat,pos)
	end
	return pos, tempTable
end


function SCparseAll(buffer)
	local bufferPos = 1
	local nextBufferPos
	local bufferlen = #buffer
	local packagelen

	local cmd
	-- 至少需要2个字节
	local maxBufferPos = bufferlen - 2
	--print("maxBufferPos = " .. maxBufferPos)
	--print("bufferPos = " .. bufferPos)
	while maxBufferPos>=bufferPos do
		nextBufferPos = SCunpack(buffer,msg16,bufferPos)
		--print("nextBufferPos == " .. nextBufferPos)
		-- 如果包不完整，则nextBufferPos为-1
		if (nextBufferPos<0) then
			break;
		end
		--find the defined len first
		--print("the package's BUfferPos is :"..bufferPos)
		cmd = msg16[INDEX_MSG_16][VALUE]
		print("SCparseAll ==  " .. os.time())
		print('cmd is:'..string.format("%02X", cmd))
		if parsefunc_db[cmd] == nil then
			print('这里有错,客户端没有此封包')
			print(string.format("你的客户端肯定crash了，请查protoParse %s",nil))
			
			return nil
		else
			nextBufferPos = parsefunc_db[cmd](buffer,bufferPos)
			print("nextBufferPos2 == " .. nextBufferPos)
			if (nextBufferPos>=0) then
				bufferPos = nextBufferPos
			else
				break
			end
		end
	end
	--print("print break while =========")
	if bufferPos < #buffer then
		buffer = string.sub(buffer,bufferPos,#buffer - bufferPos + 1)
	else
	    buffer = ""
	end
	
	return buffer
end


function SC2IP(data,isFanZhuanOrder)
    --print(type(data))
	if type(data) ~= "number" then
		return nil
	end
	local data_temp = string.format("%08X",data)
	local v = {}
	for i = 1,4,1 do
		if isFanZhuanOrder then
			v[i]=string.format("%i","0x"..data_temp:sub(i*2-1,i*2))
		else
			v[5-i] = string.format("%i","0x"..data_temp:sub(i*2-1,i*2))
		end
		--print(v[i])
	end
	--print(table.concat(v,","))
	return table.concat(v,".")

 end